
//
// @(#)btyaccpar, based on byacc 1.8 (Berkeley)
// Parser skeleton modified for use in the Firebird project by Nickolay Samofatov
//
#define YYBTYACC 1

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "dsql.tab.h"
#include "Parser.h"

#define YYERROR_DETAILED

/*
*	PROGRAM:	Dynamic SQL runtime support
*	MODULE:		parse.y
*	DESCRIPTION:	Dynamic SQL parser
*
* The contents of this file are subject to the Interbase Public
* License Version 1.0 (the "License"); you may not use this file
* except in compliance with the License. You may obtain a copy
* of the License at http://www.Inprise.com/IPL.html
*
* Software distributed under the License is distributed on an
* "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
* or implied. See the License for the specific language governing
* rights and limitations under the License.
*
* The Original Code was created by Inprise Corporation
* and its predecessors. Portions created by Inprise Corporation are
* Copyright (C) Inprise Corporation.
*
* All Rights Reserved.
* Contributor(s): ______________________________________.
*
* 2002-02-24 Sean Leyne - Code Cleanup of old Win 3.1 port (WINDOWS_ONLY)
* 2001.05.20 Neil McCalden: Allow a udf to be used in a 'group by' clause.
* 2001.05.30 Claudio Valderrama: DROP TABLE and DROP VIEW lead now to two
*   different node types so DDL can tell which is which.
* 2001.06.13 Claudio Valderrama: SUBSTRING is being surfaced.
* 2001.06.30 Claudio valderrama: Feed (line,column) for each node. See node.h.
* 2001.07.10 Claudio Valderrama: Better (line,column) report and "--" for comments.
* 2001.07.28 John Bellardo: Changes to support parsing LIMIT and FIRST
* 2001.08.03 John Bellardo: Finalized syntax for LIMIT, change LIMIT to SKIP
* 2001.08.05 Claudio Valderrama: closed Bug #448062 and other spaces that appear
*   in rdb$*_source fields when altering domains plus one unexpected null pointer.
* 2001.08.12 Claudio Valderrama: adjust SUBSTRING's starting pos argument here
*   and not in gen.c; this closes Bug #450301.
* 2001.10.01 Claudio Valderrama: enable explicit GRANT...to ROLE role_name.
* 2001.10.06 Claudio Valderrama: Honor explicit USER keyword in GRANTs and REVOKEs.
* 2002.07.05 Mark O'Donohue: change keyword DEBUG to KW_DEBUG to avoid
*			clashes with normal DEBUG macro.
* 2002.07.30 Arno Brinkman:
* 2002.07.30 	Let IN predicate handle value_expressions
* 2002.07.30 	tokens CASE, NULLIF, COALESCE added
* 2002.07.30 	See block < CASE expression > what is added to value as case_expression
* 2002.07.30 	function is split up into aggregate_function, numeric_value_function, string_value_function, generate_value_function
* 2002.07.30 	new group_by_function and added to grp_column_elem
* 2002.07.30 	cast removed from function and added as cast_specification to value
* 2002.08.04 Claudio Valderrama: allow declaring and defining variables at the same time
* 2002.08.04 Dmitry Yemanov: ALTER VIEW
* 2002.08.06 Arno Brinkman: ordinal added to grp_column_elem for using positions in group by
* 2002.08.07 Dmitry Yemanov: INT64/LARGEINT are replaced with BIGINT and available in dialect 3 only
* 2002.08.31 Dmitry Yemanov: allowed user-defined index names for PK/FK/UK constraints
* 2002.09.01 Dmitry Yemanov: RECREATE VIEW
* 2002.09.28 Dmitry Yemanov: Reworked internal_info stuff, enhanced
*							exception handling in SPs/triggers,
*							implemented ROWS_AFFECTED system variable
* 2002.10.21 Nickolay Samofatov: Added support for explicit pessimistic locks
* 2002.10.29 Nickolay Samofatov: Added support for savepoints
* 2002.12.03 Dmitry Yemanov: Implemented ORDER BY clause in subqueries.
* 2002.12.18 Dmitry Yemanov: Added support for SQL-compliant labels and LEAVE statement
* 2002.12.28 Dmitry Yemanov: Added support for parametrized events.
* 2003.01.14 Dmitry Yemanov: Fixed bug with cursors in triggers.
* 2003.01.15 Dmitry Yemanov: Added support for runtime trigger action checks.
* 2003.02.10 Mike Nordell  : Undefined Microsoft introduced macros to get a clean compile.
* 2003.05.24 Nickolay Samofatov: Make SKIP and FIRST non-reserved keywords
* 2003.06.13 Nickolay Samofatov: Make INSERTING/UPDATING/DELETING non-reserved keywords
* 2003.07.01 Blas Rodriguez Somoza: Change DEBUG and IN to avoid conflicts in win32 build/bison
* 2003.08.11 Arno Brinkman: Changed GROUP BY to support all expressions and added "AS" support
*						   with table alias. Also removed group_by_function and ordinal.
* 2003.08.14 Arno Brinkman: Added support for derived tables.
* 2003.10.05 Dmitry Yemanov: Added support for explicit cursors in PSQL.
* 2004.01.16 Vlad Horsun: added support for default parameters and
*   EXECUTE BLOCK statement
* Adriano dos Santos Fernandes
*/

#include "firebird.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../jrd/common.h"
#include <stdarg.h>

#include "gen/iberror.h"
#include "../dsql/dsql.h"
#include "../dsql/node.h"
#include "../jrd/ibase.h"
#include "../jrd/flags.h"
#include "../jrd/jrd.h"
#include "../dsql/errd_proto.h"
#include "../dsql/hsh_proto.h"
#include "../dsql/make_proto.h"
#include "../dsql/keywords.h"
#include "../dsql/misc_func.h"
#include "../jrd/gds_proto.h"
#include "../jrd/err_proto.h"
#include "../jrd/intlobj_new.h"
#include "../common/StatusArg.h"

/* since UNIX isn't standard, we have to define
  stuff which is in <limits.h> (which isn't available
  on all UNIXes... */

const long SHRT_POS_MAX			= 32767;
const long SHRT_UNSIGNED_MAX	= 65535;
const long SHRT_NEG_MAX			= 32768;
const long LONG_POS_MAX			= 2147483647;
const int POSITIVE	= 0;
const int NEGATIVE	= 1;
const int UNSIGNED	= 2;

/*const int MIN_CACHE_BUFFERS	= 250;*/
/*const int DEF_CACHE_BUFFERS	= 1000;*/

/* Fix 69th procedure problem - solution from Oleg Loa */
#define YYSTACKSIZE	2048
#define YYMAXDEPTH	2048

/* Make bison allocate static stack */
#define YYINITDEPTH 2048

/* Using this option causes build problems on Win32 with bison 1.28*/
/*#define YYSTACK_USE_ALLOCA 1*/

#define YYSTYPE YYSTYPE
#if defined(DEBUG) || defined(DEV_BUILD)
#define YYDEBUG		1
#endif

#define YYMALLOC gds__alloc
#define YYFREE gds__free

static const char INTERNAL_FIELD_NAME[] = "DSQL internal"; /* NTX: placeholder */

inline SLONG trigger_type_suffix(const int slot1, const int slot2, const int slot3)
{
	return ((slot1 << 1) | (slot2 << 3) | (slot3 << 5));
}


#include "../dsql/chars.h"

const int MAX_TOKEN_LEN = 256;

using namespace Jrd;
using namespace Dsql;
using namespace Firebird;

#ifdef NOT_USED_OR_REPLACED
static bool		long_int(dsql_nod*, SLONG*);
#endif
static dsql_fld*	make_field (dsql_nod*);
static dsql_fil*	make_file();
#ifdef NOT_USED_OR_REPLACED
static bool	short_int(dsql_nod*, SLONG*, SSHORT);
#endif
static void	stack_nodes (dsql_nod*, DsqlNodStack&);
static Firebird::MetaName toName(dsql_nod* node);

static void	yyabandon (SLONG, ISC_STATUS);

inline void check_bound(const char* const to, const char* const string)
{
	if ((to - string) >= MAX_TOKEN_LEN)
		yyabandon (-104, isc_token_too_long);
}

inline void check_copy_incr(char*& to, const char ch, const char* const string)
{
	check_bound(to, string);
	*to++ = ch;
}

static int yylhs[] = {                                        -1,
    0,    0,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,   11,   11,   11,   26,   26,
   25,   25,   25,   36,   36,   31,   37,   37,   37,   37,
   37,   29,   29,   35,   35,   30,   30,   39,   39,   40,
   32,   17,   17,   17,   17,   43,   43,   44,   44,   28,
   28,   45,   45,   45,   45,   47,   47,   47,   47,   46,
   46,   48,   48,   48,   33,   33,   53,   34,   34,   41,
   41,    8,   54,   54,   56,   61,   61,   61,   58,   58,
   58,   65,   65,   66,   68,   68,   68,   68,   59,   59,
   69,   69,   70,   70,   70,   70,   70,   55,   72,   72,
    6,   75,   75,   75,   75,   75,   75,   75,   75,   75,
   75,   75,   75,   75,   75,   75,   16,   93,   93,   93,
   93,   93,   93,    7,  100,  100,  100,  100,   76,   99,
  104,  106,   77,   77,   80,   80,   80,   89,  113,  113,
  113,  114,  114,  115,  115,  116,  116,  120,  120,   88,
  123,  123,  128,  125,  125,  126,  126,  131,  131,  132,
  133,  133,  134,  135,   86,   90,   91,  140,  140,  140,
  141,  141,  143,  143,  144,  144,  144,  145,  145,  146,
  146,  147,  147,  142,  142,  148,   87,  117,  117,  149,
  150,  150,  152,  152,  153,  153,  153,  153,  153,  151,
  151,  154,  154,  155,  155,  155,  155,  121,  156,  157,
  157,  158,  158,  159,  159,  160,  160,  160,  119,  119,
  119,   82,   95,   83,   96,  163,  163,  163,  161,  161,
  161,  162,  162,  164,  164,  165,  165,  165,  170,  171,
  171,  109,  109,  167,  167,  127,  127,  122,  173,  174,
  174,  174,  174,   67,  129,  129,  129,  129,  129,  129,
  168,  168,  182,  182,  183,  185,  185,  185,  185,  185,
  166,  184,  184,  188,  188,  188,  188,  190,  191,  192,
  187,  187,  186,  186,  186,  186,  186,  193,  194,  195,
  195,  195,  195,   81,   94,  101,  201,  196,  196,  197,
  197,  202,  202,  204,  203,  203,  207,  206,  206,  206,
  199,  199,  208,  208,  209,  213,  213,  214,  212,  212,
  215,  217,  217,  200,  219,  219,  219,  220,  220,  218,
  218,  210,  211,  222,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
  222,  223,  223,  223,  223,  223,  234,  229,  229,  230,
  237,  226,  227,  238,  242,  242,  242,  244,  244,  246,
  245,  245,  248,  243,  243,  249,  249,  250,  250,  250,
  250,  250,  250,  251,  251,  252,  253,  254,  255,  255,
  256,  235,  235,  231,  257,  225,  258,  240,  240,  240,
  240,  236,  239,  239,  233,  233,  233,  241,  241,  221,
  221,  261,  262,  262,  263,  263,  263,  263,  232,  232,
  232,  265,  267,  266,  268,   14,  269,  269,  269,  270,
  270,  270,   15,  272,  272,  273,  273,  274,   85,   97,
  103,  278,  198,  110,  112,  130,  277,  277,   84,   84,
   84,   98,   98,   98,  102,  102,  102,  279,  279,  279,
  280,  280,  285,  285,  285,  285,  285,  283,  283,  284,
  284,  284,  284,  284,  284,  284,  284,  284,  284,  284,
  284,  284,  284,  284,  281,  281,  282,    2,  287,  287,
  287,  287,  287,  287,  287,  287,  287,  287,  287,  287,
  287,  293,  293,  299,  299,  299,  299,  299,  299,  299,
  288,  288,  300,  300,  300,  300,  300,  300,  300,  300,
  300,  300,  300,  292,  305,  305,  305,  305,  305,  305,
  305,  305,  305,  305,  305,  305,  305,  305,  305,  305,
  305,  305,  305,  305,  305,  305,  305,  305,  305,  305,
  305,  305,  305,  305,  305,  305,  305,  305,  305,  305,
  305,  305,  305,  305,  305,  305,  305,  305,  305,  305,
  305,  305,  305,  305,  305,  305,  302,  302,  304,  304,
  303,  301,  301,  301,  294,  294,  295,  295,  295,  296,
  297,  310,  310,  308,  308,  309,  309,  290,  291,  291,
  311,  311,  311,  311,  311,  289,  312,  312,  313,  313,
   10,  314,  314,  314,  314,  314,  314,  314,  314,  314,
  314,  314,  314,  314,  314,  314,  124,  124,  205,  205,
  319,  319,  320,  320,  320,  169,  169,  318,  318,  323,
  323,  325,  325,   62,   62,  322,  322,  322,  322,  322,
  322,  322,  322,  322,  329,  329,  321,  321,  321,  321,
  331,  331,  330,  330,  330,   64,   64,  326,  326,  326,
  324,  324,  324,  335,  335,  335,  334,  334,  333,  333,
  333,  327,  327,  336,  336,  336,  337,  337,  328,  328,
  328,  328,  338,  338,   21,   21,   21,  340,  340,  340,
   19,   19,   19,  342,  343,  346,  346,  344,  348,  348,
    5,   24,   18,  347,  347,  349,  349,  350,  350,  339,
  351,  351,  352,  352,  353,  353,  353,  353,  353,  353,
  354,  354,  355,  355,  356,  356,  360,  360,  360,  361,
  361,  361,  362,  362,  362,  357,  357,  357,  358,  359,
  364,  364,  364,  365,  365,  363,  363,  366,  368,  368,
  367,  367,  341,    4,    4,    4,  369,  371,  371,  371,
  371,  371,  371,  371,  371,  371,  371,  371,  371,  371,
  371,  373,  373,  374,  370,  370,   20,  375,  375,  377,
  377,  376,  376,  276,  378,  378,  378,  382,  382,  383,
  386,  387,  379,  379,  379,  388,  390,  391,  391,  391,
  391,  399,  399,  399,  400,  400,  400,  392,  392,  393,
  393,  402,  402,  403,  403,  404,  404,  394,  406,  406,
  407,  407,  409,  409,  409,  411,  412,  412,  385,  385,
  413,  413,  408,  408,  408,  414,  415,  416,  418,  418,
  419,  420,  410,  410,  421,  421,  422,  422,   27,  417,
  417,  417,  417,  417,  423,  423,  396,  396,  424,  424,
  425,  397,  397,  395,  395,  398,  398,  426,  427,  427,
  427,  427,  427,  428,  428,  429,  429,  430,  430,  431,
  431,  431,  432,  432,  433,  433,  380,  380,  434,  434,
  435,   78,   78,   78,  436,  436,  437,  437,  381,  381,
  381,   12,   12,   12,   13,  440,  440,  440,  440,  441,
  442,  443,  444,    9,    9,  446,  447,   22,   22,  449,
  450,   23,  451,  451,  439,  439,  439,  448,  445,  445,
  224,  228,  228,    3,    3,  456,  456,  456,  458,  458,
  459,  457,  457,  460,  460,   38,   38,  108,  107,  107,
  438,  438,  452,  461,  461,  259,  259,  259,  172,  453,
  453,  136,  136,  136,  136,  462,  462,  462,  462,  462,
  462,  462,  462,  462,  462,  462,  462,  462,  462,  463,
  463,  463,  463,  463,  463,  463,  463,  469,  469,  469,
  469,  469,  469,  469,  469,  469,  469,  469,  469,  469,
  469,  469,  469,  476,  476,  464,  464,  465,  465,  466,
  466,  466,  466,  467,  467,  471,  471,  472,  472,  472,
  472,  473,  473,  473,  473,  470,  474,  468,  468,  475,
  475,  475,  477,  477,  478,   92,  298,  298,  317,  479,
  484,  484,  480,  480,  481,  481,  482,  482,  485,  485,
  485,  483,  483,  486,  487,  111,  111,  111,  111,  111,
  111,  111,  111,  111,  111,  111,  111,  111,  111,  111,
  111,  111,  111,  111,  111,  111,  111,  111,  111,  111,
  111,  111,  111,  181,  181,  181,  181,  181,  494,  494,
  488,  495,  495,  271,  271,  176,  176,  496,  496,  496,
  496,  496,  490,  490,  490,  490,  490,  275,  177,  177,
  178,  179,  179,  179,  179,  179,  179,   60,   60,   74,
   74,  286,  497,   63,  332,  307,  307,  118,  489,  489,
  455,  455,  455,  498,  498,  498,  498,  498,  498,  498,
  498,  498,  498,  498,  498,  498,  502,  502,  499,  499,
  503,  504,  504,  504,  506,  507,  507,  508,  501,  501,
  509,  509,  509,  509,  509,  509,  509,  509,  509,  509,
  509,  509,  509,  509,  509,  509,  509,  509,  509,  509,
  509,  509,  509,  509,  509,  509,  509,  509,  509,  509,
  509,  509,  509,  509,  509,  509,  509,  509,  509,  509,
  509,  509,  509,  509,  509,  509,  509,  510,  510,  510,
  510,  510,  510,  510,  500,  500,  500,  500,  511,  513,
  513,  512,  512,  512,  512,  514,  514,  514,  454,  454,
  491,  492,  492,  516,  516,  516,  516,  516,  517,  517,
  519,  519,  522,  522,  520,  520,  525,  525,  524,  521,
  523,  518,  518,  493,  493,  505,  505,  505,  505,  505,
  505,  505,  505,  505,  505,  401,  401,  389,  389,  180,
  515,   57,   73,  139,  138,  175,  189,  216,  316,  105,
   71,  264,  137,   79,  405,  260,  372,   42,   51,  384,
  315,   49,   52,  247,   50,  345,  306,  306,  526,  526,
  526,  526,  526,  526,  526,  526,  526,  526,  526,  526,
  526,  526,  526,  526,  526,  526,  526,  526,  526,  526,
  526,  526,  526,  526,  526,  526,  526,  526,  526,  526,
  526,  526,  526,  526,  526,  526,  526,  526,  526,  526,
  526,  526,  526,  526,  526,  526,  526,  526,  526,  526,
  526,  526,  526,  526,  526,  526,  526,  526,  526,  526,
  526,  526,  526,  526,  526,  526,  526,  526,  526,  526,
  526,  526,  526,  526,  526,  526,  526,  526,  526,  526,
  526,  526,  526,  526,  526,  526,  526,  526,  526,  526,
  526,  526,  526,  526,  526,  526,  526,  526,  526,  526,
  526,  526,  526,  526,  526,  526,  526,  526,  526,  526,
  526,  526,  526,  526,  526,  526,  526,  526,  526,  526,
  526,  526,  526,  526,  526,  526,  526,  526,  526,  526,
  526,  526,  526,  526,  526,  526,  526,  526,  526,  526,
  526,  526,  526,  526,  526,  526,  526,  526,  526,  526,
  526,  526,  526,  526,  526,  526,  526,  526,  526,  526,
  526,  526,  526,  526,  526,  526,  526,  526,
};
static int yylen[] = {                                         2,
    1,    2,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    9,    9,    6,    1,    0,
    1,    2,    1,    1,    3,    1,    1,    1,    1,    2,
    2,    3,    0,    3,    0,    2,    0,    2,    1,    1,
    1,    9,    9,    6,    6,    3,    0,    3,    0,    1,
    1,    1,    3,    3,    3,    2,    2,    2,    2,    1,
    3,    1,    2,    2,    1,    3,    1,    1,    3,    1,
    2,    2,    2,    3,    8,    1,    1,    5,    0,    1,
    3,    1,    3,    3,    0,    2,    2,    1,    1,    3,
    3,    2,    0,    2,    2,    1,    3,    9,    1,    1,
    2,    2,    7,    2,    2,    4,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    4,
    2,    2,    2,    4,    2,    2,    2,    2,    2,    2,
    2,    2,    1,    0,    1,    1,    6,    6,    1,    1,
    0,    0,    1,    0,    4,    0,    1,    1,    2,    6,
    1,    0,    4,    1,    0,    1,    0,    1,    2,    1,
    1,    1,    2,    6,    1,    1,    6,    2,    5,    0,
    0,    1,    1,    2,    1,    1,    1,    2,    2,    2,
    2,    2,    2,    0,    1,    5,    3,    0,    1,    1,
    0,    1,    1,    2,    3,    4,    2,    2,    3,    0,
    1,    1,    2,    1,    4,    6,    3,    3,    1,    0,
    1,    1,    2,    3,    4,    0,    1,    2,    0,    1,
    1,    5,    5,    5,    5,    4,    4,    0,    3,    2,
    0,    1,    3,    1,    1,    5,    3,    2,    6,    1,
    3,    2,    1,    1,    1,    2,    0,    1,    1,    2,
    3,    6,    1,    0,    1,    1,    1,    1,    1,    1,
    0,    1,    1,    2,    2,    1,    1,    5,    2,    3,
    2,    2,    0,    1,    1,    1,    1,    3,    4,    8,
    4,    0,    1,    1,    2,    2,    0,    3,    3,    1,
    2,    2,    2,    8,    8,    8,    8,    3,    0,    4,
    0,    1,    3,    4,    1,    3,    3,    4,    4,    0,
    1,    0,    1,    2,    6,    1,    1,    4,    1,    0,
    6,    1,    1,    5,    1,    2,    0,    1,    2,    4,
    3,    0,    0,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    5,    2,    3,    1,
    8,    4,    6,   10,    1,    6,    6,    1,    3,    3,
    1,    3,    1,    1,    0,    2,    1,    1,    1,    1,
    1,    1,    1,    5,    3,    3,    2,    2,    3,    3,
    3,    8,    6,    3,    0,    3,    2,    1,    1,    3,
    3,    7,    2,    0,    1,    1,    2,    3,    0,    1,
    2,    4,    1,    3,    2,    2,    2,    1,    1,    1,
    1,    2,    2,    5,    0,    5,    1,    3,    0,    2,
    4,    0,    7,    3,    0,    1,    3,    3,    7,    7,
    7,    7,    0,    0,    0,    0,    3,    0,    6,    8,
    8,    6,    8,    8,    6,    8,    8,    1,    1,    0,
    2,    2,    1,    1,    2,    2,    2,    1,    1,    1,
    1,    1,    3,    3,    3,    3,    3,    3,    5,    5,
    5,    5,    5,    5,    2,    0,    4,    2,    2,    3,
    2,    2,    2,    3,    3,    2,    2,    3,    2,    2,
    3,    1,    2,    2,    3,    2,    2,    2,    2,    3,
    1,    3,    3,    3,    2,    2,    4,    4,    4,    5,
    3,    4,    4,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    2,    1,    1,
    1,    1,    1,    0,    2,    2,    4,    4,    5,    3,
    5,    1,    1,    2,    0,    2,    0,    0,    1,    2,
    2,    4,    3,    2,    2,    7,    1,    0,    1,    0,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    3,
    2,    2,    2,    2,    2,    2,    1,    1,    1,    3,
    1,    1,    3,    6,    1,    1,    1,    4,    5,    1,
    3,    1,    3,    1,    2,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    4,    4,    6,    5,
    3,    0,    2,    2,    0,    3,    0,    4,    1,    5,
    4,    1,    4,    1,    2,    2,    1,    1,    1,    2,
    2,    2,    2,    0,    3,    5,    1,    1,    2,    3,
    1,    2,    3,    0,    1,    1,    1,    5,    5,    6,
    1,    1,    1,    2,    4,    1,    0,    5,    1,    0,
    3,    1,    3,    1,    0,    2,    0,    1,    0,    3,
    1,    0,    1,    2,    1,    1,    1,    1,    1,    1,
    2,    2,    1,    2,    3,    1,    1,    3,    3,    1,
    2,    3,    1,    2,    0,    3,    2,    2,    3,    2,
    1,    1,    0,    1,    1,    1,    3,    2,    3,    0,
    1,    3,    4,    5,    6,    7,    1,    1,    1,    1,
    1,    1,    2,    1,    1,    1,    1,    1,    1,    2,
    1,    1,    1,    2,    1,    1,    3,    3,    0,    2,
    0,    2,    0,    4,    3,    2,    0,    1,    3,    6,
    4,    4,    1,    4,    4,    1,    9,    2,    1,    1,
    0,    2,    4,    2,    2,    4,    2,    1,    1,    1,
    1,    1,    3,    1,    3,    1,    0,    2,    1,    3,
    1,    1,    1,    1,    3,    6,    1,    0,    3,    0,
    1,    3,    1,    1,    1,    4,    5,    5,    1,    1,
    2,    4,    4,    2,    3,    0,    1,    3,    1,    1,
    2,    2,    2,    0,    1,    0,    3,    0,    1,    3,
    1,    2,    0,    2,    0,    2,    0,    4,    1,    2,
    1,    1,    0,    1,    3,    2,    1,    1,    2,    1,
    4,    3,    1,    3,    4,    0,    3,    0,    1,    3,
    3,    1,    1,    0,    2,    0,    1,    1,    2,    4,
    0,    9,    6,    6,    8,    2,    2,    1,    1,    4,
    5,    3,    6,    1,    1,    8,    4,    1,    1,    9,
    5,   12,    2,    0,    2,    4,    0,    4,    1,    3,
    3,    1,    1,    7,    7,    5,    3,    0,    1,    1,
    1,    2,    0,    1,    1,    1,    0,    3,    1,    3,
    1,    0,    3,    1,    3,    1,    3,    3,    1,    1,
    3,    1,    3,    3,    2,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    1,    1,    5,    6,    5,    6,    3,
    4,    5,    6,    3,    4,    3,    4,    4,    5,    6,
    7,    3,    4,    4,    5,    4,    4,    3,    4,    1,
    1,    1,    1,    3,    3,    6,    6,    7,    1,    2,
    1,    0,    2,    0,    2,    0,    2,    0,    1,    1,
    0,    1,    0,    3,    3,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    2,    2,    3,    3,    3,
    3,    3,    3,    3,    3,    1,    1,    1,    1,    3,
    1,    1,    1,    1,    2,    2,    2,    2,    3,    0,
    4,    1,    0,    1,    3,    1,    2,    1,    1,    1,
    1,    1,    1,    1,    2,    2,    2,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    1,
    2,    1,    1,    1,    1,    1,    2,    1,    1,    1,
    1,    1,    1,    4,    5,    5,    5,    5,    5,    5,
    5,    5,    5,    5,    6,    6,    2,    0,    1,    1,
    6,    1,    1,    1,    4,    4,    4,    4,    4,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    7,    8,    8,
    8,   10,    8,    6,    1,    1,    4,    4,    7,    2,
    0,    7,    6,    6,    4,    1,    1,    1,    4,    3,
    6,    1,    1,    6,    8,    6,    6,    8,    1,    1,
    4,    6,    4,    5,    3,    5,    4,    5,    1,    1,
    1,    3,    5,    4,    6,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    0,    1,    0,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,
};
static int yydefred[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  722,    0,    0,    3,    4,    5,    6,    7,    8,    9,
   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,
   20,   21,   22,   23,   24,   25,    0,  705,  706,  707,
  711,  712,  713,    0,  934,  935,  938,  939,    0,  608,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  498,  724,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  143,    0,    0,    0,    0,    0,    0,
  111,    0,    0,    0,   82,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  621,    0,    0, 1430, 1431,    0, 1432, 1433, 1434,
 1435, 1436, 1437, 1438, 1439, 1440,   39, 1441, 1442, 1443,
 1444, 1445,   36, 1446, 1448, 1449, 1450, 1451, 1452,   38,
 1453, 1454, 1447, 1455, 1456, 1457, 1458, 1459, 1460, 1461,
 1462, 1463, 1464, 1465, 1466, 1467, 1468, 1469,    0, 1470,
 1471, 1472,   37, 1473, 1474, 1475, 1476, 1477, 1478, 1479,
 1480, 1481, 1482, 1483, 1484, 1485,    0, 1486, 1487, 1488,
 1317, 1319, 1320, 1321, 1322, 1323, 1324, 1345, 1346, 1325,
 1327, 1326, 1338, 1339, 1332, 1328, 1333, 1329, 1331, 1334,
 1330, 1335, 1336, 1337, 1341, 1342, 1340, 1343, 1344, 1348,
 1347, 1349, 1350, 1351, 1352, 1353, 1354, 1355, 1356, 1357,
 1358, 1359, 1360, 1361, 1362, 1363, 1364, 1365, 1366, 1367,
 1368, 1369, 1370, 1371, 1372, 1373, 1374, 1375, 1376, 1377,
 1378, 1379, 1380, 1381, 1382, 1383, 1384, 1385, 1386, 1387,
 1388, 1389, 1390, 1391, 1392, 1393, 1394, 1395, 1396, 1397,
 1398, 1399, 1400, 1401, 1402, 1403, 1404, 1405, 1406, 1407,
 1408, 1409, 1410, 1411, 1412, 1413, 1414, 1415, 1416, 1417,
 1423, 1419, 1418, 1420, 1421, 1422, 1424, 1425, 1426, 1427,
 1428, 1429,    0,    0,    0,    0,   34,   77,   75, 1309,
 1318,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  867, 1311,    0,    0,    0,
 1310,  806,    0,    0,    0,    0,    0,    0,    0,    0,
  127, 1316,  714,    0,    0,    2,    0,    0,    0,    0,
  813,  816,    0,    0,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,  549,  550,  551,
  552,  553,  554,  555,  556,  564,  558,  559,  557,  560,
  561,  562,  563,  565,  567,  570,  566,  568,  569,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
  582,  583,  584,  585,  586,    0,  534,  535,    0,  499,
 1300,    0,    0,  506, 1304,    0,  503, 1308,    0,  869,
    0,  502, 1312,    0,  510, 1313,    0,  501, 1315,    0,
  509,    0,  507, 1303,    0,  721, 1138,    0,  200,  121,
    0,  122,    0,  258,  979, 1296,  112,    0,  119,  175,
    0,    0,  114, 1142,    0,  123, 1144,    0,  115,    0,
  117,    0,  126,    0,  118,  176,  124,  120,  125,    0,
 1295,    0,  912,  913,    0,    0,   83,    0, 1301,    0,
 1299,  629,  622,    0,  628,  633,  623,  624,  631,  625,
  626, 1059,  636,  627,  632,  634,  635,    0,    0,    0,
   32,    0,   41,  966,   40,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  723,    0,    0,    0,    0,    0,    0,    0,  743,
    0,    0,    0,  730,    0,  733,  735,  736,  737,  738,
  739,  740,  746,  747,    0,  836,    0,    0,  805,    0,
    0,    0,  133,    0,    0,  128,    0,  129,    0,  132,
    0,  131,    0,    0,    0,  777,  778,  785,    0,  784,
  786,  788,  793,  781,  779,  782,  780,  789,  792,  787,
  791,    0,    0,    0,    0,    0,  797,    0,    0,    0,
    0,  820,    0,    0,    0,    0,  511, 1294,    0,    0,
    0,    0,    0,  609,    0,    0,    0,    0,  264,    0,
  512,  142,    0,  508, 1292,  595,  596,    0,    0,    0,
    0,    0,    0,  521,    0,  468,  469,    0,    0,    0,
 1061,    0,    0,  603,  602,    0,    0,  728,  726, 1139,
    0,    0,    0,    0,    0,    0,    0,  203,  161,    0,
  139,    0,    0,    0,    0,  134,    0,  150,  149,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   84,
    0,    0,    0,    0,  937,  630,    0,    0,    0,    0,
 1099, 1134,    0, 1290,    0, 1101, 1203,    0,    0,    0,
 1217, 1135,    0, 1129, 1120, 1119, 1118,    0,    0,    0,
    0, 1104,    0,    0, 1121, 1122, 1130, 1131,    0, 1132,
 1133,    0,    0,    0, 1137,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1136,    0,    0,    0,    0,    0,    0, 1128,
 1124,    0,  976, 1096, 1097, 1098, 1103, 1102, 1081,    0,
    0,    0, 1080,    0,    0, 1085, 1150, 1077, 1078, 1079,
 1082, 1083, 1084, 1123, 1149, 1151, 1152, 1153, 1169, 1170,
 1172, 1173, 1174,    0, 1180, 1235, 1236,    0, 1252, 1253,
 1259, 1260,  259,    0,    0,    0,  446,    0,    0,    0,
  969,   29,    0,    0,    0,    0,   78,   80,   76,   35,
    0,    0,    0,    0,  971,    0,    0,    0,   56,   58,
    0,    0,    0,  719,    0,    0,  773,    0,    0,  744,
    0,  741,    0,  742,  771,    0,  766,    0,    0,    0,
  758,  757,  734,    0,  868,  980,  949,    0,    0,    0,
  809, 1305,  851,    0,    0,  140,    0,    0,    0,    0,
    0,    0,  716,  715,  790,  783,    0, 1307,    0,    0,
    0,  798,  802, 1148,    0,  822,  824,    0,  825,  827,
 1286,  828,    0,  829,  818,    0,    0, 1288,    0,    0,
  804,    0,  219,    0,    0,  158,    0,  614,    0,  615,
  610,  454,    0,  516,  518,  517,  454,  514,  519,    0,
  513,    0,    0,    0,    0,  312,    0,    0,    0,  525,
  526,    0,  588,    0,    0,    0,    0,    0,    0,    0,
  479,  478,    0,  617,    0,    0, 1060,    0,    0,    0,
  453,    0,    0,  199,    0,    0,  208,    0,  207,    0,
    0,  214,  197,    0,  212,  204,    0,    0,  662,  697,
  665,    0,  698,    0,    0,  666,    0,    0,    0,  689,
  701,  661,  684,  663,  664,  659,  646,    0,  637,  638,
  647,    0,    0,  656,  657,  658,  660,    0,    0,    0,
    0,  138,    0,    0,  135,    0,  136,    0,  137,    0,
  153,    0,    0,  240,    0,    0,    0,    0,  453,    0,
    0,  116,    0,  264,    0,    0,   92,    0,    0,    0,
  109,  110, 1140, 1293,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  982,  986,  987,  988,  989,  990,
  991,  992,  993,  994,  995,  996,  997,  998,    0,    0,
    0,    0,    0, 1125,    0,    0,    0,    0,    0,    0,
    0, 1126, 1127,    0, 1105, 1107,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1106, 1108,    0,
    0,    0,    0,    0,    0,  407, 1314,    0,    0,    0,
    0,    0,    0,    0,    0,  436,    0,    0,    0,    0,
    0,  641,  645,    0,    0,  642,  654,    0,    0,    0,
  444,    0,    0,    0,  968,    0,    0,   51,   81,    0,
    0,    0,    0,    0,  974,    0,    0,    0,    0,    0,
    0,  841,  842,  843,  844,  853,  854,  855,    0,    0,
    0,    0,    0,  718,  709,    0, 1146,  708,    0,  745,
  756,    0,  753,  749,  748,    0,    0,    0,  768,  752,
  759,    0,    0,    0,    0,  941,    0,    0,  849,    0,
    0,    0,    0,    0,  453,    0,  130,  796,  795,  774,
    0,    0,    0,    0,    0,    0,  831,    0,    0,    0,
  832,    0,    0,  909,  815,  814,    0,    0,    0,  159,
    0,  613,    0,  515,    0,  520,  604,    0,  600,    0,
    0,  308,  453,  282, 1297,    0,    0,  250,  254,    0,
    0,  248,    0,  255,    0,    0,    0,  287,  281,  284,
  285,  286,  524,  593,  592,  523,  522,    0,    0,    0,
    0,    0,    0,    0,  531,    0,  473,  474,  472,    0,
    0,    0,  471,    0,  454,    0, 1063,    0,    0,    0,
    0,  598,    0,  597,    0,  205,  209,    0,    0,  213,
    0,    0,    0,  685,  686,  702,    0,  699,    0,    0,
  692,  690,  691,    0,  164,    0,    0,    0,  655,    0,
    0,    0,    0,  693,  141,    0,    0,    0,    0,  453,
    0,  239,    0,  242,  244,  245,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  264,   87,    0,    0,
   86, 1143, 1141,    0,    0,    0,  985,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  889,  891,
    0,  886,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1276,
 1277, 1278, 1279, 1280, 1281, 1284, 1285, 1282, 1283,    0,
    0,    0,    0,    0,    0,    0,    0, 1265,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1246, 1248,
 1247,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1094,  438,    0, 1095, 1090,    0,
    0,    0,    0,    0,    0,    0,    0,  408,  409,    0,
    0, 1100,  978,  977,    0,    0, 1250,    0,    0,    0,
  317,    0,  448,  447,    0,  315,  342,    0,  323,  343,
  970,    0,    0,    0,   79,   49,    0,   28,    0,    0,
    0,    0,  924,    0,  973,    0,  923,    0,    0,    0,
    0,    0,    0,  870,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   55,    0,    0,
   62,   70,   72,    0,    0,   54,  710, 1147,  754,  767,
  762,  761,    0,  772,    0,  981,  950,    0,    0,  852,
    0,  453,    0,    0,    0,    0,    0,  775,  794,    0,
  823,  826,    0,    0,    0,    0,    0,    0,    0,    0,
  612,    0,    0,  218,    0,  222,    0,    0,  456,  265,
  266,  267,  268,  269,  270, 1116,  606,    0,  313,    0,
  252,    0,    0,  247,  454,    0,    0,    0,  527,  528,
  533,  532,    0,  590,  529,  476,  477,  475,    0,    0,
    0,  495,    0,    0, 1065,    0,    0,    0,  601,  599,
  230,  231,  206,    0,  217,  674,  673, 1145,    0,    0,
    0,    0,    0,  700,    0,    0,    0,    0,    0,  168,
  170,  171,  172,    0,    0,  650,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  453,    0,    0,    0,    0,
  232,    0,  454,    0,  455,    0,    0,    0,  178,    0,
    0,    0,    0,    0,    0,  183,  185,  186,  187,    0,
    0,   91,    0,    0,    0,    0,   99,   93,    0,    0,
   98,   94,    0,  948, 1298,    0,    0,  999,    0,    0,
    0, 1025, 1024,    0,    0,    0, 1034, 1053,    0, 1048,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  984,    0,  890,    0,    0,    0,    0,    0,
    0, 1154,    0,    0, 1237,    0,    0,    0,    0,    0,
    0,    0,    0, 1109,    0,    0,    0,    0,    0, 1261,
    0,    0,    0,    0,    0,    0,    0, 1274, 1175, 1176,
 1177, 1238, 1178,    0, 1245,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1111,    0,    0,    0,
 1179, 1249,    0,  643,  256,  640,    0,  310,  443,  343,
  324,    0,    0,    0,   44,   48,   46,   50,    0,    0,
    0,  955,    0,  975,    0,    0,  845,    0,    0,  875,
  873,  871,    0,    0,  872,    0,    0,  954,   74,   66,
   67,   73,   68,   69,    0,    0,    0,    0,  764,  765,
  769,    0,    0,  810,    0,  233,    0,    0,  455,    0,
    0,  776,  835,    0,    0,    0,    0,  833,    0,  911,
  910,    0,  196,    0,    0,    0,  223,    0, 1117,  163,
  454,  454,  314,  342,  251,    0,    0,  273,    0,    0,
    0,    0,    0,  288,  530,    0,    0,    0,    0,    0,
    0,  619,  455,    0, 1067,    0,    0, 1057, 1069, 1070,
    0,  455,    0,    0,    0,  668,    0,  667,  703,    0,
  695,  173,  160,  169,    0,    0,  648,  676,    0,    0,
  678,  681,  683,  453,    0,    0,    0,  342,    0,  148,
    0,  243,    0,    0,    0,  459, 1056, 1072,  455,    0,
  188,  191,  190,  193,  192,  189,  195,  177,  184,    0,
  113,    0,  146,    0,  102,    0,    0,    0,    0,   96,
   97,    0, 1046, 1047,    0,    0,    0,    0,    0,    0,
    0,    0, 1049,    0,    0,    0,    0,    0,    0,    0,
 1035,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  897,
    0,    0,    0,  936, 1160, 1159,    0,    0,  263,    0,
 1156, 1155,    0, 1164, 1163, 1162, 1161,    0, 1158, 1157,
    0,    0, 1267,    0,    0,    0, 1266,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  812,  441,  411,  410,    0,  316,
    0,    0,    0,    0,    0,  961,  960,    0,  959,  957,
  965,  964,  962,    0,    0,    0,  865,  863,    0,    0,
  925,    0,    0,  856,    0,   63,   64,   65,   71,    0,
    0,    0,    0,  342,    0,    0,  462,  455,    0,    0,
    0,    0,  917,  918,  915,    0,  228,  224,  455,    0,
    0,  455,  246,  274,    0,    0,    0,  276,  277,  275,
    0,    0,  289,    0,    0,    0,    0,    0,    0,    0,
  616, 1058,    0,    0,    0,  452,    0,  670,    0,  671,
    0,  653,  651,  649,  680,    0,    0,    0,  455,    0,
  455,    0,  455,  342,  455,  449,    0,    0,  234,  454,
  100,    0,    0,  106,  101,    0,    0,    0,    0,    0,
 1054,    0, 1055,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  899,  888,    0,    0,  900,
    0,  896,    0,  260, 1251, 1275, 1234, 1171,    0,    0,
 1263, 1262,    0, 1268, 1254, 1256,    0, 1243, 1244,    0,
    0,    0,    0,    0,    0,    0, 1257,    0, 1166, 1165,
    0,    0,    0,  329,    0,    0,   26,   27,    0,    0,
  922,  847,    0,  857,    0,    0,    0,  926,    0,  927,
    0,    0,  858,  859,  860,   52,   53,    0,  940,  455,
  455,  455,  450,  235,    0,    0,    0,    0,  225,  174,
  456,  456,  307,    0,    0,  279,    0,    0,    0,  493,
  494,  490,  489,  492,  491, 1075, 1074,  457,  216,  669,
  696,  342,    0,    0,  465,  455,  304,  155,  460,  497,
  461,  179,    0,    0,    0,  104,    0,   88,    0, 1011,
 1019,    0,    0, 1012, 1020, 1015, 1023,    0,    0,    0,
 1013, 1021, 1014, 1022,    0, 1008, 1016, 1009, 1017, 1010,
 1018,  895,    0,    0,    0,  261,    0, 1239, 1264,    0,
 1242, 1228,    0,    0,    0,    0,    0,    0,  644,  333,
  343,  338,  332,    0,    0,    0,    0,  326,  327,    0,
    0,   42,  956,  846,    0,    0,    0,    0,    0,  305,
  463,  464,    0,    0,  879,    0,  817,  318,  319,  280,
    0,  249,    0,  291,  455,  455,  455,  451,    0,    0,
    0,   85,  107,  108,  811,    0,    0,    0,    0,  902,
    0, 1255, 1229, 1230, 1231,    0, 1258,    0, 1233,    0,
  334,    0,  339,    0,  420,    0,  325,    0,    0,    0,
  930,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  306,  466,  467,  237,  236,    0,    0,  901,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  435,  349,  345,  346,  351,    0,
  347,  348,    0,  341,  344,  350,  352,  353,  354,  355,
  356,  357,  358,  359,  362,  363,  364,  365,  366,    0,
    0,  429,  430,  431,    0,  952,  953,  428,    0,    0,
    0,    0,  423,  421,    0,    0,    0,  931,    0,  862,
  943,  942,  880,    0,    0,  278,    0,  296,    0,  295,
  290,  147,  904,    0,  262, 1232,    0,    0,    0,    0,
    0,  417, 1306,  432,  433,    0,    0,  340,    0,    0,
  413,  427,  426, 1302,  425,  342,    0,  328,    0,    0,
    0,    0,    0,  300,  299,  298,  905,    0,    0,    0,
    0,    0,    0,  404,    0,    0,    0,    0,    0,  422,
  424,    0,    0,  303,  301,  302,    0,    0,    0,    0,
    0,    0,    0,    0,  387,  388,  389,  390,  391,  392,
  393,    0,  342,    0,    0,    0,    0,  331,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  386,  342,
  367,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  399,  401,  400,    0,    0,    0,    0,    0,  342,  933,
    0,    0,    0,  378,    0,  381,    0,    0,  342,    0,
    0,  342,  412,    0,  376,    0,  377,    0,    0,  402,
    0,  418,  371,  379,  382,    0,  342,  374,
};
static int yydgoto[] = {                                      22,
   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,
   43,   44,   45,   46,  293,  823,  316, 1518, 2054, 1488,
  294, 1147,  295,  826, 1152,  296,  297,  493, 1489, 1807,
  827, 1160,  309,  310, 1519, 1520, 1521, 1522,  411,  417,
  298, 1523,  299,   95,  467,  660,  603, 1035, 1675,  771,
 1350,  997,  445, 1319, 1036, 1037, 1038, 1682, 1677, 2155,
  468, 1040, 1041, 2056,   91,  437,   92,  465, 2387, 1951,
  443,  449, 1032,  451,  455,  439,  430,  432,  446,  457,
  459,  453,  331,  546,  548, 1207,  552,  550,  543,  646,
 1015, 1017, 1019, 1012,  399,  400,  820,  494, 1248, 1233,
 1053, 1936,  650, 1022, 1649, 1930,  965, 1177, 1613,  915,
  916,  939,  640,  998, 1314, 1628, 1471, 1315, 1569, 1870,
 1629, 1630, 1631, 1632, 1633, 1054,  440,  460,  586, 1342,
 1664, 1948, 1665, 1666, 1667, 1668, 1669,  587,  431,  636,
  973,  637,  638,  974,  975,  917, 1564, 1565, 1566, 1866,
  652, 1333, 2149, 1334, 1335, 1336, 1250, 1876, 1132, 1252,
 1253,  773,  814, 2010,  435, 1570,  774,  775,  776,  777,
  778, 1877, 1878,  942, 2110, 2417, 1884, 1259, 1244, 1260,
 1261, 1262, 2418, 2419, 2535,  609,  819, 1290, 1477, 2340,
  407,  935, 1475,  936, 1134, 1873,  815, 1478, 1479, 2341,
 1802, 2225, 2347, 2348, 2349, 1684, 2342, 2343, 2344, 2345,
 2404, 2453, 2454,  867, 2456, 2457, 2458, 2459, 2460, 2461,
 2462, 2463, 2464, 2465, 2466, 2467, 2468, 2469, 2470, 1457,
 2608, 2541, 2563, 2612, 2613, 2614, 2615, 2616, 2564, 2565,
 2566, 2567, 2568, 2569, 2570, 2571, 2544,  779,  780, 2471,
 2405, 2482, 2483, 2523, 2472, 2473, 2474, 2516,  781, 1126,
  782,  490,  816,  817,  783,   47, 1902,  418,  618,  954,
 1285, 1655,  955, 1283, 1279,  447,   72,  613,  412,  344,
  593,  396,  600,  404,  423,  604,  421,  415,  601,  614,
 1266,  615,  949, 1595,  397,  784, 1634,  933, 1239,  626,
  594,  956, 1893,  112,  410,  472,  483, 1000, 1135, 1136,
 1001, 1137, 1635, 1138, 1636, 1004, 1005, 1006, 1007, 1303,
 1622, 1620, 1008, 1009, 1010, 1311, 1011, 1308,   48,   49,
   50,   51,   52,   53,  333,  884,   74,  845,  426,  629,
  524,  525,  526,  527,  528,  529,  530,  531,  532,  533,
  534, 1184,  856, 1533, 1841,  857,  858, 1189,  572, 1210,
  573,  889,  574, 1213,  338,  577,  892, 1969,  340,  585,
  911,  322,  323,  785,  542, 1970, 1115,  341,  909,  342,
  580,  903, 1219, 1555,  664, 2092, 2258, 1070,  581,  582,
  904, 1220, 1221,  537,  873, 1854, 1161, 1162, 1163, 1164,
 1165, 2233,  874, 1166, 1167, 1168, 1510, 2243, 2244, 2245,
 1502,  319, 1821, 2364, 2365, 2000, 1383, 2001, 2002, 2003,
 2192, 2388, 2390, 1223, 1224, 1860, 2095,  834, 1493, 2071,
 2072, 2073, 2411, 2488,  869,   55,   56,  665,   57,   58,
 2414,  835,  870,  786,  787, 1491, 1812, 2058, 2059, 2063,
 1156, 1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063,
 1064, 1065, 1066, 1067, 1068, 1695, 1697, 1698,  621,  960,
 1289, 1607, 1937,  622, 1898, 1899, 1900,  788,  789,  790,
  791,  792,  793, 1085, 1466,  794, 1353,  795,  796,  797,
  798, 2042,  799,  800, 1410,  801,  802,  803,  804,  805,
  806,  807, 2200, 1433,  808,  809,  810, 2040,  811,  812,
 1091, 1416, 1763, 1758, 1092,  301,
};
static int yysindex[] = {                                   4147,
 4739,  -65, 3571, 1393,   73, 5288,  -54,64352,   93,   68,
  628,  -38,  -65,  749,65748,66097,  845,68540,  366,  511,
    0,    0,  869,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  669,    0,    0,    0,
    0,    0,    0,  656,    0,    0,    0,    0,  713,    0,
60828,68540,  875,68540,68540,68540,68540,68540,68540,68540,
68540,    0,    0,  824, 1285,68540,68540,68540,  968,68540,
  796,68540,68540,    0,68540,68540,68540,68540,68540,  699,
    0, 1182,  942,68540,    0,68540,68540,68540, 1054,68540,
68540,68540,68540,  796,68540,68540,68540,68540,68540,68540,
68540,    0,68540, 1260,    0,    0, 1033,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1409,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1409,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1092, 1144,  227, 1485,    0,    0,    0,    0,
    0,68540,68540,68540,68540, 1176, 1284, 1306, 2856,68540,
  481,68540, 1243, 4651, 1323,    0,    0, 1483, 1383,68540,
    0,    0, 1714, 1802,68540,68540,68540,68540,68540, 1253,
    0,    0,    0,68540, 4166,    0, 1433, 1436,    0,  790,
    0,    0,68540, 1678,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  620,    0,    0, 1285,    0,
    0,68540,  569,    0,    0, 1856,    0,    0, 1636,    0,
  689,    0,    0, 1015,    0,    0, 1409,    0,    0,  641,
    0, 1395,    0,    0, 1519,    0,    0, 1527,    0,    0,
 1843,    0, 1683,    0,    0,    0,    0, 1285,    0,    0,
  829, 1856,    0,    0,  583,    0,    0, 1698,    0, 1308,
    0, 1609,    0, 1409,    0,    0,    0,    0,    0, 1703,
    0, 1600,    0,    0, 1708,68540,    0, 1715,    0, 1608,
    0,    0,    0,68540,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,52667,68540, 1661,
    0,68540,    0,    0,    0, 1646, 1684,66446,68540, 1356,
 1748,  391, 1593, 1769, 1832, 1785, 1796, 1743, 1749,  186,
 1631,    0, 1706,68540, 1798,   55,  528,68540, 1709,    0,
 1607, 1633, 1641,    0, 4651,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1836,    0,68540,68540,    0,68540,
68540, 1908,    0, 1285, 1856,    0, 1698,    0, 1412,    0,
 1409,    0, 1766, 1817, 1795,    0,    0,    0, 1890,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1874,68540,68540, 1845, 1727,    0,  126,  184, 1120,
    0,    0, 1950, 1252, 1729, 1833,    0,    0,  -28, 1756,
 1760, 1765, 1678,    0, 1119, 1417, 1949,68540,    0,  620,
    0,    0, 1941,    0,    0,    0,    0,68540, 1661,66795,
 1793,67144, 2231,    0,60828,    0,    0,   91, 1285, 1609,
    0, 1670, 2013,    0,    0, 2027, 1852,    0,    0,    0,
 2242, 2242, 1285, 1946, 1285,  529, 1843,    0,    0, 5936,
    0,68540,68540,68540,68540,    0, 1661,    0,    0, 2028,
  425, 2279,68540,   91, 1670, 2056,68540,68540,68540,    0,
 2294,57413,43772, 1948,    0,    0, 2300, 2304, 2318, 1914,
    0,    0, 2326,    0, 2327,    0,    0, 2344, 2347,    0,
    0,    0, 2363,    0,    0,    0,    0,    0, 2365, 1921,
 1955,    0, 2367, 2367,    0,    0,    0,    0, 2377,    0,
    0,48920, 2378, 2383,    0, 2384, 2059, 2387, 2392, 2393,
 2407, 2410, 2411,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2415,
 2418, 2419,    0,    0,    0,    0, 2422,    0,    0,    0,
    0,    0,    0,    0, 2429,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 2367, 2367,53063,53063,49499,68540,    0,
    0, 3501,    0,    0,    0,    0,    0,    0,    0, 2370,
 2038, 2434,    0,    0, 2427,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 2439,    0,    0,    0, 2441,    0,    0,
    0,    0,    0,63297, 2431,  330,    0, 2442, 2233, 1257,
    0,    0,68540,68540,68540,  113,    0,    0,    0,    0,
68540, 2065,68540, 1043,    0,55660,68540, 2184,    0,    0,
 1646, 2109,66446,    0,68540,  141,    0, 1210, 1973,    0,
 2066,    0, 2066,    0,    0, 2463,    0, 2195, 2093,  796,
    0,    0,    0,68540,    0,    0,    0, 2469,  110, 2458,
    0,    0,    0, 1503, 2482,    0, 1661, 2486,68540,   91,
 2263,68540,    0,    0,    0,    0, 1074,    0, 2192, 2487,
68540,    0,    0,    0,53063,    0,    0,53063,    0,    0,
    0,    0,49895,    0,    0,53063,  656,    0,  656,53063,
    0, 2239,    0, 2193, 2197,    0, 1285,    0, 2200,    0,
    0,    0, 2266,    0,    0,    0,    0,    0,    0, 5936,
    0, 1285, 2183,63297, 1732,    0, 2284,68540,63646,    0,
    0,  605,    0,68540, 1161, 1636, 2161, 2127, 1111,    0,
    0,    0,  477,    0,   51, 2166,    0, 1670, 1285, 1963,
    0, 2113,  149,    0, 2120,  796,    0, 1285,    0, 2295,
 2229,    0,    0,  529,    0,    0,  180, 2136,    0,    0,
    0, 2137,    0, 2194, 2546,    0, 2247, 2555,  611,    0,
    0,    0,    0,    0,    0,    0,    0, 1949,    0,    0,
    0, 2506,  157,    0,    0,    0,    0,  150, 2558, 2560,
 2555,    0, 1285, 1856,    0, 1419,    0, 1409,    0, 2335,
    0, 1285, 1285,    0,66795,  689, 2166, 1963,    0, 2296,
 2570,    0, 2237,    0, 2216, 2576,    0, 5876, 2173, 2249,
    0,    0,    0,    0, 2254, 2582,48128, 2593,    0,    0,
    0,44168, 1911,   94,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  761, 2256,
 1268,53063,  193,    0,68540,53063, 1275, 1280,53063, 1283,
 4049,    0,    0,  796,    0,    0,53063,48128,49499, 3501,
 2196,  602,53063,53063,48128, 2322,53063,53063,53063,53063,
53063,44564,43376, 4049,53063, 1392,53063,    0,    0, 1425,
 1425, 3501, 1841,  656, 2597,    0,    0,68540,53063,53063,
53063,53063,53063,53063,54962,    0,53063,56358,53063,50291,
 2269,    0,    0, 2366, 2280,    0,    0, 2386, 2589,68540,
    0,68540,    0,68540,    0, 2227, 2241,    0,    0, 2211,
66446,  -64, 2356, 2144,    0, 1887, 2637, 2144,55311, 2638,
 2461,    0,    0,    0,    0,    0,    0,    0, 2356,65050,
68540,68540,   95,    0,    0,  671,    0,    0,  -22,    0,
    0, 2234,    0,    0,    0,68540, 1403,68540,    0,    0,
    0, 2641,68540,68540, 1948,    0,53063,68540,    0, 2238,
 2420,66795,  689, 2166,    0, 2650,    0,    0,    0,    0,
 1074,68540, 2358, 2648, 2398, 2892,    0, 3043, 2380, 2656,
    0, 2918, 2658,    0,    0,    0, 1725, 2189, 1285,    0,
  469,    0, 2669,    0, 1245,    0,    0, 1285,    0, 2366,
68540,    0,    0,    0,    0, 2437, 2175,    0,    0, 1949,
  -59,    0, 2678,    0, 2381, 2382, 1409,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  796,68540, 2437,
 2423, 1949,63995, 2175,    0,  492,    0,    0,    0, 2357,
 2359, 2361,    0,  796,    0, 1963,    0, 1285, 2122, 2238,
 2138,    0,  789,    0, 1421,    0,    0, 2341, 1285,    0,
57413,  133, 2339,    0,    0,    0,  796,    0, 2546,  207,
    0,    0,    0,  572,    0,  207, 2342,  207,    0, 2711,
  796,  796,  796,    0,    0, 1661,68540,   91, 2488,    0,
 2403,    0, 1993,    0,    0,    0,   91,   60, 2122, 2238,
67493,  473,66795,68540, 2000,  145,    0,    0, 2715,   52,
    0,    0,    0,57413,68540, 2238,    0, 2238, 1516,  192,
53063,53063,44960, 2719, 1071,45356,53063,45752,  767,46148,
46544,50687, 2334,46940,47336,47732,48128,48128,    0,    0,
 2401,    0, 2723, 1729,53063,53063, 3259,53063, 2725,53063,
 2720, 3008,53063,53063,53063,53063, 1447,53063,53063,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2453,
 2729, 2064,  581, 3023,53063,  765,53063,    0,48128, 3078,
 3565,  663,68540, 3104, 3405, 3426, 3465, 3474,    0,    0,
    0, 2332,51083,    0,    0,    0,    0,  812, 2730,  243,
 3589,53063,53063,  127,    0,    0,  790,    0,    0, 2496,
 1105, 1105, 1425, 1425, 1215,57963, 2731,    0,    0, 2733,
 3501,    0,    0,    0, 2434, 2735,    0, 2035,67842,68540,
    0, 2430,    0,    0, 2037,    0,    0,    0,    0,    0,
    0,65050,65050, 2404,    0,    0, 2508,    0,66446,  655,
 2425,53063,    0,68540,    0,53063,    0, 2741, 1742, 2742,
53063, 1483, 2413,    0, 2413, 1504,48128, 2413, 2452, 2455,
 2425,68540,68540,68540,68540,68540,70285,    0, 2745, 2751,
    0,    0,    0, 2480, 2481,    0,    0,    0,    0,    0,
    0,    0,  662,    0, 2368,    0,    0, 2256, 3501,    0,
 2759,    0, 2071,   91,  738, 2238,66795,    0,    0, 1074,
    0,    0,68540,55660, 2362,53063, 2309,53063,53063,68540,
    0, 2242, 2537,    0,  469,    0,48128, 1551,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  421,    0,    0,
    0, 2541, 2522,    0,    0, 1409, 1409, 2317,    0,    0,
    0,    0,  -59,    0,    0,    0,    0,    0,  491,  497,
   81,    0, 2545, 2122,    0, 1285,  806, 2371,    0,    0,
    0,    0,    0,68540,    0,    0,    0,    0,  262, 2077,
 2400, 2386, 2776,    0, 2120, 2090, 2475, 2366,  572,    0,
    0,    0,    0, 2760, 1282,    0,68540, 1334,  796, 2782,
 2790, 2796, 2574,  689, 2166,    0,    0, 2242, 2197,66795,
    0, 2166,    0,68540,    0, 2516, 2371, 2800,    0, 2267,
  479,  725, 2255, 1285,  473,    0,    0,    0,    0, 2096,
56009,    0,  796, 2462, 2550, 5876,    0,    0,  796,  562,
    0,    0, 2554,    0,    0, 2809, 2820,    0, 3199, 3501,
 2822,    0,    0, 3501, 2829,49499,    0,    0, 2549,    0,
   59, 2831, 3501, 2834, 2559, 2836, 3501, 2838,53063,53063,
 2719,53063,51479, 2454, 2839, 3501, 2842, 2853, 3501, 2854,
53063, 3501,53063, 2859, 3501, 2862, 2864, 3501, 2865, 2867,
 3501, 2879,    0, 2644,    0,65399, 2144, 3524, 3531,68889,
 3601,    0, 3653,53063,    0, 3712, 3734, 3782, 3914,53063,
 3940, 3985,53063,    0,53063,53063, 3501, 2498,53063,    0,
53063, 3501, 2617,  590,53063,53063,53063,    0,    0,    0,
    0,    0,    0,53063,    0,53063, 2451, 2499,53063,53063,
53063,53063, 4268, 4268,53063, 1729,    0, 2102,57963,56707,
    0,    0,68540,    0,    0,    0,68540,    0,    0,    0,
    0, 2629, 2483, 2483,    0,    0,    0,    0,  212,  212,
  119,    0,  139,    0, 2106, 1483,    0, 2125,68540,    0,
    0,    0, 2588,  571,    0,55660,55660,    0,    0,    0,
    0,    0,    0,    0,65050,65050,65050,65050,    0,    0,
    0, 2889, 1729,    0,    0,    0, 2166,68540,    0, 2371,
 2135,    0,    0, 2886, 1742,48128, 2607,    0, 1178,    0,
    0, 3501,    0, 2120, 2556, 2120,    0,  349,    0,    0,
    0,    0,    0,    0,    0, 2366, 2522,    0,  640,53063,
 2539, 2317, 1182,    0,    0, 2563, 2565, 2566, 2567, 2568,
 2571,    0,    0,  806,    0, 2495, 2497,    0,    0,    0,
 2677,    0, 2445, 2923,  262,    0, 2518,    0,    0,  207,
    0,    0,    0,    0,  207,  207,    0,    0, 2386, 2927,
    0,    0,    0,    0,   91,  771, 2238,    0, 2120,    0,
 2197,    0, 2545,    0, 2545,    0,    0,    0,    0, 1285,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2595,
    0, 2648,    0, 2932,    0, 2933, 1285,   40, 2935,    0,
    0, 1285,    0,    0,53063, 2238, 2238, 2145,  656, 2936,
53063, 2662,    0, 2238, 2238,53063, 2238, 2238, 3607, 3501,
    0, 2615,53063, 3501,53063, 2238, 2238, 2238, 2238, 3501,
 2621, 2238, 2238, 2238, 2238, 2238, 2238, 2401,68540,    0,
 2938, 2937, 1480,    0,    0,    0, 2609, 5936,    0, 2939,
    0,    0, 4377,    0,    0,    0,    0, 4481,    0,    0,
 4489, 2581,    0,53063, 2679, 2561,    0,53063, 4521, 2168,
 4801, 4531, 4540,53063,53063, 5059, 2112, 5065, 5071, 2209,
53063, 2944, 2947, 2471,    0,    0,    0,    0, 2943,    0,
 2721, 2577, 2672,  -64,  -64,    0,    0, 2575,    0,    0,
    0,    0,    0,57963, 2144,70634,    0,    0,55660, -108,
    0, 2580, 2584,    0, 1831,    0,    0,    0,    0,  -64,
  -64,53063, 2144,    0, 2545, 2545,    0,    0, 2595,55660,
 2724, 2676,    0,    0,    0, 1421,    0,    0,    0, 1245,
 1245,    0,    0,    0, 2668,68540, 2317,    0,    0,    0,
 3501,68540,    0, 2690, 2596, 2694, 2599, 2732, 2702, 2746,
    0,    0, 2587, 2598, 2663,    0,68540,    0, 3005,    0,
 3017,    0,    0,    0,    0,    0, 2166,68540,    0, 2371,
    0, 1421,    0,    0,    0,    0, 3018, 2788,    0,    0,
    0, 2698,  -94,    0,    0, 2386, 2712, 3501, 3036, 3037,
    0,  790,    0, 3501,53063, 3038, 3039, 3501, 3040, 3041,
53063,53063, 3501, 2825, 3046, 3050, 3052, 3053,53063, 3055,
 3057, 3058, 3062, 3064, 3065,    0,    0,65399, 3068,    0,
68540,    0,68191,    0,    0,    0,    0,    0,53063, 3076,
    0,    0,53063,    0,    0,    0,53063,    0,    0, 4565,
 4574,53063,53063,53063,53063,53063,    0, 3501,    0,    0,
53063,68540,    0,    0,68540, 2750,    0,    0,  212, 2731,
    0,    0, 1802,    0, 2569, 2708, 2764,    0, 2573,    0,
48128, 3096,    0,    0,    0,    0,    0, 2225,    0,    0,
    0,    0,    0,    0, 1742,53063,48128, 1948,    0,    0,
    0,    0,    0, 2317, 1409,    0, 3097, 1409,68540,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 2545, 2545,    0,    0,    0,    0,    0,    0,
    0,    0,  -86,53063, 1285,    0, 2683,    0, 1285,    0,
    0, 1729, 3501,    0,    0,    0,    0, 3501, 3501,53063,
    0,    0,    0,    0, 3501,    0,    0,    0,    0,    0,
    0,    0,68540, 2810,68540,    0, 3501,    0,    0, 4847,
    0,    0, 4958, 4984, 4992, 3501, 2873, 1667,    0,    0,
    0,    0,    0, 2848, 2716,63297, 3103,    0,    0, 2874,
    0,    0,    0,    0, 2738, 2734,   94,68540, 2604,    0,
    0,    0, 3501, 3112,    0,   94,    0,    0,    0,    0,
 2802,    0, 2802,    0,    0,    0,    0,    0, 2680, 2686,
 3501,    0,    0,    0,    0, 3501, 3133, 3139, 3144,    0,
 3140,    0,    0,    0,    0,53063,    0,53063,    0,62599,
    0, 1036,    0, 2716,    0, 2366,    0, 2871, 2858, 2791,
    0, 2253, 2641, 2144,53063,  508, 2317, 2824, 2830, 2317,
    0,    0,    0,    0,    0, 3155,68540,    0,68540,68540,
 3501, 5014,68540,  -90,    0, 3163, 2608, 2870,53063,    0,
    0,68540,68540,68540,    0,    0,    0,    0,    0, 2872,
    0,    0, 3150,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  568,
 3152,    0,    0,    0,    0,    0,    0,    0,68540,68540,
  262,  453,    0,    0,  421, 3175, 2641,    0,68540,    0,
    0,    0,    0,  716,  716,    0, 2921,    0, 2789,    0,
    0,    0,    0, 3185,    0,    0,53063,53459,48128, 2801,
 3501,    0,    0,    0,    0,68540,57963,    0,  -31, 3187,
    0,    0,    0,    0,    0,    0, 1036,    0, 2238, 2797,
 3186, 2780,   80,    0,    0,    0,    0, 3501,49499, 3501,
 1146,  457, 2945,    0, 2900, 2731, 2752, 2901,48128,    0,
    0, 3208, 3214,    0,    0,    0, 5021, 2823, 2946,53063,
 1313,53063, 2922, 1146,    0,    0,    0,    0,    0,    0,
    0, 2835,    0,57963,53459,57963,  531,    0,53063, 3219,
53063,53855, 3501, 2844, 2880, 2851, 3501,57963,    0,    0,
    0, 2731, 1146,  205, 2962, 2261,53063, 3501, 2671, 3501,
    0,    0,    0, 2731, 2972, 2951, 2991, 2982,    0,    0,
 3501, 2277, 2287,    0, 2673,    0,    0,53063,    0,57963,
68540,    0,    0,68540,    0,53063,    0,53063, 3501,    0,
  613,    0,    0,    0,    0, 3501,    0,    0,
};
static int yyrindex[] = {                                   2884,
    0,  309,  104,    0,    0,    0,    0,    0,    0,    0,
    0,64701,  332,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 3292,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  242,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  353,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 2961,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   42,    0,    0, 2920,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  148,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  148,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2925,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  353,    0,    0,  361,    0,    0,    0,42991,    0,    0,
    0,    0, 2890, 3032,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  475,51875,  383,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  536,    0,    0,    0,    0,
 1361,    0,    0,  134,    0,    0, 3045,    0,    0,    0,
    0,    0,    0,    0, 1148,    0,    0,    0,    0,    0,
  181,    0, 6457,    0,    0,    0,    0,    0,    0,    0,
    0,  536,    0,    0,  501,    0,    0, 3263,    0,  665,
    0,    0,    0, 3045,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  337,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  213,    0, 3054,
    0,    0,    0,    0,    0,69238,    0,    0,    0,    0,
    0,  982,    0,    0,    0,    0,    0,    0,    0,    0,
69587,    0,    0,    0,    0,    0,    0,    0,  449,    0,
    0,    0,    0,    0, 1184,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  536,    0, 3263,    0,  665,    0,
 3045,    0,    0, 1213,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  286,    0,    0,    0,    0,52271,
48524,    0,    0, 2909,  229,    0,    0,    0,    0,    0,
    0,    0, 1329,    0,    0,    0,    0,    0,    0, 1338,
    0,    0,  279,    0,    0,    0,    0,    0, 3054,  727,
61190,    0, 1391,    0,    0,    0,    0,  204,    0,  134,
    0,  138,    0,    0,    0,    0,    0,    0,    0,    0,
 2869, 2869,    0,    0,    0, 1429,  208,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 3054,    0,    0, 1374,
    0,    0,    0,    0,  140,    0,    0,    0,    0,    0,
 5358,    0,    0,  251,    0,    0,    0,    0,    0,    0,
    0,    0,32839,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 4370,    0,    0,
    0,    0, 3789, 3789,    0,    0,    0,    0,30515,    0,
    0,    0,33420,34001,    0,34582,35163,    0,    0,    0,
    0,    0,    0, 4951, 5532, 6113, 6694, 7275, 7856, 8437,
 9018, 9599,10180,10761,11342,11923,12504,13085,13666,31096,
31677,35744,14247,14828,15409,15990,36325,16571,17152,17733,
18314,18895,19476,20057,32258,20638,21219,21800,22381,22962,
23543,24124,24705,25286,25867,26448,27029,27610,28191,28772,
29353,29934,    0, 3789, 3789,    0,    0, 2884,    0,    0,
    0, 1034,    0,    0,    0,    0,    0,    0,    0,37487,
 1464,  215,    0,36906,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  146,    0,    0,    0,    0,
    0,    0,    0, 2884,    0,    0,    0,    0,    0,    0,
69238,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  281,    0,  281,    0,    0,  610,    0,  945, 1455,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  337,    0,
    0,    0,    0,    0,    0,    0, 3054,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1513,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1468,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1295,    0, 1152,    0,    0, 1741,
    0,    0,    0,    0,    0,  241,    0,  138,    0,  136,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1496,    0,    0, 2199, 2993,    0,    0,
    0, 3069,    0,    0, 3444,    0,    0, 3490,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  745,    0,    0,
    0,  919, 1100,    0,    0,    0,    0,57769, 3131,    0,
 3490,    0,    0,  536,    0,  665,    0, 3045,    0,    0,
    0,    0,    0,    0,  727,  665,  850,  144,    0,  239,
    0,    0,    0,    0,    0, 2942,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1719, 1589, 2369,
 2670, 2884,    0, 1521,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 3279,  201,
54251,    0,54251,    0,    0,    0,54251,54251,    0,54251,
    0,    0,    0,    0,    0,    0,    0,    0, 2884, 2881,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,54251,    0,    0,    0,38649,
39230, 3282,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 3306,    0,
 1387,    0,    0, 1860, 2298,    0,    0, 1755,    0,    0,
    0,    0,  595,    0,    0,    0,    0,    0,    0,    0,
    0, 1534,  397, 1541,    0,    0,    0, 1541, 2884,41944,
 2985,    0,    0,    0,    0,    0,    0,    0,  397,    0,
    0,    0, 1534,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  779,    0,    0,    0,
    0, 2914,    0,    0,  251,    0,    0,    0,    0, 2884,
    0,  727,  665,  850,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  429,    0,    0,    0,57056,    0, 3035,
    0,  311,  579,    0,    0,    0,  448,    0,    0,    0,
  284,    0,    0,    0,    0,    0,    0,    0,    0,  874,
    0,    0,    0,    0,    0, 1226, 3520,    0,    0, 1020,
 3542,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 3314,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  791,
  840, 1098,    0,    0,    0,  136,    0,    0,  221, 2884,
    0,    0,    0,    0,  723,    0,    0,    0,    0,    0,
    0,    0, 2248,    0,    0,    0,    0,    0, 3444,    0,
    0,    0,    0,  328,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 3054,    0,    0,    0,    0,
  178,    0,    0,    0,    0,    0,    0,    0,  763, 2884,
    0,  179,  727,    0,    0, 5921,    0,    0,    0,  300,
    0,    0,    0,    0,    0, 2884,    0, 2884,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 3316,    0,    0,  167,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 2022, 2421, 2866, 3268,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  109,    0,    0,38068,
40973,41554,39811,40392,    0,    0, 1568,    0,    0,    0,
 1286,    0,    0,    0, 3317,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1499,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1581,    0,    0,    0,    0,    0,    0,    0, 2985, 1883,
    0,42642, 3019,    0, 3019, 2985,    0, 3019,    0,    0,
 1581,    0,    0,    0,    0,    0,  435,    0,  147,  151,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  201, 1058,    0,
    0,    0,    0,    0,    0, 2884,  727,    0,    0,    0,
    0,    0,    0,    0, 1800,    0,  305,    0,    0,    0,
    0, 2869, 2913,    0, 2345,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 2288,    0,  595,
    0,    0, 2727,    0,    0,    0,    0, 1191,    0,    0,
    0,    0, 1363,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1595,  221,    0,    0, 1613, 1628,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 2971,    0,    0,    0,    0,    0, 1644,  362,    0,
    0,    0,    0, 1350,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  665,  850,    0,  595, 2869, 1666,  727,
    0, 3100,    0,    0,    0, 1681, 1628,    0,    0,    0,
    0,    0,    0, 1685,  196,    0,    0,    0,    0,    0,
    0,    0,    0, 5921,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,49266,
    0,    0,    0,58293,    0, 2884,    0,    0,    0,    0,
    0,    0,58389,    0,58549,    0,58594,    0,    0,    0,
    0,    0,    0,    0,    0,58688,    0,    0,58720,    0,
    0,58878,    0,    0,58910,    0,    0,59004,    0,    0,
59049,    0,    0,60513,    0, 3279, 1541,    0,    0, 6470,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 2941,    0,    0,    0,
    0,  793,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 3328, 3328,    0, 3329,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  153,  153,    0,    0,    0,    0,    0,    0,
    0,    0, 1695,    0,    0,42293,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  167,    0,  595,    0, 3100,    0,    0, 1628,
    0,    0,    0, 2685, 2632,    0, 2257,    0,    0,    0,
    0,  603,    0,    0, 2924,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1457, 3060,    0,    0,    0,
    0, 1191, 2961,    0,    0, 1199, 1538, 1542, 1615, 1668,
 1675,    0,    0, 1613,    0,    0,    0,    0,    0,    0,
    0,    0,  218,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 3647,    0,
    0,    0,    0,    0,    0,    0, 2884,    0,    0,    0,
 1774,    0,    0,  595,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1778,
    0, 1784,    0,    0,    0,    0,    0,  250,    0,    0,
    0,    0,    0,    0,    0, 2884, 2884,    0,    0,    0,
    0,    0,    0, 2884, 2884,    0, 2884, 2884,    0,59147,
    0,59257,    0,59353,    0, 2884, 2884, 2884, 2884,59463,
59559, 2884, 2884, 2884, 2884, 2884, 2884,54613, 1536,    0,
    0, 3332,    0,    0,    0,    0, 3334,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 3335,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,69936,    0, 1534, 1534,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1541,60673,    0,    0,    0,    0,
    0, 1790, 1805,    0, 2985,    0,    0,    0,    0, 1534,
 1534,    0, 1541,    0,    0,    0,    0,    0, 1778,    0,
    0, 1312,    0,    0,    0, 1013,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1307,    0,    0,    0,
 3336,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  595, 3100,    0,    0, 1628,
    0,  464,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  754,    0,59617,    0,    0,
    0,  109,    0,59711,    0,    0,    0,59792,    0,    0,
    0,    0,59886,59967,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 3279,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 3337,    0,    0,
    0,    0,61901,    0,    0,    0,    0,    0,    0, 1808,
    0,    0,59315,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 3280,    0,    0, 1365,    0,    0,
    0,    0,    0, 1307, 1614,    0,    0,  175,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  351,    0,    0,    0,
    0, 3329,60090,    0,    0,    0,    0,60184,60265,    0,
    0,    0,    0,    0,60323,    0,    0,    0,    0,    0,
    0,    0,    0, 2292,    0,    0, 3339,    0,    0,    0,
    0,    0,    0,    0,    0, 2310,    0,    0,    0,    0,
    0,    0,    0,    0,62250,    0,    0,    0,    0,    0,
62948,    0,    0,    0,    0,    0,60615,    0,  173,    0,
    0,    0, 1893, 2757,    0, 2012,    0,    0,    0,    0,
 1979,    0,  187,    0,    0,    0,    0,    0,    0,    0,
 3336,    0,    0,    0,    0,60419, 3341,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  619,
    0,    0,    0, 3079,    0,  231,    0,    0,    0,    0,
    0,    0,    0, 1541,    0,    0, 1307, 3220, 3308, 1191,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 2311,    0, 1916,    0, 2116, 1960,    0,    0,    0, 2174,
 2226, 2232,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 2042,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 3326,    0, 2914,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 3333,    0,    0,    0,
 3340,    0,    0,    0,    0,    0,    0,    0, 2884,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 2884,    0,
  143,    0,    0,    0,    0,    0,    0, 3344, 2884,  862,
  164,    0,    0,    0,    0, 3346,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 3350,  200,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 4759,
    0,    0, 1150,    0,    0,    0, 1700,    0,    0,    0,
    0, 3351, 3056, 3087,    0,    0,    0, 1830, 4218, 1927,
    0,    0,    0, 3352,61552,    0,    0,    0,    0,    0,
 2319,    0,    0,    0,    0,    0,  118,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1938,    0,
    0,    0,    0,    0,    0, 2337,    0,    0,
};
static int yycindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 3128,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 2868,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1371,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 2912,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 3353,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 3029,    0, 3031,    0,    0,    0,    0, 3369,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 3373, 3376,
 3377,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 3379,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 2894,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 2821,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2898,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
static int yygindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0, 1026,    0,
    0, 1028, 1032, 1035,    0,    0,    0,    0,    0,-1188,
    0, 1038, 1040,    0, 3136, 2601,   30,-1036, 1650,-1086,
 3146, 2286, 3149, 2613,    0,    0, 2964, -172,    0,    0,
 -817,  -37,    0,    0,    0,    0,  105,  158,  -62,  -60,
  -58,   41, 2963,    0,    0,    0, 1357,    0,    0,  -57,
 1789, -909,  -70,-1467, 2438, 2128, -535,    0, 1806,    0,
 3374, 2129, 2178, -649,    0,    0,    0,-1104,  -63,    0,
    0,    0,    0,    0,    0, 3396,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -71,    0, -874, -894, 1816, -887,
 1458, -500,    0,    0,    0,    0, -565, -543,-1097, 1840,
 -599,  -73,    0, -868, 2244,    0,-1195, -480, -132, -246,
    0, 1869,    0, 1623, -557, -939,  -19, -102, -584,    0,
    0,    0,    0, 1844,    0,    0,    0,    0,    0,    0,
    0,    0, 2876,    0, 2540,    0,    0,    0, 1953,    0,
 2977, -938, 1422, 1876, 2917, 2928,    0,    0, -608, -821,
    0,  -52, -476,    0, -792,    0,-1151,-1119,-1114,-1112,
-1110,    0, 1656,-1392,    0, 1164,-1714,    0, 2603,    0,
    0,    0, 1134, 1136, 1060, -301, -495, -944,-1422,-1355,
    0,    0,    0, 2315, -911, 1073,-1022,    0, 2081,-1033,
-1667,    0,    0,    0,    0,-1367,-1285,    0,    0,    0,
    0,    0,    0,-1145,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,-1401,
    0,  985,  970,    0,    0,  944, 2806,  951,    0, 1006,
    0,    0,    0,    0,    0,    0,    0,-1109,-1105, 1138,
 1185,    0, 1055,    0,    0,    0,    0,    0,    0,    0,
 -757,    0,    0, 2448, -564, -697,-1473,    0, -404, -612,
 -977,-1415,    0,    0,    0, -643,    0,    0,    0,    0,
    0, 2978,    0,    0,    0,    0,    0,    0, 2995, 2651,
    0,    0,    0,    0,    0,   -8, -727,    0,    0,    0,
 3003,    0,    0,    0,   10,    0,    0,    0,    0,    0,
    0, -610, 2281, -609, 1682,    0,    0,    0,    0,    0,
    0,-1457,    0,    0,    0, 2591,    0, 2291,    0,    0,
    0,    0,    0,    0, -163,    0, 3590,    0, 3294,    0,
    0,    0, 3088,    0,    0,    0,    0,    0,    0, 2766,
    0, 2763,    0,    0,    0, 2433,    0,    0,    0,-1035,
    0, -443,    0,    0,    0,    0,    0,    2,-1007,-1029,
-1273,  460,    0,  -12, 1388, 3161,    0, 1011,    0,    0,
    0,    0,    0,    0, -765,    0,    0,-1130,    0, 3044,
 1320,    0, 2068,-1083,-1000,    0,-1076, 2467,-1295,    0,
    0,    0,    0,    0,    0,    0, 2114,    0,    0,    0,
    0,  169,  878,    0, 1207, 2572,    0, 1439,    0, 1639,
    0, -442,    0,    0, 2082,    0,    0,-1159,-1111,    0,
 1562, 1567,    0,    0, 1156,    0,    0, 2784,    0,    0,
    0, 1242, -709, 1256, 1259, 2491, 2151,-1630,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1078, 1952,    0, 3212, -441,
 -785,-1132,    0, 3048, 1772,    0, 2019,    0,    0,-1108,
    0,    0,    0,  673,    0, 2101,    0,    0,    0,    0,
    0, 1892,    0,    0, -678,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,-1483, 1919,    0,    0,
};
#define YYTABLESIZE 71249
static int yytable[] = {                                     300,
  403,   54,  433,  324,  495,  438,  317,  321,  487,  332,
 1113,  420, 1042,  897,  900, 1458, 1214,  429, 1043, 1459,
  450, 1133, 1240,  434,  318,  454,  473,  406,  456, 1002,
 1003,  999, 1535,  479,  896,  899,  972,  924,  477, 1235,
 1384, 1027,  442,  481, 1578,  654, 1497,  484, 1537, 1338,
  485,  422,  398,  401, 1788,  405,  408,  317,  413,  416,
  419,  300,  424,  930, 1538,  478,  966,  436,  401,  424,
 1249,  408, 1030,  317,  413,  488,  416,  419,  300,  424,
  461,  476, 1499, 1571, 1340,  469, 1526,  317,  471,  401,
  486,  469,  424,  405,  408,  409,  317,  413,  416,  419,
  300,  424,  461, 1195,  408,  318, 1447, 1357,  414, 1480,
 1737,  448, 1360,  937,  480, 1572,  928, 1557, 1178, 1476,
 1573, 1799, 1574, 1155, 1575,  452, 1576, 1275, 1351, 1849,
  890,  934, 2051, 1062, 1553, 1066, 1158, 1064, 1151, 1064,
  647, 1133,  932, 1066,  880,   45,   60,  482, 1413,  908,
   61, 1020,   43, 1194, 1908, 1422, 1151, 1874, 1296, 1296,
 1296, 1296, 1296, 1310, 1296,  895,  921, 2113, 1122, 1120,
  554, 1121,  944, 1123,  967, 1548, 1619,  154,  181, 2060,
  201,  770, 1127, 1939, 1674, 1176,  297, 1892,  770, 1321,
 1879,  967, 1062, 1293, 1066,  182, 1064, 1540, 1064, 1486,
  908,  932, 1066,  618,   45,   60, 1656,  202, 1296,   61,
 2379,   43,  439, 1028,  437,  967, 1191,  215,  967, 1302,
 1068, 1270,  385,  898, 1928,  921, 1545,  297,  921,  499,
  297,  944, 1688,  967, 1389, 1294,  154,  181,  180,  201,
  496,  799, 1339,  877,  623,  297,  770, 1318, 1789,  501,
  887, 1625,  504,  544,  182, 2296, 1039,  851,  384,  908,
 1546, 2235,  618, 1543,  470,  549,  202, 1204,  551,  921,
  499,  439, 2023,  437,  770, 2025,  215, 2547,  605, 1068,
  755,  656,  799,  220,  307,  801, 1781,  921,  545,  257,
  103,  257,  513,  436,  317,  317,  436,  180, 1580,  496,
  799,  300,  113,  424,  916,  445, 1039,  324,  725,  887,
  914,  321, 2153,  318,  913, 1230,  401,  408,  317,  413,
  419, 1236,  849, 1653, 1680,  332,  801,  167, 1002, 1003,
 1251,  725,  502, 1485,  588, 1464,  885,  605,  113,  755,
   95,  602,  220,   95,  801,  916, 1458, 1280,  916,  951,
 1459,  914,  727, 2062,  914, 1377,  547, 1972, 1486,  952,
  732,  166, 1588,  916,  302, 1234, 1455,  725,  144,  914,
 1141, 1465, 1468, 1140,  972, 2555, 2088, 1890,  881,   73,
  641, 1201,  908, 1281, 1258, 1647,  167, 2297,   96, 2099,
  725,  105, 2266,  605, 1296,  885,  958, 1603, 1681, 1296,
 1536,  144,  304, 1118, 1670, 1973,  853, 2508, 1119,   45,
   60,  727,   16, 1891,   61,  308,   43, 1786, 1819,  732,
  166, 1295, 2084,  908, 1439, 1440, 2556,  303,  800, 1584,
  833, 1317, 1913, 1654, 1323,  144,  813, 1733, 1734,  821,
 1411,  908,  445, 1800, 1480, 1803, 1804,  919,  750, 2130,
  847, 2134,  901, 1377,  114,  958, 1062,  605, 1066, 2236,
 1064, 1498, 1064,  229,  953,  605, 1066,  618, 2607,  800,
 1378, 1894,  503, 2064,  803,  914,  201, 1855, 1323, 1764,
  436, 1872, 1282,  436, 1879,  866,  876,  800,  919,  416,
  300, 1388, 2380, 1323,  850, 2154, 2527, 2572,  385, 1274,
 1604,  843, 1541,  202,  496,  405,  919,  750, 1843,  317,
 2139, 2144, 2045,  215, 1852,  803, 1286, 2143, 2102, 2145,
  154,  967,  229,  201,  865,  868,  257,  324,  321, 1673,
 2074,  321,  872,  803,  384, 1062, 1487, 1066,  828, 1064,
 2201,  220,  921, 1068, 2204,  929, 1480,  855,  967, 2370,
  202,  663, 1853,  220,  103,  813, 1150,  434, 1780,  945,
  215,  957,  947,  921,  888,  888, 1618, 1824, 1378, 2083,
 1013, 2595, 2141,  894, 1473,  967,  799,  969,  907,  220,
 1618, 1016, 1626,  932, 1018,  220, 1320,  220,  894,  436,
   60,  618, 1608, 1024,   61, 1033,  894, 1845, 2353,  436,
 1301,  436,  920,  436,  167, 1014,  950,  180, 1851,  760,
 1377, 1328,  439, 1480,  437, 1175,  908,  755,  916,  907,
  801, 1337, 1068, 1292,  914, 2004,  220, 1868,  887,  181,
  181,  894, 1528,  401,  408,  413,  419,  907,  166,  916,
 1602,  605, 1657,  920,  317,  914,  182,  182,  588,  317,
  405, 1617,  498, 1044,  894,  105, 1789, 1043, 1686,  444,
 1687,  920, 2230, 1623, 1593,  967, 2286, 1926,  760, 2251,
 2252, 1808,  921, 2400, 1933,  755, 1794,  297,  755, 2047,
 2103, 1174, 1026, 2048,  201,  799,  832, 1031, 2298,  180,
  180, 1881, 1882,  921,  755, 1487,  908, 1880, 1323,  944,
   95, 1927, 2496, 1785, 1042, 2501, 1767,  725,  908,  444,
 1043,  202, 1326, 2282,  885, 1645, 1871,  908, 1377, 2329,
  755,  215,  229,  885, 1652, 1378,  180,  908, 2250,  801,
  725, 1314, 2066, 1062, 1813, 1062, 1062, 1066, 1815, 1064,
 1064, 1064, 1064, 1818,  165, 1066,   45,   60,  916, 1528,
 2075,   61, 2526,   43,  914,  921,  958,  725,  887, 1778,
 1117,  919, 1068,  800,  934, 1934, 1351, 1023, 1549, 1114,
 1596, 1885,  180, 2234, 2050,  755, 1953,  887, 2114,  539,
  866,  229,  919,  151, 1814,  750, 1148,  220, 2290, 1857,
  482, 1592, 1377, 1888,  677,  755, 1952,  677, 1544,  309,
 2080, 2081,  914,  165, 2494,  436,  229,  851,  755,  803,
 1676, 1480,  916,  180,  317,  408,  416,  750,  914, 1562,
  868, 1068,  317, 1886,  970,  606,  908,  408,  317, 1209,
 1643,  916, 1377, 1378,  416,   54,  332,  914,  821,  480,
 1800, 1660, 1377,  750,  885, 1329,  750,  922, 1850,  482,
  648, 1377, 1146, 1122, 1120,  317, 1121, 2350, 1123, 1231,
 1153,  334,  750,  885,  322, 1149, 1169, 2376, 2377, 2085,
  317,  913,  800,  317, 1237,  427,  428,  595, 1323,  425,
  922, 2519,  436,  828,  335, 1312, 1254, 1563,  750,  342,
  908,  919,  907, 1192, 1800, 1296, 1597,  607,  480,  305,
 1480, 1287,  852, 1276, 1417, 1418,  511, 1378, 1203,  908,
 1297, 1206, 2637,  907,  257,  922,  920,  257,  654, 1255,
  375,  596, 1887,  470, 1377,  436, 2375,  336, 1889, 1245,
  436, 1847,  414,  470,  257, 1245,  309,  920, 1968, 2495,
  649, 1627,  624,  750,  770,  616,  760, 1378, 1571, 1571,
 1313,  151,  151, 2231, 1458, 1325,  853, 1378, 1459,  654,
 1661, 2162,  654,  750, 1331, 1332, 1378, 2227, 2228, 1904,
 1809, 2249,  434,  854,  919, 1043,  750,  654,  760, 2136,
 1572, 1572,  337, 2100, 2101, 1573, 1573, 1574, 1574, 1575,
 1575, 1576, 1576, 2246, 2247, 1256, 1864, 1464, 2259,  871,
 2049, 1653,  283,  770,  760, 1756, 1662,  760, 2030, 1627,
 2520, 2070,  229, 2255, 2028, 1449,  436,  617,  229,  165,
  165,  165,  907,  760, 1277,  807,  677,  597, 2385, 1903,
 2105, 1278,  971, 1114, 1653, 1257, 2106, 1709,  470, 1378,
 1942,  283, 1419, 1960, 2288,  598,  920, 1663,  625,  760,
 1800, 1710, 1918, 1114,  482, 1391, 1839,  951,  677, 2403,
  165,  414,  339,  165, 1943,  229,  424, 1759, 1760,  312,
 2107,  229, 1961,  229, 1114, 2514, 2515, 1114,  165,  599,
 1810, 1528, 1929, 1598, 2532, 1068,  907,  813, 1118,  813,
 1114, 1481, 1114, 1119, 1711, 1271, 1271,  481, 1379,  677,
  677,  951, 1480,  480,  760,  907,  229, 1840,  229,  461,
 1800, 1848, 1460,  496,  165, 2546,  951,  283,  894,  436,
  343, 1380, 1712, 2533,  760,  375, 1114, 2367, 1896,  920,
  229,  436, 2302,  436, 1148,  436,  642,  760, 1676, 2194,
  677,  866,  416,  677, 2138, 1527, 1122,  729, 2545,  434,
  408, 1123,  325, 1209,  677,  229,  481,  283,  677, 2283,
   54,  416,  317,  408,  482, 1043, 1043,  583,  313,  257,
 2534, 1561, 2592,  763, 2594,  314, 1381,  317,  482,  317,
 1577,  868, 2131,  731,  436, 1713, 2604, 2132,  813,  872,
  292,  828,  402,  436,  654,  654,  375, 1589,  487,  654,
 1524,   54,  654,  888, 2008, 1761,  729, 1897,  397,  677,
 2485, 2450,  717,  480,  654,  855, 1590, 1534, 2631,  584,
 1594,  643,  425,  496,  763, 1436,  229,  480,  441, 2140,
 1605,  292,  436, 1271,  292,  375,  894,  326, 1659, 1925,
 2550, 1615,  731,  444, 2057, 2057, 2061,  375, 1800,  292,
 1640, 1641, 1642, 2632, 2455, 2129,  644,  487, 1127,  466,
  436, 1043, 2294, 1610,  436,  253, 1436,  645,  327, 1436,
  229,  717,  328, 1400, 1401, 1402, 1403, 1404, 1405, 1406,
 1407,  770,  229,  329, 1436, 1115, 1944, 2591,  654, 1568,
  434,   54, 1044,  462,  594,  165,  165, 1145, 2478,  489,
 1144, 2357, 2492,  165, 2605,  375,  292, 1787,  229,  654,
 1945,  883, 2137,  770,  229,  654,  229, 2366,  317,  375,
 2096, 2109, 2098, 2623, 2248, 1916, 1115, 2530,  504, 1115,
 2548, 1230,  461, 2630,  436,  317, 2633,  505,  594,  770,
 2552,   54,  770, 2479, 1115, 1044, 1685,  292, 2087,  654,
  292, 2638,  883,  594, 2480,  229, 1644,   54,  770,   54,
  470,  481,  589,  229,  887,  292, 1086, 1795, 1114, 1699,
  883,  474, 1714, 1671, 1917,  677,  677, 1916, 1115,  901,
  677, 1118, 1408,  677,  770, 2142, 1119,  504,  972,  165,
  500, 1270, 2121,  652,  922,  677,  505, 1002, 1003,  999,
  619, 2126,  923, 1768,  330,  887,  589, 1458, 1409, 2558,
  165, 1459, 1271,  397,  424,  972,  165, 1700,  902,  470,
 1208,  589,  620,  887,  491,  972, 1919, 1324,  210, 2339,
 1324,  229,  591, 1114, 2406,  951, 1108, 1109, 2146,  770,
 1701,  866,  652, 1460,  951, 1324,  463, 1324,  492,  500,
  165, 1831, 2481,  591,  751, 1833,  257, 1863, 1834,  770,
  436,  461,  487,  442, 1458,  496, 1458,  607, 1459,  677,
 1459,  481,  770,  416,  416, 1830, 1157,  654, 1458,  464,
  416,  868, 1459, 2412,  397,  481,   16,  210, 1122, 1120,
  677, 1121, 1209, 1123,  434,  211,  677,  257,  951,  951,
  257, 1436, 1436,  416,  408,  413,  416,  419,  300, 1436,
 1458,  907,  611,  751, 1459,  257,  229,  497, 1272, 2559,
  884, 1436,  442,  397,  427,  428,  607,  901,  500,  828,
  677, 2560, 2391,   47,  901,  397,  670,  488,  436,  901,
  947,  484,  901, 1199,  872,  408, 1198,   54, 1895,  505,
  908,  461, 1829, 1133,  211, 1832, 1445, 1122, 1120,  591,
 1121,  884, 1123,  672,  616,  951, 1385,  440, 1920, 2542,
 1273,  611,  487, 1393,  514, 1375, 1374, 1376, 1395,  884,
  963, 1398,  292,  292,  951, 1043,  487, 2253, 1050, 2561,
  292,  674,   47,  397,  620, 1436,  488,  434, 2260,  947,
  484, 2263, 1955, 2562, 1179,  588, 1947,  397, 1959, 2577,
 2267,  591, 1071,  967,  483, 1264, 1436, 1265,  821,  470,
 1115,  653, 1436,  519,  470,  883,  440,  458,  588,  470,
 1335, 1335, 1050, 1335, 1335, 1335,  617, 2505, 2285,  963,
 2287,  436, 2289,  257, 2291,  317,  883, 1050, 1335, 1335,
 1335,  901,  127,  620,  967,  535, 1436,  967,  677,  506,
 2093,  682,  436, 1324, 2057,  156, 2009,  486,  616, 1274,
 2094, 1071,  967,  483,  485,  616,  292,  684,  887, 1335,
 1073,  507, 1324, 1935,  194, 1115,  458,  434,  140,  883,
 1442,  685,  686,  687,  945,  427,  428,  292,  883,  887,
  925, 1118,  257,  292,   93,   94, 1119, 2399, 1122, 1120,
  591, 1121,  926, 1123,  690,  691,  692,  693,  694,  695,
  696,  697,  698, 1118,  156,  879,  486,  317, 1119,  700,
  701,  436, 1327,  485,  470,  427,  428,  292,  705, 1073,
  617,  883,  887,  194,  813, 1999,  536,  617,  470, 2360,
 2361, 2362,  159,  945,  677,  883, 1324,  540,  398, 1475,
 1475, 1475,  163, 1475, 1475, 1475, 1122, 1120,  321, 1121,
  611, 1123, 1242,  157, 1750, 1241, 1460,  238, 1475, 1475,
 1475,  436,  611,  145,  436, 2378, 1361,  177,  436,  928,
  538,  751, 1118,  342,  887,  677, 1531, 1119,  677,  885,
 1362,  488, 1611, 1612,  929,  484, 2068,  946,  887, 1475,
  321, 2189, 1532,  677,  611,  677,  611,  408,  408,  883,
 1503, 2596,  661,  751,  152,  152,  416,  416,  416,  416,
  666, 2525,  157, 1504,  884, 1363,  238, 1043,  883,  317,
  885,  541,  145, 1364,  884, 2190,  884,  553,  928,  751,
 1050, 1365,  751,    6,    9,  884, 1505, 2191,  885, 1335,
  763,  764,  765,  929,  575, 1335,  946,  898,  751, 1366,
 1335, 1367,  887, 1335, 2421, 2422, 2423, 2086,  483,  576,
 2426, 1446, 2147, 1368, 1127, 1369, 1370, 1371,  396,  967,
  967,  887,  881,  610,  751,  608,  611,  967,  884, 2152,
  257,  898, 1050,  257, 2157, 1050, 1508,  884, 1335,  627,
 2584,  488, 1050,  898, 1050,  484, 1335, 1225, 1050, 1226,
  257, 2585, 2586, 1050, 1335,  488, 1050, 1495,   54,  484,
 1494,  486,  628,  881, 1372,  589,  881,  612,  485, 2076,
 2078, 1050, 1335, 1118, 1335,  772,  639,  590, 1119,  751,
  884,  881, 1122, 1120, 1050, 1121, 1335, 1123, 1335, 1335,
 1335, 1445, 1050,  398,  884, 1050, 1050, 2261, 2262,  751,
 1375, 1374, 1376, 1445,  370, 1050, 1445,  630,  297,  591,
 2398,  592,  751,  967, 2503,  395, 2504,  967,  483, 1475,
  317, 1050, 2077, 2079,  619, 1475,  394,  685,  686,  687,
 1475, 1118,  483, 1475,  967, 1450, 1119, 1335, 1999,  651,
  967,  882,  677, 1050, 2368, 2369,  657, 1450, 1050,  297,
 1450, 1296,  297,  658, 2279,  695,  696,  677,  884, 1050,
 1050,  677, 1050, 1651,  398,  677, 1650,  297, 1475,  659,
 1672,  486, 1296, 1347,  967,  662, 1475,  884,  485,  663,
  677, 1460,  882, 2232, 1475,  486,  677,  321, 1503,  677,
  408,  818,  485, 1345, 1345, 1284, 1345, 1345, 1345,  822,
  882, 1504, 1475,  398, 1475, 1792,  824, 1798, 1127, 1050,
 1797,  408,  831,  836,  837,  398, 1475, 1310, 1475, 1475,
 1475,  838, 2371,  396, 1505, 2373, 1050,  317,  839, 1306,
 1050,  677, 1296,  317,  967, 1122, 1120, 1506, 1121,  840,
 1123, 1846, 1345,  885, 1650, 1050,  841, 1906,  461, 2326,
 1905, 1373,  842,  885,  677,  885,  844, 2324, 1296,  317,
 1911,  846,  859, 1910,  885, 2265, 1950, 1475,  860, 1650,
  434, 2268, 2046,  398, 1508, 1789, 2065, 1503, 1296, 1127,
 1559, 2346,  848, 1122, 1120,  677, 1121,  398, 1123, 1090,
 1504, 1446,  677,  861,  396, 2067,  535, 2284, 1127,  862,
  864,  875,  434, 1446,  361, 2089, 1446,  885, 1650,  317,
  677, 1361,  405, 1505,  436, 2161,  885, 1118, 1127,  882,
  395,  883, 1119,  631, 1335, 1362, 1506, 1999,  675,  841,
 1296,  394,  885,  396, 2241, 2374,  881,  886, 2206,  887,
  677, 1127,  841,  436,  677,  396, 2351,  891,  881, 1483,
  841,  893,  906, 1110, 1111, 1112,  632,  881,  633,  885,
 1363, 1483,  360, 1508, 1483,  841,  910, 2382, 1364,  675,
  912, 2384,  675,  885,  927,  932, 1365,  672,  841, 2217,
  634,  943, 2216, 1509,  297,  297,  878,  675,  918,  675,
  405,  395,  297,  919, 1366, 2359, 1367,  920, 1127,  959,
  881, 1325,  394,  396,  946,  635,  961, 1330, 1368,  881,
 1369, 1370, 1371, 1325,  415,  841, 1325,  396,  672, 1330,
  416,  672, 1330, 2490,  962,  963, 1144,  878, 1345, 1296,
  395, 2610,  964, 1345, 1127,  821,  672,  885,  672,  968,
 1021,  394,  395,  677,  405,  878,  436, 2625, 1025, 1029,
 2624, 2242,  881,  394, 1475,  882,  885, 2627,  320, 1372,
 2626,  320,  906, 1034, 1069,  906,  881,  436,  639, 1071,
 1118,  639, 1509, 1072,  221, 1119,  882,  866,  297,  436,
 1272, 1273, 1215, 1272, 1273, 1216,  639, 1073,  639,  383,
 1218, 2507,  383, 1222, 1074, 1075, 1076, 1227, 1051,  297,
  395, 1082, 1775, 1122, 1120,  297, 1121,  380, 1123, 1755,
  380,  394, 1822, 1077,  395, 1825, 1078,  868, 1118,  882,
 1386, 2475, 1390, 1119,  841,  394, 1394, 1396,  882, 1399,
  881,   54, 1080,  221, 1081, 1083, 1084, 2522, 1096,  297,
 1336, 1336, 1051, 1336, 1336, 1336, 1087, 1093,  405,  881,
  405,  436, 1094, 1095,  401, 1443, 1097, 1051, 1336, 1336,
 1336, 1098, 1099, 2513, 1685, 1685,  866, 1125, 1551, 1122,
 1120,  882, 1121, 1704, 1123, 1708, 1100, 1717, 1720, 1101,
 1102, 1726, 1729, 1732, 1103,  882,  675, 1104, 1105, 1336,
 1124, 1106, 1346, 1346, 1285, 1346, 1346, 1346, 1107,  297,
  401, 2524, 1128,  675,  675,  675,  868, 1127, 1129,  675,
 1130, 1142,  675, 1345, 1345, 1345, 1345, 1345, 1345, 1345,
 1345, 1139, 1122, 1120,  675, 1121, 1143, 1123, 1154, 1170,
  675, 1172, 1181, 1183, 1460,  672, 1186, 1685, 1187, 1359,
 1190, 1346, 1122, 1120, 1193, 1121, 1373, 1123, 1197,  882,
   54, 1200,  672,  672,  672, 1202, 1205, 1211,  672, 1387,
   54,  672, 1212, 1392, 1228, 1229, 1397, 2213,  882,  913,
 1114,  922, 1232,  672, 1412, 1238, 1414, 1243, 1268,  672,
 1420, 1421, 1269, 1284, 1424, 1425, 1426, 1427, 1428, 1432,
 1438, 1460, 1441, 1460, 1444, 1288, 1291,  894,  675, 1298,
  878, 1299, 1304, 1305,  639, 1460, 1450, 1451, 1452, 1453,
 1454,  772,  878, 1306, 1461, 1307,  772,  772, 2617,  675,
 1309,  878, 1345,  639, 1310,  675, 1316, 1322, 1330, 1323,
 1122, 1120,  221, 1121,  675, 1123,  675, 1460, 1118, 1343,
 1344, 1341, 1685, 1119,  221, 1117, 1346,  672, 1345, 1347,
 1352, 1356, 1122, 1120,  675, 1121, 1355, 1123, 1354,  675,
 1051,  839, 1358,  583,  878, 1423, 1415, 1448,  672, 1336,
  221, 1469, 1470,  878,  672, 1336,  221, 1774,  221, 1472,
 1336,  770, 1482, 1336, 1539,  672, 1122, 1120,  675, 1121,
 1317, 1123, 1122, 1120, 1484, 1121, 1483, 1123, 1490, 1052,
 1492, 1529,  839,  672, 1118,  839, 1496, 1501,  672, 1119,
  833,   16, 1051, 1542,  838, 1051,  878,  221, 1336, 1547,
  839, 1144, 1051, 1550, 1051, 1554, 1336, 1346, 1051, 1556,
  878, 1558, 1346, 1051, 1336, 1560, 1051,  672, 1567, 1581,
 1582, 1337, 1337, 1052, 1337, 1337, 1337, 1585, 1591, 1586,
 1587, 1051, 1336, 1606, 1336,  838,  271, 1118, 1052, 1337,
 1337, 1337, 1119, 1599, 1051, 1600, 1336, 1601, 1336, 1336,
 1336, 1609, 1051,  838, 1621, 1051, 1051, 1118, 1614, 1637,
 1639, 1646, 1119, 1648, 1679, 1051,  877,  675, 1696, 1723,
 1337, 1735, 1736, 1744,  878, 1742, 2034,  271, 1753, 1754,
  271, 1051, 1118, 1779, 1789, 1791, 1796, 1503, 1790, 1805,
 1806, 1816, 1817,  878, 1811,  271, 2221, 1336, 1835, 1826,
 1504, 1820, 1827, 1051, 1836, 1837, 1838,  877, 1051, 1844,
 1859, 1842, 1865, 1856, 1875,  938,  672, 1883, 1653, 1051,
 1051, 1907, 1051, 1505, 1901,  877, 1909, 1915, 1689, 1690,
 1694, 1912, 1921, 1703, 1705, 1707, 1506, 1716, 1719, 1722,
 1922, 1725, 1728, 1731, 1507, 1118, 1923, 1924, 1896, 1940,
 1119, 1941, 1738, 1739, 1946, 1741, 1673, 1743,  221, 1963,
 1746, 1747, 1748, 1749, 1957, 1751, 1752, 1118, 1962, 1051,
 1964, 1966, 1119, 1508, 1971, 1976, 1122, 1120, 1967, 1121,
 1974, 1123, 1757, 1975, 1762, 1977, 1051, 1978, 1986, 1985,
 1051, 1987, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
 1777, 1118, 1988, 1989, 2199, 1051, 1119, 1118, 1992, 1783,
 1784, 1993, 1119, 1994, 1995, 1377, 1996, 1391, 1391, 1282,
 1391, 1391, 1391, 2397, 1122, 1120, 2396, 1121, 1997, 1123,
 2027, 2172, 2024, 2052, 2035, 2069, 2053, 2179, 2082, 2090,
 2091, 1052, 1552, 1122, 1120, 2112, 1121, 2097, 1123, 2115,
 1337, 2116, 2117, 2118, 2119,  839, 1337, 2120, 2123,  772,
 2124, 1337, 2125,  772, 1337,  839, 1391,  839,  772, 1122,
 1120, 2127, 1121, 2128, 1123, 1618,  839, 2135, 2148,  874,
  677, 2150, 1509, 2151, 1336, 2156, 2163, 2165, 2187, 2195,
 2188, 2193, 2202, 1052, 2219, 2203, 1052, 2220, 2222, 1337,
 2223, 1346,  687, 1052, 2226, 1052, 2256, 1337,  838, 1052,
 2229, 2257,  283,  271, 1052, 1337, 2264, 1052,  838,  839,
  838,  677, 2224, 1218,  677, 1222, 1862, 1346,  839,  838,
 2237, 2269, 1052, 1337, 2239, 1337, 2271, 2270, 2273,  677,
 2272,  677,  687,  687, 2274, 1052,  687, 1337, 2278, 1337,
 1337, 1337, 2275, 1052, 2276, 2280, 1052, 1052, 1745, 1122,
 1120,  687, 1121,  687, 1123, 2277, 1052, 2281, 2292,  272,
 2295,  839,  838, 1445, 1122, 1120, 2293, 1121,  688, 1123,
  877,  838, 1052,  839, 2299,  839, 2300, 2301, 2304, 2305,
 2306, 2307,  877,  687, 1122, 1120, 2311, 1121, 1337, 1123,
 2312,  877, 2313, 2314, 1052, 2316,  283, 2317, 2318, 1052,
  272, 1118, 2319,  272, 2320, 2321, 1119, 2323,  688,  688,
 1052, 1052,  688, 1052,  838,  117, 2328,  283,  272, 1122,
 1120, 1765, 1121,  283, 1123, 2352,  838,  688,  838,  688,
  682, 2310, 2356, 2235,  877, 2358, 2355, 2372, 2383,  839,
 2236, 2389, 1391,  877, 1769, 1122, 1120, 1391, 1121, 1118,
 1123, 2401,  127,  772, 1119, 2415, 2402,  283,  839,  688,
 1052, 2407, 2409, 2408,  133, 2410, 1979, 1980, 1118, 1982,
 1984,  682, 2413, 1119,  682, 2416, 2427, 1052, 1990, 2428,
 1991, 1052,  463, 2429, 2486, 2430,  877, 2424,  140,  682,
 2487,  682,  838, 2425, 1118, 2502, 1052, 2497, 2489, 1119,
  877, 2013, 2509, 2499,  303, 2510, 2517, 2018, 2518, 2521,
 2021,  838, 2022, 1762, 2529,  464, 1762, 2494, 1757,  293,
 2495,  682, 2029,  772, 2031, 2537, 2549, 2543,  677, 1194,
 2553, 2032, 2554, 2033, 2574, 2576, 2036, 2037, 2038, 2039,
 1122, 1120, 2044, 1121, 2573, 1123,  677,  677, 2578, 2575,
  687,  677,  159, 2579,  677, 2581, 2588, 2582, 2597, 2590,
  293, 2609,  163,  293,  877,  687,  677,  687,  687,  687,
 2601, 2602,  677,  687, 2619, 1337,  687, 2603,  293,  840,
 2621, 2622, 2618,  877, 1118, 2620, 2628,  177,  687, 1119,
  807,    1,  914,   31,  687,  850,  808,  687,   33, 1118,
 1122, 1120,  241, 1121, 1119, 1123,  536,  294,  967, 1414,
 1414, 1283, 1414, 1414, 1414, 1289,  198,  311,  893, 1118,
  840, 1270,  874,  840, 1119, 1114,  688, 1391, 1391, 1391,
 1391, 1391, 1391, 1391, 1391,  283,  272, 2111,  840,  687,
  677,  688,   90,  688,  688,  688, 1113,  972,  294,  688,
  830,  294,  688,  253, 1118,  892,  876, 1112, 1414, 1119,
  226,  677,  687,  496,  688, 1269,  294,  677, 1168,  921,
  688,  227,  894,  688, 1324, 1241,  455, 1167,  677, 1240,
 1118,  903,  336,  687,  320, 1119,  419,    0,  682,  687,
  385,  368,   15,  687,    2,   12,  677,   18,  405,   18,
  687,  677,  369,  682,  406,  682,  682,  682,  372,  434,
  373,  682,   21,   23,  682,  688,   26,   29,  687,   33,
   35,   39, 2158,  687,   42, 2446,  682, 2447, 2164,  283,
  677, 2448,  682, 2168, 2449,  682, 1391, 2451,  688, 2452,
 2173, 1171, 2174,  704,  508, 1770, 1122, 1120,  687, 1121,
  283, 1123,  687, 2055,  509, 1173,  283, 1525,  510,  688,
 1965,  829, 1391,  830, 1958,  688, 1771, 1122, 1120,  688,
 1121, 1345, 1123,  475, 1678, 1118,  688,  682, 1616, 1956,
 1119, 1762, 1683,  458,  704, 1762, 1954,  704, 1931,  694,
  283, 2210, 2211, 1583,  688,  293,  293, 1914, 2218,  688,
  682, 2108,  704,  293,  704, 1772, 1122, 1120, 1949, 1121,
 2254, 1123,  976, 1300, 1773, 1122, 1120, 1867, 1121, 1381,
 1123,  682, 1740,  878,  688, 1932,  940,  682,  688,  677,
  694,  682, 2104,  694,  704, 1118, 2420,  941,  682,  772,
 1119,  637, 1122, 1120, 1414, 1121, 1263, 1123,  694, 1414,
  694,  687, 2500, 2498, 2536, 1579,  682, 2528, 1801, 2593,
 1381,  682, 2606, 1381, 2005, 1122, 1120, 2634, 1121, 2589,
 1123, 2006, 1122, 1120, 1116, 1121, 2635, 1123, 1381, 2512,
  694, 2551,  637,  294,  294,  637,  682, 1474, 2484,  293,
  682,  294,  948,  840,  931,  921, 1267, 2133, 1638, 1624,
  637, 1324,  311,  840,  512,  840, 1122, 1120, 1766, 1121,
  293, 1123,  863, 1180,  840, 1185,  293,  874, 1530, 1823,
 2354, 2493, 2303, 1858,  905, 1500, 2322,  688, 2308, 2309,
 1122, 1120, 1782, 1121, 2240, 1123, 2315, 2186, 2238, 1861,
 1382, 2011, 1122, 1120, 2531, 1121,  677, 1123, 1122, 1120,
  293, 1121, 1196, 1123, 2491, 2476, 2327,  840, 2477, 1511,
 1762, 1828, 1981,  655, 2330, 2122,  840,  958, 1869, 2333,
 2334, 2335, 2336, 2337, 1938, 2043,    0,  294, 2338, 2026,
    0, 1118,    0,    0,    0,    0, 1119,  677,    0,  682,
  677,    0,    0, 2012, 1122, 1120,    0, 1121,  294, 1123,
    0,  704, 1118,    0,  294,  677,    0, 1119,    0,  840,
  293,    0,    0, 2363,    0,    0,  704,    0,    0,  704,
  704,  840,    0,  840,  704,    0,    0,  704,    0, 1414,
 1414, 1414, 1414, 1414, 1414, 1414, 1414,    0,  294,  704,
    0, 1118,    0,    0,    0,  704, 1119,  694,  704,    0,
 1118, 2381, 2014, 1122, 1120, 1119, 1121,    0, 1123,    0,
    0,    0,  694,    0,    0,  694,  694, 2386,    0,    0,
  694,    0,    0,  694, 2015, 1122, 1120, 1118, 1121,    0,
 1123,    0, 1119,    0,    0,  694,    0,  840, 1110,    0,
  704,  694,    0,    0,  694, 1381, 1381,    0,  294,    0,
 1118,    0,    0, 1381,    0, 1119,  840, 1118,    0,    0,
    0,    0, 1119,  704,    0, 1381,    0,  637,  637,    0,
    0,    0, 2016, 1122, 1120,  637, 1121,    0, 1123, 1110,
 1110, 1110, 1110, 1110,  704, 1110,  694,  637, 1414,    0,
  704, 1118,    0,    0,  704,    0, 1119, 1110, 1110, 1110,
 1110,  704,    0, 2431,    0, 2432,    0,    0,    0,  694,
    0,   75,    0,    0, 1414, 1118,    0,    0, 2171,  704,
 1119,   76, 2363,    0,  704,    0,    0, 1118,   77,    0,
  694, 1110, 1119, 1118,    0,    0,  694,    0, 1119, 1381,
  694,   78,    0,    0,    0,    0, 2511,  694,    0,  704,
    0,    0,    0,  704,    0,    0,    0,    0,    0,    0,
 1381,  637,    0,    0,    0,  694, 1381,    0,    0,    0,
  694,    0,  677,  677,    0,    0,    0,    0,    0, 1118,
  677,    0,  637,    0, 1119,    0,    0,    0,  637,    0,
    0,    0,  677,    0,    0,  694,    0,   79,    0,  694,
 1381,    0,    0,    0, 2017, 1122, 1120,    0, 1121,    0,
 1123,    0,    0,   80, 2538, 2540,    0,    0,    0,    0,
    0,    0,  637,    0,    0,    0,    0,    0,    0,   81,
 2019, 1122, 1120,    0, 1121,    0, 1123,    0, 1118,    0,
    0,    0,    0, 1119,   82,    0, 2557,    0,   83,    0,
    0,   84,  704,   85,    0,    0,    0,    0,    0,   86,
 1118,    0,    0,    0,    0, 1119,  677, 2583,    0, 2587,
    0,    0,    0,    0,    0, 2020, 1122, 1120,   87, 1121,
    0, 1123, 2540,    0,    0,    0,  772,  677, 2598, 2600,
    0,    0,    0,  677,    0, 1110, 1110, 1110,  694,    0,
 1110,    0, 1110, 1110, 2611,    0, 1110, 1110, 1118, 1110,
    0,    0,    0, 1119, 1110, 1110,    0,    0, 1110, 1110,
 1110, 1110, 1110, 1110,    0, 2629, 1110,  677,    0, 1110,
    0,    0,    0, 2611,   88, 2636, 1110,   89, 1110, 1110,
 1110, 1110, 1110, 1110,    0, 1110, 1110,    0,    0, 1110,
    0,    0, 1110,    0, 1110, 1110,    0,    0, 1110, 1110,
 1110,    0, 1110,    0, 1110, 1110, 1110, 1110, 1110, 1110,
    0,    0,    0, 1110, 1110, 1110, 1110, 1110,    0,    0,
   90, 1110,    0,    0,    0,    0,    0,    0,    0, 1110,
    0, 1110, 1110, 1110, 1110,    0, 1110,    0,    0,    0,
    0, 1110, 1110,    0, 1110,    0, 1110,    0, 1110, 1110,
 1110,    0, 1110,    0, 1110, 1110, 1110,    0, 1110, 1110,
 1110, 1110, 1110,    0, 1110, 1110,    0,    0,    0, 1110,
 1110,    0, 1110, 1110,    0, 1110, 1110, 1110, 1110,    0,
 1118, 1110,    0,    0, 1110, 1119, 1110, 1110, 1110, 1110,
 1110,    0, 1110,    0, 1110,    0, 1110, 1110, 1110, 1110,
 1110,    0,    0, 1110, 1110, 1110, 1118, 1110, 1110, 1110,
    0, 1119,    0,    0,    0,    0,    0,    0, 1110, 1110,
 1110,    0, 1110, 1110, 1110,    0,    0,    0, 1110,    0,
    0, 1110,    0, 1110, 1110, 1110, 1110,    0, 1110,    0,
 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,    0, 1426,
 1426, 1118, 1426, 1426, 1426,    0, 1119, 1110, 1110,    0,
 1110, 1110, 1110,    0,    0,    0, 1426, 1110, 1110, 1110,
 1110, 1110,    0, 1110,    0,    0, 1110, 1110, 1110, 1110,
 1110, 1110, 1110,    0,    0,    0, 1110, 1110, 1110, 1110,
 1110, 1110, 1110, 1110,    0, 1110,    0,    0, 1426, 1122,
 1120, 2041, 1121,    0, 1123, 1110, 1110, 1110, 1110, 1110,
 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
 1110, 1110, 1110, 1110, 1110, 1110,    0, 1110, 1110, 1110,
 1110, 1110, 1110,    0, 1110, 1110, 1110, 1110,    0, 1110,
    0, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1317,
 1110, 1110, 1110, 1110,    0, 1110, 1110, 1110, 1110, 1110,
    0, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
 1110, 1110, 1110, 1110, 1110, 1110,    0, 1110, 1110, 1110,
 1110, 1110,    0, 1110,    0,    0,    0,    1,    0, 1291,
 1317, 1317, 1317, 1317, 1317, 1317, 1317, 2196, 1122, 1120,
    0, 1121,    0, 1123,    0,    2,    0, 1317, 1317, 1317,
 1317, 1317,    0,    3,    0,    0,    0,    0,    0,    0,
  555,    4,    0,    5,    0,    0,    0,    0,    6,    0,
    0,    0,    0,    0,    0,    7,  556,    0,    0,    0,
 1317,    0, 1317,    0,    0,    0,  557,    0,    0,    8,
    0,    0,    0,  558,    0,    0,    0,  559,  560,    9,
    0, 1426,    0,    0,    0,    0,  561,    0,    0,    0,
    0,    0,    0,    0, 1426,    0,    0,  562,    0, 1426,
    0,    0,    0,    0,    0,    0,    0,   10,    0,    0,
 1400, 1401, 1402, 1403, 1404, 1405, 1406, 1407,    0,    0,
    0, 2197, 1122, 1120,    0, 1121,    0, 1123,    0, 2198,
 1122, 1120,    0, 1121,    0, 1123,    0,    0,    0,    0,
    0,   11,    0,    0, 1118,    0,    0,    0,   12, 1119,
  563,   13, 1426,    0,   14,    0,    0,    0,  564,    0,
    0, 2205, 1122, 1120,    0, 1121,    0, 1123,    0,    0,
    0, 2208, 1122, 1120,    0, 1121,    0, 1123,   15,    0,
 2209, 1122, 1120,    0, 1121,    0, 1123,    0,    0,  565,
   16, 1426,    0,  566,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1426,  567, 2331, 1122, 1120,    0, 1121,
    0, 1123,    0,    0, 2332, 1122, 1120,    0, 1121, 1408,
 1123,    0,    0,  568,  569,    0, 1317,   17, 1317,    0,
    0, 1317,    0, 1317, 1317,    0,    0, 1317, 1317,    0,
 1317,    0,   18,   19,    0, 1409, 1317,    0,    0, 1317,
 1317, 1317, 1317, 1118, 1317,    0,    0, 1317, 1119,    0,
 1317, 1426,    0,    0,   20,    0,    0, 1317,    0, 1317,
 1317,    0, 1317, 1317, 1317, 1426, 1317, 1317,    0,  570,
 1317,    0,  571, 1317,    0, 1317, 1317,    0,    0, 1317,
 1317, 1317,    0, 1317,    0, 1317, 1317, 1317, 1317, 1317,
 1317,    0,    0,    0, 1317, 1317, 1317, 1317, 1317,    0,
    0,    0, 1317,    0,    0,    0,    0,    0,    0,    0,
 1317,    0, 1317, 1317, 1317, 1317,    0, 1317,    0,    0,
    0,    0, 1317, 1317,    0, 1317,    0, 1317,    0, 1317,
 1317, 1317,    0, 1317,    0, 1317, 1317, 1317,    0, 1317,
 1317, 1317, 1317, 1317,   21, 1317, 1317, 1118,    0,    0,
    0, 1317, 1119, 1317, 1317, 1118,    0, 1317, 1317, 1317,
 1119,    0, 1317,    0,    0, 1317,    0,    0, 1317, 1317,
 1317, 1317,    0, 1317,    0, 1317,    0, 1317, 1317, 1317,
 1317, 1317,    0,    0, 1317, 1317, 1317, 1118, 1317, 1317,
 1094, 1094, 1119, 1094,    0, 1094,    0, 1118,    0, 1317,
 1317, 1317, 1119, 1317, 1317, 1317, 1118, 1094,    0, 1317,
    0, 1119, 1317,    0, 1317, 1317, 1317, 1317,    0, 1317,
    0, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317,    0,
    0, 1118, 1122, 1120, 2207, 1121, 1119, 1123, 1317, 1317,
 1118, 1317, 1317, 1317,    0, 1119,    0,    0, 1317, 1317,
 1317, 1317, 1317,    0, 1317,    0,    0, 1317, 1317, 1317,
 1317, 1317, 1317, 1317,    0,    0,    0, 1317, 1317, 1317,
 1317, 1317, 1317, 1317, 1317,    0, 1317, 2392, 1122, 1120,
    0, 1121,    0, 1123,    0,    0, 1317, 1317, 1317, 1317,
 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317,
 1317, 1317, 1317, 1317, 1317, 1317, 1317,    0, 1317, 1317,
 1317, 1317, 1317, 1317,    0, 1317, 1317, 1317, 1317,    0,
 1317,    0, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317,
 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317,
 1357, 1317, 1317, 1317, 1317,    0, 1317, 1317, 1317, 1317,
 1317,    0, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317,
 1317, 1317, 1317, 1317, 1317, 1317, 1317,    0, 1317, 1317,
 1317, 1317, 1317, 1317, 1317,    0,    0,  515,    0,    0,
 1181, 1357, 1357, 1357, 1357, 1357, 1357, 1357, 2393, 1122,
 1120,    0, 1121,    0, 1123,    0,    0,    0, 1357, 1357,
 1357, 1357, 1357,   59,    0,    0,    0,    0,    0,  516,
    0,    0, 1094,    0, 2394, 1122, 1120,    0, 1121,   60,
 1123,    0, 2395, 1122, 1120, 1094, 1121,    0, 1123,   61,
 1094, 1357,    0, 1357,    0,  517,   62,    0,  518,    0,
   63,    0,    0,    0, 2506, 1122, 1120,    0, 1121,    0,
 1123, 2580, 1122, 1120,  519, 1121,    0, 1123,    0,    0,
   64,    0,    0,    0,    0,    0,    0, 1118,    0,    0,
    0,    0, 1119,    0,    0,    0,    0,    0,    0,    0,
  520,    0,    0, 1094,    0,    0,    0,    0,    0,    0,
 1122, 1120, 2212, 1121,    0, 1123, 1122, 1120, 2214, 1121,
    0, 1123, 1122, 1120, 2215, 1121,    0, 1123,    0,    0,
    0,    0,    0, 1118,    0,    0, 2159, 2160, 1119,    0,
    0,   65, 1094,    0, 2166, 2167,    0, 2169, 2170,    0,
    0,    0,    0,    0, 1094,  521, 2175, 2176, 2177, 2178,
    0,    0, 2180, 2181, 2182, 2183, 2184, 2185,    0,    0,
    0,    0,   66,    0,    0,  522,   67,    0,    0,    0,
    0,   68,    0,    0,    0,    0,    0,   69,  523,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   70,    0,    0,    0,
    0,    0, 1094,    0,    0,    0,    0, 1357,    0, 1357,
    0,    0, 1357,    0, 1357, 1357, 1094,    0, 1357, 1357,
    0, 1357,    0,    0,    0,    0,    0, 1357,    0,    0,
 1357, 1357, 1357, 1357, 1118, 1357,    0,    0, 1357, 1119,
    0, 1357,    0,    0,    0,    0,    0,    0, 1357,    0,
 1357, 1357,   71, 1357, 1357, 1357,    0, 1357, 1357,    0,
 1118, 1357,    0,    0, 1357, 1119, 1357, 1357, 1118,    0,
 1357, 1357, 1357, 1119, 1357,    0, 1357, 1357, 1357, 1357,
 1357, 1357,    0,    0,    0, 1357, 1357, 1357, 1357, 1357,
 1118,    0,    0, 1357,    0, 1119,    0, 1118,    0,    0,
    0, 1357, 1119, 1357, 1357, 1357, 1357,    0, 1357,    0,
    0,    0,    0, 1357, 1357,    0, 1357,    0, 1357,    0,
 1357, 1357, 1357,    0, 1357,    0, 1357, 1357, 1357,    0,
 1357, 1357, 1357, 1357, 1357, 1118, 1357, 1357,    0,    0,
 1119, 1118, 1357,    0, 1357, 1357, 1119, 1118, 1357, 1357,
 1357,    0, 1119, 1357,    0,    0, 1357,    0,    0, 1357,
 1357, 1357, 1357,    0, 1357,    0, 1357,    0, 1357, 1357,
 1357, 1357, 1357,    0,    0, 1357, 1357, 1357,    0, 1357,
 1357,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1357, 1357, 1357,    0, 1357, 1357, 1357,    0,    0,    0,
 1357,    0,    0, 1357,    0, 1357, 1357, 1357, 1357,    0,
 1357,    0, 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1357,
 1357,    0, 1357, 1357, 1357,    0,    0,    0,    0, 1357,
 1357, 1357, 1357, 1357,    0, 1357,    0,    0, 1357, 1357,
 1357, 1357, 1357, 1357, 1357,    0,    0,    0, 1357, 1357,
 1357, 1357, 1357, 1357, 1357, 1357,    0, 1357,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1357, 1357, 1357,
 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357,
 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357,    0, 1357,
 1357, 1357, 1357, 1357, 1357,    0, 1357, 1357, 1357, 1357,
    0, 1357,    0, 1357, 1357, 1357, 1357, 1357, 1357, 1357,
 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357,
 1357, 1359, 1357, 1357, 1357, 1357,    0, 1357, 1357, 1357,
 1357, 1357,    0, 1357, 1357, 1357, 1357, 1357, 1357, 1357,
 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357,    0, 1357,
 1357, 1357, 1357, 1357, 1357, 1357,    0,    0,    0,    0,
    0, 1182, 1359, 1359, 1359, 1359, 1359, 1359, 1359,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   97, 1359,
 1359, 1359, 1359, 1359,    0,   98,    0,    0,    0,   99,
  100,    0,    0,    0,    0,    0,    0,    0,  101,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  102,
    0,    0, 1359,    0, 1359,    0,    0,    0,    0,  264,
    0,    0,  264,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  264,    0,    0,    0,  264,
    0,  264,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  103,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  264,    0,    0,    0,    0,  104,  264,  264,  264,
    0,  264,  264,  264,    0,  264,    0,    0,    0,    0,
    0,  105,    0,    0,    0,  106,    0,    0,    0,    0,
  107,    0,  264,    0,  264,    0,  108,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  109,    0,    0,    0,    0,
    0,    0,    0,  264,    0,    0,    0,    0,   89,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  264,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1359,    0,
 1359,    0,  264, 1359,    0, 1359, 1359,    0,    0, 1359,
 1359,  110, 1359,    0,  111,    0,    0,    0, 1359,    0,
    0, 1359, 1359, 1359, 1359,    0, 1359,    0,    0, 1359,
    0,    0, 1359,    0,    0,    0,    0,  264,  264, 1359,
    0, 1359, 1359,    0, 1359, 1359, 1359,    0, 1359, 1359,
    0,    0, 1359,    0,  264, 1359,    0, 1359, 1359,    0,
    0, 1359, 1359, 1359,    0, 1359,    0, 1359, 1359, 1359,
 1359, 1359, 1359,    0,    0,    0, 1359, 1359, 1359, 1359,
 1359,    0,    0,    0, 1359,    0,    0,    0,    0,    0,
    0,    0, 1359,    0, 1359, 1359, 1359, 1359,    0, 1359,
    0,    0,    0,    0, 1359, 1359,    0, 1359,    0, 1359,
    0, 1359, 1359, 1359,    0, 1359,    0, 1359, 1359, 1359,
    0, 1359, 1359, 1359, 1359, 1359,    0, 1359, 1359,    0,
    0,    0,    0, 1359,    0, 1359, 1359,    0,    0, 1359,
 1359, 1359,    0,    0, 1359,    0,    0, 1359,    0,    0,
 1359, 1359, 1359, 1359,    0, 1359,    0, 1359,    0, 1359,
 1359, 1359, 1359, 1359,    0,    0, 1359, 1359, 1359,    0,
 1359, 1359,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1359, 1359, 1359,    0, 1359, 1359, 1359,    0,    0,
    0, 1359,    0,    0, 1359,    0, 1359, 1359, 1359, 1359,
    0, 1359,    0, 1359, 1359, 1359, 1359, 1359, 1359, 1359,
 1359,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1359, 1359,    0, 1359, 1359, 1359,    0,    0,    0,    0,
 1359, 1359, 1359, 1359, 1359,    0, 1359,    0,    0, 1359,
 1359, 1359, 1359, 1359, 1359, 1359,    0,    0,    0, 1359,
 1359, 1359, 1359, 1359, 1359, 1359, 1359,    0, 1359,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1359, 1359,
 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1359,
 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1359,    0,
 1359, 1359, 1359, 1359, 1359, 1359,    0, 1359, 1359, 1359,
 1359,    0, 1359,    0, 1359, 1359, 1359, 1359, 1359, 1359,
 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1359,
 1359, 1359, 1361, 1359, 1359, 1359, 1359,    0, 1359, 1359,
 1359, 1359, 1359,    0, 1359, 1359, 1359, 1359, 1359, 1359,
 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1359,    0,
 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1348,    0,    0,
  978,    0, 1183, 1361, 1361, 1361, 1361, 1361, 1361, 1361,
    0,    0,    0, 1349,    0,    0,    0,  979,    0,  980,
 1361, 1361, 1361, 1361, 1361,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  264,    0,    0,  264,    0,    0,    0,    0,
    0,    0,    0, 1361,    0, 1361,    0,  977,  264,  981,
  978,    0,  264,    0,  264,  982,  983,  984,    0,  985,
  986,  987,    0,  988,    0,    0,    0,  979,    0,  980,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  989,    0,  990,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  264,    0,    0,    0,    0,    0,
  264,  264,  264,    0,  264,  264,  264,    0,  264,  981,
    0,  991,    0,    0,    0,  982,  983,  984,    0,  985,
  986,  987,    0,  988,    0,  264,    0,  264,  992,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  989,    0,  990,    0,    0,    0,    0,    0,    0,    0,
  993,    0,    0,    0,    0,    0,  264,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  991,    0,  264,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  994,  995,    0,  992,    0,
    0,    0,    0,    0,    0,  264,    0,    0,    0,    0,
    0,    0,  996,    0,    0,    0,    0,    0,    0, 1361,
  993, 1361,    0,    0, 1361,    0, 1361, 1361,    0,    0,
 1361, 1361,    0, 1361,    0,    0,    0,    0,    0, 1361,
  264,  264, 1361, 1361, 1361, 1361,    0, 1361,    0,    0,
 1361,    0,    0, 1361,    0,  994,  995,  264,    0,    0,
 1361,    0, 1361, 1361,    0, 1361, 1361, 1361,    0, 1361,
 1361,    0,  996, 1361,    0,    0, 1361,    0, 1361, 1361,
    0,    0, 1361, 1361, 1361,    0, 1361,    0, 1361, 1361,
 1361, 1361, 1361, 1361,    0,    0,    0, 1361, 1361, 1361,
 1361, 1361,    0,    0,    0, 1361,    0,    0,    0,    0,
    0,    0,    0, 1361,    0, 1361, 1361, 1361, 1361,    0,
 1361,    0,    0,    0,    0, 1361, 1361,    0, 1361,    0,
 1361,    0, 1361, 1361, 1361,    0, 1361,    0, 1361, 1361,
 1361,    0, 1361, 1361, 1361, 1361, 1361,    0, 1361, 1361,
    0,    0,    0,    0, 1361,    0, 1361, 1361,    0,    0,
 1361, 1361, 1361,    0,    0, 1361,    0,    0, 1361,    0,
    0, 1361, 1361, 1361, 1361,    0, 1361,    0, 1361,    0,
 1361, 1361, 1361, 1361, 1361,    0,    0, 1361, 1361, 1361,
    0, 1361, 1361,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1361, 1361, 1361,    0, 1361, 1361, 1361,    0,
    0,    0, 1361,    0,    0, 1361,    0, 1361, 1361, 1361,
 1361,    0, 1361,    0, 1361, 1361, 1361, 1361, 1361, 1361,
 1361, 1361,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1361, 1361,    0, 1361, 1361, 1361,    0,    0,    0,
    0, 1361, 1361, 1361, 1361, 1361,    0, 1361,    0,    0,
 1361, 1361, 1361, 1361, 1361, 1361, 1361,    0,    0,    0,
 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361,    0, 1361,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1361,
 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361,
 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361,
    0, 1361, 1361, 1361, 1361, 1361, 1361,    0, 1361, 1361,
 1361, 1361,    0, 1361,    0, 1361, 1361, 1361, 1361, 1361,
 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361,
 1361, 1361, 1361, 1362, 1361, 1361, 1361, 1361,    0, 1361,
 1361, 1361, 1361, 1361,    0, 1361, 1361, 1361, 1361, 1361,
 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361,
    0, 1361, 1361, 1361, 1361, 1361, 1361, 1361,  162,    0,
    0,  162,    0, 1184, 1362, 1362, 1362, 1362, 1362, 1362,
 1362,  264,    0,    0,  264,    0,    0,    0,  162,    0,
  162, 1362, 1362, 1362, 1362, 1362,    0,    0,    0,    0,
    0,  264,    0,  264,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1362,    0, 1362,    0,    0,    0,
  162,    0,    0,    0,    0,    0,  162,  162,  162,    0,
  162,  162,  162,  264,  162,    0,    0,    0,    0,  264,
  264,  264,    0,  264,  264,  264,    0,  264,    0,    0,
    0,  162,    0,  162,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  264,    0,  264,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  162,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  264,    0,    0,    0,  162,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  264,    0,    0,    0,    0,    0,    0,    0,
    0,  162,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  264,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  162,  162,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  264,
  264,    0,    0,  162,    0,    0,    0,    0,    0,    0,
 1362,    0, 1362,    0,    0, 1362,  264, 1362, 1362,    0,
    0, 1362, 1362,    0, 1362,    0,    0,    0,    0,    0,
 1362,    0,    0, 1362, 1362, 1362, 1362,    0, 1362,    0,
    0, 1362,    0,    0, 1362,    0,    0,    0,    0,    0,
    0, 1362,    0, 1362, 1362,    0, 1362, 1362, 1362,    0,
 1362, 1362,    0,    0, 1362,    0,    0, 1362,    0, 1362,
 1362,    0,    0, 1362, 1362, 1362,    0, 1362,    0, 1362,
 1362, 1362, 1362, 1362, 1362,    0,    0,    0, 1362, 1362,
 1362, 1362, 1362,    0,    0,    0, 1362,    0,    0,    0,
    0,    0,    0,    0, 1362,    0, 1362, 1362, 1362, 1362,
    0, 1362,    0,    0,    0,    0, 1362, 1362,    0, 1362,
    0, 1362,    0, 1362, 1362, 1362,    0, 1362,    0, 1362,
 1362, 1362,    0, 1362, 1362, 1362, 1362, 1362,    0, 1362,
 1362,    0,    0,    0,    0, 1362,    0, 1362, 1362,    0,
    0, 1362, 1362, 1362,    0,    0, 1362,    0,    0, 1362,
    0,    0, 1362, 1362, 1362, 1362,    0, 1362,    0, 1362,
    0, 1362, 1362, 1362, 1362, 1362,    0,    0, 1362, 1362,
 1362,    0, 1362, 1362,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1362, 1362, 1362,    0, 1362, 1362, 1362,
    0,    0,    0, 1362,    0,    0, 1362,    0, 1362, 1362,
 1362, 1362,    0, 1362,    0, 1362, 1362, 1362, 1362, 1362,
 1362, 1362, 1362,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1362, 1362,    0, 1362, 1362, 1362,    0,    0,
    0,    0, 1362, 1362, 1362, 1362, 1362,    0, 1362,    0,
    0, 1362, 1362, 1362, 1362, 1362, 1362, 1362,    0,    0,
    0, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,    0,
 1362,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
 1362,    0, 1362, 1362, 1362, 1362, 1362, 1362,    0, 1362,
 1362, 1362, 1362,    0, 1362,    0, 1362, 1362, 1362, 1362,
 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
 1362, 1362, 1362, 1362, 1363, 1362, 1362, 1362, 1362,    0,
 1362, 1362, 1362, 1362, 1362,    0, 1362, 1362, 1362, 1362,
 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
 1362,    0, 1362, 1362, 1362, 1362, 1362, 1362, 1362,    0,
    0,    0,    0,    0, 1185, 1363, 1363, 1363, 1363, 1363,
 1363, 1363,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1363, 1363, 1363, 1363, 1363,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1363,    0, 1363,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1363,    0, 1363,    0,    0, 1363,    0, 1363, 1363,
    0,    0, 1363, 1363,    0, 1363,    0,    0,    0,    0,
    0, 1363,    0,    0, 1363, 1363, 1363, 1363,    0, 1363,
    0,    0, 1363,    0,    0, 1363,    0,    0,    0,    0,
    0,    0, 1363,    0, 1363, 1363,    0, 1363, 1363, 1363,
    0, 1363, 1363,    0,    0, 1363,    0,    0, 1363,    0,
 1363, 1363,    0,    0, 1363, 1363, 1363,    0, 1363,    0,
 1363, 1363, 1363, 1363, 1363, 1363,    0,    0,    0, 1363,
 1363, 1363, 1363, 1363,    0,    0,    0, 1363,    0,    0,
    0,    0,    0,    0,    0, 1363,    0, 1363, 1363, 1363,
 1363,    0, 1363,    0,    0,    0,    0, 1363, 1363,    0,
 1363,    0, 1363,    0, 1363, 1363, 1363,    0, 1363,    0,
 1363, 1363, 1363,    0, 1363, 1363, 1363, 1363, 1363,    0,
 1363, 1363,    0,    0,    0,    0, 1363,    0, 1363, 1363,
    0,    0, 1363, 1363, 1363,    0,    0, 1363,    0,    0,
 1363,    0,    0, 1363, 1363, 1363, 1363,    0, 1363,    0,
 1363,    0, 1363, 1363, 1363, 1363, 1363,    0,    0, 1363,
 1363, 1363,    0, 1363, 1363,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1363, 1363, 1363,    0, 1363, 1363,
 1363,    0,    0,    0, 1363,    0,    0, 1363,    0, 1363,
 1363, 1363, 1363,    0, 1363,    0, 1363, 1363, 1363, 1363,
 1363, 1363, 1363, 1363,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1363, 1363,    0, 1363, 1363, 1363,    0,
    0,    0,    0, 1363, 1363, 1363, 1363, 1363,    0, 1363,
    0,    0, 1363, 1363, 1363, 1363, 1363, 1363, 1363,    0,
    0,    0, 1363, 1363, 1363, 1363, 1363, 1363, 1363, 1363,
    0, 1363,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1363, 1363, 1363, 1363, 1363, 1363, 1363, 1363, 1363,
 1363, 1363, 1363, 1363, 1363, 1363, 1363, 1363, 1363, 1363,
 1363, 1363,    0, 1363, 1363, 1363, 1363, 1363, 1363,    0,
 1363, 1363, 1363, 1363,    0, 1363,    0, 1363, 1363, 1363,
 1363, 1363, 1363, 1363, 1363, 1363, 1363, 1363, 1363, 1363,
 1363, 1363, 1363, 1363, 1363, 1364, 1363, 1363, 1363, 1363,
    0, 1363, 1363, 1363, 1363, 1363,    0, 1363, 1363, 1363,
 1363, 1363, 1363, 1363, 1363, 1363, 1363, 1363, 1363, 1363,
 1363, 1363,    0, 1363, 1363, 1363, 1363, 1363, 1363, 1363,
    0,    0,    0,    0,    0, 1186, 1364, 1364, 1364, 1364,
 1364, 1364, 1364,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1364, 1364, 1364, 1364, 1364,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1364,    0, 1364,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1364,    0, 1364,    0,    0, 1364,    0, 1364,
 1364,    0,    0, 1364, 1364,    0, 1364,    0,    0,    0,
    0,    0, 1364,    0,    0, 1364, 1364, 1364, 1364,    0,
 1364,    0,    0, 1364,    0,    0, 1364,    0,    0,    0,
    0,    0,    0, 1364,    0, 1364, 1364,    0, 1364, 1364,
 1364,    0, 1364, 1364,    0,    0, 1364,    0,    0, 1364,
    0, 1364, 1364,    0,    0, 1364, 1364, 1364,    0, 1364,
    0, 1364, 1364, 1364, 1364, 1364, 1364,    0,    0,    0,
 1364, 1364, 1364, 1364, 1364,    0,    0,    0, 1364,    0,
    0,    0,    0,    0,    0,    0, 1364,    0, 1364, 1364,
 1364, 1364,    0, 1364,    0,    0,    0,    0, 1364, 1364,
    0, 1364,    0, 1364,    0, 1364, 1364, 1364,    0, 1364,
    0, 1364, 1364, 1364,    0, 1364, 1364, 1364, 1364, 1364,
    0, 1364, 1364,    0,    0,    0,    0, 1364,    0, 1364,
 1364,    0,    0, 1364, 1364, 1364,    0,    0, 1364,    0,
    0, 1364,    0,    0, 1364, 1364, 1364, 1364,    0, 1364,
    0, 1364,    0, 1364, 1364, 1364, 1364, 1364,    0,    0,
 1364, 1364, 1364,    0, 1364, 1364,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1364, 1364, 1364,    0, 1364,
 1364, 1364,    0,    0,    0, 1364,    0,    0, 1364,    0,
 1364, 1364, 1364, 1364,    0, 1364,    0, 1364, 1364, 1364,
 1364, 1364, 1364, 1364, 1364,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1364, 1364,    0, 1364, 1364, 1364,
    0,    0,    0,    0, 1364, 1364, 1364, 1364, 1364,    0,
 1364,    0,    0, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
    0,    0,    0, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
 1364,    0, 1364,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
 1364, 1364, 1364,    0, 1364, 1364, 1364, 1364, 1364, 1364,
    0, 1364, 1364, 1364, 1364,    0, 1364,    0, 1364, 1364,
 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
 1364, 1364, 1364, 1364, 1364, 1364, 1365, 1364, 1364, 1364,
 1364,    0, 1364, 1364, 1364, 1364, 1364,    0, 1364, 1364,
 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
 1364, 1364, 1364,    0, 1364, 1364, 1364, 1364, 1364, 1364,
 1364,    0,    0,    0,    0,    0, 1187, 1365, 1365, 1365,
 1365, 1365, 1365, 1365,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1365, 1365, 1365, 1365, 1365,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1365,    0, 1365,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1365,    0, 1365,    0,    0, 1365,    0,
 1365, 1365,    0,    0, 1365, 1365,    0, 1365,    0,    0,
    0,    0,    0, 1365,    0,    0, 1365, 1365, 1365, 1365,
    0, 1365,    0,    0, 1365,    0,    0, 1365,    0,    0,
    0,    0,    0,    0, 1365,    0, 1365, 1365,    0, 1365,
 1365, 1365,    0, 1365, 1365,    0,    0, 1365,    0,    0,
 1365,    0, 1365, 1365,    0,    0, 1365, 1365, 1365,    0,
 1365,    0, 1365, 1365, 1365, 1365, 1365, 1365,    0,    0,
    0, 1365, 1365, 1365, 1365, 1365,    0,    0,    0, 1365,
    0,    0,    0,    0,    0,    0,    0, 1365,    0, 1365,
 1365, 1365, 1365,    0, 1365,    0,    0,    0,    0, 1365,
 1365,    0, 1365,    0, 1365,    0, 1365, 1365, 1365,    0,
 1365,    0, 1365, 1365, 1365,    0, 1365, 1365, 1365, 1365,
 1365,    0, 1365, 1365,    0,    0,    0,    0, 1365,    0,
 1365, 1365,    0,    0, 1365, 1365, 1365,    0,    0, 1365,
    0,    0, 1365,    0,    0, 1365, 1365, 1365, 1365,    0,
 1365,    0, 1365,    0, 1365, 1365, 1365, 1365, 1365,    0,
    0, 1365, 1365, 1365,    0, 1365, 1365,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1365, 1365, 1365,    0,
 1365, 1365, 1365,    0,    0,    0, 1365,    0,    0, 1365,
    0, 1365, 1365, 1365, 1365,    0, 1365,    0, 1365, 1365,
 1365, 1365, 1365, 1365, 1365, 1365,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1365, 1365,    0, 1365, 1365,
 1365,    0,    0,    0,    0, 1365, 1365, 1365, 1365, 1365,
    0, 1365,    0,    0, 1365, 1365, 1365, 1365, 1365, 1365,
 1365,    0,    0,    0, 1365, 1365, 1365, 1365, 1365, 1365,
 1365, 1365,    0, 1365,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1365, 1365, 1365, 1365, 1365, 1365, 1365,
 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365,
 1365, 1365, 1365, 1365,    0, 1365, 1365, 1365, 1365, 1365,
 1365,    0, 1365, 1365, 1365, 1365,    0, 1365,    0, 1365,
 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365,
 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1366, 1365, 1365,
 1365, 1365,    0, 1365, 1365, 1365, 1365, 1365,    0, 1365,
 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365,
 1365, 1365, 1365, 1365,    0, 1365, 1365, 1365, 1365, 1365,
 1365, 1365,    0,    0,    0,    0,    0, 1188, 1366, 1366,
 1366, 1366, 1366, 1366, 1366,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1366, 1366, 1366, 1366, 1366,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1366,    0,
 1366,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1366,    0, 1366,    0,    0, 1366,
    0, 1366, 1366,    0,    0, 1366, 1366,    0, 1366,    0,
    0,    0,    0,    0, 1366,    0,    0, 1366, 1366, 1366,
 1366,    0, 1366,    0,    0, 1366,    0,    0, 1366,    0,
    0,    0,    0,    0,    0, 1366,    0, 1366, 1366,    0,
 1366, 1366, 1366,    0, 1366, 1366,    0,    0, 1366,    0,
    0, 1366,    0, 1366, 1366,    0,    0, 1366, 1366, 1366,
    0, 1366,    0, 1366, 1366, 1366, 1366, 1366, 1366,    0,
    0,    0, 1366, 1366, 1366, 1366, 1366,    0,    0,    0,
 1366,    0,    0,    0,    0,    0,    0,    0, 1366,    0,
 1366, 1366, 1366, 1366,    0, 1366,    0,    0,    0,    0,
 1366, 1366,    0, 1366,    0, 1366,    0, 1366, 1366, 1366,
    0, 1366,    0, 1366, 1366, 1366,    0, 1366, 1366, 1366,
 1366, 1366,    0, 1366, 1366,    0,    0,    0,    0, 1366,
    0, 1366, 1366,    0,    0, 1366, 1366, 1366,    0,    0,
 1366,    0,    0, 1366,    0,    0, 1366, 1366, 1366, 1366,
    0, 1366,    0, 1366,    0, 1366, 1366, 1366, 1366, 1366,
    0,    0, 1366, 1366, 1366,    0, 1366, 1366,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1366, 1366, 1366,
    0, 1366, 1366, 1366,    0,    0,    0, 1366,    0,    0,
 1366,    0, 1366, 1366, 1366, 1366,    0, 1366,    0, 1366,
 1366, 1366, 1366, 1366, 1366, 1366, 1366,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1366, 1366,    0, 1366,
 1366, 1366,    0,    0,    0,    0, 1366, 1366, 1366, 1366,
 1366,    0, 1366,    0,    0, 1366, 1366, 1366, 1366, 1366,
 1366, 1366,    0,    0,    0, 1366, 1366, 1366, 1366, 1366,
 1366, 1366, 1366,    0, 1366,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1366, 1366, 1366, 1366, 1366, 1366,
 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
 1366, 1366, 1366, 1366, 1366,    0, 1366, 1366, 1366, 1366,
 1366, 1366,    0, 1366, 1366, 1366, 1366,    0, 1366,    0,
 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1367, 1366,
 1366, 1366, 1366,    0, 1366, 1366, 1366, 1366, 1366,    0,
 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
 1366, 1366, 1366, 1366, 1366,    0, 1366, 1366, 1366, 1366,
 1366, 1366, 1366,    0,    0,    0,    0,    0, 1190, 1367,
 1367, 1367, 1367, 1367, 1367, 1367,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1367, 1367, 1367, 1367,
 1367,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1367,
    0, 1367,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1367,    0, 1367,    0,    0,
 1367,    0, 1367, 1367,    0,    0, 1367, 1367,    0, 1367,
    0,    0,    0,    0,    0, 1367,    0,    0, 1367, 1367,
 1367, 1367,    0, 1367,    0,    0, 1367,    0,    0, 1367,
    0,    0,    0,    0,    0,    0, 1367,    0, 1367, 1367,
    0, 1367, 1367, 1367,    0, 1367, 1367,    0,    0, 1367,
    0,    0, 1367,    0, 1367, 1367,    0,    0, 1367, 1367,
 1367,    0, 1367,    0, 1367, 1367, 1367, 1367, 1367, 1367,
    0,    0,    0, 1367, 1367, 1367, 1367, 1367,    0,    0,
    0, 1367,    0,    0,    0,    0,    0,    0,    0, 1367,
    0, 1367, 1367, 1367, 1367,    0, 1367,    0,    0,    0,
    0, 1367, 1367,    0, 1367,    0, 1367,    0, 1367, 1367,
 1367,    0, 1367,    0, 1367, 1367, 1367,    0, 1367, 1367,
 1367, 1367, 1367,    0, 1367, 1367,    0,    0,    0,    0,
 1367,    0, 1367, 1367,    0,    0, 1367, 1367, 1367,    0,
    0, 1367,    0,    0, 1367,    0,    0, 1367, 1367, 1367,
 1367,    0, 1367,    0, 1367,    0, 1367, 1367, 1367, 1367,
 1367,    0,    0, 1367, 1367, 1367,    0, 1367, 1367,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1367, 1367,
 1367,    0, 1367, 1367, 1367,    0,    0,    0, 1367,    0,
    0, 1367,    0, 1367, 1367, 1367, 1367,    0, 1367,    0,
 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1367, 1367,    0,
 1367, 1367, 1367,    0,    0,    0,    0, 1367, 1367, 1367,
 1367, 1367,    0, 1367,    0,    0, 1367, 1367, 1367, 1367,
 1367, 1367, 1367,    0,    0,    0, 1367, 1367, 1367, 1367,
 1367, 1367, 1367, 1367,    0, 1367,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1367, 1367, 1367, 1367, 1367,
 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367,
 1367, 1367, 1367, 1367, 1367, 1367,    0, 1367, 1367, 1367,
 1367, 1367, 1367,    0, 1367, 1367, 1367, 1367,    0, 1367,
    0, 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367,
 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1368,
 1367, 1367, 1367, 1367,    0, 1367, 1367, 1367, 1367, 1367,
    0, 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367,
 1367, 1367, 1367, 1367, 1367, 1367,    0, 1367, 1367, 1367,
 1367, 1367, 1367, 1367,    0,    0,    0,    0,    0, 1191,
 1368, 1368, 1368, 1368, 1368, 1368, 1368,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1368, 1368, 1368,
 1368, 1368,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1368,    0, 1368,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1368,    0, 1368,    0,
    0, 1368,    0, 1368, 1368,    0,    0, 1368, 1368,    0,
 1368,    0,    0,    0,    0,    0, 1368,    0,    0, 1368,
 1368, 1368, 1368,    0, 1368,    0,    0, 1368,    0,    0,
 1368,    0,    0,    0,    0,    0,    0, 1368,    0, 1368,
 1368,    0, 1368, 1368, 1368,    0, 1368, 1368,    0,    0,
 1368,    0,    0, 1368,    0, 1368, 1368,    0,    0, 1368,
 1368, 1368,    0, 1368,    0, 1368, 1368, 1368, 1368, 1368,
 1368,    0,    0,    0, 1368, 1368, 1368, 1368, 1368,    0,
    0,    0, 1368,    0,    0,    0,    0,    0,    0,    0,
 1368,    0, 1368, 1368, 1368, 1368,    0, 1368,    0,    0,
    0,    0, 1368, 1368,    0, 1368,    0, 1368,    0, 1368,
 1368, 1368,    0, 1368,    0, 1368, 1368, 1368,    0, 1368,
 1368, 1368, 1368, 1368,    0, 1368, 1368,    0,    0,    0,
    0, 1368,    0, 1368, 1368,    0,    0, 1368, 1368, 1368,
    0,    0, 1368,    0,    0, 1368,    0,    0, 1368, 1368,
 1368, 1368,    0, 1368,    0, 1368,    0, 1368, 1368, 1368,
 1368, 1368,    0,    0, 1368, 1368, 1368,    0, 1368, 1368,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1368,
 1368, 1368,    0, 1368, 1368, 1368,    0,    0,    0, 1368,
    0,    0, 1368,    0, 1368, 1368, 1368, 1368,    0, 1368,
    0, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1368, 1368,
    0, 1368, 1368, 1368,    0,    0,    0,    0, 1368, 1368,
 1368, 1368, 1368,    0, 1368,    0,    0, 1368, 1368, 1368,
 1368, 1368, 1368, 1368,    0,    0,    0, 1368, 1368, 1368,
 1368, 1368, 1368, 1368, 1368,    0, 1368,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1368, 1368, 1368, 1368,
 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
 1368, 1368, 1368, 1368, 1368, 1368, 1368,    0, 1368, 1368,
 1368, 1368, 1368, 1368,    0, 1368, 1368, 1368, 1368,    0,
 1368,    0, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
 1369, 1368, 1368, 1368, 1368,    0, 1368, 1368, 1368, 1368,
 1368,    0, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
 1368, 1368, 1368, 1368, 1368, 1368, 1368,    0, 1368, 1368,
 1368, 1368, 1368, 1368, 1368,    0,    0,    0,    0,    0,
 1192, 1369, 1369, 1369, 1369, 1369, 1369, 1369,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1369, 1369,
 1369, 1369, 1369,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1369,    0, 1369,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1369,    0, 1369,
    0,    0, 1369,    0, 1369, 1369,    0,    0, 1369, 1369,
    0, 1369,    0,    0,    0,    0,    0, 1369,    0,    0,
 1369, 1369, 1369, 1369,    0, 1369,    0,    0, 1369,    0,
    0, 1369,    0,    0,    0,    0,    0,    0, 1369,    0,
 1369, 1369,    0, 1369, 1369, 1369,    0, 1369, 1369,    0,
    0, 1369,    0,    0, 1369,    0, 1369, 1369,    0,    0,
 1369, 1369, 1369,    0, 1369,    0, 1369, 1369, 1369, 1369,
 1369, 1369,    0,    0,    0, 1369, 1369, 1369, 1369, 1369,
    0,    0,    0, 1369,    0,    0,    0,    0,    0,    0,
    0, 1369,    0, 1369, 1369, 1369, 1369,    0, 1369,    0,
    0,    0,    0, 1369, 1369,    0, 1369,    0, 1369,    0,
 1369, 1369, 1369,    0, 1369,    0, 1369, 1369, 1369,    0,
 1369, 1369, 1369, 1369, 1369,    0, 1369, 1369,    0,    0,
    0,    0, 1369,    0, 1369, 1369,    0,    0, 1369, 1369,
 1369,    0,    0, 1369,    0,    0, 1369,    0,    0, 1369,
 1369, 1369, 1369,    0, 1369,    0, 1369,    0, 1369, 1369,
 1369, 1369, 1369,    0,    0, 1369, 1369, 1369,    0, 1369,
 1369,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1369, 1369, 1369,    0, 1369, 1369, 1369,    0,    0,    0,
 1369,    0,    0, 1369,    0, 1369, 1369, 1369, 1369,    0,
 1369,    0, 1369, 1369, 1369, 1369, 1369, 1369, 1369, 1369,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1369,
 1369,    0, 1369, 1369, 1369,    0,    0,    0,    0, 1369,
 1369, 1369, 1369, 1369,    0, 1369,    0,    0, 1369, 1369,
 1369, 1369, 1369, 1369, 1369,    0,    0,    0, 1369, 1369,
 1369, 1369, 1369, 1369, 1369, 1369,    0, 1369,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1369, 1369, 1369,
 1369, 1369, 1369, 1369, 1369, 1369, 1369, 1369, 1369, 1369,
 1369, 1369, 1369, 1369, 1369, 1369, 1369, 1369,    0, 1369,
 1369, 1369, 1369, 1369, 1369,    0, 1369, 1369, 1369, 1369,
    0, 1369,    0, 1369, 1369, 1369, 1369, 1369, 1369, 1369,
 1369, 1369, 1369, 1369, 1369, 1369, 1369, 1369, 1369, 1369,
 1369, 1370, 1369, 1369, 1369, 1369,    0, 1369, 1369, 1369,
 1369, 1369,    0, 1369, 1369, 1369, 1369, 1369, 1369, 1369,
 1369, 1369, 1369, 1369, 1369, 1369, 1369, 1369,    0, 1369,
 1369, 1369, 1369, 1369, 1369, 1369,    0,    0,    0,    0,
    0, 1193, 1370, 1370, 1370, 1370, 1370, 1370, 1370,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1370,
 1370, 1370, 1370, 1370,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1370,    0, 1370,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1370,    0,
 1370,    0,    0, 1370,    0, 1370, 1370,    0,    0, 1370,
 1370,    0, 1370,    0,    0,    0,    0,    0, 1370,    0,
    0, 1370, 1370, 1370, 1370,    0, 1370,    0,    0, 1370,
    0,    0, 1370,    0,    0,    0,    0,    0,    0, 1370,
    0, 1370, 1370,    0, 1370, 1370, 1370,    0, 1370, 1370,
    0,    0, 1370,    0,    0, 1370,    0, 1370, 1370,    0,
    0, 1370, 1370, 1370,    0, 1370,    0, 1370, 1370, 1370,
 1370, 1370, 1370,    0,    0,    0, 1370, 1370, 1370, 1370,
 1370,    0,    0,    0, 1370,    0,    0,    0,    0,    0,
    0,    0, 1370,    0, 1370, 1370, 1370, 1370,    0, 1370,
    0,    0,    0,    0, 1370, 1370,    0, 1370,    0, 1370,
    0, 1370, 1370, 1370,    0, 1370,    0, 1370, 1370, 1370,
    0, 1370, 1370, 1370, 1370, 1370,    0, 1370, 1370,    0,
    0,    0,    0, 1370,    0, 1370, 1370,    0,    0, 1370,
 1370, 1370,    0,    0, 1370,    0,    0, 1370,    0,    0,
 1370, 1370, 1370, 1370,    0, 1370,    0, 1370,    0, 1370,
 1370, 1370, 1370, 1370,    0,    0, 1370, 1370, 1370,    0,
 1370, 1370,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1370, 1370, 1370,    0, 1370, 1370, 1370,    0,    0,
    0, 1370,    0,    0, 1370,    0, 1370, 1370, 1370, 1370,
    0, 1370,    0, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
 1370,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1370, 1370,    0, 1370, 1370, 1370,    0,    0,    0,    0,
 1370, 1370, 1370, 1370, 1370,    0, 1370,    0,    0, 1370,
 1370, 1370, 1370, 1370, 1370, 1370,    0,    0,    0, 1370,
 1370, 1370, 1370, 1370, 1370, 1370, 1370,    0, 1370,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1370, 1370,
 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,    0,
 1370, 1370, 1370, 1370, 1370, 1370,    0, 1370, 1370, 1370,
 1370,    0, 1370,    0, 1370, 1370, 1370, 1370, 1370, 1370,
 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
 1370, 1370, 1371, 1370, 1370, 1370, 1370,    0, 1370, 1370,
 1370, 1370, 1370,    0, 1370, 1370, 1370, 1370, 1370, 1370,
 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,    0,
 1370, 1370, 1370, 1370, 1370, 1370, 1370,    0,    0,    0,
    0,    0, 1194, 1371, 1371, 1371, 1371, 1371, 1371, 1371,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1371, 1371, 1371, 1371, 1371,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1371,    0, 1371,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1371,
    0, 1371,    0,    0, 1371,    0, 1371, 1371,    0,    0,
 1371, 1371,    0, 1371,    0,    0,    0,    0,    0, 1371,
    0,    0, 1371, 1371, 1371, 1371,    0, 1371,    0,    0,
 1371,    0,    0, 1371,    0,    0,    0,    0,    0,    0,
 1371,    0, 1371, 1371,    0, 1371, 1371, 1371,    0, 1371,
 1371,    0,    0, 1371,    0,    0, 1371,    0, 1371, 1371,
    0,    0, 1371, 1371, 1371,    0, 1371,    0, 1371, 1371,
 1371, 1371, 1371, 1371,    0,    0,    0, 1371, 1371, 1371,
 1371, 1371,    0,    0,    0, 1371,    0,    0,    0,    0,
    0,    0,    0, 1371,    0, 1371, 1371, 1371, 1371,    0,
 1371,    0,    0,    0,    0, 1371, 1371,    0, 1371,    0,
 1371,    0, 1371, 1371, 1371,    0, 1371,    0, 1371, 1371,
 1371,    0, 1371, 1371, 1371, 1371, 1371,    0, 1371, 1371,
    0,    0,    0,    0, 1371,    0, 1371, 1371,    0,    0,
 1371, 1371, 1371,    0,    0, 1371,    0,    0, 1371,    0,
    0, 1371, 1371, 1371, 1371,    0, 1371,    0, 1371,    0,
 1371, 1371, 1371, 1371, 1371,    0,    0, 1371, 1371, 1371,
    0, 1371, 1371,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1371, 1371, 1371,    0, 1371, 1371, 1371,    0,
    0,    0, 1371,    0,    0, 1371,    0, 1371, 1371, 1371,
 1371,    0, 1371,    0, 1371, 1371, 1371, 1371, 1371, 1371,
 1371, 1371,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1371, 1371,    0, 1371, 1371, 1371,    0,    0,    0,
    0, 1371, 1371, 1371, 1371, 1371,    0, 1371,    0,    0,
 1371, 1371, 1371, 1371, 1371, 1371, 1371,    0,    0,    0,
 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371,    0, 1371,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1371,
 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371,
 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371,
    0, 1371, 1371, 1371, 1371, 1371, 1371,    0, 1371, 1371,
 1371, 1371,    0, 1371,    0, 1371, 1371, 1371, 1371, 1371,
 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371,
 1371, 1371, 1371, 1372, 1371, 1371, 1371, 1371,    0, 1371,
 1371, 1371, 1371, 1371,    0, 1371, 1371, 1371, 1371, 1371,
 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371,
    0, 1371, 1371, 1371, 1371, 1371, 1371, 1371,    0,    0,
    0,    0,    0, 1196, 1372, 1372, 1372, 1372, 1372, 1372,
 1372,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1372, 1372, 1372, 1372, 1372,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1372,    0, 1372,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1372,    0, 1372,    0,    0, 1372,    0, 1372, 1372,    0,
    0, 1372, 1372,    0, 1372,    0,    0,    0,    0,    0,
 1372,    0,    0, 1372, 1372, 1372, 1372,    0, 1372,    0,
    0, 1372,    0,    0, 1372,    0,    0,    0,    0,    0,
    0, 1372,    0, 1372, 1372,    0, 1372, 1372, 1372,    0,
 1372, 1372,    0,    0, 1372,    0,    0, 1372,    0, 1372,
 1372,    0,    0, 1372, 1372, 1372,    0, 1372,    0, 1372,
 1372, 1372, 1372, 1372, 1372,    0,    0,    0, 1372, 1372,
 1372, 1372, 1372,    0,    0,    0, 1372,    0,    0,    0,
    0,    0,    0,    0, 1372,    0, 1372, 1372, 1372, 1372,
    0, 1372,    0,    0,    0,    0, 1372, 1372,    0, 1372,
    0, 1372,    0, 1372, 1372, 1372,    0, 1372,    0, 1372,
 1372, 1372,    0, 1372, 1372, 1372, 1372, 1372,    0, 1372,
 1372,    0,    0,    0,    0, 1372,    0, 1372, 1372,    0,
    0, 1372, 1372, 1372,    0,    0, 1372,    0,    0, 1372,
    0,    0, 1372, 1372, 1372, 1372,    0, 1372,    0, 1372,
    0, 1372, 1372, 1372, 1372, 1372,    0,    0, 1372, 1372,
 1372,    0, 1372, 1372,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1372, 1372, 1372,    0, 1372, 1372, 1372,
    0,    0,    0, 1372,    0,    0, 1372,    0, 1372, 1372,
 1372, 1372,    0, 1372,    0, 1372, 1372, 1372, 1372, 1372,
 1372, 1372, 1372,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1372, 1372,    0, 1372, 1372, 1372,    0,    0,
    0,    0, 1372, 1372, 1372, 1372, 1372,    0, 1372,    0,
    0, 1372, 1372, 1372, 1372, 1372, 1372, 1372,    0,    0,
    0, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,    0,
 1372,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
 1372,    0, 1372, 1372, 1372, 1372, 1372, 1372,    0, 1372,
 1372, 1372, 1372,    0, 1372,    0, 1372, 1372, 1372, 1372,
 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
 1372, 1372, 1372, 1372, 1373, 1372, 1372, 1372, 1372,    0,
 1372, 1372, 1372, 1372, 1372,    0, 1372, 1372, 1372, 1372,
 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
 1372,    0, 1372, 1372, 1372, 1372, 1372, 1372, 1372,    0,
    0,    0,    0,    0, 1197, 1373, 1373, 1373, 1373, 1373,
 1373, 1373,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1373, 1373, 1373, 1373, 1373,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1373,    0, 1373,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1373,    0, 1373,    0,    0, 1373,    0, 1373, 1373,
    0,    0, 1373, 1373,    0, 1373,    0,    0,    0,    0,
    0, 1373,    0,    0, 1373, 1373, 1373, 1373,    0, 1373,
    0,    0, 1373,    0,    0, 1373,    0,    0,    0,    0,
    0,    0, 1373,    0, 1373, 1373,    0, 1373, 1373, 1373,
    0, 1373, 1373,    0,    0, 1373,    0,    0, 1373,    0,
 1373, 1373,    0,    0, 1373, 1373, 1373,    0, 1373,    0,
 1373, 1373, 1373, 1373, 1373, 1373,    0,    0,    0, 1373,
 1373, 1373, 1373, 1373,    0,    0,    0, 1373,    0,    0,
    0,    0,    0,    0,    0, 1373,    0, 1373, 1373, 1373,
 1373,    0, 1373,    0,    0,    0,    0, 1373, 1373,    0,
 1373,    0, 1373,    0, 1373, 1373, 1373,    0, 1373,    0,
 1373, 1373, 1373,    0, 1373, 1373, 1373, 1373, 1373,    0,
 1373, 1373,    0,    0,    0,    0, 1373,    0, 1373, 1373,
    0,    0, 1373, 1373, 1373,    0,    0, 1373,    0,    0,
 1373,    0,    0, 1373, 1373, 1373, 1373,    0, 1373,    0,
 1373,    0, 1373, 1373, 1373, 1373, 1373,    0,    0, 1373,
 1373, 1373,    0, 1373, 1373,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1373, 1373, 1373,    0, 1373, 1373,
 1373,    0,    0,    0, 1373,    0,    0, 1373,    0, 1373,
 1373, 1373, 1373,    0, 1373,    0, 1373, 1373, 1373, 1373,
 1373, 1373, 1373, 1373,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1373, 1373,    0, 1373, 1373, 1373,    0,
    0,    0,    0, 1373, 1373, 1373, 1373, 1373,    0, 1373,
    0,    0, 1373, 1373, 1373, 1373, 1373, 1373, 1373,    0,
    0,    0, 1373, 1373, 1373, 1373, 1373, 1373, 1373, 1373,
    0, 1373,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1373, 1373, 1373, 1373, 1373, 1373, 1373, 1373, 1373,
 1373, 1373, 1373, 1373, 1373, 1373, 1373, 1373, 1373, 1373,
 1373, 1373,    0, 1373, 1373, 1373, 1373, 1373, 1373,    0,
 1373, 1373, 1373, 1373,    0, 1373,    0, 1373, 1373, 1373,
 1373, 1373, 1373, 1373, 1373, 1373, 1373, 1373, 1373, 1373,
 1373, 1373, 1373, 1373, 1373, 1374, 1373, 1373, 1373, 1373,
    0, 1373, 1373, 1373, 1373, 1373,    0, 1373, 1373, 1373,
 1373, 1373, 1373, 1373, 1373, 1373, 1373, 1373, 1373, 1373,
 1373, 1373,    0, 1373, 1373, 1373, 1373, 1373, 1373, 1373,
    0,    0,    0,    0,    0, 1198, 1374, 1374, 1374, 1374,
 1374, 1374, 1374,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1374, 1374, 1374, 1374, 1374,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1374,    0, 1374,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1374,    0, 1374,    0,    0, 1374,    0, 1374,
 1374,    0,    0, 1374, 1374,    0, 1374,    0,    0,    0,
    0,    0, 1374,    0,    0, 1374, 1374, 1374, 1374,    0,
 1374,    0,    0, 1374,    0,    0, 1374,    0,    0,    0,
    0,    0,    0, 1374,    0, 1374, 1374,    0, 1374, 1374,
 1374,    0, 1374, 1374,    0,    0, 1374,    0,    0, 1374,
    0, 1374, 1374,    0,    0, 1374, 1374, 1374,    0, 1374,
    0, 1374, 1374, 1374, 1374, 1374, 1374,    0,    0,    0,
 1374, 1374, 1374, 1374, 1374,    0,    0,    0, 1374,    0,
    0,    0,    0,    0,    0,    0, 1374,    0, 1374, 1374,
 1374, 1374,    0, 1374,    0,    0,    0,    0, 1374, 1374,
    0, 1374,    0, 1374,    0, 1374, 1374, 1374,    0, 1374,
    0, 1374, 1374, 1374,    0, 1374, 1374, 1374, 1374, 1374,
    0, 1374, 1374,    0,    0,    0,    0, 1374,    0, 1374,
 1374,    0,    0, 1374, 1374, 1374,    0,    0, 1374,    0,
    0, 1374,    0,    0, 1374, 1374, 1374, 1374,    0, 1374,
    0, 1374,    0, 1374, 1374, 1374, 1374, 1374,    0,    0,
 1374, 1374, 1374,    0, 1374, 1374,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1374, 1374, 1374,    0, 1374,
 1374, 1374,    0,    0,    0, 1374,    0,    0, 1374,    0,
 1374, 1374, 1374, 1374,    0, 1374,    0, 1374, 1374, 1374,
 1374, 1374, 1374, 1374, 1374,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1374, 1374,    0, 1374, 1374, 1374,
    0,    0,    0,    0, 1374, 1374, 1374, 1374, 1374,    0,
 1374,    0,    0, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
    0,    0,    0, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
 1374,    0, 1374,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
 1374, 1374, 1374,    0, 1374, 1374, 1374, 1374, 1374, 1374,
    0, 1374, 1374, 1374, 1374,    0, 1374,    0, 1374, 1374,
 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
 1374, 1374, 1374, 1374, 1374, 1374, 1378, 1374, 1374, 1374,
 1374,    0, 1374, 1374, 1374, 1374, 1374,    0, 1374, 1374,
 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
 1374, 1374, 1374,    0, 1374, 1374, 1374, 1374, 1374, 1374,
 1374,    0,    0,    0,    0,    0, 1199, 1378, 1378, 1378,
 1378, 1378, 1378, 1378,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1378, 1378, 1378, 1378, 1378,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1378,    0, 1378,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1378,    0, 1378,    0,    0, 1378,    0,
 1378, 1378,    0,    0, 1378, 1378,    0, 1378,    0,    0,
    0,    0,    0, 1378,    0,    0, 1378, 1378, 1378, 1378,
    0, 1378,    0,    0, 1378,    0,    0, 1378,    0,    0,
    0,    0,    0,    0, 1378,    0, 1378, 1378,    0, 1378,
 1378, 1378,    0, 1378, 1378,    0,    0, 1378,    0,    0,
 1378,    0, 1378, 1378,    0,    0, 1378, 1378, 1378,    0,
 1378,    0, 1378, 1378, 1378, 1378, 1378, 1378,    0,    0,
    0, 1378, 1378, 1378, 1378, 1378,    0,    0,    0, 1378,
    0,    0,    0,    0,    0,    0,    0, 1378,    0, 1378,
 1378, 1378, 1378,    0, 1378,    0,    0,    0,    0, 1378,
 1378,    0, 1378,    0, 1378,    0, 1378, 1378, 1378,    0,
 1378,    0, 1378, 1378, 1378,    0, 1378, 1378, 1378, 1378,
 1378,    0, 1378, 1378,    0,    0,    0,    0, 1378,    0,
 1378, 1378,    0,    0, 1378, 1378, 1378,    0,    0, 1378,
    0,    0, 1378,    0,    0, 1378, 1378, 1378, 1378,    0,
 1378,    0, 1378,    0, 1378, 1378, 1378, 1378, 1378,    0,
    0, 1378, 1378, 1378,    0, 1378, 1378,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1378, 1378, 1378,    0,
 1378, 1378, 1378,    0,    0,    0, 1378,    0,    0, 1378,
    0, 1378, 1378, 1378, 1378,    0, 1378,    0, 1378, 1378,
 1378, 1378, 1378, 1378, 1378, 1378,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1378, 1378,    0, 1378, 1378,
 1378,    0,    0,    0,    0, 1378, 1378, 1378, 1378, 1378,
    0, 1378,    0,    0, 1378, 1378, 1378, 1378, 1378, 1378,
 1378,    0,    0,    0, 1378, 1378, 1378, 1378, 1378, 1378,
 1378, 1378,    0, 1378,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
 1378, 1378, 1378, 1378,    0, 1378, 1378, 1378, 1378, 1378,
 1378,    0, 1378, 1378, 1378, 1378,    0, 1378,    0, 1378,
 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1379, 1378, 1378,
 1378, 1378,    0, 1378, 1378, 1378, 1378, 1378,    0, 1378,
 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
 1378, 1378, 1378, 1378,    0, 1378, 1378, 1378, 1378, 1378,
 1378, 1378,    0,    0,    0,    0,    0, 1200, 1379, 1379,
 1379, 1379, 1379, 1379, 1379,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1379, 1379, 1379, 1379, 1379,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1379,    0,
 1379,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1379,    0, 1379,    0,    0, 1379,
    0, 1379, 1379,    0,    0, 1379, 1379,    0, 1379,    0,
    0,    0,    0,    0, 1379,    0,    0, 1379, 1379, 1379,
 1379,    0, 1379,    0,    0, 1379,    0,    0, 1379,    0,
    0,    0,    0,    0,    0, 1379,    0, 1379, 1379,    0,
 1379, 1379, 1379,    0, 1379, 1379,    0,    0, 1379,    0,
    0, 1379,    0, 1379, 1379,    0,    0, 1379, 1379, 1379,
    0, 1379,    0, 1379, 1379, 1379, 1379, 1379, 1379,    0,
    0,    0, 1379, 1379, 1379, 1379, 1379,    0,    0,    0,
 1379,    0,    0,    0,    0,    0,    0,    0, 1379,    0,
 1379, 1379, 1379, 1379,    0, 1379,    0,    0,    0,    0,
 1379, 1379,    0, 1379,    0, 1379,    0, 1379, 1379, 1379,
    0, 1379,    0, 1379, 1379, 1379,    0, 1379, 1379, 1379,
 1379, 1379,    0, 1379, 1379,    0,    0,    0,    0, 1379,
    0, 1379, 1379,    0,    0, 1379, 1379, 1379,    0,    0,
 1379,    0,    0, 1379,    0,    0, 1379, 1379, 1379, 1379,
    0, 1379,    0, 1379,    0, 1379, 1379, 1379, 1379, 1379,
    0,    0, 1379, 1379, 1379,    0, 1379, 1379,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1379, 1379, 1379,
    0, 1379, 1379, 1379,    0,    0,    0, 1379,    0,    0,
 1379,    0, 1379, 1379, 1379, 1379,    0, 1379,    0, 1379,
 1379, 1379, 1379, 1379, 1379, 1379, 1379,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1379, 1379,    0, 1379,
 1379, 1379,    0,    0,    0,    0, 1379, 1379, 1379, 1379,
 1379,    0, 1379,    0,    0, 1379, 1379, 1379, 1379, 1379,
 1379, 1379,    0,    0,    0, 1379, 1379, 1379, 1379, 1379,
 1379, 1379, 1379,    0, 1379,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1379, 1379, 1379, 1379, 1379, 1379,
 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379,
 1379, 1379, 1379, 1379, 1379,    0, 1379, 1379, 1379, 1379,
 1379, 1379,    0, 1379, 1379, 1379, 1379,    0, 1379,    0,
 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379,
 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1380, 1379,
 1379, 1379, 1379,    0, 1379, 1379, 1379, 1379, 1379,    0,
 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379,
 1379, 1379, 1379, 1379, 1379,    0, 1379, 1379, 1379, 1379,
 1379, 1379, 1379,    0,    0,    0,    0,    0, 1201, 1380,
 1380, 1380, 1380, 1380, 1380, 1380,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1380, 1380, 1380, 1380,
 1380,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1380,
    0, 1380,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1380,    0, 1380,    0,    0,
 1380,    0, 1380, 1380,    0,    0, 1380, 1380,    0, 1380,
    0,    0,    0,    0,    0, 1380,    0,    0, 1380, 1380,
 1380, 1380,    0, 1380,    0,    0, 1380,    0,    0, 1380,
    0,    0,    0,    0,    0,    0, 1380,    0, 1380, 1380,
    0, 1380, 1380, 1380,    0, 1380, 1380,    0,    0, 1380,
    0,    0, 1380,    0, 1380, 1380,    0,    0, 1380, 1380,
 1380,    0, 1380,    0, 1380, 1380, 1380, 1380, 1380, 1380,
    0,    0,    0, 1380, 1380, 1380, 1380, 1380,    0,    0,
    0, 1380,    0,    0,    0,    0,    0,    0,    0, 1380,
    0, 1380, 1380, 1380, 1380,    0, 1380,    0,    0,    0,
    0, 1380, 1380,    0, 1380,    0, 1380,    0, 1380, 1380,
 1380,    0, 1380,    0, 1380, 1380, 1380,    0, 1380, 1380,
 1380, 1380, 1380,    0, 1380, 1380,    0,    0,    0,    0,
 1380,    0, 1380, 1380,    0,    0, 1380, 1380, 1380,    0,
    0, 1380,    0,    0, 1380,    0,    0, 1380, 1380, 1380,
 1380,    0, 1380,    0, 1380,    0, 1380, 1380, 1380, 1380,
 1380,    0,    0, 1380, 1380, 1380,    0, 1380, 1380,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1380, 1380,
 1380,    0, 1380, 1380, 1380,    0,    0,    0, 1380,    0,
    0, 1380,    0, 1380, 1380, 1380, 1380,    0, 1380,    0,
 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1380, 1380,    0,
 1380, 1380, 1380,    0,    0,    0,    0, 1380, 1380, 1380,
 1380, 1380,    0, 1380,    0,    0, 1380, 1380, 1380, 1380,
 1380, 1380, 1380,    0,    0,    0, 1380, 1380, 1380, 1380,
 1380, 1380, 1380, 1380,    0, 1380,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1380, 1380, 1380, 1380, 1380,
 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
 1380, 1380, 1380, 1380, 1380, 1380,    0, 1380, 1380, 1380,
 1380, 1380, 1380,    0, 1380, 1380, 1380, 1380,    0, 1380,
    0, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1382,
 1380, 1380, 1380, 1380,    0, 1380, 1380, 1380, 1380, 1380,
    0, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
 1380, 1380, 1380, 1380, 1380, 1380,    0, 1380, 1380, 1380,
 1380, 1380, 1380, 1380,    0,    0,    0,    0,    0, 1202,
 1382, 1382, 1382, 1382, 1382, 1382, 1382,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1382, 1382, 1382,
 1382, 1382,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1382,    0, 1382,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1382,    0, 1382,    0,
    0, 1382,    0, 1382, 1382,    0,    0, 1382, 1382,    0,
 1382,    0,    0,    0,    0,    0, 1382,    0,    0, 1382,
 1382, 1382, 1382,    0, 1382,    0,    0, 1382,    0,    0,
 1382,    0,    0,    0,    0,    0,    0, 1382,    0, 1382,
 1382,    0, 1382, 1382, 1382,    0, 1382, 1382,    0,    0,
 1382,    0,    0, 1382,    0, 1382, 1382,    0,    0, 1382,
 1382, 1382,    0, 1382,    0, 1382, 1382, 1382, 1382, 1382,
 1382,    0,    0,    0, 1382, 1382, 1382, 1382, 1382,    0,
    0,    0, 1382,    0,    0,    0,    0,    0,    0,    0,
 1382,    0, 1382, 1382, 1382, 1382,    0, 1382,    0,    0,
    0,    0, 1382, 1382,    0, 1382,    0, 1382,    0, 1382,
 1382, 1382,    0, 1382,    0, 1382, 1382, 1382,    0, 1382,
 1382, 1382, 1382, 1382,    0, 1382, 1382,    0,    0,    0,
    0, 1382,    0, 1382, 1382,    0,    0, 1382, 1382, 1382,
    0,    0, 1382,    0,    0, 1382,    0,    0, 1382, 1382,
 1382, 1382,    0, 1382,    0, 1382,    0, 1382, 1382, 1382,
 1382, 1382,    0,    0, 1382, 1382, 1382,    0, 1382, 1382,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1382,
 1382, 1382,    0, 1382, 1382, 1382,    0,    0,    0, 1382,
    0,    0, 1382,    0, 1382, 1382, 1382, 1382,    0, 1382,
    0, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1382, 1382,
    0, 1382, 1382, 1382,    0,    0,    0,    0, 1382, 1382,
 1382, 1382, 1382,    0, 1382,    0,    0, 1382, 1382, 1382,
 1382, 1382, 1382, 1382,    0,    0,    0, 1382, 1382, 1382,
 1382, 1382, 1382, 1382, 1382,    0, 1382,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1382, 1382, 1382, 1382,
 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
 1382, 1382, 1382, 1382, 1382, 1382, 1382,    0, 1382, 1382,
 1382, 1382, 1382, 1382,    0, 1382, 1382, 1382, 1382,    0,
 1382,    0, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
 1384, 1382, 1382, 1382, 1382,    0, 1382, 1382, 1382, 1382,
 1382,    0, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
 1382, 1382, 1382, 1382, 1382, 1382, 1382,    0, 1382, 1382,
 1382, 1382, 1382, 1382, 1382,    0,    0,    0,    0,    0,
 1204, 1384, 1384, 1384, 1384, 1384, 1384, 1384,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1384, 1384,
 1384, 1384, 1384,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1384,    0, 1384,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1384,    0, 1384,
    0,    0, 1384,    0, 1384, 1384,    0,    0, 1384, 1384,
    0, 1384,    0,    0,    0,    0,    0, 1384,    0,    0,
 1384, 1384, 1384, 1384,    0, 1384,    0,    0, 1384,    0,
    0, 1384,    0,    0,    0,    0,    0,    0, 1384,    0,
 1384, 1384,    0, 1384, 1384, 1384,    0, 1384, 1384,    0,
    0, 1384,    0,    0, 1384,    0, 1384, 1384,    0,    0,
 1384, 1384, 1384,    0, 1384,    0, 1384, 1384, 1384, 1384,
 1384, 1384,    0,    0,    0, 1384, 1384, 1384, 1384, 1384,
    0,    0,    0, 1384,    0,    0,    0,    0,    0,    0,
    0, 1384,    0, 1384, 1384, 1384, 1384,    0, 1384,    0,
    0,    0,    0, 1384, 1384,    0, 1384,    0, 1384,    0,
 1384, 1384, 1384,    0, 1384,    0, 1384, 1384, 1384,    0,
 1384, 1384, 1384, 1384, 1384,    0, 1384, 1384,    0,    0,
    0,    0, 1384,    0, 1384, 1384,    0,    0, 1384, 1384,
 1384,    0,    0, 1384,    0,    0, 1384,    0,    0, 1384,
 1384, 1384, 1384,    0, 1384,    0, 1384,    0, 1384, 1384,
 1384, 1384, 1384,    0,    0, 1384, 1384, 1384,    0, 1384,
 1384,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1384, 1384, 1384,    0, 1384, 1384, 1384,    0,    0,    0,
 1384,    0,    0, 1384,    0, 1384, 1384, 1384, 1384,    0,
 1384,    0, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1384,
 1384,    0, 1384, 1384, 1384,    0,    0,    0,    0, 1384,
 1384, 1384, 1384, 1384,    0, 1384,    0,    0, 1384, 1384,
 1384, 1384, 1384, 1384, 1384,    0,    0,    0, 1384, 1384,
 1384, 1384, 1384, 1384, 1384, 1384,    0, 1384,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1384, 1384, 1384,
 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,    0, 1384,
 1384, 1384, 1384, 1384, 1384,    0, 1384, 1384, 1384, 1384,
    0, 1384,    0, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
 1384, 1385, 1384, 1384, 1384, 1384,    0, 1384, 1384, 1384,
 1384, 1384,    0, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,    0, 1384,
 1384, 1384, 1384, 1384, 1384, 1384,    0,    0,    0,    0,
    0, 1205, 1385, 1385, 1385, 1385, 1385, 1385, 1385,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1385,
 1385, 1385, 1385, 1385,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1385,    0, 1385,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1385,    0,
 1385,    0,    0, 1385,    0, 1385, 1385,    0,    0, 1385,
 1385,    0, 1385,    0,    0,    0,    0,    0, 1385,    0,
    0, 1385, 1385, 1385, 1385,    0, 1385,    0,    0, 1385,
    0,    0, 1385,    0,    0,    0,    0,    0,    0, 1385,
    0, 1385, 1385,    0, 1385, 1385, 1385,    0, 1385, 1385,
    0,    0, 1385,    0,    0, 1385,    0, 1385, 1385,    0,
    0, 1385, 1385, 1385,    0, 1385,    0, 1385, 1385, 1385,
 1385, 1385, 1385,    0,    0,    0, 1385, 1385, 1385, 1385,
 1385,    0,    0,    0, 1385,    0,    0,    0,    0,    0,
    0,    0, 1385,    0, 1385, 1385, 1385, 1385,    0, 1385,
    0,    0,    0,    0, 1385, 1385,    0, 1385,    0, 1385,
    0, 1385, 1385, 1385,    0, 1385,    0, 1385, 1385, 1385,
    0, 1385, 1385, 1385, 1385, 1385,    0, 1385, 1385,    0,
    0,    0,    0, 1385,    0, 1385, 1385,    0,    0, 1385,
 1385, 1385,    0,    0, 1385,    0,    0, 1385,    0,    0,
 1385, 1385, 1385, 1385,    0, 1385,    0, 1385,    0, 1385,
 1385, 1385, 1385, 1385,    0,    0, 1385, 1385, 1385,    0,
 1385, 1385,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1385, 1385, 1385,    0, 1385, 1385, 1385,    0,    0,
    0, 1385,    0,    0, 1385,    0, 1385, 1385, 1385, 1385,
    0, 1385,    0, 1385, 1385, 1385, 1385, 1385, 1385, 1385,
 1385,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1385, 1385,    0, 1385, 1385, 1385,    0,    0,    0,    0,
 1385, 1385, 1385, 1385, 1385,    0, 1385,    0,    0, 1385,
 1385, 1385, 1385, 1385, 1385, 1385,    0,    0,    0, 1385,
 1385, 1385, 1385, 1385, 1385, 1385, 1385,    0, 1385,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1385, 1385,
 1385, 1385, 1385, 1385, 1385, 1385, 1385, 1385, 1385, 1385,
 1385, 1385, 1385, 1385, 1385, 1385, 1385, 1385, 1385,    0,
 1385, 1385, 1385, 1385, 1385, 1385,    0, 1385, 1385, 1385,
 1385,    0, 1385,    0, 1385, 1385, 1385, 1385, 1385, 1385,
 1385, 1385, 1385, 1385, 1385, 1385, 1385, 1385, 1385, 1385,
 1385, 1385, 1386, 1385, 1385, 1385, 1385,    0, 1385, 1385,
 1385, 1385, 1385,    0, 1385, 1385, 1385, 1385, 1385, 1385,
 1385, 1385, 1385, 1385, 1385, 1385, 1385, 1385, 1385,    0,
 1385, 1385, 1385, 1385, 1385, 1385, 1385,    0,    0,    0,
    0,    0, 1206, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1386, 1386, 1386, 1386, 1386,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1386,    0, 1386,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1386,
    0, 1386,    0,    0, 1386,    0, 1386, 1386,    0,    0,
 1386, 1386,    0, 1386,    0,    0,    0,    0,    0, 1386,
    0,    0, 1386, 1386, 1386, 1386,    0, 1386,    0,    0,
 1386,    0,    0, 1386,    0,    0,    0,    0,    0,    0,
 1386,    0, 1386, 1386,    0, 1386, 1386, 1386,    0, 1386,
 1386,    0,    0, 1386,    0,    0, 1386,    0, 1386, 1386,
    0,    0, 1386, 1386, 1386,    0, 1386,    0, 1386, 1386,
 1386, 1386, 1386, 1386,    0,    0,    0, 1386, 1386, 1386,
 1386, 1386,    0,    0,    0, 1386,    0,    0,    0,    0,
    0,    0,    0, 1386,    0, 1386, 1386, 1386, 1386,    0,
 1386,    0,    0,    0,    0, 1386, 1386,    0, 1386,    0,
 1386,    0, 1386, 1386, 1386,    0, 1386,    0, 1386, 1386,
 1386,    0, 1386, 1386, 1386, 1386, 1386,    0, 1386, 1386,
    0,    0,    0,    0, 1386,    0, 1386, 1386,    0,    0,
 1386, 1386, 1386,    0,    0, 1386,    0,    0, 1386,    0,
    0, 1386, 1386, 1386, 1386,    0, 1386,    0, 1386,    0,
 1386, 1386, 1386, 1386, 1386,    0,    0, 1386, 1386, 1386,
    0, 1386, 1386,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1386, 1386, 1386,    0, 1386, 1386, 1386,    0,
    0,    0, 1386,    0,    0, 1386,    0, 1386, 1386, 1386,
 1386,    0, 1386,    0, 1386, 1386, 1386, 1386, 1386, 1386,
 1386, 1386,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1386, 1386,    0, 1386, 1386, 1386,    0,    0,    0,
    0, 1386, 1386, 1386, 1386, 1386,    0, 1386,    0,    0,
 1386, 1386, 1386, 1386, 1386, 1386, 1386,    0,    0,    0,
 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,    0, 1386,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1386,
 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
    0, 1386, 1386, 1386, 1386, 1386, 1386,    0, 1386, 1386,
 1386, 1386,    0, 1386,    0, 1386, 1386, 1386, 1386, 1386,
 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
 1386, 1386, 1386, 1387, 1386, 1386, 1386, 1386,    0, 1386,
 1386, 1386, 1386, 1386,    0, 1386, 1386, 1386, 1386, 1386,
 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
    0, 1386, 1386, 1386, 1386, 1386, 1386, 1386,    0,    0,
    0,    0,    0, 1207, 1387, 1387, 1387, 1387, 1387, 1387,
 1387,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1387, 1387, 1387, 1387, 1387,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1387,    0, 1387,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1387,    0, 1387,    0,    0, 1387,    0, 1387, 1387,    0,
    0, 1387, 1387,    0, 1387,    0,    0,    0,    0,    0,
 1387,    0,    0, 1387, 1387, 1387, 1387,    0, 1387,    0,
    0, 1387,    0,    0, 1387,    0,    0,    0,    0,    0,
    0, 1387,    0, 1387, 1387,    0, 1387, 1387, 1387,    0,
 1387, 1387,    0,    0, 1387,    0,    0, 1387,    0, 1387,
 1387,    0,    0, 1387, 1387, 1387,    0, 1387,    0, 1387,
 1387, 1387, 1387, 1387, 1387,    0,    0,    0, 1387, 1387,
 1387, 1387, 1387,    0,    0,    0, 1387,    0,    0,    0,
    0,    0,    0,    0, 1387,    0, 1387, 1387, 1387, 1387,
    0, 1387,    0,    0,    0,    0, 1387, 1387,    0, 1387,
    0, 1387,    0, 1387, 1387, 1387,    0, 1387,    0, 1387,
 1387, 1387,    0, 1387, 1387, 1387, 1387, 1387,    0, 1387,
 1387,    0,    0,    0,    0, 1387,    0, 1387, 1387,    0,
    0, 1387, 1387, 1387,    0,    0, 1387,    0,    0, 1387,
    0,    0, 1387, 1387, 1387, 1387,    0, 1387,    0, 1387,
    0, 1387, 1387, 1387, 1387, 1387,    0,    0, 1387, 1387,
 1387,    0, 1387, 1387,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1387, 1387, 1387,    0, 1387, 1387, 1387,
    0,    0,    0, 1387,    0,    0, 1387,    0, 1387, 1387,
 1387, 1387,    0, 1387,    0, 1387, 1387, 1387, 1387, 1387,
 1387, 1387, 1387,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1387, 1387,    0, 1387, 1387, 1387,    0,    0,
    0,    0, 1387, 1387, 1387, 1387, 1387,    0, 1387,    0,
    0, 1387, 1387, 1387, 1387, 1387, 1387, 1387,    0,    0,
    0, 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387,    0,
 1387,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387,
 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387,
 1387,    0, 1387, 1387, 1387, 1387, 1387, 1387,    0, 1387,
 1387, 1387, 1387,    0, 1387,    0, 1387, 1387, 1387, 1387,
 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387,
 1387, 1387, 1387, 1387, 1390, 1387, 1387, 1387, 1387,    0,
 1387, 1387, 1387, 1387, 1387,    0, 1387, 1387, 1387, 1387,
 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387,
 1387,    0, 1387, 1387, 1387, 1387, 1387, 1387, 1387,    0,
    0,    0,    0,    0, 1208, 1390, 1390, 1390, 1390, 1390,
 1390, 1390,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1390, 1390, 1390, 1390, 1390,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1390,    0, 1390,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1390,    0, 1390,    0,    0, 1390,    0, 1390, 1390,
    0,    0, 1390, 1390,    0, 1390,    0,    0,    0,    0,
    0, 1390,    0,    0, 1390, 1390, 1390, 1390,    0, 1390,
    0,    0, 1390,    0,    0, 1390,    0,    0,    0,    0,
    0,    0, 1390,    0, 1390, 1390,    0, 1390, 1390, 1390,
    0, 1390, 1390,    0,    0, 1390,    0,    0, 1390,    0,
 1390, 1390,    0,    0, 1390, 1390, 1390,    0, 1390,    0,
 1390, 1390, 1390, 1390, 1390, 1390,    0,    0,    0, 1390,
 1390, 1390, 1390, 1390,    0,    0,    0, 1390,    0,    0,
    0,    0,    0,    0,    0, 1390,    0, 1390, 1390, 1390,
 1390,    0, 1390,    0,    0,    0,    0, 1390, 1390,    0,
 1390,    0, 1390,    0, 1390, 1390, 1390,    0, 1390,    0,
 1390, 1390, 1390,    0, 1390, 1390, 1390, 1390, 1390,    0,
 1390, 1390,    0,    0,    0,    0, 1390,    0, 1390, 1390,
    0,    0, 1390, 1390, 1390,    0,    0, 1390,    0,    0,
 1390,    0,    0, 1390, 1390, 1390, 1390,    0, 1390,    0,
 1390,    0, 1390, 1390, 1390, 1390, 1390,    0,    0, 1390,
 1390, 1390,    0, 1390, 1390,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1390, 1390, 1390,    0, 1390, 1390,
 1390,    0,    0,    0, 1390,    0,    0, 1390,    0, 1390,
 1390, 1390, 1390,    0, 1390,    0, 1390, 1390, 1390, 1390,
 1390, 1390, 1390, 1390,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1390, 1390,    0, 1390, 1390, 1390,    0,
    0,    0,    0, 1390, 1390, 1390, 1390, 1390,    0, 1390,
    0,    0, 1390, 1390, 1390, 1390, 1390, 1390, 1390,    0,
    0,    0, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
    0, 1390,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
 1390, 1390,    0, 1390, 1390, 1390, 1390, 1390, 1390,    0,
 1390, 1390, 1390, 1390,    0, 1390,    0, 1390, 1390, 1390,
 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
 1390, 1390, 1390, 1390, 1390, 1392, 1390, 1390, 1390, 1390,
    0, 1390, 1390, 1390, 1390, 1390,    0, 1390, 1390, 1390,
 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
 1390, 1390,    0, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
    0,    0,    0,    0,    0, 1209, 1392, 1392, 1392, 1392,
 1392, 1392, 1392,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1392, 1392, 1392, 1392, 1392,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1392,    0, 1392,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1392,    0, 1392,    0,    0, 1392,    0, 1392,
 1392,    0,    0, 1392, 1392,    0, 1392,    0,    0,    0,
    0,    0, 1392,    0,    0, 1392, 1392, 1392, 1392,    0,
 1392,    0,    0, 1392,    0,    0, 1392,    0,    0,    0,
    0,    0,    0, 1392,    0, 1392, 1392,    0, 1392, 1392,
 1392,    0, 1392, 1392,    0,    0, 1392,    0,    0, 1392,
    0, 1392, 1392,    0,    0, 1392, 1392, 1392,    0, 1392,
    0, 1392, 1392, 1392, 1392, 1392, 1392,    0,    0,    0,
 1392, 1392, 1392, 1392, 1392,    0,    0,    0, 1392,    0,
    0,    0,    0,    0,    0,    0, 1392,    0, 1392, 1392,
 1392, 1392,    0, 1392,    0,    0,    0,    0, 1392, 1392,
    0, 1392,    0, 1392,    0, 1392, 1392, 1392,    0, 1392,
    0, 1392, 1392, 1392,    0, 1392, 1392, 1392, 1392, 1392,
    0, 1392, 1392,    0,    0,    0,    0, 1392,    0, 1392,
 1392,    0,    0, 1392, 1392, 1392,    0,    0, 1392,    0,
    0, 1392,    0,    0, 1392, 1392, 1392, 1392,    0, 1392,
    0, 1392,    0, 1392, 1392, 1392, 1392, 1392,    0,    0,
 1392, 1392, 1392,    0, 1392, 1392,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1392, 1392, 1392,    0, 1392,
 1392, 1392,    0,    0,    0, 1392,    0,    0, 1392,    0,
 1392, 1392, 1392, 1392,    0, 1392,    0, 1392, 1392, 1392,
 1392, 1392, 1392, 1392, 1392,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1392, 1392,    0, 1392, 1392, 1392,
    0,    0,    0,    0, 1392, 1392, 1392, 1392, 1392,    0,
 1392,    0,    0, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
    0,    0,    0, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
 1392,    0, 1392,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
 1392, 1392, 1392,    0, 1392, 1392, 1392, 1392, 1392, 1392,
    0, 1392, 1392, 1392, 1392,    0, 1392,    0, 1392, 1392,
 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
 1392, 1392, 1392, 1392, 1392, 1392, 1393, 1392, 1392, 1392,
 1392,    0, 1392, 1392, 1392, 1392, 1392,    0, 1392, 1392,
 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
 1392, 1392, 1392,    0, 1392, 1392, 1392, 1392, 1392, 1392,
 1392,    0,    0,    0,    0,    0, 1210, 1393, 1393, 1393,
 1393, 1393, 1393, 1393,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1393, 1393, 1393, 1393, 1393,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1393,    0, 1393,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1393,    0, 1393,    0,    0, 1393,    0,
 1393, 1393,    0,    0, 1393, 1393,    0, 1393,    0,    0,
    0,    0,    0, 1393,    0,    0, 1393, 1393, 1393, 1393,
    0, 1393,    0,    0, 1393,    0,    0, 1393,    0,    0,
    0,    0,    0,    0, 1393,    0, 1393, 1393,    0, 1393,
 1393, 1393,    0, 1393, 1393,    0,    0, 1393,    0,    0,
 1393,    0, 1393, 1393,    0,    0, 1393, 1393, 1393,    0,
 1393,    0, 1393, 1393, 1393, 1393, 1393, 1393,    0,    0,
    0, 1393, 1393, 1393, 1393, 1393,    0,    0,    0, 1393,
    0,    0,    0,    0,    0,    0,    0, 1393,    0, 1393,
 1393, 1393, 1393,    0, 1393,    0,    0,    0,    0, 1393,
 1393,    0, 1393,    0, 1393,    0, 1393, 1393, 1393,    0,
 1393,    0, 1393, 1393, 1393,    0, 1393, 1393, 1393, 1393,
 1393,    0, 1393, 1393,    0,    0,    0,    0, 1393,    0,
 1393, 1393,    0,    0, 1393, 1393, 1393,    0,    0, 1393,
    0,    0, 1393,    0,    0, 1393, 1393, 1393, 1393,    0,
 1393,    0, 1393,    0, 1393, 1393, 1393, 1393, 1393,    0,
    0, 1393, 1393, 1393,    0, 1393, 1393,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1393, 1393, 1393,    0,
 1393, 1393, 1393,    0,    0,    0, 1393,    0,    0, 1393,
    0, 1393, 1393, 1393, 1393,    0, 1393,    0, 1393, 1393,
 1393, 1393, 1393, 1393, 1393, 1393,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1393, 1393,    0, 1393, 1393,
 1393,    0,    0,    0,    0, 1393, 1393, 1393, 1393, 1393,
    0, 1393,    0,    0, 1393, 1393, 1393, 1393, 1393, 1393,
 1393,    0,    0,    0, 1393, 1393, 1393, 1393, 1393, 1393,
 1393, 1393,    0, 1393,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1393, 1393, 1393, 1393, 1393, 1393, 1393,
 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393,
 1393, 1393, 1393, 1393,    0, 1393, 1393, 1393, 1393, 1393,
 1393,    0, 1393, 1393, 1393, 1393,    0, 1393,    0, 1393,
 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393,
 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1396, 1393, 1393,
 1393, 1393,    0, 1393, 1393, 1393, 1393, 1393,    0, 1393,
 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393,
 1393, 1393, 1393, 1393,    0, 1393, 1393, 1393, 1393, 1393,
 1393, 1393,    0,    0,    0,    0,    0, 1211, 1396, 1396,
 1396, 1396, 1396, 1396, 1396,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1396, 1396, 1396, 1396, 1396,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1396,    0,
 1396,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1396,    0, 1396,    0,    0, 1396,
    0, 1396, 1396,    0,    0, 1396, 1396,    0, 1396,    0,
    0,    0,    0,    0, 1396,    0,    0, 1396, 1396, 1396,
 1396,    0, 1396,    0,    0, 1396,    0,    0, 1396,    0,
    0,    0,    0,    0,    0, 1396,    0, 1396, 1396,    0,
 1396, 1396, 1396,    0, 1396, 1396,    0,    0, 1396,    0,
    0, 1396,    0, 1396, 1396,    0,    0, 1396, 1396, 1396,
    0, 1396,    0, 1396, 1396, 1396, 1396, 1396, 1396,    0,
    0,    0, 1396, 1396, 1396, 1396, 1396,    0,    0,    0,
 1396,    0,    0,    0,    0,    0,    0,    0, 1396,    0,
 1396, 1396, 1396, 1396,    0, 1396,    0,    0,    0,    0,
 1396, 1396,    0, 1396,    0, 1396,    0, 1396, 1396, 1396,
    0, 1396,    0, 1396, 1396, 1396,    0, 1396, 1396, 1396,
 1396, 1396,    0, 1396, 1396,    0,    0,    0,    0, 1396,
    0, 1396, 1396,    0,    0, 1396, 1396, 1396,    0,    0,
 1396,    0,    0, 1396,    0,    0, 1396, 1396, 1396, 1396,
    0, 1396,    0, 1396,    0, 1396, 1396, 1396, 1396, 1396,
    0,    0, 1396, 1396, 1396,    0, 1396, 1396,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1396, 1396, 1396,
    0, 1396, 1396, 1396,    0,    0,    0, 1396,    0,    0,
 1396,    0, 1396, 1396, 1396, 1396,    0, 1396,    0, 1396,
 1396, 1396, 1396, 1396, 1396, 1396, 1396,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1396, 1396,    0, 1396,
 1396, 1396,    0,    0,    0,    0, 1396, 1396, 1396, 1396,
 1396,    0, 1396,    0,    0, 1396, 1396, 1396, 1396, 1396,
 1396, 1396,    0,    0,    0, 1396, 1396, 1396, 1396, 1396,
 1396, 1396, 1396,    0, 1396,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1396, 1396, 1396, 1396, 1396, 1396,
 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
 1396, 1396, 1396, 1396, 1396,    0, 1396, 1396, 1396, 1396,
 1396, 1396,    0, 1396, 1396, 1396, 1396,    0, 1396,    0,
 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1398, 1396,
 1396, 1396, 1396,    0, 1396, 1396, 1396, 1396, 1396,    0,
 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
 1396, 1396, 1396, 1396, 1396,    0, 1396, 1396, 1396, 1396,
 1396, 1396, 1396,    0,    0,    0,    0,    0, 1213, 1398,
 1398, 1398, 1398, 1398, 1398, 1398,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1398, 1398, 1398, 1398,
 1398,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1398,
    0, 1398,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1398,    0, 1398,    0,    0,
 1398,    0, 1398, 1398,    0,    0, 1398, 1398,    0, 1398,
    0,    0,    0,    0,    0, 1398,    0,    0, 1398, 1398,
 1398, 1398,    0, 1398,    0,    0, 1398,    0,    0, 1398,
    0,    0,    0,    0,    0,    0, 1398,    0, 1398, 1398,
    0, 1398, 1398, 1398,    0, 1398, 1398,    0,    0, 1398,
    0,    0, 1398,    0, 1398, 1398,    0,    0, 1398, 1398,
 1398,    0, 1398,    0, 1398, 1398, 1398, 1398, 1398, 1398,
    0,    0,    0, 1398, 1398, 1398, 1398, 1398,    0,    0,
    0, 1398,    0,    0,    0,    0,    0,    0,    0, 1398,
    0, 1398, 1398, 1398, 1398,    0, 1398,    0,    0,    0,
    0, 1398, 1398,    0, 1398,    0, 1398,    0, 1398, 1398,
 1398,    0, 1398,    0, 1398, 1398, 1398,    0, 1398, 1398,
 1398, 1398, 1398,    0, 1398, 1398,    0,    0,    0,    0,
 1398,    0, 1398, 1398,    0,    0, 1398, 1398, 1398,    0,
    0, 1398,    0,    0, 1398,    0,    0, 1398, 1398, 1398,
 1398,    0, 1398,    0, 1398,    0, 1398, 1398, 1398, 1398,
 1398,    0,    0, 1398, 1398, 1398,    0, 1398, 1398,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1398, 1398,
 1398,    0, 1398, 1398, 1398,    0,    0,    0, 1398,    0,
    0, 1398,    0, 1398, 1398, 1398, 1398,    0, 1398,    0,
 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1398, 1398,    0,
 1398, 1398, 1398,    0,    0,    0,    0, 1398, 1398, 1398,
 1398, 1398,    0, 1398,    0,    0, 1398, 1398, 1398, 1398,
 1398, 1398, 1398,    0,    0,    0, 1398, 1398, 1398, 1398,
 1398, 1398, 1398, 1398,    0, 1398,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1398, 1398, 1398, 1398, 1398,
 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
 1398, 1398, 1398, 1398, 1398, 1398,    0, 1398, 1398, 1398,
 1398, 1398, 1398,    0, 1398, 1398, 1398, 1398,    0, 1398,
    0, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1400,
 1398, 1398, 1398, 1398,    0, 1398, 1398, 1398, 1398, 1398,
    0, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
 1398, 1398, 1398, 1398, 1398, 1398,    0, 1398, 1398, 1398,
 1398, 1398, 1398, 1398,    0,    0,    0,    0,    0, 1214,
 1400, 1400, 1400, 1400, 1400, 1400, 1400,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1400, 1400, 1400,
 1400, 1400,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1400,    0, 1400,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1400,    0, 1400,    0,
    0, 1400,    0, 1400, 1400,    0,    0, 1400, 1400,    0,
 1400,    0,    0,    0,    0,    0, 1400,    0,    0, 1400,
 1400, 1400, 1400,    0, 1400,    0,    0, 1400,    0,    0,
 1400,    0,    0,    0,    0,    0,    0, 1400,    0, 1400,
 1400,    0, 1400, 1400, 1400,    0, 1400, 1400,    0,    0,
 1400,    0,    0, 1400,    0, 1400, 1400,    0,    0, 1400,
 1400, 1400,    0, 1400,    0, 1400, 1400, 1400, 1400, 1400,
 1400,    0,    0,    0, 1400, 1400, 1400, 1400, 1400,    0,
    0,    0, 1400,    0,    0,    0,    0,    0,    0,    0,
 1400,    0, 1400, 1400, 1400, 1400,    0, 1400,    0,    0,
    0,    0, 1400, 1400,    0, 1400,    0, 1400,    0, 1400,
 1400, 1400,    0, 1400,    0, 1400, 1400, 1400,    0, 1400,
 1400, 1400, 1400, 1400,    0, 1400, 1400,    0,    0,    0,
    0, 1400,    0, 1400, 1400,    0,    0, 1400, 1400, 1400,
    0,    0, 1400,    0,    0, 1400,    0,    0, 1400, 1400,
 1400, 1400,    0, 1400,    0, 1400,    0, 1400, 1400, 1400,
 1400, 1400,    0,    0, 1400, 1400, 1400,    0, 1400, 1400,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1400,
 1400, 1400,    0, 1400, 1400, 1400,    0,    0,    0, 1400,
    0,    0, 1400,    0, 1400, 1400, 1400, 1400,    0, 1400,
    0, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1400, 1400,
    0, 1400, 1400, 1400,    0,    0,    0,    0, 1400, 1400,
 1400, 1400, 1400,    0, 1400,    0,    0, 1400, 1400, 1400,
 1400, 1400, 1400, 1400,    0,    0,    0, 1400, 1400, 1400,
 1400, 1400, 1400, 1400, 1400,    0, 1400,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1400, 1400, 1400, 1400,
 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
 1400, 1400, 1400, 1400, 1400, 1400, 1400,    0, 1400, 1400,
 1400, 1400, 1400, 1400,    0, 1400, 1400, 1400, 1400,    0,
 1400,    0, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
 1401, 1400, 1400, 1400, 1400,    0, 1400, 1400, 1400, 1400,
 1400,    0, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
 1400, 1400, 1400, 1400, 1400, 1400, 1400,    0, 1400, 1400,
 1400, 1400, 1400, 1400, 1400,    0,    0,    0,    0,    0,
 1215, 1401, 1401, 1401, 1401, 1401, 1401, 1401,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1401, 1401,
 1401, 1401, 1401,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1401,    0, 1401,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1401,    0, 1401,
    0,    0, 1401,    0, 1401, 1401,    0,    0, 1401, 1401,
    0, 1401,    0,    0,    0,    0,    0, 1401,    0,    0,
 1401, 1401, 1401, 1401,    0, 1401,    0,    0, 1401,    0,
    0, 1401,    0,    0,    0,    0,    0,    0, 1401,    0,
 1401, 1401,    0, 1401, 1401, 1401,    0, 1401, 1401,    0,
    0, 1401,    0,    0, 1401,    0, 1401, 1401,    0,    0,
 1401, 1401, 1401,    0, 1401,    0, 1401, 1401, 1401, 1401,
 1401, 1401,    0,    0,    0, 1401, 1401, 1401, 1401, 1401,
    0,    0,    0, 1401,    0,    0,    0,    0,    0,    0,
    0, 1401,    0, 1401, 1401, 1401, 1401,    0, 1401,    0,
    0,    0,    0, 1401, 1401,    0, 1401,    0, 1401,    0,
 1401, 1401, 1401,    0, 1401,    0, 1401, 1401, 1401,    0,
 1401, 1401, 1401, 1401, 1401,    0, 1401, 1401,    0,    0,
    0,    0, 1401,    0, 1401, 1401,    0,    0, 1401, 1401,
 1401,    0,    0, 1401,    0,    0, 1401,    0,    0, 1401,
 1401, 1401, 1401,    0, 1401,    0, 1401,    0, 1401, 1401,
 1401, 1401, 1401,    0,    0, 1401, 1401, 1401,    0, 1401,
 1401,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1401, 1401, 1401,    0, 1401, 1401, 1401,    0,    0,    0,
 1401,    0,    0, 1401,    0, 1401, 1401, 1401, 1401,    0,
 1401,    0, 1401, 1401, 1401, 1401, 1401, 1401, 1401, 1401,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1401,
 1401,    0, 1401, 1401, 1401,    0,    0,    0,    0, 1401,
 1401, 1401, 1401, 1401,    0, 1401,    0,    0, 1401, 1401,
 1401, 1401, 1401, 1401, 1401,    0,    0,    0, 1401, 1401,
 1401, 1401, 1401, 1401, 1401, 1401,    0, 1401,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1401, 1401, 1401,
 1401, 1401, 1401, 1401, 1401, 1401, 1401, 1401, 1401, 1401,
 1401, 1401, 1401, 1401, 1401, 1401, 1401, 1401,    0, 1401,
 1401, 1401, 1401, 1401, 1401,    0, 1401, 1401, 1401, 1401,
    0, 1401,    0, 1401, 1401, 1401, 1401, 1401, 1401, 1401,
 1401, 1401, 1401, 1401, 1401, 1401, 1401, 1401, 1401, 1401,
 1401, 1402, 1401, 1401, 1401, 1401,    0, 1401, 1401, 1401,
 1401, 1401,    0, 1401, 1401, 1401, 1401, 1401, 1401, 1401,
 1401, 1401, 1401, 1401, 1401, 1401, 1401, 1401,    0, 1401,
 1401, 1401, 1401, 1401, 1401, 1401,    0,    0,    0,    0,
    0, 1216, 1402, 1402, 1402, 1402, 1402, 1402, 1402,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1402,
 1402, 1402, 1402, 1402,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1402,    0, 1402,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1402,    0,
 1402,    0,    0, 1402,    0, 1402, 1402,    0,    0, 1402,
 1402,    0, 1402,    0,    0,    0,    0,    0, 1402,    0,
    0, 1402, 1402, 1402, 1402,    0, 1402,    0,    0, 1402,
    0,    0, 1402,    0,    0,    0,    0,    0,    0, 1402,
    0, 1402, 1402,    0, 1402, 1402, 1402,    0, 1402, 1402,
    0,    0, 1402,    0,    0, 1402,    0, 1402, 1402,    0,
    0, 1402, 1402, 1402,    0, 1402,    0, 1402, 1402, 1402,
 1402, 1402, 1402,    0,    0,    0, 1402, 1402, 1402, 1402,
 1402,    0,    0,    0, 1402,    0,    0,    0,    0,    0,
    0,    0, 1402,    0, 1402, 1402, 1402, 1402,    0, 1402,
    0,    0,    0,    0, 1402, 1402,    0, 1402,    0, 1402,
    0, 1402, 1402, 1402,    0, 1402,    0, 1402, 1402, 1402,
    0, 1402, 1402, 1402, 1402, 1402,    0, 1402, 1402,    0,
    0,    0,    0, 1402,    0, 1402, 1402,    0,    0, 1402,
 1402, 1402,    0,    0, 1402,    0,    0, 1402,    0,    0,
 1402, 1402, 1402, 1402,    0, 1402,    0, 1402,    0, 1402,
 1402, 1402, 1402, 1402,    0,    0, 1402, 1402, 1402,    0,
 1402, 1402,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1402, 1402, 1402,    0, 1402, 1402, 1402,    0,    0,
    0, 1402,    0,    0, 1402,    0, 1402, 1402, 1402, 1402,
    0, 1402,    0, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
 1402,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1402, 1402,    0, 1402, 1402, 1402,    0,    0,    0,    0,
 1402, 1402, 1402, 1402, 1402,    0, 1402,    0,    0, 1402,
 1402, 1402, 1402, 1402, 1402, 1402,    0,    0,    0, 1402,
 1402, 1402, 1402, 1402, 1402, 1402, 1402,    0, 1402,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1402, 1402,
 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,    0,
 1402, 1402, 1402, 1402, 1402, 1402,    0, 1402, 1402, 1402,
 1402,    0, 1402,    0, 1402, 1402, 1402, 1402, 1402, 1402,
 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
 1402, 1402, 1403, 1402, 1402, 1402, 1402,    0, 1402, 1402,
 1402, 1402, 1402,    0, 1402, 1402, 1402, 1402, 1402, 1402,
 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,    0,
 1402, 1402, 1402, 1402, 1402, 1402, 1402,    0,    0,    0,
    0,    0, 1218, 1403, 1403, 1403, 1403, 1403, 1403, 1403,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1403, 1403, 1403, 1403, 1403,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1403,    0, 1403,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1403,
    0, 1403,    0,    0, 1403,    0, 1403, 1403,    0,    0,
 1403, 1403,    0, 1403,    0,    0,    0,    0,    0, 1403,
    0,    0, 1403, 1403, 1403, 1403,    0, 1403,    0,    0,
 1403,    0,    0, 1403,    0,    0,    0,    0,    0,    0,
 1403,    0, 1403, 1403,    0, 1403, 1403, 1403,    0, 1403,
 1403,    0,    0, 1403,    0,    0, 1403,    0, 1403, 1403,
    0,    0, 1403, 1403, 1403,    0, 1403,    0, 1403, 1403,
 1403, 1403, 1403, 1403,    0,    0,    0, 1403, 1403, 1403,
 1403, 1403,    0,    0,    0, 1403,    0,    0,    0,    0,
    0,    0,    0, 1403,    0, 1403, 1403, 1403, 1403,    0,
 1403,    0,    0,    0,    0, 1403, 1403,    0, 1403,    0,
 1403,    0, 1403, 1403, 1403,    0, 1403,    0, 1403, 1403,
 1403,    0, 1403, 1403, 1403, 1403, 1403,    0, 1403, 1403,
    0,    0,    0,    0, 1403,    0, 1403, 1403,    0,    0,
 1403, 1403, 1403,    0,    0, 1403,    0,    0, 1403,    0,
    0, 1403, 1403, 1403, 1403,    0, 1403,    0, 1403,    0,
 1403, 1403, 1403, 1403, 1403,    0,    0, 1403, 1403, 1403,
    0, 1403, 1403,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1403, 1403, 1403,    0, 1403, 1403, 1403,    0,
    0,    0, 1403,    0,    0, 1403,    0, 1403, 1403, 1403,
 1403,    0, 1403,    0, 1403, 1403, 1403, 1403, 1403, 1403,
 1403, 1403,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1403, 1403,    0, 1403, 1403, 1403,    0,    0,    0,
    0, 1403, 1403, 1403, 1403, 1403,    0, 1403,    0,    0,
 1403, 1403, 1403, 1403, 1403, 1403, 1403,    0,    0,    0,
 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403,    0, 1403,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1403,
 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403,
 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403,
    0, 1403, 1403, 1403, 1403, 1403, 1403,    0, 1403, 1403,
 1403, 1403,    0, 1403,    0, 1403, 1403, 1403, 1403, 1403,
 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403,
 1403, 1403, 1403, 1404, 1403, 1403, 1403, 1403,    0, 1403,
 1403, 1403, 1403, 1403,    0, 1403, 1403, 1403, 1403, 1403,
 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403,
    0, 1403, 1403, 1403, 1403, 1403, 1403, 1403,    0,    0,
    0,    0,    0, 1219, 1404, 1404, 1404, 1404, 1404, 1404,
 1404,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1404, 1404, 1404, 1404, 1404,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1404,    0, 1404,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1404,    0, 1404,    0,    0, 1404,    0, 1404, 1404,    0,
    0, 1404, 1404,    0, 1404,    0,    0,    0,    0,    0,
 1404,    0,    0, 1404, 1404, 1404, 1404,    0, 1404,    0,
    0, 1404,    0,    0, 1404,    0,    0,    0,    0,    0,
    0, 1404,    0, 1404, 1404,    0, 1404, 1404, 1404,    0,
 1404, 1404,    0,    0, 1404,    0,    0, 1404,    0, 1404,
 1404,    0,    0, 1404, 1404, 1404,    0, 1404,    0, 1404,
 1404, 1404, 1404, 1404, 1404,    0,    0,    0, 1404, 1404,
 1404, 1404, 1404,    0,    0,    0, 1404,    0,    0,    0,
    0,    0,    0,    0, 1404,    0, 1404, 1404, 1404, 1404,
    0, 1404,    0,    0,    0,    0, 1404, 1404,    0, 1404,
    0, 1404,    0, 1404, 1404, 1404,    0, 1404,    0, 1404,
 1404, 1404,    0, 1404, 1404, 1404, 1404, 1404,    0, 1404,
 1404,    0,    0,    0,    0, 1404,    0, 1404, 1404,    0,
    0, 1404, 1404, 1404,    0,    0, 1404,    0,    0, 1404,
    0,    0, 1404, 1404, 1404, 1404,    0, 1404,    0, 1404,
    0, 1404, 1404, 1404, 1404, 1404,    0,    0, 1404, 1404,
 1404,    0, 1404, 1404,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1404, 1404, 1404,    0, 1404, 1404, 1404,
    0,    0,    0, 1404,    0,    0, 1404,    0, 1404, 1404,
 1404, 1404,    0, 1404,    0, 1404, 1404, 1404, 1404, 1404,
 1404, 1404, 1404,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1404, 1404,    0, 1404, 1404, 1404,    0,    0,
    0,    0, 1404, 1404, 1404, 1404, 1404,    0, 1404,    0,
    0, 1404, 1404, 1404, 1404, 1404, 1404, 1404,    0,    0,
    0, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,    0,
 1404,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
 1404,    0, 1404, 1404, 1404, 1404, 1404, 1404,    0, 1404,
 1404, 1404, 1404,    0, 1404,    0, 1404, 1404, 1404, 1404,
 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
 1404, 1404, 1404, 1404, 1405, 1404, 1404, 1404, 1404,    0,
 1404, 1404, 1404, 1404, 1404,    0, 1404, 1404, 1404, 1404,
 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
 1404,    0, 1404, 1404, 1404, 1404, 1404, 1404, 1404,    0,
    0,    0,    0,    0, 1220, 1405, 1405, 1405, 1405, 1405,
 1405, 1405,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1405, 1405, 1405, 1405, 1405,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1405,    0, 1405,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1405,    0, 1405,    0,    0, 1405,    0, 1405, 1405,
    0,    0, 1405, 1405,    0, 1405,    0,    0,    0,    0,
    0, 1405,    0,    0, 1405, 1405, 1405, 1405,    0, 1405,
    0,    0, 1405,    0,    0, 1405,    0,    0,    0,    0,
    0,    0, 1405,    0, 1405, 1405,    0, 1405, 1405, 1405,
    0, 1405, 1405,    0,    0, 1405,    0,    0, 1405,    0,
 1405, 1405,    0,    0, 1405, 1405, 1405,    0, 1405,    0,
 1405, 1405, 1405, 1405, 1405, 1405,    0,    0,    0, 1405,
 1405, 1405, 1405, 1405,    0,    0,    0, 1405,    0,    0,
    0,    0,    0,    0,    0, 1405,    0, 1405, 1405, 1405,
 1405,    0, 1405,    0,    0,    0,    0, 1405, 1405,    0,
 1405,    0, 1405,    0, 1405, 1405, 1405,    0, 1405,    0,
 1405, 1405, 1405,    0, 1405, 1405, 1405, 1405, 1405,    0,
 1405, 1405,    0,    0,    0,    0, 1405,    0, 1405, 1405,
    0,    0, 1405, 1405, 1405,    0,    0, 1405,    0,    0,
 1405,    0,    0, 1405, 1405, 1405, 1405,    0, 1405,    0,
 1405,    0, 1405, 1405, 1405, 1405, 1405,    0,    0, 1405,
 1405, 1405,    0, 1405, 1405,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1405, 1405, 1405,    0, 1405, 1405,
 1405,    0,    0,    0, 1405,    0,    0, 1405,    0, 1405,
 1405, 1405, 1405,    0, 1405,    0, 1405, 1405, 1405, 1405,
 1405, 1405, 1405, 1405,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1405, 1405,    0, 1405, 1405, 1405,    0,
    0,    0,    0, 1405, 1405, 1405, 1405, 1405,    0, 1405,
    0,    0, 1405, 1405, 1405, 1405, 1405, 1405, 1405,    0,
    0,    0, 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405,
    0, 1405,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405,
 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405,
 1405, 1405,    0, 1405, 1405, 1405, 1405, 1405, 1405,    0,
 1405, 1405, 1405, 1405,    0, 1405,    0, 1405, 1405, 1405,
 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405,
 1405, 1405, 1405, 1405, 1405, 1406, 1405, 1405, 1405, 1405,
    0, 1405, 1405, 1405, 1405, 1405,    0, 1405, 1405, 1405,
 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405,
 1405, 1405,    0, 1405, 1405, 1405, 1405, 1405, 1405, 1405,
    0,    0,    0,    0,    0, 1221, 1406, 1406, 1406, 1406,
 1406, 1406, 1406,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1406, 1406, 1406, 1406, 1406,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1406,    0, 1406,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1406,    0, 1406,    0,    0, 1406,    0, 1406,
 1406,    0,    0, 1406, 1406,    0, 1406,    0,    0,    0,
    0,    0, 1406,    0,    0, 1406, 1406, 1406, 1406,    0,
 1406,    0,    0, 1406,    0,    0, 1406,    0,    0,    0,
    0,    0,    0, 1406,    0, 1406, 1406,    0, 1406, 1406,
 1406,    0, 1406, 1406,    0,    0, 1406,    0,    0, 1406,
    0, 1406, 1406,    0,    0, 1406, 1406, 1406,    0, 1406,
    0, 1406, 1406, 1406, 1406, 1406, 1406,    0,    0,    0,
 1406, 1406, 1406, 1406, 1406,    0,    0,    0, 1406,    0,
    0,    0,    0,    0,    0,    0, 1406,    0, 1406, 1406,
 1406, 1406,    0, 1406,    0,    0,    0,    0, 1406, 1406,
    0, 1406,    0, 1406,    0, 1406, 1406, 1406,    0, 1406,
    0, 1406, 1406, 1406,    0, 1406, 1406, 1406, 1406, 1406,
    0, 1406, 1406,    0,    0,    0,    0, 1406,    0, 1406,
 1406,    0,    0, 1406, 1406, 1406,    0,    0, 1406,    0,
    0, 1406,    0,    0, 1406, 1406, 1406, 1406,    0, 1406,
    0, 1406,    0, 1406, 1406, 1406, 1406, 1406,    0,    0,
 1406, 1406, 1406,    0, 1406, 1406,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1406, 1406, 1406,    0, 1406,
 1406, 1406,    0,    0,    0, 1406,    0,    0, 1406,    0,
 1406, 1406, 1406, 1406,    0, 1406,    0, 1406, 1406, 1406,
 1406, 1406, 1406, 1406, 1406,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1406, 1406,    0, 1406, 1406, 1406,
    0,    0,    0,    0, 1406, 1406, 1406, 1406, 1406,    0,
 1406,    0,    0, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
    0,    0,    0, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
 1406,    0, 1406,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
 1406, 1406, 1406,    0, 1406, 1406, 1406, 1406, 1406, 1406,
    0, 1406, 1406, 1406, 1406,    0, 1406,    0, 1406, 1406,
 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
 1406, 1406, 1406, 1406, 1406, 1406, 1407, 1406, 1406, 1406,
 1406,    0, 1406, 1406, 1406, 1406, 1406,    0, 1406, 1406,
 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
 1406, 1406, 1406,    0, 1406, 1406, 1406, 1406, 1406, 1406,
 1406,    0,    0,    0,    0,    0, 1222, 1407, 1407, 1407,
 1407, 1407, 1407, 1407,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1407, 1407, 1407, 1407, 1407,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1407,    0, 1407,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1407,    0, 1407,    0,    0, 1407,    0,
 1407, 1407,    0,    0, 1407, 1407,    0, 1407,    0,    0,
    0,    0,    0, 1407,    0,    0, 1407, 1407, 1407, 1407,
    0, 1407,    0,    0, 1407,    0,    0, 1407,    0,    0,
    0,    0,    0,    0, 1407,    0, 1407, 1407,    0, 1407,
 1407, 1407,    0, 1407, 1407,    0,    0, 1407,    0,    0,
 1407,    0, 1407, 1407,    0,    0, 1407, 1407, 1407,    0,
 1407,    0, 1407, 1407, 1407, 1407, 1407, 1407,    0,    0,
    0, 1407, 1407, 1407, 1407, 1407,    0,    0,    0, 1407,
    0,    0,    0,    0,    0,    0,    0, 1407,    0, 1407,
 1407, 1407, 1407,    0, 1407,    0,    0,    0,    0, 1407,
 1407,    0, 1407,    0, 1407,    0, 1407, 1407, 1407,    0,
 1407,    0, 1407, 1407, 1407,    0, 1407, 1407, 1407, 1407,
 1407,    0, 1407, 1407,    0,    0,    0,    0, 1407,    0,
 1407, 1407,    0,    0, 1407, 1407, 1407,    0,    0, 1407,
    0,    0, 1407,    0,    0, 1407, 1407, 1407, 1407,    0,
 1407,    0, 1407,    0, 1407, 1407, 1407, 1407, 1407,    0,
    0, 1407, 1407, 1407,    0, 1407, 1407,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1407, 1407, 1407,    0,
 1407, 1407, 1407,    0,    0,    0, 1407,    0,    0, 1407,
    0, 1407, 1407, 1407, 1407,    0, 1407,    0, 1407, 1407,
 1407, 1407, 1407, 1407, 1407, 1407,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1407, 1407,    0, 1407, 1407,
 1407,    0,    0,    0,    0, 1407, 1407, 1407, 1407, 1407,
    0, 1407,    0,    0, 1407, 1407, 1407, 1407, 1407, 1407,
 1407,    0,    0,    0, 1407, 1407, 1407, 1407, 1407, 1407,
 1407, 1407,    0, 1407,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1407, 1407, 1407, 1407, 1407, 1407, 1407,
 1407, 1407, 1407, 1407, 1407, 1407, 1407, 1407, 1407, 1407,
 1407, 1407, 1407, 1407,    0, 1407, 1407, 1407, 1407, 1407,
 1407,    0, 1407, 1407, 1407, 1407,    0, 1407,    0, 1407,
 1407, 1407, 1407, 1407, 1407, 1407, 1407, 1407, 1407, 1407,
 1407, 1407, 1407, 1407, 1407, 1407, 1407, 1409, 1407, 1407,
 1407, 1407,    0, 1407, 1407, 1407, 1407, 1407,    0, 1407,
 1407, 1407, 1407, 1407, 1407, 1407, 1407, 1407, 1407, 1407,
 1407, 1407, 1407, 1407,    0, 1407, 1407, 1407, 1407, 1407,
 1407, 1407,    0,    0,    0,    0,    0, 1223, 1409, 1409,
 1409, 1409, 1409, 1409, 1409,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1409, 1409, 1409, 1409, 1409,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1409,    0,
 1409,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1409,    0, 1409,    0,    0, 1409,
    0, 1409, 1409,    0,    0, 1409, 1409,    0, 1409,    0,
    0,    0,    0,    0, 1409,    0,    0, 1409, 1409, 1409,
 1409,    0, 1409,    0,    0, 1409,    0,    0, 1409,    0,
    0,    0,    0,    0,    0, 1409,    0, 1409, 1409,    0,
 1409, 1409, 1409,    0, 1409, 1409,    0,    0, 1409,    0,
    0, 1409,    0, 1409, 1409,    0,    0, 1409, 1409, 1409,
    0, 1409,    0, 1409, 1409, 1409, 1409, 1409, 1409,    0,
    0,    0, 1409, 1409, 1409, 1409, 1409,    0,    0,    0,
 1409,    0,    0,    0,    0,    0,    0,    0, 1409,    0,
 1409, 1409, 1409, 1409,    0, 1409,    0,    0,    0,    0,
 1409, 1409,    0, 1409,    0, 1409,    0, 1409, 1409, 1409,
    0, 1409,    0, 1409, 1409, 1409,    0, 1409, 1409, 1409,
 1409, 1409,    0, 1409, 1409,    0,    0,    0,    0, 1409,
    0, 1409, 1409,    0,    0, 1409, 1409, 1409,    0,    0,
 1409,    0,    0, 1409,    0,    0, 1409, 1409, 1409, 1409,
    0, 1409,    0, 1409,    0, 1409, 1409, 1409, 1409, 1409,
    0,    0, 1409, 1409, 1409,    0, 1409, 1409,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1409, 1409, 1409,
    0, 1409, 1409, 1409,    0,    0,    0, 1409,    0,    0,
 1409,    0, 1409, 1409, 1409, 1409,    0, 1409,    0, 1409,
 1409, 1409, 1409, 1409, 1409, 1409, 1409,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1409, 1409,    0, 1409,
 1409, 1409,    0,    0,    0,    0, 1409, 1409, 1409, 1409,
 1409,    0, 1409,    0,    0, 1409, 1409, 1409, 1409, 1409,
 1409, 1409,    0,    0,    0, 1409, 1409, 1409, 1409, 1409,
 1409, 1409, 1409,    0, 1409,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1409, 1409, 1409, 1409, 1409, 1409,
 1409, 1409, 1409, 1409, 1409, 1409, 1409, 1409, 1409, 1409,
 1409, 1409, 1409, 1409, 1409,    0, 1409, 1409, 1409, 1409,
 1409, 1409,    0, 1409, 1409, 1409, 1409,    0, 1409,    0,
 1409, 1409, 1409, 1409, 1409, 1409, 1409, 1409, 1409, 1409,
 1409, 1409, 1409, 1409, 1409, 1409, 1409, 1409, 1410, 1409,
 1409, 1409, 1409,    0, 1409, 1409, 1409, 1409, 1409,    0,
 1409, 1409, 1409, 1409, 1409, 1409, 1409, 1409, 1409, 1409,
 1409, 1409, 1409, 1409, 1409,    0, 1409, 1409, 1409, 1409,
 1409, 1409, 1409,    0,    0,    0,    0,    0, 1224, 1410,
 1410, 1410, 1410, 1410, 1410, 1410,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1410, 1410, 1410, 1410,
 1410,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1410,
    0, 1410,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1410,    0, 1410,    0,    0,
 1410,    0, 1410, 1410,    0,    0, 1410, 1410,    0, 1410,
    0,    0,    0,    0,    0, 1410,    0,    0, 1410, 1410,
 1410, 1410,    0, 1410,    0,    0, 1410,    0,    0, 1410,
    0,    0,    0,    0,    0,    0, 1410,    0, 1410, 1410,
    0, 1410, 1410, 1410,    0, 1410, 1410,    0,    0, 1410,
    0,    0, 1410,    0, 1410, 1410,    0,    0, 1410, 1410,
 1410,    0, 1410,    0, 1410, 1410, 1410, 1410, 1410, 1410,
    0,    0,    0, 1410, 1410, 1410, 1410, 1410,    0,    0,
    0, 1410,    0,    0,    0,    0,    0,    0,    0, 1410,
    0, 1410, 1410, 1410, 1410,    0, 1410,    0,    0,    0,
    0, 1410, 1410,    0, 1410,    0, 1410,    0, 1410, 1410,
 1410,    0, 1410,    0, 1410, 1410, 1410,    0, 1410, 1410,
 1410, 1410, 1410,    0, 1410, 1410,    0,    0,    0,    0,
 1410,    0, 1410, 1410,    0,    0, 1410, 1410, 1410,    0,
    0, 1410,    0,    0, 1410,    0,    0, 1410, 1410, 1410,
 1410,    0, 1410,    0, 1410,    0, 1410, 1410, 1410, 1410,
 1410,    0,    0, 1410, 1410, 1410,    0, 1410, 1410,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1410, 1410,
 1410,    0, 1410, 1410, 1410,    0,    0,    0, 1410,    0,
    0, 1410,    0, 1410, 1410, 1410, 1410,    0, 1410,    0,
 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1410, 1410,    0,
 1410, 1410, 1410,    0,    0,    0,    0, 1410, 1410, 1410,
 1410, 1410,    0, 1410,    0,    0, 1410, 1410, 1410, 1410,
 1410, 1410, 1410,    0,    0,    0, 1410, 1410, 1410, 1410,
 1410, 1410, 1410, 1410,    0, 1410,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1410, 1410, 1410, 1410, 1410,
 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
 1410, 1410, 1410, 1410, 1410, 1410,    0, 1410, 1410, 1410,
 1410, 1410, 1410,    0, 1410, 1410, 1410, 1410,    0, 1410,
    0, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1411,
 1410, 1410, 1410, 1410,    0, 1410, 1410, 1410, 1410, 1410,
    0, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
 1410, 1410, 1410, 1410, 1410, 1410,    0, 1410, 1410, 1410,
 1410, 1410, 1410, 1410,    0,    0,    0,    0,    0, 1225,
 1411, 1411, 1411, 1411, 1411, 1411, 1411,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1411, 1411, 1411,
 1411, 1411,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1411,    0, 1411,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1411,    0, 1411,    0,
    0, 1411,    0, 1411, 1411,    0,    0, 1411, 1411,    0,
 1411,    0,    0,    0,    0,    0, 1411,    0,    0, 1411,
 1411, 1411, 1411,    0, 1411,    0,    0, 1411,    0,    0,
 1411,    0,    0,    0,    0,    0,    0, 1411,    0, 1411,
 1411,    0, 1411, 1411, 1411,    0, 1411, 1411,    0,    0,
 1411,    0,    0, 1411,    0, 1411, 1411,    0,    0, 1411,
 1411, 1411,    0, 1411,    0, 1411, 1411, 1411, 1411, 1411,
 1411,    0,    0,    0, 1411, 1411, 1411, 1411, 1411,    0,
    0,    0, 1411,    0,    0,    0,    0,    0,    0,    0,
 1411,    0, 1411, 1411, 1411, 1411,    0, 1411,    0,    0,
    0,    0, 1411, 1411,    0, 1411,    0, 1411,    0, 1411,
 1411, 1411,    0, 1411,    0, 1411, 1411, 1411,    0, 1411,
 1411, 1411, 1411, 1411,    0, 1411, 1411,    0,    0,    0,
    0, 1411,    0, 1411, 1411,    0,    0, 1411, 1411, 1411,
    0,    0, 1411,    0,    0, 1411,    0,    0, 1411, 1411,
 1411, 1411,    0, 1411,    0, 1411,    0, 1411, 1411, 1411,
 1411, 1411,    0,    0, 1411, 1411, 1411,    0, 1411, 1411,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1411,
 1411, 1411,    0, 1411, 1411, 1411,    0,    0,    0, 1411,
    0,    0, 1411,    0, 1411, 1411, 1411, 1411,    0, 1411,
    0, 1411, 1411, 1411, 1411, 1411, 1411, 1411, 1411,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1411, 1411,
    0, 1411, 1411, 1411,    0,    0,    0,    0, 1411, 1411,
 1411, 1411, 1411,    0, 1411,    0,    0, 1411, 1411, 1411,
 1411, 1411, 1411, 1411,    0,    0,    0, 1411, 1411, 1411,
 1411, 1411, 1411, 1411, 1411,    0, 1411,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1411, 1411, 1411, 1411,
 1411, 1411, 1411, 1411, 1411, 1411, 1411, 1411, 1411, 1411,
 1411, 1411, 1411, 1411, 1411, 1411, 1411,    0, 1411, 1411,
 1411, 1411, 1411, 1411,    0, 1411, 1411, 1411, 1411,    0,
 1411,    0, 1411, 1411, 1411, 1411, 1411, 1411, 1411, 1411,
 1411, 1411, 1411, 1411, 1411, 1411, 1411, 1411, 1411, 1411,
 1413, 1411, 1411, 1411, 1411,    0, 1411, 1411, 1411, 1411,
 1411,    0, 1411, 1411, 1411, 1411, 1411, 1411, 1411, 1411,
 1411, 1411, 1411, 1411, 1411, 1411, 1411,    0, 1411, 1411,
 1411, 1411, 1411, 1411, 1411,    0,    0,    0,    0,    0,
 1226, 1413, 1413, 1413, 1413, 1413, 1413, 1413,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1413, 1413,
 1413, 1413, 1413,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1413,    0, 1413,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1413,    0, 1413,
    0,    0, 1413,    0, 1413, 1413,    0,    0, 1413, 1413,
    0, 1413,    0,    0,    0,    0,    0, 1413,    0,    0,
 1413, 1413, 1413, 1413,    0, 1413,    0,    0, 1413,    0,
    0, 1413,    0,    0,    0,    0,    0,    0, 1413,    0,
 1413, 1413,    0, 1413, 1413, 1413,    0, 1413, 1413,    0,
    0, 1413,    0,    0, 1413,    0, 1413, 1413,    0,    0,
 1413, 1413, 1413,    0, 1413,    0, 1413, 1413, 1413, 1413,
 1413, 1413,    0,    0,    0, 1413, 1413, 1413, 1413, 1413,
    0,    0,    0, 1413,    0,    0,    0,    0,    0,    0,
    0, 1413,    0, 1413, 1413, 1413, 1413,    0, 1413,    0,
    0,    0,    0, 1413, 1413,    0, 1413,    0, 1413,    0,
 1413, 1413, 1413,    0, 1413,    0, 1413, 1413, 1413,    0,
 1413, 1413, 1413, 1413, 1413,    0, 1413, 1413,    0,    0,
    0,    0, 1413,    0, 1413, 1413,    0,    0, 1413, 1413,
 1413,    0,    0, 1413,    0,    0, 1413,    0,    0, 1413,
 1413, 1413, 1413,    0, 1413,    0, 1413,    0, 1413, 1413,
 1413, 1413, 1413,    0,    0, 1413, 1413, 1413,    0, 1413,
 1413,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1413, 1413, 1413,    0, 1413, 1413, 1413,    0,    0,    0,
 1413,    0,    0, 1413,    0, 1413, 1413, 1413, 1413,    0,
 1413,    0, 1413, 1413, 1413, 1413, 1413, 1413, 1413, 1413,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1413,
 1413,    0, 1413, 1413, 1413,    0,    0,    0,    0, 1413,
 1413, 1413, 1413, 1413,    0, 1413,    0,    0, 1413, 1413,
 1413, 1413, 1413, 1413, 1413,    0,    0,    0, 1413, 1413,
 1413, 1413, 1413, 1413, 1413, 1413,    0, 1413,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1413, 1413, 1413,
 1413, 1413, 1413, 1413, 1413, 1413, 1413, 1413, 1413, 1413,
 1413, 1413, 1413, 1413, 1413, 1413, 1413, 1413,    0, 1413,
 1413, 1413, 1413, 1413, 1413,    0, 1413, 1413, 1413, 1413,
    0, 1413,    0, 1413, 1413, 1413, 1413, 1413, 1413, 1413,
 1413, 1413, 1413, 1413, 1413, 1413, 1413, 1413, 1413, 1413,
 1413, 1416, 1413, 1413, 1413, 1413,    0, 1413, 1413, 1413,
 1413, 1413,    0, 1413, 1413, 1413, 1413, 1413, 1413, 1413,
 1413, 1413, 1413, 1413, 1413, 1413, 1413, 1413,    0, 1413,
 1413, 1413, 1413, 1413, 1413, 1413,    0,    0,    0,    0,
    0, 1195, 1416, 1416, 1416, 1416, 1416, 1416, 1416,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1416,
 1416, 1416, 1416, 1416,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1416,    0, 1416,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1416,    0,
 1416,    0,    0, 1416,    0, 1416, 1416,    0,    0, 1416,
 1416,    0, 1416,    0,    0,    0,    0,    0, 1416,    0,
    0, 1416, 1416, 1416, 1416,    0, 1416,    0,    0, 1416,
    0,    0, 1416,    0,    0,    0,    0,    0,    0, 1416,
    0, 1416, 1416,    0, 1416, 1416, 1416,    0, 1416, 1416,
    0,    0, 1416,    0,    0, 1416,    0, 1416, 1416,    0,
    0, 1416, 1416, 1416,    0, 1416,    0, 1416, 1416, 1416,
 1416, 1416, 1416,    0,    0,    0, 1416, 1416, 1416, 1416,
 1416,    0,    0,    0, 1416,    0,    0,    0,    0,    0,
    0,    0, 1416,    0, 1416, 1416, 1416, 1416,    0, 1416,
    0,    0,    0,    0, 1416, 1416,    0, 1416,    0, 1416,
    0, 1416, 1416, 1416,    0, 1416,    0, 1416, 1416, 1416,
    0, 1416, 1416, 1416, 1416, 1416,    0, 1416, 1416,    0,
    0,    0,    0, 1416,    0, 1416, 1416,    0,    0, 1416,
 1416, 1416,    0,    0, 1416,    0,    0, 1416,    0,    0,
 1416, 1416, 1416, 1416,    0, 1416,    0, 1416,    0, 1416,
 1416, 1416, 1416, 1416,    0,    0, 1416, 1416, 1416,    0,
 1416, 1416,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1416, 1416, 1416,    0, 1416, 1416, 1416,    0,    0,
    0, 1416,    0,    0, 1416,    0, 1416, 1416, 1416, 1416,
    0, 1416,    0, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
 1416,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1416, 1416,    0, 1416, 1416, 1416,    0,    0,    0,    0,
 1416, 1416, 1416, 1416, 1416,    0, 1416,    0,    0, 1416,
 1416, 1416, 1416, 1416, 1416, 1416,    0,    0,    0, 1416,
 1416, 1416, 1416, 1416, 1416, 1416, 1416,    0, 1416,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1416, 1416,
 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,    0,
 1416, 1416, 1416, 1416, 1416, 1416,    0, 1416, 1416, 1416,
 1416,    0, 1416,    0, 1416, 1416, 1416, 1416, 1416, 1416,
 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
 1416, 1416, 1422, 1416, 1416, 1416, 1416,    0, 1416, 1416,
 1416, 1416, 1416,    0, 1416, 1416, 1416, 1416, 1416, 1416,
 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,    0,
 1416, 1416, 1416, 1416, 1416, 1416, 1416,    0,    0,    0,
    0,    0, 1227, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1422, 1422, 1422, 1422, 1422,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1422,    0, 1422,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1422,
    0, 1422,    0,    0, 1422,    0, 1422, 1422,    0,    0,
 1422, 1422,    0, 1422,    0,    0,    0,    0,    0, 1422,
    0,    0, 1422, 1422, 1422, 1422,    0, 1422,    0,    0,
 1422,    0,    0, 1422,    0,    0,    0,    0,    0,    0,
 1422,    0, 1422, 1422,    0, 1422, 1422, 1422,    0, 1422,
 1422,    0,    0, 1422,    0,    0, 1422,    0, 1422, 1422,
    0,    0, 1422, 1422, 1422,    0, 1422,    0, 1422, 1422,
 1422, 1422, 1422, 1422,    0,    0,    0, 1422, 1422, 1422,
 1422, 1422,    0,    0,    0, 1422,    0,    0,    0,    0,
    0,    0,    0, 1422,    0, 1422, 1422, 1422, 1422,    0,
 1422,    0,    0,    0,    0, 1422, 1422,    0, 1422,    0,
 1422,    0, 1422, 1422, 1422,    0, 1422,    0, 1422, 1422,
 1422,    0, 1422, 1422, 1422, 1422, 1422,    0, 1422, 1422,
    0,    0,    0,    0, 1422,    0, 1422, 1422,    0,    0,
 1422, 1422, 1422,    0,    0, 1422,    0,    0, 1422,    0,
    0, 1422, 1422, 1422, 1422,    0, 1422,    0, 1422,    0,
 1422, 1422, 1422, 1422, 1422,    0,    0, 1422, 1422, 1422,
    0, 1422, 1422,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1422, 1422, 1422,    0, 1422, 1422, 1422,    0,
    0,    0, 1422,    0,    0, 1422,    0, 1422, 1422, 1422,
 1422,    0, 1422,    0, 1422, 1422, 1422, 1422, 1422, 1422,
 1422, 1422,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1422, 1422,    0, 1422, 1422, 1422,    0,    0,    0,
    0, 1422, 1422, 1422, 1422, 1422,    0, 1422,    0,    0,
 1422, 1422, 1422, 1422, 1422, 1422, 1422,    0,    0,    0,
 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,    0, 1422,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1422,
 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
    0, 1422, 1422, 1422, 1422, 1422, 1422,    0, 1422, 1422,
 1422, 1422,    0, 1422,    0, 1422, 1422, 1422, 1422, 1422,
 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
 1422, 1422, 1422, 1429, 1422, 1422, 1422, 1422,    0, 1422,
 1422, 1422, 1422, 1422,    0, 1422, 1422, 1422, 1422, 1422,
 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
    0, 1422, 1422, 1422, 1422, 1422, 1422, 1422,    0,    0,
    0,    0,    0, 1189, 1429, 1429, 1429, 1429, 1429, 1429,
 1429,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1429, 1429, 1429, 1429, 1429,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1429,    0, 1429,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1429,    0, 1429,    0,    0, 1429,    0, 1429, 1429,    0,
    0, 1429, 1429,    0, 1429,    0,    0,    0,    0,    0,
 1429,    0,    0, 1429, 1429, 1429, 1429,    0, 1429,    0,
    0, 1429,    0,    0, 1429,    0,    0,    0,    0,    0,
    0, 1429,    0, 1429, 1429,    0, 1429, 1429, 1429,    0,
 1429, 1429,    0,    0, 1429,    0,    0, 1429,    0, 1429,
 1429,    0,    0, 1429, 1429, 1429,    0, 1429,    0, 1429,
 1429, 1429, 1429, 1429, 1429,    0,    0,    0, 1429, 1429,
 1429, 1429, 1429,    0,    0,    0, 1429,    0,    0,    0,
    0,    0,    0,    0, 1429,    0, 1429, 1429, 1429, 1429,
    0, 1429,    0,    0,    0,    0, 1429, 1429,    0, 1429,
    0, 1429,    0, 1429, 1429, 1429,    0, 1429,    0, 1429,
 1429, 1429,    0, 1429, 1429, 1429, 1429, 1429,    0, 1429,
 1429,    0,    0,    0,    0, 1429,    0, 1429, 1429,    0,
    0, 1429, 1429, 1429,    0,    0, 1429,    0,    0, 1429,
    0,    0, 1429, 1429, 1429, 1429,    0, 1429,    0, 1429,
    0, 1429, 1429, 1429, 1429, 1429,    0,    0, 1429, 1429,
 1429,    0, 1429, 1429,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1429, 1429, 1429,    0, 1429, 1429, 1429,
    0,    0,    0, 1429,    0,    0, 1429,    0, 1429, 1429,
 1429, 1429,    0, 1429,    0, 1429, 1429, 1429, 1429, 1429,
 1429, 1429, 1429,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1429, 1429,    0, 1429, 1429, 1429,    0,    0,
    0,    0, 1429, 1429, 1429, 1429, 1429,    0, 1429,    0,
    0, 1429, 1429, 1429, 1429, 1429, 1429, 1429,    0,    0,
    0, 1429, 1429, 1429, 1429, 1429, 1429, 1429, 1429,    0,
 1429,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1429, 1429, 1429, 1429, 1429, 1429, 1429, 1429, 1429, 1429,
 1429, 1429, 1429, 1429, 1429, 1429, 1429, 1429, 1429, 1429,
 1429,    0, 1429, 1429, 1429, 1429, 1429, 1429,    0, 1429,
 1429, 1429, 1429,    0, 1429,    0, 1429, 1429, 1429, 1429,
 1429, 1429, 1429, 1429, 1429, 1429, 1429, 1429, 1429, 1429,
 1429, 1429, 1429, 1429, 1327, 1429, 1429, 1429, 1429,    0,
 1429, 1429, 1429, 1429, 1429,    0, 1429, 1429, 1429, 1429,
 1429, 1429, 1429, 1429, 1429, 1429, 1429, 1429, 1429, 1429,
 1429,    0, 1429, 1429, 1429, 1429, 1429, 1429, 1429,    0,
    0,    0,    0,    0,    0, 1327, 1327, 1327, 1327, 1327,
 1327, 1327,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1327, 1327, 1327, 1327, 1327,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1327,    0, 1327,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1327,    0, 1327,    0,    0, 1327,    0, 1327, 1327,
    0,    0, 1327, 1327,    0, 1327,    0,    0,    0,    0,
    0, 1327,    0,    0, 1327, 1327, 1327, 1327,    0, 1327,
    0,    0, 1327,    0,    0, 1327,    0,    0,    0,    0,
    0,    0, 1327,    0, 1327, 1327,    0, 1327, 1327, 1327,
    0, 1327, 1327,    0,    0, 1327,    0,    0, 1327,    0,
 1327, 1327,    0,    0, 1327, 1327, 1327,    0, 1327,    0,
 1327, 1327, 1327, 1327, 1327, 1327,    0,    0,    0, 1327,
 1327, 1327, 1327, 1327,    0,    0,    0, 1327,    0,    0,
    0,    0,    0,    0,    0, 1327,    0, 1327, 1327, 1327,
 1327,    0, 1327,    0,    0,    0,    0, 1327, 1327,    0,
 1327,    0, 1327,    0, 1327, 1327, 1327,    0, 1327,    0,
 1327, 1327, 1327,    0, 1327, 1327, 1327, 1327, 1327,    0,
 1327, 1327,    0,    0,    0,    0, 1327,    0, 1327, 1327,
    0,    0, 1327, 1327, 1327,    0,    0, 1327,    0,    0,
 1327,    0,    0, 1327, 1327, 1327, 1327,    0, 1327,    0,
 1327,    0, 1327, 1327, 1327, 1327, 1327,    0,    0, 1327,
 1327, 1327,    0, 1327, 1327,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1327, 1327, 1327,    0, 1327, 1327,
 1327,    0,    0,    0, 1327,    0,    0, 1327,    0, 1327,
 1327, 1327, 1327,    0, 1327,    0, 1327, 1327, 1327, 1327,
 1327, 1327, 1327, 1327,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1327, 1327,    0, 1327, 1327, 1327,    0,
    0,    0,    0, 1327, 1327, 1327, 1327, 1327,    0, 1327,
    0,    0, 1327, 1327, 1327, 1327, 1327, 1327, 1327,    0,
    0,    0, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327,
    0, 1327,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327,
 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327,
 1327, 1327,    0, 1327, 1327, 1327, 1327, 1327, 1327,    0,
 1327, 1327, 1327, 1327,    0, 1327,    0, 1327, 1327, 1327,
 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327,
 1327, 1327, 1327, 1327, 1327, 1375, 1327, 1327, 1327, 1327,
    0, 1327, 1327, 1327, 1327, 1327,    0, 1327, 1327, 1327,
 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327,
 1327, 1327,    0, 1327, 1327, 1327, 1327, 1327, 1327, 1327,
    0,    0,    0,    0,    0,    0, 1375, 1375, 1375, 1375,
 1375, 1375, 1375,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1375, 1375, 1375, 1375, 1375,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1375,    0, 1375,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1375,    0, 1375,    0,    0, 1375,    0, 1375,
 1375,    0,    0, 1375, 1375,    0, 1375,    0,    0,    0,
    0,    0, 1375,    0,    0, 1375, 1375, 1375, 1375,    0,
 1375,    0,    0, 1375,    0,    0, 1375,    0,    0,    0,
    0,    0,    0, 1375,    0, 1375, 1375,    0, 1375, 1375,
 1375,    0, 1375, 1375,    0,    0, 1375,    0,    0, 1375,
    0, 1375, 1375,    0,    0, 1375, 1375, 1375,    0, 1375,
    0, 1375, 1375, 1375, 1375, 1375, 1375,    0,    0,    0,
 1375, 1375, 1375, 1375, 1375,    0,    0,    0, 1375,    0,
    0,    0,    0,    0,    0,    0, 1375,    0, 1375, 1375,
 1375, 1375,    0, 1375,    0,    0,    0,    0, 1375, 1375,
    0, 1375,    0, 1375,    0, 1375, 1375, 1375,    0, 1375,
    0, 1375, 1375, 1375,    0, 1375, 1375, 1375, 1375, 1375,
    0, 1375, 1375,    0,    0,    0,    0, 1375,    0, 1375,
 1375,    0,    0, 1375, 1375, 1375,    0,    0, 1375,    0,
    0, 1375,    0,    0, 1375, 1375, 1375, 1375,    0, 1375,
    0, 1375,    0, 1375, 1375, 1375, 1375, 1375,    0,    0,
 1375, 1375, 1375,    0, 1375, 1375,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1375, 1375, 1375,    0, 1375,
 1375, 1375,    0,    0,    0, 1375,    0,    0, 1375,    0,
 1375, 1375, 1375, 1375,    0, 1375,    0, 1375, 1375, 1375,
 1375, 1375, 1375, 1375, 1375,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1375, 1375,    0, 1375, 1375, 1375,
    0,    0,    0,    0, 1375, 1375, 1375, 1375, 1375,    0,
 1375,    0,    0, 1375, 1375, 1375, 1375, 1375, 1375, 1375,
    0,    0,    0, 1375, 1375, 1375, 1375, 1375, 1375, 1375,
 1375,    0, 1375,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375,
 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375,
 1375, 1375, 1375,    0, 1375, 1375, 1375, 1375, 1375, 1375,
    0, 1375, 1375, 1375, 1375,    0, 1375,    0, 1375, 1375,
 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375,
 1375, 1375, 1375, 1375, 1375, 1375, 1376, 1375, 1375, 1375,
 1375,    0, 1375, 1375, 1375, 1375, 1375,    0, 1375, 1375,
 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375,
 1375, 1375, 1375,    0, 1375, 1375, 1375, 1375, 1375, 1375,
 1375,    0,    0,    0,    0,    0,    0, 1376, 1376, 1376,
 1376, 1376, 1376, 1376,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1376, 1376, 1376, 1376, 1376,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1376,    0, 1376,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1376,    0, 1376,    0,    0, 1376,    0,
 1376, 1376,    0,    0, 1376, 1376,    0, 1376,    0,    0,
    0,    0,    0, 1376,    0,    0, 1376, 1376, 1376, 1376,
    0, 1376,    0,    0, 1376,    0,    0, 1376,    0,    0,
    0,    0,    0,    0, 1376,    0, 1376, 1376,    0, 1376,
 1376, 1376,    0, 1376, 1376,    0,    0, 1376,    0,    0,
 1376,    0, 1376, 1376,    0,    0, 1376, 1376, 1376,    0,
 1376,    0, 1376, 1376, 1376, 1376, 1376, 1376,    0,    0,
    0, 1376, 1376, 1376, 1376, 1376,    0,    0,    0, 1376,
    0,    0,    0,    0,    0,    0,    0, 1376,    0, 1376,
 1376, 1376, 1376,    0, 1376,    0,    0,    0,    0, 1376,
 1376,    0, 1376,    0, 1376,    0, 1376, 1376, 1376,    0,
 1376,    0, 1376, 1376, 1376,    0, 1376, 1376, 1376, 1376,
 1376,    0, 1376, 1376,    0,    0,    0,    0, 1376,    0,
 1376, 1376,    0,    0, 1376, 1376, 1376,    0,    0, 1376,
    0,    0, 1376,    0,    0, 1376, 1376, 1376, 1376,    0,
 1376,    0, 1376,    0, 1376, 1376, 1376, 1376, 1376,    0,
    0, 1376, 1376, 1376,    0, 1376, 1376,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1376, 1376, 1376,    0,
 1376, 1376, 1376,    0,    0,    0, 1376,    0,    0, 1376,
    0, 1376, 1376, 1376, 1376,    0, 1376,    0, 1376, 1376,
 1376, 1376, 1376, 1376, 1376, 1376,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1376, 1376,    0, 1376, 1376,
 1376,    0,    0,    0,    0, 1376, 1376, 1376, 1376, 1376,
    0, 1376,    0,    0, 1376, 1376, 1376, 1376, 1376, 1376,
 1376,    0,    0,    0, 1376, 1376, 1376, 1376, 1376, 1376,
 1376, 1376,    0, 1376,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
 1376, 1376, 1376, 1376,    0, 1376, 1376, 1376, 1376, 1376,
 1376,    0, 1376, 1376, 1376, 1376,    0, 1376,    0, 1376,
 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1394, 1376, 1376,
 1376, 1376,    0, 1376, 1376, 1376, 1376, 1376,    0, 1376,
 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
 1376, 1376, 1376, 1376,    0, 1376, 1376, 1376, 1376, 1376,
 1376, 1376,    0,    0,    0,    0,    0,    0, 1394, 1394,
 1394, 1394, 1394, 1394, 1394,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1394, 1394, 1394, 1394, 1394,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1394,    0,
 1394,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1394,    0, 1394,    0,    0, 1394,
    0, 1394, 1394,    0,    0, 1394, 1394,    0, 1394,    0,
    0,    0,    0,    0, 1394,    0,    0, 1394, 1394, 1394,
 1394,    0, 1394,    0,    0, 1394,    0,    0, 1394,    0,
    0,    0,    0,    0,    0, 1394,    0, 1394, 1394,    0,
 1394, 1394, 1394,    0, 1394, 1394,    0,    0, 1394,    0,
    0, 1394,    0, 1394, 1394,    0,    0, 1394, 1394, 1394,
    0, 1394,    0, 1394, 1394, 1394, 1394, 1394, 1394,    0,
    0,    0, 1394, 1394, 1394, 1394, 1394,    0,    0,    0,
 1394,    0,    0,    0,    0,    0,    0,    0, 1394,    0,
 1394, 1394, 1394, 1394,    0, 1394,    0,    0,    0,    0,
 1394, 1394,    0, 1394,    0, 1394,    0, 1394, 1394, 1394,
    0, 1394,    0, 1394, 1394, 1394,    0, 1394, 1394, 1394,
 1394, 1394,    0, 1394, 1394,    0,    0,    0,    0, 1394,
    0, 1394, 1394,    0,    0, 1394, 1394, 1394,    0,    0,
 1394,    0,    0, 1394,    0,    0, 1394, 1394, 1394, 1394,
    0, 1394,    0, 1394,    0, 1394, 1394, 1394, 1394, 1394,
    0,    0, 1394, 1394, 1394,    0, 1394, 1394,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1394, 1394, 1394,
    0, 1394, 1394, 1394,    0,    0,    0, 1394,    0,    0,
 1394,    0, 1394, 1394, 1394, 1394,    0, 1394,    0, 1394,
 1394, 1394, 1394, 1394, 1394, 1394, 1394,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1394, 1394,    0, 1394,
 1394, 1394,    0,    0,    0,    0, 1394, 1394, 1394, 1394,
 1394,    0, 1394,    0,    0, 1394, 1394, 1394, 1394, 1394,
 1394, 1394,    0,    0,    0, 1394, 1394, 1394, 1394, 1394,
 1394, 1394, 1394,    0, 1394,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1394, 1394, 1394, 1394, 1394, 1394,
 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
 1394, 1394, 1394, 1394, 1394,    0, 1394, 1394, 1394, 1394,
 1394, 1394,    0, 1394, 1394, 1394, 1394,    0, 1394,    0,
 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1449, 1394,
 1394, 1394, 1394,    0, 1394, 1394, 1394, 1394, 1394,    0,
 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
 1394, 1394, 1394, 1394, 1394,    0, 1394, 1394, 1394, 1394,
 1394, 1394, 1394,    0,    0,    0,    0,    0,    0, 1449,
 1449, 1449, 1449, 1449, 1449, 1449,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1449, 1449, 1449,
 1449,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1449,
    0, 1449,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1449,    0, 1449,    0,    0,
 1449,    0, 1449, 1449,    0,    0, 1449, 1449,    0, 1449,
    0,    0,    0,    0,    0, 1449,    0,    0, 1449, 1449,
 1449, 1449,    0, 1449,    0,    0, 1449,    0,    0, 1449,
    0,    0,    0,    0,    0,    0, 1449,    0, 1449, 1449,
    0, 1449, 1449, 1449,    0, 1449, 1449,    0,    0, 1449,
    0,    0, 1449,    0, 1449, 1449,    0,    0, 1449, 1449,
 1449,    0, 1449,    0, 1449, 1449, 1449, 1449, 1449, 1449,
    0,    0,    0, 1449, 1449, 1449, 1449, 1449,    0,    0,
    0, 1449,    0,    0,    0,    0,    0,    0,    0, 1449,
    0, 1449, 1449, 1449, 1449,    0, 1449,    0,    0,    0,
    0, 1449, 1449,    0, 1449,    0, 1449,    0, 1449, 1449,
 1449,    0, 1449,    0, 1449, 1449, 1449,    0, 1449, 1449,
 1449, 1449, 1449,    0, 1449, 1449,    0,    0,    0,    0,
 1449,    0, 1449, 1449,    0,    0, 1449, 1449, 1449,    0,
    0, 1449,    0,    0, 1449,    0,    0, 1449, 1449, 1449,
 1449,    0, 1449,    0, 1449,    0, 1449, 1449, 1449, 1449,
 1449,    0,    0, 1449, 1449, 1449,    0, 1449, 1449,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1449, 1449,
 1449,    0, 1449, 1449, 1449,    0,    0,    0, 1449,    0,
    0, 1449,    0, 1449, 1449, 1449, 1449,    0, 1449,    0,
 1449, 1449, 1449, 1449, 1449, 1449, 1449, 1449,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1449, 1449,    0,
 1449, 1449, 1449,    0,    0,    0,    0, 1449, 1449, 1449,
 1449, 1449,    0, 1449,    0,    0, 1449, 1449, 1449, 1449,
 1449, 1449, 1449,    0,    0,    0, 1449, 1449, 1449, 1449,
 1449, 1449, 1449, 1449,    0, 1449,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1449, 1449, 1449, 1449, 1449,
 1449, 1449, 1449, 1449, 1449, 1449, 1449, 1449, 1449, 1449,
 1449, 1449, 1449, 1449, 1449, 1449,    0, 1449, 1449, 1449,
 1449, 1449, 1449,    0, 1449, 1449, 1449, 1449,    0, 1449,
    0, 1449, 1449, 1449, 1449, 1449, 1449, 1449, 1449, 1449,
 1449, 1449, 1449, 1449, 1449, 1449, 1449, 1449, 1449, 1332,
 1449, 1449, 1449, 1449,    0, 1449, 1449, 1449, 1449, 1449,
    0, 1449, 1449, 1449, 1449, 1449, 1449, 1449, 1449, 1449,
 1449, 1449, 1449, 1449, 1449, 1449,    0, 1449, 1449, 1449,
 1449, 1449, 1449, 1449,    0,    0,    0,    0,    0,    0,
 1332, 1332, 1332, 1332, 1332, 1332, 1332,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1332, 1332,
 1332, 1332,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1332,    0, 1332,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1332,    0, 1332,    0,
    0, 1332,    0, 1332, 1332,    0,    0, 1332, 1332,    0,
 1332,    0,    0,    0,    0,    0, 1332,    0,    0, 1332,
 1332, 1332, 1332,    0, 1332,    0,    0, 1332,    0,    0,
 1332,    0,    0,    0,    0,    0,    0, 1332,    0, 1332,
 1332,    0, 1332, 1332, 1332,    0, 1332, 1332,    0,    0,
 1332,    0,    0, 1332,    0, 1332, 1332,    0,    0, 1332,
 1332, 1332,    0, 1332,    0, 1332, 1332, 1332, 1332, 1332,
 1332,    0,    0,    0, 1332, 1332, 1332, 1332, 1332,    0,
    0,    0, 1332,    0,    0,    0,    0,    0,    0,    0,
 1332,    0, 1332, 1332, 1332, 1332,    0, 1332,    0,    0,
    0,    0, 1332, 1332,    0, 1332,    0, 1332,    0, 1332,
 1332, 1332,    0, 1332,    0, 1332, 1332, 1332,    0, 1332,
 1332, 1332, 1332, 1332,    0, 1332, 1332,    0,    0,    0,
    0, 1332,    0, 1332, 1332,    0,    0, 1332, 1332, 1332,
    0,    0, 1332,    0,    0, 1332,    0,    0, 1332, 1332,
 1332, 1332,    0, 1332,    0, 1332,    0, 1332, 1332, 1332,
 1332, 1332,    0,    0, 1332, 1332, 1332,    0, 1332, 1332,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1332,
 1332, 1332,    0, 1332, 1332, 1332,    0,    0,    0, 1332,
    0,    0, 1332,    0, 1332, 1332, 1332, 1332,    0, 1332,
    0, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1332, 1332,
    0, 1332, 1332, 1332,    0,    0,    0,    0, 1332, 1332,
 1332, 1332, 1332,    0, 1332,    0,    0, 1332, 1332, 1332,
 1332, 1332, 1332, 1332,    0,    0,    0, 1332, 1332, 1332,
 1332, 1332, 1332, 1332, 1332,    0, 1332,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1332, 1332, 1332, 1332,
 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
 1332, 1332, 1332, 1332, 1332, 1332, 1332,    0, 1332, 1332,
 1332, 1332, 1332, 1332,    0, 1332, 1332, 1332, 1332,    0,
 1332,    0, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
 1328, 1332, 1332, 1332, 1332,    0, 1332, 1332, 1332, 1332,
 1332,    0, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
 1332, 1332, 1332, 1332, 1332, 1332, 1332,    0, 1332, 1332,
 1332, 1332, 1332, 1332, 1332,    0,    0,    0,    0,    0,
    0, 1328, 1328, 1328, 1328, 1328, 1328, 1328,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1328,
 1328, 1328, 1328,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1328,    0, 1328,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1328,    0, 1328,
    0,    0, 1328,    0, 1328, 1328,    0,    0, 1328, 1328,
    0, 1328,    0,    0,    0,    0,    0, 1328,    0,    0,
 1328, 1328, 1328, 1328,    0, 1328,    0,    0, 1328,    0,
    0, 1328,    0,    0,    0,    0,    0,    0, 1328,    0,
 1328, 1328,    0, 1328, 1328, 1328,    0, 1328, 1328,    0,
    0, 1328,    0,    0, 1328,    0, 1328, 1328,    0,    0,
 1328, 1328, 1328,    0, 1328,    0, 1328, 1328, 1328, 1328,
 1328, 1328,    0,    0,    0, 1328, 1328, 1328, 1328, 1328,
    0,    0,    0, 1328,    0,    0,    0,    0,    0,    0,
    0, 1328,    0, 1328, 1328, 1328, 1328,    0, 1328,    0,
    0,    0,    0, 1328, 1328,    0, 1328,    0, 1328,    0,
 1328, 1328, 1328,    0, 1328,    0, 1328, 1328, 1328,    0,
 1328, 1328, 1328, 1328, 1328,    0, 1328, 1328,    0,    0,
    0,    0, 1328,    0, 1328, 1328,    0,    0, 1328, 1328,
 1328,    0,    0, 1328,    0,    0, 1328,    0,    0, 1328,
 1328, 1328, 1328,    0, 1328,    0, 1328,    0, 1328, 1328,
 1328, 1328, 1328,    0,    0, 1328, 1328, 1328,    0, 1328,
 1328,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1328, 1328, 1328,    0, 1328, 1328, 1328,    0,    0,    0,
 1328,    0,    0, 1328,    0, 1328, 1328, 1328, 1328,    0,
 1328,    0, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1328,
 1328,    0, 1328, 1328, 1328,    0,    0,    0,    0, 1328,
 1328, 1328, 1328, 1328,    0, 1328,    0,    0, 1328, 1328,
 1328, 1328, 1328, 1328, 1328,    0,    0,    0, 1328, 1328,
 1328, 1328, 1328, 1328, 1328, 1328,    0, 1328,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1328, 1328, 1328,
 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,    0, 1328,
 1328, 1328, 1328, 1328, 1328,    0, 1328, 1328, 1328, 1328,
    0, 1328,    0, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
 1328, 1343, 1328, 1328, 1328, 1328,    0, 1328, 1328, 1328,
 1328, 1328,    0, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,    0, 1328,
 1328, 1328, 1328, 1328, 1328, 1328,    0,    0,    0,    0,
    0,    0, 1343, 1343, 1343, 1343, 1343, 1343, 1343,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1343, 1343, 1343, 1343,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1343,    0, 1343,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1343,    0,
 1343,    0,    0, 1343,    0, 1343, 1343,    0,    0, 1343,
 1343,    0, 1343,    0,    0,    0,    0,    0, 1343,    0,
    0, 1343, 1343, 1343, 1343,    0, 1343,    0,    0, 1343,
    0,    0, 1343,    0,    0,    0,    0,    0,    0, 1343,
    0, 1343, 1343,    0, 1343, 1343, 1343,    0, 1343, 1343,
    0,    0, 1343,    0,    0, 1343,    0, 1343, 1343,    0,
    0, 1343, 1343, 1343,    0, 1343,    0, 1343, 1343, 1343,
 1343, 1343, 1343,    0,    0,    0, 1343, 1343, 1343, 1343,
 1343,    0,    0,    0, 1343,    0,    0,    0,    0,    0,
    0,    0, 1343,    0, 1343, 1343, 1343, 1343,    0, 1343,
    0,    0,    0,    0, 1343, 1343,    0, 1343,    0, 1343,
    0, 1343, 1343, 1343,    0, 1343,    0, 1343, 1343, 1343,
    0, 1343, 1343, 1343, 1343, 1343,    0, 1343, 1343,    0,
    0,    0,    0, 1343,    0, 1343, 1343,    0,    0, 1343,
 1343, 1343,    0,    0, 1343,    0,    0, 1343,    0,    0,
 1343, 1343, 1343, 1343,    0, 1343,    0, 1343,    0, 1343,
 1343, 1343, 1343, 1343,    0,    0, 1343, 1343, 1343,    0,
 1343, 1343,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1343, 1343, 1343,    0, 1343, 1343, 1343,    0,    0,
    0, 1343,    0,    0, 1343,    0, 1343, 1343, 1343, 1343,
    0, 1343,    0, 1343, 1343, 1343, 1343, 1343, 1343, 1343,
 1343,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1343, 1343,    0, 1343, 1343, 1343,    0,    0,    0,    0,
 1343, 1343, 1343, 1343, 1343,    0, 1343,    0,    0, 1343,
 1343, 1343, 1343, 1343, 1343, 1343,    0,    0,    0, 1343,
 1343, 1343, 1343, 1343, 1343, 1343, 1343,    0, 1343,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1343, 1343,
 1343, 1343, 1343, 1343, 1343, 1343, 1343, 1343, 1343, 1343,
 1343, 1343, 1343, 1343, 1343, 1343, 1343, 1343, 1343,    0,
 1343, 1343, 1343, 1343, 1343, 1343,    0, 1343, 1343, 1343,
 1343,    0, 1343,    0, 1343, 1343, 1343, 1343, 1343, 1343,
 1343, 1343, 1343, 1343, 1343, 1343, 1343, 1343, 1343, 1343,
 1343, 1343, 1348, 1343, 1343, 1343, 1343,    0, 1343, 1343,
 1343, 1343, 1343,    0, 1343, 1343, 1343, 1343, 1343, 1343,
 1343, 1343, 1343, 1343, 1343, 1343, 1343, 1343, 1343,    0,
 1343, 1343, 1343, 1343, 1343, 1343, 1343,    0,    0,    0,
    0,    0,    0, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1348, 1348, 1348, 1348,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1348,    0, 1348,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1348,
    0, 1348,    0,    0, 1348,    0, 1348, 1348,    0,    0,
 1348, 1348,    0, 1348,    0,    0,    0,    0,    0, 1348,
    0,    0, 1348, 1348, 1348, 1348,    0, 1348,    0,    0,
 1348,    0,    0, 1348,    0,    0,    0,    0,    0,    0,
 1348,    0, 1348, 1348,    0, 1348, 1348, 1348,    0, 1348,
 1348,    0,    0, 1348,    0,    0, 1348,    0, 1348, 1348,
    0,    0, 1348, 1348, 1348,    0, 1348,    0, 1348, 1348,
 1348, 1348, 1348, 1348,    0,    0,    0, 1348, 1348, 1348,
 1348, 1348,    0,    0,    0, 1348,    0,    0,    0,    0,
    0,    0,    0, 1348,    0, 1348, 1348, 1348, 1348,    0,
 1348,    0,    0,    0,    0, 1348, 1348,    0, 1348,    0,
 1348,    0, 1348, 1348, 1348,    0, 1348,    0, 1348, 1348,
 1348,    0, 1348, 1348, 1348, 1348, 1348,    0, 1348, 1348,
    0,    0,    0,    0, 1348,    0, 1348, 1348,    0,    0,
 1348, 1348, 1348,    0,    0, 1348,    0,    0, 1348,    0,
    0, 1348, 1348, 1348, 1348,    0, 1348,    0, 1348,    0,
 1348, 1348, 1348, 1348, 1348,    0,    0, 1348, 1348, 1348,
    0, 1348, 1348,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1348, 1348, 1348,    0, 1348, 1348, 1348,    0,
    0,    0, 1348,    0,    0, 1348,    0, 1348, 1348, 1348,
 1348,    0, 1348,    0, 1348, 1348, 1348, 1348, 1348, 1348,
 1348, 1348,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1348, 1348,    0, 1348, 1348, 1348,    0,    0,    0,
    0, 1348, 1348, 1348, 1348, 1348,    0, 1348,    0,    0,
 1348, 1348, 1348, 1348, 1348, 1348, 1348,    0,    0,    0,
 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,    0, 1348,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1348,
 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
    0, 1348, 1348, 1348, 1348, 1348, 1348,    0, 1348, 1348,
 1348, 1348,    0, 1348,    0, 1348, 1348, 1348, 1348, 1348,
 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
 1348, 1348, 1348, 1377, 1348, 1348, 1348, 1348,    0, 1348,
 1348, 1348, 1348, 1348,    0, 1348, 1348, 1348, 1348, 1348,
 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
    0, 1348, 1348, 1348, 1348, 1348, 1348, 1348,    0,    0,
    0,    0,    0,    0, 1377, 1377, 1377, 1377, 1377, 1377,
 1377,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1377, 1377, 1377, 1377,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1377,    0, 1377,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1377,    0, 1377,    0,    0, 1377,    0, 1377, 1377,    0,
    0, 1377, 1377,    0, 1377,    0,    0,    0,    0,    0,
 1377,    0,    0, 1377, 1377, 1377, 1377,    0, 1377,    0,
    0, 1377,    0,    0, 1377,    0,    0,    0,    0,    0,
    0, 1377,    0, 1377, 1377,    0, 1377, 1377, 1377,    0,
 1377, 1377,    0,    0, 1377,    0,    0, 1377,    0, 1377,
 1377,    0,    0, 1377, 1377, 1377,    0, 1377,    0, 1377,
 1377, 1377, 1377, 1377, 1377,    0,    0,    0, 1377, 1377,
 1377, 1377, 1377,    0,    0,    0, 1377,    0,    0,    0,
    0,    0,    0,    0, 1377,    0, 1377, 1377, 1377, 1377,
    0, 1377,    0,    0,    0,    0, 1377, 1377,    0, 1377,
    0, 1377,    0, 1377, 1377, 1377,    0, 1377,    0, 1377,
 1377, 1377,    0, 1377, 1377, 1377, 1377, 1377,    0, 1377,
 1377,    0,    0,    0,    0, 1377,    0, 1377, 1377,    0,
    0, 1377, 1377, 1377,    0,    0, 1377,    0,    0, 1377,
    0,    0, 1377, 1377, 1377, 1377,    0, 1377,    0, 1377,
    0, 1377, 1377, 1377, 1377, 1377,    0,    0, 1377, 1377,
 1377,    0, 1377, 1377,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1377, 1377, 1377,    0, 1377, 1377, 1377,
    0,    0,    0, 1377,    0,    0, 1377,    0, 1377, 1377,
 1377, 1377,    0, 1377,    0, 1377, 1377, 1377, 1377, 1377,
 1377, 1377, 1377,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1377, 1377,    0, 1377, 1377, 1377,    0,    0,
    0,    0, 1377, 1377, 1377, 1377, 1377,    0, 1377,    0,
    0, 1377, 1377, 1377, 1377, 1377, 1377, 1377,    0,    0,
    0, 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377,    0,
 1377,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377,
 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377,
 1377,    0, 1377, 1377, 1377, 1377, 1377, 1377,    0, 1377,
 1377, 1377, 1377,    0, 1377,    0, 1377, 1377, 1377, 1377,
 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377,
 1377, 1377, 1377, 1377, 1383, 1377, 1377, 1377, 1377,    0,
 1377, 1377, 1377, 1377, 1377,    0, 1377, 1377, 1377, 1377,
 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377,
 1377,    0, 1377, 1377, 1377, 1377, 1377, 1377, 1377,    0,
    0,    0,    0,    0,    0, 1383, 1383, 1383, 1383, 1383,
 1383, 1383,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1383, 1383, 1383, 1383,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1383,    0, 1383,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1383,    0, 1383,    0,    0, 1383,    0, 1383, 1383,
    0,    0, 1383, 1383,    0, 1383,    0,    0,    0,    0,
    0, 1383,    0,    0, 1383, 1383, 1383, 1383,    0, 1383,
    0,    0, 1383,    0,    0, 1383,    0,    0,    0,    0,
    0,    0, 1383,    0, 1383, 1383,    0, 1383, 1383, 1383,
    0, 1383, 1383,    0,    0, 1383,    0,    0, 1383,    0,
 1383, 1383,    0,    0, 1383, 1383, 1383,    0, 1383,    0,
 1383, 1383, 1383, 1383, 1383, 1383,    0,    0,    0, 1383,
 1383, 1383, 1383, 1383,    0,    0,    0, 1383,    0,    0,
    0,    0,    0,    0,    0, 1383,    0, 1383, 1383, 1383,
 1383,    0, 1383,    0,    0,    0,    0, 1383, 1383,    0,
 1383,    0, 1383,    0, 1383, 1383, 1383,    0, 1383,    0,
 1383, 1383, 1383,    0, 1383, 1383, 1383, 1383, 1383,    0,
 1383, 1383,    0,    0,    0,    0, 1383,    0, 1383, 1383,
    0,    0, 1383, 1383, 1383,    0,    0, 1383,    0,    0,
 1383,    0,    0, 1383, 1383, 1383, 1383,    0, 1383,    0,
 1383,    0, 1383, 1383, 1383, 1383, 1383,    0,    0, 1383,
 1383, 1383,    0, 1383, 1383,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1383, 1383, 1383,    0, 1383, 1383,
 1383,    0,    0,    0, 1383,    0,    0, 1383,    0, 1383,
 1383, 1383, 1383,    0, 1383,    0, 1383, 1383, 1383, 1383,
 1383, 1383, 1383, 1383,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1383, 1383,    0, 1383, 1383, 1383,    0,
    0,    0,    0, 1383, 1383, 1383, 1383, 1383,    0, 1383,
    0,    0, 1383, 1383, 1383, 1383, 1383, 1383, 1383,    0,
    0,    0, 1383, 1383, 1383, 1383, 1383, 1383, 1383, 1383,
    0, 1383,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1383, 1383, 1383, 1383, 1383, 1383, 1383, 1383, 1383,
 1383, 1383, 1383, 1383, 1383, 1383, 1383, 1383, 1383, 1383,
 1383, 1383,    0, 1383, 1383, 1383, 1383, 1383, 1383,    0,
 1383, 1383, 1383, 1383,    0, 1383,    0, 1383, 1383, 1383,
 1383, 1383, 1383, 1383, 1383, 1383, 1383, 1383, 1383, 1383,
 1383, 1383, 1383, 1383, 1383, 1296, 1383, 1383, 1383, 1383,
    0, 1383, 1383, 1383, 1383, 1383,    0, 1383, 1383, 1383,
 1383, 1383, 1383, 1383, 1383, 1383, 1383, 1383, 1383, 1383,
 1383, 1383,    0, 1383, 1383, 1383, 1383, 1383, 1383, 1383,
    0,    0,    0,    0,    0,    0, 1296, 1296, 1296, 1296,
 1296, 1310, 1296,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1296, 1296, 1296, 1296,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1296,    0, 1296,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1296,    0, 1296,    0,    0, 1296,    0, 1296,
 1296,    0,    0, 1296, 1296,    0, 1296,    0,    0,    0,
    0,    0, 1296,    0,    0, 1296, 1296, 1296, 1296,    0,
 1296,    0,    0, 1296,    0,    0, 1296,    0,    0,    0,
    0,    0,    0, 1296,    0, 1296, 1296,    0, 1296, 1296,
 1296,    0, 1296, 1296,    0,    0, 1296,    0,    0, 1296,
    0, 1296, 1296,    0,    0, 1296, 1296, 1296,    0, 1296,
    0, 1296, 1296, 1296, 1296, 1296, 1296,    0,    0,    0,
 1296, 1296, 1296, 1296, 1296,    0,    0,    0, 1296,    0,
    0,    0,    0,    0,    0,    0, 1296,    0, 1296, 1296,
 1296, 1296,    0, 1296,    0,    0,    0,    0, 1296, 1296,
    0, 1296,    0, 1296,    0, 1296, 1296, 1296,    0, 1296,
    0, 1296, 1296, 1296,    0, 1296, 1296, 1296, 1296, 1296,
    0, 1296, 1296,    0,    0,    0,    0, 1296,    0, 1296,
 1296,    0,    0, 1296, 1296, 1296,    0,    0, 1296,    0,
    0, 1296,    0,    0, 1296, 1296, 1296, 1296,    0, 1296,
    0, 1296,    0, 1296, 1296, 1296, 1296, 1296,    0,    0,
 1296, 1296, 1296,    0, 1296, 1296,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1296, 1296, 1296,    0, 1296,
 1296, 1296,    0,    0,    0, 1296,    0,    0, 1296,    0,
 1296, 1296, 1296, 1296,    0, 1296,    0, 1296, 1296, 1296,
 1296, 1296, 1296, 1296, 1296,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1296, 1296,    0, 1296, 1296, 1296,
    0,    0,    0,    0, 1296, 1296, 1296, 1296, 1296,    0,
 1296,    0,    0, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
    0,    0,    0, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
 1296,    0, 1296,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
 1296, 1296, 1296,    0, 1296, 1296, 1296, 1296, 1296, 1296,
    0, 1296, 1296, 1296, 1296,    0, 1296,    0, 1296, 1296,
 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
 1296, 1296, 1296, 1296, 1296, 1296, 1076, 1296, 1296, 1296,
 1296,    0, 1296, 1296, 1296, 1296, 1296,    0, 1296, 1296,
 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
 1296, 1296, 1296,    0, 1296, 1296, 1296, 1296, 1296,    0,
 1296,    0,    0,    0,    0,    0,    0, 1076, 1076, 1076,
 1076, 1076,    0, 1076,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1076, 1076, 1076, 1076,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1076,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1076,    0, 1076,    0,    0, 1076,    0,
 1076, 1076,    0,    0, 1076, 1076,    0, 1076,    0,    0,
    0,    0,    0, 1076,    0,    0, 1076, 1076, 1076, 1076,
    0, 1076,    0,    0, 1076,    0,    0, 1076,    0,    0,
    0,    0,    0,    0, 1076,    0, 1076, 1076,    0, 1076,
 1076, 1076,    0, 1076, 1076,    0,    0, 1076,    0,    0,
 1076,    0, 1076, 1076,    0,    0, 1076, 1076, 1076,    0,
 1076,    0, 1076, 1076, 1076, 1076, 1076, 1076,    0,    0,
    0, 1076, 1076, 1076, 1076, 1076,    0,    0,    0, 1076,
    0,    0,    0,    0,    0,    0,    0, 1076,    0, 1076,
 1076, 1076, 1076,    0, 1076,    0,    0,    0,    0, 1076,
 1076,    0, 1076,    0, 1076,    0, 1076, 1076, 1076,    0,
 1076,    0, 1076, 1076, 1076,    0, 1076, 1076, 1076, 1076,
 1076,    0, 1076, 1076,    0,    0,    0,    0, 1076,    0,
 1076, 1076,    0,    0, 1076, 1076, 1076,    0,    0, 1076,
    0,    0, 1076,    0,    0, 1076, 1076, 1076, 1076,    0,
 1076,    0, 1076,    0, 1076, 1076, 1076, 1076, 1076,    0,
    0, 1076, 1076, 1076,    0, 1076, 1076,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1076, 1076, 1076,    0,
 1076, 1076, 1076,    0,    0,    0, 1076,    0,    0, 1076,
    0, 1076, 1076, 1076, 1076,    0, 1076,    0, 1076, 1076,
 1076, 1076, 1076, 1076, 1076, 1076,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1076, 1076,    0, 1076, 1076,
 1076,    0,    0,    0,    0, 1076, 1076, 1076, 1076, 1076,
    0, 1076,    0,    0, 1076, 1076, 1076, 1076, 1076, 1076,
 1076,    0,    0,    0, 1076, 1076, 1076, 1076, 1076, 1076,
 1076, 1076,    0, 1076,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
 1076, 1076, 1076, 1076,    0, 1076, 1076, 1076, 1076, 1076,
 1076,    0, 1076, 1076, 1076, 1076,    0, 1076,    0, 1076,
 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1089, 1076, 1076,
 1076, 1076,    0, 1076, 1076, 1076, 1076, 1076,    0, 1076,
 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
 1076, 1076, 1076, 1076,    0, 1076, 1076, 1076, 1076, 1076,
    0, 1076,    0,    0,    0,    0,    0,    0, 1089, 1089,
 1089, 1089, 1089,    0, 1089,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1089, 1089, 1089, 1089,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1089,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1089,    0, 1089,    0,    0, 1089,
    0, 1089, 1089,    0,    0, 1089, 1089,    0, 1089,    0,
    0,    0,    0,    0,    0,    0,    0, 1089, 1089, 1089,
 1089,    0, 1089,    0,    0, 1089,    0,    0, 1089,    0,
    0,    0,    0,    0,    0, 1089,    0, 1089, 1089,    0,
 1089, 1089, 1089,    0, 1089, 1089,    0,    0, 1089,    0,
    0, 1089,    0, 1089, 1089,    0,    0, 1089, 1089, 1089,
    0, 1089,    0, 1089, 1089, 1089, 1089, 1089, 1089,    0,
    0,    0, 1089, 1089, 1089, 1089, 1089,    0,    0,    0,
 1089,    0,    0,    0,    0,    0,    0,    0, 1089,    0,
 1089, 1089, 1089, 1089,    0, 1089,    0,    0,    0,    0,
 1089, 1089,    0, 1089,    0, 1089,    0, 1089, 1089, 1089,
    0, 1089,    0, 1089, 1089, 1089,    0, 1089, 1089, 1089,
 1089, 1089,    0, 1089, 1089,    0,    0,    0,    0, 1089,
    0, 1089, 1089,    0,    0, 1089, 1089, 1089,    0,    0,
 1089,    0,    0, 1089,    0,    0, 1089, 1089, 1089, 1089,
    0, 1089,    0, 1089,    0, 1089, 1089, 1089, 1089, 1089,
    0,    0, 1089, 1089, 1089,    0, 1089, 1089,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1089, 1089, 1089,
    0, 1089, 1089, 1089,    0,    0,    0, 1089,    0,    0,
 1089,    0, 1089, 1089, 1089, 1089,    0, 1089,    0, 1089,
 1089, 1089, 1089, 1089, 1089, 1089, 1089,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1089, 1089,    0, 1089,
 1089, 1089,    0,    0,    0,    0, 1089, 1089, 1089, 1089,
 1089,    0, 1089,    0,    0, 1089, 1089, 1089, 1089, 1089,
 1089, 1089,    0,    0,    0, 1089, 1089, 1089, 1089, 1089,
 1089, 1089, 1089,    0, 1089,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1089, 1089, 1089, 1089, 1089, 1089,
 1089, 1089, 1089, 1089, 1089, 1089, 1089, 1089, 1089, 1089,
 1089, 1089, 1089, 1089, 1089,    0, 1089, 1089, 1089, 1089,
 1089, 1089,    0, 1089, 1089, 1089, 1089,    0, 1089,    0,
 1089, 1089, 1089, 1089, 1089, 1089, 1089, 1089, 1089, 1089,
 1089, 1089, 1089, 1089, 1089, 1089, 1089, 1089, 1087, 1089,
 1089, 1089, 1089,    0, 1089, 1089, 1089, 1089, 1089,    0,
 1089, 1089, 1089, 1089, 1089, 1089, 1089, 1089, 1089, 1089,
 1089, 1089, 1089, 1089, 1089,    0, 1089, 1089, 1089, 1089,
 1089,    0, 1089,    0,    0,    0,    0,    0,    0, 1087,
 1087, 1087, 1087, 1087,    0, 1087,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1087, 1087, 1087,
 1087,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1087,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1087,    0, 1087,    0,    0,
 1087,    0, 1087, 1087,    0,    0, 1087, 1087,    0, 1087,
    0,    0,    0,    0,    0,    0,    0,    0, 1087, 1087,
    0, 1087,    0, 1087,    0,    0, 1087,    0,    0, 1087,
    0,    0,    0,    0,    0,    0, 1087,    0, 1087, 1087,
    0, 1087, 1087, 1087,    0, 1087, 1087,    0,    0, 1087,
    0,    0, 1087,    0, 1087, 1087,    0,    0, 1087, 1087,
 1087,    0, 1087,    0, 1087, 1087, 1087, 1087, 1087, 1087,
    0,    0,    0, 1087, 1087, 1087, 1087, 1087,    0,    0,
    0, 1087,    0,    0,    0,    0,    0,    0,    0, 1087,
    0, 1087, 1087, 1087, 1087,    0, 1087,    0,    0,    0,
    0, 1087, 1087,    0, 1087,    0, 1087,    0, 1087, 1087,
 1087,    0, 1087,    0, 1087, 1087, 1087,    0, 1087, 1087,
 1087, 1087, 1087,    0, 1087, 1087,    0,    0,    0,    0,
 1087,    0, 1087, 1087,    0,    0, 1087, 1087, 1087,    0,
    0, 1087,    0,    0, 1087,    0,    0, 1087, 1087, 1087,
 1087,    0, 1087,    0, 1087,    0, 1087, 1087, 1087, 1087,
 1087,    0,    0, 1087, 1087, 1087,    0, 1087, 1087,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1087, 1087,
 1087,    0, 1087, 1087, 1087,    0,    0,    0, 1087,    0,
    0, 1087,    0, 1087, 1087, 1087, 1087,    0, 1087,    0,
 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1087, 1087,    0,
 1087, 1087, 1087,    0,    0,    0,    0, 1087, 1087, 1087,
 1087, 1087,    0, 1087,    0,    0, 1087, 1087, 1087, 1087,
 1087, 1087, 1087,    0,    0,    0, 1087, 1087, 1087, 1087,
 1087, 1087, 1087, 1087,    0, 1087,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1087, 1087, 1087, 1087, 1087,
 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087,
 1087, 1087, 1087, 1087, 1087, 1087,    0, 1087, 1087, 1087,
 1087, 1087, 1087,    0, 1087, 1087, 1087, 1087,    0, 1087,
    0, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087,
 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1086,
 1087, 1087, 1087, 1087,    0, 1087, 1087, 1087, 1087, 1087,
    0, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087,
 1087, 1087, 1087, 1087, 1087, 1087,    0, 1087, 1087, 1087,
 1087, 1087,    0, 1087,    0,    0,    0,    0,    0,    0,
 1086, 1086, 1086, 1086, 1086,    0, 1086,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1086, 1086,
 1086, 1086,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1086,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1086,    0, 1086,    0,
    0, 1086,    0, 1086, 1086,    0,    0, 1086, 1086,    0,
 1086,    0,    0,    0,    0,    0,    0,    0,    0, 1086,
 1086,    0, 1086,    0, 1086,    0,    0, 1086,    0,    0,
 1086,    0,    0,    0,    0,    0,    0, 1086,    0, 1086,
 1086,    0, 1086, 1086, 1086,    0, 1086, 1086,    0,    0,
 1086,    0,    0, 1086,    0, 1086, 1086,    0,    0, 1086,
 1086, 1086,    0, 1086,    0, 1086, 1086, 1086, 1086, 1086,
 1086,    0,    0,    0, 1086, 1086, 1086, 1086, 1086,    0,
    0,    0, 1086,    0,    0,    0,    0,    0,    0,    0,
 1086,    0, 1086, 1086, 1086, 1086,    0, 1086,    0,    0,
    0,    0, 1086, 1086,    0, 1086,    0, 1086,    0, 1086,
 1086, 1086,    0, 1086,    0, 1086, 1086, 1086,    0, 1086,
 1086, 1086, 1086, 1086,    0, 1086, 1086,    0,    0,    0,
    0, 1086,    0, 1086, 1086,    0,    0, 1086, 1086, 1086,
    0,    0, 1086,    0,    0, 1086,    0,    0, 1086, 1086,
 1086, 1086,    0, 1086,    0, 1086,    0, 1086, 1086, 1086,
 1086, 1086,    0,    0, 1086, 1086, 1086,    0, 1086, 1086,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1086,
 1086, 1086,    0, 1086, 1086, 1086,    0,    0,    0, 1086,
    0,    0, 1086,    0, 1086, 1086, 1086, 1086,    0, 1086,
    0, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1086, 1086,
    0, 1086, 1086, 1086,    0,    0,    0,    0, 1086, 1086,
 1086, 1086, 1086,    0, 1086,    0,    0, 1086, 1086, 1086,
 1086, 1086, 1086, 1086,    0,    0,    0, 1086, 1086, 1086,
 1086, 1086, 1086, 1086, 1086,    0, 1086,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1086, 1086, 1086, 1086,
 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
 1086, 1086, 1086, 1086, 1086, 1086, 1086,    0, 1086, 1086,
 1086, 1086, 1086, 1086,    0, 1086, 1086, 1086, 1086,    0,
 1086,    0, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
 1092, 1086, 1086, 1086, 1086,    0, 1086, 1086, 1086, 1086,
 1086,    0, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
 1086, 1086, 1086, 1086, 1086, 1086, 1086,    0, 1086, 1086,
 1086, 1086, 1086,    0, 1086,    0,    0,    0,    0,    0,
    0, 1092, 1092, 1092, 1092, 1092,    0, 1092,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1092,
 1092, 1092, 1092,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1092,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1092,    0, 1092,
    0,    0, 1092,    0, 1092, 1092,    0,    0, 1092, 1092,
    0, 1092,    0,    0,    0,    0,    0,    0,    0,    0,
 1092, 1092,    0, 1092,    0, 1092,    0,    0, 1092,    0,
    0, 1092,    0,    0,    0,    0,    0,    0, 1092,    0,
 1092, 1092,    0, 1092, 1092, 1092,    0, 1092, 1092,    0,
    0, 1092,    0,    0, 1092,    0, 1092, 1092,    0,    0,
 1092, 1092, 1092,    0, 1092,    0, 1092, 1092, 1092, 1092,
 1092, 1092,    0,    0,    0, 1092, 1092, 1092, 1092, 1092,
    0,    0,    0, 1092,    0,    0,    0,    0,    0,    0,
    0, 1092,    0, 1092, 1092, 1092, 1092,    0, 1092,    0,
    0,    0,    0, 1092, 1092,    0, 1092,    0, 1092,    0,
 1092, 1092, 1092,    0, 1092,    0, 1092, 1092, 1092,    0,
 1092, 1092, 1092, 1092, 1092,    0, 1092, 1092,    0,    0,
    0,    0, 1092,    0, 1092, 1092,    0,    0, 1092, 1092,
 1092,    0,    0, 1092,    0,    0, 1092,    0,    0, 1092,
 1092, 1092, 1092,    0, 1092,    0, 1092,    0, 1092, 1092,
 1092, 1092, 1092,    0,    0, 1092, 1092, 1092,    0, 1092,
 1092,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1092, 1092, 1092,    0, 1092, 1092, 1092,    0,    0,    0,
 1092,    0,    0, 1092,    0, 1092, 1092, 1092, 1092,    0,
 1092,    0, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1092,
 1092,    0, 1092, 1092, 1092,    0,    0,    0,    0, 1092,
 1092, 1092, 1092, 1092,    0, 1092,    0,    0, 1092, 1092,
 1092, 1092, 1092, 1092, 1092,    0,    0,    0, 1092, 1092,
 1092, 1092, 1092, 1092, 1092, 1092,    0, 1092,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1092, 1092, 1092,
 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,    0, 1092,
 1092, 1092, 1092, 1092, 1092,    0, 1092, 1092, 1092, 1092,
    0, 1092,    0, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
 1092, 1093, 1092, 1092, 1092, 1092,    0, 1092, 1092, 1092,
 1092, 1092,    0, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,    0, 1092,
 1092, 1092, 1092, 1092,    0, 1092,    0,    0,    0,    0,
    0,    0, 1093, 1093, 1093, 1093, 1093,    0, 1093,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1093, 1093, 1093, 1093,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1093,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1093,    0,
 1093,    0,    0, 1093,    0, 1093, 1093,    0,    0, 1093,
 1093,    0, 1093,    0,    0,    0,    0,    0,    0,    0,
    0, 1093, 1093,    0, 1093,    0, 1093,    0,    0, 1093,
    0,    0, 1093,    0,    0,    0,    0,    0,    0, 1093,
    0, 1093, 1093,    0, 1093, 1093, 1093,    0, 1093, 1093,
    0,    0, 1093,    0,    0, 1093,    0, 1093, 1093,    0,
    0, 1093, 1093, 1093,    0, 1093,    0, 1093, 1093, 1093,
 1093, 1093, 1093,    0,    0,    0, 1093, 1093, 1093, 1093,
 1093,    0,    0,    0, 1093,    0,    0,    0,    0,    0,
    0,    0, 1093,    0, 1093, 1093, 1093, 1093,    0, 1093,
    0,    0,    0,    0, 1093, 1093,    0, 1093,    0, 1093,
    0, 1093, 1093, 1093,    0, 1093,    0, 1093, 1093, 1093,
    0, 1093, 1093, 1093, 1093, 1093,    0, 1093, 1093,    0,
    0,    0,    0, 1093,    0, 1093, 1093,    0,    0, 1093,
 1093, 1093,    0,    0, 1093,    0,    0, 1093,    0,    0,
 1093, 1093, 1093, 1093,    0, 1093,    0, 1093,    0, 1093,
 1093, 1093, 1093, 1093,    0,    0, 1093, 1093, 1093,    0,
 1093, 1093,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1093, 1093, 1093,    0, 1093, 1093, 1093,    0,    0,
    0, 1093,    0,    0, 1093,    0, 1093, 1093, 1093, 1093,
    0, 1093,    0, 1093, 1093, 1093, 1093, 1093, 1093, 1093,
 1093,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1093, 1093,    0, 1093, 1093, 1093,    0,    0,    0,    0,
 1093, 1093, 1093, 1093, 1093,    0, 1093,    0,    0, 1093,
 1093, 1093, 1093, 1093, 1093, 1093,    0,    0,    0, 1093,
 1093, 1093, 1093, 1093, 1093, 1093, 1093,    0, 1093,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1093, 1093,
 1093, 1093, 1093, 1093, 1093, 1093, 1093, 1093, 1093, 1093,
 1093, 1093, 1093, 1093, 1093, 1093, 1093, 1093, 1093,    0,
 1093, 1093, 1093, 1093, 1093, 1093,    0, 1093, 1093, 1093,
 1093,    0, 1093,    0, 1093, 1093, 1093, 1093, 1093, 1093,
 1093, 1093, 1093, 1093, 1093, 1093, 1093, 1093, 1093, 1093,
 1093, 1093, 1088, 1093, 1093, 1093, 1093,    0, 1093, 1093,
 1093, 1093, 1093,    0, 1093, 1093, 1093, 1093, 1093, 1093,
 1093, 1093, 1093, 1093, 1093, 1093, 1093, 1093, 1093,    0,
 1093, 1093, 1093, 1093, 1093,    0, 1093,    0,    0,    0,
    0,    0,    0, 1088,    0, 1088, 1088, 1088,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1088, 1088, 1088, 1088,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1088,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1088,
    0, 1088,    0,    0, 1088,    0, 1088, 1088,    0,    0,
 1088, 1088,    0, 1088,    0,    0,    0,    0,    0,    0,
    0,    0, 1088, 1088,    0, 1088,    0, 1088,    0,    0,
 1088,    0,    0, 1088,    0,    0,    0,    0,    0,    0,
 1088,    0, 1088, 1088,    0, 1088, 1088, 1088,    0, 1088,
 1088,    0,    0, 1088,    0,    0, 1088,    0, 1088, 1088,
    0,    0, 1088, 1088, 1088,    0, 1088,    0, 1088, 1088,
 1088, 1088, 1088, 1088,    0,    0,    0, 1088, 1088, 1088,
 1088, 1088,    0,    0,    0, 1088,    0,    0,    0,    0,
    0,    0,    0, 1088,    0, 1088, 1088, 1088, 1088,    0,
 1088,    0,    0,    0,    0, 1088, 1088,    0, 1088,    0,
 1088,    0, 1088, 1088, 1088,    0, 1088,    0, 1088, 1088,
 1088,    0, 1088, 1088, 1088, 1088, 1088,    0, 1088, 1088,
    0,    0,    0,    0, 1088,    0, 1088, 1088,    0,    0,
 1088, 1088, 1088,    0,    0, 1088,    0,    0, 1088,    0,
    0, 1088, 1088, 1088, 1088,    0, 1088,    0, 1088,    0,
 1088, 1088, 1088, 1088, 1088,    0,    0, 1088, 1088, 1088,
    0, 1088, 1088,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1088, 1088, 1088,    0, 1088, 1088, 1088,    0,
    0,    0, 1088,    0,    0, 1088,    0, 1088, 1088, 1088,
 1088,    0, 1088,    0, 1088, 1088, 1088, 1088, 1088, 1088,
 1088, 1088,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1088, 1088,    0, 1088, 1088, 1088,    0,    0,    0,
    0, 1088, 1088, 1088, 1088, 1088,    0, 1088,    0,    0,
 1088, 1088, 1088, 1088, 1088, 1088, 1088,    0,    0,    0,
 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,    0, 1088,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1088,
 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
    0, 1088, 1088, 1088, 1088, 1088, 1088,    0, 1088, 1088,
 1088, 1088,    0, 1088,    0, 1088, 1088, 1088, 1088, 1088,
 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
 1088, 1088, 1088, 1091, 1088, 1088, 1088, 1088,    0, 1088,
 1088, 1088, 1088, 1088,    0, 1088, 1088, 1088, 1088, 1088,
 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
    0, 1088, 1088, 1088, 1088, 1088,    0, 1088,    0,    0,
    0,    0,    0,    0, 1091,    0, 1091, 1091, 1091,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1091, 1091, 1091, 1091,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1091,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1091,    0, 1091,    0,    0, 1091,    0, 1091, 1091,    0,
    0, 1091, 1091,    0, 1091,    0,    0,    0,    0,    0,
    0,    0,    0, 1091, 1091,    0, 1091,    0, 1091,    0,
    0, 1091,    0,    0, 1091,    0,    0,    0,    0,    0,
    0, 1091,    0, 1091, 1091,    0, 1091, 1091, 1091,    0,
 1091, 1091,    0,    0, 1091,    0,    0, 1091,    0, 1091,
 1091,    0,    0, 1091, 1091, 1091,    0, 1091,    0, 1091,
 1091, 1091, 1091, 1091, 1091,    0,    0,    0, 1091, 1091,
 1091, 1091, 1091,    0,    0,    0, 1091,    0,    0,    0,
    0,    0,    0,    0, 1091,    0, 1091, 1091, 1091, 1091,
    0, 1091,    0,    0,    0,    0, 1091, 1091,    0, 1091,
    0, 1091,    0, 1091, 1091, 1091,    0, 1091,    0, 1091,
 1091, 1091,    0, 1091, 1091, 1091, 1091, 1091,    0, 1091,
 1091,    0,    0,  866,    0, 1091,    0, 1091, 1091,    0,
    0, 1091, 1091, 1091,    0,    0, 1091,    0,    0, 1091,
    0,    0, 1091, 1091, 1091, 1091,    0, 1091,    0, 1091,
    0, 1091, 1091, 1091, 1091, 1091,    0,    0, 1091, 1091,
 1091,    0, 1091, 1091,  866,    0,    0,  866,    0,    0,
    0,    0,    0, 1091, 1091, 1091,    0, 1091, 1091, 1091,
    0,    0,  866, 1091,    0,    0, 1091,    0, 1091, 1091,
 1091, 1091,    0, 1091,    0, 1091, 1091, 1091, 1091, 1091,
 1091, 1091, 1091,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1091, 1091,    0, 1091, 1091, 1091,    0,    0,
    0,    0, 1091, 1091, 1091, 1091, 1091,    0, 1091,    0,
    0, 1091, 1091, 1091, 1091, 1091, 1091, 1091,    0,    0,
    0, 1091, 1091, 1091, 1091, 1091, 1091, 1091, 1091,    0,
 1091,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1091, 1091, 1091, 1091, 1091, 1091, 1091, 1091, 1091, 1091,
 1091, 1091, 1091, 1091, 1091, 1091, 1091, 1091, 1091, 1091,
 1091,    0, 1091, 1091, 1091, 1091, 1091, 1091,    0, 1091,
 1091, 1091, 1091,    0, 1091,    0, 1091, 1091, 1091, 1091,
 1091, 1091, 1091, 1091, 1091, 1091, 1091, 1091, 1091, 1091,
 1091, 1091, 1091, 1091,    0, 1091, 1091, 1091, 1091,    0,
 1091, 1091, 1091, 1091, 1091,    0, 1091, 1091, 1091, 1091,
 1091, 1091, 1091, 1091, 1091, 1091, 1091, 1091, 1091, 1091,
 1091,    0, 1091, 1091, 1091, 1091, 1091,    0, 1091,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  866,    0,  866,    0,    0,    0,    0,  866,  866,    0,
    0,  866,  866,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  866,  866,    0,  866,    0,  866,    0,
    0,  866,    0,    0,  866,    0,    0,    0,    0,    0,
    0,  866,    0,  866,  866,    0,    0,    0,  866,    0,
    0,  866,    0,    0,  866,    0,    0,  866,    0,    0,
  866,    0,    0,    0,  866,  866,    0,  866,    0,  866,
  866,    0,  866,  866,  866,    0,    0,    0,  866,    0,
  866,  866,  866,    0,    0,    0,  866,    0,    0,    0,
    0,    0,  837,    0,  866,    0,  866,    0,  866,    0,
    0,  866,    0,    0,    0,    0,  866,  866,    0,  866,
    0,    0,    0,    0,    0,    0,    0,  866,    0,  866,
    0,  866,    0,  866,  866,  866,  866,  866,    0,  866,
  866,    0,  837,  837,    0,  866,  837,  866,  866,    0,
    0,  866,  866,    0,    0,    0,  866,    0,    0,  866,
    0,  837,  866,  866,  866,  866,    0,  866,    0,  866,
    0,  866,  866,  866,  866,  866,    0,    0,    0,    0,
  866,    0,  866,  866,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  866,    0,  866,    0,  866,  866,  866,
    0,    0,    0,  866,    0,    0,  866,    0,  866,  866,
  866,  866,    0,  866,    0,    0,    0,    0,    0,    0,
    0,  866,  866,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  866,  866,    0,  866,  866,  866,    0,    0,
    0,    0,  866,  866,  866,  866,  866,    0,  866,    0,
    0,  866,  866,  866,  866,  866,  866,  866,    0,    0,
    0,  866,  866,  866,  866,  866,  866,  866,  866,    0,
  866,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  866,  866,  866,  866,  866,  866,  866,  866,  866,  866,
  866,  866,  866,  866,  866,  866,  866,  866,  866,  866,
  866,    0,  866,  866,  866,  866,  866,  866,    0,  866,
  866,  866,  866,    0,  866,    0,  866,  866,  866,  866,
  866,  866,  866,  866,  866,  866,  866,  866,  866,  866,
  866,  866,  866,  866,    0,  866,  866,  866,  866,    0,
  866,  866,  866,  866,  866,    0,  866,  866,  866,  866,
  866,  866,  866,  866,  866,  866,  866,  866,  866,  837,
  866,  837,  866,  866,  866,  866,  866,  837,  866,    0,
  837,  837,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  837,  837,    0,  837,    0,  837,    0,    0,
  837,    0,    0,  837,    0,    0,    0,    0,    0,    0,
  837,    0,  837,  837,    0,    0,    0,  837,    0,    0,
  837,    0,    0,  837,    0,    0,  837,    0,    0,  837,
    0,    0,    0,  837,  837,    0,  837,    0,  837,  837,
    0,  837,  837,  837,    0,    0,    0,  837,    0,  837,
  837,  837,    0,    0,    0,  837,    0,    0,    0,    0,
    0,  864,    0,  837,    0,  837,    0,  837,    0,    0,
  837,    0,    0,    0,    0,  837,  837,    0,  837,    0,
    0,    0,    0,    0,    0,    0,  837,    0,  837,    0,
  837,    0,  837,  837,  837,  837,  837,    0,  837,  837,
    0,    0,  864,    0,  837,  864,  837,  837,    0,    0,
  837,  837,    0,    0,    0,  837,    0,    0,  837,    0,
  864,  837,  837,  837,  837,    0,  837,    0,  837,    0,
  837,  837,  837,  837,  837,    0,    0,    0,    0,  837,
    0,  837,  837,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  837,    0,  837,    0,  837,  837,  837,    0,
    0,    0,  837,    0,    0,  837,    0,  837,  837,  837,
  837,    0,  837,    0,    0,    0,    0,    0,    0,    0,
  837,  837,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  837,  837,    0,  837,  837,  837,    0,    0,    0,
    0,  837,  837,  837,  837,  837,    0,  837,    0,    0,
  837,  837,  837,  837,  837,  837,  837,    0,    0,    0,
  837,  837,  837,  837,  837,  837,  837,  837,    0,  837,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  837,
  837,  837,  837,  837,  837,  837,  837,  837,  837,  837,
  837,  837,  837,  837,  837,  837,  837,  837,  837,  837,
    0,  837,  837,  837,  837,  837,  837,    0,  837,  837,
  837,  837,    0,  837,    0,  837,  837,  837,  837,  837,
  837,  837,  837,  837,  837,  837,  837,  837,  837,  837,
  837,  837,  837,    0,  837,  837,  837,  837,    0,  837,
  837,  837,  837,  837,    0,  837,  837,  837,  837,  837,
  837,  837,  837,  837,  837,  837,  837,  837,  837,  837,
  837,  837,  837,  837,  837,  837,  837,  837,    0,  837,
  837,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  837,  837,    0,  837,    0,  837,    0,    0,  837,
    0,    0,  837,    0,    0,    0,    0,    0,    0,  837,
    0,  837,  837,    0,    0,    0,  837,    0,    0,  837,
    0,    0,  837,    0,    0,  864,    0,    0,  864,    0,
    0,    0,  837,  837,    0,  864,    0,  864,  837,    0,
  837,  864,  837,    0,    0,    0,  864,    0,  837,  864,
  837,    0,    0,    0,  837,    0,    0,    0,    0,    0,
  869,    0,  837,    0,  864,    0,  837,    0,    0,  837,
    0,    0,    0,    0,  837,  837,    0,  864,    0,    0,
    0,    0,    0,    0,    0,  864,    0,  837,    0,  864,
    0,  837,  837,  837,  837,  837,    0,  837,  864,    0,
    0,    0,    0,  837,    0,  837,  837,    0,    0,  837,
  837,    0,    0,    0,  864,    0,    0,  837,    0,  869,
  837,  837,  837,  837,    0,  837,    0,  837,    0,  837,
  837,  837,  837,  837,    0,    0,    0,    0,  837,    0,
  837,  864,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  837,    0,  864,    0,  864,  837,  837,    0,    0,
    0,  837,    0,    0,  837,    0,  837,  837,  837,  837,
    0,  837,    0,    0,    0,    0,    0,    0,    0,  837,
  837,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  837,  837,    0,  837,  837,  837,    0,    0,    0,    0,
  837,  837,  864,  837,  837,    0,  837,    0,    0,  837,
  837,  837,  837,  837,  837,  837,    0,    0,    0,  864,
  837,  837,  837,  864,  837,  837,  837,    0,  837,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  837,
  837,  837,  837,  837,  837,  837,  837,  837,  837,  837,
  837,  837,  837,  837,  837,  837,  837,  837,  837,    0,
  837,  837,  837,  837,  837,  837,    0,  837,  837,  837,
  837,    0,  837,    0,  837,  837,  837,  837,  837,  837,
  837,  837,  837,  837,  837,  837,  837,  837,  837,  837,
  837,  837,    0,  837,  837,  837,  837,    0,  837,  837,
  837,  837,  837,    0,  837,  837,  837,  837,  837,  837,
  837,  837,  837,  837,  837,  837,  837,  837,  837,  837,
  837,  837,  837,  837,  837,  837,  837,    0,  837,  837,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  837,  837,    0,  837,    0,  837,    0,    0,  837,    0,
    0,  837,    0,    0,    0,    0,    0,    0,  837,    0,
  837,  837,    0,    0,    0,  837,    0,    0,  837,    0,
    0,  837,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  837,  837,    0,    0,    0,    0,  837,    0,  837,
    0,  837,    0,    0,    0,    0,    0,  837,    0,  837,
    0,    0,    0,  837,    0,    0,    0,    0,    0,    0,
    0,  837,    0,    0,    0,  837,    0,    0,  837,    0,
    0,    0,    0,  837,  837,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  837,    0,  869,    0,
  837,  837,  837,  837,  837,    0,  837,  869,    0,    0,
    0,    0,  837,    0,  837,  837,    0,    0,  837,  837,
    0,    0,    0,    0,    0,    0,  837,    0,  869,  837,
  837,  837,  837,    0,  837,    0,  837,    0,  837,  837,
  837,  837,  837,    0,    0, 1089,    0,  837,  766,  837,
  767,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  837,    0,  869,  769,    0,  837,  837,    0,  770,    0,
  837,    0,    0,  837,    0,  837,  837,  837,  837,    0,
  837,    0,    0,    0,    0,    0,    0,    0,  837,  837,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  837,
  837,    0,  837,  837,  837,    0,    0,    0,    0,  837,
  837,  869,  837,  837,    0,  837,    0,    0,  837,  837,
  837,  837,  837,  837,  837,    0,    0,    0,  869,  837,
  837,  837,    0,  837,  837,  837,    0,  837,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  837,  837,
  837,  837,  837,  837,  837,  837,  837,  837,  837,  837,
  837,  837,  837,  837,  837,  837,  837,  837,    0,  837,
  837,  837,  837,  837,  837,    0,  837,  837,  837,  837,
    0,  837,    0,  837,  837,  837,  837,  837,  837,  837,
  837,  837,  837,  837,  837,  837,  837,  837,  837,  837,
  837,    0,  837,  837,  837,  837,    0,  837,  837,  837,
  837,  837,    0,  837,  837,  837,  837,  837,  837,  837,
  837,  837,  837,  837,  837,  837,    0,  837,    0,  837,
  837,  837,  837,  837,    0,  837,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  115,    0,  116,    0,    0,    0,    0,    0,
  118,    0,  667,  119,  120,    0,    0,    0,    0,  668,
    0,    0,    0,    0,    0,  121,  122,    0,  123,    0,
  124,  669,    0,  125,    0,    0,  126,  670,  671,    0,
    0,    0,    0,  128,    0,  129,  130,    0,    0,    0,
  131,    0,    0,  132,    0,    0,  134,    0,    0,    0,
    0,    0,    0,    0,  672,    0,  135,  673,    0,    0,
    0,    0,  137,    0,  138,    0,  139,    0,    0,    0,
    0,    0,  141,    0,  142,    0,    0,    0,  143,    0,
    0,    0,  674,    0,  675,  676,  144,    0,  677,    0,
  145,    0,    0,  146,  678,    0,    0,  679,  147,  148,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  149,    0,    0,    0,  150,  151,  152,  153,  154,
    0,  155,    0,  680,    0,    0,    0,  156,    0,  157,
  158,    0,    0,  160,  161,    0,    0,    0,  681,    0,
    0,  162,    0,    0,  164,  165,  166,  167,    0,  168,
    0,  169,  682,  170,  171,  172,  173,  174,  683,    0,
    0,    0,  175,    0,  176,    0,    0,    0,  684,    0,
    0, 1052,    0,    0,  766,  178,  767,    0,    0,    0,
  179,  180,  685,  686,  687,  688,  427,  428,  182,  769,
  183,  184,  185,  186,  770,  187,  689, 1400, 1401, 1402,
 1403, 1404, 1405, 1434, 1435,  690,  691,  692,  693,  694,
  695,  696,  697,  698,  190,  699,    0,  192,  193,  194,
  700,  701,    0,  702,  703,  704,    0,  197,  198,  705,
  199,    0,    0,  200,  201,  202,  203,  204,  205,  206,
    0,    0,    0,    0,  207,  706,  209,    0,  707,  211,
  212,    0,  213,    0,  708,  709,  710,    0,  711,  712,
    0,  713,  214,  215,  216,  217,  218,  219,  714,  221,
  715,  223,  716,  717,  718,  719,  720,  721,  722,  723,
  724,  725,  726,    0,  727,  728,  729,  730,  731,  732,
    0,  733,  734,  735,  244,    0,  736,    0,  737,  738,
  739,  740,  741,  251,  252,  742, 1436,  743,  744,  745,
  258,  746,  260,  747,  262,  748,    0,  749,  750,  751,
  752,    0,  753,  754,  755,  271,  756,    0,  757,  758,
  275,  759, 1437,  278,  760,  280,  281,  282,  283,  284,
  285,    0,  761,    0,  287,  288,  289,  290,  291,    0,
  762,  763,  764,  765,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  115,    0,
  116,    0,    0,    0,    0,    0,  118,    0,  667,  119,
  120,    0,    0,    0,    0,  668,    0,    0,    0,    0,
    0,  121,  122,    0,  123,    0,  124,  669,    0,  125,
 1045,    0,  126,  670,  671,    0,    0,    0,    0,  128,
    0,  129,  130,    0,    0,    0,  131,    0,    0,  132,
    0, 1046,  134,    0,    0,    0,    0,    0,    0,    0,
  672,    0,  135,  673,    0,    0,    0,    0,  137,    0,
  138,    0,  139,    0,    0,    0,    0,    0,  141,    0,
  142,    0,    0,    0,  143,    0,    0,    0,  674,    0,
  675,  676,  144,    0,  677,    0,  145,    0,    0,  146,
  678,    0,    0,  679,  147,  148,    0,    0,    0,    0,
    0, 1047,    0,    0,    0,    0,    0,  149,    0,    0,
    0,  150,  151,  152,  153,  154,    0,  155,    0,  680,
    0,    0,    0,  156,    0,  157,  158,    0,    0,  160,
  161,    0,    0,    0,  681,    0,    0,  162,    0,    0,
  164,  165, 1048,  167,    0,  168,    0,  169,  682,  170,
  171,  172,  173,  174,  683,    0,    0,    0,  175,    0,
  176,    0,    0,    0,  684,    0,    0, 1052,    0,    0,
  766,  178,  767,    0,    0,    0,  179,  180,  685,  686,
  687,  688,  427,  428,  182,  769,  183,  184,  185,  186,
  770,  187,  689,    0,    0,    0,    0,    0,    0,  188,
  189,  690,  691,  692,  693,  694,  695,  696,  697,  698,
  190,  699,    0,  192,  193,  194,  700,  701,    0,  702,
  703,  704,    0,  197,  198,  705,  199,    0,    0,  200,
  201, 1049, 1050, 1051,  205,  206,    0,    0,    0,    0,
  207,  706,  209,    0,  707,  211,  212,    0,  213,    0,
  708,  709,  710,    0,  711,  712,    0,  713,  214,  215,
  216,  217,  218,  219,  714,  221,  715,  223,  716,  717,
  718,  719,  720,  721,  722,  723,  724,  725,  726,    0,
  727,  728,  729,  730,  731,  732,    0,  733,  734,  735,
  244,    0,  736,    0,  737,  738,  739,  740,  741,  251,
  252,  742,  254,  743,  744,  745,  258,  746,  260,  747,
  262,  748,    0,  749,  750,  751,  752,    0,  753,  754,
  755,  271,  756,    0,  757,  758,  275,  759,  277,  278,
  760,  280,  281,  282,  283,  284,  285,    0,  761,    0,
  287,  288,  289,  290,  291,    0,  762,  763,  764,  765,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  115,    0,  116,    0,    0,    0,
    0,    0,  118,    0,  667,  119,  120,    0,    0,    0,
    0,  668,    0,    0,    0,    0,    0,  121,  122,    0,
  123,    0,  124,  669,    0,  125,    0,    0,  126,  670,
  671,    0,    0,    0,    0,  128,    0,  129,  130,    0,
    0,    0,  131,    0,    0,  132,    0, 1046,  134,    0,
    0,    0,    0,    0,    0,    0,  672,    0,  135,  673,
    0,    0,    0,    0,  137,    0,  138,    0,  139,    0,
    0,    0,    0,    0,  141,    0,  142,    0,    0,    0,
  143,    0,    0,    0,  674,    0,  675,  676,  144,    0,
  677,    0,  145,    0,    0,  146,  678,    0,    0,  679,
  147,  148,    0,    0,    0,    0,    0, 1047,    0,    0,
    0,    0,    0,  149,    0,    0,    0,  150,  151,  152,
  153,  154,    0,  155,    0,  680,    0,    0,    0,  156,
    0,  157,  158,    0,    0,  160,  161,    0,    0,    0,
  681,    0,    0,  162,    0,    0,  164,  165, 1048,  167,
    0,  168,    0,  169,  682,  170,  171,  172,  173,  174,
  683,    0,    0,    0,  175,    0,  176,    0,    0,    0,
  684,    0,    0, 1089,    0,    0,  766,  178,  767,    0,
    0,   16,  179,  180,  685,  686,  687,  688,  427,  428,
  182,  769,  183,  184,  185,  186,  770,  187,  689,    0,
    0,    0,    0,    0,    0,  188,  189,  690,  691,  692,
  693,  694,  695,  696,  697,  698,  190,  699,    0,  192,
  193,  194,  700,  701,    0,  702,  703,  704,    0,  197,
  198,  705,  199,    0,    0,  200,  201, 1049, 1050, 1051,
  205,  206,    0,    0,    0,    0,  207,  706,  209,    0,
  707,  211,  212,    0,  213,    0,  708,  709,  710,    0,
  711,  712,    0,  713,  214,  215,  216,  217,  218,  219,
  714,  221,  715,  223,  716,  717,  718,  719,  720,  721,
  722,  723,  724,  725,  726,    0,  727,  728,  729,  730,
  731,  732,    0,  733,  734,  735,  244,    0,  736,    0,
  737,  738,  739,  740,  741,  251,  252,  742,  254,  743,
  744,  745,  258,  746,  260,  747,  262,  748,    0,  749,
  750,  751,  752,    0,  753,  754,  755,  271,  756,    0,
  757,  758,  275,  759,  277,  278,  760,  280,  281,  282,
  283,  284,  285,    0,  761,    0,  287,  288,  289,  290,
  291,    0,  762,  763,  764,  765,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  115,    0,  116,    0,    0,    0,    0,    0,  118,    0,
  667,  119,  120,    0,    0,    0,    0,  668,    0,    0,
    0,    0,    0,  121,  122,    0,  123,    0,  124,  669,
    0,  125,    0,    0,  126,  670,  671,    0,    0,    0,
    0,  128,    0,  129,  130,    0,    0,    0,  131,    0,
    0,  132,    0,    0,  134,    0,    0,    0,    0,    0,
    0,    0,  672,    0,  135,  673,    0,    0,    0,    0,
  137,    0,  138,    0,  139,    0,    0,    0,    0,    0,
  141,    0,  142,    0,    0,    0,  143,    0,    0,    0,
  674,    0,  675,  676,  144,    0,  677,    0,  145,    0,
    0,  146,  678,    0,    0,  679,  147,  148,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  149,
    0,    0,    0,  150,  151,  152,  153,  154,    0,  155,
    0,  680,    0,    0,    0,  156,    0,  157,  158,    0,
    0,  160,  161,    0,    0,    0,  681,    0,    0,  162,
    0,    0,  164,  165,  166,  167,    0,  168,    0,  169,
  682,  170,  171,  172,  173,  174,  683,    0,    0,    0,
  175,    0,  176,    0,    0,    0,  684,    0,    0, 1089,
    0,    0,  766,  178,  767,    0,    0,    0,  179,  180,
  685,  686,  687,  688,  427,  428,  182,  769,  183,  184,
  185,  186,  770,  187,  689,    0,    0,    0,    0,    0,
    0,  188,  189,  690,  691,  692,  693,  694,  695,  696,
  697,  698,  190,  699,    0,  192,  193,  194,  700,  701,
    0,  702,  703,  704,    0,  197,  198,  705,  199,    0,
    0,  200,  201,  202,  203,  204,  205,  206,    0,    0,
    0,    0,  207,  706,  209,    0,  707,  211,  212, 1429,
  213,    0,  708,  709,  710, 1430,  711,  712, 1431,  713,
  214,  215,  216,  217,  218,  219,  714,  221,  715,  223,
  716,  717,  718,  719,  720,  721,  722,  723,  724,  725,
  726,    0,  727,  728,  729,  730,  731,  732,    0,  733,
  734,  735,  244,    0,  736,    0,  737,  738,  739,  740,
  741,  251,  252,  742,  254,  743,  744,  745,  258,  746,
  260,  747,  262,  748,    0,  749,  750,  751,  752,    0,
  753,  754,  755,  271,  756,    0,  757,  758,  275,  759,
  277,  278,  760,  280,  281,  282,  283,  284,  285,    0,
  761,    0,  287,  288,  289,  290,  291,    0,  762,  763,
  764,  765,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  115,    0,  116, 1691,
    0,    0, 1692,    0,  118,    0,  667,  119,  120,    0,
    0,    0,    0,  668,    0,    0,    0,    0,    0,  121,
  122,    0,  123,    0,  124,  669,    0,  125,    0,    0,
  126,  670,  671,    0,    0,    0,    0,  128,    0,  129,
  130,    0,    0,    0,  131,    0,    0,  132,    0,    0,
  134,    0,    0,    0,    0,    0,    0,    0,  672,    0,
  135,  673,    0,    0,    0,    0,  137,    0,  138,    0,
  139,    0,    0,    0,    0,    0,  141,    0,  142,    0,
    0,    0,  143,    0,    0,    0,  674,    0,  675,  676,
  144,    0,  677,    0,  145,    0,    0,  146,  678,    0,
    0,  679,  147,  148,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  149,    0,    0,    0,  150,
  151,  152,  153,  154,    0,  155,    0,  680,    0,    0,
    0,  156,    0,  157,  158,    0,    0,  160,  161,    0,
    0,    0,  681,    0,    0,  162,    0,    0,  164,  165,
  166,  167,    0,  168, 1693,  169,  682,  170,  171,  172,
  173,  174,  683,    0,    0,    0,  175,    0,  176,    0,
    0,    0,  684,    0,    0, 1089,    0,    0,  766,  178,
  767,    0,    0,    0,  179,  180,  685,  686,  687,  688,
  427,  428,  182,  769,  183,  184,  185,  186,  770,  187,
  689,    0,    0,    0,    0,    0,    0,  188,  189,  690,
  691,  692,  693,  694,  695,  696,  697,  698,  190,  699,
    0,  192,  193,  194,  700,  701,    0,  702,  703,  704,
    0,  197,  198,  705,  199,    0,    0,  200,  201,  202,
  203,  204,  205,  206,    0,    0,    0,    0,  207,  706,
  209,    0,  707,  211,  212,    0,  213,    0,  708,  709,
  710,    0,  711,  712,    0,  713,  214,  215,  216,  217,
  218,  219,  714,  221,  715,  223,  716,  717,  718,  719,
  720,  721,  722,  723,  724,  725,  726,    0,  727,  728,
  729,  730,  731,  732,    0,  733,  734,  735,  244,    0,
  736,    0,  737,  738,  739,  740,  741,  251,  252,  742,
  254,  743,  744,  745,  258,  746,  260,  747,  262,  748,
    0,  749,  750,  751,  752,    0,  753,  754,  755,  271,
  756,    0,  757,  758,  275,  759,  277,  278,  760,  280,
  281,  282,  283,  284,  285,    0,  761,    0,  287,  288,
  289,  290,  291,    0,  762,  763,  764,  765,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  115,    0,  116, 1702,    0,    0, 1692,    0,
  118,    0,  667,  119,  120,    0,    0,    0,    0,  668,
    0,    0,    0,    0,    0,  121,  122,    0,  123,    0,
  124,  669,    0,  125,    0,    0,  126,  670,  671,    0,
    0,    0,    0,  128,    0,  129,  130,    0,    0,    0,
  131,    0,    0,  132,    0,    0,  134,    0,    0,    0,
    0,    0,    0,    0,  672,    0,  135,  673,    0,    0,
    0,    0,  137,    0,  138,    0,  139,    0,    0,    0,
    0,    0,  141,    0,  142,    0,    0,    0,  143,    0,
    0,    0,  674,    0,  675,  676,  144,    0,  677,    0,
  145,    0,    0,  146,  678,    0,    0,  679,  147,  148,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  149,    0,    0,    0,  150,  151,  152,  153,  154,
    0,  155,    0,  680,    0,    0,    0,  156,    0,  157,
  158,    0,    0,  160,  161,    0,    0,    0,  681,    0,
    0,  162,    0,    0,  164,  165,  166,  167,    0,  168,
 1693,  169,  682,  170,  171,  172,  173,  174,  683,    0,
    0,    0,  175,    0,  176,    0,    0,    0,  684,    0,
    0, 1089,    0,    0,  766,  178,  767,    0,    0,    0,
  179,  180,  685,  686,  687,  688,  427,  428,  182,  769,
  183,  184,  185,  186,  770,  187,  689,    0,    0,    0,
    0,    0,    0,  188,  189,  690,  691,  692,  693,  694,
  695,  696,  697,  698,  190,  699,    0,  192,  193,  194,
  700,  701,    0,  702,  703,  704,    0,  197,  198,  705,
  199,    0,    0,  200,  201,  202,  203,  204,  205,  206,
    0,    0,    0,    0,  207,  706,  209,    0,  707,  211,
  212,    0,  213,    0,  708,  709,  710,    0,  711,  712,
    0,  713,  214,  215,  216,  217,  218,  219,  714,  221,
  715,  223,  716,  717,  718,  719,  720,  721,  722,  723,
  724,  725,  726,    0,  727,  728,  729,  730,  731,  732,
    0,  733,  734,  735,  244,    0,  736,    0,  737,  738,
  739,  740,  741,  251,  252,  742,  254,  743,  744,  745,
  258,  746,  260,  747,  262,  748,    0,  749,  750,  751,
  752,    0,  753,  754,  755,  271,  756,    0,  757,  758,
  275,  759,  277,  278,  760,  280,  281,  282,  283,  284,
  285,    0,  761,    0,  287,  288,  289,  290,  291,    0,
  762,  763,  764,  765,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  115,    0,
  116, 1706,    0,    0, 1692,    0,  118,    0,  667,  119,
  120,    0,    0,    0,    0,  668,    0,    0,    0,    0,
    0,  121,  122,    0,  123,    0,  124,  669,    0,  125,
    0,    0,  126,  670,  671,    0,    0,    0,    0,  128,
    0,  129,  130,    0,    0,    0,  131,    0,    0,  132,
    0,    0,  134,    0,    0,    0,    0,    0,    0,    0,
  672,    0,  135,  673,    0,    0,    0,    0,  137,    0,
  138,    0,  139,    0,    0,    0,    0,    0,  141,    0,
  142,    0,    0,    0,  143,    0,    0,    0,  674,    0,
  675,  676,  144,    0,  677,    0,  145,    0,    0,  146,
  678,    0,    0,  679,  147,  148,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  149,    0,    0,
    0,  150,  151,  152,  153,  154,    0,  155,    0,  680,
    0,    0,    0,  156,    0,  157,  158,    0,    0,  160,
  161,    0,    0,    0,  681,    0,    0,  162,    0,    0,
  164,  165,  166,  167,    0,  168, 1693,  169,  682,  170,
  171,  172,  173,  174,  683,    0,    0,    0,  175,    0,
  176,    0,    0,    0,  684,    0,    0, 1089,    0,    0,
  766,  178,  767,    0,    0,    0,  179,  180,  685,  686,
  687,  688,  427,  428,  182,  769,  183,  184,  185,  186,
  770,  187,  689,    0,    0,    0,    0,    0,    0,  188,
  189,  690,  691,  692,  693,  694,  695,  696,  697,  698,
  190,  699,    0,  192,  193,  194,  700,  701,    0,  702,
  703,  704,    0,  197,  198,  705,  199,    0,    0,  200,
  201,  202,  203,  204,  205,  206,    0,    0,    0,    0,
  207,  706,  209,    0,  707,  211,  212,    0,  213,    0,
  708,  709,  710,    0,  711,  712,    0,  713,  214,  215,
  216,  217,  218,  219,  714,  221,  715,  223,  716,  717,
  718,  719,  720,  721,  722,  723,  724,  725,  726,    0,
  727,  728,  729,  730,  731,  732,    0,  733,  734,  735,
  244,    0,  736,    0,  737,  738,  739,  740,  741,  251,
  252,  742,  254,  743,  744,  745,  258,  746,  260,  747,
  262,  748,    0,  749,  750,  751,  752,    0,  753,  754,
  755,  271,  756,    0,  757,  758,  275,  759,  277,  278,
  760,  280,  281,  282,  283,  284,  285,    0,  761,    0,
  287,  288,  289,  290,  291,    0,  762,  763,  764,  765,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  115,    0,  116, 1715,    0,    0,
 1692,    0,  118,    0,  667,  119,  120,    0,    0,    0,
    0,  668,    0,    0,    0,    0,    0,  121,  122,    0,
  123,    0,  124,  669,    0,  125,    0,    0,  126,  670,
  671,    0,    0,    0,    0,  128,    0,  129,  130,    0,
    0,    0,  131,    0,    0,  132,    0,    0,  134,    0,
    0,    0,    0,    0,    0,    0,  672,    0,  135,  673,
    0,    0,    0,    0,  137,    0,  138,    0,  139,    0,
    0,    0,    0,    0,  141,    0,  142,    0,    0,    0,
  143,    0,    0,    0,  674,    0,  675,  676,  144,    0,
  677,    0,  145,    0,    0,  146,  678,    0,    0,  679,
  147,  148,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  149,    0,    0,    0,  150,  151,  152,
  153,  154,    0,  155,    0,  680,    0,    0,    0,  156,
    0,  157,  158,    0,    0,  160,  161,    0,    0,    0,
  681,    0,    0,  162,    0,    0,  164,  165,  166,  167,
    0,  168, 1693,  169,  682,  170,  171,  172,  173,  174,
  683,    0,    0,    0,  175,    0,  176,    0,    0,    0,
  684,    0,    0, 1089,    0,    0,  766,  178,  767,    0,
    0,    0,  179,  180,  685,  686,  687,  688,  427,  428,
  182,  769,  183,  184,  185,  186,  770,  187,  689,    0,
    0,    0,    0,    0,    0,  188,  189,  690,  691,  692,
  693,  694,  695,  696,  697,  698,  190,  699,    0,  192,
  193,  194,  700,  701,    0,  702,  703,  704,    0,  197,
  198,  705,  199,    0,    0,  200,  201,  202,  203,  204,
  205,  206,    0,    0,    0,    0,  207,  706,  209,    0,
  707,  211,  212,    0,  213,    0,  708,  709,  710,    0,
  711,  712,    0,  713,  214,  215,  216,  217,  218,  219,
  714,  221,  715,  223,  716,  717,  718,  719,  720,  721,
  722,  723,  724,  725,  726,    0,  727,  728,  729,  730,
  731,  732,    0,  733,  734,  735,  244,    0,  736,    0,
  737,  738,  739,  740,  741,  251,  252,  742,  254,  743,
  744,  745,  258,  746,  260,  747,  262,  748,    0,  749,
  750,  751,  752,    0,  753,  754,  755,  271,  756,    0,
  757,  758,  275,  759,  277,  278,  760,  280,  281,  282,
  283,  284,  285,    0,  761,    0,  287,  288,  289,  290,
  291,    0,  762,  763,  764,  765,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  115,    0,  116, 1718,    0,    0, 1692,    0,  118,    0,
  667,  119,  120,    0,    0,    0,    0,  668,    0,    0,
    0,    0,    0,  121,  122,    0,  123,    0,  124,  669,
    0,  125,    0,    0,  126,  670,  671,    0,    0,    0,
    0,  128,    0,  129,  130,    0,    0,    0,  131,    0,
    0,  132,    0,    0,  134,    0,    0,    0,    0,    0,
    0,    0,  672,    0,  135,  673,    0,    0,    0,    0,
  137,    0,  138,    0,  139,    0,    0,    0,    0,    0,
  141,    0,  142,    0,    0,    0,  143,    0,    0,    0,
  674,    0,  675,  676,  144,    0,  677,    0,  145,    0,
    0,  146,  678,    0,    0,  679,  147,  148,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  149,
    0,    0,    0,  150,  151,  152,  153,  154,    0,  155,
    0,  680,    0,    0,    0,  156,    0,  157,  158,    0,
    0,  160,  161,    0,    0,    0,  681,    0,    0,  162,
    0,    0,  164,  165,  166,  167,    0,  168, 1693,  169,
  682,  170,  171,  172,  173,  174,  683,    0,    0,    0,
  175,    0,  176,    0,    0,    0,  684,    0,    0, 1089,
    0,    0,  766,  178,  767,    0,    0,    0,  179,  180,
  685,  686,  687,  688,  427,  428,  182,  769,  183,  184,
  185,  186,  770,  187,  689,    0,    0,    0,    0,    0,
    0,  188,  189,  690,  691,  692,  693,  694,  695,  696,
  697,  698,  190,  699,    0,  192,  193,  194,  700,  701,
    0,  702,  703,  704,    0,  197,  198,  705,  199,    0,
    0,  200,  201,  202,  203,  204,  205,  206,    0,    0,
    0,    0,  207,  706,  209,    0,  707,  211,  212,    0,
  213,    0,  708,  709,  710,    0,  711,  712,    0,  713,
  214,  215,  216,  217,  218,  219,  714,  221,  715,  223,
  716,  717,  718,  719,  720,  721,  722,  723,  724,  725,
  726,    0,  727,  728,  729,  730,  731,  732,    0,  733,
  734,  735,  244,    0,  736,    0,  737,  738,  739,  740,
  741,  251,  252,  742,  254,  743,  744,  745,  258,  746,
  260,  747,  262,  748,    0,  749,  750,  751,  752,    0,
  753,  754,  755,  271,  756,    0,  757,  758,  275,  759,
  277,  278,  760,  280,  281,  282,  283,  284,  285,    0,
  761,    0,  287,  288,  289,  290,  291,    0,  762,  763,
  764,  765,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  115,    0,  116, 1724,
    0,    0, 1692,    0,  118,    0,  667,  119,  120,    0,
    0,    0,    0,  668,    0,    0,    0,    0,    0,  121,
  122,    0,  123,    0,  124,  669,    0,  125,    0,    0,
  126,  670,  671,    0,    0,    0,    0,  128,    0,  129,
  130,    0,    0,    0,  131,    0,    0,  132,    0,    0,
  134,    0,    0,    0,    0,    0,    0,    0,  672,    0,
  135,  673,    0,    0,    0,    0,  137,    0,  138,    0,
  139,    0,    0,    0,    0,    0,  141,    0,  142,    0,
    0,    0,  143,    0,    0,    0,  674,    0,  675,  676,
  144,    0,  677,    0,  145,    0,    0,  146,  678,    0,
    0,  679,  147,  148,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  149,    0,    0,    0,  150,
  151,  152,  153,  154,    0,  155,    0,  680,    0,    0,
    0,  156,    0,  157,  158,    0,    0,  160,  161,    0,
    0,    0,  681,    0,    0,  162,    0,    0,  164,  165,
  166,  167,    0,  168, 1693,  169,  682,  170,  171,  172,
  173,  174,  683,    0,    0,    0,  175,    0,  176,    0,
    0,    0,  684,    0,    0, 1089,    0,    0,  766,  178,
  767,    0,    0,    0,  179,  180,  685,  686,  687,  688,
  427,  428,  182,  769,  183,  184,  185,  186,  770,  187,
  689,    0,    0,    0,    0,    0,    0,  188,  189,  690,
  691,  692,  693,  694,  695,  696,  697,  698,  190,  699,
    0,  192,  193,  194,  700,  701,    0,  702,  703,  704,
    0,  197,  198,  705,  199,    0,    0,  200,  201,  202,
  203,  204,  205,  206,    0,    0,    0,    0,  207,  706,
  209,    0,  707,  211,  212,    0,  213,    0,  708,  709,
  710,    0,  711,  712,    0,  713,  214,  215,  216,  217,
  218,  219,  714,  221,  715,  223,  716,  717,  718,  719,
  720,  721,  722,  723,  724,  725,  726,    0,  727,  728,
  729,  730,  731,  732,    0,  733,  734,  735,  244,    0,
  736,    0,  737,  738,  739,  740,  741,  251,  252,  742,
  254,  743,  744,  745,  258,  746,  260,  747,  262,  748,
    0,  749,  750,  751,  752,    0,  753,  754,  755,  271,
  756,    0,  757,  758,  275,  759,  277,  278,  760,  280,
  281,  282,  283,  284,  285,    0,  761,    0,  287,  288,
  289,  290,  291,    0,  762,  763,  764,  765,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  115,    0,  116, 1727,    0,    0, 1692,    0,
  118,    0,  667,  119,  120,    0,    0,    0,    0,  668,
    0,    0,    0,    0,    0,  121,  122,    0,  123,    0,
  124,  669,    0,  125,    0,    0,  126,  670,  671,    0,
    0,    0,    0,  128,    0,  129,  130,    0,    0,    0,
  131,    0,    0,  132,    0,    0,  134,    0,    0,    0,
    0,    0,    0,    0,  672,    0,  135,  673,    0,    0,
    0,    0,  137,    0,  138,    0,  139,    0,    0,    0,
    0,    0,  141,    0,  142,    0,    0,    0,  143,    0,
    0,    0,  674,    0,  675,  676,  144,    0,  677,    0,
  145,    0,    0,  146,  678,    0,    0,  679,  147,  148,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  149,    0,    0,    0,  150,  151,  152,  153,  154,
    0,  155,    0,  680,    0,    0,    0,  156,    0,  157,
  158,    0,    0,  160,  161,    0,    0,    0,  681,    0,
    0,  162,    0,    0,  164,  165,  166,  167,    0,  168,
 1693,  169,  682,  170,  171,  172,  173,  174,  683,    0,
    0,    0,  175,    0,  176,    0,    0,    0,  684,    0,
    0, 1089,    0,    0,  766,  178,  767,    0,    0,    0,
  179,  180,  685,  686,  687,  688,  427,  428,  182,  769,
  183,  184,  185,  186,  770,  187,  689,    0,    0,    0,
    0,    0,    0,  188,  189,  690,  691,  692,  693,  694,
  695,  696,  697,  698,  190,  699,    0,  192,  193,  194,
  700,  701,    0,  702,  703,  704,    0,  197,  198,  705,
  199,    0,    0,  200,  201,  202,  203,  204,  205,  206,
    0,    0,    0,    0,  207,  706,  209,    0,  707,  211,
  212,    0,  213,    0,  708,  709,  710,    0,  711,  712,
    0,  713,  214,  215,  216,  217,  218,  219,  714,  221,
  715,  223,  716,  717,  718,  719,  720,  721,  722,  723,
  724,  725,  726,    0,  727,  728,  729,  730,  731,  732,
    0,  733,  734,  735,  244,    0,  736,    0,  737,  738,
  739,  740,  741,  251,  252,  742,  254,  743,  744,  745,
  258,  746,  260,  747,  262,  748,    0,  749,  750,  751,
  752,    0,  753,  754,  755,  271,  756,    0,  757,  758,
  275,  759,  277,  278,  760,  280,  281,  282,  283,  284,
  285,    0,  761,    0,  287,  288,  289,  290,  291,    0,
  762,  763,  764,  765,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  115,    0,
  116, 1730,    0,    0, 1692,    0,  118,    0,  667,  119,
  120,    0,    0,    0,    0,  668,    0,    0,    0,    0,
    0,  121,  122,    0,  123,    0,  124,  669,    0,  125,
    0,    0,  126,  670,  671,    0,    0,    0,    0,  128,
    0,  129,  130,    0,    0,    0,  131,    0,    0,  132,
    0,    0,  134,    0,    0,    0,    0,    0,    0,    0,
  672,    0,  135,  673,    0,    0,    0,    0,  137,    0,
  138,    0,  139,    0,    0,    0,    0,    0,  141,    0,
  142,    0,    0,    0,  143,    0,    0,    0,  674,    0,
  675,  676,  144,    0,  677,    0,  145,    0,    0,  146,
  678,    0,    0,  679,  147,  148,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  149,    0,    0,
    0,  150,  151,  152,  153,  154,    0,  155,    0,  680,
    0,    0,    0,  156,    0,  157,  158,    0,    0,  160,
  161,    0,    0,    0,  681,    0,    0,  162,    0,    0,
  164,  165,  166,  167,    0,  168, 1693,  169,  682,  170,
  171,  172,  173,  174,  683,    0,    0,    0,  175,    0,
  176,    0,    0,    0,  684,    0,    0, 1052,    0,    0,
  766,  178,  767,    0,    0,    0,  179,  180,  685,  686,
  687,  688,  427,  428,  182,  769,  183,  184,  185,  186,
  770,  187,  689,    0,    0,    0,    0,    0,    0,  188,
  189,  690,  691,  692,  693,  694,  695,  696,  697,  698,
  190,  699,    0,  192,  193,  194,  700,  701,    0,  702,
  703,  704,    0,  197,  198,  705,  199,    0,    0,  200,
  201,  202,  203,  204,  205,  206,    0,    0,    0,    0,
  207,  706,  209,    0,  707,  211,  212,    0,  213,    0,
  708,  709,  710,    0,  711,  712,    0,  713,  214,  215,
  216,  217,  218,  219,  714,  221,  715,  223,  716,  717,
  718,  719,  720,  721,  722,  723,  724,  725,  726,    0,
  727,  728,  729,  730,  731,  732,    0,  733,  734,  735,
  244,    0,  736,    0,  737,  738,  739,  740,  741,  251,
  252,  742,  254,  743,  744,  745,  258,  746,  260,  747,
  262,  748,    0,  749,  750,  751,  752,    0,  753,  754,
  755,  271,  756,    0,  757,  758,  275,  759,  277,  278,
  760,  280,  281,  282,  283,  284,  285,    0,  761,    0,
  287,  288,  289,  290,  291,    0,  762,  763,  764,  765,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  115,    0,  116,    0,    0,    0,
    0,    0,  118,    0,  667,  119,  120,    0,    0,    0,
    0,  668,    0,    0,    0,    0,    0,  121,  122,    0,
  123,    0,  124,  669,    0,  125,    0,    0,  126,  670,
  671,    0,    0,    0,    0,  128,    0,  129,  130,    0,
    0,    0,  131,    0,    0,  132,    0, 1046,  134,    0,
    0,    0,    0,    0,    0,    0,  672,    0,  135,  673,
    0,    0,    0,    0,  137,    0,  138,    0,  139,    0,
    0,    0,    0,    0,  141,    0,  142,    0,    0,    0,
  143,    0,    0,    0,  674,    0,  675,  676,  144,    0,
  677,    0,  145,    0,    0,  146,  678,    0,    0,  679,
  147,  148,    0,    0,    0,    0,    0, 1047,    0,    0,
    0,    0,    0,  149,    0,    0,    0,  150,  151,  152,
  153,  154,    0,  155,    0,  680,    0,    0,    0,  156,
    0,  157,  158,    0,    0,  160,  161,    0,    0,    0,
  681,    0,    0,  162,    0,    0,  164,  165, 1048,  167,
    0,  168,    0,  169,  682,  170,  171,  172,  173,  174,
  683,    0,    0,    0,  175,    0,  176,    0,    0,    0,
  684,    0,    0,  819,    0,  819,  819,  178,  819,    0,
    0,    0,  179,  180,  685,  686,  687,  688,  427,  428,
  182,  819,  183,  184,  185,  186,  819,  187,  689,    0,
    0,    0,    0,    0,    0,  188,  189,  690,  691,  692,
  693,  694,  695,  696,  697,  698,  190,  699,    0,  192,
  193,  194,  700,  701,    0,  702,  703,  704,    0,  197,
  198,  705,  199,    0,    0,  200,  201, 1049, 1050, 1051,
  205,  206,    0,    0,    0,    0,  207,  706,  209,    0,
  707,  211,  212,    0,  213,    0,  708,  709,  710,    0,
  711,  712,    0,  713,  214,  215,  216,  217,  218,  219,
  714,  221,  715,  223,  716,  717,  718,  719,  720,  721,
  722,  723,  724,  725,  726,    0,  727,  728,  729,  730,
  731,  732,    0,  733,  734,  735,  244,    0,  736,    0,
  737,  738,  739,  740,  741,  251,  252,  742,  254,  743,
  744,  745,  258,  746,  260,  747,  262,  748,    0,  749,
  750,  751,  752,    0,  753,  754,  755,  271,  756,    0,
  757,  758,  275,  759,  277,  278,  760,  280,  281,  282,
  283,  284,  285,    0,  761,    0,  287,  288,  289,  290,
  291,    0,  762,  763,  764,  765,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  819,    0,  819,  819,    0,    0,    0,    0,  819,    0,
  819,  819,  819,    0,    0,    0,    0,  819,    0,    0,
    0,    0,    0,  819,  819,    0,  819,    0,  819,  819,
    0,  819,    0,    0,  819,  819,  819,    0,    0,    0,
    0,  819,  819,  819,  819,    0,    0,    0,  819,    0,
    0,  819,    0,    0,  819,    0,    0,    0,    0,    0,
    0,    0,  819,    0,  819,  819,    0,    0,    0,    0,
  819,    0,  819,    0,  819,    0,    0,    0,    0,    0,
  819,    0,  819,    0,    0,    0,  819,    0,    0,    0,
  819,    0,  819,  819,  819,    0,  819,    0,  819,    0,
    0,  819,  819,    0,    0,  819,  819,  819,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  819,
    0,    0,    0,  819,  819,  819,  819,  819,    0,  819,
    0,  819,    0,    0,    0,  819,    0,  819,  819,    0,
    0,  819,  819,    0,    0,    0,  819,    0,    0,  819,
    0,    0,  819,  819,  819,  819,    0,  819,    0,  819,
  819,  819,  819,  819,  819,  819,  819,    0,    0,    0,
  819,    0,  819,    0,    0,    0,  819,    0,    0, 1089,
    0,    0,  766,  819,  767,    0,    0,    0,  819,  819,
  819,  819,  819,  819,  819,  819,  819,  769,  819,  819,
  819,  819,  770,  819,  819,    0,    0,    0,    0,    0,
    0,  819,  819,  819,  819,  819,  819,  819,  819,  819,
  819,  819,  819,  819,    0,  819,  819,    0,  819,  819,
    0,  819,  819,  819,    0,  819,  819,  819,  819,    0,
    0,  819,  819,  819,  819,  819,  819,  819,    0,    0,
    0,    0,  819,  819,  819,    0,  819,  819,  819,    0,
  819,    0,  819,  819,  819,    0,  819,  819,    0,  819,
  819,  819,  819,  819,  819,  819,  819,  819,  819,  819,
  819,  819,  819,  819,  819,  819,  819,  819,  819,  819,
  819,    0,  819,  819,  819,  819,  819,  819,    0,  819,
  819,  819,  819,    0,  819,    0,  819,  819,  819,  819,
  819,  819,  819,  819,  819,  819,  819,  819,  819,  819,
  819,  819,  819,  819,    0,  819,  819,  819,  819,    0,
  819,  819,  819,  819,  819,    0,  819,  819,  819,  819,
  819,  819,  819,  819,  819,  819,  819,  819,  819,    0,
  819,    0,  819,  819,  819,  819,  819,    0,  819,  819,
  819,  819,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  115,    0,  116,    0,
    0,    0,    0,    0,  118,    0,  667,  119,  120,    0,
    0,    0,    0,  668,    0,    0,    0,    0,    0,  121,
  122,    0,  123,    0,  124,  669,    0,  125,    0,    0,
  126,  670,  671,    0,    0,    0,    0,  128,    0,  129,
  130,    0,    0,    0,  131,    0,    0,  132,    0,    0,
  134,    0,    0,    0,    0,    0,    0,    0,  672,    0,
  135,  673,    0,    0,    0,    0,  137,    0,  138,    0,
  139,    0,    0,    0,    0,    0,  141,    0,  142,    0,
    0,    0,  143,    0,    0, 1036,  674,    0,  675,  676,
  144,    0,  677,    0,  145,    0,    0,  146,  678,    0,
    0,  679,  147,  148,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  149,    0,    0,    0,  150,
  151,  152,  153,  154,    0,  155, 1036,  680,    0, 1036,
    0,  156,    0,  157,  158,    0,    0,  160,  161,    0,
    0,    0,  681,    0, 1036,  162,    0,    0,  164,  165,
  166,  167,    0,  168,    0,  169,  682,  170,  171,  172,
  173,  174,  683,    0,    0,    0,  175,    0,  176,    0,
    0,    0,  684,    0,    0,    0,    0,    0,    0,  178,
 1088,    0,    0,    0,  179,  180,  685,  686,  687,  688,
  427,  428,  182,    0,  183,  184,  185,  186,    0,  187,
  689,    0,    0,    0,    0,    0,    0,  188,  189,  690,
  691,  692,  693,  694,  695,  696,  697,  698,  190,  699,
    0,  192,  193,  194,  700,  701,    0,  702,  703,  704,
    0,  197,  198,  705,  199,    0,    0,  200,  201,  202,
  203,  204,  205,  206,    0,    0,    0,    0,  207,  706,
  209,    0,  707,  211,  212,    0,  213,    0,  708,  709,
  710,    0,  711,  712,    0,  713,  214,  215,  216,  217,
  218,  219,  714,  221,  715,  223,  716,  717,  718,  719,
  720,  721,  722,  723,  724,  725,  726,    0,  727,  728,
  729,  730,  731,  732,    0,  733,  734,  735,  244,    0,
  736,    0,  737,  738,  739,  740,  741,  251,  252,  742,
  254,  743,  744,  745,  258,  746,  260,  747,  262,  748,
    0,  749,  750,  751,  752,    0,  753,  754,  755,  271,
  756,    0,  757,  758,  275,  759,  277,  278,  760,  280,
  281,  282,  283,  284,  285,    0,  761, 1036,  287,  288,
  289,  290,  291,    0,  762,  763,  764,  765, 1089,    0,
    0,  766,    0,  767,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  769,    0,    0,    0,
    0,  770,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1036,
    0,    0, 1036,    0,    0,    0,    0,    0,    0, 1036,
    0, 1036,    0,    0,    0, 1036,    0,    0,    0,    0,
 1036,    0,    0, 1036,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1036,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1036,    0,    0,    0,    0,    0,    0,    0, 1036,
    0,    0, 1036, 1036,    0,    0,    0,    0,    0,    0,
    0,    0, 1036,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1036,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1036,    0,    0,    0,    0, 1036,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1036, 1036,    0, 1036,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  115, 1036,  116,    0,    0,
    0,    0,    0,  118,    0,  667,  119,  120,    0,    0,
    0,    0,  668, 1036,    0,    0,    0, 1036,  121,  122,
    0,  123,    0,  124,  669,    0,  125,    0,    0,  126,
  670,  671, 1036,    0,    0,    0,  128,    0,  129,  130,
    0,    0,    0,  131,    0,    0,  132,    0,    0,  134,
    0,    0,    0,    0,    0,    0,    0,  672,    0,  135,
  673,    0,    0,    0,    0,  137,    0,  138,    0,  139,
    0,    0,    0,    0,    0,  141,    0,  142,    0,    0,
    0,  143,    0,    0,    0,  674,    0,  675,  676,  144,
    0,  677,    0,  145,    0,    0,  146,  678,    0,    0,
  679,  147,  148,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  149,    0,    0,    0,  150,  151,
  152,  153,  154,    0,  155,    0,  680,    0,    0,    0,
  156,    0,  157,  158,    0,    0,  160,  161,    0,    0,
    0,  681,    0,    0,  162,    0,    0,  164,  165,  166,
  167,    0,  168,    0,  169,  682,  170,  171,  172,  173,
  174,  683,    0,    0,    0,  175,    0,  176,    0,    0,
    0,  684,    0,    0, 1089,    0, 1217,  766,  178,  767,
    0,    0,   16,  179,  180,  685,  686,  687,  688,  427,
  428,  182,  769,  183,  184,  185,  186,  770,  187,  689,
    0,    0,    0,    0,    0,    0,  188,  189,  690,  691,
  692,  693,  694,  695,  696,  697,  698,  190,  699,    0,
  192,  193,  194,  700,  701,    0,  702,  703,  704,    0,
  197,  198,  705,  199,    0,    0,  200,  201,  202,  203,
  204,  205,  206,    0,    0,    0,    0,  207,  706,  209,
    0,  707,  211,  212,    0,  213,    0,  708,  709,  710,
    0,  711,  712,    0,  713,  214,  215,  216,  217,  218,
  219,  714,  221,  715,  223,  716,  717,  718,  719,  720,
  721,  722,  723,  724,  725,  726,    0,  727,  728,  729,
  730,  731,  732,    0,  733,  734,  735,  244,    0,  736,
    0,  737,  738,  739,  740,  741,  251,  252,  742,  254,
  743,  744,  745,  258,  746,  260,  747,  262,  748,    0,
  749,  750,  751,  752,    0,  753,  754,  755,  271,  756,
    0,  757,  758,  275,  759,  277,  278,  760,  280,  281,
  282,  283,  284,  285,    0,  761,    0,  287,  288,  289,
  290,  291,    0,  762,  763,  764,  765,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  115,    0,  116,    0,    0,    0,    0,    0,  118,
    0,  667,  119,  120,    0,    0,    0,    0,  668,    0,
    0,    0,    0,    0,  121,  122,    0,  123,    0,  124,
  669,    0,  125,    0,    0,  126,  670,  671,    0,    0,
    0,    0,  128,    0,  129,  130,    0,    0,    0,  131,
    0,    0,  132,    0,    0,  134,    0,    0,    0,    0,
    0,    0,    0,  672,    0,  135,  673,    0,    0,    0,
    0,  137,    0,  138,    0,  139,    0,    0,    0,    0,
    0,  141,    0,  142,    0,    0,    0,  143,    0,    0,
    0,  674,    0,  675,  676,  144,    0,  677,    0,  145,
    0,    0,  146,  678,    0,    0,  679,  147,  148,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  149,    0,    0,    0,  150,  151,  152,  153,  154,    0,
  155,    0,  680,    0,    0,    0,  156,    0,  157,  158,
    0,    0,  160,  161,    0,    0,    0,  681,    0,    0,
  162,    0,    0,  164,  165,  166,  167,    0,  168,    0,
  169,  682,  170,  171,  172,  173,  174,  683,    0,    0,
    0,  175,    0,  176,    0,    0,    0,  684,    0,    0,
 1089, 1467,    0,  766,  178,  767,    0,    0,    0,  179,
  180,  685,  686,  687,  688,  427,  428,  182,  769,  183,
  184,  185,  186,  770,  187,  689,    0,    0,    0,    0,
    0,    0,  188,  189,  690,  691,  692,  693,  694,  695,
  696,  697,  698,  190,  699,    0,  192,  193,  194,  700,
  701,    0,  702,  703,  704,    0,  197,  198,  705,  199,
    0,    0,  200,  201,  202,  203,  204,  205,  206,    0,
    0,    0,    0,  207,  706,  209,    0,  707,  211,  212,
    0,  213,    0,  708,  709,  710,    0,  711,  712,    0,
  713,  214,  215,  216,  217,  218,  219,  714,  221,  715,
  223,  716,  717,  718,  719,  720,  721,  722,  723,  724,
  725,  726,    0,  727,  728,  729,  730,  731,  732,    0,
  733,  734,  735,  244,    0,  736,    0,  737,  738,  739,
  740,  741,  251,  252,  742,  254,  743,  744,  745,  258,
  746,  260,  747,  262,  748,    0,  749,  750,  751,  752,
    0,  753,  754,  755,  271,  756,    0,  757,  758,  275,
  759,  277,  278,  760,  280,  281,  282,  283,  284,  285,
    0,  761,    0,  287,  288,  289,  290,  291,    0,  762,
  763,  764,  765,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  115,    0,  116,
    0,    0,    0,    0,    0,  118,    0,  667,  119,  120,
    0,    0,    0,    0,  668,    0,    0,    0,    0,    0,
  121,  122,    0,  123,    0,  124,  669,    0,  125,    0,
    0,  126,  670,  671,    0,    0,    0,    0,  128,    0,
  129,  130,    0,    0,    0,  131,    0,    0,  132,    0,
    0,  134,    0,    0,    0,    0,    0,    0,    0,  672,
    0,  135,  673,    0,    0,    0,    0,  137,    0,  138,
    0,  139,    0,    0,    0,    0,    0,  141,    0,  142,
    0,    0,    0,  143,    0,    0,    0,  674,    0,  675,
  676,  144,    0,  677,    0,  145,    0,    0,  146,  678,
    0,    0,  679,  147,  148,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  149,    0,    0,    0,
  150,  151,  152,  153,  154,    0,  155,    0,  680,    0,
    0,    0,  156,    0,  157,  158,    0,    0,  160,  161,
    0,    0,    0,  681,    0,    0,  162,    0,    0,  164,
  165,  166,  167,    0,  168,    0,  169,  682,  170,  171,
  172,  173,  174,  683,    0,    0,    0,  175,    0,  176,
    0,    0,    0,  684,    0,    0, 1089,    0,    0,  766,
  178,  767,    0,    0,    0,  179,  180,  685,  686,  687,
  688,  427,  428,  182,  769,  183,  184,  185,  186,  770,
  187,  689,    0,    0,    0,    0,    0,    0,  188,  189,
  690,  691,  692,  693,  694,  695,  696,  697,  698,  190,
  699,    0,  192,  193,  194,  700,  701,    0,  702,  703,
  704,    0,  197,  198,  705,  199,    0,    0,  200,  201,
  202,  203,  204,  205,  206,    0,    0,    0,    0,  207,
  706,  209,    0,  707,  211,  212,    0,  213,    0,  708,
  709,  710,    0,  711,  712,    0,  713,  214,  215,  216,
  217,  218,  219,  714,  221,  715,  223,  716,  717,  718,
  719,  720,  721,  722,  723,  724,  725,  726,    0,  727,
  728,  729,  730,  731,  732,    0,  733,  734,  735,  244,
    0,  736,    0,  737,  738,  739,  740,  741,  251,  252,
  742,  254,  743,  744,  745,  258,  746,  260,  747,  262,
  748,    0,  749,  750,  751,  752,    0,  753,  754,  755,
  271,  756,    0,  757,  758,  275,  759,  277,  278,  760,
  280,  281,  282,  283,  284,  285,    0,  761,    0,  287,
  288,  289,  290,  291,    0,  762,  763,  764,  765,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  115,    0,  116,    0,    0,    0,    0,
    0,  118,    0,  667,  119,  120,    0,    0,    0,    0,
  668,    0,    0,    0,    0,    0,  121,  122,    0,  123,
    0,  124,  669,    0,  125,    0,    0,  126,  670,  671,
    0,    0,    0,    0,  128,    0,  129,  130,    0,    0,
    0,  131,    0,    0,  132,    0,    0,  134,    0,    0,
    0,    0,    0,    0,    0,  672,    0,  135,  673,    0,
    0,    0,    0,  137,    0,  138,    0,  139,    0,    0,
    0,    0,    0,  141,    0,  142,    0,    0,    0,  143,
    0,    0,    0,  674,    0,  675,  676,  144,    0,  677,
    0,  145,    0,    0,  146,  678,    0,    0,  679,  147,
  148,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  149,    0,    0,    0,  150,  151,  152,  153,
  154,    0,  155,    0,  680,    0,    0,    0,  156,    0,
  157,  158,    0,    0,  160,  161,    0,    0,    0,  681,
    0,    0,  162,    0,    0,  164,  165,  166,  167,    0,
  168,    0,  169,  682,  170,  171,  172,  173,  174,  683,
    0,    0,    0,  175,    0,  176,    0,    0,    0,  684,
    0,    0, 1089,    0,    0,  766,  178,  767,    0,    0,
 1721,  179,  180,  685,  686,  687,  688,  427,  428,  182,
  769,  183,  184,  185,  186,  770,  187,  689,    0,    0,
    0,    0,    0,    0,  188,  189,  690,  691,  692,  693,
  694,  695,  696,  697,  698,  190,  699,    0,  192,  193,
  194,  700,  701,    0,  702,  703,  704,    0,  197,  198,
  705,  199,    0,    0,  200,  201,  202,  203,  204,  205,
  206,    0,    0,    0,    0,  207,  706,  209,    0,  707,
  211,  212,    0,  213,    0,  708,  709,  710,    0,  711,
  712,    0,  713,  214,  215,  216,  217,  218,  219,  714,
  221,  715,  223,  716,  717,  718,  719,  720,  721,  722,
  723,  724,  725,  726,    0,  727,  728,  729,  730,  731,
  732,    0,  733,  734,  735,  244,    0,  736,    0,  737,
  738,  739,  740,  741,  251,  252,  742,  254,  743,  744,
  745,  258,  746,  260,  747,  262,  748,    0,  749,  750,
  751,  752,    0,  753,  754,  755,  271,  756,    0,  757,
  758,  275,  759,  277,  278,  760,  280,  281,  282,  283,
  284,  285,    0,  761,    0,  287,  288,  289,  290,  291,
    0,  762,  763,  764,  765,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  115,
    0,  116,    0,    0,    0,    0,    0,  118,    0,  667,
  119,  120,    0,    0,    0,    0,  668,    0,    0,    0,
    0,    0,  121,  122,    0,  123,    0,  124,  669,    0,
  125,    0,    0,  126,  670,  671,    0,    0,    0,    0,
  128,    0,  129,  130,    0,    0,    0,  131,    0,    0,
  132,    0,    0,  134,    0,    0,    0,    0, 1776,    0,
    0,  672,    0,  135,  673,    0,    0,    0,    0,  137,
    0,  138,    0,  139,    0,    0,    0,    0,    0,  141,
    0,  142,    0,    0,    0,  143,    0,    0,    0,  674,
    0,  675,  676,  144,    0,  677,    0,  145,    0,    0,
  146,  678,    0,    0,  679,  147,  148,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  149,    0,
    0,    0,  150,  151,  152,  153,  154,    0,  155,    0,
  680,    0,    0,    0,  156,    0,  157,  158,    0,    0,
  160,  161,    0,    0,    0,  681,    0,    0,  162,    0,
    0,  164,  165,  166,  167,    0,  168,    0,  169,  682,
  170,  171,  172,  173,  174,  683,    0,    0,    0,  175,
    0,  176,    0,    0,    0,  684,    0,    0, 1089,    0,
    0,  766,  178,  767,    0,    0,    0,  179,  180,  685,
  686,  687,  688,  427,  428,  182,  769,  183,  184,  185,
  186,  770,  187,  689,    0,    0,    0,    0,    0,    0,
  188,  189,  690,  691,  692,  693,  694,  695,  696,  697,
  698,  190,  699,    0,  192,  193,  194,  700,  701,    0,
  702,  703,  704,    0,  197,  198,  705,  199,    0,    0,
  200,  201,  202,  203,  204,  205,  206,    0,    0,    0,
    0,  207,  706,  209,    0,  707,  211,  212,    0,  213,
    0,  708,  709,  710,    0,  711,  712,    0,  713,  214,
  215,  216,  217,  218,  219,  714,  221,  715,  223,  716,
  717,  718,  719,  720,  721,  722,  723,  724,  725,  726,
    0,  727,  728,  729,  730,  731,  732,    0,  733,  734,
  735,  244,    0,  736,    0,  737,  738,  739,  740,  741,
  251,  252,  742,  254,  743,  744,  745,  258,  746,  260,
  747,  262,  748,    0,  749,  750,  751,  752,    0,  753,
  754,  755,  271,  756,    0,  757,  758,  275,  759,  277,
  278,  760,  280,  281,  282,  283,  284,  285,    0,  761,
    0,  287,  288,  289,  290,  291,    0,  762,  763,  764,
  765,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  115,    0,  116,    0,    0,
    0,    0,    0,  118,    0,  667,  119,  120,    0,    0,
    0,    0,  668,    0,    0,    0,    0,    0,  121,  122,
    0,  123,    0,  124,  669,    0,  125,    0,    0,  126,
  670,  671,    0,    0,    0,    0,  128,    0,  129,  130,
    0,    0,    0,  131,    0,    0,  132,    0,    0,  134,
    0,    0,    0,    0,    0,    0,    0,  672,    0,  135,
  673,    0,    0,    0,    0,  137,    0,  138,    0,  139,
    0,    0,    0,    0,    0,  141,    0,  142,    0,    0,
    0,  143,    0,    0,    0,  674,    0,  675,  676,  144,
    0,  677,    0,  145,    0,    0,  146,  678,    0,    0,
  679,  147,  148,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  149,    0,    0,    0,  150,  151,
  152,  153,  154,    0,  155,    0,  680,    0,    0,    0,
  156,    0,  157,  158,    0,    0,  160,  161,    0,    0,
    0,  681,    0,    0,  162,    0,    0,  164,  165,  166,
  167,    0,  168,    0,  169,  682,  170,  171,  172,  173,
  174,  683,    0,    0,    0,  175,    0,  176,    0,    0,
    0,  684,    0,    0,  821,    0,  821,  821,  178,  821,
    0,    0, 1983,  179,  180,  685,  686,  687,  688,  427,
  428,  182,  821,  183,  184,  185,  186,  821,  187,  689,
    0,    0,    0,    0,    0,    0,  188,  189,  690,  691,
  692,  693,  694,  695,  696,  697,  698,  190,  699,    0,
  192,  193,  194,  700,  701,    0,  702,  703,  704,    0,
  197,  198,  705,  199,    0,    0,  200,  201,  202,  203,
  204,  205,  206,    0,    0,    0,    0,  207,  706,  209,
    0,  707,  211,  212,    0,  213,    0,  708,  709,  710,
    0,  711,  712,    0,  713,  214,  215,  216,  217,  218,
  219,  714,  221,  715,  223,  716,  717,  718,  719,  720,
  721,  722,  723,  724,  725,  726,    0,  727,  728,  729,
  730,  731,  732,    0,  733,  734,  735,  244,    0,  736,
    0,  737,  738,  739,  740,  741,  251,  252,  742,  254,
  743,  744,  745,  258,  746,  260,  747,  262,  748,    0,
  749,  750,  751,  752,    0,  753,  754,  755,  271,  756,
    0,  757,  758,  275,  759,  277,  278,  760,  280,  281,
  282,  283,  284,  285,    0,  761,    0,  287,  288,  289,
  290,  291,    0,  762,  763,  764,  765,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  821,    0,  821,  821,    0,    0,    0,    0,  821,
    0,  821,  821,  821,    0,    0,    0,    0,  821,    0,
    0,    0,    0,    0,  821,  821,    0,  821,    0,  821,
  821,    0,  821,    0,    0,  821,  821,  821,    0,    0,
    0,    0,  821,  821,  821,  821,    0,    0,    0,  821,
    0,    0,  821,    0,    0,  821,    0,    0,    0,    0,
    0,    0,    0,  821,    0,  821,  821,    0,    0,    0,
    0,  821,    0,  821,    0,  821,    0,    0,    0,    0,
    0,  821,    0,  821,    0,    0,    0,  821,    0,    0,
    0,  821,    0,  821,  821,  821,    0,  821,    0,  821,
    0,    0,  821,  821,    0,    0,  821,  821,  821,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  821,    0,    0,    0,  821,  821,  821,  821,  821,    0,
  821,    0,  821,    0,    0,    0,  821,    0,  821,  821,
    0,    0,  821,  821,    0,    0,    0,  821,    0,    0,
  821,    0,    0,  821,  821,  821,  821,    0,  821,    0,
  821,  821,  821,  821,  821,  821,  821,  821,    0,    0,
    0,  821,    0,  821,    0,    0,    0,  821,    0,    0,
 1287,    0, 1287, 1287,  821, 1287,    0,    0,    0,  821,
  821,  821,  821,  821,  821,  821,  821,  821, 1287,  821,
  821,  821,  821, 1287,  821,  821,    0,    0,    0,    0,
    0,    0,  821,  821,  821,  821,  821,  821,  821,  821,
  821,  821,  821,  821,  821,    0,  821,    0,    0,  821,
  821,    0,  821,  821,  821,    0,  821,  821,  821,  821,
    0,    0,  821,  821,  821,  821,  821,  821,  821,    0,
    0,    0,    0,  821,  821,  821,    0,  821,  821,  821,
    0,  821,    0,  821,  821,  821,    0,  821,  821,    0,
  821,  821,  821,  821,  821,  821,  821,  821,  821,  821,
  821,  821,  821,  821,  821,  821,  821,  821,  821,  821,
  821,  821,    0,  821,  821,  821,  821,  821,  821,    0,
  821,  821,  821,  821,    0,  821,    0,  821,  821,  821,
  821,  821,  821,  821,  821,  821,  821,  821,  821,  821,
  821,  821,  821,  821,  821,    0,  821,  821,  821,  821,
    0,  821,  821,  821,  821,  821,    0,  821,  821,  821,
  821,  821,  821,  821,  821,  821,  821,  821,  821,  821,
    0,  821,    0,  821,  821,  821,  821,  821,    0,  821,
  821,  821,  821,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1287,    0, 1287,
    0,    0,    0,    0,    0, 1287,    0, 1287, 1287, 1287,
    0,    0,    0,    0, 1287,    0,    0,    0,    0,    0,
 1287, 1287,    0, 1287,    0, 1287, 1287,    0, 1287,    0,
    0, 1287, 1287, 1287,    0,    0,    0,    0, 1287,    0,
 1287, 1287,    0,    0,    0, 1287,    0,    0, 1287,    0,
    0, 1287,    0,    0,    0,    0,    0,    0,    0, 1287,
    0, 1287, 1287,    0,    0,    0,    0, 1287,    0, 1287,
    0, 1287,    0,    0,    0,    0,    0, 1287,    0, 1287,
    0,    0,    0, 1287,    0,    0,    0, 1287,    0, 1287,
 1287, 1287,    0, 1287,    0, 1287,    0,    0, 1287, 1287,
    0,    0, 1287, 1287, 1287,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1287,    0,    0,    0,
 1287, 1287, 1287, 1287, 1287,    0, 1287,    0, 1287,    0,
    0,    0, 1287,    0, 1287, 1287,    0,    0, 1287, 1287,
    0,    0,    0, 1287,    0,    0, 1287,    0,    0, 1287,
 1287, 1287, 1287,    0, 1287,    0, 1287, 1287, 1287, 1287,
 1287, 1287, 1287, 1287,    0,    0,    0, 1287,    0, 1287,
    0,    0,    0, 1287,    0,    0,  768,    0,    0,  766,
 1287,  767,    0,    0,    0, 1287, 1287, 1287, 1287, 1287,
 1287, 1287, 1287, 1287,  769, 1287, 1287, 1287, 1287,  770,
 1287, 1287,    0,    0,    0,    0,    0,    0, 1287, 1287,
 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287,
 1287,    0, 1287, 1287, 1287, 1287, 1287,    0, 1287, 1287,
 1287,    0, 1287, 1287, 1287, 1287,    0,    0, 1287, 1287,
 1287, 1287, 1287, 1287, 1287,    0,    0,    0,    0, 1287,
 1287, 1287,    0, 1287, 1287, 1287,    0, 1287,    0, 1287,
 1287, 1287,    0, 1287, 1287,    0, 1287, 1287, 1287, 1287,
 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287,
 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287,    0, 1287,
 1287, 1287, 1287, 1287, 1287,    0, 1287, 1287, 1287, 1287,
    0, 1287,    0, 1287, 1287, 1287, 1287, 1287, 1287, 1287,
 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287,
 1287,    0, 1287, 1287, 1287, 1287,    0, 1287, 1287, 1287,
 1287, 1287,    0, 1287, 1287, 1287, 1287, 1287, 1287, 1287,
 1287, 1287, 1287, 1287, 1287, 1287,    0, 1287,    0, 1287,
 1287, 1287, 1287, 1287,    0, 1287, 1287, 1287, 1287,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  115,    0,  116,    0,    0,    0,    0,
    0,  118,    0,  667,  119,  120,    0,    0,    0,    0,
  668,    0,    0,    0,    0,    0,  121,  122,    0,  123,
    0,  124,  669,    0,  125,    0,    0,  126,  670,  671,
    0,    0,    0,    0,  128,    0,  129,  130,    0,    0,
    0,  131,    0,    0,  132,    0,    0,  134,    0,    0,
    0,    0,    0,    0,    0,  672,    0,  135,  673,    0,
    0,    0,    0,  137,    0,  138,    0,  139,    0,    0,
    0,    0,    0,  141,    0,  142,    0,    0,    0,  143,
    0,    0,    0,  674,    0,  675,  676,  144,    0,  677,
    0,  145,    0,    0,  146,  678,    0,    0,  679,  147,
  148,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  149,    0,    0,    0,  150,  151,  152,  153,
  154,    0,  155,    0,  680,    0,    0,    0,  156,    0,
  157,  158,    0,    0,  160,  161,    0,    0,    0,  681,
    0,    0,  162,    0,    0,  164,  165,  166,  167,    0,
  168,    0,  169,  682,  170,  171,  172,  173,  174,  683,
    0,    0,    0,  175,    0,  176,    0,    0,    0,  684,
    0,    0, 1089,    0,    0,  766,  178,  767,    0,    0,
    0,  179,  180,  685,  686,  687,  688,  427,  428,  182,
  769,  183,  184,  185,  186,  770,  187,  689,    0,    0,
    0,    0,    0,    0,  188,  189,  690,  691,  692,  693,
  694,  695,  696,  697,  698,  190,  699,    0,  192,  193,
  194,  700,  701,    0,  702,  703,  704,    0,  197,  198,
  705,  199,    0,    0,  200,  201,  202,  203,  204,  205,
  206,    0,    0,    0,    0,  207,  706,  209,    0,  707,
  211,  212,    0,  213,    0,  708,  709,  710,    0,  711,
  712,    0,  713,  214,  215,  216,  217,  218,  219,  714,
  221,  715,  223,  716,  717,  718,  719,  720,  721,  722,
  723,  724,  725,  726,    0,  727,  728,  729,  730,  731,
  732,    0,  733,  734,  735,  244,    0,  736,    0,  737,
  738,  739,  740,  741,  251,  252,  742,  254,  743,  744,
  745,  258,  746,  260,  747,  262,  748,    0,  749,  750,
  751,  752,    0,  753,  754,  755,  271,  756,    0,  757,
  758,  275,  759,  277,  278,  760,  280,  281,  282,  283,
  284,  285,    0,  761,    0,  287,  288,  289,  290,  291,
    0,  762,  763,  764,  765,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  115,
    0,  116,    0,    0,    0,    0,    0,  118,    0,  667,
  119,  120,    0,    0,    0,    0,  668,    0,    0,    0,
    0,    0,  121,  122,    0,  123,    0,  124,  669,    0,
  125,    0,    0,  126,  670,  671,    0,    0,    0,    0,
  128,    0,  129,  130,    0,    0,    0,  131,    0,    0,
  132,    0,    0,  134,    0,    0,    0,    0,    0,    0,
    0,  672,    0,  135,  673,    0,    0,    0,    0,  137,
    0,  138,    0,  139,    0,    0,    0,    0,    0,  141,
    0,  142,    0,    0,    0,  143,    0,    0,    0,  674,
    0,  675,  676,  144,    0,  677,    0,  145,    0,    0,
  146,  678,    0,    0,  679,  147,  148,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  149,    0,
    0,    0,  150,  151,  152,  153,  154,    0,  155,    0,
  680,    0,    0,    0,  156,    0,  157,  158,    0,    0,
  160,  161,    0,    0,    0,  681,    0,    0,  162,    0,
    0,  164,  165,  166,  167,    0,  168,    0,  169,  682,
  170,  171,  172,  173,  174,  683,    0,    0,    0,  175,
    0,  176,    0,    0,    0,  684,    0,    0, 2539,    0,
    0,  766,  178,  767,    0,    0,    0,  179,  180,  685,
  686,  687,  688,  427,  428,  182,  769,  183,  184,  185,
  186,  770,  187,  689,    0,    0,    0,    0,    0,    0,
  188,  189,  690,  691,  692,  693,  694,  695,  696,  697,
  698,  190,  699,    0,  192,  193,  194,  700,  701,    0,
  702,  703,  704,    0,  197,  198,  705,  199,    0,    0,
  200,  201,  202,  203,  204,  205,  206,    0,    0,    0,
    0,  207,  706,  209,    0,  707,  211,  212,    0,  213,
    0,  708,  709,  710,    0,  711,  712,    0,  713,  214,
  215,  216,  217,  218,  219,  714,  221,  715,  223,  716,
  717,  718,  719,  720,  721,  722,  723,  724,  725,  726,
    0,  727,  728,  729,  730,  731,  732,    0,  733,  734,
  735,  244,    0,  736,    0,  737,  738,  739,  740,  741,
  251,  252,  742,  254,  743,  744,  745,  258,  746,  260,
  747,  262,  748,    0,  749,  750,  751,  752,    0,  753,
  754,  755,  271,  756,    0,  757,  758,  275,  759,  277,
  278,  760,  280,  281,  282,  283,  284,  285,    0,  761,
    0,  287,  288,  289,  290,  291,    0,  762,  763,  764,
  765,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  115,    0,  116,    0,    0,
    0,    0,    0,  118,    0,  667,  119,  120,    0,    0,
    0,    0,  668,    0,    0,    0,    0,    0,  121,  122,
    0,  123,    0,  124,  669,    0,  125,    0,    0,  126,
  670,  671,    0,    0,    0,    0,  128,    0,  129,  130,
    0,    0,    0,  131,    0,    0,  132,    0,    0,  134,
    0,    0,    0,    0,    0,    0,    0,  672,    0,  135,
  673,    0,    0,    0,    0,  137,    0,  138,    0,  139,
    0,    0,    0,    0,    0,  141,    0,  142,    0,    0,
    0,  143,    0,    0,    0,  674,    0,  675,  676,  144,
    0,  677,    0,  145,    0,    0,  146,  678,    0,    0,
  679,  147,  148,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  149,    0,    0,    0,  150,  151,
  152,  153,  154,    0,  155,    0,  680,    0,    0,    0,
  156,    0,  157,  158,    0,    0,  160,  161,    0,    0,
    0,  681,    0,    0,  162,    0,    0,  164,  165,  166,
  167,    0,  168,    0,  169,  682,  170,  171,  172,  173,
  174,  683,    0,    0,    0,  175,    0,  176,    0,    0,
    0,  684,    0,    0, 1089,    0,    0,  766,  178,  767,
    0,    0,    0,  179,  180,  685,  686,  687,  688,  427,
  428,  182,  769,  183,  184,  185,  186,  770,  187,  689,
    0,    0,    0,    0,    0,    0,  188,  189,  690,  691,
  692,  693,  694,  695,  696,  697,  698,  190,  699,    0,
  192,  193,  194,  700,  701,    0,  702,  703,  704,    0,
  197,  198,  705,  199,    0,    0,  200,  201,  202,  203,
  204,  205,  206,    0,    0,    0,    0,  207,  706,  209,
    0,  707,  211,  212,    0,  213,    0,  708,  709,  710,
    0,  711,  712,    0,  713,  214,  215,  216,  217,  218,
  219,  714,  221,  715,  223,  716,  717,  718,  719,  720,
  721,  722,  723,  724,  725,  726,    0,  727,  728,  729,
  730,  731,  732,    0,  733,  734,  735,  244,    0,  736,
    0,  737,  738,  739,  740,  741,  251,  252,  742,  254,
  743,  744,  745,  258,  746,  260,  747,  262,  748,    0,
  749,  750,  751,  752,    0,  753,  754,  755,  271,  756,
    0,  757,  758,  275,  759,  277,  278,  760,  280,  281,
  282,  283,  284,  285,    0,  761,    0,  287,  288,  289,
  290,  291,    0,  762,  763,  764,  765,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  115,    0,  116,    0,    0,    0,    0,    0,  118,
    0,  667,  119,  120,    0,    0,    0,    0,  668,    0,
    0,    0,    0,    0,  121,  122,    0,  123,    0,  124,
  669,    0,  125,    0,    0,  126,  670,  671,    0,    0,
    0,    0,  128,    0,  129,  130,    0,    0,    0,  131,
    0,    0,  132,    0,    0,  134,    0,    0,    0,    0,
    0,    0,    0,  672,    0,  135,  673,    0,    0,    0,
    0,  137,    0,  138,    0,  139,    0,    0,    0,    0,
    0,  141,    0,  142,    0,    0,    0,  143,    0,    0,
    0,  674,    0,  675,  676,  144,    0,  677,    0,  145,
    0,    0,  146,  678,    0,    0,  679,  147,  148,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  149,    0,    0,    0,  150,  151,  152,  153,  154,    0,
  155,    0,  680,    0,    0,    0,  156,    0,  157,  158,
    0,    0,  160,  161,    0,    0,    0,  681,    0,    0,
  162,    0,    0,  164,  165,  166,  167,    0,  168,    0,
  169,  682,  170,  171,  172,  173,  174,  683,    0,    0,
    0,  175,    0,  176,    0,    0,    0,  684,    0,    0,
 1287,    0,    0, 1287,  178, 1287,    0,    0,    0,  179,
  180,  685,  686,  687,  688,  427,  428,  182, 1287,  183,
  184,  185,  186, 1287,  187,  689,    0,    0,    0,    0,
    0,    0,  188,  189,  690,  691,  692,  693,  694,  695,
  696,  697,  698,  190,  699,    0,  192,  193,  194,  700,
  701,    0,  702,  703,  704,    0,  197,  198,  705,  199,
    0,    0,  200,  201,  202,  203,  204,  205,  206,    0,
    0,    0,    0,  207,  706,  209,    0,  707,  211,  212,
    0,  213,    0,  708,  709,  710,    0,  711,  712,    0,
  713,  214,  215,  216,  217,  218,  219,  714,  221,  715,
  223,  716,  717,  718,  719,  720,  721,  722,  723,  724,
  725,  726,    0,  727,  728,  729,  730,  731,  732,    0,
  733,  734,  735,  244,    0,  736,    0,  737,  738,  739,
  740,  741,  251,  252,  742,  254,  743,  744,  745,  258,
  746,  260,  747,  262,  748,    0,  749,  750,  751,  752,
    0,  753,  754,  755,  271,  756,    0,  757,  758,  275,
  759,  277,  278,  760,  280,  281,  282,  283,  284,  285,
    0,  761,    0,  287,  288, 2599,  290,  291,    0,  762,
  763,  764,  765,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1287,    0, 1287,
    0,    0,    0,    0,    0, 1287,    0, 1287, 1287, 1287,
    0,    0,    0,    0, 1287,    0,    0,    0,    0,    0,
 1287, 1287,    0, 1287,    0, 1287, 1287,    0, 1287,    0,
    0, 1287, 1287, 1287,    0,    0,    0,    0, 1287,    0,
 1287, 1287,    0,    0,    0, 1287,    0,    0, 1287,    0,
    0, 1287,    0,    0,    0,    0,    0,    0,    0, 1287,
    0, 1287, 1287,    0,    0,    0,    0, 1287,    0, 1287,
    0, 1287,    0,    0,    0,    0,    0, 1287,    0, 1287,
    0,    0,    0, 1287,    0,    0,    0, 1287,    0, 1287,
 1287, 1287,    0, 1287,    0, 1287,    0,    0, 1287, 1287,
    0,    0, 1287, 1287, 1287,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1287,    0,    0,    0,
 1287, 1287, 1287, 1287, 1287,    0, 1287,    0, 1287,    0,
    0,    0, 1287,    0, 1287, 1287,    0,    0, 1287, 1287,
    0,    0,  892, 1287,    0,    0, 1287,    0,    0, 1287,
 1287, 1287, 1287,    0, 1287,    0, 1287, 1287, 1287, 1287,
 1287, 1287, 1287, 1287,    0,    0,    0, 1287,    0, 1287,
    0,    0,    0, 1287,    0,    0,    0,    0,    0,    0,
 1287,    0,    0,    0,    0, 1287, 1287, 1287, 1287, 1287,
 1287, 1287, 1287, 1287,    0, 1287, 1287, 1287, 1287,    0,
 1287, 1287,    0,    0,    0,    0,    0,    0, 1287, 1287,
 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287,
 1287,    0, 1287, 1287, 1287, 1287, 1287,    0, 1287, 1287,
 1287,    0, 1287, 1287, 1287, 1287,    0,    0, 1287, 1287,
 1287, 1287, 1287, 1287, 1287,    0,    0,    0,    0, 1287,
 1287, 1287,    0, 1287, 1287, 1287,    0, 1287,    0, 1287,
 1287, 1287,    0, 1287, 1287,    0, 1287, 1287, 1287, 1287,
 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287,
 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287,    0, 1287,
 1287, 1287, 1287, 1287, 1287,    0, 1287, 1287, 1287, 1287,
    0, 1287,    0, 1287, 1287, 1287, 1287, 1287, 1287, 1287,
 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287,
 1287,    0, 1287, 1287, 1287, 1287,    0, 1287, 1287, 1287,
 1287, 1287,    0, 1287, 1287, 1287, 1287, 1287, 1287, 1287,
 1287, 1287, 1287, 1287, 1287, 1287,    0, 1287,    0, 1287,
 1287, 1287, 1287, 1287,    0, 1287, 1287, 1287, 1287, 1478,
    0, 1478,    0,    0,    0,    0,    0, 1478,    0,    0,
 1478, 1478,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1478, 1478,    0, 1478,    0, 1478,    0,    0,
 1478,    0,    0, 1478,    0,    0,    0,    0,    0,    0,
 1478,    0, 1478, 1478,    0,    0,    0, 1478,    0,    0,
 1478,    0,    0, 1478,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1478, 1478,    0,    0,    0,    0, 1478,
    0, 1478,    0, 1478, 1478,    0,    0,    0,    0, 1478,
    0, 1478,    0,    0,    0, 1478,    0,    0,    0,    0,
    0,    0,    0, 1478,    0,    0,    0, 1478,    0,    0,
 1478,    0,    0,    0,    0, 1478, 1478,    0, 1478,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1478,    0,
 1478,    0, 1478, 1478, 1478, 1478, 1478,    0, 1478,    0,
    0, 1456,    0,    0, 1478,    0, 1478, 1478,    0,    0,
 1478, 1478,    0,    0,    0,    0,    0,    0, 1478,  769,
    0, 1478, 1478, 1478, 1478,    0, 1478,    0, 1478,    0,
 1478, 1478, 1478, 1478, 1478,    0,    0,    0,    0, 1478,
    0, 1478,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1478,    0,    0,    0,    0, 1478, 1478,    0,
    0,    0, 1478,    0,    0, 1478,    0, 1478, 1478, 1478,
 1478,    0, 1478,    0,    0,    0,    0,    0,    0,    0,
 1478, 1478,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1478, 1478,    0, 1478, 1478, 1478,    0,    0,    0,
    0, 1478, 1478,    0, 1478, 1478,    0, 1478,    0,    0,
 1478, 1478, 1478, 1478, 1478, 1478, 1478,    0,    0,    0,
    0, 1478, 1478, 1478,    0, 1478, 1478, 1478,    0, 1478,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1478,
 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
    0, 1478, 1478, 1478, 1478, 1478, 1478,    0, 1478, 1478,
 1478, 1478,    0, 1478,    0, 1478, 1478, 1478, 1478, 1478,
 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
 1478, 1478, 1478,    0, 1478, 1478, 1478, 1478,    0, 1478,
 1478, 1478, 1478, 1478,    0, 1478, 1478, 1478, 1478, 1478,
 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,  115, 1478,
  116, 1478, 1478, 1478, 1478, 1478,  118, 1478,    0,  119,
  120,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  121,  122,    0,  123,    0,  124,    0,    0,  125,
    0,    0,  126,    0,    0,    0,    0,    0,    0,  128,
    0,  129,  130,    0,    0,    0,  131,    0,    0,  132,
    0,    0,  134,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  135,  136,    0,    0,    0,    0,  137,    0,
  138,    0,  139,    0,    0,    0,    0,    0,  141,    0,
  142,    0,    0,    0,  143,    0,    0,    0,    0,    0,
    0,    0,  144,    0,    0,    0,  145,    0,    0,  146,
    0,    0,    0,    0,  147,  148,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  149,    0,    0,
    0,  150,  151,  152,  153,  154,    0,  155,    0,    0,
 1159,    0,    0,  156,    0,  157,  158,    0,    0,  160,
  161,    0,    0,    0,    0,    0,    0,  162,    0,    0,
  164,  165,  166,  167,    0,  168,    0,  169,    0,  170,
  171,  172,  173,  174,    0,    0,    0,    0,  175,    0,
  176,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  178,    0,    0,    0,    0,  179,  180,    0,    0,
    0,  181,    0,    0,  182,    0,  183,  184,  185,  186,
    0,  187,    0,    0,    0,    0,    0,    0,    0,  188,
  189,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  190,  191,    0,  192,  193,  194,    0,    0,    0,    0,
  195,  196,    0,  197,  198,    0,  199,    0,    0,  200,
  201,  202,  203,  204,  205,  206,    0,    0,    0,    0,
  207,  208,  209,    0,  210,  211,  212,    0,  213,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  214,  215,
  216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,  233,  234,    0,
  235,  236,  237,  238,  239,  240,    0,  241,  242,  243,
  244,    0,  245,    0,  246,  247,  248,  249,  250,  251,
  252,  253,  254,  255,  256,  257,  258,  259,  260,  261,
  262,  263,    0,  264,  265,  266,  267,    0,  268,  269,
  270,  271,  272,    0,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  115,  286,  116,
  287,  288,  289,  290,  291,  118,  292,    0,  119,  120,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  121,  122,    0,  123,    0,  124,    0,    0,  125,    0,
    0,  126,    0,    0,    0,    0,    0,    0,  128,    0,
  129,  130,    0,    0,    0,  131,    0,    0,  132,    0,
    0,  134,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  135,  136,    0,    0,    0,    0,  137,    0,  138,
    0,  139,    0,    0,    0,    0,    0,  141,    0,  142,
    0,    0,    0,  143,    0,    0,    0,    0,    0,    0,
    0,  144,    0,    0,    0,  145,    0,    0,  146,    0,
    0,    0,    0,  147,  148,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  149,    0,    0,    0,
  150,  151,  152,  153,  154,    0,  155,    0,    0, 1159,
    0,    0,  156,    0,  157,  158,    0,    0,  160,  161,
    0,    0,    0,    0,    0,    0,  162,    0,    0,  164,
  165,  166,  167,    0,  168,    0,  169,    0,  170,  171,
  172,  173,  174,    0,    0,    0,    0,  175,    0,  176,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  178,    0,    0,    0,   16,  179,  180,    0,    0,    0,
  181,    0,    0,  182,    0,  183,  184,  185,  186,    0,
  187,    0,    0,    0,    0,    0,    0,    0,  188,  189,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  190,
  191,    0,  192,  193,  194,    0,    0,    0,    0,  195,
  196,    0,  197,  198,    0,  199,    0,    0,  200,  201,
  202,  203,  204,  205,  206,    0,    0,    0,    0,  207,
  208,  209,    0,  210,  211,  212,    0,  213,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  214,  215,  216,
  217,  218,  219,  220,  221,  222,  223,  224,  225,  226,
  227,  228,  229,  230,  231,  232,  233,  234,    0,  235,
  236,  237,  238,  239,  240,    0,  241,  242,  243,  244,
    0,  245,    0,  246,  247,  248,  249,  250,  251,  252,
  253,  254,  255,  256,  257,  258,  259,  260,  261,  262,
  263,    0,  264,  265,  266,  267,    0,  268,  269,  270,
  271,  272,    0,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  115,  286,  116,  287,
  288,  289,  290,  291,  118,  292,    0,  119,  120,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  121,
  122,    0,  123,    0,  124,    0,    0,  125,    0,    0,
  126,    0,    0,    0,    0,    0,    0,  128,    0,  129,
  130,    0,    0,    0,  131,    0,    0,  132,    0,    0,
  134,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  135,  136,    0,    0,    0,    0,  137,    0,  138,    0,
  139,    0,    0,    0,    0,    0,  141,    0,  142,    0,
    0,    0,  143,    0,    0,    0,    0,    0,    0,    0,
  144,    0,    0,    0,  145,    0,    0,  146,    0,    0,
    0,    0,  147,  148,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  149,    0,    0,    0,  150,
  151,  152,  153,  154,    0,  155,    0,    0,  492,    0,
    0,  156,    0,  157,  158,    0,    0,  160,  161,    0,
    0,    0,    0,    0,    0,  162,    0,    0,  164,  165,
  166,  167,    0,  168,    0,  169,    0,  170,  171,  172,
  173,  174,    0,    0,    0,    0,  175,    0,  176,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  178,
    0,    0,    0,    0,  179,  180,    0,    0,    0,  181,
    0,    0,  182,    0,  183,  184,  185,  186,    0,  187,
    0,    0,    0,    0,    0,    0,    0,  188,  189,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  190,  191,
    0,  192,  193,  194,    0,    0,    0,    0,  195,  196,
    0,  197,  198,    0,  199,    0,    0,  200,  201,  202,
  203,  204,  205,  206,    0,    0,    0,    0,  207,  208,
  209,    0,  210,  211,  212,    0,  213,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  214,  215,  216,  217,
  218,  219,  220,  221,  222,  223,  224,  225,  226,  227,
  228,  229,  230,  231,  232,  233,  234,    0,  235,  236,
  237,  238,  239,  240,    0,  241,  242,  243,  244,    0,
  245,    0,  246,  247,  248,  249,  250,  251,  252,  253,
  254,  255,  256,  257,  258,  259,  260,  261,  262,  263,
    0,  264,  265,  266,  267,    0,  268,  269,  270,  271,
  272,    0,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  115,  286,  116,  287,  288,
  289,  290,  291,  118,  292,    0,  119,  120,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  121, 1246,
    0,  123,    0,  124,    0,    0,  125,    0,    0,  126,
    0,    0,    0,    0,    0,    0,  128,    0,  129,  130,
    0,    0,    0,  131,    0,    0,  132,    0,    0,  134,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  135,
  136,    0,    0,    0,    0,  137,    0,  138,    0,  139,
    0,    0,    0,    0,    0,  141,    0,  142,    0,    0,
    0,  143,    0,    0,    0,    0,    0,    0,    0,  144,
    0,    0,    0,  145,    0,    0,  146,    0,    0,    0,
    0,  147,  148,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  149,    0,    0,    0,  150,  151,
  152,  153,  154,    0,  155,    0,    0,    0,    0, 1463,
  156,    0,  157,  158,    0,    0,  160,  161,    0,    0,
    0,    0,    0,    0,  162,    0,    0,  164,  165,  166,
  167,    0,  168,    0,  169,    0,  170,  171,  172,  173,
  174,    0,    0,    0,    0,  175,    0,  176,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  178,    0,
    0,    0,    0,  179,  180,    0,    0,    0,  181,    0,
    0,  182,    0,  183,  184,  185,  186,    0,  187,    0,
    0,    0,    0,    0,    0,    0,  188,  189,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  190,  191,    0,
  192,  193,  194,    0,    0,    0,    0,  195,  196,    0,
  197,  198,    0,  199,    0,    0,  200,  201,  202,  203,
  204,  205,  206,    0,    0,    0,    0,  207,  208,  209,
    0,  210,  211,  212,    0,  213,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  214,  215,  216,  217,  218,
  219,  220,  221,  222,  223,  224,  225,  226,  227,  228,
  229,  230,  231,  232,  233,  234,    0,  235,  236,  237,
  238,  239,  240,    0,  241,  242,  243,  244,    0,  245,
    0,  246,  247,  248,  249,  250,  251,  252,  253,  254,
  255,  256,  257,  258,  259,  260,  261,  262,  263,    0,
  264,  265,  266,  267,    0,  268,  269,  270,  271,  272,
    0,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  115,  286,  116,  287,  288,  289,
  290,  291,  118,  292,    0,  119,  120,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  121,  122,    0,
  123,    0,  124,    0,    0,  125,    0,    0,  126,    0,
 1462,    0,    0,    0,    0,  128,    0,  129,  130,    0,
    0,    0,  131,    0,    0,  132,    0,    0,  134,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  135,  136,
    0,    0,    0,    0,  137,    0,  138,    0,  139,    0,
    0,    0,    0,    0,  141,    0,  142,    0,    0,    0,
  143,    0,    0,    0,    0,    0,    0,    0,  144,    0,
    0,    0,  145,    0,    0,  146,    0,    0,    0,    0,
  147,  148,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  149,    0,    0,    0,  150,  151,  152,
  153,  154,    0,  155,    0,    0,    0,    0, 1463,  156,
    0,  157,  158,    0,    0,  160,  161,    0,    0,    0,
    0,    0,    0,  162,    0,    0,  164,  165,  166,  167,
    0,  168,    0,  169,    0,  170,  171,  172,  173,  174,
    0,    0,    0,    0,  175,    0,  176,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  178,    0,    0,
    0,    0,  179,  180,    0,    0,    0,  181,    0,    0,
  182,    0,  183,  184,  185,  186,    0,  187,    0,    0,
    0,    0,    0,    0,    0,  188,  189,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  190,  191,    0,  192,
  193,  194,    0,    0,    0,    0,  195,  196,    0,  197,
  198,    0,  199,    0,    0,  200,  201,  202,  203,  204,
  205,  206,    0,    0,    0,    0,  207,  208,  209,    0,
  210,  211,  212,    0,  213,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  214,  215,  216,  217,  218,  219,
  220,  221,  222,  223,  224,  225,  226,  227,  228,  229,
  230,  231,  232,  233,  234,    0,  235,  236,  237,  238,
  239,  240,    0,  241,  242,  243,  244,    0,  245,    0,
  246,  247,  248,  249,  250,  251,  252,  253,  254,  255,
  256,  257,  258,  259,  260,  261,  262,  263,    0,  264,
  265,  266,  267,    0,  268,  269,  270,  271,  272,    0,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,  284,  285,  115,  286,  116,  287,  288,  289,  290,
  291,  118,  292,    0,  119,  120,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  121,  122,    0,  123,
    0,  124,    0,    0,  125,    0,    0,  126,    0,    0,
    0,    0,    0,    0,  128,    0,  129,  130,    0,    0,
    0,  131,    0,    0,  132,    0,    0,  134,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  135,  136,    0,
    0,    0,    0,  137,    0,  138,    0,  139,    0,    0,
    0,    0,    0,  141,    0,  142,    0,    0,    0,  143,
    0,    0,    0,    0,    0,    0,    0,  144,    0,    0,
    0,  145,    0,    0,  146,    0,    0,    0,    0,  147,
  148,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  149,    0,    0,    0,  150,  151,  152,  153,
  154,    0,  155,    0,    0,    0,    0,    0,  156,  834,
  157,  158,    0,    0,  160,  161,    0,    0,    0,    0,
    0,    0,  162,    0,    0,  164,  165,  166,  167,    0,
  168,    0,  169,    0,  170,  171,  172,  173,  174,    0,
    0,    0,    0,  175,    0,  176,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  178,    0,    0,    0,
    0,  179,  180,    0,    0,    0,  181,    0,    0,  182,
    0,  183,  184,  185,  186,    0,  187,    0,    0,    0,
    0,    0,    0,    0,  188,  189,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  190,  191,    0,  192,  193,
  194,    0,    0,    0,    0,  195,  196,    0,  197,  198,
    0,  199,    0,    0,  200,  201,  202,  203,  204,  205,
  206,    0,    0,    0,    0,  207,  208,  209,    0,  210,
  211,  212,    0,  213,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  214,  215,  216,  217,  218,  219,  220,
  221,  222,  223,  224,  225,  226,  227,  228,  229,  230,
  231,  232,  233,  234,    0,  235,  236,  237,  238,  239,
  240,    0,  241,  242,  243,  244,    0,  245,    0,  246,
  247,  248,  249,  250,  251,  252,  253,  254,  255,  256,
  257,  258,  259,  260,  261,  262,  263,    0,  264,  265,
  266,  267,    0,  268,  269,  270,  271,  272,    0,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  837,  286,  837,  287,  288,  289,  290,  291,
  837,  292,    0,  837,  837,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  837,  837,    0,  837,    0,
  837,    0,    0,  837,    0,    0,  837,    0,    0,    0,
    0,    0,    0,  837,    0,  837,  837,    0,    0,    0,
  837,    0,    0,  837,    0,    0,  837,    0,    0,    0,
    0,  834,    0,    0,    0,    0,  837,  837,    0,    0,
    0,    0,  837,    0,  837,    0,  837,    0,    0,    0,
    0,    0,  837,    0,  837,    0,    0,    0,  837,    0,
    0,    0,    0,    0,    0,    0,  837,    0,    0,    0,
  837,    0,    0,  837,    0,    0,    0,    0,  837,  837,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  837,    0,    0,    0,  837,  837,  837,  837,  837,
    0,  837,    0,    0,    0,    0,    0,  837,    0,  837,
  837,    0,    0,  837,  837,    0,    0, 1039,    0,    0,
    0,  837,    0,    0,  837,  837,  837,  837,    0,  837,
    0,  837,    0,  837,  837,  837,  837,  837,    0,    0,
    0,    0,  837,    0,  837,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  837,    0,    0,    0,    0,
  837,  837,    0,    0,    0,  837,    0,    0,  837,    0,
  837,  837,  837,  837,    0,  837,    0,    0,    0,    0,
    0,    0,    0,  837,  837,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  837,  837,    0,  837,  837,  837,
    0,    0,    0,    0,  837,  837,    0,  837,  837,    0,
  837,    0,    0,  837,  837,  837,  837,  837,  837,  837,
    0,    0,    0,    0,  837,  837,  837,    0,  837,  837,
  837,    0,  837,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  837,  837,  837,  837,  837,  837,  837,  837,
  837,  837,  837,  837,  837,  837,  837,  837,  837,  837,
  837,  837,  837,    0,  837,  837,  837,  837,  837,  837,
    0,  837,  837,  837,  837,    0,  837,    0,  837,  837,
  837,  837,  837,  837,  837,  837,  837,  837,  837,  837,
  837,  837,  837,  837,  837,  837,    0,  837,  837,  837,
  837,    0,  837,  837,  837,  837,  837,    0,  837,  837,
  837,  837,  837,  837,  837,  837,  837,  837,  837,  837,
  837,    0,  837,    0,  837,  837,  837,  837,  837,  115,
  837,  116,    0,    0,    0,    0,    0,  118,    0,    0,
  119,  120,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  121,  122,    0,  123,    0,  124,    0,    0,
  125,    0,    0,  126,    0,    0,    0,    0,    0,    0,
  128,    0,  129,  130,    0,    0,    0,  131,    0,    0,
  132,    0,    0,  134,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  135,  136,    0,    0,    0,    0,  137,
    0,  138,    0,  139,    0,    0,    0,    0,    0,  141,
    0,  142,    0,    0,    0,  143,    0,    0,    0,    0,
    0,    0,    0,  144,    0,    0,    0,  145,  679,    0,
  146,    0,    0,    0,    0,  147,  148,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  149,    0,
    0,    0,  150,  151,  152,  153,  154,    0,  155,    0,
    0,    0,    0,    0,  156,    0,  157,  158,    0,  679,
  160,  161,  679,    0,    0,    0,    0,    0,  162,    0,
    0,  164,  165,  166,  167,    0,  168,  679,  169,  679,
  170,  171,  172,  173,  174,    0,    0,    0,    0,  175,
    0,  176,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  178,    0,    0,    0,    0,  179,  180,  679,
  444,    0,  181,    0,    0,  182,    0,  183,  184,  185,
  186,    0,  187,    0,    0,    0,    0,    0,    0,    0,
  188,  189,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  190,  191,    0,  192,  193,  194,    0,    0,    0,
    0,  195,  196,    0,  197,  198,    0,  199,    0,    0,
  200,  201,  202,  203,  204,  205,  206,    0,    0,    0,
    0,  207,  208,  209,    0,  210,  211,  212,    0,  213,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  214,
  215,  216,  217,  218,  219,  220,  221,  222,  223,  224,
  225,  226,  227,  228,  229,  230,  231,  232,  233,  234,
    0,  235,  236,  237,  238,  239,  240,    0,  241,  242,
  243,  244,    0,  245,    0,  246,  247,  248,  249,  250,
  251,  252,  253,  254,  255,  256,  257,  258,  259,  260,
  261,  262,  263,    0,  264,  265,  266,  267,    0,  268,
  269,  270,  271,  272,    0,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  283,  284,  285,    0,  286,
  769,  287,  288,  289,  290,  291,  679,  292,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  679,    0,    0,  679,  679,    0,    0,    0,  679,
    0,    0,  679,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  679,    0,    0,    0,    0,    0,
  679,    0,    0,  679,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  679,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  679,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  679,
    0,    0,    0,    0,    0,  679,    0,    0,    0,  679,
    0,    0,    0,    0,    0,    0,  679,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  679,    0,    0,    0,    0,  679,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  115,
    0,  116,    0,    0,  679,    0,    0,  118,  679,    0,
  119,  120,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  121,  122,    0,  123,    0,  124,    0,    0,
  125,    0,    0,  126,    0,    0,    0,    0,    0,    0,
  128,    0,  129,  130,    0,    0,    0,  131,    0,    0,
  132,    0,    0,  134,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  135,  136,    0,    0,    0,    0,  137,
    0,  138, 1003,  139,    0,    0,    0,    0,    0,  141,
    0,  142,    0,    0,    0,  143,    0,    0,    0,    0,
    0,    0,    0,  144,    0,    0,    0,  145,    0,    0,
  146,    0,    0,    0,    0,  147,  148,  679,    0,    0,
    0,    0,    0, 1003,    0,    0, 1003,    0,  149,    0,
    0,    0,  150,  151,  152,  153,  154,    0,  155,    0,
    0, 1003,    0,    0,  156,    0,  157,  158,    0,    0,
  160,  161,    0,    0,    0,    0,    0,    0,  162,    0,
    0,  164,  165,  166,  167,    0,  168,    0,  169,    0,
  170,  171,  172,  173,  174,    0,    0,    0, 1004,  175,
    0,  176,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  178,    0,    0,    0,    0,  179,  180,    0,
    0,    0,  181,    0,    0,  182,    0,  183,  184,  185,
  186,    0,  187,    0,    0,    0,    0,    0,    0, 1004,
  188,  189, 1004,    0,    0,    0,    0,    0,    0,    0,
    0,  190,  191,    0,  192,  193,  194, 1004,    0,    0,
    0,  195,  196,    0,  197,  198,    0,  199,    0,    0,
  200,  201,  202,  203,  204,  205,  206,    0,    0,    0,
    0,  207,  208,  209,    0,  210,  211,  212,    0,  213,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  214,
  215,  216,  217,  218,  219,  220,  221,  222,  223,  224,
  225,  226,  227,  228,  229,  230,  231,  232,  233,  234,
    0,  235,  236,  237,  238,  239,  240,    0,  241,  242,
  243,  244,    0,  245,    0,  246,  247,  248,  249,  250,
  251,  252,  253,  254,  255,  256,  257,  258,  259,  260,
  261,  262,  263,    0,  264,  265,  266,  267, 1030,  268,
  269,  270,  271,  272, 1003,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  283,  284,  285,    0,  286,
    0,  287,  288,  289,  290,  291,    0,  292,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1030,
    0,    0, 1030, 1007,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1003, 1030,    0, 1003,
    0,    0,    0,    0,    0,    0, 1003,    0, 1003,    0,
    0,    0, 1003,    0,    0,    0,    0, 1003,    0,    0,
 1003,    0,    0,    0, 1007,    0,    0, 1007,    0,    0,
    0,    0,    0,    0,    0, 1003,    0,    0,    0,    0,
 1004,    0, 1007,    0,    0,    0,    0,    0, 1003,    0,
    0,    0,    0,    0,    0,    0, 1003,    0,    0, 1003,
 1003,    0,    0,    0,    0,    0,    0,    0,    0, 1003,
    0,    0,    0,    0,    0,    0,    0, 1005,    0,    0,
    0,    0,    0,    0,    0, 1003,    0,    0,    0,    0,
    0,    0, 1004,    0,    0, 1004,    0,    0,    0,    0,
    0,    0, 1004,    0, 1004,    0,    0, 1003, 1004, 1006,
    0,    0, 1003, 1004,    0,    0, 1004,    0, 1005,    0,
    0, 1005,    0, 1003, 1003,    0, 1003,    0,    0,    0,
    0, 1004,    0,    0,    0,    0, 1005,    0,    0,    0,
    0,    0,    0,    0, 1004,    0,    0,    0,    0,    0,
 1006,    0, 1004, 1006,    0, 1004, 1004,    0,    0,    0,
    0,    0,    0,    0,    0, 1004,    0,    0, 1006,    0,
    0,    0,    0, 1003,    0,    0,    0,    0,    0,    0,
    0, 1004,    0,    0,    0,    0,    0,    0,    0,    0,
 1003,    0,    0,    0, 1003,    0,    0,    0,    0,    0,
 1030,    0,    0, 1004,    0,    0,    0,    0, 1004, 1003,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1004,
 1004,    0, 1004,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1007,    0,    0,    0,    0,
    0,    0, 1030,    0,    0, 1030,    0,    0,    0,    0,
    0,    0, 1030,    0, 1030,    0,    0, 1042, 1030, 1004,
    0,    0,    0, 1030,    0,    0, 1030,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1004,    0,    0,    0,
 1004, 1030,    0,    0,    0,    0,    0, 1007,    0, 1000,
 1007,    0,    0,    0, 1030, 1004,    0, 1007, 1042, 1007,
    0, 1042, 1030, 1007,    0, 1030, 1030,    0, 1007,    0,
    0, 1007,    0,    0,    0, 1030, 1042,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1007,    0,    0, 1005,
 1000, 1030,    0, 1000,    0,    0,    0,    0,    0, 1007,
    0,    0,    0,    0,    0,    0,    0, 1007, 1000,    0,
 1007, 1007,    0, 1030,    0,    0,    0,    0, 1030,    0,
 1007, 1006,    0,    0,    0,    0,    0,    0,    0, 1030,
 1030,    0, 1030,    0,    0,    0, 1007,    0,    0,    0,
    0, 1005,    0, 1001, 1005,    0,    0,    0,    0,    0,
    0, 1005,    0, 1005,    0,    0,    0, 1005, 1007,    0,
    0,    0, 1005, 1007,    0, 1005,    0,    0,    0,    0,
    0,    0,    0, 1006, 1007, 1007, 1006, 1007,    0, 1030,
 1005,    0,    0, 1006, 1001, 1006,    0, 1001, 1002, 1006,
    0,    0,    0, 1005, 1006,    0, 1030, 1006,    0,    0,
 1030, 1005, 1001,    0, 1005, 1005,    0,    0,    0,    0,
    0,    0, 1006,    0, 1005, 1030,    0,    0,    0,    0,
    0,    0,    0,    0, 1007, 1006,    0,    0,    0, 1002,
 1005,    0, 1002, 1006,    0,    0, 1006, 1006,    0,    0,
    0, 1007,    0,    0,    0, 1007, 1006, 1002,    0,    0,
    0,    0, 1005,    0,    0,    0,    0, 1005,    0,    0,
 1007,    0, 1006,    0,    0,    0,    0,    0, 1005, 1005,
    0, 1005,    0,    0,    0,    0,    0,    0,    0, 1042,
    0,    0,    0,    0, 1006,    0, 1037,    0,    0, 1006,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1006, 1006,    0, 1006,    0,    0,    0,    0,    0,    0,
    0, 1000,    0,    0,    0,    0,    0,    0, 1005,    0,
    0,    0,    0,    0,    0,    0,    0, 1037,    0,    0,
 1037, 1042,    0,    0, 1042, 1005,    0,    0,    0, 1005,
    0, 1042,    0, 1042,    0, 1037,    0, 1042,    0,    0,
 1006,    0, 1042,    0, 1005, 1042,    0,    0,    0,    0,
    0,    0,    0, 1000,    0,    0, 1000, 1006,    0,    0,
 1042, 1006,    0, 1000,    0, 1000,    0,    0,    0, 1000,
    0,    0,    0, 1042, 1000,    0, 1006, 1000,    0,    0,
    0, 1042,    0,    0, 1042, 1042, 1031,    0,    0,    0,
    0,    0, 1000,    0, 1042, 1001,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1000,    0,    0,    0,    0,
 1042,    0,    0, 1000,    0,    0, 1000, 1000,    0,    0,
    0,    0,    0,    0,    0,    0, 1000, 1031,    0,    0,
 1031,    0, 1042,    0,    0,    0,    0, 1042,    0,    0,
 1002,    0, 1000,    0,  850, 1031,    0, 1001, 1042, 1042,
 1001, 1042,    0,    0,    0,    0,    0, 1001,    0, 1001,
    0,    0,    0, 1001, 1000,    0,    0,    0, 1001, 1000,
    0, 1001,    0,    0,    0,    0,    0,    0,    0,    0,
 1000, 1000, 1043, 1000,    0,  850, 1001,    0,  850,    0,
    0,    0, 1002,    0,    0, 1002,    0,    0, 1042, 1001,
    0,    0, 1002,  850, 1002,    0,    0, 1001, 1002,    0,
 1001, 1001,    0, 1002,    0, 1042, 1002,    0,    0, 1042,
 1001,    0,    0, 1043,    0,    0, 1043,    0,    0,    0,
 1000, 1002,    0,    0, 1042,    0, 1001,    0, 1037,    0,
    0, 1043,    0,    0, 1002,    0,    0, 1000,    0,    0,
    0, 1000, 1002,    0,    0, 1002, 1002,    0, 1001,    0,
    0,    0,    0, 1001,    0, 1002, 1000,    0,    0,    0,
    0,    0,    0,    0, 1001, 1001,    0, 1001,    0,    0,
    0, 1002,    0,    0,    0,    0,    0,    0,    0,    0,
 1037,    0, 1044, 1037,    0,    0,    0,    0,    0,    0,
 1037,    0, 1037, 1002,    0,    0, 1037,    0, 1002,    0,
    0, 1037,    0,    0, 1037,    0,    0,    0,    0, 1002,
 1002,    0, 1002,    0, 1001,    0,    0,    0,    0, 1037,
    0,    0,    0, 1044,    0,    0, 1044,    0,    0,    0,
    0, 1001, 1037,    0,    0, 1001,    0,    0, 1031,    0,
 1037, 1044,    0, 1037, 1037,    0,    0,    0,    0,    0,
 1001,    0,    0, 1037,    0,    0,    0,    0,    0, 1002,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1037,
    0,    0,    0,    0,    0,    0, 1002,    0, 1038,    0,
 1002,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1031, 1037,    0, 1031,    0, 1002, 1037,    0,    0,    0,
 1031,    0, 1031,    0,    0,    0, 1031, 1037, 1037,    0,
 1037, 1031,    0,    0, 1031,    0,    0,    0,    0, 1038,
    0,    0, 1038,    0,    0,    0,    0,    0,    0, 1031,
    0,    0,    0,    0, 1043,    0, 1028, 1038,    0,    0,
    0,    0, 1031,    0,    0,    0,    0,    0,  850,    0,
 1031,  850,    0, 1031, 1031,    0,    0, 1037,  850,    0,
  850,    0,    0, 1031,  850,    0,    0,    0,    0,  850,
    0,    0,  850,    0, 1037,    0,    0, 1028, 1037, 1031,
 1028,    0,    0,    0,    0,    0, 1043,  850,    0, 1043,
    0,    0,    0, 1037,    0, 1028, 1043,    0, 1043,    0,
  850, 1031, 1043,    0,    0,    0, 1031, 1043,  850,    0,
 1043,    0,  850,    0,    0,    0,    0, 1031, 1031,    0,
 1031,  850,    0,    0,    0, 1043,    0,    0,    0,    0,
 1026,    0,    0,    0,    0,    0,    0,  850, 1043,    0,
    0,    0,    0,    0, 1044,    0, 1043,    0,    0, 1043,
 1043,    0,    0,    0,    0,    0,    0,    0,    0, 1043,
    0,    0,    0,    0,  850,    0,    0, 1031,    0,    0,
    0, 1026,    0,    0, 1026, 1043,  850,    0,  850,    0,
    0,    0,    0,    0, 1031,    0,    0,    0, 1031, 1026,
    0,    0,    0,    0,    0,    0, 1044, 1043,    0, 1044,
    0,    0, 1043, 1031,    0,    0, 1044,    0, 1044,    0,
    0, 1032, 1044, 1043, 1043,    0, 1043, 1044,    0,    0,
 1044,    0,    0,    0,    0,  850,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1044,    0,    0,    0,    0,
 1038,    0,  850,    0,    0,    0,  850,    0, 1044,    0,
    0,    0, 1032,    0,    0, 1032, 1044,    0,    0, 1044,
 1044,  850,    0, 1043,    0,    0,    0,    0,    0, 1044,
 1032,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1043,    0,    0,    0, 1043, 1044,    0,    0,    0,    0,
    0,    0, 1038,    0,    0, 1038,    0,    0, 1028, 1043,
    0,    0, 1038,    0, 1038, 1045,    0, 1044, 1038,    0,
    0,    0, 1044, 1038,    0,    0, 1038,    0,    0,    0,
    0,    0,    0, 1044, 1044,    0, 1044,    0,    0,    0,
    0, 1038,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1038,    0, 1045,    0,    0, 1045,
 1028,    0, 1038, 1028,    0, 1038, 1038,    0,    0,    0,
 1028,    0, 1028,    0, 1045, 1038, 1028,    0,    0,    0,
    0, 1028,    0, 1044, 1028,    0,    0,    0,    0,    0,
    0, 1038,    0,    0,    0,    0, 1039,    0,    0, 1028,
 1044,    0, 1026,    0, 1044,    0,    0,    0,    0,    0,
    0,    0, 1028, 1038,    0,    0,    0,    0, 1038, 1044,
 1028,    0,    0, 1028, 1028,    0,    0,    0,    0, 1038,
 1038,    0, 1038, 1028,    0,    0,    0, 1039,    0,    0,
 1039,    0,    0,    0,    0,    0,    0,    0,    0, 1028,
    0,    0,    0,    0, 1026, 1039,    0, 1026,    0,    0,
    0,    0,    0,    0, 1026,    0, 1026,    0,    0,    0,
 1026, 1028,    0,    0,    0, 1026, 1028,    0, 1026, 1038,
    0,    0,    0, 1032,    0,    0,    0, 1028, 1028,    0,
 1028,    0,    0, 1026,    0,    0, 1038,    0,    0,    0,
 1038,    0,    0,    0,    0,    0, 1026,    0,    0,    0,
    0,    0,    0,    0, 1026, 1038,    0, 1026, 1026, 1027,
    0,    0,    0,    0,    0,    0,    0, 1026,    0,    0,
    0,    0,    0,    0,    0, 1032,    0, 1028, 1032,    0,
    0,    0,    0, 1026,    0, 1032,    0, 1032,    0,    0,
    0, 1032,    0,    0, 1028,    0, 1032,    0, 1028, 1032,
 1027,    0,    0, 1027,    0, 1026,    0,    0,    0,    0,
 1026,    0,    0, 1028, 1032,    0,    0, 1045, 1027,    0,
    0, 1026, 1026,    0, 1026,    0,    0, 1032,    0,    0,
    0,    0,    0,    0,    0, 1032,    0,    0, 1032, 1032,
    0,    0,    0,    0,    0,    0,    0,    0, 1032,    0,
    0,    0,    0, 1029,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1032,    0,    0,    0,    0, 1045,
    0, 1026, 1045,    0,    0,    0,    0,    0,    0, 1045,
    0, 1045,    0,    0,    0, 1045, 1032,    0, 1026,    0,
 1045, 1032, 1026, 1045, 1029,    0,    0, 1029, 1039,    0,
    0,    0, 1032, 1032,    0, 1032,    0, 1026, 1045,    0,
    0,    0, 1029,    0,    0,    0,    0,    0,    0,    0,
    0, 1045,    0,    0,    0,    0,    0,    0,    0, 1045,
    0,    0, 1045, 1045, 1033,    0,    0,    0,    0,    0,
    0,    0, 1045,    0,    0,    0,    0,    0,    0,    0,
 1039,    0, 1032, 1039,    0,    0,    0,    0, 1045,    0,
 1039,    0, 1039,    0,    0,    0, 1039,    0,    0, 1032,
    0, 1039,    0, 1032, 1039, 1033,    0,    0, 1033,    0,
 1045,    0,    0,    0,    0, 1045,    0,    0, 1032, 1039,
    0,    0, 1040, 1033,    0,    0, 1045, 1045,    0, 1045,
    0,    0, 1039,    0,    0,    0,    0,    0,    0,    0,
 1039,    0,    0, 1039, 1039,    0,    0,    0,    0,    0,
    0, 1027,    0, 1039,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1040,    0,    0, 1040,    0,    0, 1039,
    0,    0,    0,    0,    0,    0, 1045,    0,    0,    0,
    0, 1040,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1039,    0, 1045,    0,    0, 1039, 1045,    0,    0,
    0,    0,    0, 1027,    0,    0, 1027, 1039, 1039,    0,
 1039,    0, 1045, 1027,    0, 1027,    0,    0, 1041, 1027,
    0,    0,    0,    0, 1027,    0,    0, 1027,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1027,    0,    0, 1029,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1027,    0, 1039,    0, 1041,
    0,    0, 1041, 1027,    0,    0, 1027, 1027,    0,    0,
    0,    0,    0,    0, 1039,    0, 1027, 1041, 1039,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1027, 1039,    0,    0,    0, 1029,    0,    0,
 1029,    0,    0,    0,    0,    0,    0, 1029,    0, 1029,
    0,    0,  983, 1029, 1027,    0,    0,    0, 1029, 1027,
    0, 1029,    0,    0,    0,    0, 1033,    0,    0,    0,
 1027, 1027,    0, 1027,    0,    0, 1029,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1029,
    0,    0,    0,  983,    0,    0,  983, 1029,    0,    0,
 1029, 1029,    0,    0,    0,    0,    0,    0,    0,    0,
 1029,  983,    0,    0,    0,    0,    0,    0, 1033,    0,
 1027, 1033,    0,    0, 1040,    0, 1029,    0, 1033,    0,
 1033,    0,    0,    0, 1033,    0,    0, 1027,    0, 1033,
    0, 1027, 1033,    0,    0,    0,    0,    0, 1029,    0,
    0,    0,    0, 1029,  861,    0, 1027, 1033,    0,    0,
    0,    0,    0,    0, 1029, 1029,    0, 1029,    0,    0,
 1033,    0,    0,    0,    0,    0, 1040,    0, 1033, 1040,
    0, 1033, 1033,    0,    0,    0, 1040,    0, 1040,    0,
    0, 1033, 1040,    0,    0,  861,    0, 1040,  861,    0,
 1040,    0,    0,    0,    0,    0,    0, 1033,    0,    0,
    0,    0,  848,  861, 1029, 1040,    0,    0,    0,    0,
 1041,    0,    0,    0,    0,    0,    0,    0, 1040, 1033,
    0, 1029,    0,    0, 1033, 1029, 1040,    0,    0, 1040,
 1040,    0,    0,    0,    0, 1033, 1033,    0, 1033, 1040,
 1029,    0,  848,  848,    0,    0,  848,    0,    0,    0,
    0,    0,    0,    0,    0, 1040,    0,    0,    0,    0,
    0,  848, 1041,    0,    0, 1041,    0,    0,    0,    0,
    0,    0, 1041,    0, 1041,    0,    0, 1040, 1041,    0,
    0,    0, 1040, 1041,    0, 1033, 1041,    0,    0,    0,
    0,    0,    0, 1040, 1040,    0, 1040,    0,    0,    0,
    0, 1041, 1033,    0,    0,    0, 1033,    0,    0,    0,
    0,    0,    0,    0, 1041,    0,    0,    0,    0,    0,
    0, 1033, 1041,    0,    0, 1041, 1041,    0,    0,    0,
    0,    0,    0,    0,    0, 1041,    0,    0,    0,    0,
    0,    0,    0, 1040,    0,    0,    0,    0,    0,    0,
    0, 1041,    0,    0,    0,    0,  983,    0,    0,  983,
 1040,    0,    0,    0, 1040,    0,  983,    0,  983,    0,
    0,    0,  983, 1041,    0,    0,    0,  983, 1041, 1040,
  983,    0,    0,    0,    0,    0,    0,    0,    0, 1041,
 1041,    0, 1041,    0,    0,  983,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  983,    0,
    0,    0,    0,    0,    0,    0,  983,    0,    0,  983,
  983,    0,    0,    0,    0,    0,    0,    0,    0,  983,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1041,
    0,    0,    0,    0,    0,  983,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1041,    0,  861,    0,
 1041,  861,    0,    0,    0,    0,    0,  983,  861,    0,
  861,    0,  983,    0,  861, 1041,    0,    0,    0,  861,
    0,    0,  861,  983,  983,    0,  983,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  861,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  861,    0,    0,    0,    0,    0,  848,    0,  861,  848,
    0,    0,  861,    0,    0,    0,  848,    0,  848,    0,
    0,  861,  848,  983,    0,    0,    0,  848,    0,    0,
  848,    0,    0,    0,    0,    0,    0,  861,    0,    0,
  983,    0,    0,    0,  983,  848,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  848,  983,
    0,    0,    0,    0,  861,    0,  848,    0,    0,    0,
  848,    0,    0,    0,    0,    0,  861,    0,  861,  848,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  848,    0,    0,    0,    0,
    0,    0,    0,    0,  115,    0,  116,    0,    0,    0,
    0,    0,  118,    0,    0,  119,  120,    0,    0,    0,
    0,    0,  848,    0,    0,  861,    0,  121,  122,    0,
  123,    0,  124,    0,  848,  125,  848,    0,  126,    0,
    0,    0,  861,    0,    0,  128,  861,  129,  130,    0,
    0,    0,  131,    0,    0,  132,    0,    0,  134,    0,
    0,  861,    0,    0,    0,    0,    0,    0,  135,  136,
    0,    0,    0,    0,  137,    0,  138,    0,  139,    0,
    0,    0,    0,  848,  141,    0,  142,    0,    0,    0,
  143,    0,    0,    0,    0,    0,    0,    0,  144,    0,
  848,    0,  145,    0,  848,  146,    0,    0,    0,    0,
  147,  148,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  149,    0,    0,    0,  150,  151,  152,
  153,  154,    0,  155,    0,    0,    0,    0,    0,  156,
    0,  157,  158,    0,    0,  160,  161,    0,    0,    0,
    0,    0,    0,  162,    0,    0,  164,  165,  166,  167,
    0,  168,    0,  169,    0,  170,  171,  172,  173,  174,
    0,    0,    0,    0,  175,    0,  176,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  178,    0,    0,
    0,    0,  179,  180,    0,    0,    0,  181,    0,    0,
  182,  345,  183,  184,  185,  186,  346,  187,  347,  348,
  349,  350,  351,  352,  353,  188,  189,  354,  355,  356,
  357,  358,    0,    0,  359,  360,  190,  191,  361,  192,
  193,  194,  362,  363,  364,  365,  195,  196,  366,  197,
  198,  367,  199,  368,  369,  200,  201,  202,  203,  204,
  205,  206,  370,  371,  372,  373,  207,  208,  209,  374,
  210,  211,  212,  375,  213,  376,  377,  378,  379,  380,
  381,  382,  383,  384,  214,  215,  216,  217,  218,  219,
  220,  221,  222,  223,  224,  225,  226,  227,  228,  229,
  230,  231,  232,  233,  234,  385,  235,  236,  237,  238,
  239,  240,  386,  241,  242,  243,  244,  387,  245,  388,
  246,  247,  248,  249,  250,  251,  252,  253,  254,  255,
  256,  257,  258,  259,  260,  261,  262,  263,  389,  264,
  265,  266,  267,  390,  268,  269,  270,  271,  272,  391,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,  284,  285,  392,  286,    0,  287,  288,  289,  290,
  291,    0,  292,  393,  394,  395,  587,    0,  587,    0,
    0,    0,    0,    0,  587,    0,    0,  587,  587,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  587,
  587,    0,  587,    0,  587,    0,    0,  587,    0,    0,
  587,    0,    0,    0,    0,    0,    0,  587,    0,  587,
  587,    0,    0,    0,  587,    0,    0,  587,    0,    0,
  587,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  587,  587,    0,    0,    0,    0,  587,    0,  587,    0,
  587,    0,    0,    0,    0,    0,  587,    0,  587,    0,
    0,    0,  587,    0,    0,    0,    0,    0,    0,    0,
  587,    0,    0,    0,  587,    0,    0,  587,    0,    0,
    0,    0,  587,  587,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  587,    0,    0,    0,  587,
  587,  587,  587,  587,    0,  587,    0,    0,    0,    0,
    0,  587,    0,  587,  587,    0,    0,  587,  587,    0,
    0,    0,    0,    0,    0,  587,    0,    0,  587,  587,
  587,  587,    0,  587,    0,  587,    0,  587,  587,  587,
  587,  587,    0,    0,    0,    0,  587,    0,  587,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  587,
    0,    0,    0,    0,  587,  587,    0,    0,    0,  587,
    0,    0,  587,  587,  587,  587,  587,  587,    0,  587,
  587,  587,  587,  587,  587,  587,  587,  587,  587,  587,
  587,  587,  587,  587,    0,    0,  587,  587,  587,  587,
  587,  587,  587,  587,  587,  587,  587,  587,  587,  587,
  587,  587,  587,  587,  587,  587,  587,  587,  587,  587,
  587,  587,  587,  587,  587,  587,  587,  587,  587,  587,
  587,  587,  587,  587,  587,  587,  587,  587,  587,  587,
  587,  587,  587,  587,  587,  587,  587,  587,  587,  587,
  587,  587,  587,  587,  587,  587,  587,  587,  587,  587,
  587,  587,  587,  587,  587,  587,  587,  587,  587,  587,
  587,  587,  587,  587,  587,  587,  587,  587,  587,  587,
  587,  587,  587,  587,  587,  587,  587,  587,  587,  587,
  587,  587,  587,  587,  587,  587,  587,  587,  587,  587,
  587,  587,  587,  587,  587,  587,  587,  587,  587,  587,
  587,  587,  587,  587,  587,  587,  587,  587,  587,  587,
  587,  587,  587,  587,  587,  587,  587,    0,  587,  587,
  587,  587,  587,    0,  587,  587,  587,  587,  403,    0,
  403,    0,    0,    0,    0,    0,  403,    0,    0,  403,
  403,  403,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  403,  403,    0,  403,    0,  403,    0,    0,  403,
    0,    0,  403,    0,    0,    0,    0,    0,  403,  403,
    0,  403,  403,    0,    0,  403,  403,    0,    0,  403,
  403,    0,  403,    0,    0,  403,    0,    0,    0,    0,
    0,    0,  403,  403,    0,    0,    0,    0,  403,  403,
  403,    0,  403,    0,  403,    0,    0,    0,  403,    0,
  403,    0,    0,    0,  403,    0,    0,    0,    0,    0,
  403,    0,  403,    0,  403,    0,  403,    0,    0,  403,
    0,    0,  403,    0,  403,  403,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  403,    0,    0,
    0,  403,  403,  403,  403,  403,    0,  403,    0,  403,
  403,    0,    0,  403,    0,  403,  403,    0,    0,  403,
  403,    0,    0,    0,  403,    0,    0,  403,  403,    0,
  403,  403,  403,  403,    0,  403,    0,  403,    0,  403,
  403,  403,  403,  403,    0,    0,    0,    0,  403,    0,
  403,    0,    0,  403,    0,    0,    0,    0,    0,    0,
    0,  403,  403,    0,  403,  403,  403,  403,    0,    0,
    0,  403,    0,    0,  403,    0,  403,  403,  403,  403,
    0,  403,  403,    0,    0,    0,    0,    0,    0,  403,
  403,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  403,  403,    0,  403,  403,  403,    0,    0,    0,    0,
  403,  403,    0,  403,  403,    0,  403,    0,    0,  403,
  403,  403,  403,  403,  403,  403,  403,  403,  403,    0,
  403,  403,  403,    0,  403,  403,  403,    0,  403,    0,
  403,  403,  403,    0,  403,  403,    0,  403,  403,  403,
  403,  403,  403,  403,  403,  403,  403,  403,  403,  403,
  403,  403,  403,  403,  403,  403,  403,  403,  403,    0,
  403,  403,  403,  403,  403,  403,    0,  403,  403,  403,
  403,    0,  403,    0,  403,  403,  403,  403,  403,  403,
  403,  403,  403,  403,  403,  403,  403,  403,  403,  403,
  403,  403,    0,  403,  403,  403,  403,    0,  403,  403,
  403,  403,  403,    0,  403,  403,  403,  403,  403,  403,
  403,  403,  403,  403,  403,  403,  403,  342,  403,  342,
  403,  403,  403,  403,  403,  342,  403,    0,  342,  342,
  342,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  342,  342,    0,  342,    0,  342,    0,    0,  342,    0,
    0,  342,    0,    0,    0,    0,    0,  342,  342,    0,
  342,  342,    0,    0,  337,  342,    0,    0,  342,  342,
    0,  342,    0,    0,  342,    0,    0,    0,    0,    0,
    0,  342,  342,    0,    0,    0,    0,  342,  342,  342,
    0,  342,    0,  342,    0,    0,    0,  342,    0,  342,
    0,    0,    0,  342,    0,    0,    0,    0,    0,  342,
    0,  342,    0,  342,    0,  342,    0,    0,  342,    0,
    0,  342,    0,  342,  342,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  342,    0,    0,    0,
  342,  342,  342,  342,  342,    0,  342,    0,  342,  342,
    0,    0,  342,    0,  342,  342,    0,    0,  342,  342,
    0,    0,    0,  342,    0,    0,  342,  342,    0,  342,
  342,  342,  342,    0,  342,    0,  342,    0,  342,  342,
  342,  342,  342,    0,    0,    0,    0,  342,    0,  342,
    0,    0,  342,    0,    0,    0,    0,    0,    0,    0,
  342,    0,    0,  342,  342,  342,  342,    0,    0,    0,
  342,    0,    0,  342,    0,  342,  342,  342,  342,    0,
  342,  342,    0,    0,    0,    0,    0,    0,  342,  342,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  342,
  342,    0,  342,  342,  342,    0,    0,    0,    0,  342,
  342,    0,  342,  342,    0,  342,    0,    0,  342,  342,
  342,  342,  342,  342,  342,  342,  342,  342,    0,  342,
  342,  342,    0,  342,  342,  342,    0,  342,    0,  342,
  342,  342,    0,  342,  342,    0,  342,  342,  342,  342,
  342,  342,  342,  342,  342,  342,  342,  342,  342,  342,
  342,  342,  342,  342,  342,  342,  342,  342,    0,  342,
  342,  342,  342,  342,  342,    0,  342,  342,  342,  342,
    0,  342,    0,  342,  342,  342,  342,  342,  342,  342,
  342,  342,  342,  342,  342,  342,  342,  342,  342,  342,
  342,    0,  342,  342,  342,  342,    0,  342,  342,  342,
  342,  342,    0,  342,  342,  342,  342,  342,  342,  342,
  342,  342,  342,  342,  342,  342,  342,  342,  342,  342,
  342,  342,  342,  342,  342,  342,    0,  342,  342,  342,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  342,
  342,    0,  342,    0,  342,    0,    0,  342,    0,    0,
  342,    0,    0,    0,    0,    0,  342,  342,    0,  342,
  342,    0,    0,  335,  342,    0,    0,  342,  342,    0,
  342,    0,    0,  342,    0,    0,    0,    0,    0,    0,
  342,  342,    0,    0,    0,    0,  342,  342,  342,    0,
  342,    0,  342,    0,    0,    0,  342,    0,  342,    0,
    0,    0,  342,    0,    0,    0,    0,    0,  342,    0,
  342,    0,  342,    0,  342,    0,    0,  342,    0,    0,
  342,    0,  342,  342,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  342,    0,    0,    0,  342,
  342,  342,  342,  342,    0,  342,    0,  342,  342,    0,
    0,  342,    0,  342,  342,    0,    0,  342,  342,    0,
    0,    0,  342,    0,    0,  342,  342,    0,  342,  342,
  342,  342,    0,  342,    0,  342,    0,  342,  342,  342,
  342,  342,    0,    0,    0,    0,  342,    0,  342,    0,
    0,  342,    0,    0,    0,    0,    0,    0,    0,  342,
    0,    0,  342,  342,  342,  342,    0,    0,    0,  342,
    0,    0,  342,    0,  342,  342,  342,  342,    0,  342,
  342,    0,    0,    0,    0,    0,    0,  342,  342,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  342,  342,
    0,  342,  342,  342,    0,    0,    0,    0,  342,  342,
    0,  342,  342,    0,  342,    0,    0,  342,  342,  342,
  342,  342,  342,  342,  342,  342,  342,    0,  342,  342,
  342,    0,  342,  342,  342,    0,  342,    0,  342,  342,
  342,    0,  342,  342,    0,  342,  342,  342,  342,  342,
  342,  342,  342,  342,  342,  342,  342,  342,  342,  342,
  342,  342,  342,  342,  342,  342,  342,    0,  342,  342,
  342,  342,  342,  342,    0,  342,  342,  342,  342,    0,
  342,    0,  342,  342,  342,  342,  342,  342,  342,  342,
  342,  342,  342,  342,  342,  342,  342,  342,  342,  342,
    0,  342,  342,  342,  342,    0,  342,  342,  342,  342,
  342,    0,  342,  342,  342,  342,  342,  342,  342,  342,
  342,  342,  342,  342,  342,  115,  342,  116,  342,  342,
  342,  342,  342,  118,  342,    0,  119,  120, 2223,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  121,  122,
    0,  123,    0,  124,    0,    0,  125,    0,    0,  126,
    0,    0,    0,    0,    0,    5,  128,    0,  129,  130,
    0,    0,    0,  131,    0,    0, 2433, 2434,    0, 2435,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  135,
  136,    0,    0,    0,    0, 2436, 2437,  138,    0,  139,
    0, 2438,    0,    0,    0,  141,    0,  142,    0,    0,
    0,  143,    0,    0,    0,    0,    0,  675,    0,  144,
    0,  677,    0,  145,    0,    0,  146,    0,    0,   10,
    0,  147,  148,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  149,    0,    0,    0,  150,  151,
  152,  153,  154,    0,  155,    0,  680, 2439,    0,    0,
  156,    0,  157,  158,    0,    0,  160,  161,    0,    0,
    0,  681,    0,    0,  162,    0,    0,  164,  165,  166,
  167,    0,  168,    0,  169,    0,  170,  171,  172,  173,
 2440,    0,    0,    0,    0,  175,    0,  176,    0,    0,
   15,    0,    0,    0,    0,    0,    0,    0,  178,    0,
    0,    0,   16,  179,  180,    0,    0,    0,  688,    0,
    0,  182,    0,  183,  184,  185,  186,    0,  187,  689,
    0,    0,    0,    0,    0,    0,  188,  189,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 2441,  699,    0,
  192,  193,  194,    0,    0,    0,    0,  195,  196,    0,
  197,  198,    0,  199,    0,    0,  200, 2442,  202,  203,
  204,  205,  206, 2443, 2444, 2445,    0,  207,  208,  209,
    0,  210,  211,  212,    0,  213,    0,  708,  709,  710,
    0,  711,  712,    0,  713,  214,  215,  216,  217,  218,
  219,  714,  221,  715,  223,  716,  717,  718,  719,  720,
  721,  722,  723,  724,  725,  726,    0,  727,  728,  729,
  730,  731,  240,    0,  733,  734,  735,  244,    0,  736,
    0,  246,  738,  739,  740,  741,  251,  252,  742,  254,
  743,  744,  745,  258,  746,  260,  747,  262,  748,    0,
  749,  750,  751,  752,    0,  753,  754,  755,  271,  756,
    0,  757,  758,  275,  759,  277,  278,  760,  280,  281,
  282,  283,  284,  285, 1296,  761, 1296,  287,  288,  289,
  290,  291, 1296,  762,    0, 1296, 1296,    0,    0, 1296,
    0,    0, 1296,    0,    0,    0,    0, 1296, 1296,    0,
 1296,    0, 1296,    0,    0, 1296,    0, 1298, 1296, 1296,
    0, 1296,    0,    0,    0, 1296,    0, 1296, 1296,    0,
    0,    0, 1296,    0,    0, 1296,    0,    0, 1296,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1296, 1296,
    0,    0,    0,    0, 1296,    0, 1296,    0, 1296,    0,
    0, 1296,    0,    0, 1296,    0, 1296, 1296, 1296, 1296,
 1296, 1296, 1296, 1296,    0, 1296,    0,    0, 1296,    0,
    0,    0, 1296,    0,    0, 1296,    0,    0,    0,    0,
 1296, 1296, 1296,    0, 1296,    0,    0,    0,    0,    0,
    0,    0,    0, 1296,    0,    0,    0, 1296, 1296, 1296,
 1296, 1296,    0, 1296,    0,    0,    0,    0,    0, 1296,
    0, 1296, 1296, 1296,    0, 1296, 1296,    0,    0,    0,
    0,    0,    0, 1296,    0,    0, 1296, 1296, 1296, 1296,
 1296, 1296,    0, 1296,    0, 1296, 1296, 1296, 1296, 1296,
    0,    0,    0,    0, 1296,    0, 1296,    0,    0,    0,
    0,    0, 1296,    0,    0,    0,    0, 1296,    0,    0,
    0,    0, 1296, 1296,    0,    0,    0, 1296,    0,    0,
 1296,    0, 1296, 1296, 1296, 1296,    0, 1296,    0,    0,
    0,    0,    0,    0,    0, 1296, 1296, 1296, 1296,    0,
    0,    0,    0,    0,    0,    0, 1296, 1296,    0, 1296,
 1296, 1296,    0,    0, 1296,    0, 1296, 1296,    0, 1296,
 1296,    0, 1296,    0,    0, 1296, 1296, 1296, 1296, 1296,
 1296, 1296,    0,    0,    0,    0, 1296, 1296, 1296,    0,
 1296, 1296, 1296,    0, 1296,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1296, 1296, 1296, 1296, 1296, 1296,
 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
 1296, 1296, 1296, 1296, 1296,    0, 1296, 1296, 1296, 1296,
 1296, 1296,    0, 1296, 1296, 1296, 1296,    0, 1296,    0,
 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,    0, 1296,
 1296, 1296, 1296,    0, 1296, 1296, 1296, 1296, 1296,    0,
 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
 1296, 1296, 1296,  115, 1296,  116, 1296, 1296, 1296, 1296,
 1296,  118, 1296,    0,  119,  120,    0,    0,  977,    0,
    0,  978,    0,    0,    0,    0,  121,  122,    0,  123,
    0,  124,    0,    0,  125,    0,    0,  126,  979,    0,
  980,    0,    0,    0,  128,    0,  129,  130,    0,    0,
    0,  131,    0,    0,  132,    0,    0,  134,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  135,  136,    0,
    0,    0,    0,  137,    0,  138,    0,  139,    0,    0,
  981,    0,    0,  141,    0,  142,  982,  983,  984,  143,
  985,  986,  987,    0,  988,    0,    0,  144,    0,    0,
    0,  145,    0,    0,  146,    0,    0,    0,    0,  147,
  148,  989,    0,  990,    0,    0,    0,    0,    0,    0,
    0,    0,  149,    0,    0,    0,  150,  151,  152,  153,
  154,    0,  155,    0,    0,    0,    0,    0,  156,    0,
  157,  158,  991,    0,  160,  161,    0,    0,    0,    0,
    0,    0,  162,    0,    0,  164,  165,  166,  167,  992,
  168,    0,  169,    0,  170,  171,  172,  173,  174,    0,
    0,    0,    0,  175,    0,  176,    0,    0,    0,    0,
    0,  993,    0,    0,    0,    0,  178,    0,    0,    0,
    0,  179,  180,    0,    0,    0,  181,    0,    0,  182,
    0,  183,  184,  185,  186,    0, 1131,    0,    0,    0,
    0,    0,    0,    0,  188,  189,  994,  995,    0,    0,
    0,    0,    0,    0,    0,  190,  191,    0,  192,  193,
  194,    0,    0,  996,    0,  195,  196,    0,  197,  198,
    0,  199,    0,    0,  200,  201,  202,  203,  204,  205,
  206,    0,    0,    0,    0,  207,  208,  209,    0,  210,
  211,  212,    0,  213,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  214,  215,  216,  217,  218,  219,  220,
  221,  222,  223,  224,  225,  226,  227,  228,  229,  230,
  231,  232,  233,  234,    0,  235,  236,  237,  238,  239,
  240,    0,  241,  242,  243,  244,    0,  245,    0,  246,
  247,  248,  249,  250,  251,  252,  253,  254,  255,  256,
  257,  258,  259,  260,  261,  262,  263,    0,  264,  265,
  266,  267,    0,  268,  269,  270,  271,  272,    0,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  115,  286,  116,  287,  288,  289,  290,  291,
  118,  292,    0,  119,  120,    0,    0,  977,    0,    0,
  978,    0,    0,    0,    0,  121, 1246,    0,  123,    0,
  124,    0,    0,  125,    0,    0,  126,  979,    0,  980,
    0,    0,    0,  128,    0,  129,  130,    0,    0,    0,
  131,    0,    0,  132,    0,    0,  134,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  135,  136,    0,    0,
    0,    0,  137,    0,  138,    0,  139,    0,    0,  981,
    0,    0,  141,    0,  142,  982,  983,  984,  143,  985,
  986,  987,    0,  988,    0,    0,  144,    0,    0,    0,
  145,    0,    0,  146,    0,    0,    0,    0,  147,  148,
  989,    0,  990,    0,    0,    0,    0,    0,    0,    0,
    0,  149,    0,    0,    0,  150,  151,  152,  153,  154,
    0,  155,    0,    0,    0,    0,    0,  156,    0,  157,
  158,  991,    0,  160,  161,    0,    0,    0,    0,    0,
    0,  162,    0,    0,  164,  165,  166,  167,  992,  168,
    0,  169,    0,  170,  171,  172,  173,  174,    0,    0,
    0,    0,  175,    0,  176,    0,    0,    0,    0,    0,
  993,    0,    0,    0,    0,  178,    0,    0,    0,    0,
  179,  180,    0,    0,    0,  181,    0,    0,  182,    0,
  183,  184,  185,  186,    0,  187,    0,    0,    0,    0,
    0,    0,    0,  188,  189,  994,  995,    0,    0,    0,
    0,    0,    0,    0,  190,  191,    0,  192,  193,  194,
    0,    0,  996,    0,  195,  196,    0,  197,  198,    0,
  199,    0,    0,  200,  201,  202,  203,  204,  205,  206,
    0,    0,    0,    0,  207,  208,  209,    0,  210,  211,
  212,    0,  213,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  214,  215,  216,  217,  218,  219,  220,  221,
  222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
  232,  233,  234,    0,  235,  236,  237,  238,  239,  240,
    0,  241,  242,  243, 1247,    0,  245,    0,  246,  247,
  248,  249,  250,  251,  252,  253,  254,  255,  256,  257,
  258,  259,  260,  261,  262,  263,    0,  264,  265,  266,
  267,    0,  268,  269,  270,  271,  272,    0,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  115,  286,  116,  287,  288,  289,  290,  291,  118,
  292,    0,  119,  120,    0,    0,  977,    0,    0,  978,
    0,    0,    0,    0,  121,  122,    0,  123,    0,  124,
    0,    0,  125,    0,    0,  126,  979,    0,  980,    0,
    0,    0,  128,    0,  129,  130,    0,    0,    0,  131,
    0,    0,  132,    0,    0,  134,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  135,  136,    0,    0,    0,
    0,  137,    0,  138,    0,  139,    0,    0,  981,    0,
    0,  141,    0,  142,  982,  983,  984,  143,  985,  986,
  987,    0,  988,    0,    0,  144,    0,    0,    0,  145,
    0,    0,  146,    0,    0,    0,    0,  147,  148,  989,
    0,  990,    0,    0,    0,    0,    0,    0,    0,    0,
  149,    0,    0,    0,  150,  151,  152,  153,  154,    0,
  155,    0,    0,    0,    0,    0,  156,    0,  157,  158,
  991,    0,  160,  161,    0,    0,    0,    0,    0,    0,
  162,    0,    0,  164,  165,  166,  167,  992,  168,    0,
  169,    0,  170,  171,  172,  173,  174,    0,    0,    0,
    0,  175,    0,  176,    0,    0,    0,    0,    0,  993,
    0,    0,    0,    0,  178,    0,    0,    0,    0,  179,
  180,    0,    0,    0,  181,    0,    0,  182,    0,  183,
  184,  185,  186,    0,  187,    0,    0,    0,    0,    0,
    0,    0,  188,  189,  994,  995,    0,    0,    0,    0,
    0,    0,    0,  190,  191,    0,  192,  193,  194,    0,
    0,  996,    0,  195,  196,    0,  197,  198,    0,  199,
    0,    0,  200,  201,  202,  203,  204,  205,  206,    0,
    0,    0,    0,  207,  208,  209,    0,  210,  211,  212,
    0,  213,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  214,  215,  216,  217,  218,  219,  220,  221,  222,
  223,  224,  225,  226,  227,  228,  229,  230,  231,  232,
  233,  234,    0,  235,  236,  237,  238,  239,  240,    0,
  241,  242,  243,  244,    0,  245,    0,  246,  247,  248,
  249,  250,  251,  252,  253,  254,  255,  256,  257,  258,
  259,  260,  261,  262,  263,    0,  264,  265,  266,  267,
    0,  268,  269,  270,  271,  272,    0,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
    0,  286,    0,  287,  288,  289,  290,  291,  115,  292,
  116,  117,    0,    0,    0,    0,  118,    0,    0,  119,
  120,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  121,  122,    0,  123,    0,  124,    0,    0,  125,
    0,    0,  126,    0,    0,    0,    0,    0,  127,  128,
    0,  129,  130,    0,    0,    0,  131,    0,    0,  132,
  133,    0,  134,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  135,  136,    0,    0,    0,    0,  137,    0,
  138,    0,  139,    0,  140,    0,    0,    0,  141,    0,
  142,    0,    0,    0,  143,    0,    0,    0,    0,    0,
    0,    0,  144,    0,    0,    0,  145,    0,    0,  146,
    0,    0,    0,    0,  147,  148,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  149,    0,    0,
    0,  150,  151,  152,  153,  154,    0,  155,    0,    0,
    0,    0,    0,  156,    0,  157,  158,    0,  159,  160,
  161,    0,    0,    0,    0,    0,    0,  162,  163,    0,
  164,  165,  166,  167,    0,  168,    0,  169,    0,  170,
  171,  172,  173,  174,    0,    0,    0,    0,  175,    0,
  176,    0,    0,  177,    0,    0,    0,    0,    0,    0,
    0,  178,    0,    0,    0,    0,  179,  180,    0,    0,
    0,  181,    0,    0,  182,    0,  183,  184,  185,  186,
    0,  187,    0,    0,    0,    0,    0,    0,    0,  188,
  189,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  190,  191,    0,  192,  193,  194,    0,    0,    0,    0,
  195,  196,    0,  197,  198,    0,  199,    0,    0,  200,
  201,  202,  203,  204,  205,  206,    0,    0,    0,    0,
  207,  208,  209,    0,  210,  211,  212,    0,  213,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  214,  215,
  216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,  233,  234,    0,
  235,  236,  237,  238,  239,  240,    0,  241,  242,  243,
  244,    0,  245,    0,  246,  247,  248,  249,  250,  251,
  252,  253,  254,  255,  256,  257,  258,  259,  260,  261,
  262,  263,    0,  264,  265,  266,  267,    0,  268,  269,
  270,  271,  272,    0,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,   59,  286,   59,
  287,  288,  289,  290,  291,   59,  292,    0,   59,   59,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   59,   59,    0,   59,    0,   59,    0,    0,   59,    0,
    0,   59,    0,    0,    0,    0,    0,   57,   59,    0,
   59,   59,    0,    0,    0,   59,    0,    0,   59,   57,
    0,   59,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   59,   59,    0,    0,    0,    0,   59,    0,   59,
    0,   59,    0,   57,    0,    0,    0,   59,    0,   59,
    0,    0,    0,   59,    0,    0,    0,    0,    0,    0,
    0,   59,    0,    0,    0,   59,    0,    0,   59,    0,
    0,    0,    0,   59,   59,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   59,    0,    0,    0,
   59,   59,   59,   59,   59,    0,   59,    0,    0,    0,
    0,    0,   59,    0,   59,   59,    0,   57,   59,   59,
    0,    0,    0,    0,    0,    0,   59,   57,    0,   59,
   59,   59,   59,    0,   59,    0,   59,    0,   59,   59,
   59,   59,   59,    0,    0,    0,    0,   59,    0,   59,
    0,    0,   57,    0,    0,    0,    0,    0,    0,    0,
   59,    0,    0,    0,    0,   59,   59,    0,    0,    0,
   59,    0,    0,   59,    0,   59,   59,   59,   59,    0,
   59,    0,    0,    0,    0,    0,    0,    0,   59,   59,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   59,
   59,    0,   59,   59,   59,    0,    0,    0,    0,   59,
   59,    0,   59,   59,    0,   59,    0,    0,   59,   59,
   59,   59,   59,   59,   59,    0,    0,    0,    0,   59,
   59,   59,    0,   59,   59,   59,    0,   59,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   59,   59,   59,
   59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
   59,   59,   59,   59,   59,   59,   59,   59,    0,   59,
   59,   59,   59,   59,   59,    0,   59,   59,   59,   59,
    0,   59,    0,   59,   59,   59,   59,   59,   59,   59,
   59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
   59,    0,   59,   59,   59,   59,    0,   59,   59,   59,
   59,   59,    0,   59,   59,   59,   59,   59,   59,   59,
   59,   59,   59,   59,   59,   59,  115,   59,  116,   59,
   59,   59,   59,   59,  118,   59,    0,  119,  120,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  121,
  122,    0,  123,    0,  124,    0,    0,  125,    0,    0,
  126,    0,    0,    0,    0,    0,    0,  128,    0,  129,
  130,    0,    0,    0,  131,    0,    0,  132,    0,    0,
  134,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  135,  136,    0, 1512,    0,    0,  137,    0,  138,    0,
  139,    0,    0,    0,    0,    0,  141,    0,  142,    0,
    0,    0,  143,    0,    0,    0,    0,    0,    0,    0,
  144,    0,    0,    0,  145,    0,    0,  146,    0,    0,
    0,    0,  147,  148,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  149,    0,    0,    0,  150,
  151,  152,  153,  154,    0,  155,    0,    0,    0,    0,
    0,  156, 1513,  157,  158,    0,    0,  160,  161,    0,
    0,    0,    0,    0,    0,  162,    0,    0,  164,  165,
  166,  167,    0,  168,    0,  169,    0,  170,  171,  172,
  173,  174,    0,    0,    0,    0,  175, 1514,  176,    0,
    0,    0, 1515,    0,    0,    0,    0,    0, 1516,  178,
    0,    0,    0,    0,  179,  180,    0,    0,    0,  181,
    0,    0,  182,    0,  183,  184,  185, 1517,    0,  187,
    0,    0,    0,    0,    0,    0,    0,  188,  189,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  190,  191,
    0,  192,  193,  194,    0,    0,    0,    0,  195,  196,
    0,  197,  198,    0,  199,    0,    0,  200,  201,  202,
  203,  204,  205,  206,    0,    0,    0,    0,  207,  208,
  209,    0,  210,  211,  212,    0,  213,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  214,  215,  216,  217,
  218,  219,  220,  221,  222,  223,  224,  225,  226,  227,
  228,  229,  230,  231,  232,  233,  234,    0,  235,  236,
  237,  238,  239,  240,    0,  241,  242,  243,  244,    0,
  245,    0,  246,  247,  248,  249,  250,  251,  252,  253,
  254,  255,  256,  257,  258,  259,  260,  261,  262,  263,
    0,  264,  265,  266,  267,    0,  268,  269,  270,  271,
  272,    0,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  115,  286,  116,  287,  288,
  289,  290,  291,  118,  292,    0,  119,  120,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  121,  122,
    0,  123,    0,  124,    0,    0,  125,    0,    0,  126,
    0,    0,    0,    0,    0,    0,  128,    0,  129,  130,
    0,    0,    0,  131,    0,    0,  132,    0,    0,  134,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  135,
  136,    0,    0,    0,    0,  137,    0,  138,    0,  139,
    0,    0,    0,    0,    0,  141, 1379,  142,    0,    0,
    0,  143,    0,    0,    0,    0,    0,    0,    0,  144,
    0,    0,    0,  145,    0,    0,  146,    0,    0, 1380,
    0,  147,  148,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  149,    0,    0,    0,  150,  151,
  152,  153,  154,    0,  155,    0,    0,    0,    0,    0,
  156,    0,  157,  158,    0,    0,  160,  161,    0,    0,
    0,    0,    0,    0,  162,    0,    0,  164,  165,  166,
  167,    0,  168,    0, 1998,    0,  170,  171,  172,  173,
  174,    0,    0,    0,    0,  175,    0,  176,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  178,    0,
    0,    0,    0,  179,  180,    0,    0,    0,  181,    0,
    0,  182,    0,  183,  184,  185,  186,    0,  187,    0,
    0,    0,    0,    0,    0,    0,  188,  189,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  190,  191,    0,
  192,  193,  194,    0,    0,    0,    0,  195,  196,    0,
  197,  198,    0,  199,    0,    0,  200,  201,  202,  203,
  204,  205,  206,    0,    0,    0,    0,  207,  208,  209,
    0,  210,  211,  212,    0,  213,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  214,  215,  216,  217,  218,
  219,  220,  221,  222,  223,  224,  225,  226,  227,  228,
  229,  230,  231,  232,  233,  234,    0,  235,  236,  237,
  238,  239,  240,    0,  241,  242,  243,  244,    0,  245,
    0,  246,  247,  248,  249,  250,  251,  252,  253,  254,
  255,  256,  257,  258,  259,  260,  261,  262,  263,    0,
  264,  265,  266,  267,    0,  268,  269,  270,  271,  272,
    0,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  115,  286,  116,  287,  288,  289,
  290,  291,  118,  292,    0,  119,  120,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  121,  122,    0,
  123,    0,  124,    0,    0,  125,    0,    0,  126,    0,
    0,    0,    0,    0,    0,  128,    0,  129,  130,    0,
    0,    0,  131,    0,    0,  132,    0,    0,  134,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  135,  136,
    0,    0,    0,    0,  137,    0,  138,    0,  139,    0,
    0,    0,    0,    0,  141,    0,  142,    0,    0,    0,
  143,    0,    0,    0,    0,    0,    0,    0,  144,    0,
    0,    0,  145,    0,    0,  146,    0,    0,    0,    0,
  147,  148,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  149,  315,    0,    0,  150,  151,  152,
  153,  154,    0,  155,    0,    0,    0,    0,    0,  156,
    0,  157,  158,    0,    0,  160,  161,    0,    0,    0,
    0,    0,    0,  162,    0,    0,  164,  165,  166,  167,
    0,  168,    0,  169,    0,  170,  171,  172,  173,  174,
    0,    0,    0,    0,  175,    0,  176,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  178,    0,    0,
    0,    0,  179,  180,    0,    0,    0,  181,    0,    0,
  182,    0,  183,  184,  185,  186,    0,  187,    0,    0,
    0,    0,    0,    0,    0,  188,  189,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  190,  191,    0,  192,
  193,  194,    0,    0,    0,    0,  195,  196,    0,  197,
  198,    0,  199,    0,    0,  200,  201,  202,  203,  204,
  205,  206,    0,    0,    0,    0,  207,  208,  209,    0,
  210,  211,  212,    0,  213,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  214,  215,  216,  217,  218,  219,
  220,  221,  222,  223,  224,  225,  226,  227,  228,  229,
  230,  231,  232,  233,  234,    0,  235,  236,  237,  238,
  239,  240,    0,  241,  242,  243,  244,    0,  245,    0,
  246,  247,  248,  249,  250,  251,  252,  253,  254,  255,
  256,  257,  258,  259,  260,  261,  262,  263,    0,  264,
  265,  266,  267,    0,  268,  269,  270,  271,  272,    0,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,  284,  285,  115,  286,  116,  287,  288,  289,  290,
  291,  118,  292,    0,  119,  120,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  121,  122,    0,  123,
    0,  124,    0,    0,  125,    0,    0,  126,    0,    0,
    0,    0,    0,    0,  128,    0,  129,  130,    0,    0,
    0,  131,    0,    0,  132,    0,    0,  134,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  135,  136,    0,
    0,    0,    0,  137,    0,  138,    0,  139,    0,    0,
    0,    0,    0,  141,    0,  142,    0,    0,    0,  143,
    0,    0,    0,    0,    0,    0,    0,  144,    0,    0,
    0,  145,    0,    0,  146,    0,    0,    0,    0,  147,
  148,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  149,    0,    0,    0,  150,  151,  152,  153,
  154,    0,  155,    0,    0,    0,    0,    0,  156,    0,
  157,  158,    0,    0,  160,  161,    0,    0,    0,    0,
    0,    0,  162,    0,    0,  164,  165,  166,  167,    0,
  168,    0,  169,    0,  170,  171,  172,  173,  174,    0,
    0,    0,    0,  175,    0,  176,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  178,    0,    0,    0,
    0,  179,  180,    0,    0,    0,  181,    0,    0,  182,
    0,  183,  184,  185,  186,    0,  187,    0,    0,    0,
    0,    0,    0,    0,  188,  189,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  190,  191,    0,  192,  193,
  194,    0,    0,    0,    0,  195,  196,    0,  197,  198,
    0,  199,    0,    0,  200,  201,  202,  203,  204,  205,
  206,    0,    0,    0,    0,  207,  208,  209,    0,  210,
  211,  212,    0,  213,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  214,  215,  216,  217,  218,  219,  220,
  221,  222,  223,  224,  225,  226,  227,  228,  229,  230,
  231,  232,  233,  234,    0,  235,  236,  237,  238,  239,
  240,    0,  241,  242,  243,  244,    0,  245,    0,  246,
  247,  248,  249,  250,  251,  252,  253,  254,  255,  256,
  257,  258,  259,  260,  261,  262,  263,  320,  264,  265,
  266,  267,    0,  268,  269,  270,  271,  272,    0,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  115,  286,  116,  287,  288,  289,  290,  291,
  118,  292,    0,  119,  120,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  121,  122,    0,  123,    0,
  124,    0,    0,  125,    0,    0,  126,    0,    0,    0,
    0,    0,    0,  128,    0,  129,  130,    0,    0,    0,
  131,    0,    0,  132,    0,    0,  134,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  135,  136,    0,    0,
    0,    0,  137,    0,  138,    0,  139,    0,    0,    0,
    0,    0,  141,    0,  142,    0,    0,    0,  143,    0,
    0,    0,    0,    0,    0,    0,  144,    0,    0,    0,
  145,    0,    0,  146,    0,    0,    0,    0,  147,  148,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  149,    0,    0,    0,  150,  151,  152,  153,  154,
    0,  155,    0,    0,    0,    0,    0,  156,    0,  157,
  158,    0,    0,  160,  161,    0,    0,    0,    0,    0,
    0,  162,    0,    0,  164,  165,  166,  167,    0,  168,
    0,  169,    0,  170,  171,  172,  173,  174,    0,    0,
    0,    0,  175,    0,  176,    0,    0,    0,  825,    0,
    0,    0,    0,    0,    0,  178,    0,    0,    0,    0,
  179,  180,    0,    0,    0,  181,    0,    0,  182,    0,
  183,  184,  185,  186,    0,  187,    0,    0,    0,    0,
    0,    0,    0,  188,  189,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  190,  191,    0,  192,  193,  194,
    0,    0,    0,    0,  195,  196,    0,  197,  198,    0,
  199,    0,    0,  200,  201,  202,  203,  204,  205,  206,
    0,    0,    0,    0,  207,  208,  209,    0,  210,  211,
  212,    0,  213,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  214,  215,  216,  217,  218,  219,  220,  221,
  222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
  232,  233,  234,    0,  235,  236,  237,  238,  239,  240,
    0,  241,  242,  243,  244,    0,  245,    0,  246,  247,
  248,  249,  250,  251,  252,  253,  254,  255,  256,  257,
  258,  259,  260,  261,  262,  263,    0,  264,  265,  266,
  267,    0,  268,  269,  270,  271,  272,    0,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  115,  286,  116,  287,  288,  289,  290,  291,  118,
  292,    0,  119,  120,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  121,  122,    0,  123,  938,  124,
    0,    0,  125,    0,    0,  126,    0,    0,    0,    0,
    0,    0,  128,    0,  129,  130,    0,    0,    0,  131,
    0,    0,  132,    0,    0,  134,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  135,  136,    0,    0,    0,
    0,  137,    0,  138,    0,  139,    0,    0,    0,    0,
    0,  141,    0,  142,    0,    0,    0,  143,    0,    0,
    0,    0,    0,    0,    0,  144,    0,    0,    0,  145,
    0,    0,  146,    0,    0,    0,    0,  147,  148,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  149,    0,    0,    0,  150,  151,  152,  153,  154,    0,
  155,    0,    0,    0,    0,    0,  156,    0,  157,  158,
    0,    0,  160,  161,    0,    0,    0,    0,    0,    0,
  162,    0,    0,  164,  165,  166,  167,    0,  168,    0,
  169,    0,  170,  171,  172,  173,  174,    0,    0,    0,
    0,  175,    0,  176,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  178,    0,    0,    0,    0,  179,
  180,    0,    0,    0,  181,    0,    0,  182,    0,  183,
  184,  185,  186,    0,  187,    0,    0,    0,    0,    0,
    0,    0,  188,  189,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  190,  191,    0,  192,  193,  194,    0,
    0,    0,    0,  195,  196,    0,  197,  198,    0,  199,
    0,    0,  200,  201,  202,  203,  204,  205,  206,    0,
    0,    0,    0,  207,  208,  209,    0,  210,  211,  212,
    0,  213,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  214,  215,  216,  217,  218,  219,  220,  221,  222,
  223,  224,  225,  226,  227,  228,  229,  230,  231,  232,
  233,  234,    0,  235,  236,  237,  238,  239,  240,    0,
  241,  242,  243,  244,    0,  245,    0,  246,  247,  248,
  249,  250,  251,  252,  253,  254,  255,  256,  257,  258,
  259,  260,  261,  262,  263,    0,  264,  265,  266,  267,
    0,  268,  269,  270,  271,  272,    0,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  115,  286,  116,  287,  288,  289,  290,  291,  118,  292,
    0,  119,  120,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  121,  122,    0,  123,  944,  124,    0,
    0,  125,    0,    0,  126,    0,    0,    0,    0,    0,
    0,  128,    0,  129,  130,    0,    0,    0,  131,    0,
    0,  132,    0,    0,  134,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  135,  136,    0,    0,    0,    0,
  137,    0,  138,    0,  139,    0,    0,    0,    0,    0,
  141,    0,  142,    0,    0,    0,  143,    0,    0,    0,
    0,    0,    0,    0,  144,    0,    0,    0,  145,    0,
    0,  146,    0,    0,    0,    0,  147,  148,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  149,
    0,    0,    0,  150,  151,  152,  153,  154,    0,  155,
    0,    0,    0,    0,    0,  156,    0,  157,  158,    0,
    0,  160,  161,    0,    0,    0,    0,    0,    0,  162,
    0,    0,  164,  165,  166,  167,    0,  168,    0,  169,
    0,  170,  171,  172,  173,  174,    0,    0,    0,    0,
  175,    0,  176,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  178,    0,    0,    0,    0,  179,  180,
    0,    0,    0,  181,    0,    0,  182,    0,  183,  184,
  185,  186,    0,  187,    0,    0,    0,    0,    0,    0,
    0,  188,  189,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  190,  191,    0,  192,  193,  194,    0,    0,
    0,    0,  195,  196,    0,  197,  198,    0,  199,    0,
    0,  200,  201,  202,  203,  204,  205,  206,    0,    0,
    0,    0,  207,  208,  209,    0,  210,  211,  212,    0,
  213,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  214,  215,  216,  217,  218,  219,  220,  221,  222,  223,
  224,  225,  226,  227,  228,  229,  230,  231,  232,  233,
  234,    0,  235,  236,  237,  238,  239,  240,    0,  241,
  242,  243,  244,    0,  245,    0,  246,  247,  248,  249,
  250,  251,  252,  253,  254,  255,  256,  257,  258,  259,
  260,  261,  262,  263,    0,  264,  265,  266,  267,    0,
  268,  269,  270,  271,  272,    0,  273,  274,  275,  276,
  277,  278,  279,  280,  281,  282,  283,  284,  285,  115,
  286,  116,  287,  288,  289,  290,  291,  118,  292,    0,
  119,  120,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  121,  122,    0,  123,    0,  124,    0,    0,
  125,    0,    0,  126,    0,    0,    0,    0,    0,    0,
  128,    0,  129,  130,    0,    0,    0,  131,    0,    0,
  132,    0,    0,  134, 1658,    0,    0,    0,    0,    0,
    0,    0,    0,  135,  136,    0,    0,    0,    0,  137,
    0,  138,    0,  139,    0,    0,    0,    0,    0,  141,
    0,  142,    0,    0,    0,  143,    0,    0,    0,    0,
    0,    0,    0,  144,    0,    0,    0,  145,    0,    0,
  146,    0,    0,    0,    0,  147,  148,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  149,    0,
    0,    0,  150,  151,  152,  153,  154,    0,  155,    0,
    0,    0,    0,    0,  156,    0,  157,  158,    0,    0,
  160,  161,    0,    0,    0,    0,    0,    0,  162,    0,
    0,  164,  165,  166,  167,    0,  168,    0,  169,    0,
  170,  171,  172,  173,  174,    0,    0,    0,    0,  175,
    0,  176,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  178,    0,    0,    0,    0,  179,  180,    0,
    0,    0,  181,    0,    0,  182,    0,  183,  184,  185,
  186,    0,  187,    0,    0,    0,    0,    0,    0,    0,
  188,  189,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  190,  191,    0,  192,  193,  194,    0,    0,    0,
    0,  195,  196,    0,  197,  198,    0,  199,    0,    0,
  200,  201,  202,  203,  204,  205,  206,    0,    0,    0,
    0,  207,  208,  209,    0,  210,  211,  212,    0,  213,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  214,
  215,  216,  217,  218,  219,  220,  221,  222,  223,  224,
  225,  226,  227,  228,  229,  230,  231,  232,  233,  234,
    0,  235,  236,  237,  238,  239,  240,    0,  241,  242,
  243,  244,    0,  245,    0,  246,  247,  248,  249,  250,
  251,  252,  253,  254,  255,  256,  257,  258,  259,  260,
  261,  262,  263,    0,  264,  265,  266,  267,    0,  268,
  269,  270,  271,  272,    0,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  283,  284,  285,  115,  286,
  116,  287,  288,  289,  290,  291,  118,  292,    0,  119,
  120,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  121,  122,    0,  123,    0,  124,    0,    0,  125,
    0,    0,  126,    0,    0,    0,    0,    0,    0,  128,
    0,  129,  130,    0,    0,    0,  131,    0,    0,  132,
    0,    0,  134,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  135,  136,    0,    0,    0,    0,  137,    0,
  138,    0,  139,    0,    0,    0,    0,    0,  141,    0,
  142,    0,    0,    0,  143,    0,    0,    0,    0,    0,
    0,    0,  144,    0,    0,    0,  145,    0,    0,  146,
    0,    0,    0,    0,  147,  148,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  149,    0,    0,
    0,  150,  151,  152,  153,  154,    0,  155,    0,    0,
    0,    0,    0,  156,    0,  157,  158,    0,    0,  160,
  161,    0,    0,    0,    0,    0,    0,  162,    0,    0,
  164,  165,  166,  167,    0,  168,    0,  169,    0,  170,
  171,  172,  173,  174,    0,    0,    0,    0,  175,    0,
  176,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  178,    0,    0,    0,    0,  179,  180,    0,    0,
    0,  181,    0,    0,  182,    0,  183,  184,  185,  186,
 1793,  187,    0,    0,    0,    0,    0,    0,    0,  188,
  189,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  190,  191,    0,  192,  193,  194,    0,    0,    0,    0,
  195,  196,    0,  197,  198,    0,  199,    0,    0,  200,
  201,  202,  203,  204,  205,  206,    0,    0,    0,    0,
  207,  208,  209,    0,  210,  211,  212,    0,  213,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  214,  215,
  216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,  233,  234,    0,
  235,  236,  237,  238,  239,  240,    0,  241,  242,  243,
  244,    0,  245,    0,  246,  247,  248,  249,  250,  251,
  252,  253,  254,  255,  256,  257,  258,  259,  260,  261,
  262,  263,    0,  264,  265,  266,  267,    0,  268,  269,
  270,  271,  272,    0,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  115,  286,  116,
  287,  288,  289,  290,  291,  118,  292,    0,  119,  120,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  121,  122,    0,  123,    0,  124,    0,    0,  125,    0,
    0,  126,    0,    0,    0,    0,    0,    0,  128,    0,
  129,  130,    0,    0,    0,  131,    0,    0,  132,    0,
    0,  134,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  135,  136,    0,    0,    0,    0,  137,    0,  138,
    0,  139,    0,    0,    0,    0,    0,  141,    0,  142,
    0,    0,    0,  143,    0,    0,    0,    0,    0,    0,
    0,  144,    0,    0,    0,  145,    0,    0,  146,    0,
    0,    0,    0,  147,  148,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  149,    0,    0,    0,
  150,  151,  152,  153,  154,    0,  155,    0,    0,    0,
    0,    0,  156,    0,  157,  158,    0,    0,  160,  161,
    0,    0,    0,    0,    0,    0,  162,    0,    0,  164,
  165,  166,  167,    0,  168,    0,  169,    0,  170,  171,
  172,  173,  174,    0,    0,    0,    0,  175,    0,  176,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  178,    0,    0,    0,    0,  179,  180,    0,    0,    0,
  181,    0,    0,  182,    0,  183,  184,  185,  186, 2325,
  187,    0,    0,    0,    0,    0,    0,    0,  188,  189,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  190,
  191,    0,  192,  193,  194,    0,    0,    0,    0,  195,
  196,    0,  197,  198,    0,  199,    0,    0,  200,  201,
  202,  203,  204,  205,  206,    0,    0,    0,    0,  207,
  208,  209,    0,  210,  211,  212,    0,  213,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  214,  215,  216,
  217,  218,  219,  220,  221,  222,  223,  224,  225,  226,
  227,  228,  229,  230,  231,  232,  233,  234,    0,  235,
  236,  237,  238,  239,  240,    0,  241,  242,  243,  244,
    0,  245,    0,  246,  247,  248,  249,  250,  251,  252,
  253,  254,  255,  256,  257,  258,  259,  260,  261,  262,
  263,    0,  264,  265,  266,  267,    0,  268,  269,  270,
  271,  272,    0,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  115,  286,  116,  287,
  288,  289,  290,  291,  118,  292,    0,  119,  120,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  121,
  122,    0,  123,    0,  124,    0,    0,  125,    0,    0,
  126,    0,    0,    0,    0,    0,    0,  128,    0,  129,
  130,    0,    0,    0,  131,    0,    0,  132,    0,    0,
  134,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  135,  136,    0,    0,    0,    0,  137,    0,  138,    0,
  139,    0,    0,    0,    0,    0,  141,    0,  142,    0,
    0,    0,  143,    0,    0,    0,    0,    0,    0,    0,
  144,    0,    0,    0,  145,    0,    0,  146,    0,    0,
    0,    0,  147,  148,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  149,    0,    0,    0,  150,
  151,  152,  153,  154,    0,  155,    0,    0,    0,    0,
    0,  156,    0,  157,  158,    0,    0,  160,  161,    0,
    0,    0,    0,    0,    0,  162,    0,    0,  164,  165,
  166,  167,    0,  168,    0,  169,    0,  170,  171,  172,
  173,  174,    0,    0,    0,    0,  175,    0,  176,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  178,
    0,    0,    0,    0,  179,  180,    0,    0,    0,  181,
    0,    0,  182,    0,  183,  184,  185,  186,    0,  187,
    0,    0,    0,    0,    0,    0,    0,  188,  189,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  190,  191,
    0,  192,  193,  194,    0,    0,    0,    0,  195,  196,
    0,  197,  198,    0,  199,    0,    0,  200,  201,  202,
  203,  204,  205,  206,    0,    0,    0,    0,  207,  208,
  209,    0,  210,  211,  212,    0,  213,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  214,  215,  216,  217,
  218,  219,  220,  221,  222,  223,  224,  225,  226,  227,
  228,  229,  230,  231,  232,  233,  234,    0,  235,  236,
  237,  238,  239,  240,    0,  241,  242,  243,  244,    0,
  245,    0,  246,  247,  248,  249,  250,  251,  252,  253,
  254,  255,  256,  257,  258,  259,  260,  261,  262,  263,
    0,  264,  265,  266,  267,    0,  268,  269,  270,  271,
  272,    0,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  115,  286,  116,  287,  288,
  289,  290,  291,  118,  292,    0,  119,  120,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  121,  122,
    0,  123,    0,  124,    0,    0,  125,    0,    0,  126,
    0,    0,    0,    0,    0,    0,  128,    0,  129,  130,
    0,    0,    0,  131,    0,    0,  132,    0,    0,  134,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  135,
  136,    0,    0,    0,    0,  137,    0,  138,    0,  139,
    0,    0,    0,    0,    0,  141,    0,  142,    0,    0,
    0,  143,    0,    0,    0,    0,    0,    0,    0,  144,
    0,    0,    0,  145,    0,    0,  146,    0,    0,    0,
    0,  147,  148,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  149,    0,    0,    0,  150,  151,
  152,  153,  154,    0,  155,    0,    0,    0,    0,    0,
  156,    0,  157,  158,    0,    0,  160,  161,    0,    0,
    0,    0,    0,    0,  162,    0,    0,  164,  165,  166,
  167,    0,  168,    0,  169,    0,  170,  171,  172,  173,
  174,    0,    0,    0,    0,  175,    0,  176,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  178,    0,
    0,    0,    0,  179,  180,    0,    0,    0,  181,    0,
    0,  182,    0,  183,  184,  185,  186,    0, 2007,    0,
    0,    0,    0,    0,    0,    0,  188,  189,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  190,  191,    0,
  192,  193,  194,    0,    0,    0,    0,  195,  196,    0,
  197,  198,    0,  199,    0,    0,  200,  201,  202,  203,
  204,  205,  206,    0,    0,    0,    0,  207,  208,  209,
    0,  210,  211,  212,    0,  213,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  214,  215,  216,  217,  218,
  219,  220,  221,  222,  223,  224,  225,  226,  227,  228,
  229,  230,  231,  232,  233,  234,    0,  235,  236,  237,
  238,  239,  240,    0,  241,  242,  243,  244,    0,  245,
    0,  246,  247,  248,  249,  250,  251,  252,  253,  254,
  255,  256,  257,  258,  259,  260,  261,  262,  263,    0,
  264,  265,  266,  267,    0,  268,  269,  270,  271,  272,
    0,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,   30,  286,   30,  287,  288,  289,
  290,  291,   30,  292,    0,   30,   30,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   30,   30,    0,
   30,    0,   30,    0,    0,   30,    0,    0,   30,    0,
    0,    0,    0,    0,    0,   30,    0,   30,   30,    0,
    0,    0,   30,    0,    0,   30,    0,    0,   30,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   30,   30,
    0,    0,    0,    0,   30,    0,   30,    0,   30,    0,
    0,    0,    0,    0,   30,    0,   30,    0,    0,    0,
   30,    0,    0,    0,    0,    0,    0,    0,   30,    0,
    0,    0,   30,    0,    0,   30,    0,    0,    0,    0,
   30,   30,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   30,    0,    0,    0,   30,   30,   30,
   30,   30,    0,   30,    0,    0,    0,    0,    0,   30,
    0,   30,   30,    0,    0,   30,   30,    0,    0,    0,
    0,    0,    0,   30,    0,    0,   30,   30,   30,   30,
    0,   30,    0,   30,    0,   30,   30,   30,   30,   30,
    0,    0,    0,    0,   30,    0,   30,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   30,    0,    0,
    0,    0,   30,   30,    0,    0,    0,   30,    0,    0,
   30,    0,   30,   30,   30,   30,    0,   30,    0,    0,
    0,    0,    0,    0,    0,   30,   30,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   30,   30,    0,   30,
   30,   30,    0,    0,    0,    0,   30,   30,    0,   30,
   30,    0,   30,    0,    0,   30,   30,   30,   30,   30,
   30,   30,    0,    0,    0,    0,   30,   30,   30,    0,
   30,   30,   30,    0,   30,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   30,   30,   30,   30,   30,   30,
   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
   30,   30,   30,   30,   30,    0,   30,   30,   30,   30,
   30,   30,    0,   30,   30,   30,   30,    0,   30,    0,
   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
   30,   30,   30,   30,   30,   30,   30,   30,    0,   30,
   30,   30,   30,    0,   30,   30,   30,   30,   30,    0,
   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
   30,   30,   30,  720,   30,  720,   30,   30,   30,   30,
   30,  720,   30,    0,  720,  720,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  720,  720,    0,  720,
    0,  720,    0,    0,  720,    0,    0,  720,    0,    0,
    0,    0,    0,    0,  720,    0,  720,  720,    0,    0,
    0,  720,    0,    0,  720,    0,    0,  720,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  720,  720,    0,
    0,    0,    0,  720,    0,  720,    0,  720,    0,    0,
    0,    0,    0,  720,    0,  720,    0,    0,    0,  720,
    0,    0,    0,    0,    0,    0,    0,  720,    0,    0,
    0,  720,    0,    0,  720,    0,    0,    0,    0,  720,
  720,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  720,    0,    0,    0,  720,  720,  720,  720,
  720,    0,  720,    0,    0,    0,    0,    0,  720,    0,
  720,  720,    0,    0,  720,  720,    0,    0,    0,    0,
    0,    0,  720,    0,    0,  720,  720,  720,  720,    0,
  720,    0,  720,    0,  720,  720,  720,  720,  720,    0,
    0,    0,    0,  720,    0,  720,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  720,    0,    0,    0,
    0,  720,  720,    0,    0,    0,  720,    0,    0,  720,
    0,  720,  720,  720,  720,    0,  720,    0,    0,    0,
    0,    0,    0,    0,  720,  720,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  720,  720,    0,  720,  720,
  720,    0,    0,    0,    0,  720,  720,    0,  720,  720,
    0,  720,    0,    0,  720,  720,  720,  720,  720,  720,
  720,    0,    0,    0,    0,  720,  720,  720,    0,  720,
  720,  720,    0,  720,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  720,  720,  720,  720,  720,  720,  720,
  720,  720,  720,  720,  720,  720,  720,  720,  720,  720,
  720,  720,  720,  720,    0,  720,  720,  720,  720,  720,
  720,    0,  720,  720,  720,  720,    0,  720,    0,  720,
  720,  720,  720,  720,  720,  720,  720,  720,  720,  720,
  720,  720,  720,  720,  720,  720,  720,    0,  720,  720,
  720,  720,    0,  720,  720,  720,  720,  720,    0,  720,
  720,  720,  720,  720,  720,  720,  720,  720,  720,  720,
  720,  720,  330,  720,  330,  720,  720,  720,  720,  720,
  330,  720,    0,  330,  330,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  330,  330,    0,  330,    0,
  330,    0,    0,  330,    0,    0,  330,    0,    0,    0,
    0,    0,    0,  330,    0,  330,  330,    0,    0,    0,
  330,    0,    0,  330,    0,    0,  330,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  330,  330,    0,    0,
    0,    0,  330,    0,  330,    0,  330,    0,    0,    0,
    0,    0,  330,    0,  330,    0,    0,    0,  330,    0,
    0,    0,    0,    0,    0,    0,  330,    0,    0,    0,
  330,    0,    0,  330,    0,    0,    0,    0,  330,  330,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  330,    0,    0,    0,  330,  330,  330,  330,  330,
    0,  330,    0,    0,    0,    0,    0,  330,    0,  330,
  330,    0,    0,  330,  330,    0,    0,    0,    0,    0,
    0,  330,    0,    0,  330,  330,  330,  330,    0,  330,
    0,  330,    0,  330,  330,  330,  330,  330,    0,    0,
    0,    0,  330,    0,  330,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  330,    0,    0,    0,    0,
  330,  330,    0,    0,    0,  330,    0,    0,  330,    0,
  330,  330,  330,  330,    0,  330,    0,    0,    0,    0,
    0,    0,    0,  330,  330,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  330,  330,    0,  330,  330,  330,
    0,    0,    0,    0,  330,  330,    0,  330,  330,    0,
  330,    0,    0,  330,  330,  330,  330,  330,  330,  330,
    0,    0,    0,    0,  330,  330,  330,    0,  330,  330,
  330,    0,  330,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  330,  330,  330,  330,  330,  330,  330,  330,
  330,  330,  330,  330,  330,  330,  330,  330,  330,  330,
  330,  330,  330,    0,  330,  330,  330,  330,  330,  330,
    0,  330,  330,  330,  330,    0,  330,    0,  330,  330,
  330,  330,  330,  330,  330,  330,  330,  330,  330,  330,
  330,  330,  330,  330,  330,  330,    0,  330,  330,  330,
  330,    0,  330,  330,  330,  330,  330,    0,  330,  330,
  330,  330,  330,  330,  330,  330,  330,  330,  330,  330,
  330,  115,  330,  116,  330,  330,  330,  330,  330,  118,
  330,    0,  119,  120,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  121,  122,    0,  123,    0,  124,
    0,    0,  125,    0,    0,  126,    0,    0,    0,    0,
    0,    0,  128,    0,  129,  130,    0,    0,    0,  131,
    0,    0,  132,    0,    0,  134,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  135,  136,    0,    0,    0,
    0,  137,    0,  138,    0,  139,    0,    0,    0,    0,
    0,  141,    0,  142,    0,    0,    0,  143,    0,    0,
    0,    0,    0,    0,    0,  144,    0,    0,    0,  145,
    0,    0,  146,    0,    0,    0,    0,  147,  148,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  149,    0,    0,    0,  150,  151,  152,  153,  154,    0,
  155,    0,    0,    0,    0,    0,  156,    0,  157,  158,
    0,    0,  160,  161,    0,    0,    0,    0,    0,    0,
  162,    0,    0,  164,  165,  166,  167,    0,  168,    0,
  169,    0,  170,  171,  172,  173,  174,    0,    0,    0,
    0,  175,    0,  176,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  178,    0,    0,    0,    0,  179,
  180,    0,    0,    0,  181,    0,    0,  182,    0,  183,
  184,  185,  186,    0,  187,    0,    0,    0,    0,    0,
    0,    0,  188,  189,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  190,  191,    0,  192,  193,  194,    0,
    0,    0,    0,  195,  196,    0,  197,  198,    0,  199,
    0,    0,  200,  201,  202,  203,  204,  205,  206,    0,
    0,    0,    0,  207,  208,  209,    0,  210,  211,  212,
    0,  213,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  214,  215,  216,  217,  218,  219,  220,  221,  222,
  223,  224,  225,  226,  227,  228,  229,  230,  231,  232,
  233,  234,    0,  235,  236,  237,  238,  239,  240,    0,
  241,  242,  243,  244,    0,  245,    0,  246,  247,  248,
  249,  250,  251,  252,  253,  254,  255,  256,  257,  258,
  259,  260,  261,  262,  263,    0,  264,  265,  266,  267,
    0,  268,  269,  270,  271,  272,    0,  273,  274,  275,
  276,  277,  278,  279,  280,    0,  282,  283,  284,  285,
  115,  286,  116,  287,  288,  289,  290,  291,  118,  292,
    0,  119,  120,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  121,  122,    0,  123,    0,  124,    0,
    0,  125,    0,    0,  126,    0,    0,    0,    0,    0,
    0,  128,    0,  129,  130,    0,    0,    0,  131,    0,
    0,  132,    0,    0,  134,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  135,  136,    0,    0,    0,    0,
  137,    0,  138,    0,  139,    0,    0,    0,    0,    0,
  141,    0,  142,    0,    0,    0,  143,    0,    0,    0,
    0,    0,    0,    0,  144,    0,    0,    0,  145,    0,
    0,  146,    0,    0,    0,    0,  147,  148,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  149,
    0,    0,    0,  150,  151,  152,  153,  154,    0,  155,
    0,    0,    0,    0,    0,  156,    0,  157,  158,    0,
    0,  160,  161,    0,    0,    0,    0,    0,    0,  162,
    0,    0,  164,  165,  166,  167,    0,  168,    0,  169,
    0,  170,  171,  172,  173,  174,    0,    0,    0,    0,
  175,    0,  176,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  178,    0,    0,    0,    0,  179,  180,
    0,    0,    0,  181,    0,    0,  182,    0,  183,  184,
  185,  186,    0,  187,    0,    0,    0,    0,    0,    0,
    0,  188,  189,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  190,  191,    0,  192,  193,  194,    0,    0,
    0,    0,  195,  196,    0,  197,  198,    0,  199,    0,
    0,  200,  201,  202,  203,  204,  205,  206,    0,    0,
    0,    0,  207,  208,  209,    0,  210,  211,  212,    0,
  213,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  215,  216,  217,  218,  219,  220,  221,  222,  223,
  224,  225,  226,  227,  228,  229,  230,  231,  232,  233,
  234,    0,  235,  236,  237,  238,  239,  240,    0,  241,
  242,  243,  244,    0,  245,    0,  246,  247,  248,  249,
  250,  251,  252,  253,  254,  255,  256,  257,  258,  259,
  260,  261,  262,  263,    0,  264,  265,  266,  267,    0,
  268,  269,  270,  271,  272,    0,  273,  274,  275,  276,
  277,  278,  279,  280,  281,  282,  283,  284,  285,    0,
  286,    0,  287,  288,  289,  290,  291,    0,  292,
};
static int yycheck[] = {                                       8,
   64,    0,   76,   16,  177,   77,   15,   16,  111,   18,
  768,   70,  662,  578,  579, 1125,  891,   75,  662, 1125,
   83,  814,  934,   76,   15,   86,   98,   65,   87,  640,
  640,  640, 1192,  104,  578,  579,  636,  595,  102,  927,
 1070,  654,   80,  106, 1240,  450, 1158,  108, 1194, 1027,
  109,   71,   61,   62, 1456,   64,   65,   66,   67,   68,
   69,   70,   71,  599, 1195,  103,  632,   76,   77,   78,
  939,   80,  657,   82,   83,  113,   85,   86,   87,   88,
   89,  101, 1159, 1235, 1029,   94, 1173,   96,   97,   98,
  110,  100,  101,  102,  103,   66,  105,  106,  107,  108,
  109,  110,  111,  869,  113,   96, 1114, 1047,   68, 1143,
 1384,   82, 1052,  609,  105, 1235,  597, 1222,  846, 1142,
 1235, 1477, 1235,  833, 1235,   85, 1235,  949, 1038, 1545,
  574,  608, 1800,    0, 1218,    0,  834,    0,   44,    0,
  442,  934,    0,    0,  549,    0,    0,  107, 1088,   41,
    0,  647,    0,   44, 1622, 1095,   44, 1580,   41,   42,
   43,   44,   45,   46,   47,   40,    0, 1882,   42,   43,
  334,   45,    0,   47,    0, 1211,   44,    0,    0, 1810,
    0,   63,   44, 1657,   40,   45,    0, 1603,   63,   40,
 1583,   44,   59,   45,   59,    0,   59, 1198,   59,  264,
    0,   59,   59,    0,   59,   59, 1339,    0,   91,   59,
  297,   59,    0,  655,    0,   41,  860,    0,   44,   40,
    0,  281,   59,   40, 1647,   59, 1204,   41,    0,   44,
   44,   59,   41,   59,   42,  963,   59,   59,    0,   59,
    0,    0, 1028,  545,  417,   59,   63,   91,   44,  302,
    0,   45,  305,  325,   59,  350,   45,  280,   59,   59,
 1205,  370,   59, 1202,   96,  328,   59,  880,  329,   41,
   44,   59, 1756,   59,   63, 1759,   59,  309,    0,   59,
    0,  454,   41,    0,  323,    0,   44,   59,  326,   59,
   41,   61,  312,  302,  303,  304,  305,   59, 1243,   59,
   59,  310,  393,  312,    0,  264,   45,  320,    0,   59,
    0,  320,  273,  304,  343,  915,  325,  326,  327,  328,
  329,  930,  268,  264,  273,  334,   41,    0,  939,  939,
  939,    0,  303, 1151,  343, 1128,    0,   59,  393,   59,
   41,  399,   59,   44,   59,   41, 1456,  297,   44,  259,
 1456,   41,    0, 1811,   44,  262,  327,  299,  264,  269,
    0,    0, 1257,   59,  272,  923, 1124,   59,  265,   59,
   41, 1129, 1130,   44,  974,  296, 1850,  297,  551,  445,
  438,  877,    0,  333,  942, 1330,   59,  482,  316,   41,
   59,   41, 2107,  402,  277,   59,    0, 1285,  347,  282,
 1193,  298,  335,  277, 1343,  347,  429,  498,  282,  264,
  264,   59,  444,  333,  264,  454,  264, 1447, 1502,   59,
   59,  965, 1845,   41, 1103, 1104,  347,  335,    0, 1251,
   40,  275, 1628,  374,    0,  332,  489, 1377, 1378,  492,
 1084,   59,  401, 1477, 1478, 1482, 1483,    0,    0, 1907,
  514, 1919,  260,  262,  509,   59,  323,  466,  323,  568,
  323, 1159,  323,    0,  374,  474,  323,  264,  264,   41,
  377, 1604,  304,  335,    0,  504,  296, 1554,   44, 1419,
  489,   61,  432,  492, 1877,  538,  544,   59,   41,  498,
  499,  299,  579,   59,  440,  456,   44,   41,  335,  559,
 1286,  316, 1200,  296,  264,  514,   59,   59, 1538,  518,
 1926, 1934, 1786,  296, 1550,   41,  958, 1933, 1874, 1935,
  343,  374,   59,  343,  537,  538,  296,  540,  537,  385,
 1826,  540,  541,   59,  335,  402,  601,  402,  498,  402,
 2024,  258,  314,  323, 2028,  598, 1580,  518,  374, 2264,
  343,  442, 1553,  270,  305,  608,  444,  610,  316,  612,
  343,  619,  615,  335,  573,  574,  448, 1507,  377, 1843,
  642,   41, 1928,  448, 1139,  633,  335,  635,    0,  296,
  448,  644, 1310,  441,  645,  302,  437,  304,  448,  598,
  444,  388, 1290,  651,  444,  659,  448, 1542, 2229,  608,
  421,  610,    0,  612,  277,  643,  615,  369, 1547,    0,
  262, 1016,  400, 1647,  400,  475,  508,  337,  314,   41,
  335, 1026,  402,  475,  314, 1737,  343, 1567,  378,  451,
  452,  448, 1176,  642,  643,  644,  645,   59,  277,  335,
 1284,  363, 1340,   41,  653,  335,  451,  452,  657,  658,
  659, 1301,  426,  662,  448,  305,   44, 1301, 1356,  448,
 1358,   59, 2064, 1307, 1273,  491, 2140, 1645,   59, 2085,
 2086, 1489,  444, 2341, 1652,  395, 1469,  491,  398, 1789,
 1876,  845,  653, 1789,  504,  444,  296,  658, 2156,  451,
  452, 1586, 1587,  527,  414,  601,  314, 1585,  264,  527,
  401, 1646, 2417,  577, 1354, 2420,   44,  399,  508,  448,
 1354,  504, 1014, 2136,  378, 1328,  296,  335,  262, 2203,
  440,  504,    0,  387, 1337,  377,  488,  527, 2084,  444,
  399,  614, 1816,  600, 1492,  602,  603,  602, 1496,  602,
  603,  602,  603, 1501,    0,  602,  601,  601,  444, 1293,
 1827,  601,  300,  601,  444,  527,  360,  426,  508, 1438,
  769,  314,    0,  335, 1241, 1653, 1676,  343, 1212,  768,
  279, 1593,  534, 2069, 1797,  495, 1671,  527, 1883,  320,
  833,   59,  335,  283, 1494,  337,  824,  504, 2144, 1555,
    0, 1272,  262,  297,   41,  515, 1671,   44, 1203,  264,
 1837, 1838,  492,   59,  297,  814,  343,  280,  528,  335,
 1346, 1845,  508,  575,  823,  824,  825,  369,  508,  351,
  833,   59,  831,  333,  296,  257,  444,  836,  837,  887,
 1326,  527,  262,  377,  843,  834,  845,  527,  891,    0,
 1874,  369,  262,  395,  508, 1018,  398,  276, 1546,   59,
  268,  262,  823,   42,   43,  864,   45, 2225,   47,  917,
  831,  496,  414,  527,  270,  825,  837, 2283, 2284, 1847,
  879,  343,  444,  882,  932,  451,  452,  258,  444,  399,
  276,  314,  891,  843,  374,  275,  939,  419,  440,  295,
  508,  444,  314,  864, 1928,  966,  405,  329,   59,  272,
 1934,  959,  375,  427,  303,  304,  426,  377,  879,  527,
  968,  882,  300,  335,   41,  276,  314,   44,    0,  315,
   59,  302,  432,  259,  262,  934, 2282,   59,  432,  938,
  939, 1544,  314,  269,   61,  944,  401,  335, 1696,  432,
  358,  370,  302,  495,    0,  257,  337,  377, 2100, 2101,
  340,  451,  452, 2065, 2064, 1013,  429,  377, 2064,   41,
  488, 1969,   44,  515, 1022, 1023,  377, 2054, 2055, 1619,
  316, 2083, 1025,  446,  527, 1619,  528,   59,  369, 1924,
 2100, 2101,  314, 1871, 1872, 2100, 2101, 2100, 2101, 2100,
 2101, 2100, 2101, 2080, 2081,  391, 1562, 1790, 2096,  540,
 1793,  264,  276,   59,  395,  425,  534,  398, 1766,  370,
  443,  441,    0, 2090,  425, 1118, 1025,  329,  296,    0,
  276,  277,  444,  414,  548,  407,  273,  408, 2302, 1614,
  391,  555,  504,    0,  264,  431,  397,  271,  374,  377,
  562,  315,  441,  482, 2142,  426,  444,  575,  408,  440,
 2084,  285, 1637, 1052,  264, 1075,  395,    0,  305, 2345,
   41,  443,  407,   44,  586,  343, 1075,  303,  304,  321,
  431,   59,  511,  351,   41, 2443, 2444,   44,   59,  460,
  426, 1625, 1648,  592,  369,  323,  508, 1140,  277, 1142,
 1089, 1144,   59,  282,  328,  303,  304,    0,  338,    0,
  347,   44, 2136,  264,  495,  527,  384,  446,  386, 1118,
 2144,  374, 1125,  264,  370, 2517,   59,  391,  448, 1128,
  408,  361,  356,  408,  515,  264,   93, 2258,  323,  527,
  408, 1140, 2162, 1142, 1172, 1144,  308,  528, 1674, 2008,
   41, 1194, 1151,   44,  374,  475,   42,    0, 2516, 1202,
 1159,   47,  308, 1211,  401,  433,   59,  431,   59, 2137,
 1159, 1170, 1171, 1172,  374, 1809, 1810,  378,  420,  296,
  455, 1229, 2574,  395, 2576,  427,  416, 1186,  388, 1188,
 1238, 1194, 1910,    0, 1193,  419, 2588, 1915, 1241, 1198,
    0, 1151,  318, 1202,  276,  277,  335, 1268,    0,  281,
 1171, 1200,  284, 1212, 1740,  441,   59,  402,   59,  456,
 2406, 2400,    0,  374,  296, 1186, 1269, 1188, 2620,  430,
 1273,  393,  399,  374,  446,    0,  504,  388,  261, 1927,
 1288,   41, 1241,  441,   44,  374,  448,  393, 1341, 1644,
 2526, 1299,   59,  448, 1809, 1810, 1811,  386, 2282,   59,
 1321, 1322, 1323, 2621, 2400, 1905,  428,   59,   44,  318,
 1269, 1905, 2150,  475, 1273,   40,   41,  439,  424,   44,
  258,   59,  428,  462,  463,  464,  465,  466,  467,  468,
  469,  337,  270,  439,   59,    0,  562, 2573,  370,   45,
 1343, 1290, 1301,  595,    0,  276,  277,   41,  263,   40,
   44, 2241, 2414,  284, 2590,  444,    0,   93,  296,  391,
  586,    0, 1925,  369,  302,  397,  304, 2257, 1327,  458,
 1864, 1879, 1866, 2609, 2082,   44,   41, 2487,    0,   44,
 2519, 1931, 1341, 2619, 1343, 1344, 2622,    0,   44,  395,
 2529, 1340,  398,  308,   59, 1354, 1355,   41, 1849,  431,
   44, 2637,   41,   59,  319,  343, 1327, 1356,  414, 1358,
    0,  264,    0,  351,    0,   59,  694, 1470,  335,  299,
   59,  318,  606, 1344,   93,  276,  277,   44,   93,  260,
  281,  277,  571,  284,  440, 1929,  282,   59,  407,  370,
    0,  281, 1893,   44,  276,  296,   59, 2008, 2008, 2008,
  386, 1902,  284, 1423,  560,   41,   44, 2517,  597,  264,
  391, 2517,  302,  264, 1423,  434,  397,  347,  299,   59,
  347,   59,  408,   59,  392,  444,   93,   41,    0, 2222,
   44,  419,  281,  400, 2346,  378,  764,  765, 1939,  495,
  370, 1494,   93, 1456,  387,   59,  265,   61,   40,   59,
  431, 1514,  417,  302,    0, 1516,    0, 1560, 1517,  515,
 1469, 1470,  264,    0, 2574,  374, 2576,    0, 2574,  370,
 2576,  374,  528, 1482, 1483, 1513,  434,  559, 2588,  298,
 1489, 1494, 2588, 2358,  335,  388,  444,   59,   42,   43,
  391,   45, 1550,   47, 1547,    0,  397,   41,  441,  442,
   44,  276,  277, 1512, 1513, 1514, 1515, 1516, 1517,  284,
 2620,  260,    0,   59, 2620,   59,  504,  374,  408,  374,
    0,  296,   59,  374,  451,  452,   59,  260,   44, 1489,
  431,  386, 2325,    0,  260,  386,  292,    0, 1547,  260,
    0,    0,  260,   41, 1553, 1554,   44, 1546, 1606,  374,
  299, 1560, 1512, 2346,   59, 1515,   41,   42,   43,  408,
   45,   41,   47,  319,  257,  508,  299,    0, 1639, 2509,
  460,   59,  374,  299,  332,   60,   61,   62,  299,   59,
    0,  299,  276,  277,  527, 2229,  388, 2088,    0,  444,
  284,  347,   59,  444,    0,  370,   59, 1650, 2099,   59,
   59, 2102, 1673,  458,  395, 1614, 1664,  458, 1679, 2549,
 2111,  460,    0,    0,    0,  455,  391,  457, 1671,  259,
  335,  314,  397,  414,  264,  314,   59,    0, 1637,  269,
   42,   43,   44,   45,   46,   47,  329, 2430, 2139,   59,
 2141, 1650, 2143,    0, 2145, 1654,  335,   59,   60,   61,
   62,  260,  297,   59,   41,  333,  431,   44,  559,  376,
  483,  417, 1671,  277, 2229,    0, 1740,    0,  257,  559,
  493,   59,   59,   59,    0,  257,  370,  433,  314,   91,
    0,  376,  296, 1654,    0,  400,   59, 1740,  333,  378,
  299,  447,  448,  449,    0,  451,  452,  391,  387,  335,
  284,  277,   59,  397,  312,  313,  282,   41,   42,   43,
  559,   45,  296,   47,  470,  471,  472,  473,  474,  475,
  476,  477,  478,  277,   59,  314,   59, 1736,  282,  485,
  486, 1740,  314,   59,  374,  451,  452,  431,  494,   59,
  329,  430,  378,   59, 1797, 1736,  264,  329,  388, 2250,
 2251, 2252,  397,   59,    0,  444,  370,   44,   59,   41,
   42,   43,  407,   45,   46,   47,   42,   43,  270,   45,
  258,   47,   41,    0,  328,   44, 1789,    0,   60,   61,
   62, 1790,  270,    0, 1793, 2286,  271,  432, 1797,    0,
  408,  337,  277,  295,  430,   41,  394,  282,   44,    0,
  285,  264,  382,  383,    0,  264, 1819,    0,  444,   91,
 1819,  332,  410,   59,  302,   61,  304, 1826, 1827,  508,
  317, 2579,  466,  369,  451,  452, 1835, 1836, 1837, 1838,
  474, 2481,   59,  330,  314,  320,   59, 2481,  527, 1848,
   41,   40,   59,  328,  324,  366,  326,  595,   59,  395,
  262,  336,  398,  483,  484,  335,  353,  378,   59,  271,
  616,  617,  618,   59,  432,  277,   59,  332,  414,  354,
  282,  356,  508,  285, 2375, 2376, 2377, 1848,  264,  444,
 2381,   41, 1940,  368,   44,  370,  371,  372,   59,  276,
  277,  527,    0,  258,  440,   40,  261,  284,  378, 1957,
   41,  366,  314,   44, 1962,  317,  403,  387,  320,  515,
  598,  374,  324,  378,  326,  374,  328,  907,  330,  909,
   61,  609,  610,  335,  336,  388,  338,   41, 1927,  388,
   44,  264,  414,   41,  419,  258,   44,  302,  264, 1835,
 1836,  353,  354,  277,  356,  488,  264,  270,  282,  495,
  430,   59,   42,   43,  366,   45,  368,   47,  370,  371,
  372,   46,  374,  264,  444,  377,  378, 2100, 2101,  515,
   60,   61,   62,   58,   59,  387,   61,  451,    0,  302,
  314,  304,  528,  370, 2427,   59, 2429,  374,  374,  271,
 1999,  403, 1835, 1836,  386,  277,   59,  447,  448,  449,
  282,  277,  388,  285,  391,   46,  282,  419, 1999,  312,
  397,    0,  258,  425, 2261, 2262,  314,   58,  430,   41,
   61,  281,   44,  424, 2127,  475,  476,  273,  508,  441,
  442,  277,  444,   41,  335,  281,   44,   59,  320,  332,
   41,  374,  302,   44,  431,  331,  328,  527,  374,  442,
  296, 2064,   41, 2066,  336,  388,  302, 2066,  317,  305,
 2069,  401,  388,   42,   43,   44,   45,   46,   47,  424,
   59,  330,  354,  374,  356,   41,  393,   41,   44,  491,
   44, 2090,  335,  491,  316,  386,  368,   46,  370,  371,
  372,  260, 2265,  264,  353, 2268,  508, 2106,  314,   58,
  512,  347,   61, 2112,  491,   42,   43,  366,   45,  314,
   47,   41,   91,  314,   44,  527,  374,   41, 2127, 2193,
   44,  606,  374,  324,  370,  326,  496, 2191,  388, 2138,
   41,  426,  424,   44,  335, 2106,   41,  419,  532,   44,
 2193, 2112,   41,  444,  403,   44,   41,  317,  408,   44,
  426, 2225,  355,   42,   43,  401,   45,  458,   47,  702,
  330,   46,  408,  531,  335,   41,  426, 2138,   44,  529,
  335,  264, 2225,   58,   59,   41,   61,  378,   44, 2188,
  426,  271, 2191,  353, 2193,   41,  387,  277,   44,  424,
  264,  375,  282,  351,  606,  285,  366, 2188,    0,  317,
  460,  264,  408,  374,  374, 2269,  314,  318,   41,  336,
  456,   44,  330, 2222,  460,  386, 2225,  373,  326,   46,
  338,  495,  273,  766,  767,  768,  384,  335,  386,  430,
  320,   58,   59,  403,   61,  353,  508, 2295,  328,   41,
  408, 2299,   44,  444,  296,  305,  336,    0,  366,   41,
  408,  459,   44,  512,  276,  277,    0,   59,  503,   61,
 2269,  335,  284,  504,  354,   41,  356,  503,   44,  600,
  378,   46,  335,  444,   44,  433,  264,   46,  368,  387,
  370,  371,  372,   58,   59,  403,   61,  458,   41,   58,
   59,   44,   61,   41,  268,  444,   44,   41,  277,  559,
  374,   41,   61,  282,   44, 2358,   59,  508,   61,  364,
  283,  374,  386,  559, 2323,   59, 2325,   41,   40,  264,
   44,  491,  430,  386,  606,  314,  527,   41,   41,  419,
   44,   44,   41,   40,  387,   44,  444, 2346,   41,   40,
  277,   44,  512,   40,    0,  282,  335, 2400,  370, 2358,
   41,   41,  895,   44,   44,  898,   59,   40,   61,   41,
  903, 2433,   44,  906,  451,   40,   40,  910,    0,  391,
  444,  451,   41,   42,   43,  397,   45,   41,   47,  316,
   44,  444, 1505,   40,  458, 1508,   40, 2400,  277,  378,
 1071, 2400, 1073,  282,  512,  458, 1077, 1078,  387, 1080,
  508, 2400,   40,   59,   40,  451,   40, 2479,  350,  431,
   42,   43,   44,   45,   46,   47,   40,   40, 2427,  527,
 2429, 2430,   40,   40, 2433, 1106,   40,   59,   60,   61,
   62,   40,   40, 2442, 2443, 2444, 2489,  400,   41,   42,
   43,  430,   45, 1366,   47, 1368,   40, 1370, 1371,   40,
   40, 1374, 1375, 1376,   40,  444,  258,   40,   40,   91,
   91,   40,   42,   43,   44,   45,   46,   47,   40,  491,
 2479, 2480,   46,  275,  276,  277, 2489,   44,   40,  281,
   40,   40,  284,  462,  463,  464,  465,  466,  467,  468,
  469,   61,   42,   43,  296,   45,  264,   47,  434,  316,
  302,  393,  530,  438, 2517,  258,   44, 2516,  314, 1052,
  418,   91,   42,   43,   46,   45,  606,   47,   61,  508,
 2519,   40,  275,  276,  277,   40,  264,  336,  281, 1072,
 2529,  284,   46, 1076,  296,  343, 1079,  426,  527,  343,
 2539,  276,  343,  296, 1087,  363, 1089,  264,  388,  302,
 1093, 1094,  426,  388, 1097, 1098, 1099, 1100, 1101, 1102,
 1103, 2574, 1105, 2576, 1107,  603,  454,  448,  370,  275,
  314,  343,  437,  437,  277, 2588, 1119, 1120, 1121, 1122,
 1123, 1124,  326,  390, 1127,   40, 1129, 1130, 2597,  391,
  344,  335,  571,  296,   40,  397,   91,   40,  264,   40,
   42,   43,  258,   45,  406,   47,  408, 2620,  277,   40,
  374,  316, 2621,  282,  270, 2624,  401,  370,  597,   44,
  448,   40,   42,   43,  426,   45,  373,   47,  380,  431,
  262,    0,   40,  378,  378,  314,  441,   41,  391,  271,
  296,  373,  277,  387,  397,  277,  302,  316,  304,  370,
  282,   63,  426,  285, 1197,  408,   42,   43,  460,   45,
  275,   47,   42,   43,  454,   45,  426,   47,  313,    0,
  527,  438,   41,  426,  277,   44,   40,   40,  431,  282,
   40,  444,  314,  264,    0,  317,  430,  343,  320,   40,
   59,   44,  324,  336,  326,  316,  328,  277,  330,   44,
  444,   44,  282,  335,  336,  517,  338,  460,   40,  273,
  536,   42,   43,   44,   45,   46,   47,   40,  296,  339,
  339,  353,  354,  602,  356,   41,    0,  277,   59,   60,
   61,   62,  282,  377,  366,  377,  368,  377,  370,  371,
  372,  604,  374,   59,  406,  377,  378,  277,  408,  408,
   40,  264,  282,  351,   40,  387,    0,  559,   40,  426,
   91,  361,   40,   44,  508,   41,  316,   41,  316,   41,
   44,  403,  277,   44,   44,   41,  347,  317,   46,  376,
  273,   41,   41,  527,  360,   59,  316,  419,   44,  338,
  330,  379,  338,  425,   44,  316,  316,   41,  430,   41,
  492,  434,  266,  442,  264,  284,  559,  491,  264,  441,
  442,  412,  444,  353,  444,   59,   41,   58, 1361, 1362,
 1363,  347,   41, 1366, 1367, 1368,  366, 1370, 1371, 1372,
   41, 1374, 1375, 1376,  374,  277,   41,  264,  323,   40,
  282,  575, 1385, 1386,  590, 1388,  385, 1390,  504,   41,
 1393, 1394, 1395, 1396,  305, 1398, 1399,  277,  305,  491,
   41,   40,  282,  403,  316,  307,   42,   43,   40,   45,
   40,   47, 1415,   40, 1417,   40,  508,   40,   40,  426,
  512,   40,  462,  463,  464,  465,  466,  467,  468,  469,
 1433,  277,   40,   40,  314,  527,  282,  277,   40, 1442,
 1443,   40,  282,   40,   40,  262,   40,   42,   43,   44,
   45,   46,   47,   41,   42,   43,   44,   45,   40,   47,
  304,  307,  425,  295,  426,  338,  444,  307,   40,   44,
  324,  262,   41,   42,   43,  397,   45,  382,   47,  377,
  271,  377,  377,  377,  377,  314,  277,  377,  454, 1492,
  454,  282,  276, 1496,  285,  324,   91,  326, 1501,   42,
   43,  517,   45,   41,   47,  448,  335,   41,  374,  338,
    0,   40,  512,   41,  606,   41,   41,  316,   41,   41,
   44,  373,  304,  314,   41,  425,  317,   41,   46,  320,
  270,  571,    0,  324,  323,  326,  273,  328,  314,  330,
  426,  326,  276,  277,  335,  336,  339,  338,  324,  378,
  326,   41,  436, 1556,   44, 1558, 1559,  597,  387,  335,
  441,  332,  353,  354,  441,  356,  333,  432,  297,   59,
  432,   61,   40,   41,  333,  366,   44,  368,  376,  370,
  371,  372,  297,  374,  458,   41,  377,  378,   41,   42,
   43,   59,   45,   61,   47,  458,  387,   41,   41,    0,
  363,  430,  378,   41,   42,   43,  279,   45,    0,   47,
  314,  387,  403,  442,  363,  444,   41,   41,   41,   41,
   41,   41,  326,   91,   42,   43,   41,   45,  419,   47,
   41,  335,   41,   41,  425,   41,  370,   41,   41,  430,
   41,  277,   41,   44,   41,   41,  282,   40,   40,   41,
  441,  442,   44,  444,  430,  260,   41,  391,   59,   42,
   43,   44,   45,  397,   47,  376,  442,   59,  444,   61,
    0,  307,  425,  370,  378,   40,  568,   41,  456,  508,
  568,  332,  277,  387,   41,   42,   43,  282,   45,  277,
   47,  304,  297, 1696,  282,   44,  441,  431,  527,   91,
  491,   59,  425,  290,  309,  432, 1709, 1710,  277, 1712,
 1713,   41,  569,  282,   44,  374,   44,  508, 1721,   41,
 1723,  512,  265,   40,  314,   46,  430,  508,  333,   59,
  333,   61,  508,  508,  277,   41,  527,  374,  408,  282,
  444, 1744,   40,  374,  335,  598,  335, 1750,   59,   58,
 1753,  527, 1755, 1756,   40,  298, 1759,  297, 1761,    0,
  432,   91, 1765, 1766, 1767,   41,   40,  427,  258,   44,
  434, 1774,  453, 1776,  335,  335, 1779, 1780, 1781, 1782,
   42,   43, 1785,   45,  300,   47,  276,  277,   41,  498,
  258,  281,  397,   40,  284,  433,  335,  312,   40,  425,
   41,  300,  407,   44,  508,  273,  296,  275,  276,  277,
  427,  392,  302,  281,  303,  606,  284,  427,   59,    0,
  290,  300,  612,  527,  277,  335,  614,  432,  296,  282,
  407,    0,  332,  374,  302,  264,  407,  305,  374,  277,
   42,   43,   40,   45,  282,   47,  264,    0,  264,   42,
   43,   44,   45,   46,   47,  407,  448,  264,   40,  277,
   41,  441,  338,   44,  282,   44,  258,  462,  463,  464,
  465,  466,  467,  468,  469,  276,  277, 1880,   59,  347,
  370,  273,  401,  275,  276,  277,   41,  434,   41,  281,
  316,   44,  284,   40,  277,   40,  338,   41,   91,  282,
  448,  391,  370,  264,  296,  425,   59,  397,   41,   41,
  302,  448,   41,  305,   41,   41,   41,   41,  408,   41,
  277,   41,  304,  391,   59,  282,  300,  260,  258,  397,
  335,   59,   40,  401,  527,  484,  426,  369,   59,  369,
  408,  431,   59,  273,   59,  275,  276,  277,   59,   59,
   59,  281,   44,   41,  284,  347,   41,   41,  426,   41,
  527,  601, 1965,  431,  527, 2400,  296, 2400, 1971,  370,
  460, 2400,  302, 1976, 2400,  305,  571, 2400,  370, 2400,
 1983,  841, 1985,    0,  309,   41,   42,   43,  456,   45,
  391,   47,  460, 1804,  309,  843,  397, 1172,  310,  391,
  262,  499,  597,  500, 1676,  397,   41,   42,   43,  401,
   45, 1034,   47,  100, 1347,  277,  408,  347, 1301, 1674,
  282, 2024, 1354,   88,   41, 2028, 1671,   44, 1649,    0,
  431, 2034, 2035, 1250,  426,  276,  277, 1629, 2041,  431,
  370, 1879,   59,  284,   61,   41,   42,   43, 1665,   45,
 2089,   47,  637,  974,   41,   42,   43, 1565,   45,    0,
   47,  391,  264,  547,  456, 1650,  610,  397,  460,  559,
   41,  401, 1877,   44,   91,  277, 2373,  610,  408, 2082,
  282,    0,   42,   43,  277,   45,  944,   47,   59,  282,
   61,  559, 2419, 2418, 2495, 1241,  426, 2485, 1478, 2575,
   41,  431, 2593,   44,   41,   42,   43, 2624,   45, 2564,
   47,   41,   42,   43,  769,   45, 2626,   47,   59, 2442,
   91, 2527,   41,  276,  277,   44,  456, 1140, 2404,  370,
  460,  284,  615,  314,  600,  593,  946, 1916, 1318, 1309,
   59, 1011,   13,  324,  311,  326,   42,   43,   44,   45,
  391,   47,  525,  848,  335,  853,  397,  338, 1186, 1506,
 2233, 2415, 2165, 1556,  581, 1159, 2188,  559, 2171, 2172,
   42,   43,   44,   45, 2073,   47, 2179, 1999, 2072, 1558,
 1069,   41,   42,   43, 2489,   45,    0,   47,   42,   43,
  431,   45,  869,   47, 2413, 2400, 2199,  378, 2400, 1169,
 2203, 1511, 1711,  452, 2207, 1894,  387,  620, 1568, 2212,
 2213, 2214, 2215, 2216, 1656, 1784,   -1,  370, 2221, 1761,
   -1,  277,   -1,   -1,   -1,   -1,  282,   41,   -1,  559,
   44,   -1,   -1,   41,   42,   43,   -1,   45,  391,   47,
   -1,  258,  277,   -1,  397,   59,   -1,  282,   -1,  430,
  491,   -1,   -1, 2256,   -1,   -1,  273,   -1,   -1,  276,
  277,  442,   -1,  444,  281,   -1,   -1,  284,   -1,  462,
  463,  464,  465,  466,  467,  468,  469,   -1,  431,  296,
   -1,  277,   -1,   -1,   -1,  302,  282,  258,  305,   -1,
  277, 2294,   41,   42,   43,  282,   45,   -1,   47,   -1,
   -1,   -1,  273,   -1,   -1,  276,  277, 2310,   -1,   -1,
  281,   -1,   -1,  284,   41,   42,   43,  277,   45,   -1,
   47,   -1,  282,   -1,   -1,  296,   -1,  508,    0,   -1,
  347,  302,   -1,   -1,  305,  276,  277,   -1,  491,   -1,
  277,   -1,   -1,  284,   -1,  282,  527,  277,   -1,   -1,
   -1,   -1,  282,  370,   -1,  296,   -1,  276,  277,   -1,
   -1,   -1,   41,   42,   43,  284,   45,   -1,   47,   41,
   42,   43,   44,   45,  391,   47,  347,  296,  571,   -1,
  397,  277,   -1,   -1,  401,   -1,  282,   59,   60,   61,
   62,  408,   -1, 2396,   -1, 2398,   -1,   -1,   -1,  370,
   -1,  291,   -1,   -1,  597,  277,   -1,   -1,  262,  426,
  282,  301, 2415,   -1,  431,   -1,   -1,  277,  308,   -1,
  391,   93,  282,  277,   -1,   -1,  397,   -1,  282,  370,
  401,  321,   -1,   -1,   -1,   -1, 2439,  408,   -1,  456,
   -1,   -1,   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,
  391,  370,   -1,   -1,   -1,  426,  397,   -1,   -1,   -1,
  431,   -1,  276,  277,   -1,   -1,   -1,   -1,   -1,  277,
  284,   -1,  391,   -1,  282,   -1,   -1,   -1,  397,   -1,
   -1,   -1,  296,   -1,   -1,  456,   -1,  377,   -1,  460,
  431,   -1,   -1,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,  393, 2507, 2508,   -1,   -1,   -1,   -1,
   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,  409,
   41,   42,   43,   -1,   45,   -1,   47,   -1,  277,   -1,
   -1,   -1,   -1,  282,  424,   -1, 2539,   -1,  428,   -1,
   -1,  431,  559,  433,   -1,   -1,   -1,   -1,   -1,  439,
  277,   -1,   -1,   -1,   -1,  282,  370, 2560,   -1, 2562,
   -1,   -1,   -1,   -1,   -1,   41,   42,   43,  458,   45,
   -1,   47, 2575,   -1,   -1,   -1, 2579,  391, 2581, 2582,
   -1,   -1,   -1,  397,   -1,  257,  258,  259,  559,   -1,
  262,   -1,  264,  265, 2597,   -1,  268,  269,  277,  271,
   -1,   -1,   -1,  282,  276,  277,   -1,   -1,  280,  281,
  282,  283,  284,  285,   -1, 2618,  288,  431,   -1,  291,
   -1,   -1,   -1, 2626,  514, 2628,  298,  517,  300,  301,
  302,  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,
   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,
  322,   -1,  324,   -1,  326,  327,  328,  329,  330,  331,
   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,
  560,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,
   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,
   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,
  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,
  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,  391,
  392,   -1,  394,  395,   -1,  397,  398,  399,  400,   -1,
  277,  403,   -1,   -1,  406,  282,  408,  409,  410,  411,
  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,
  422,   -1,   -1,  425,  426,  427,  277,  429,  430,  431,
   -1,  282,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,
  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,
   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,
  462,  463,  464,  465,  466,  467,  468,  469,   -1,   42,
   43,  277,   45,   46,   47,   -1,  282,  479,  480,   -1,
  482,  483,  484,   -1,   -1,   -1,   59,  489,  490,  491,
  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,
  512,  513,  514,  515,   -1,  517,   -1,   -1,   91,   42,
   43,   44,   45,   -1,   47,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,    0,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,  606,  607,   -1,  609,  610,  611,
  612,  613,   -1,  615,   -1,   -1,   -1,  261,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,   41,   42,   43,
   -1,   45,   -1,   47,   -1,  279,   -1,   58,   59,   60,
   61,   62,   -1,  287,   -1,   -1,   -1,   -1,   -1,   -1,
  275,  295,   -1,  297,   -1,   -1,   -1,   -1,  302,   -1,
   -1,   -1,   -1,   -1,   -1,  309,  291,   -1,   -1,   -1,
   91,   -1,   93,   -1,   -1,   -1,  301,   -1,   -1,  323,
   -1,   -1,   -1,  308,   -1,   -1,   -1,  312,  313,  333,
   -1,  264,   -1,   -1,   -1,   -1,  321,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,  332,   -1,  282,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  361,   -1,   -1,
  462,  463,  464,  465,  466,  467,  468,  469,   -1,   -1,
   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,  395,   -1,   -1,  277,   -1,   -1,   -1,  402,  282,
  385,  405,  335,   -1,  408,   -1,   -1,   -1,  393,   -1,
   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   41,   42,   43,   -1,   45,   -1,   47,  432,   -1,
   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,  424,
  444,  374,   -1,  428,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  386,  439,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   41,   42,   43,   -1,   45,  571,
   47,   -1,   -1,  458,  459,   -1,  257,  481,  259,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,
  271,   -1,  496,  497,   -1,  597,  277,   -1,   -1,  280,
  281,  282,  283,  277,  285,   -1,   -1,  288,  282,   -1,
  291,  444,   -1,   -1,  518,   -1,   -1,  298,   -1,  300,
  301,   -1,  303,  304,  305,  458,  307,  308,   -1,  514,
  311,   -1,  517,  314,   -1,  316,  317,   -1,   -1,  320,
  321,  322,   -1,  324,   -1,  326,  327,  328,  329,  330,
  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,
   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,
  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,
  381,  382,  383,  384,  608,  386,  387,  277,   -1,   -1,
   -1,  392,  282,  394,  395,  277,   -1,  398,  399,  400,
  282,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,  425,  426,  427,  277,  429,  430,
   42,   43,  282,   45,   -1,   47,   -1,  277,   -1,  440,
  441,  442,  282,  444,  445,  446,  277,   59,   -1,  450,
   -1,  282,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,  462,  463,  464,  465,  466,  467,  468,  469,   -1,
   -1,  277,   42,   43,   44,   45,  282,   47,  479,  480,
  277,  482,  483,  484,   -1,  282,   -1,   -1,  489,  490,
  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,
  511,  512,  513,  514,  515,   -1,  517,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
    0,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,  606,  607,   -1,  609,  610,
  611,  612,  613,  614,  615,   -1,   -1,  337,   -1,   -1,
   40,   41,   42,   43,   44,   45,   46,   47,   41,   42,
   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   58,   59,
   60,   61,   62,  275,   -1,   -1,   -1,   -1,   -1,  369,
   -1,   -1,  264,   -1,   41,   42,   43,   -1,   45,  291,
   47,   -1,   41,   42,   43,  277,   45,   -1,   47,  301,
  282,   91,   -1,   93,   -1,  395,  308,   -1,  398,   -1,
  312,   -1,   -1,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   41,   42,   43,  414,   45,   -1,   47,   -1,   -1,
  332,   -1,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
   -1,   -1,  282,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  440,   -1,   -1,  335,   -1,   -1,   -1,   -1,   -1,   -1,
   42,   43,   44,   45,   -1,   47,   42,   43,   44,   45,
   -1,   47,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1, 1966, 1967,  282,   -1,
   -1,  393,  374,   -1, 1974, 1975,   -1, 1977, 1978,   -1,
   -1,   -1,   -1,   -1,  386,  495, 1986, 1987, 1988, 1989,
   -1,   -1, 1992, 1993, 1994, 1995, 1996, 1997,   -1,   -1,
   -1,   -1,  424,   -1,   -1,  515,  428,   -1,   -1,   -1,
   -1,  433,   -1,   -1,   -1,   -1,   -1,  439,  528,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  458,   -1,   -1,   -1,
   -1,   -1,  444,   -1,   -1,   -1,   -1,  257,   -1,  259,
   -1,   -1,  262,   -1,  264,  265,  458,   -1,  268,  269,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
  280,  281,  282,  283,  277,  285,   -1,   -1,  288,  282,
   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,
  300,  301,  514,  303,  304,  305,   -1,  307,  308,   -1,
  277,  311,   -1,   -1,  314,  282,  316,  317,  277,   -1,
  320,  321,  322,  282,  324,   -1,  326,  327,  328,  329,
  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,
  277,   -1,   -1,  343,   -1,  282,   -1,  277,   -1,   -1,
   -1,  351,  282,  353,  354,  355,  356,   -1,  358,   -1,
   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,
  370,  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,
  380,  381,  382,  383,  384,  277,  386,  387,   -1,   -1,
  282,  277,  392,   -1,  394,  395,  282,  277,  398,  399,
  400,   -1,  282,  403,   -1,   -1,  406,   -1,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,
  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,
  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,
  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,
  460,   -1,  462,  463,  464,  465,  466,  467,  468,  469,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,
  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,
  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,
  510,  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,    0,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,  606,  607,   -1,  609,
  610,  611,  612,  613,  614,  615,   -1,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  301,   58,
   59,   60,   61,   62,   -1,  308,   -1,   -1,   -1,  312,
  313,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  321,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  332,
   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,  272,
   -1,   -1,  275,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  288,   -1,   -1,   -1,  292,
   -1,  294,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  393,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  334,   -1,   -1,   -1,   -1,  409,  340,  341,  342,
   -1,  344,  345,  346,   -1,  348,   -1,   -1,   -1,   -1,
   -1,  424,   -1,   -1,   -1,  428,   -1,   -1,   -1,   -1,
  433,   -1,  365,   -1,  367,   -1,  439,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  458,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  396,   -1,   -1,   -1,   -1,  401,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  413,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,
  259,   -1,  435,  262,   -1,  264,  265,   -1,   -1,  268,
  269,  514,  271,   -1,  517,   -1,   -1,   -1,  277,   -1,
   -1,  280,  281,  282,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,  470,  471,  298,
   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,  308,
   -1,   -1,  311,   -1,  487,  314,   -1,  316,  317,   -1,
   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,  328,
  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,
   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,  378,
   -1,  380,  381,  382,  383,  384,   -1,  386,  387,   -1,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,
  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
   -1,  460,   -1,  462,  463,  464,  465,  466,  467,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,
  509,  510,  511,  512,  513,  514,  515,   -1,  517,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,    0,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,  606,  607,   -1,
  609,  610,  611,  612,  613,  614,  615,  272,   -1,   -1,
  275,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
   -1,   -1,   -1,  288,   -1,   -1,   -1,  292,   -1,  294,
   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  272,   -1,   -1,  275,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,   -1,   93,   -1,  272,  288,  334,
  275,   -1,  292,   -1,  294,  340,  341,  342,   -1,  344,
  345,  346,   -1,  348,   -1,   -1,   -1,  292,   -1,  294,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  365,   -1,  367,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  334,   -1,   -1,   -1,   -1,   -1,
  340,  341,  342,   -1,  344,  345,  346,   -1,  348,  334,
   -1,  396,   -1,   -1,   -1,  340,  341,  342,   -1,  344,
  345,  346,   -1,  348,   -1,  365,   -1,  367,  413,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  365,   -1,  367,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  435,   -1,   -1,   -1,   -1,   -1,  396,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  396,   -1,  413,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  470,  471,   -1,  413,   -1,
   -1,   -1,   -1,   -1,   -1,  435,   -1,   -1,   -1,   -1,
   -1,   -1,  487,   -1,   -1,   -1,   -1,   -1,   -1,  257,
  435,  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
  470,  471,  280,  281,  282,  283,   -1,  285,   -1,   -1,
  288,   -1,   -1,  291,   -1,  470,  471,  487,   -1,   -1,
  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,
  308,   -1,  487,  311,   -1,   -1,  314,   -1,  316,  317,
   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,
  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,
  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,
  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,
  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,
  378,   -1,  380,  381,  382,  383,  384,   -1,  386,  387,
   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,
  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,
   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,
  418,  419,  420,  421,  422,   -1,   -1,  425,  426,  427,
   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,
   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,
  458,   -1,  460,   -1,  462,  463,  464,  465,  466,  467,
  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,
   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
  508,  509,  510,  511,  512,  513,  514,  515,   -1,  517,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,    0,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,  606,  607,
   -1,  609,  610,  611,  612,  613,  614,  615,  272,   -1,
   -1,  275,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,  272,   -1,   -1,  275,   -1,   -1,   -1,  292,   -1,
  294,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,  292,   -1,  294,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,
  334,   -1,   -1,   -1,   -1,   -1,  340,  341,  342,   -1,
  344,  345,  346,  334,  348,   -1,   -1,   -1,   -1,  340,
  341,  342,   -1,  344,  345,  346,   -1,  348,   -1,   -1,
   -1,  365,   -1,  367,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  365,   -1,  367,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  396,   -1,   -1,   -1,  413,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  413,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  435,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  435,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  470,  471,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  470,
  471,   -1,   -1,  487,   -1,   -1,   -1,   -1,   -1,   -1,
  257,   -1,  259,   -1,   -1,  262,  487,  264,  265,   -1,
   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,   -1,
   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,
  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,
  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,
  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,
  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,
   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,
   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,
  377,  378,   -1,  380,  381,  382,  383,  384,   -1,  386,
  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,  426,
  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,
   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,   -1,  462,  463,  464,  465,  466,
  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,  508,  509,  510,  511,  512,  513,  514,  515,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,    0,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,  606,
  607,   -1,  609,  610,  611,  612,  613,  614,  615,   -1,
   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,  265,
   -1,   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,
   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,
   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,
   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,
  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,
  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,
  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,
  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,
  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,
  376,  377,  378,   -1,  380,  381,  382,  383,  384,   -1,
  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,
   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,
  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,
  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,
  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,
  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,
  456,  457,  458,   -1,  460,   -1,  462,  463,  464,  465,
  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,
   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,
   -1,   -1,  498,  499,  500,  501,  502,  503,  504,   -1,
   -1,   -1,  508,  509,  510,  511,  512,  513,  514,  515,
   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,   -1,  549,  550,  551,  552,  553,  554,   -1,
  556,  557,  558,  559,   -1,  561,   -1,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,    0,  582,  583,  584,  585,
   -1,  587,  588,  589,  590,  591,   -1,  593,  594,  595,
  596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
  606,  607,   -1,  609,  610,  611,  612,  613,  614,  615,
   -1,   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,
  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,
  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,
   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,
   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,
  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,
  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,
   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,
   -1,  376,  377,  378,   -1,  380,  381,  382,  383,  384,
   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,
  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,
  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,
  455,  456,  457,  458,   -1,  460,   -1,  462,  463,  464,
  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,
   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,  514,
  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,    0,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,  606,  607,   -1,  609,  610,  611,  612,  613,  614,
  615,   -1,   -1,   -1,   -1,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,
   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,
   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,
  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,
  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,
  324,   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,
   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,
  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,
  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,
  374,   -1,  376,  377,  378,   -1,  380,  381,  382,  383,
  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,
  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,
   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,
  414,   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,
   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,
  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,
   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,  463,
  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,
  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,
   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,  503,
  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,
  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,   -1,  549,  550,  551,  552,  553,
  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,    0,  582,  583,
  584,  585,   -1,  587,  588,  589,  590,  591,   -1,  593,
  594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
  604,  605,  606,  607,   -1,  609,  610,  611,  612,  613,
  614,  615,   -1,   -1,   -1,   -1,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,
  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,
   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,
   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,
   -1,  324,   -1,  326,  327,  328,  329,  330,  331,   -1,
   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,
  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,
  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,
   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,  382,
  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,
  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,
   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,
  463,  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,
  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,
  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,
  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,    0,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,  606,  607,   -1,  609,  610,  611,  612,
  613,  614,  615,   -1,   -1,   -1,   -1,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,
   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,
  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,
   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,
  282,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,
   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,
   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,
   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,
  322,   -1,  324,   -1,  326,  327,  328,  329,  330,  331,
   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,
   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,
   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,
   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,
  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,
  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,
  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,
   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,
  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,
  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,
  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,
   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,
  462,  463,  464,  465,  466,  467,  468,  469,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,
  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,
  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,
  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,    0,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,  606,  607,   -1,  609,  610,  611,
  612,  613,  614,  615,   -1,   -1,   -1,   -1,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,
  281,  282,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,
  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,
  321,  322,   -1,  324,   -1,  326,  327,  328,  329,  330,
  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,
   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,
  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,
  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,
   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,
  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,  462,  463,  464,  465,  466,  467,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,
  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
    0,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,  606,  607,   -1,  609,  610,
  611,  612,  613,  614,  615,   -1,   -1,   -1,   -1,   -1,
   40,   41,   42,   43,   44,   45,   46,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,
   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
  280,  281,  282,  283,   -1,  285,   -1,   -1,  288,   -1,
   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,
  300,  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,
   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,
  320,  321,  322,   -1,  324,   -1,  326,  327,  328,  329,
  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,
   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,
  370,  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,
  380,  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,
   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,
  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,
  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,
  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,
  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,
  460,   -1,  462,  463,  464,  465,  466,  467,  468,  469,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,
  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,
  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,
  510,  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,    0,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,  606,  607,   -1,  609,
  610,  611,  612,  613,  614,  615,   -1,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,
  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,
  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,  280,  281,  282,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,  308,
   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,
   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,  328,
  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,
   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,  378,
   -1,  380,  381,  382,  383,  384,   -1,  386,  387,   -1,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,
  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
   -1,  460,   -1,  462,  463,  464,  465,  466,  467,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,
  509,  510,  511,  512,  513,  514,  515,   -1,  517,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,    0,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,  606,  607,   -1,
  609,  610,  611,  612,  613,  614,  615,   -1,   -1,   -1,
   -1,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
   -1,  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
   -1,   -1,  280,  281,  282,  283,   -1,  285,   -1,   -1,
  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,
  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,
  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,
   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,
  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,
  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,
  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,
  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,
  378,   -1,  380,  381,  382,  383,  384,   -1,  386,  387,
   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,
  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,
   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,
  418,  419,  420,  421,  422,   -1,   -1,  425,  426,  427,
   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,
   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,
  458,   -1,  460,   -1,  462,  463,  464,  465,  466,  467,
  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,
   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
  508,  509,  510,  511,  512,  513,  514,  515,   -1,  517,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,    0,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,  606,  607,
   -1,  609,  610,  611,  612,  613,  614,  615,   -1,   -1,
   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,   -1,  259,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,   -1,
   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,
  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,
  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,
  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,
  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,
   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,
   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,
  377,  378,   -1,  380,  381,  382,  383,  384,   -1,  386,
  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,  426,
  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,
   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,   -1,  462,  463,  464,  465,  466,
  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,  508,  509,  510,  511,  512,  513,  514,  515,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,    0,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,  606,
  607,   -1,  609,  610,  611,  612,  613,  614,  615,   -1,
   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,  265,
   -1,   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,
   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,
   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,
   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,
  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,
  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,
  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,
  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,
  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,
  376,  377,  378,   -1,  380,  381,  382,  383,  384,   -1,
  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,
   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,
  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,
  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,
  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,
  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,
  456,  457,  458,   -1,  460,   -1,  462,  463,  464,  465,
  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,
   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,
   -1,   -1,  498,  499,  500,  501,  502,  503,  504,   -1,
   -1,   -1,  508,  509,  510,  511,  512,  513,  514,  515,
   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,   -1,  549,  550,  551,  552,  553,  554,   -1,
  556,  557,  558,  559,   -1,  561,   -1,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,    0,  582,  583,  584,  585,
   -1,  587,  588,  589,  590,  591,   -1,  593,  594,  595,
  596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
  606,  607,   -1,  609,  610,  611,  612,  613,  614,  615,
   -1,   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,
  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,
  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,
   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,
   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,
  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,
  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,
   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,
   -1,  376,  377,  378,   -1,  380,  381,  382,  383,  384,
   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,
  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,
  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,
  455,  456,  457,  458,   -1,  460,   -1,  462,  463,  464,
  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,
   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,  514,
  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,    0,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,  606,  607,   -1,  609,  610,  611,  612,  613,  614,
  615,   -1,   -1,   -1,   -1,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,
   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,
   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,
  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,
  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,
  324,   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,
   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,
  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,
  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,
  374,   -1,  376,  377,  378,   -1,  380,  381,  382,  383,
  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,
  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,
   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,
  414,   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,
   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,
  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,
   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,  463,
  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,
  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,
   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,  503,
  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,
  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,   -1,  549,  550,  551,  552,  553,
  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,    0,  582,  583,
  584,  585,   -1,  587,  588,  589,  590,  591,   -1,  593,
  594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
  604,  605,  606,  607,   -1,  609,  610,  611,  612,  613,
  614,  615,   -1,   -1,   -1,   -1,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,
  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,
   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,
   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,
   -1,  324,   -1,  326,  327,  328,  329,  330,  331,   -1,
   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,
  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,
  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,
   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,  382,
  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,
  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,
   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,
  463,  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,
  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,
  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,
  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,    0,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,  606,  607,   -1,  609,  610,  611,  612,
  613,  614,  615,   -1,   -1,   -1,   -1,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,
   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,
  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,
   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,
  282,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,
   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,
   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,
   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,
  322,   -1,  324,   -1,  326,  327,  328,  329,  330,  331,
   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,
   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,
   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,
   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,
  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,
  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,
  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,
   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,
  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,
  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,
  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,
   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,
  462,  463,  464,  465,  466,  467,  468,  469,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,
  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,
  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,
  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,    0,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,  606,  607,   -1,  609,  610,  611,
  612,  613,  614,  615,   -1,   -1,   -1,   -1,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,
  281,  282,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,
  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,
  321,  322,   -1,  324,   -1,  326,  327,  328,  329,  330,
  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,
   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,
  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,
  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,
   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,
  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,  462,  463,  464,  465,  466,  467,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,
  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
    0,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,  606,  607,   -1,  609,  610,
  611,  612,  613,  614,  615,   -1,   -1,   -1,   -1,   -1,
   40,   41,   42,   43,   44,   45,   46,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,
   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
  280,  281,  282,  283,   -1,  285,   -1,   -1,  288,   -1,
   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,
  300,  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,
   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,
  320,  321,  322,   -1,  324,   -1,  326,  327,  328,  329,
  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,
   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,
  370,  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,
  380,  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,
   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,
  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,
  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,
  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,
  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,
  460,   -1,  462,  463,  464,  465,  466,  467,  468,  469,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,
  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,
  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,
  510,  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,    0,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,  606,  607,   -1,  609,
  610,  611,  612,  613,  614,  615,   -1,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,
  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,
  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,  280,  281,  282,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,  308,
   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,
   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,  328,
  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,
   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,  378,
   -1,  380,  381,  382,  383,  384,   -1,  386,  387,   -1,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,
  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
   -1,  460,   -1,  462,  463,  464,  465,  466,  467,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,
  509,  510,  511,  512,  513,  514,  515,   -1,  517,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,    0,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,  606,  607,   -1,
  609,  610,  611,  612,  613,  614,  615,   -1,   -1,   -1,
   -1,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
   -1,  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
   -1,   -1,  280,  281,  282,  283,   -1,  285,   -1,   -1,
  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,
  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,
  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,
   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,
  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,
  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,
  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,
  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,
  378,   -1,  380,  381,  382,  383,  384,   -1,  386,  387,
   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,
  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,
   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,
  418,  419,  420,  421,  422,   -1,   -1,  425,  426,  427,
   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,
   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,
  458,   -1,  460,   -1,  462,  463,  464,  465,  466,  467,
  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,
   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
  508,  509,  510,  511,  512,  513,  514,  515,   -1,  517,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,    0,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,  606,  607,
   -1,  609,  610,  611,  612,  613,  614,  615,   -1,   -1,
   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,   -1,  259,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,   -1,
   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,
  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,
  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,
  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,
  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,
   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,
   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,
  377,  378,   -1,  380,  381,  382,  383,  384,   -1,  386,
  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,  426,
  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,
   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,   -1,  462,  463,  464,  465,  466,
  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,  508,  509,  510,  511,  512,  513,  514,  515,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,    0,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,  606,
  607,   -1,  609,  610,  611,  612,  613,  614,  615,   -1,
   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,  265,
   -1,   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,
   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,
   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,
   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,
  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,
  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,
  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,
  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,
  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,
  376,  377,  378,   -1,  380,  381,  382,  383,  384,   -1,
  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,
   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,
  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,
  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,
  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,
  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,
  456,  457,  458,   -1,  460,   -1,  462,  463,  464,  465,
  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,
   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,
   -1,   -1,  498,  499,  500,  501,  502,  503,  504,   -1,
   -1,   -1,  508,  509,  510,  511,  512,  513,  514,  515,
   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,   -1,  549,  550,  551,  552,  553,  554,   -1,
  556,  557,  558,  559,   -1,  561,   -1,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,    0,  582,  583,  584,  585,
   -1,  587,  588,  589,  590,  591,   -1,  593,  594,  595,
  596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
  606,  607,   -1,  609,  610,  611,  612,  613,  614,  615,
   -1,   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,
  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,
  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,
   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,
   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,
  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,
  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,
   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,
   -1,  376,  377,  378,   -1,  380,  381,  382,  383,  384,
   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,
  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,
  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,
  455,  456,  457,  458,   -1,  460,   -1,  462,  463,  464,
  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,
   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,  514,
  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,    0,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,  606,  607,   -1,  609,  610,  611,  612,  613,  614,
  615,   -1,   -1,   -1,   -1,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,
   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,
   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,
  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,
  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,
  324,   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,
   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,
  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,
  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,
  374,   -1,  376,  377,  378,   -1,  380,  381,  382,  383,
  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,
  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,
   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,
  414,   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,
   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,
  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,
   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,  463,
  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,
  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,
   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,  503,
  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,
  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,   -1,  549,  550,  551,  552,  553,
  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,    0,  582,  583,
  584,  585,   -1,  587,  588,  589,  590,  591,   -1,  593,
  594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
  604,  605,  606,  607,   -1,  609,  610,  611,  612,  613,
  614,  615,   -1,   -1,   -1,   -1,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,
  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,
   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,
   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,
   -1,  324,   -1,  326,  327,  328,  329,  330,  331,   -1,
   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,
  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,
  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,
   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,  382,
  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,
  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,
   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,
  463,  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,
  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,
  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,
  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,    0,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,  606,  607,   -1,  609,  610,  611,  612,
  613,  614,  615,   -1,   -1,   -1,   -1,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,
   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,
  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,
   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,
  282,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,
   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,
   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,
   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,
  322,   -1,  324,   -1,  326,  327,  328,  329,  330,  331,
   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,
   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,
   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,
   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,
  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,
  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,
  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,
   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,
  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,
  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,
  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,
   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,
  462,  463,  464,  465,  466,  467,  468,  469,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,
  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,
  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,
  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,    0,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,  606,  607,   -1,  609,  610,  611,
  612,  613,  614,  615,   -1,   -1,   -1,   -1,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,
  281,  282,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,
  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,
  321,  322,   -1,  324,   -1,  326,  327,  328,  329,  330,
  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,
   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,
  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,
  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,
   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,
  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,  462,  463,  464,  465,  466,  467,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,
  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
    0,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,  606,  607,   -1,  609,  610,
  611,  612,  613,  614,  615,   -1,   -1,   -1,   -1,   -1,
   40,   41,   42,   43,   44,   45,   46,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,
   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
  280,  281,  282,  283,   -1,  285,   -1,   -1,  288,   -1,
   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,
  300,  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,
   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,
  320,  321,  322,   -1,  324,   -1,  326,  327,  328,  329,
  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,
   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,
  370,  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,
  380,  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,
   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,
  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,
  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,
  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,
  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,
  460,   -1,  462,  463,  464,  465,  466,  467,  468,  469,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,
  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,
  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,
  510,  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,    0,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,  606,  607,   -1,  609,
  610,  611,  612,  613,  614,  615,   -1,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,
  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,
  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,  280,  281,  282,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,  308,
   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,
   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,  328,
  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,
   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,  378,
   -1,  380,  381,  382,  383,  384,   -1,  386,  387,   -1,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,
  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
   -1,  460,   -1,  462,  463,  464,  465,  466,  467,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,
  509,  510,  511,  512,  513,  514,  515,   -1,  517,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,    0,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,  606,  607,   -1,
  609,  610,  611,  612,  613,  614,  615,   -1,   -1,   -1,
   -1,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
   -1,  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
   -1,   -1,  280,  281,  282,  283,   -1,  285,   -1,   -1,
  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,
  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,
  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,
   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,
  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,
  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,
  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,
  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,
  378,   -1,  380,  381,  382,  383,  384,   -1,  386,  387,
   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,
  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,
   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,
  418,  419,  420,  421,  422,   -1,   -1,  425,  426,  427,
   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,
   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,
  458,   -1,  460,   -1,  462,  463,  464,  465,  466,  467,
  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,
   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
  508,  509,  510,  511,  512,  513,  514,  515,   -1,  517,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,    0,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,  606,  607,
   -1,  609,  610,  611,  612,  613,  614,  615,   -1,   -1,
   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,   -1,  259,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,   -1,
   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,
  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,
  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,
  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,
  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,
   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,
   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,
  377,  378,   -1,  380,  381,  382,  383,  384,   -1,  386,
  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,  426,
  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,
   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,   -1,  462,  463,  464,  465,  466,
  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,  508,  509,  510,  511,  512,  513,  514,  515,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,    0,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,  606,
  607,   -1,  609,  610,  611,  612,  613,  614,  615,   -1,
   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,  265,
   -1,   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,
   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,
   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,
   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,
  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,
  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,
  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,
  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,
  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,
  376,  377,  378,   -1,  380,  381,  382,  383,  384,   -1,
  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,
   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,
  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,
  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,
  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,
  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,
  456,  457,  458,   -1,  460,   -1,  462,  463,  464,  465,
  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,
   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,
   -1,   -1,  498,  499,  500,  501,  502,  503,  504,   -1,
   -1,   -1,  508,  509,  510,  511,  512,  513,  514,  515,
   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,   -1,  549,  550,  551,  552,  553,  554,   -1,
  556,  557,  558,  559,   -1,  561,   -1,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,    0,  582,  583,  584,  585,
   -1,  587,  588,  589,  590,  591,   -1,  593,  594,  595,
  596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
  606,  607,   -1,  609,  610,  611,  612,  613,  614,  615,
   -1,   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,
  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,
  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,
   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,
   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,
  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,
  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,
   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,
   -1,  376,  377,  378,   -1,  380,  381,  382,  383,  384,
   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,
  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,
  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,
  455,  456,  457,  458,   -1,  460,   -1,  462,  463,  464,
  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,
   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,  514,
  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,    0,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,  606,  607,   -1,  609,  610,  611,  612,  613,  614,
  615,   -1,   -1,   -1,   -1,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,
   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,
   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,
  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,
  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,
  324,   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,
   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,
  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,
  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,
  374,   -1,  376,  377,  378,   -1,  380,  381,  382,  383,
  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,
  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,
   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,
  414,   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,
   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,
  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,
   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,  463,
  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,
  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,
   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,  503,
  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,
  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,   -1,  549,  550,  551,  552,  553,
  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,    0,  582,  583,
  584,  585,   -1,  587,  588,  589,  590,  591,   -1,  593,
  594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
  604,  605,  606,  607,   -1,  609,  610,  611,  612,  613,
  614,  615,   -1,   -1,   -1,   -1,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,
  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,
   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,
   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,
   -1,  324,   -1,  326,  327,  328,  329,  330,  331,   -1,
   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,
  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,
  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,
   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,  382,
  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,
  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,
   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,
  463,  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,
  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,
  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,
  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,    0,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,  606,  607,   -1,  609,  610,  611,  612,
  613,  614,  615,   -1,   -1,   -1,   -1,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,
   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,
  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,
   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,
  282,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,
   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,
   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,
   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,
  322,   -1,  324,   -1,  326,  327,  328,  329,  330,  331,
   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,
   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,
   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,
   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,
  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,
  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,
  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,
   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,
  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,
  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,
  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,
   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,
  462,  463,  464,  465,  466,  467,  468,  469,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,
  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,
  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,
  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,    0,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,  606,  607,   -1,  609,  610,  611,
  612,  613,  614,  615,   -1,   -1,   -1,   -1,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,
  281,  282,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,
  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,
  321,  322,   -1,  324,   -1,  326,  327,  328,  329,  330,
  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,
   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,
  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,
  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,
   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,
  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,  462,  463,  464,  465,  466,  467,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,
  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
    0,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,  606,  607,   -1,  609,  610,
  611,  612,  613,  614,  615,   -1,   -1,   -1,   -1,   -1,
   40,   41,   42,   43,   44,   45,   46,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,
   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
  280,  281,  282,  283,   -1,  285,   -1,   -1,  288,   -1,
   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,
  300,  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,
   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,
  320,  321,  322,   -1,  324,   -1,  326,  327,  328,  329,
  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,
   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,
  370,  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,
  380,  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,
   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,
  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,
  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,
  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,
  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,
  460,   -1,  462,  463,  464,  465,  466,  467,  468,  469,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,
  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,
  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,
  510,  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,    0,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,  606,  607,   -1,  609,
  610,  611,  612,  613,  614,  615,   -1,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,
  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,
  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,  280,  281,  282,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,  308,
   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,
   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,  328,
  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,
   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,  378,
   -1,  380,  381,  382,  383,  384,   -1,  386,  387,   -1,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,
  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
   -1,  460,   -1,  462,  463,  464,  465,  466,  467,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,
  509,  510,  511,  512,  513,  514,  515,   -1,  517,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,    0,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,  606,  607,   -1,
  609,  610,  611,  612,  613,  614,  615,   -1,   -1,   -1,
   -1,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
   -1,  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
   -1,   -1,  280,  281,  282,  283,   -1,  285,   -1,   -1,
  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,
  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,
  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,
   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,
  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,
  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,
  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,
  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,
  378,   -1,  380,  381,  382,  383,  384,   -1,  386,  387,
   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,
  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,
   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,
  418,  419,  420,  421,  422,   -1,   -1,  425,  426,  427,
   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,
   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,
  458,   -1,  460,   -1,  462,  463,  464,  465,  466,  467,
  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,
   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
  508,  509,  510,  511,  512,  513,  514,  515,   -1,  517,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,    0,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,  606,  607,
   -1,  609,  610,  611,  612,  613,  614,  615,   -1,   -1,
   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,   -1,  259,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,   -1,
   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,
  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,
  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,
  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,
  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,
   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,
   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,
  377,  378,   -1,  380,  381,  382,  383,  384,   -1,  386,
  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,  426,
  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,
   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,   -1,  462,  463,  464,  465,  466,
  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,  508,  509,  510,  511,  512,  513,  514,  515,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,    0,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,  606,
  607,   -1,  609,  610,  611,  612,  613,  614,  615,   -1,
   -1,   -1,   -1,   -1,   -1,   41,   42,   43,   44,   45,
   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,  265,
   -1,   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,
   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,
   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,
   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,
  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,
  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,
  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,
  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,
  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,
  376,  377,  378,   -1,  380,  381,  382,  383,  384,   -1,
  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,
   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,
  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,
  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,
  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,
  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,
  456,  457,  458,   -1,  460,   -1,  462,  463,  464,  465,
  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,
   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,
   -1,   -1,  498,  499,  500,  501,  502,  503,  504,   -1,
   -1,   -1,  508,  509,  510,  511,  512,  513,  514,  515,
   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,   -1,  549,  550,  551,  552,  553,  554,   -1,
  556,  557,  558,  559,   -1,  561,   -1,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,    0,  582,  583,  584,  585,
   -1,  587,  588,  589,  590,  591,   -1,  593,  594,  595,
  596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
  606,  607,   -1,  609,  610,  611,  612,  613,  614,  615,
   -1,   -1,   -1,   -1,   -1,   -1,   41,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,
  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,
  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,
   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,
   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,
  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,
  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,
   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,
   -1,  376,  377,  378,   -1,  380,  381,  382,  383,  384,
   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,
  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,
  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,
  455,  456,  457,  458,   -1,  460,   -1,  462,  463,  464,
  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,
   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,  514,
  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,    0,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,  606,  607,   -1,  609,  610,  611,  612,  613,  614,
  615,   -1,   -1,   -1,   -1,   -1,   -1,   41,   42,   43,
   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,
   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,
   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,
  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,
  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,
  324,   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,
   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,
  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,
  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,
  374,   -1,  376,  377,  378,   -1,  380,  381,  382,  383,
  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,
  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,
   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,
  414,   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,
   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,
  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,
   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,  463,
  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,
  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,
   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,  503,
  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,
  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,   -1,  549,  550,  551,  552,  553,
  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,    0,  582,  583,
  584,  585,   -1,  587,  588,  589,  590,  591,   -1,  593,
  594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
  604,  605,  606,  607,   -1,  609,  610,  611,  612,  613,
  614,  615,   -1,   -1,   -1,   -1,   -1,   -1,   41,   42,
   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,
  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,
   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,
   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,
   -1,  324,   -1,  326,  327,  328,  329,  330,  331,   -1,
   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,
  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,
  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,
   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,  382,
  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,
  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,
   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,
  463,  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,
  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,
  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,
  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,    0,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,  606,  607,   -1,  609,  610,  611,  612,
  613,  614,  615,   -1,   -1,   -1,   -1,   -1,   -1,   41,
   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,
   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,
  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,
   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,
  282,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,
   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,
   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,
   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,
  322,   -1,  324,   -1,  326,  327,  328,  329,  330,  331,
   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,
   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,
   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,
   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,
  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,
  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,
  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,
   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,
  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,
  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,
  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,
   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,
  462,  463,  464,  465,  466,  467,  468,  469,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,
  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,
  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,
  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,    0,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,  606,  607,   -1,  609,  610,  611,
  612,  613,  614,  615,   -1,   -1,   -1,   -1,   -1,   -1,
   41,   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,
  281,  282,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,
  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,
  321,  322,   -1,  324,   -1,  326,  327,  328,  329,  330,
  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,
   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,
  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,
  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,
   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,
  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,  462,  463,  464,  465,  466,  467,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,
  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
    0,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,  606,  607,   -1,  609,  610,
  611,  612,  613,  614,  615,   -1,   -1,   -1,   -1,   -1,
   -1,   41,   42,   43,   44,   45,   46,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,
   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
  280,  281,  282,  283,   -1,  285,   -1,   -1,  288,   -1,
   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,
  300,  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,
   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,
  320,  321,  322,   -1,  324,   -1,  326,  327,  328,  329,
  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,
   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,
  370,  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,
  380,  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,
   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,
  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,
  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,
  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,
  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,
  460,   -1,  462,  463,  464,  465,  466,  467,  468,  469,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,
  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,
  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,
  510,  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,    0,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,  606,  607,   -1,  609,
  610,  611,  612,  613,  614,  615,   -1,   -1,   -1,   -1,
   -1,   -1,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,
  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,
  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,  280,  281,  282,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,  308,
   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,
   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,  328,
  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,
   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,  378,
   -1,  380,  381,  382,  383,  384,   -1,  386,  387,   -1,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,
  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
   -1,  460,   -1,  462,  463,  464,  465,  466,  467,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,
  509,  510,  511,  512,  513,  514,  515,   -1,  517,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,    0,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,  606,  607,   -1,
  609,  610,  611,  612,  613,  614,  615,   -1,   -1,   -1,
   -1,   -1,   -1,   41,   42,   43,   44,   45,   46,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
   -1,  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
   -1,   -1,  280,  281,  282,  283,   -1,  285,   -1,   -1,
  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,
  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,
  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,
   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,
  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,
  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,
  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,
  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,
  378,   -1,  380,  381,  382,  383,  384,   -1,  386,  387,
   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,
  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,
   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,
  418,  419,  420,  421,  422,   -1,   -1,  425,  426,  427,
   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,
   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,
  458,   -1,  460,   -1,  462,  463,  464,  465,  466,  467,
  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,
   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
  508,  509,  510,  511,  512,  513,  514,  515,   -1,  517,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,    0,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,  606,  607,
   -1,  609,  610,  611,  612,  613,  614,  615,   -1,   -1,
   -1,   -1,   -1,   -1,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,   -1,  259,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,   -1,
   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,
  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,
  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,
  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,
  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,
   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,
   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,
  377,  378,   -1,  380,  381,  382,  383,  384,   -1,  386,
  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,  426,
  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,
   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,   -1,  462,  463,  464,  465,  466,
  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,  508,  509,  510,  511,  512,  513,  514,  515,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,    0,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,  606,
  607,   -1,  609,  610,  611,  612,  613,  614,  615,   -1,
   -1,   -1,   -1,   -1,   -1,   41,   42,   43,   44,   45,
   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,  265,
   -1,   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,
   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,
   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,
   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,
  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,
  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,
  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,
  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,
  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,
  376,  377,  378,   -1,  380,  381,  382,  383,  384,   -1,
  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,
   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,
  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,
  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,
  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,
  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,
  456,  457,  458,   -1,  460,   -1,  462,  463,  464,  465,
  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,
   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,
   -1,   -1,  498,  499,  500,  501,  502,  503,  504,   -1,
   -1,   -1,  508,  509,  510,  511,  512,  513,  514,  515,
   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,   -1,  549,  550,  551,  552,  553,  554,   -1,
  556,  557,  558,  559,   -1,  561,   -1,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,    0,  582,  583,  584,  585,
   -1,  587,  588,  589,  590,  591,   -1,  593,  594,  595,
  596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
  606,  607,   -1,  609,  610,  611,  612,  613,  614,  615,
   -1,   -1,   -1,   -1,   -1,   -1,   41,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,
  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,
  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,
   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,
   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,
  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,
  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,
   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,
   -1,  376,  377,  378,   -1,  380,  381,  382,  383,  384,
   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,
  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,
  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,
  455,  456,  457,  458,   -1,  460,   -1,  462,  463,  464,
  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,
   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,  514,
  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,    0,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,  606,  607,   -1,  609,  610,  611,  612,  613,   -1,
  615,   -1,   -1,   -1,   -1,   -1,   -1,   41,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,
   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,
   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,
  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,
  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,
  324,   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,
   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,
  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,
  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,
  374,   -1,  376,  377,  378,   -1,  380,  381,  382,  383,
  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,
  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,
   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,
  414,   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,
   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,
  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,
   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,  463,
  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,
  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,
   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,  503,
  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,
  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,   -1,  549,  550,  551,  552,  553,
  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,    0,  582,  583,
  584,  585,   -1,  587,  588,  589,  590,  591,   -1,  593,
  594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
  604,  605,  606,  607,   -1,  609,  610,  611,  612,  613,
   -1,  615,   -1,   -1,   -1,   -1,   -1,   -1,   41,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,  281,  282,
  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,
   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,
   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,
   -1,  324,   -1,  326,  327,  328,  329,  330,  331,   -1,
   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,
  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,
  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,
   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,  382,
  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,
  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,
   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,
  463,  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,
  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,
  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,
  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,    0,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,  606,  607,   -1,  609,  610,  611,  612,
  613,   -1,  615,   -1,   -1,   -1,   -1,   -1,   -1,   41,
   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,
  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,  281,
   -1,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,
   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,
   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,
   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,
  322,   -1,  324,   -1,  326,  327,  328,  329,  330,  331,
   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,
   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,
   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,
   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,
  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,
  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,
  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,
   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,
  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,
  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,
  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,
   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,
  462,  463,  464,  465,  466,  467,  468,  469,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,
  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,
  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,
  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,    0,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,  606,  607,   -1,  609,  610,  611,
  612,  613,   -1,  615,   -1,   -1,   -1,   -1,   -1,   -1,
   41,   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,
  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
  281,   -1,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,
  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,
  321,  322,   -1,  324,   -1,  326,  327,  328,  329,  330,
  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,
   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,
  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,
  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,
   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,
  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,  462,  463,  464,  465,  466,  467,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,
  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
    0,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,  606,  607,   -1,  609,  610,
  611,  612,  613,   -1,  615,   -1,   -1,   -1,   -1,   -1,
   -1,   41,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,
   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,
   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  280,  281,   -1,  283,   -1,  285,   -1,   -1,  288,   -1,
   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,
  300,  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,
   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,
  320,  321,  322,   -1,  324,   -1,  326,  327,  328,  329,
  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,
   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,
  370,  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,
  380,  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,
   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,
  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,
  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,
  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,
  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,
  460,   -1,  462,  463,  464,  465,  466,  467,  468,  469,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,
  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,
  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,
  510,  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,    0,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,  606,  607,   -1,  609,
  610,  611,  612,  613,   -1,  615,   -1,   -1,   -1,   -1,
   -1,   -1,   41,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   93,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,
  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,
  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  280,  281,   -1,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,  308,
   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,
   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,  328,
  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,
   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,  378,
   -1,  380,  381,  382,  383,  384,   -1,  386,  387,   -1,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,
  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
   -1,  460,   -1,  462,  463,  464,  465,  466,  467,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,
  509,  510,  511,  512,  513,  514,  515,   -1,  517,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,    0,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,  606,  607,   -1,
  609,  610,  611,  612,  613,   -1,  615,   -1,   -1,   -1,
   -1,   -1,   -1,   41,   -1,   43,   44,   45,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
   -1,  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  280,  281,   -1,  283,   -1,  285,   -1,   -1,
  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,
  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,
  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,
   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,
  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,
  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,
  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,
  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,
  378,   -1,  380,  381,  382,  383,  384,   -1,  386,  387,
   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,
  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,
   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,
  418,  419,  420,  421,  422,   -1,   -1,  425,  426,  427,
   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,
   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,
  458,   -1,  460,   -1,  462,  463,  464,  465,  466,  467,
  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,
   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
  508,  509,  510,  511,  512,  513,  514,  515,   -1,  517,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,    0,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,  606,  607,
   -1,  609,  610,  611,  612,  613,   -1,  615,   -1,   -1,
   -1,   -1,   -1,   -1,   41,   -1,   43,   44,   45,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,   -1,  259,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,   -1,
   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,
  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,
  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,
  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,
  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,
   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,
   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,
  377,  378,   -1,  380,  381,  382,  383,  384,   -1,  386,
  387,   -1,   -1,    0,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,  426,
  427,   -1,  429,  430,   41,   -1,   -1,   44,   -1,   -1,
   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,
   -1,   -1,   59,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,   -1,  462,  463,  464,  465,  466,
  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,  508,  509,  510,  511,  512,  513,  514,  515,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,   -1,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,  606,
  607,   -1,  609,  610,  611,  612,  613,   -1,  615,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,   -1,  259,   -1,   -1,   -1,   -1,  264,  265,   -1,
   -1,  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,   -1,
   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,
   -1,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,   -1,
  317,   -1,   -1,   -1,  321,  322,   -1,  324,   -1,  326,
  327,   -1,  329,  330,  331,   -1,   -1,   -1,  335,   -1,
  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,   -1,    0,   -1,  351,   -1,  353,   -1,  355,   -1,
   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  374,   -1,  376,
   -1,  378,   -1,  380,  381,  382,  383,  384,   -1,  386,
  387,   -1,   40,   41,   -1,  392,   44,  394,  395,   -1,
   -1,  398,  399,   -1,   -1,   -1,  403,   -1,   -1,  406,
   -1,   59,  409,  410,  411,  412,   -1,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,   -1,   -1,
  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  440,   -1,  442,   -1,  444,  445,  446,
   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,  508,  509,  510,  511,  512,  513,  514,  515,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,   -1,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,  257,
  607,  259,  609,  610,  611,  612,  613,  265,  615,   -1,
  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  280,  281,   -1,  283,   -1,  285,   -1,   -1,
  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,
  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,
  308,   -1,   -1,  311,   -1,   -1,  314,   -1,   -1,  317,
   -1,   -1,   -1,  321,  322,   -1,  324,   -1,  326,  327,
   -1,  329,  330,  331,   -1,   -1,   -1,  335,   -1,  337,
  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,    0,   -1,  351,   -1,  353,   -1,  355,   -1,   -1,
  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  374,   -1,  376,   -1,
  378,   -1,  380,  381,  382,  383,  384,   -1,  386,  387,
   -1,   -1,   41,   -1,  392,   44,  394,  395,   -1,   -1,
  398,  399,   -1,   -1,   -1,  403,   -1,   -1,  406,   -1,
   59,  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,
  418,  419,  420,  421,  422,   -1,   -1,   -1,   -1,  427,
   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  440,   -1,  442,   -1,  444,  445,  446,   -1,
   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,
  458,   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,
   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
  508,  509,  510,  511,  512,  513,  514,  515,   -1,  517,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,   -1,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,  257,  607,
  259,  609,  610,  611,  612,  613,  265,  615,   -1,  268,
  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  280,  281,   -1,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,
   -1,   -1,  311,   -1,   -1,  314,   -1,   -1,  317,   -1,
   -1,   -1,  321,  322,   -1,  324,   -1,  326,  327,   -1,
  329,  330,  331,   -1,   -1,   -1,  335,   -1,  337,  338,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
    0,   -1,  351,   -1,  353,   -1,  355,   -1,   -1,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  374,   -1,  376,   -1,  378,
   -1,  380,  381,  382,  383,  384,   -1,  386,  387,   -1,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,   -1,   -1,   -1,  403,   -1,   -1,  406,   -1,   59,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,   -1,   -1,  427,   -1,
  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,   -1,  442,   -1,  444,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,
  509,  510,  511,  512,  513,  514,  515,   -1,  517,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,   -1,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,  257,  607,  259,
  609,  610,  611,  612,  613,  265,  615,   -1,  268,  269,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  280,  281,   -1,  283,   -1,  285,   -1,   -1,  288,   -1,
   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,
  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,
   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,
   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  351,   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,
   -1,   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,  378,   -1,
  380,  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,
   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,
   -1,   -1,   -1,   -1,   -1,   -1,  406,   -1,  408,  409,
  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,
  420,  421,  422,   -1,   -1,   40,   -1,  427,   43,  429,
   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  440,   -1,  442,   58,   -1,  445,  446,   -1,   63,   -1,
  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,
  460,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,
  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,
  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,
  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,   -1,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,   -1,  607,   -1,  609,
  610,  611,  612,  613,   -1,  615,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,  259,   -1,   -1,   -1,   -1,   -1,
  265,   -1,  267,  268,  269,   -1,   -1,   -1,   -1,  274,
   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,
  285,  286,   -1,  288,   -1,   -1,  291,  292,  293,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,   -1,   -1,
  305,   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  319,   -1,  321,  322,   -1,   -1,
   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,  347,   -1,  349,  350,  351,   -1,  353,   -1,
  355,   -1,   -1,  358,  359,   -1,   -1,  362,  363,  364,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,
   -1,  386,   -1,  388,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,   -1,   -1,   -1,  403,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
   -1,  416,  417,  418,  419,  420,  421,  422,  423,   -1,
   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,  433,   -1,
   -1,   40,   -1,   -1,   43,  440,   45,   -1,   -1,   -1,
  445,  446,  447,  448,  449,  450,  451,  452,  453,   58,
  455,  456,  457,  458,   63,  460,  461,  462,  463,  464,
  465,  466,  467,  468,  469,  470,  471,  472,  473,  474,
  475,  476,  477,  478,  479,  480,   -1,  482,  483,  484,
  485,  486,   -1,  488,  489,  490,   -1,  492,  493,  494,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,
  515,   -1,  517,   -1,  519,  520,  521,   -1,  523,  524,
   -1,  526,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,   -1,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,   -1,  607,   -1,  609,  610,  611,  612,  613,   -1,
  615,  616,  617,  618,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,
  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,  267,  268,
  269,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,
   -1,  280,  281,   -1,  283,   -1,  285,  286,   -1,  288,
  289,   -1,  291,  292,  293,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,
   -1,  310,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  319,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,  347,   -1,
  349,  350,  351,   -1,  353,   -1,  355,   -1,   -1,  358,
  359,   -1,   -1,  362,  363,  364,   -1,   -1,   -1,   -1,
   -1,  370,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,
   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,  388,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,   -1,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,  417,  418,
  419,  420,  421,  422,  423,   -1,   -1,   -1,  427,   -1,
  429,   -1,   -1,   -1,  433,   -1,   -1,   40,   -1,   -1,
   43,  440,   45,   -1,   -1,   -1,  445,  446,  447,  448,
  449,  450,  451,  452,  453,   58,  455,  456,  457,  458,
   63,  460,  461,   -1,   -1,   -1,   -1,   -1,   -1,  468,
  469,  470,  471,  472,  473,  474,  475,  476,  477,  478,
  479,  480,   -1,  482,  483,  484,  485,  486,   -1,  488,
  489,  490,   -1,  492,  493,  494,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,   -1,
  509,  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,
  519,  520,  521,   -1,  523,  524,   -1,  526,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,   -1,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,   -1,  607,   -1,
  609,  610,  611,  612,  613,   -1,  615,  616,  617,  618,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,   -1,
   -1,   -1,  265,   -1,  267,  268,  269,   -1,   -1,   -1,
   -1,  274,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,
  283,   -1,  285,  286,   -1,  288,   -1,   -1,  291,  292,
  293,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
   -1,   -1,  305,   -1,   -1,  308,   -1,  310,  311,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  319,   -1,  321,  322,
   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,  347,   -1,  349,  350,  351,   -1,
  353,   -1,  355,   -1,   -1,  358,  359,   -1,   -1,  362,
  363,  364,   -1,   -1,   -1,   -1,   -1,  370,   -1,   -1,
   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,
  383,  384,   -1,  386,   -1,  388,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,   -1,
  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,  417,  418,  419,  420,  421,  422,
  423,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,
  433,   -1,   -1,   40,   -1,   -1,   43,  440,   45,   -1,
   -1,  444,  445,  446,  447,  448,  449,  450,  451,  452,
  453,   58,  455,  456,  457,  458,   63,  460,  461,   -1,
   -1,   -1,   -1,   -1,   -1,  468,  469,  470,  471,  472,
  473,  474,  475,  476,  477,  478,  479,  480,   -1,  482,
  483,  484,  485,  486,   -1,  488,  489,  490,   -1,  492,
  493,  494,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,
  513,  514,  515,   -1,  517,   -1,  519,  520,  521,   -1,
  523,  524,   -1,  526,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,   -1,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,   -1,  607,   -1,  609,  610,  611,  612,
  613,   -1,  615,  616,  617,  618,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,   -1,  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,
  267,  268,  269,   -1,   -1,   -1,   -1,  274,   -1,   -1,
   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,  286,
   -1,  288,   -1,   -1,  291,  292,  293,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,
   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  319,   -1,  321,  322,   -1,   -1,   -1,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,
  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
  347,   -1,  349,  350,  351,   -1,  353,   -1,  355,   -1,
   -1,  358,  359,   -1,   -1,  362,  363,  364,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,
   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,
   -1,  388,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,   -1,   -1,   -1,  403,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
  417,  418,  419,  420,  421,  422,  423,   -1,   -1,   -1,
  427,   -1,  429,   -1,   -1,   -1,  433,   -1,   -1,   40,
   -1,   -1,   43,  440,   45,   -1,   -1,   -1,  445,  446,
  447,  448,  449,  450,  451,  452,  453,   58,  455,  456,
  457,  458,   63,  460,  461,   -1,   -1,   -1,   -1,   -1,
   -1,  468,  469,  470,  471,  472,  473,  474,  475,  476,
  477,  478,  479,  480,   -1,  482,  483,  484,  485,  486,
   -1,  488,  489,  490,   -1,  492,  493,  494,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,  516,
  517,   -1,  519,  520,  521,  522,  523,  524,  525,  526,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,   -1,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,   -1,
  607,   -1,  609,  610,  611,  612,  613,   -1,  615,  616,
  617,  618,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,  260,
   -1,   -1,  263,   -1,  265,   -1,  267,  268,  269,   -1,
   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,  280,
  281,   -1,  283,   -1,  285,  286,   -1,  288,   -1,   -1,
  291,  292,  293,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,
  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  319,   -1,
  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,  347,   -1,  349,  350,
  351,   -1,  353,   -1,  355,   -1,   -1,  358,  359,   -1,
   -1,  362,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,
  381,  382,  383,  384,   -1,  386,   -1,  388,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,
   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,  415,  416,  417,  418,  419,  420,
  421,  422,  423,   -1,   -1,   -1,  427,   -1,  429,   -1,
   -1,   -1,  433,   -1,   -1,   40,   -1,   -1,   43,  440,
   45,   -1,   -1,   -1,  445,  446,  447,  448,  449,  450,
  451,  452,  453,   58,  455,  456,  457,  458,   63,  460,
  461,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,  470,
  471,  472,  473,  474,  475,  476,  477,  478,  479,  480,
   -1,  482,  483,  484,  485,  486,   -1,  488,  489,  490,
   -1,  492,  493,  494,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,
  511,   -1,  513,  514,  515,   -1,  517,   -1,  519,  520,
  521,   -1,  523,  524,   -1,  526,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
   -1,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,   -1,  607,   -1,  609,  610,
  611,  612,  613,   -1,  615,  616,  617,  618,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,  259,  260,   -1,   -1,  263,   -1,
  265,   -1,  267,  268,  269,   -1,   -1,   -1,   -1,  274,
   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,
  285,  286,   -1,  288,   -1,   -1,  291,  292,  293,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,   -1,   -1,
  305,   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  319,   -1,  321,  322,   -1,   -1,
   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,  347,   -1,  349,  350,  351,   -1,  353,   -1,
  355,   -1,   -1,  358,  359,   -1,   -1,  362,  363,  364,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,
   -1,  386,   -1,  388,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,   -1,   -1,   -1,  403,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
  415,  416,  417,  418,  419,  420,  421,  422,  423,   -1,
   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,  433,   -1,
   -1,   40,   -1,   -1,   43,  440,   45,   -1,   -1,   -1,
  445,  446,  447,  448,  449,  450,  451,  452,  453,   58,
  455,  456,  457,  458,   63,  460,  461,   -1,   -1,   -1,
   -1,   -1,   -1,  468,  469,  470,  471,  472,  473,  474,
  475,  476,  477,  478,  479,  480,   -1,  482,  483,  484,
  485,  486,   -1,  488,  489,  490,   -1,  492,  493,  494,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,
  515,   -1,  517,   -1,  519,  520,  521,   -1,  523,  524,
   -1,  526,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,   -1,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,   -1,  607,   -1,  609,  610,  611,  612,  613,   -1,
  615,  616,  617,  618,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,
  259,  260,   -1,   -1,  263,   -1,  265,   -1,  267,  268,
  269,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,
   -1,  280,  281,   -1,  283,   -1,  285,  286,   -1,  288,
   -1,   -1,  291,  292,  293,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,
   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  319,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,  347,   -1,
  349,  350,  351,   -1,  353,   -1,  355,   -1,   -1,  358,
  359,   -1,   -1,  362,  363,  364,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,
   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,  388,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,   -1,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,  415,  416,  417,  418,
  419,  420,  421,  422,  423,   -1,   -1,   -1,  427,   -1,
  429,   -1,   -1,   -1,  433,   -1,   -1,   40,   -1,   -1,
   43,  440,   45,   -1,   -1,   -1,  445,  446,  447,  448,
  449,  450,  451,  452,  453,   58,  455,  456,  457,  458,
   63,  460,  461,   -1,   -1,   -1,   -1,   -1,   -1,  468,
  469,  470,  471,  472,  473,  474,  475,  476,  477,  478,
  479,  480,   -1,  482,  483,  484,  485,  486,   -1,  488,
  489,  490,   -1,  492,  493,  494,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,   -1,
  509,  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,
  519,  520,  521,   -1,  523,  524,   -1,  526,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,   -1,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,   -1,  607,   -1,
  609,  610,  611,  612,  613,   -1,  615,  616,  617,  618,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,   -1,  259,  260,   -1,   -1,
  263,   -1,  265,   -1,  267,  268,  269,   -1,   -1,   -1,
   -1,  274,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,
  283,   -1,  285,  286,   -1,  288,   -1,   -1,  291,  292,
  293,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  319,   -1,  321,  322,
   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,  347,   -1,  349,  350,  351,   -1,
  353,   -1,  355,   -1,   -1,  358,  359,   -1,   -1,  362,
  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,
  383,  384,   -1,  386,   -1,  388,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,   -1,
  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,  415,  416,  417,  418,  419,  420,  421,  422,
  423,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,
  433,   -1,   -1,   40,   -1,   -1,   43,  440,   45,   -1,
   -1,   -1,  445,  446,  447,  448,  449,  450,  451,  452,
  453,   58,  455,  456,  457,  458,   63,  460,  461,   -1,
   -1,   -1,   -1,   -1,   -1,  468,  469,  470,  471,  472,
  473,  474,  475,  476,  477,  478,  479,  480,   -1,  482,
  483,  484,  485,  486,   -1,  488,  489,  490,   -1,  492,
  493,  494,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,
  513,  514,  515,   -1,  517,   -1,  519,  520,  521,   -1,
  523,  524,   -1,  526,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,   -1,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,   -1,  607,   -1,  609,  610,  611,  612,
  613,   -1,  615,  616,  617,  618,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,   -1,  259,  260,   -1,   -1,  263,   -1,  265,   -1,
  267,  268,  269,   -1,   -1,   -1,   -1,  274,   -1,   -1,
   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,  286,
   -1,  288,   -1,   -1,  291,  292,  293,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,
   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  319,   -1,  321,  322,   -1,   -1,   -1,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,
  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
  347,   -1,  349,  350,  351,   -1,  353,   -1,  355,   -1,
   -1,  358,  359,   -1,   -1,  362,  363,  364,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,
   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,
   -1,  388,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,   -1,   -1,   -1,  403,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,  415,  416,
  417,  418,  419,  420,  421,  422,  423,   -1,   -1,   -1,
  427,   -1,  429,   -1,   -1,   -1,  433,   -1,   -1,   40,
   -1,   -1,   43,  440,   45,   -1,   -1,   -1,  445,  446,
  447,  448,  449,  450,  451,  452,  453,   58,  455,  456,
  457,  458,   63,  460,  461,   -1,   -1,   -1,   -1,   -1,
   -1,  468,  469,  470,  471,  472,  473,  474,  475,  476,
  477,  478,  479,  480,   -1,  482,  483,  484,  485,  486,
   -1,  488,  489,  490,   -1,  492,  493,  494,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,
  517,   -1,  519,  520,  521,   -1,  523,  524,   -1,  526,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,   -1,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,   -1,
  607,   -1,  609,  610,  611,  612,  613,   -1,  615,  616,
  617,  618,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,  260,
   -1,   -1,  263,   -1,  265,   -1,  267,  268,  269,   -1,
   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,  280,
  281,   -1,  283,   -1,  285,  286,   -1,  288,   -1,   -1,
  291,  292,  293,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,
  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  319,   -1,
  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,  347,   -1,  349,  350,
  351,   -1,  353,   -1,  355,   -1,   -1,  358,  359,   -1,
   -1,  362,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,
  381,  382,  383,  384,   -1,  386,   -1,  388,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,
   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,  415,  416,  417,  418,  419,  420,
  421,  422,  423,   -1,   -1,   -1,  427,   -1,  429,   -1,
   -1,   -1,  433,   -1,   -1,   40,   -1,   -1,   43,  440,
   45,   -1,   -1,   -1,  445,  446,  447,  448,  449,  450,
  451,  452,  453,   58,  455,  456,  457,  458,   63,  460,
  461,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,  470,
  471,  472,  473,  474,  475,  476,  477,  478,  479,  480,
   -1,  482,  483,  484,  485,  486,   -1,  488,  489,  490,
   -1,  492,  493,  494,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,
  511,   -1,  513,  514,  515,   -1,  517,   -1,  519,  520,
  521,   -1,  523,  524,   -1,  526,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
   -1,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,   -1,  607,   -1,  609,  610,
  611,  612,  613,   -1,  615,  616,  617,  618,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,  259,  260,   -1,   -1,  263,   -1,
  265,   -1,  267,  268,  269,   -1,   -1,   -1,   -1,  274,
   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,
  285,  286,   -1,  288,   -1,   -1,  291,  292,  293,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,   -1,   -1,
  305,   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  319,   -1,  321,  322,   -1,   -1,
   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,  347,   -1,  349,  350,  351,   -1,  353,   -1,
  355,   -1,   -1,  358,  359,   -1,   -1,  362,  363,  364,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,
   -1,  386,   -1,  388,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,   -1,   -1,   -1,  403,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
  415,  416,  417,  418,  419,  420,  421,  422,  423,   -1,
   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,  433,   -1,
   -1,   40,   -1,   -1,   43,  440,   45,   -1,   -1,   -1,
  445,  446,  447,  448,  449,  450,  451,  452,  453,   58,
  455,  456,  457,  458,   63,  460,  461,   -1,   -1,   -1,
   -1,   -1,   -1,  468,  469,  470,  471,  472,  473,  474,
  475,  476,  477,  478,  479,  480,   -1,  482,  483,  484,
  485,  486,   -1,  488,  489,  490,   -1,  492,  493,  494,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,
  515,   -1,  517,   -1,  519,  520,  521,   -1,  523,  524,
   -1,  526,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,   -1,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,   -1,  607,   -1,  609,  610,  611,  612,  613,   -1,
  615,  616,  617,  618,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,
  259,  260,   -1,   -1,  263,   -1,  265,   -1,  267,  268,
  269,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,
   -1,  280,  281,   -1,  283,   -1,  285,  286,   -1,  288,
   -1,   -1,  291,  292,  293,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,
   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  319,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,  347,   -1,
  349,  350,  351,   -1,  353,   -1,  355,   -1,   -1,  358,
  359,   -1,   -1,  362,  363,  364,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,
   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,  388,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,   -1,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,  415,  416,  417,  418,
  419,  420,  421,  422,  423,   -1,   -1,   -1,  427,   -1,
  429,   -1,   -1,   -1,  433,   -1,   -1,   40,   -1,   -1,
   43,  440,   45,   -1,   -1,   -1,  445,  446,  447,  448,
  449,  450,  451,  452,  453,   58,  455,  456,  457,  458,
   63,  460,  461,   -1,   -1,   -1,   -1,   -1,   -1,  468,
  469,  470,  471,  472,  473,  474,  475,  476,  477,  478,
  479,  480,   -1,  482,  483,  484,  485,  486,   -1,  488,
  489,  490,   -1,  492,  493,  494,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,   -1,
  509,  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,
  519,  520,  521,   -1,  523,  524,   -1,  526,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,   -1,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,   -1,  607,   -1,
  609,  610,  611,  612,  613,   -1,  615,  616,  617,  618,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,   -1,
   -1,   -1,  265,   -1,  267,  268,  269,   -1,   -1,   -1,
   -1,  274,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,
  283,   -1,  285,  286,   -1,  288,   -1,   -1,  291,  292,
  293,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
   -1,   -1,  305,   -1,   -1,  308,   -1,  310,  311,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  319,   -1,  321,  322,
   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,  347,   -1,  349,  350,  351,   -1,
  353,   -1,  355,   -1,   -1,  358,  359,   -1,   -1,  362,
  363,  364,   -1,   -1,   -1,   -1,   -1,  370,   -1,   -1,
   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,
  383,  384,   -1,  386,   -1,  388,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,   -1,
  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,  417,  418,  419,  420,  421,  422,
  423,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,
  433,   -1,   -1,   40,   -1,   42,   43,  440,   45,   -1,
   -1,   -1,  445,  446,  447,  448,  449,  450,  451,  452,
  453,   58,  455,  456,  457,  458,   63,  460,  461,   -1,
   -1,   -1,   -1,   -1,   -1,  468,  469,  470,  471,  472,
  473,  474,  475,  476,  477,  478,  479,  480,   -1,  482,
  483,  484,  485,  486,   -1,  488,  489,  490,   -1,  492,
  493,  494,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,
  513,  514,  515,   -1,  517,   -1,  519,  520,  521,   -1,
  523,  524,   -1,  526,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,   -1,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,   -1,  607,   -1,  609,  610,  611,  612,
  613,   -1,  615,  616,  617,  618,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,   -1,  259,  260,   -1,   -1,   -1,   -1,  265,   -1,
  267,  268,  269,   -1,   -1,   -1,   -1,  274,   -1,   -1,
   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,  286,
   -1,  288,   -1,   -1,  291,  292,  293,   -1,   -1,   -1,
   -1,  298,  299,  300,  301,   -1,   -1,   -1,  305,   -1,
   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  319,   -1,  321,  322,   -1,   -1,   -1,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,
  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
  347,   -1,  349,  350,  351,   -1,  353,   -1,  355,   -1,
   -1,  358,  359,   -1,   -1,  362,  363,  364,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,
   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,
   -1,  388,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,   -1,   -1,   -1,  403,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
  417,  418,  419,  420,  421,  422,  423,   -1,   -1,   -1,
  427,   -1,  429,   -1,   -1,   -1,  433,   -1,   -1,   40,
   -1,   -1,   43,  440,   45,   -1,   -1,   -1,  445,  446,
  447,  448,  449,  450,  451,  452,  453,   58,  455,  456,
  457,  458,   63,  460,  461,   -1,   -1,   -1,   -1,   -1,
   -1,  468,  469,  470,  471,  472,  473,  474,  475,  476,
  477,  478,  479,  480,   -1,  482,  483,   -1,  485,  486,
   -1,  488,  489,  490,   -1,  492,  493,  494,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,
  517,   -1,  519,  520,  521,   -1,  523,  524,   -1,  526,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,   -1,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,   -1,
  607,   -1,  609,  610,  611,  612,  613,   -1,  615,  616,
  617,  618,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,
   -1,   -1,   -1,   -1,  265,   -1,  267,  268,  269,   -1,
   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,  280,
  281,   -1,  283,   -1,  285,  286,   -1,  288,   -1,   -1,
  291,  292,  293,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,
  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  319,   -1,
  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,
   -1,   -1,  343,   -1,   -1,    0,  347,   -1,  349,  350,
  351,   -1,  353,   -1,  355,   -1,   -1,  358,  359,   -1,
   -1,  362,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,
  381,  382,  383,  384,   -1,  386,   41,  388,   -1,   44,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,
   -1,   -1,  403,   -1,   59,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,  417,  418,  419,  420,
  421,  422,  423,   -1,   -1,   -1,  427,   -1,  429,   -1,
   -1,   -1,  433,   -1,   -1,   -1,   -1,   -1,   -1,  440,
  441,   -1,   -1,   -1,  445,  446,  447,  448,  449,  450,
  451,  452,  453,   -1,  455,  456,  457,  458,   -1,  460,
  461,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,  470,
  471,  472,  473,  474,  475,  476,  477,  478,  479,  480,
   -1,  482,  483,  484,  485,  486,   -1,  488,  489,  490,
   -1,  492,  493,  494,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,
  511,   -1,  513,  514,  515,   -1,  517,   -1,  519,  520,
  521,   -1,  523,  524,   -1,  526,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
   -1,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,   -1,  607,  262,  609,  610,
  611,  612,  613,   -1,  615,  616,  617,  618,   40,   -1,
   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   -1,   -1,   -1,
   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  314,
   -1,   -1,  317,   -1,   -1,   -1,   -1,   -1,   -1,  324,
   -1,  326,   -1,   -1,   -1,  330,   -1,   -1,   -1,   -1,
  335,   -1,   -1,  338,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  353,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  366,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  374,
   -1,   -1,  377,  378,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  387,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  403,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  425,   -1,   -1,   -1,   -1,  430,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  441,  442,   -1,  444,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,  491,  259,   -1,   -1,
   -1,   -1,   -1,  265,   -1,  267,  268,  269,   -1,   -1,
   -1,   -1,  274,  508,   -1,   -1,   -1,  512,  280,  281,
   -1,  283,   -1,  285,  286,   -1,  288,   -1,   -1,  291,
  292,  293,  527,   -1,   -1,   -1,  298,   -1,  300,  301,
   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  319,   -1,  321,
  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,
   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,
   -1,  343,   -1,   -1,   -1,  347,   -1,  349,  350,  351,
   -1,  353,   -1,  355,   -1,   -1,  358,  359,   -1,   -1,
  362,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,
  382,  383,  384,   -1,  386,   -1,  388,   -1,   -1,   -1,
  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,
   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,
  412,   -1,  414,   -1,  416,  417,  418,  419,  420,  421,
  422,  423,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,
   -1,  433,   -1,   -1,   40,   -1,   42,   43,  440,   45,
   -1,   -1,  444,  445,  446,  447,  448,  449,  450,  451,
  452,  453,   58,  455,  456,  457,  458,   63,  460,  461,
   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,  470,  471,
  472,  473,  474,  475,  476,  477,  478,  479,  480,   -1,
  482,  483,  484,  485,  486,   -1,  488,  489,  490,   -1,
  492,  493,  494,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,
   -1,  513,  514,  515,   -1,  517,   -1,  519,  520,  521,
   -1,  523,  524,   -1,  526,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,   -1,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,   -1,  607,   -1,  609,  610,  611,
  612,  613,   -1,  615,  616,  617,  618,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,   -1,  259,   -1,   -1,   -1,   -1,   -1,  265,
   -1,  267,  268,  269,   -1,   -1,   -1,   -1,  274,   -1,
   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,
  286,   -1,  288,   -1,   -1,  291,  292,  293,   -1,   -1,
   -1,   -1,  298,   -1,  300,  301,   -1,   -1,   -1,  305,
   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  319,   -1,  321,  322,   -1,   -1,   -1,
   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,
   -1,  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,
   -1,  347,   -1,  349,  350,  351,   -1,  353,   -1,  355,
   -1,   -1,  358,  359,   -1,   -1,  362,  363,  364,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,
  386,   -1,  388,   -1,   -1,   -1,  392,   -1,  394,  395,
   -1,   -1,  398,  399,   -1,   -1,   -1,  403,   -1,   -1,
  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,
  416,  417,  418,  419,  420,  421,  422,  423,   -1,   -1,
   -1,  427,   -1,  429,   -1,   -1,   -1,  433,   -1,   -1,
   40,   41,   -1,   43,  440,   45,   -1,   -1,   -1,  445,
  446,  447,  448,  449,  450,  451,  452,  453,   58,  455,
  456,  457,  458,   63,  460,  461,   -1,   -1,   -1,   -1,
   -1,   -1,  468,  469,  470,  471,  472,  473,  474,  475,
  476,  477,  478,  479,  480,   -1,  482,  483,  484,  485,
  486,   -1,  488,  489,  490,   -1,  492,  493,  494,  495,
   -1,   -1,  498,  499,  500,  501,  502,  503,  504,   -1,
   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,
   -1,  517,   -1,  519,  520,  521,   -1,  523,  524,   -1,
  526,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,   -1,  549,  550,  551,  552,  553,  554,   -1,
  556,  557,  558,  559,   -1,  561,   -1,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,   -1,  582,  583,  584,  585,
   -1,  587,  588,  589,  590,  591,   -1,  593,  594,  595,
  596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
   -1,  607,   -1,  609,  610,  611,  612,  613,   -1,  615,
  616,  617,  618,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,
   -1,   -1,   -1,   -1,   -1,  265,   -1,  267,  268,  269,
   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,
  280,  281,   -1,  283,   -1,  285,  286,   -1,  288,   -1,
   -1,  291,  292,  293,   -1,   -1,   -1,   -1,  298,   -1,
  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,
   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  319,
   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,
   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,  347,   -1,  349,
  350,  351,   -1,  353,   -1,  355,   -1,   -1,  358,  359,
   -1,   -1,  362,  363,  364,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,
  380,  381,  382,  383,  384,   -1,  386,   -1,  388,   -1,
   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,
   -1,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,  417,  418,  419,
  420,  421,  422,  423,   -1,   -1,   -1,  427,   -1,  429,
   -1,   -1,   -1,  433,   -1,   -1,   40,   -1,   -1,   43,
  440,   45,   -1,   -1,   -1,  445,  446,  447,  448,  449,
  450,  451,  452,  453,   58,  455,  456,  457,  458,   63,
  460,  461,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,
  470,  471,  472,  473,  474,  475,  476,  477,  478,  479,
  480,   -1,  482,  483,  484,  485,  486,   -1,  488,  489,
  490,   -1,  492,  493,  494,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,
  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,  519,
  520,  521,   -1,  523,  524,   -1,  526,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,   -1,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,   -1,  607,   -1,  609,
  610,  611,  612,  613,   -1,  615,  616,  617,  618,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,   -1,   -1,
   -1,  265,   -1,  267,  268,  269,   -1,   -1,   -1,   -1,
  274,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,
   -1,  285,  286,   -1,  288,   -1,   -1,  291,  292,  293,
   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,   -1,
   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  319,   -1,  321,  322,   -1,
   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,
   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,  343,
   -1,   -1,   -1,  347,   -1,  349,  350,  351,   -1,  353,
   -1,  355,   -1,   -1,  358,  359,   -1,   -1,  362,  363,
  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,
  384,   -1,  386,   -1,  388,   -1,   -1,   -1,  392,   -1,
  394,  395,   -1,   -1,  398,  399,   -1,   -1,   -1,  403,
   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,
  414,   -1,  416,  417,  418,  419,  420,  421,  422,  423,
   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,  433,
   -1,   -1,   40,   -1,   -1,   43,  440,   45,   -1,   -1,
  444,  445,  446,  447,  448,  449,  450,  451,  452,  453,
   58,  455,  456,  457,  458,   63,  460,  461,   -1,   -1,
   -1,   -1,   -1,   -1,  468,  469,  470,  471,  472,  473,
  474,  475,  476,  477,  478,  479,  480,   -1,  482,  483,
  484,  485,  486,   -1,  488,  489,  490,   -1,  492,  493,
  494,  495,   -1,   -1,  498,  499,  500,  501,  502,  503,
  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,
  514,  515,   -1,  517,   -1,  519,  520,  521,   -1,  523,
  524,   -1,  526,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,   -1,  549,  550,  551,  552,  553,
  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,   -1,  582,  583,
  584,  585,   -1,  587,  588,  589,  590,  591,   -1,  593,
  594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
  604,  605,   -1,  607,   -1,  609,  610,  611,  612,  613,
   -1,  615,  616,  617,  618,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
   -1,  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,  267,
  268,  269,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,
   -1,   -1,  280,  281,   -1,  283,   -1,  285,  286,   -1,
  288,   -1,   -1,  291,  292,  293,   -1,   -1,   -1,   -1,
  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,
  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,  316,   -1,
   -1,  319,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,
   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,
   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,  347,
   -1,  349,  350,  351,   -1,  353,   -1,  355,   -1,   -1,
  358,  359,   -1,   -1,  362,  363,  364,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,
   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,
  388,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,
  398,  399,   -1,   -1,   -1,  403,   -1,   -1,  406,   -1,
   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,  417,
  418,  419,  420,  421,  422,  423,   -1,   -1,   -1,  427,
   -1,  429,   -1,   -1,   -1,  433,   -1,   -1,   40,   -1,
   -1,   43,  440,   45,   -1,   -1,   -1,  445,  446,  447,
  448,  449,  450,  451,  452,  453,   58,  455,  456,  457,
  458,   63,  460,  461,   -1,   -1,   -1,   -1,   -1,   -1,
  468,  469,  470,  471,  472,  473,  474,  475,  476,  477,
  478,  479,  480,   -1,  482,  483,  484,  485,  486,   -1,
  488,  489,  490,   -1,  492,  493,  494,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,  517,
   -1,  519,  520,  521,   -1,  523,  524,   -1,  526,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,   -1,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,   -1,  607,
   -1,  609,  610,  611,  612,  613,   -1,  615,  616,  617,
  618,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,
   -1,   -1,   -1,  265,   -1,  267,  268,  269,   -1,   -1,
   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,  280,  281,
   -1,  283,   -1,  285,  286,   -1,  288,   -1,   -1,  291,
  292,  293,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,
   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  319,   -1,  321,
  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,
   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,
   -1,  343,   -1,   -1,   -1,  347,   -1,  349,  350,  351,
   -1,  353,   -1,  355,   -1,   -1,  358,  359,   -1,   -1,
  362,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,
  382,  383,  384,   -1,  386,   -1,  388,   -1,   -1,   -1,
  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,
   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,
  412,   -1,  414,   -1,  416,  417,  418,  419,  420,  421,
  422,  423,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,
   -1,  433,   -1,   -1,   40,   -1,   42,   43,  440,   45,
   -1,   -1,  444,  445,  446,  447,  448,  449,  450,  451,
  452,  453,   58,  455,  456,  457,  458,   63,  460,  461,
   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,  470,  471,
  472,  473,  474,  475,  476,  477,  478,  479,  480,   -1,
  482,  483,  484,  485,  486,   -1,  488,  489,  490,   -1,
  492,  493,  494,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,
   -1,  513,  514,  515,   -1,  517,   -1,  519,  520,  521,
   -1,  523,  524,   -1,  526,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,   -1,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,   -1,  607,   -1,  609,  610,  611,
  612,  613,   -1,  615,  616,  617,  618,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,   -1,  259,  260,   -1,   -1,   -1,   -1,  265,
   -1,  267,  268,  269,   -1,   -1,   -1,   -1,  274,   -1,
   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,
  286,   -1,  288,   -1,   -1,  291,  292,  293,   -1,   -1,
   -1,   -1,  298,  299,  300,  301,   -1,   -1,   -1,  305,
   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  319,   -1,  321,  322,   -1,   -1,   -1,
   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,
   -1,  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,
   -1,  347,   -1,  349,  350,  351,   -1,  353,   -1,  355,
   -1,   -1,  358,  359,   -1,   -1,  362,  363,  364,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,
  386,   -1,  388,   -1,   -1,   -1,  392,   -1,  394,  395,
   -1,   -1,  398,  399,   -1,   -1,   -1,  403,   -1,   -1,
  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,
  416,  417,  418,  419,  420,  421,  422,  423,   -1,   -1,
   -1,  427,   -1,  429,   -1,   -1,   -1,  433,   -1,   -1,
   40,   -1,   42,   43,  440,   45,   -1,   -1,   -1,  445,
  446,  447,  448,  449,  450,  451,  452,  453,   58,  455,
  456,  457,  458,   63,  460,  461,   -1,   -1,   -1,   -1,
   -1,   -1,  468,  469,  470,  471,  472,  473,  474,  475,
  476,  477,  478,  479,  480,   -1,  482,   -1,   -1,  485,
  486,   -1,  488,  489,  490,   -1,  492,  493,  494,  495,
   -1,   -1,  498,  499,  500,  501,  502,  503,  504,   -1,
   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,
   -1,  517,   -1,  519,  520,  521,   -1,  523,  524,   -1,
  526,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,   -1,  549,  550,  551,  552,  553,  554,   -1,
  556,  557,  558,  559,   -1,  561,   -1,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,   -1,  582,  583,  584,  585,
   -1,  587,  588,  589,  590,  591,   -1,  593,  594,  595,
  596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
   -1,  607,   -1,  609,  610,  611,  612,  613,   -1,  615,
  616,  617,  618,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,
   -1,   -1,   -1,   -1,   -1,  265,   -1,  267,  268,  269,
   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,
  280,  281,   -1,  283,   -1,  285,  286,   -1,  288,   -1,
   -1,  291,  292,  293,   -1,   -1,   -1,   -1,  298,   -1,
  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,
   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  319,
   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,
   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,  347,   -1,  349,
  350,  351,   -1,  353,   -1,  355,   -1,   -1,  358,  359,
   -1,   -1,  362,  363,  364,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,
  380,  381,  382,  383,  384,   -1,  386,   -1,  388,   -1,
   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,
   -1,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,  417,  418,  419,
  420,  421,  422,  423,   -1,   -1,   -1,  427,   -1,  429,
   -1,   -1,   -1,  433,   -1,   -1,   40,   -1,   -1,   43,
  440,   45,   -1,   -1,   -1,  445,  446,  447,  448,  449,
  450,  451,  452,  453,   58,  455,  456,  457,  458,   63,
  460,  461,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,
  470,  471,  472,  473,  474,  475,  476,  477,  478,  479,
  480,   -1,  482,  483,  484,  485,  486,   -1,  488,  489,
  490,   -1,  492,  493,  494,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,
  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,  519,
  520,  521,   -1,  523,  524,   -1,  526,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,   -1,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,   -1,  607,   -1,  609,
  610,  611,  612,  613,   -1,  615,  616,  617,  618,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,   -1,   -1,
   -1,  265,   -1,  267,  268,  269,   -1,   -1,   -1,   -1,
  274,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,
   -1,  285,  286,   -1,  288,   -1,   -1,  291,  292,  293,
   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,   -1,
   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  319,   -1,  321,  322,   -1,
   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,
   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,  343,
   -1,   -1,   -1,  347,   -1,  349,  350,  351,   -1,  353,
   -1,  355,   -1,   -1,  358,  359,   -1,   -1,  362,  363,
  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,
  384,   -1,  386,   -1,  388,   -1,   -1,   -1,  392,   -1,
  394,  395,   -1,   -1,  398,  399,   -1,   -1,   -1,  403,
   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,
  414,   -1,  416,  417,  418,  419,  420,  421,  422,  423,
   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,  433,
   -1,   -1,   40,   -1,   -1,   43,  440,   45,   -1,   -1,
   -1,  445,  446,  447,  448,  449,  450,  451,  452,  453,
   58,  455,  456,  457,  458,   63,  460,  461,   -1,   -1,
   -1,   -1,   -1,   -1,  468,  469,  470,  471,  472,  473,
  474,  475,  476,  477,  478,  479,  480,   -1,  482,  483,
  484,  485,  486,   -1,  488,  489,  490,   -1,  492,  493,
  494,  495,   -1,   -1,  498,  499,  500,  501,  502,  503,
  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,
  514,  515,   -1,  517,   -1,  519,  520,  521,   -1,  523,
  524,   -1,  526,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,   -1,  549,  550,  551,  552,  553,
  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,   -1,  582,  583,
  584,  585,   -1,  587,  588,  589,  590,  591,   -1,  593,
  594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
  604,  605,   -1,  607,   -1,  609,  610,  611,  612,  613,
   -1,  615,  616,  617,  618,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
   -1,  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,  267,
  268,  269,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,
   -1,   -1,  280,  281,   -1,  283,   -1,  285,  286,   -1,
  288,   -1,   -1,  291,  292,  293,   -1,   -1,   -1,   -1,
  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,
  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  319,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,
   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,
   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,  347,
   -1,  349,  350,  351,   -1,  353,   -1,  355,   -1,   -1,
  358,  359,   -1,   -1,  362,  363,  364,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,
   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,
  388,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,
  398,  399,   -1,   -1,   -1,  403,   -1,   -1,  406,   -1,
   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,  417,
  418,  419,  420,  421,  422,  423,   -1,   -1,   -1,  427,
   -1,  429,   -1,   -1,   -1,  433,   -1,   -1,   40,   -1,
   -1,   43,  440,   45,   -1,   -1,   -1,  445,  446,  447,
  448,  449,  450,  451,  452,  453,   58,  455,  456,  457,
  458,   63,  460,  461,   -1,   -1,   -1,   -1,   -1,   -1,
  468,  469,  470,  471,  472,  473,  474,  475,  476,  477,
  478,  479,  480,   -1,  482,  483,  484,  485,  486,   -1,
  488,  489,  490,   -1,  492,  493,  494,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,  517,
   -1,  519,  520,  521,   -1,  523,  524,   -1,  526,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,   -1,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,   -1,  607,
   -1,  609,  610,  611,  612,  613,   -1,  615,  616,  617,
  618,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,
   -1,   -1,   -1,  265,   -1,  267,  268,  269,   -1,   -1,
   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,  280,  281,
   -1,  283,   -1,  285,  286,   -1,  288,   -1,   -1,  291,
  292,  293,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,
   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  319,   -1,  321,
  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,
   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,
   -1,  343,   -1,   -1,   -1,  347,   -1,  349,  350,  351,
   -1,  353,   -1,  355,   -1,   -1,  358,  359,   -1,   -1,
  362,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,
  382,  383,  384,   -1,  386,   -1,  388,   -1,   -1,   -1,
  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,
   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,
  412,   -1,  414,   -1,  416,  417,  418,  419,  420,  421,
  422,  423,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,
   -1,  433,   -1,   -1,   40,   -1,   -1,   43,  440,   45,
   -1,   -1,   -1,  445,  446,  447,  448,  449,  450,  451,
  452,  453,   58,  455,  456,  457,  458,   63,  460,  461,
   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,  470,  471,
  472,  473,  474,  475,  476,  477,  478,  479,  480,   -1,
  482,  483,  484,  485,  486,   -1,  488,  489,  490,   -1,
  492,  493,  494,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,
   -1,  513,  514,  515,   -1,  517,   -1,  519,  520,  521,
   -1,  523,  524,   -1,  526,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,   -1,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,   -1,  607,   -1,  609,  610,  611,
  612,  613,   -1,  615,  616,  617,  618,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,   -1,  259,   -1,   -1,   -1,   -1,   -1,  265,
   -1,  267,  268,  269,   -1,   -1,   -1,   -1,  274,   -1,
   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,
  286,   -1,  288,   -1,   -1,  291,  292,  293,   -1,   -1,
   -1,   -1,  298,   -1,  300,  301,   -1,   -1,   -1,  305,
   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  319,   -1,  321,  322,   -1,   -1,   -1,
   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,
   -1,  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,
   -1,  347,   -1,  349,  350,  351,   -1,  353,   -1,  355,
   -1,   -1,  358,  359,   -1,   -1,  362,  363,  364,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,
  386,   -1,  388,   -1,   -1,   -1,  392,   -1,  394,  395,
   -1,   -1,  398,  399,   -1,   -1,   -1,  403,   -1,   -1,
  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,
  416,  417,  418,  419,  420,  421,  422,  423,   -1,   -1,
   -1,  427,   -1,  429,   -1,   -1,   -1,  433,   -1,   -1,
   40,   -1,   -1,   43,  440,   45,   -1,   -1,   -1,  445,
  446,  447,  448,  449,  450,  451,  452,  453,   58,  455,
  456,  457,  458,   63,  460,  461,   -1,   -1,   -1,   -1,
   -1,   -1,  468,  469,  470,  471,  472,  473,  474,  475,
  476,  477,  478,  479,  480,   -1,  482,  483,  484,  485,
  486,   -1,  488,  489,  490,   -1,  492,  493,  494,  495,
   -1,   -1,  498,  499,  500,  501,  502,  503,  504,   -1,
   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,
   -1,  517,   -1,  519,  520,  521,   -1,  523,  524,   -1,
  526,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,   -1,  549,  550,  551,  552,  553,  554,   -1,
  556,  557,  558,  559,   -1,  561,   -1,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,   -1,  582,  583,  584,  585,
   -1,  587,  588,  589,  590,  591,   -1,  593,  594,  595,
  596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
   -1,  607,   -1,  609,  610,  611,  612,  613,   -1,  615,
  616,  617,  618,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,
   -1,   -1,   -1,   -1,   -1,  265,   -1,  267,  268,  269,
   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,
  280,  281,   -1,  283,   -1,  285,  286,   -1,  288,   -1,
   -1,  291,  292,  293,   -1,   -1,   -1,   -1,  298,   -1,
  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,
   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  319,
   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,
   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,  347,   -1,  349,
  350,  351,   -1,  353,   -1,  355,   -1,   -1,  358,  359,
   -1,   -1,  362,  363,  364,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,
  380,  381,  382,  383,  384,   -1,  386,   -1,  388,   -1,
   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,
   -1,   -1,   40,  403,   -1,   -1,  406,   -1,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,  417,  418,  419,
  420,  421,  422,  423,   -1,   -1,   -1,  427,   -1,  429,
   -1,   -1,   -1,  433,   -1,   -1,   -1,   -1,   -1,   -1,
  440,   -1,   -1,   -1,   -1,  445,  446,  447,  448,  449,
  450,  451,  452,  453,   -1,  455,  456,  457,  458,   -1,
  460,  461,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,
  470,  471,  472,  473,  474,  475,  476,  477,  478,  479,
  480,   -1,  482,  483,  484,  485,  486,   -1,  488,  489,
  490,   -1,  492,  493,  494,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,
  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,  519,
  520,  521,   -1,  523,  524,   -1,  526,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,   -1,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,   -1,  607,   -1,  609,
  610,  611,  612,  613,   -1,  615,  616,  617,  618,  257,
   -1,  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,   -1,
  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  280,  281,   -1,  283,   -1,  285,   -1,   -1,
  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,
  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,
  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,
   -1,  329,   -1,  331,  332,   -1,   -1,   -1,   -1,  337,
   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  351,   -1,   -1,   -1,  355,   -1,   -1,
  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,
  378,   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,
   -1,   40,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,
  398,  399,   -1,   -1,   -1,   -1,   -1,   -1,  406,   58,
   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,
  418,  419,  420,  421,  422,   -1,   -1,   -1,   -1,  427,
   -1,  429,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  440,   -1,   -1,   -1,   -1,  445,  446,   -1,
   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,
  458,   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,
   -1,  489,  490,   -1,  492,  493,   -1,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,  517,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,   -1,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,  257,  607,
  259,  609,  610,  611,  612,  613,  265,  615,   -1,  268,
  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  280,  281,   -1,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,
   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  351,   -1,   -1,   -1,  355,   -1,   -1,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,
   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,   -1,
   40,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,   -1,   -1,   -1,   -1,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,   -1,   -1,  427,   -1,
  429,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,   -1,   -1,   -1,   -1,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,   -1,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,   -1,
  509,  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,   -1,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,  257,  607,  259,
  609,  610,  611,  612,  613,  265,  615,   -1,  268,  269,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  280,  281,   -1,  283,   -1,  285,   -1,   -1,  288,   -1,
   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,
  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,
   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,
   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  351,   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,
   -1,   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,
  380,  381,  382,  383,  384,   -1,  386,   -1,   -1,   40,
   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,
   -1,   -1,   -1,   -1,   -1,   -1,  406,   -1,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,
  420,  421,  422,   -1,   -1,   -1,   -1,  427,   -1,  429,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  440,   -1,   -1,   -1,  444,  445,  446,   -1,   -1,   -1,
  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,
  460,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,
  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,
  490,   -1,  492,  493,   -1,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,
  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,   -1,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,  257,  607,  259,  609,
  610,  611,  612,  613,  265,  615,   -1,  268,  269,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
  281,   -1,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,
  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,
   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,
  381,  382,  383,  384,   -1,  386,   -1,   -1,   40,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,
   -1,   -1,   -1,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,
   -1,   -1,   -1,   -1,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
   -1,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,
  511,   -1,  513,  514,  515,   -1,  517,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
   -1,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,  257,  607,  259,  609,  610,
  611,  612,  613,  265,  615,   -1,  268,  269,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,  281,
   -1,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,
   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,
   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  321,
  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,
   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,
   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,
   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,   -1,
   -1,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,
  382,  383,  384,   -1,  386,   -1,   -1,   -1,   -1,   42,
  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,
   -1,   -1,   -1,   -1,  406,   -1,   -1,  409,  410,  411,
  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,
  422,   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,   -1,
   -1,   -1,   -1,  445,  446,   -1,   -1,   -1,  450,   -1,
   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,
  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,   -1,
  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,
   -1,  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,   -1,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,  257,  607,  259,  609,  610,  611,
  612,  613,  265,  615,   -1,  268,  269,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,
  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,
  293,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,
   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,
   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,
  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,
  383,  384,   -1,  386,   -1,   -1,   -1,   -1,   42,  392,
   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,   -1,
   -1,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,   -1,   -1,
   -1,   -1,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,
  483,  484,   -1,   -1,   -1,   -1,  489,  490,   -1,  492,
  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,
  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,   -1,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,  257,  607,  259,  609,  610,  611,  612,
  613,  265,  615,   -1,  268,  269,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,
   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,
   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,   -1,
   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,   -1,
   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,
   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,  343,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,   -1,
   -1,  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,  363,
  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,
  384,   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   44,
  394,  395,   -1,   -1,  398,  399,   -1,   -1,   -1,   -1,
   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,
  414,   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,
   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  440,   -1,   -1,   -1,
   -1,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,
   -1,  455,  456,  457,  458,   -1,  460,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  468,  469,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,
  484,   -1,   -1,   -1,   -1,  489,  490,   -1,  492,  493,
   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,  503,
  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,
  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,   -1,  549,  550,  551,  552,  553,
  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,   -1,  582,  583,
  584,  585,   -1,  587,  588,  589,  590,  591,   -1,  593,
  594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
  604,  605,  257,  607,  259,  609,  610,  611,  612,  613,
  265,  615,   -1,  268,  269,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,
  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,   -1,   -1,
  305,   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,
   -1,  316,   -1,   -1,   -1,   -1,  321,  322,   -1,   -1,
   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,   -1,   -1,
  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,
   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,   -1,   -1,   45,   -1,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,
   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  440,   -1,   -1,   -1,   -1,
  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,
  455,  456,  457,  458,   -1,  460,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  468,  469,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,
   -1,   -1,   -1,   -1,  489,  490,   -1,  492,  493,   -1,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,
  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,   -1,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,   -1,  607,   -1,  609,  610,  611,  612,  613,  257,
  615,  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,   -1,
  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  280,  281,   -1,  283,   -1,  285,   -1,   -1,
  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,
  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,
  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,
   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,
   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  351,   -1,   -1,   -1,  355,    0,   -1,
  358,   -1,   -1,   -1,   -1,  363,  364,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,
   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,
   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   41,
  398,  399,   44,   -1,   -1,   -1,   -1,   -1,  406,   -1,
   -1,  409,  410,  411,  412,   -1,  414,   59,  416,   61,
  418,  419,  420,  421,  422,   -1,   -1,   -1,   -1,  427,
   -1,  429,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  440,   -1,   -1,   -1,   -1,  445,  446,   91,
  448,   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,
  458,   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,
   -1,  489,  490,   -1,  492,  493,   -1,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,  517,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,   -1,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,   -1,  607,
   58,  609,  610,  611,  612,  613,  258,  615,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  273,   -1,   -1,  276,  277,   -1,   -1,   -1,  281,
   -1,   -1,  284,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  296,   -1,   -1,   -1,   -1,   -1,
  302,   -1,   -1,  305,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  347,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  370,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  391,
   -1,   -1,   -1,   -1,   -1,  397,   -1,   -1,   -1,  401,
   -1,   -1,   -1,   -1,   -1,   -1,  408,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  426,   -1,   -1,   -1,   -1,  431,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
   -1,  259,   -1,   -1,  456,   -1,   -1,  265,  460,   -1,
  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  280,  281,   -1,  283,   -1,  285,   -1,   -1,
  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,
  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,
  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,
   -1,  329,    0,  331,   -1,   -1,   -1,   -1,   -1,  337,
   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  351,   -1,   -1,   -1,  355,   -1,   -1,
  358,   -1,   -1,   -1,   -1,  363,  364,  559,   -1,   -1,
   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,  376,   -1,
   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,
   -1,   59,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,
  398,  399,   -1,   -1,   -1,   -1,   -1,   -1,  406,   -1,
   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,
  418,  419,  420,  421,  422,   -1,   -1,   -1,    0,  427,
   -1,  429,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  440,   -1,   -1,   -1,   -1,  445,  446,   -1,
   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,
  458,   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,   41,
  468,  469,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  479,  480,   -1,  482,  483,  484,   59,   -1,   -1,
   -1,  489,  490,   -1,  492,  493,   -1,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,  517,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,   -1,  582,  583,  584,  585,    0,  587,
  588,  589,  590,  591,  262,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,   -1,  607,
   -1,  609,  610,  611,  612,  613,   -1,  615,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,
   -1,   -1,   44,    0,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  314,   59,   -1,  317,
   -1,   -1,   -1,   -1,   -1,   -1,  324,   -1,  326,   -1,
   -1,   -1,  330,   -1,   -1,   -1,   -1,  335,   -1,   -1,
  338,   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  353,   -1,   -1,   -1,   -1,
  262,   -1,   59,   -1,   -1,   -1,   -1,   -1,  366,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  374,   -1,   -1,  377,
  378,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  387,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  403,   -1,   -1,   -1,   -1,
   -1,   -1,  314,   -1,   -1,  317,   -1,   -1,   -1,   -1,
   -1,   -1,  324,   -1,  326,   -1,   -1,  425,  330,    0,
   -1,   -1,  430,  335,   -1,   -1,  338,   -1,   41,   -1,
   -1,   44,   -1,  441,  442,   -1,  444,   -1,   -1,   -1,
   -1,  353,   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  366,   -1,   -1,   -1,   -1,   -1,
   41,   -1,  374,   44,   -1,  377,  378,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  387,   -1,   -1,   59,   -1,
   -1,   -1,   -1,  491,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  403,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  508,   -1,   -1,   -1,  512,   -1,   -1,   -1,   -1,   -1,
  262,   -1,   -1,  425,   -1,   -1,   -1,   -1,  430,  527,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  441,
  442,   -1,  444,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,   -1,   -1,   -1,
   -1,   -1,  314,   -1,   -1,  317,   -1,   -1,   -1,   -1,
   -1,   -1,  324,   -1,  326,   -1,   -1,    0,  330,  491,
   -1,   -1,   -1,  335,   -1,   -1,  338,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  508,   -1,   -1,   -1,
  512,  353,   -1,   -1,   -1,   -1,   -1,  314,   -1,    0,
  317,   -1,   -1,   -1,  366,  527,   -1,  324,   41,  326,
   -1,   44,  374,  330,   -1,  377,  378,   -1,  335,   -1,
   -1,  338,   -1,   -1,   -1,  387,   59,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  353,   -1,   -1,  262,
   41,  403,   -1,   44,   -1,   -1,   -1,   -1,   -1,  366,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  374,   59,   -1,
  377,  378,   -1,  425,   -1,   -1,   -1,   -1,  430,   -1,
  387,  262,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  441,
  442,   -1,  444,   -1,   -1,   -1,  403,   -1,   -1,   -1,
   -1,  314,   -1,    0,  317,   -1,   -1,   -1,   -1,   -1,
   -1,  324,   -1,  326,   -1,   -1,   -1,  330,  425,   -1,
   -1,   -1,  335,  430,   -1,  338,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  314,  441,  442,  317,  444,   -1,  491,
  353,   -1,   -1,  324,   41,  326,   -1,   44,    0,  330,
   -1,   -1,   -1,  366,  335,   -1,  508,  338,   -1,   -1,
  512,  374,   59,   -1,  377,  378,   -1,   -1,   -1,   -1,
   -1,   -1,  353,   -1,  387,  527,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  491,  366,   -1,   -1,   -1,   41,
  403,   -1,   44,  374,   -1,   -1,  377,  378,   -1,   -1,
   -1,  508,   -1,   -1,   -1,  512,  387,   59,   -1,   -1,
   -1,   -1,  425,   -1,   -1,   -1,   -1,  430,   -1,   -1,
  527,   -1,  403,   -1,   -1,   -1,   -1,   -1,  441,  442,
   -1,  444,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
   -1,   -1,   -1,   -1,  425,   -1,    0,   -1,   -1,  430,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  441,  442,   -1,  444,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,   -1,   -1,   -1,   -1,   -1,  491,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,   -1,   -1,
   44,  314,   -1,   -1,  317,  508,   -1,   -1,   -1,  512,
   -1,  324,   -1,  326,   -1,   59,   -1,  330,   -1,   -1,
  491,   -1,  335,   -1,  527,  338,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  314,   -1,   -1,  317,  508,   -1,   -1,
  353,  512,   -1,  324,   -1,  326,   -1,   -1,   -1,  330,
   -1,   -1,   -1,  366,  335,   -1,  527,  338,   -1,   -1,
   -1,  374,   -1,   -1,  377,  378,    0,   -1,   -1,   -1,
   -1,   -1,  353,   -1,  387,  262,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  366,   -1,   -1,   -1,   -1,
  403,   -1,   -1,  374,   -1,   -1,  377,  378,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  387,   41,   -1,   -1,
   44,   -1,  425,   -1,   -1,   -1,   -1,  430,   -1,   -1,
  262,   -1,  403,   -1,    0,   59,   -1,  314,  441,  442,
  317,  444,   -1,   -1,   -1,   -1,   -1,  324,   -1,  326,
   -1,   -1,   -1,  330,  425,   -1,   -1,   -1,  335,  430,
   -1,  338,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  441,  442,    0,  444,   -1,   41,  353,   -1,   44,   -1,
   -1,   -1,  314,   -1,   -1,  317,   -1,   -1,  491,  366,
   -1,   -1,  324,   59,  326,   -1,   -1,  374,  330,   -1,
  377,  378,   -1,  335,   -1,  508,  338,   -1,   -1,  512,
  387,   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,
  491,  353,   -1,   -1,  527,   -1,  403,   -1,  262,   -1,
   -1,   59,   -1,   -1,  366,   -1,   -1,  508,   -1,   -1,
   -1,  512,  374,   -1,   -1,  377,  378,   -1,  425,   -1,
   -1,   -1,   -1,  430,   -1,  387,  527,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  441,  442,   -1,  444,   -1,   -1,
   -1,  403,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  314,   -1,    0,  317,   -1,   -1,   -1,   -1,   -1,   -1,
  324,   -1,  326,  425,   -1,   -1,  330,   -1,  430,   -1,
   -1,  335,   -1,   -1,  338,   -1,   -1,   -1,   -1,  441,
  442,   -1,  444,   -1,  491,   -1,   -1,   -1,   -1,  353,
   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,
   -1,  508,  366,   -1,   -1,  512,   -1,   -1,  262,   -1,
  374,   59,   -1,  377,  378,   -1,   -1,   -1,   -1,   -1,
  527,   -1,   -1,  387,   -1,   -1,   -1,   -1,   -1,  491,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  403,
   -1,   -1,   -1,   -1,   -1,   -1,  508,   -1,    0,   -1,
  512,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  314,  425,   -1,  317,   -1,  527,  430,   -1,   -1,   -1,
  324,   -1,  326,   -1,   -1,   -1,  330,  441,  442,   -1,
  444,  335,   -1,   -1,  338,   -1,   -1,   -1,   -1,   41,
   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,  353,
   -1,   -1,   -1,   -1,  262,   -1,    0,   59,   -1,   -1,
   -1,   -1,  366,   -1,   -1,   -1,   -1,   -1,  314,   -1,
  374,  317,   -1,  377,  378,   -1,   -1,  491,  324,   -1,
  326,   -1,   -1,  387,  330,   -1,   -1,   -1,   -1,  335,
   -1,   -1,  338,   -1,  508,   -1,   -1,   41,  512,  403,
   44,   -1,   -1,   -1,   -1,   -1,  314,  353,   -1,  317,
   -1,   -1,   -1,  527,   -1,   59,  324,   -1,  326,   -1,
  366,  425,  330,   -1,   -1,   -1,  430,  335,  374,   -1,
  338,   -1,  378,   -1,   -1,   -1,   -1,  441,  442,   -1,
  444,  387,   -1,   -1,   -1,  353,   -1,   -1,   -1,   -1,
    0,   -1,   -1,   -1,   -1,   -1,   -1,  403,  366,   -1,
   -1,   -1,   -1,   -1,  262,   -1,  374,   -1,   -1,  377,
  378,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  387,
   -1,   -1,   -1,   -1,  430,   -1,   -1,  491,   -1,   -1,
   -1,   41,   -1,   -1,   44,  403,  442,   -1,  444,   -1,
   -1,   -1,   -1,   -1,  508,   -1,   -1,   -1,  512,   59,
   -1,   -1,   -1,   -1,   -1,   -1,  314,  425,   -1,  317,
   -1,   -1,  430,  527,   -1,   -1,  324,   -1,  326,   -1,
   -1,    0,  330,  441,  442,   -1,  444,  335,   -1,   -1,
  338,   -1,   -1,   -1,   -1,  491,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  353,   -1,   -1,   -1,   -1,
  262,   -1,  508,   -1,   -1,   -1,  512,   -1,  366,   -1,
   -1,   -1,   41,   -1,   -1,   44,  374,   -1,   -1,  377,
  378,  527,   -1,  491,   -1,   -1,   -1,   -1,   -1,  387,
   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  508,   -1,   -1,   -1,  512,  403,   -1,   -1,   -1,   -1,
   -1,   -1,  314,   -1,   -1,  317,   -1,   -1,  262,  527,
   -1,   -1,  324,   -1,  326,    0,   -1,  425,  330,   -1,
   -1,   -1,  430,  335,   -1,   -1,  338,   -1,   -1,   -1,
   -1,   -1,   -1,  441,  442,   -1,  444,   -1,   -1,   -1,
   -1,  353,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  366,   -1,   41,   -1,   -1,   44,
  314,   -1,  374,  317,   -1,  377,  378,   -1,   -1,   -1,
  324,   -1,  326,   -1,   59,  387,  330,   -1,   -1,   -1,
   -1,  335,   -1,  491,  338,   -1,   -1,   -1,   -1,   -1,
   -1,  403,   -1,   -1,   -1,   -1,    0,   -1,   -1,  353,
  508,   -1,  262,   -1,  512,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  366,  425,   -1,   -1,   -1,   -1,  430,  527,
  374,   -1,   -1,  377,  378,   -1,   -1,   -1,   -1,  441,
  442,   -1,  444,  387,   -1,   -1,   -1,   41,   -1,   -1,
   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  403,
   -1,   -1,   -1,   -1,  314,   59,   -1,  317,   -1,   -1,
   -1,   -1,   -1,   -1,  324,   -1,  326,   -1,   -1,   -1,
  330,  425,   -1,   -1,   -1,  335,  430,   -1,  338,  491,
   -1,   -1,   -1,  262,   -1,   -1,   -1,  441,  442,   -1,
  444,   -1,   -1,  353,   -1,   -1,  508,   -1,   -1,   -1,
  512,   -1,   -1,   -1,   -1,   -1,  366,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  374,  527,   -1,  377,  378,    0,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  387,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  314,   -1,  491,  317,   -1,
   -1,   -1,   -1,  403,   -1,  324,   -1,  326,   -1,   -1,
   -1,  330,   -1,   -1,  508,   -1,  335,   -1,  512,  338,
   41,   -1,   -1,   44,   -1,  425,   -1,   -1,   -1,   -1,
  430,   -1,   -1,  527,  353,   -1,   -1,  262,   59,   -1,
   -1,  441,  442,   -1,  444,   -1,   -1,  366,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  374,   -1,   -1,  377,  378,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  387,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  403,   -1,   -1,   -1,   -1,  314,
   -1,  491,  317,   -1,   -1,   -1,   -1,   -1,   -1,  324,
   -1,  326,   -1,   -1,   -1,  330,  425,   -1,  508,   -1,
  335,  430,  512,  338,   41,   -1,   -1,   44,  262,   -1,
   -1,   -1,  441,  442,   -1,  444,   -1,  527,  353,   -1,
   -1,   -1,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  366,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  374,
   -1,   -1,  377,  378,    0,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  387,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  314,   -1,  491,  317,   -1,   -1,   -1,   -1,  403,   -1,
  324,   -1,  326,   -1,   -1,   -1,  330,   -1,   -1,  508,
   -1,  335,   -1,  512,  338,   41,   -1,   -1,   44,   -1,
  425,   -1,   -1,   -1,   -1,  430,   -1,   -1,  527,  353,
   -1,   -1,    0,   59,   -1,   -1,  441,  442,   -1,  444,
   -1,   -1,  366,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  374,   -1,   -1,  377,  378,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  387,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,  403,
   -1,   -1,   -1,   -1,   -1,   -1,  491,   -1,   -1,   -1,
   -1,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  425,   -1,  508,   -1,   -1,  430,  512,   -1,   -1,
   -1,   -1,   -1,  314,   -1,   -1,  317,  441,  442,   -1,
  444,   -1,  527,  324,   -1,  326,   -1,   -1,    0,  330,
   -1,   -1,   -1,   -1,  335,   -1,   -1,  338,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  353,   -1,   -1,  262,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  366,   -1,  491,   -1,   41,
   -1,   -1,   44,  374,   -1,   -1,  377,  378,   -1,   -1,
   -1,   -1,   -1,   -1,  508,   -1,  387,   59,  512,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  403,  527,   -1,   -1,   -1,  314,   -1,   -1,
  317,   -1,   -1,   -1,   -1,   -1,   -1,  324,   -1,  326,
   -1,   -1,    0,  330,  425,   -1,   -1,   -1,  335,  430,
   -1,  338,   -1,   -1,   -1,   -1,  262,   -1,   -1,   -1,
  441,  442,   -1,  444,   -1,   -1,  353,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  366,
   -1,   -1,   -1,   41,   -1,   -1,   44,  374,   -1,   -1,
  377,  378,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  387,   59,   -1,   -1,   -1,   -1,   -1,   -1,  314,   -1,
  491,  317,   -1,   -1,  262,   -1,  403,   -1,  324,   -1,
  326,   -1,   -1,   -1,  330,   -1,   -1,  508,   -1,  335,
   -1,  512,  338,   -1,   -1,   -1,   -1,   -1,  425,   -1,
   -1,   -1,   -1,  430,    0,   -1,  527,  353,   -1,   -1,
   -1,   -1,   -1,   -1,  441,  442,   -1,  444,   -1,   -1,
  366,   -1,   -1,   -1,   -1,   -1,  314,   -1,  374,  317,
   -1,  377,  378,   -1,   -1,   -1,  324,   -1,  326,   -1,
   -1,  387,  330,   -1,   -1,   41,   -1,  335,   44,   -1,
  338,   -1,   -1,   -1,   -1,   -1,   -1,  403,   -1,   -1,
   -1,   -1,    0,   59,  491,  353,   -1,   -1,   -1,   -1,
  262,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  366,  425,
   -1,  508,   -1,   -1,  430,  512,  374,   -1,   -1,  377,
  378,   -1,   -1,   -1,   -1,  441,  442,   -1,  444,  387,
  527,   -1,   40,   41,   -1,   -1,   44,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  403,   -1,   -1,   -1,   -1,
   -1,   59,  314,   -1,   -1,  317,   -1,   -1,   -1,   -1,
   -1,   -1,  324,   -1,  326,   -1,   -1,  425,  330,   -1,
   -1,   -1,  430,  335,   -1,  491,  338,   -1,   -1,   -1,
   -1,   -1,   -1,  441,  442,   -1,  444,   -1,   -1,   -1,
   -1,  353,  508,   -1,   -1,   -1,  512,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  366,   -1,   -1,   -1,   -1,   -1,
   -1,  527,  374,   -1,   -1,  377,  378,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  387,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  491,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  403,   -1,   -1,   -1,   -1,  314,   -1,   -1,  317,
  508,   -1,   -1,   -1,  512,   -1,  324,   -1,  326,   -1,
   -1,   -1,  330,  425,   -1,   -1,   -1,  335,  430,  527,
  338,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  441,
  442,   -1,  444,   -1,   -1,  353,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  366,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  374,   -1,   -1,  377,
  378,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  387,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  491,
   -1,   -1,   -1,   -1,   -1,  403,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  508,   -1,  314,   -1,
  512,  317,   -1,   -1,   -1,   -1,   -1,  425,  324,   -1,
  326,   -1,  430,   -1,  330,  527,   -1,   -1,   -1,  335,
   -1,   -1,  338,  441,  442,   -1,  444,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  353,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  366,   -1,   -1,   -1,   -1,   -1,  314,   -1,  374,  317,
   -1,   -1,  378,   -1,   -1,   -1,  324,   -1,  326,   -1,
   -1,  387,  330,  491,   -1,   -1,   -1,  335,   -1,   -1,
  338,   -1,   -1,   -1,   -1,   -1,   -1,  403,   -1,   -1,
  508,   -1,   -1,   -1,  512,  353,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  366,  527,
   -1,   -1,   -1,   -1,  430,   -1,  374,   -1,   -1,   -1,
  378,   -1,   -1,   -1,   -1,   -1,  442,   -1,  444,  387,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  403,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,   -1,
   -1,   -1,  265,   -1,   -1,  268,  269,   -1,   -1,   -1,
   -1,   -1,  430,   -1,   -1,  491,   -1,  280,  281,   -1,
  283,   -1,  285,   -1,  442,  288,  444,   -1,  291,   -1,
   -1,   -1,  508,   -1,   -1,  298,  512,  300,  301,   -1,
   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,
   -1,  527,   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,
   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  491,  337,   -1,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,
  508,   -1,  355,   -1,  512,  358,   -1,   -1,   -1,   -1,
  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,
  383,  384,   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,   -1,
   -1,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,   -1,   -1,
   -1,   -1,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,  454,  455,  456,  457,  458,  459,  460,  461,  462,
  463,  464,  465,  466,  467,  468,  469,  470,  471,  472,
  473,  474,   -1,   -1,  477,  478,  479,  480,  481,  482,
  483,  484,  485,  486,  487,  488,  489,  490,  491,  492,
  493,  494,  495,  496,  497,  498,  499,  500,  501,  502,
  503,  504,  505,  506,  507,  508,  509,  510,  511,  512,
  513,  514,  515,  516,  517,  518,  519,  520,  521,  522,
  523,  524,  525,  526,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,  549,  550,  551,  552,
  553,  554,  555,  556,  557,  558,  559,  560,  561,  562,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,  582,
  583,  584,  585,  586,  587,  588,  589,  590,  591,  592,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,  606,  607,   -1,  609,  610,  611,  612,
  613,   -1,  615,  616,  617,  618,  257,   -1,  259,   -1,
   -1,   -1,   -1,   -1,  265,   -1,   -1,  268,  269,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
  281,   -1,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,
  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,
   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,
  381,  382,  383,  384,   -1,  386,   -1,   -1,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,
   -1,   -1,   -1,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,
   -1,   -1,   -1,   -1,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,  454,  455,  456,  457,  458,   -1,  460,
  461,  462,  463,  464,  465,  466,  467,  468,  469,  470,
  471,  472,  473,  474,   -1,   -1,  477,  478,  479,  480,
  481,  482,  483,  484,  485,  486,  487,  488,  489,  490,
  491,  492,  493,  494,  495,  496,  497,  498,  499,  500,
  501,  502,  503,  504,  505,  506,  507,  508,  509,  510,
  511,  512,  513,  514,  515,  516,  517,  518,  519,  520,
  521,  522,  523,  524,  525,  526,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,  549,  550,
  551,  552,  553,  554,  555,  556,  557,  558,  559,  560,
  561,  562,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,  582,  583,  584,  585,  586,  587,  588,  589,  590,
  591,  592,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,  606,  607,   -1,  609,  610,
  611,  612,  613,   -1,  615,  616,  617,  618,  257,   -1,
  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,   -1,  268,
  269,  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  280,  281,   -1,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,  297,  298,
   -1,  300,  301,   -1,   -1,  304,  305,   -1,   -1,  308,
  309,   -1,  311,   -1,   -1,  314,   -1,   -1,   -1,   -1,
   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,  328,
  329,   -1,  331,   -1,  333,   -1,   -1,   -1,  337,   -1,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
  349,   -1,  351,   -1,  353,   -1,  355,   -1,   -1,  358,
   -1,   -1,  361,   -1,  363,  364,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,
   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,  388,
  389,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,   -1,   -1,   -1,  403,   -1,   -1,  406,  407,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,   -1,   -1,  427,   -1,
  429,   -1,   -1,  432,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,  441,   -1,  443,  444,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
   -1,  460,  461,   -1,   -1,   -1,   -1,   -1,   -1,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,   -1,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,  505,  506,  507,   -1,
  509,  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,
  519,  520,  521,   -1,  523,  524,   -1,  526,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,   -1,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,  257,  607,  259,
  609,  610,  611,  612,  613,  265,  615,   -1,  268,  269,
  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  280,  281,   -1,  283,   -1,  285,   -1,   -1,  288,   -1,
   -1,  291,   -1,   -1,   -1,   -1,   -1,  297,  298,   -1,
  300,  301,   -1,   -1,  304,  305,   -1,   -1,  308,  309,
   -1,  311,   -1,   -1,  314,   -1,   -1,   -1,   -1,   -1,
   -1,  321,  322,   -1,   -1,   -1,   -1,  327,  328,  329,
   -1,  331,   -1,  333,   -1,   -1,   -1,  337,   -1,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,  349,
   -1,  351,   -1,  353,   -1,  355,   -1,   -1,  358,   -1,
   -1,  361,   -1,  363,  364,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,
  380,  381,  382,  383,  384,   -1,  386,   -1,  388,  389,
   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,
   -1,   -1,   -1,  403,   -1,   -1,  406,  407,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,
  420,  421,  422,   -1,   -1,   -1,   -1,  427,   -1,  429,
   -1,   -1,  432,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  440,   -1,   -1,  443,  444,  445,  446,   -1,   -1,   -1,
  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,
  460,  461,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,
  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,
  490,   -1,  492,  493,   -1,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,  505,  506,  507,   -1,  509,
  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,  519,
  520,  521,   -1,  523,  524,   -1,  526,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,   -1,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,  257,  607,  259,  609,
  610,  611,  612,  613,  265,  615,   -1,  268,  269,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
  281,   -1,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,  297,  298,   -1,  300,
  301,   -1,   -1,  304,  305,   -1,   -1,  308,  309,   -1,
  311,   -1,   -1,  314,   -1,   -1,   -1,   -1,   -1,   -1,
  321,  322,   -1,   -1,   -1,   -1,  327,  328,  329,   -1,
  331,   -1,  333,   -1,   -1,   -1,  337,   -1,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,  349,   -1,
  351,   -1,  353,   -1,  355,   -1,   -1,  358,   -1,   -1,
  361,   -1,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,
  381,  382,  383,  384,   -1,  386,   -1,  388,  389,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,
   -1,   -1,  403,   -1,   -1,  406,  407,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,
   -1,  432,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,
   -1,   -1,  443,  444,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
  461,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
   -1,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,  505,  506,  507,   -1,  509,  510,
  511,   -1,  513,  514,  515,   -1,  517,   -1,  519,  520,
  521,   -1,  523,  524,   -1,  526,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
   -1,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,  257,  607,  259,  609,  610,
  611,  612,  613,  265,  615,   -1,  268,  269,  270,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,  281,
   -1,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,
   -1,   -1,   -1,   -1,   -1,  297,  298,   -1,  300,  301,
   -1,   -1,   -1,  305,   -1,   -1,  308,  309,   -1,  311,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  321,
  322,   -1,   -1,   -1,   -1,  327,  328,  329,   -1,  331,
   -1,  333,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,
   -1,  343,   -1,   -1,   -1,   -1,   -1,  349,   -1,  351,
   -1,  353,   -1,  355,   -1,   -1,  358,   -1,   -1,  361,
   -1,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,
  382,  383,  384,   -1,  386,   -1,  388,  389,   -1,   -1,
  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,
   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,
  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,
  422,   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,
  432,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,   -1,
   -1,   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,
   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,  461,
   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,
  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,   -1,
  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,  505,  506,  507,   -1,  509,  510,  511,
   -1,  513,  514,  515,   -1,  517,   -1,  519,  520,  521,
   -1,  523,  524,   -1,  526,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,   -1,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,  257,  607,  259,  609,  610,  611,
  612,  613,  265,  615,   -1,  268,  269,   -1,   -1,  272,
   -1,   -1,  275,   -1,   -1,   -1,   -1,  280,  281,   -1,
  283,   -1,  285,   -1,   -1,  288,   -1,  290,  291,  292,
   -1,  294,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,
   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,  334,   -1,   -1,  337,   -1,  339,  340,  341,  342,
  343,  344,  345,  346,   -1,  348,   -1,   -1,  351,   -1,
   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,
  363,  364,  365,   -1,  367,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,
  383,  384,   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,
   -1,  394,  395,  396,   -1,  398,  399,   -1,   -1,   -1,
   -1,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
  413,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,
   -1,   -1,  435,   -1,   -1,   -1,   -1,  440,   -1,   -1,
   -1,   -1,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  468,  469,  470,  471,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,
  483,  484,   -1,   -1,  487,   -1,  489,  490,   -1,  492,
  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,
  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,   -1,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,  257,  607,  259,  609,  610,  611,  612,
  613,  265,  615,   -1,  268,  269,   -1,   -1,  272,   -1,
   -1,  275,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,
   -1,  285,   -1,   -1,  288,   -1,   -1,  291,  292,   -1,
  294,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,   -1,
   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,   -1,
   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,
  334,   -1,   -1,  337,   -1,  339,  340,  341,  342,  343,
  344,  345,  346,   -1,  348,   -1,   -1,  351,   -1,   -1,
   -1,  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,  363,
  364,  365,   -1,  367,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,
  384,   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,
  394,  395,  396,   -1,  398,  399,   -1,   -1,   -1,   -1,
   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,  413,
  414,   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,
   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,   -1,
   -1,  435,   -1,   -1,   -1,   -1,  440,   -1,   -1,   -1,
   -1,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,
   -1,  455,  456,  457,  458,   -1,  460,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  468,  469,  470,  471,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,
  484,   -1,   -1,  487,   -1,  489,  490,   -1,  492,  493,
   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,  503,
  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,
  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,   -1,  549,  550,  551,  552,  553,
  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,   -1,  582,  583,
  584,  585,   -1,  587,  588,  589,  590,  591,   -1,  593,
  594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
  604,  605,  257,  607,  259,  609,  610,  611,  612,  613,
  265,  615,   -1,  268,  269,   -1,   -1,  272,   -1,   -1,
  275,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,
  285,   -1,   -1,  288,   -1,   -1,  291,  292,   -1,  294,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,   -1,   -1,
  305,   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,   -1,   -1,
   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,  334,
   -1,   -1,  337,   -1,  339,  340,  341,  342,  343,  344,
  345,  346,   -1,  348,   -1,   -1,  351,   -1,   -1,   -1,
  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,
  365,   -1,  367,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,
   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,  394,
  395,  396,   -1,  398,  399,   -1,   -1,   -1,   -1,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,  413,  414,
   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,
   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,   -1,   -1,
  435,   -1,   -1,   -1,   -1,  440,   -1,   -1,   -1,   -1,
  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,
  455,  456,  457,  458,   -1,  460,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  468,  469,  470,  471,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,
   -1,   -1,  487,   -1,  489,  490,   -1,  492,  493,   -1,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,
  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,   -1,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,  257,  607,  259,  609,  610,  611,  612,  613,  265,
  615,   -1,  268,  269,   -1,   -1,  272,   -1,   -1,  275,
   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,
   -1,   -1,  288,   -1,   -1,  291,  292,   -1,  294,   -1,
   -1,   -1,  298,   -1,  300,  301,   -1,   -1,   -1,  305,
   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  321,  322,   -1,   -1,   -1,
   -1,  327,   -1,  329,   -1,  331,   -1,   -1,  334,   -1,
   -1,  337,   -1,  339,  340,  341,  342,  343,  344,  345,
  346,   -1,  348,   -1,   -1,  351,   -1,   -1,   -1,  355,
   -1,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,  365,
   -1,  367,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,
  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,
  396,   -1,  398,  399,   -1,   -1,   -1,   -1,   -1,   -1,
  406,   -1,   -1,  409,  410,  411,  412,  413,  414,   -1,
  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,   -1,
   -1,  427,   -1,  429,   -1,   -1,   -1,   -1,   -1,  435,
   -1,   -1,   -1,   -1,  440,   -1,   -1,   -1,   -1,  445,
  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,
  456,  457,  458,   -1,  460,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  468,  469,  470,  471,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,
   -1,  487,   -1,  489,  490,   -1,  492,  493,   -1,  495,
   -1,   -1,  498,  499,  500,  501,  502,  503,  504,   -1,
   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,
   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,   -1,  549,  550,  551,  552,  553,  554,   -1,
  556,  557,  558,  559,   -1,  561,   -1,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,   -1,  582,  583,  584,  585,
   -1,  587,  588,  589,  590,  591,   -1,  593,  594,  595,
  596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
   -1,  607,   -1,  609,  610,  611,  612,  613,  257,  615,
  259,  260,   -1,   -1,   -1,   -1,  265,   -1,   -1,  268,
  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  280,  281,   -1,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,  297,  298,
   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,
  309,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,
  329,   -1,  331,   -1,  333,   -1,   -1,   -1,  337,   -1,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  351,   -1,   -1,   -1,  355,   -1,   -1,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,
   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,   -1,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,  397,  398,
  399,   -1,   -1,   -1,   -1,   -1,   -1,  406,  407,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,   -1,   -1,  427,   -1,
  429,   -1,   -1,  432,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,   -1,   -1,   -1,   -1,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,   -1,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,   -1,
  509,  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,   -1,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,  257,  607,  259,
  609,  610,  611,  612,  613,  265,  615,   -1,  268,  269,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  280,  281,   -1,  283,   -1,  285,   -1,   -1,  288,   -1,
   -1,  291,   -1,   -1,   -1,   -1,   -1,  297,  298,   -1,
  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,  309,
   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,
   -1,  331,   -1,  333,   -1,   -1,   -1,  337,   -1,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  351,   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,
   -1,   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,
  380,  381,  382,  383,  384,   -1,  386,   -1,   -1,   -1,
   -1,   -1,  392,   -1,  394,  395,   -1,  397,  398,  399,
   -1,   -1,   -1,   -1,   -1,   -1,  406,  407,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,
  420,  421,  422,   -1,   -1,   -1,   -1,  427,   -1,  429,
   -1,   -1,  432,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  440,   -1,   -1,   -1,   -1,  445,  446,   -1,   -1,   -1,
  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,
  460,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,
  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,
  490,   -1,  492,  493,   -1,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,
  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,   -1,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,  257,  607,  259,  609,
  610,  611,  612,  613,  265,  615,   -1,  268,  269,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
  281,   -1,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,
  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  321,  322,   -1,  324,   -1,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,
   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,
  381,  382,  383,  384,   -1,  386,   -1,   -1,   -1,   -1,
   -1,  392,  393,  394,  395,   -1,   -1,  398,  399,   -1,
   -1,   -1,   -1,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,   -1,   -1,  427,  428,  429,   -1,
   -1,   -1,  433,   -1,   -1,   -1,   -1,   -1,  439,  440,
   -1,   -1,   -1,   -1,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
   -1,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,
  511,   -1,  513,  514,  515,   -1,  517,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
   -1,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,  257,  607,  259,  609,  610,
  611,  612,  613,  265,  615,   -1,  268,  269,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,  281,
   -1,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,
   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,
   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  321,
  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,
   -1,   -1,   -1,   -1,   -1,  337,  338,  339,   -1,   -1,
   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,
   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,  361,
   -1,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,
  382,  383,  384,   -1,  386,   -1,   -1,   -1,   -1,   -1,
  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,
   -1,   -1,   -1,   -1,  406,   -1,   -1,  409,  410,  411,
  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,
  422,   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,   -1,
   -1,   -1,   -1,  445,  446,   -1,   -1,   -1,  450,   -1,
   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,
  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,   -1,
  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,
   -1,  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,   -1,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,  257,  607,  259,  609,  610,  611,
  612,  613,  265,  615,   -1,  268,  269,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,
  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,
   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,
   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,
   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,
  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  376,  377,   -1,   -1,  380,  381,  382,
  383,  384,   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,   -1,
   -1,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,   -1,   -1,
   -1,   -1,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,
  483,  484,   -1,   -1,   -1,   -1,  489,  490,   -1,  492,
  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,
  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,   -1,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,  257,  607,  259,  609,  610,  611,  612,
  613,  265,  615,   -1,  268,  269,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,
   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,
   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,   -1,
   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,   -1,
   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,
   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,  343,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,   -1,
   -1,  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,  363,
  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,
  384,   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,
  394,  395,   -1,   -1,  398,  399,   -1,   -1,   -1,   -1,
   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,
  414,   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,
   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  440,   -1,   -1,   -1,
   -1,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,
   -1,  455,  456,  457,  458,   -1,  460,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  468,  469,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,
  484,   -1,   -1,   -1,   -1,  489,  490,   -1,  492,  493,
   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,  503,
  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,
  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,   -1,  549,  550,  551,  552,  553,
  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,  582,  583,
  584,  585,   -1,  587,  588,  589,  590,  591,   -1,  593,
  594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
  604,  605,  257,  607,  259,  609,  610,  611,  612,  613,
  265,  615,   -1,  268,  269,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,
  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,   -1,   -1,
  305,   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,   -1,   -1,
   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,   -1,   -1,
  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,
   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,   -1,   -1,   -1,   -1,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,
   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,  433,   -1,
   -1,   -1,   -1,   -1,   -1,  440,   -1,   -1,   -1,   -1,
  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,
  455,  456,  457,  458,   -1,  460,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  468,  469,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,
   -1,   -1,   -1,   -1,  489,  490,   -1,  492,  493,   -1,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,
  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,   -1,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,  257,  607,  259,  609,  610,  611,  612,  613,  265,
  615,   -1,  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  280,  281,   -1,  283,  284,  285,
   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,
   -1,   -1,  298,   -1,  300,  301,   -1,   -1,   -1,  305,
   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  321,  322,   -1,   -1,   -1,
   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,
   -1,  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  351,   -1,   -1,   -1,  355,
   -1,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,
  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,
   -1,   -1,  398,  399,   -1,   -1,   -1,   -1,   -1,   -1,
  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,
  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,   -1,
   -1,  427,   -1,  429,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  440,   -1,   -1,   -1,   -1,  445,
  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,
  456,  457,  458,   -1,  460,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,
   -1,   -1,   -1,  489,  490,   -1,  492,  493,   -1,  495,
   -1,   -1,  498,  499,  500,  501,  502,  503,  504,   -1,
   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,
   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,   -1,  549,  550,  551,  552,  553,  554,   -1,
  556,  557,  558,  559,   -1,  561,   -1,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,   -1,  582,  583,  584,  585,
   -1,  587,  588,  589,  590,  591,   -1,  593,  594,  595,
  596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
  257,  607,  259,  609,  610,  611,  612,  613,  265,  615,
   -1,  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  280,  281,   -1,  283,  284,  285,   -1,
   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,
   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,
  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  351,   -1,   -1,   -1,  355,   -1,
   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,
   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,
   -1,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,   -1,   -1,   -1,   -1,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,   -1,   -1,
  427,   -1,  429,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  440,   -1,   -1,   -1,   -1,  445,  446,
   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
   -1,   -1,  489,  490,   -1,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,   -1,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,  257,
  607,  259,  609,  610,  611,  612,  613,  265,  615,   -1,
  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  280,  281,   -1,  283,   -1,  285,   -1,   -1,
  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,
  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,
  308,   -1,   -1,  311,  312,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,
   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,
   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  351,   -1,   -1,   -1,  355,   -1,   -1,
  358,   -1,   -1,   -1,   -1,  363,  364,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,
   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,
   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,
  398,  399,   -1,   -1,   -1,   -1,   -1,   -1,  406,   -1,
   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,
  418,  419,  420,  421,  422,   -1,   -1,   -1,   -1,  427,
   -1,  429,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  440,   -1,   -1,   -1,   -1,  445,  446,   -1,
   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,
  458,   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,
   -1,  489,  490,   -1,  492,  493,   -1,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,  517,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,   -1,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,  257,  607,
  259,  609,  610,  611,  612,  613,  265,  615,   -1,  268,
  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  280,  281,   -1,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,
   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  351,   -1,   -1,   -1,  355,   -1,   -1,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,
   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,   -1,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,   -1,   -1,   -1,   -1,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,   -1,   -1,  427,   -1,
  429,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,   -1,   -1,   -1,   -1,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
  459,  460,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,   -1,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,   -1,
  509,  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,   -1,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,  257,  607,  259,
  609,  610,  611,  612,  613,  265,  615,   -1,  268,  269,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  280,  281,   -1,  283,   -1,  285,   -1,   -1,  288,   -1,
   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,
  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,
   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,
   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  351,   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,
   -1,   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,
  380,  381,  382,  383,  384,   -1,  386,   -1,   -1,   -1,
   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,
   -1,   -1,   -1,   -1,   -1,   -1,  406,   -1,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,
  420,  421,  422,   -1,   -1,   -1,   -1,  427,   -1,  429,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  440,   -1,   -1,   -1,   -1,  445,  446,   -1,   -1,   -1,
  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,  459,
  460,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,
  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,
  490,   -1,  492,  493,   -1,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,
  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,   -1,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,  257,  607,  259,  609,
  610,  611,  612,  613,  265,  615,   -1,  268,  269,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
  281,   -1,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,
  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,
   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,
  381,  382,  383,  384,   -1,  386,   -1,   -1,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,
   -1,   -1,   -1,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,
   -1,   -1,   -1,   -1,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
   -1,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,
  511,   -1,  513,  514,  515,   -1,  517,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
   -1,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,  257,  607,  259,  609,  610,
  611,  612,  613,  265,  615,   -1,  268,  269,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,  281,
   -1,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,
   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,
   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  321,
  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,
   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,
   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,
   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,   -1,
   -1,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,
  382,  383,  384,   -1,  386,   -1,   -1,   -1,   -1,   -1,
  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,
   -1,   -1,   -1,   -1,  406,   -1,   -1,  409,  410,  411,
  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,
  422,   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,   -1,
   -1,   -1,   -1,  445,  446,   -1,   -1,   -1,  450,   -1,
   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,
  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,   -1,
  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,
   -1,  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,   -1,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,  257,  607,  259,  609,  610,  611,
  612,  613,  265,  615,   -1,  268,  269,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,
  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,
   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,
   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,
   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,
  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,
  383,  384,   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,   -1,
   -1,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,   -1,   -1,
   -1,   -1,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,
  483,  484,   -1,   -1,   -1,   -1,  489,  490,   -1,  492,
  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,
  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,   -1,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,  257,  607,  259,  609,  610,  611,  612,
  613,  265,  615,   -1,  268,  269,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,
   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,
   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,   -1,
   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,   -1,
   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,
   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,  343,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,   -1,
   -1,  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,  363,
  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,
  384,   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,
  394,  395,   -1,   -1,  398,  399,   -1,   -1,   -1,   -1,
   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,
  414,   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,
   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  440,   -1,   -1,   -1,
   -1,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,
   -1,  455,  456,  457,  458,   -1,  460,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  468,  469,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,
  484,   -1,   -1,   -1,   -1,  489,  490,   -1,  492,  493,
   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,  503,
  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,
  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,   -1,  549,  550,  551,  552,  553,
  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,   -1,  582,  583,
  584,  585,   -1,  587,  588,  589,  590,  591,   -1,  593,
  594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
  604,  605,  257,  607,  259,  609,  610,  611,  612,  613,
  265,  615,   -1,  268,  269,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,
  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,   -1,   -1,
  305,   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,   -1,   -1,
   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,   -1,   -1,
  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,
   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,   -1,   -1,   -1,   -1,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,
   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  440,   -1,   -1,   -1,   -1,
  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,
  455,  456,  457,  458,   -1,  460,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  468,  469,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,
   -1,   -1,   -1,   -1,  489,  490,   -1,  492,  493,   -1,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,
  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,   -1,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,  257,  607,  259,  609,  610,  611,  612,  613,  265,
  615,   -1,  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,
   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,
   -1,   -1,  298,   -1,  300,  301,   -1,   -1,   -1,  305,
   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  321,  322,   -1,   -1,   -1,
   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,
   -1,  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  351,   -1,   -1,   -1,  355,
   -1,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,
  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,
   -1,   -1,  398,  399,   -1,   -1,   -1,   -1,   -1,   -1,
  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,
  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,   -1,
   -1,  427,   -1,  429,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  440,   -1,   -1,   -1,   -1,  445,
  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,
  456,  457,  458,   -1,  460,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,
   -1,   -1,   -1,  489,  490,   -1,  492,  493,   -1,  495,
   -1,   -1,  498,  499,  500,  501,  502,  503,  504,   -1,
   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,
   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,   -1,  549,  550,  551,  552,  553,  554,   -1,
  556,  557,  558,  559,   -1,  561,   -1,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,   -1,  582,  583,  584,  585,
   -1,  587,  588,  589,  590,  591,   -1,  593,  594,  595,
  596,  597,  598,  599,  600,   -1,  602,  603,  604,  605,
  257,  607,  259,  609,  610,  611,  612,  613,  265,  615,
   -1,  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,   -1,
   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,
   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,
  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  351,   -1,   -1,   -1,  355,   -1,
   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,
   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,
   -1,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,   -1,   -1,   -1,   -1,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,   -1,   -1,
  427,   -1,  429,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  440,   -1,   -1,   -1,   -1,  445,  446,
   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
   -1,   -1,  489,  490,   -1,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,   -1,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,   -1,
  607,   -1,  609,  610,  611,  612,  613,   -1,  615,
};
static int yyctable[] = {                                    306,
   57,   -1,  837,  869,   -1,  578,  821,   -1,  579,  821,
   -1,  579,  819,   -1, 1079, 1212,   -1, 1182,  755,   -1,
 1188,  770,   -1, 1050, 1335,   -1, 1051, 1336,   -1, 1052,
 1337,   -1, 1445, 1114,   -1,  837,  864,   -1,  281, 1323,
   -1,  214,  848,   -1,
};
#define YYFINAL 22
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 620
#if YYDEBUG
static const char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,0,0,0,0,0,0,0,
"':'","';'","'<'","'='","'>'","'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,"'['",0,"']'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"ACTIVE","ADD","AFTER","ALL","ALTER","AND","ANY",
"AS","ASC","AT","AVG","AUTO","BEFORE","BEGIN","BETWEEN","BLOB","BY","CAST",
"CHARACTER","CHECK","COLLATE","COMMA","COMMIT","COMMITTED","COMPUTED",
"CONCATENATE","CONDITIONAL","CONSTRAINT","CONTAINING","COUNT","CREATE",
"CSTRING","CURRENT","CURSOR","DATABASE","DATE","DB_KEY","DECIMAL","DECLARE",
"DEFAULT","KW_DELETE","DESC","DISTINCT","DO","DOMAIN","DROP","ELSE","END",
"ENTRY_POINT","EQL","ESCAPE","EXCEPTION","EXECUTE","EXISTS","EXIT","EXTERNAL",
"FILTER","FOR","FOREIGN","FROM","FULL","FUNCTION","GDSCODE","GEQ","GENERATOR",
"GEN_ID","GRANT","GROUP","GTR","HAVING","IF","KW_IN","INACTIVE","INNER",
"INPUT_TYPE","INDEX","INSERT","INTEGER","INTO","IS","ISOLATION","JOIN","KEY",
"KW_CHAR","KW_DEC","KW_DOUBLE","KW_FILE","KW_FLOAT","KW_INT","KW_LONG",
"KW_NULL","KW_NUMERIC","KW_UPPER","KW_VALUE","LENGTH","LPAREN","LEFT","LEQ",
"LEVEL","LIKE","LSS","MANUAL","MAXIMUM","MAX_SEGMENT","MERGE","MINIMUM",
"MODULE_NAME","NAMES","NATIONAL","NATURAL","NCHAR","NEQ","NO","NOT","NOT_GTR",
"NOT_LSS","OF","ON","ONLY","OPTION","OR","ORDER","OUTER","OUTPUT_TYPE",
"OVERFLOW","PAGE","PAGES","KW_PAGE_SIZE","PARAMETER","PASSWORD","PLAN",
"POSITION","POST_EVENT","PRECISION","PRIMARY","PRIVILEGES","PROCEDURE",
"PROTECTED","READ","REAL","REFERENCES","RESERVING","RETAIN","RETURNING_VALUES",
"RETURNS","REVOKE","RIGHT","RPAREN","ROLLBACK","SEGMENT","SELECT","SET",
"SHADOW","KW_SHARED","SINGULAR","KW_SIZE","SMALLINT","SNAPSHOT","SOME","SORT",
"SQLCODE","STABILITY","STARTING","STATISTICS","SUB_TYPE","SUSPEND","SUM",
"TABLE","THEN","TO","TRANSACTION","TRIGGER","UNCOMMITTED","UNION","UNIQUE",
"UPDATE","USER","VALUES","VARCHAR","VARIABLE","VARYING","VERSION","VIEW","WAIT",
"WHEN","WHERE","WHILE","WITH","WORK","WRITE","FLOAT_NUMBER","NUMBER","NUMERIC",
"SYMBOL","STRING","INTRODUCER","ACTION","ADMIN","CASCADE","FREE_IT","RESTRICT",
"ROLE","COLUMN","KW_TYPE","EXTRACT","YEAR","MONTH","DAY","HOUR","MINUTE",
"SECOND","WEEKDAY","YEARDAY","TIME","TIMESTAMP","CURRENT_DATE","CURRENT_TIME",
"CURRENT_TIMESTAMP","NUMBER64BIT","SCALEDINT","CURRENT_USER","CURRENT_ROLE",
"KW_BREAK","SUBSTRING","RECREATE","KW_DESCRIPTOR","FIRST","SKIP",
"CURRENT_CONNECTION","CURRENT_TRANSACTION","BIGINT","CASE","NULLIF","COALESCE",
"USING","NULLS","LAST","ROW_COUNT","LOCK","SAVEPOINT","RELEASE","STATEMENT",
"LEAVE","INSERTING","UPDATING","DELETING","BACKUP","KW_DIFFERENCE","OPEN",
"CLOSE","FETCH","ROWS","BLOCK","IIF","SCALAR_ARRAY","CROSS","NEXT","SEQUENCE",
"RESTART","BOTH","COLLATION","COMMENT","BIT_LENGTH","CHAR_LENGTH",
"CHARACTER_LENGTH","LEADING","KW_LOWER","OCTET_LENGTH","TRAILING","TRIM",
"RETURNING","KW_IGNORE","LIMBO","UNDO","REQUESTS","TIMEOUT","ABS","ACCENT",
"ACOS","ALWAYS","ASCII_CHAR","ASCII_VAL","ASIN","ATAN","ATAN2","BIN_AND",
"BIN_OR","BIN_SHL","BIN_SHR","BIN_XOR","CEIL","CONNECT","COS","COSH","COT",
"DATEADD","DATEDIFF","DECODE","DISCONNECT","EXP","FLOOR","GEN_UUID","GENERATED",
"GLOBAL","HASH","INSENSITIVE","LIST","LN","LOG","LOG10","LPAD","MATCHED",
"MATCHING","MAXVALUE","MILLISECOND","MINVALUE","MOD","OVERLAY","PAD","PI",
"PLACING","POWER","PRESERVE","RAND","RECURSIVE","REPLACE","REVERSE","ROUND",
"RPAD","SENSITIVE","SIGN","SIN","SINH","SPACE","SQRT","START","TAN","TANH",
"TEMPORARY","TRUNC","WEEK","AUTONOMOUS","CHAR_TO_UUID","FIRSTNAME","GRANTED",
"LASTNAME","MIDDLENAME","MAPPING","OS_NAME","SIMILAR","UUID_TO_CHAR","DUMP",
"CALLER","COMMON","DATA","SOURCE","TWO_PHASE","BIND_PARAM","BIN_NOT","SQLSTATE",
"LOCALTIME","LOCALTIMESTAMP","UMINUS","UPLUS",
};
static const char *yyrule[] = {
"$accept : top",
"top : statement",
"top : statement ';'",
"statement : alter",
"statement : blob_io",
"statement : comment",
"statement : commit",
"statement : create",
"statement : create_or_alter",
"statement : declare",
"statement : delete",
"statement : drop",
"statement : grant",
"statement : insert",
"statement : merge",
"statement : exec_procedure",
"statement : exec_block",
"statement : recreate",
"statement : revoke",
"statement : rollback",
"statement : savepoint",
"statement : select",
"statement : set",
"statement : update",
"statement : update_or_insert",
"statement : dump",
"grant : GRANT privileges ON table_noise simple_table_name TO non_role_grantee_list grant_option granted_by",
"grant : GRANT proc_privileges ON PROCEDURE simple_proc_name TO non_role_grantee_list grant_option granted_by",
"grant : GRANT role_name_list TO role_grantee_list role_admin_option granted_by",
"table_noise : TABLE",
"table_noise :",
"privileges : ALL",
"privileges : ALL PRIVILEGES",
"privileges : privilege_list",
"privilege_list : privilege",
"privilege_list : privilege_list ',' privilege",
"proc_privileges : EXECUTE",
"privilege : SELECT",
"privilege : INSERT",
"privilege : KW_DELETE",
"privilege : UPDATE column_parens_opt",
"privilege : REFERENCES column_parens_opt",
"grant_option : WITH GRANT OPTION",
"grant_option :",
"role_admin_option : WITH ADMIN OPTION",
"role_admin_option :",
"granted_by : granted_by_text grantor",
"granted_by :",
"granted_by_text : GRANTED BY",
"granted_by_text : AS",
"grantor : role_grantee",
"simple_proc_name : symbol_procedure_name",
"revoke : REVOKE rev_grant_option privileges ON table_noise simple_table_name FROM non_role_grantee_list granted_by",
"revoke : REVOKE rev_grant_option proc_privileges ON PROCEDURE simple_proc_name FROM non_role_grantee_list granted_by",
"revoke : REVOKE rev_admin_option role_name_list FROM role_grantee_list granted_by",
"revoke : REVOKE ALL ON ALL FROM non_role_grantee_list",
"rev_grant_option : GRANT OPTION FOR",
"rev_grant_option :",
"rev_admin_option : ADMIN OPTION FOR",
"rev_admin_option :",
"non_role_grantee_list : grantee_list",
"non_role_grantee_list : user_grantee_list",
"grantee_list : grantee",
"grantee_list : grantee_list ',' grantee",
"grantee_list : grantee_list ',' user_grantee",
"grantee_list : user_grantee_list ',' grantee",
"grantee : PROCEDURE symbol_procedure_name",
"grantee : TRIGGER symbol_trigger_name",
"grantee : VIEW symbol_view_name",
"grantee : ROLE symbol_role_name",
"user_grantee_list : user_grantee",
"user_grantee_list : user_grantee_list ',' user_grantee",
"user_grantee : symbol_user_name",
"user_grantee : USER symbol_user_name",
"user_grantee : GROUP symbol_user_name",
"role_name_list : role_name",
"role_name_list : role_name_list ',' role_name",
"role_name : symbol_role_name",
"role_grantee_list : role_grantee",
"role_grantee_list : role_grantee_list ',' role_grantee",
"role_grantee : symbol_user_name",
"role_grantee : USER symbol_user_name",
"declare : DECLARE declare_clause",
"declare_clause : FILTER filter_decl_clause",
"declare_clause : EXTERNAL FUNCTION udf_decl_clause",
"udf_decl_clause : symbol_UDF_name arg_desc_list1 RETURNS return_value1 ENTRY_POINT sql_string MODULE_NAME sql_string",
"udf_data_type : simple_type",
"udf_data_type : BLOB",
"udf_data_type : CSTRING '(' pos_short_integer ')' charset_clause",
"arg_desc_list1 :",
"arg_desc_list1 : arg_desc_list",
"arg_desc_list1 : '(' arg_desc_list ')'",
"arg_desc_list : arg_desc",
"arg_desc_list : arg_desc_list ',' arg_desc",
"arg_desc : init_data_type udf_data_type param_mechanism",
"param_mechanism :",
"param_mechanism : BY KW_DESCRIPTOR",
"param_mechanism : BY SCALAR_ARRAY",
"param_mechanism : KW_NULL",
"return_value1 : return_value",
"return_value1 : '(' return_value ')'",
"return_value : init_data_type udf_data_type return_mechanism",
"return_value : PARAMETER pos_short_integer",
"return_mechanism :",
"return_mechanism : BY KW_VALUE",
"return_mechanism : BY KW_DESCRIPTOR",
"return_mechanism : FREE_IT",
"return_mechanism : BY KW_DESCRIPTOR FREE_IT",
"filter_decl_clause : symbol_filter_name INPUT_TYPE blob_filter_subtype OUTPUT_TYPE blob_filter_subtype ENTRY_POINT sql_string MODULE_NAME sql_string",
"blob_filter_subtype : symbol_blob_subtype_name",
"blob_filter_subtype : signed_short_integer",
"create : CREATE create_clause",
"create_clause : EXCEPTION exception_clause",
"create_clause : unique_opt order_direction INDEX symbol_index_name ON simple_table_name index_definition",
"create_clause : PROCEDURE procedure_clause",
"create_clause : TABLE table_clause",
"create_clause : GLOBAL TEMPORARY TABLE gtt_table_clause",
"create_clause : TRIGGER trigger_clause",
"create_clause : VIEW view_clause",
"create_clause : GENERATOR generator_clause",
"create_clause : SEQUENCE generator_clause",
"create_clause : DATABASE db_clause",
"create_clause : DOMAIN domain_clause",
"create_clause : SHADOW shadow_clause",
"create_clause : ROLE role_clause",
"create_clause : COLLATION collation_clause",
"create_clause : USER create_user_clause",
"recreate : RECREATE recreate_clause",
"recreate_clause : PROCEDURE rprocedure_clause",
"recreate_clause : TABLE rtable_clause",
"recreate_clause : GLOBAL TEMPORARY TABLE gtt_recreate_clause",
"recreate_clause : VIEW rview_clause",
"recreate_clause : TRIGGER rtrigger_clause",
"recreate_clause : EXCEPTION rexception_clause",
"create_or_alter : CREATE OR ALTER replace_clause",
"replace_clause : PROCEDURE replace_procedure_clause",
"replace_clause : TRIGGER replace_trigger_clause",
"replace_clause : VIEW replace_view_clause",
"replace_clause : EXCEPTION replace_exception_clause",
"exception_clause : symbol_exception_name sql_string",
"rexception_clause : symbol_exception_name sql_string",
"replace_exception_clause : symbol_exception_name sql_string",
"alter_exception_clause : symbol_exception_name sql_string",
"unique_opt : UNIQUE",
"unique_opt :",
"index_definition : column_list",
"index_definition : column_parens",
"index_definition : computed_by '(' begin_trigger value end_trigger ')'",
"shadow_clause : pos_short_integer manual_auto conditional sql_string first_file_length sec_shadow_files",
"manual_auto : MANUAL",
"manual_auto : AUTO",
"manual_auto :",
"conditional :",
"conditional : CONDITIONAL",
"first_file_length :",
"first_file_length : LENGTH equals long_integer page_noise",
"sec_shadow_files :",
"sec_shadow_files : db_file_list",
"db_file_list : db_file",
"db_file_list : db_file_list db_file",
"domain_clause : column_def_name as_opt data_type domain_default_opt domain_constraint_clause collate_clause",
"as_opt : AS",
"as_opt :",
"domain_default : DEFAULT begin_trigger default_value end_default",
"domain_default_opt : domain_default",
"domain_default_opt :",
"domain_constraint_clause : domain_constraint_list",
"domain_constraint_clause :",
"domain_constraint_list : domain_constraint_def",
"domain_constraint_list : domain_constraint_list domain_constraint_def",
"domain_constraint_def : domain_constraint",
"domain_constraint : null_constraint",
"domain_constraint : check_constraint",
"null_constraint : NOT KW_NULL",
"check_constraint : CHECK begin_trigger '(' search_condition ')' end_trigger",
"generator_clause : symbol_generator_name",
"role_clause : symbol_role_name",
"collation_clause : symbol_collation_name FOR symbol_character_set_name collation_sequence_definition collation_attribute_list_opt collation_specific_attribute_opt",
"collation_sequence_definition : FROM symbol_collation_name",
"collation_sequence_definition : FROM EXTERNAL '(' sql_string ')'",
"collation_sequence_definition :",
"collation_attribute_list_opt :",
"collation_attribute_list_opt : collation_attribute_list",
"collation_attribute_list : collation_attribute",
"collation_attribute_list : collation_attribute_list collation_attribute",
"collation_attribute : collation_pad_attribute",
"collation_attribute : collation_case_attribute",
"collation_attribute : collation_accent_attribute",
"collation_pad_attribute : NO PAD",
"collation_pad_attribute : PAD SPACE",
"collation_case_attribute : CASE SENSITIVE",
"collation_case_attribute : CASE INSENSITIVE",
"collation_accent_attribute : ACCENT SENSITIVE",
"collation_accent_attribute : ACCENT INSENSITIVE",
"collation_specific_attribute_opt :",
"collation_specific_attribute_opt : sql_string",
"alter_charset_clause : symbol_character_set_name SET DEFAULT COLLATION symbol_collation_name",
"db_clause : db_name db_initial_desc1 db_rem_desc1",
"equals :",
"equals : '='",
"db_name : sql_string",
"db_initial_desc1 :",
"db_initial_desc1 : db_initial_desc",
"db_initial_desc : db_initial_option",
"db_initial_desc : db_initial_desc db_initial_option",
"db_initial_option : KW_PAGE_SIZE equals pos_short_integer",
"db_initial_option : LENGTH equals long_integer page_noise",
"db_initial_option : USER sql_string",
"db_initial_option : PASSWORD sql_string",
"db_initial_option : SET NAMES sql_string",
"db_rem_desc1 :",
"db_rem_desc1 : db_rem_desc",
"db_rem_desc : db_rem_option",
"db_rem_desc : db_rem_desc db_rem_option",
"db_rem_option : db_file",
"db_rem_option : DEFAULT CHARACTER SET symbol_character_set_name",
"db_rem_option : DEFAULT CHARACTER SET symbol_character_set_name COLLATION symbol_collation_name",
"db_rem_option : KW_DIFFERENCE KW_FILE sql_string",
"db_file : file1 sql_string file_desc1",
"file1 : KW_FILE",
"file_desc1 :",
"file_desc1 : file_desc",
"file_desc : file_clause",
"file_desc : file_desc file_clause",
"file_clause : STARTING file_clause_noise long_integer",
"file_clause : LENGTH equals long_integer page_noise",
"file_clause_noise :",
"file_clause_noise : AT",
"file_clause_noise : AT PAGE",
"page_noise :",
"page_noise : PAGE",
"page_noise : PAGES",
"table_clause : simple_table_name external_file '(' table_elements ')'",
"rtable_clause : simple_table_name external_file '(' table_elements ')'",
"gtt_table_clause : simple_table_name '(' table_elements ')' gtt_scope",
"gtt_recreate_clause : simple_table_name '(' table_elements ')' gtt_scope",
"gtt_scope : ON COMMIT PRESERVE ROWS",
"gtt_scope : ON COMMIT KW_DELETE ROWS",
"gtt_scope :",
"external_file : EXTERNAL KW_FILE sql_string",
"external_file : EXTERNAL sql_string",
"external_file :",
"table_elements : table_element",
"table_elements : table_elements ',' table_element",
"table_element : column_def",
"table_element : table_constraint_definition",
"column_def : column_def_name data_type_or_domain domain_default_opt column_constraint_clause collate_clause",
"column_def : column_def_name non_array_type def_computed",
"column_def : column_def_name def_computed",
"def_computed : computed_clause '(' begin_trigger value end_trigger ')'",
"computed_clause : computed_by",
"computed_clause : GENERATED ALWAYS AS",
"computed_by : COMPUTED BY",
"computed_by : COMPUTED",
"data_type_or_domain : data_type",
"data_type_or_domain : simple_column_name",
"collate_clause : COLLATE symbol_collation_name",
"collate_clause :",
"column_def_name : simple_column_name",
"simple_column_def_name : simple_column_name",
"data_type_descriptor : init_data_type data_type",
"data_type_descriptor : KW_TYPE OF column_def_name",
"data_type_descriptor : KW_TYPE OF COLUMN symbol_column_name '.' symbol_column_name",
"data_type_descriptor : column_def_name",
"init_data_type :",
"default_value : constant",
"default_value : current_user",
"default_value : current_role",
"default_value : internal_info",
"default_value : null_value",
"default_value : datetime_value_expression",
"column_constraint_clause :",
"column_constraint_clause : column_constraint_list",
"column_constraint_list : column_constraint_def",
"column_constraint_list : column_constraint_list column_constraint_def",
"column_constraint_def : constraint_name_opt column_constraint",
"column_constraint : null_constraint",
"column_constraint : check_constraint",
"column_constraint : REFERENCES simple_table_name column_parens_opt referential_trigger_action constraint_index_opt",
"column_constraint : UNIQUE constraint_index_opt",
"column_constraint : PRIMARY KEY constraint_index_opt",
"table_constraint_definition : constraint_name_opt table_constraint",
"constraint_name_opt : CONSTRAINT symbol_constraint_name",
"constraint_name_opt :",
"table_constraint : unique_constraint",
"table_constraint : primary_constraint",
"table_constraint : referential_constraint",
"table_constraint : check_constraint",
"unique_constraint : UNIQUE column_parens constraint_index_opt",
"primary_constraint : PRIMARY KEY column_parens constraint_index_opt",
"referential_constraint : FOREIGN KEY column_parens REFERENCES simple_table_name column_parens_opt referential_trigger_action constraint_index_opt",
"constraint_index_opt : USING order_direction INDEX symbol_index_name",
"constraint_index_opt :",
"referential_trigger_action : update_rule",
"referential_trigger_action : delete_rule",
"referential_trigger_action : delete_rule update_rule",
"referential_trigger_action : update_rule delete_rule",
"referential_trigger_action :",
"update_rule : ON UPDATE referential_action",
"delete_rule : ON KW_DELETE referential_action",
"referential_action : CASCADE",
"referential_action : SET DEFAULT",
"referential_action : SET KW_NULL",
"referential_action : NO ACTION",
"procedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string local_declaration_list full_proc_block end_trigger",
"rprocedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string local_declaration_list full_proc_block end_trigger",
"replace_procedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string local_declaration_list full_proc_block end_trigger",
"alter_procedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string local_declaration_list full_proc_block end_trigger",
"input_parameters : '(' input_proc_parameters ')'",
"input_parameters :",
"output_parameters : RETURNS '(' output_proc_parameters ')'",
"output_parameters :",
"input_proc_parameters : input_proc_parameter",
"input_proc_parameters : input_proc_parameters ',' input_proc_parameter",
"input_proc_parameter : simple_column_def_name domain_or_non_array_type collate_clause default_par_opt",
"output_proc_parameters : proc_parameter",
"output_proc_parameters : output_proc_parameters ',' proc_parameter",
"proc_parameter : simple_column_def_name domain_or_non_array_type collate_clause",
"default_par_opt : DEFAULT begin_trigger default_value end_default",
"default_par_opt : '=' begin_trigger default_value end_default",
"default_par_opt :",
"local_declaration_list : local_declarations",
"local_declaration_list :",
"local_declarations : local_declaration",
"local_declarations : local_declarations local_declaration",
"local_declaration : stmt_start_line stmt_start_column DECLARE var_decl_opt local_declaration_item ';'",
"local_declaration_item : var_declaration_item",
"local_declaration_item : cursor_declaration_item",
"var_declaration_item : column_def_name domain_or_non_array_type collate_clause default_par_opt",
"var_decl_opt : VARIABLE",
"var_decl_opt :",
"cursor_declaration_item : symbol_cursor_name CURSOR FOR '(' select ')'",
"proc_block : proc_statement",
"proc_block : full_proc_block",
"full_proc_block : stmt_start_line stmt_start_column BEGIN full_proc_block_body END",
"full_proc_block_body : proc_statements",
"full_proc_block_body : proc_statements excp_hndl_statements",
"full_proc_block_body :",
"proc_statements : proc_block",
"proc_statements : proc_statements proc_block",
"proc_statement : stmt_start_line stmt_start_column simple_proc_statement ';'",
"proc_statement : stmt_start_line stmt_start_column complex_proc_statement",
"stmt_start_line :",
"stmt_start_column :",
"simple_proc_statement : assignment",
"simple_proc_statement : insert",
"simple_proc_statement : merge",
"simple_proc_statement : update",
"simple_proc_statement : update_or_insert",
"simple_proc_statement : delete",
"simple_proc_statement : singleton_select",
"simple_proc_statement : exec_procedure",
"simple_proc_statement : exec_sql",
"simple_proc_statement : exec_into",
"simple_proc_statement : exec_function",
"simple_proc_statement : excp_statement",
"simple_proc_statement : raise_statement",
"simple_proc_statement : post_event",
"simple_proc_statement : cursor_statement",
"simple_proc_statement : breakleave",
"simple_proc_statement : SUSPEND",
"simple_proc_statement : EXIT",
"complex_proc_statement : in_autonomous_transaction",
"complex_proc_statement : if_then_else",
"complex_proc_statement : while",
"complex_proc_statement : for_select",
"complex_proc_statement : for_exec_into",
"in_autonomous_transaction : KW_IN AUTONOMOUS TRANSACTION DO proc_block",
"excp_statement : EXCEPTION symbol_exception_name",
"excp_statement : EXCEPTION symbol_exception_name value",
"raise_statement : EXCEPTION",
"for_select : label_opt FOR select INTO variable_list cursor_def DO proc_block",
"exec_sql : EXECUTE STATEMENT exec_stmt_inputs exec_stmt_options",
"exec_into : EXECUTE STATEMENT exec_stmt_inputs exec_stmt_options INTO variable_list",
"for_exec_into : label_opt FOR EXECUTE STATEMENT exec_stmt_inputs exec_stmt_options INTO variable_list DO proc_block",
"exec_stmt_inputs : value",
"exec_stmt_inputs : '(' value ')' '(' named_params_list ')'",
"exec_stmt_inputs : '(' value ')' '(' not_named_params_list ')'",
"named_params_list : named_param",
"named_params_list : named_params_list ',' named_param",
"named_param : symbol_variable_name BIND_PARAM value",
"not_named_params_list : not_named_param",
"not_named_params_list : not_named_params_list ',' not_named_param",
"not_named_param : value",
"exec_stmt_options : exec_stmt_options_list",
"exec_stmt_options :",
"exec_stmt_options_list : exec_stmt_options_list exec_stmt_option",
"exec_stmt_options_list : exec_stmt_option",
"exec_stmt_option : ext_datasrc",
"exec_stmt_option : ext_user",
"exec_stmt_option : ext_pwd",
"exec_stmt_option : ext_role",
"exec_stmt_option : ext_tran",
"exec_stmt_option : ext_privs",
"ext_datasrc : ON EXTERNAL DATA SOURCE value",
"ext_datasrc : ON EXTERNAL value",
"ext_user : AS USER value",
"ext_pwd : PASSWORD value",
"ext_role : ROLE value",
"ext_tran : WITH AUTONOMOUS TRANSACTION",
"ext_tran : WITH COMMON TRANSACTION",
"ext_privs : WITH CALLER PRIVILEGES",
"if_then_else : IF '(' search_condition ')' THEN proc_block ELSE proc_block",
"if_then_else : IF '(' search_condition ')' THEN proc_block",
"post_event : POST_EVENT value event_argument_opt",
"event_argument_opt :",
"singleton_select : select INTO variable_list",
"variable : ':' symbol_variable_name",
"variable_list : variable",
"variable_list : column_name",
"variable_list : variable_list ',' column_name",
"variable_list : variable_list ',' variable",
"while : label_opt WHILE '(' search_condition ')' DO proc_block",
"label_opt : symbol_label_name ':'",
"label_opt :",
"breakleave : KW_BREAK",
"breakleave : LEAVE",
"breakleave : LEAVE symbol_label_name",
"cursor_def : AS CURSOR symbol_cursor_name",
"cursor_def :",
"excp_hndl_statements : excp_hndl_statement",
"excp_hndl_statements : excp_hndl_statements excp_hndl_statement",
"excp_hndl_statement : WHEN errors DO proc_block",
"errors : err",
"errors : errors ',' err",
"err : SQLCODE signed_short_integer",
"err : GDSCODE symbol_gdscode_name",
"err : EXCEPTION symbol_exception_name",
"err : ANY",
"cursor_statement : open_cursor",
"cursor_statement : fetch_cursor",
"cursor_statement : close_cursor",
"open_cursor : OPEN symbol_cursor_name",
"close_cursor : CLOSE symbol_cursor_name",
"fetch_cursor : FETCH fetch_opt symbol_cursor_name INTO variable_list",
"fetch_opt :",
"exec_procedure : EXECUTE PROCEDURE symbol_procedure_name proc_inputs proc_outputs_opt",
"proc_inputs : value_list",
"proc_inputs : '(' value_list ')'",
"proc_inputs :",
"proc_outputs_opt : RETURNING_VALUES variable_list",
"proc_outputs_opt : RETURNING_VALUES '(' variable_list ')'",
"proc_outputs_opt :",
"exec_block : EXECUTE BLOCK block_input_params output_parameters AS local_declaration_list full_proc_block",
"block_input_params : '(' block_parameters ')'",
"block_input_params :",
"block_parameters : block_parameter",
"block_parameters : block_parameters ',' block_parameter",
"block_parameter : proc_parameter '=' parameter",
"view_clause : symbol_view_name column_parens_opt AS begin_string select_expr check_opt end_trigger",
"rview_clause : symbol_view_name column_parens_opt AS begin_string select_expr check_opt end_trigger",
"replace_view_clause : symbol_view_name column_parens_opt AS begin_string select_expr check_opt end_trigger",
"alter_view_clause : symbol_view_name column_parens_opt AS begin_string select_expr check_opt end_trigger",
"begin_string :",
"begin_trigger :",
"end_trigger :",
"end_default :",
"check_opt : WITH CHECK OPTION",
"check_opt :",
"trigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"trigger_clause : symbol_trigger_name FOR simple_table_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"trigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position ON simple_table_name trigger_action end_trigger",
"rtrigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"rtrigger_clause : symbol_trigger_name FOR simple_table_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"rtrigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position ON simple_table_name trigger_action end_trigger",
"replace_trigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"replace_trigger_clause : symbol_trigger_name FOR simple_table_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"replace_trigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position ON simple_table_name trigger_action end_trigger",
"trigger_active : ACTIVE",
"trigger_active : INACTIVE",
"trigger_active :",
"trigger_type : trigger_type_prefix trigger_type_suffix",
"trigger_type : ON trigger_db_type",
"trigger_db_type : CONNECT",
"trigger_db_type : DISCONNECT",
"trigger_db_type : TRANSACTION START",
"trigger_db_type : TRANSACTION COMMIT",
"trigger_db_type : TRANSACTION ROLLBACK",
"trigger_type_prefix : BEFORE",
"trigger_type_prefix : AFTER",
"trigger_type_suffix : INSERT",
"trigger_type_suffix : UPDATE",
"trigger_type_suffix : KW_DELETE",
"trigger_type_suffix : INSERT OR UPDATE",
"trigger_type_suffix : INSERT OR KW_DELETE",
"trigger_type_suffix : UPDATE OR INSERT",
"trigger_type_suffix : UPDATE OR KW_DELETE",
"trigger_type_suffix : KW_DELETE OR INSERT",
"trigger_type_suffix : KW_DELETE OR UPDATE",
"trigger_type_suffix : INSERT OR UPDATE OR KW_DELETE",
"trigger_type_suffix : INSERT OR KW_DELETE OR UPDATE",
"trigger_type_suffix : UPDATE OR INSERT OR KW_DELETE",
"trigger_type_suffix : UPDATE OR KW_DELETE OR INSERT",
"trigger_type_suffix : KW_DELETE OR INSERT OR UPDATE",
"trigger_type_suffix : KW_DELETE OR UPDATE OR INSERT",
"trigger_position : POSITION nonneg_short_integer",
"trigger_position :",
"trigger_action : AS begin_trigger local_declaration_list full_proc_block",
"alter : ALTER alter_clause",
"alter_clause : EXCEPTION alter_exception_clause",
"alter_clause : TABLE simple_table_name alter_ops",
"alter_clause : VIEW alter_view_clause",
"alter_clause : TRIGGER alter_trigger_clause",
"alter_clause : PROCEDURE alter_procedure_clause",
"alter_clause : DATABASE init_alter_db alter_db",
"alter_clause : DOMAIN alter_column_name alter_domain_ops",
"alter_clause : INDEX alter_index_clause",
"alter_clause : SEQUENCE alter_sequence_clause",
"alter_clause : EXTERNAL FUNCTION alter_udf_clause",
"alter_clause : ROLE alter_role_clause",
"alter_clause : USER alter_user_clause",
"alter_clause : CHARACTER SET alter_charset_clause",
"alter_domain_ops : alter_domain_op",
"alter_domain_ops : alter_domain_ops alter_domain_op",
"alter_domain_op : SET domain_default",
"alter_domain_op : ADD CONSTRAINT check_constraint",
"alter_domain_op : ADD check_constraint",
"alter_domain_op : DROP DEFAULT",
"alter_domain_op : DROP CONSTRAINT",
"alter_domain_op : TO simple_column_name",
"alter_domain_op : KW_TYPE init_data_type non_array_type",
"alter_ops : alter_op",
"alter_ops : alter_ops ',' alter_op",
"alter_op : DROP simple_column_name drop_behaviour",
"alter_op : DROP CONSTRAINT symbol_constraint_name",
"alter_op : ADD column_def",
"alter_op : ADD table_constraint_definition",
"alter_op : col_opt simple_column_name POSITION pos_short_integer",
"alter_op : col_opt alter_column_name TO simple_column_name",
"alter_op : col_opt alter_col_name KW_TYPE alter_data_type_or_domain",
"alter_op : col_opt alter_col_name KW_TYPE non_array_type def_computed",
"alter_op : col_opt alter_col_name def_computed",
"alter_op : col_opt alter_col_name SET domain_default",
"alter_op : col_opt alter_col_name DROP DEFAULT",
"alter_column_name : keyword_or_column",
"keyword_or_column : valid_symbol_name",
"keyword_or_column : ADMIN",
"keyword_or_column : COLUMN",
"keyword_or_column : EXTRACT",
"keyword_or_column : YEAR",
"keyword_or_column : MONTH",
"keyword_or_column : DAY",
"keyword_or_column : HOUR",
"keyword_or_column : MINUTE",
"keyword_or_column : SECOND",
"keyword_or_column : TIME",
"keyword_or_column : TIMESTAMP",
"keyword_or_column : CURRENT_DATE",
"keyword_or_column : CURRENT_TIME",
"keyword_or_column : CURRENT_TIMESTAMP",
"keyword_or_column : CURRENT_USER",
"keyword_or_column : CURRENT_ROLE",
"keyword_or_column : RECREATE",
"keyword_or_column : CURRENT_CONNECTION",
"keyword_or_column : CURRENT_TRANSACTION",
"keyword_or_column : BIGINT",
"keyword_or_column : CASE",
"keyword_or_column : RELEASE",
"keyword_or_column : ROW_COUNT",
"keyword_or_column : SAVEPOINT",
"keyword_or_column : OPEN",
"keyword_or_column : CLOSE",
"keyword_or_column : FETCH",
"keyword_or_column : ROWS",
"keyword_or_column : USING",
"keyword_or_column : CROSS",
"keyword_or_column : BIT_LENGTH",
"keyword_or_column : BOTH",
"keyword_or_column : CHAR_LENGTH",
"keyword_or_column : CHARACTER_LENGTH",
"keyword_or_column : COMMENT",
"keyword_or_column : LEADING",
"keyword_or_column : KW_LOWER",
"keyword_or_column : OCTET_LENGTH",
"keyword_or_column : TRAILING",
"keyword_or_column : TRIM",
"keyword_or_column : CONNECT",
"keyword_or_column : DISCONNECT",
"keyword_or_column : GLOBAL",
"keyword_or_column : INSENSITIVE",
"keyword_or_column : RECURSIVE",
"keyword_or_column : SENSITIVE",
"keyword_or_column : START",
"keyword_or_column : SIMILAR",
"keyword_or_column : SQLSTATE",
"keyword_or_column : LOCALTIME",
"keyword_or_column : LOCALTIMESTAMP",
"col_opt : ALTER",
"col_opt : ALTER COLUMN",
"alter_data_type_or_domain : non_array_type",
"alter_data_type_or_domain : simple_column_name",
"alter_col_name : simple_column_name",
"drop_behaviour : RESTRICT",
"drop_behaviour : CASCADE",
"drop_behaviour :",
"alter_index_clause : symbol_index_name ACTIVE",
"alter_index_clause : symbol_index_name INACTIVE",
"alter_sequence_clause : symbol_generator_name RESTART WITH signed_long_integer",
"alter_sequence_clause : symbol_generator_name RESTART WITH NUMBER64BIT",
"alter_sequence_clause : symbol_generator_name RESTART WITH '-' NUMBER64BIT",
"alter_udf_clause : symbol_UDF_name entry_op module_op",
"alter_role_clause : symbol_role_name alter_role_enable AUTO ADMIN MAPPING",
"alter_role_enable : SET",
"alter_role_enable : DROP",
"entry_op : ENTRY_POINT sql_string",
"entry_op :",
"module_op : MODULE_NAME sql_string",
"module_op :",
"init_alter_db :",
"alter_db : db_alter_clause",
"alter_db : alter_db db_alter_clause",
"db_alter_clause : ADD db_file_list",
"db_alter_clause : ADD KW_DIFFERENCE KW_FILE sql_string",
"db_alter_clause : DROP KW_DIFFERENCE KW_FILE",
"db_alter_clause : BEGIN BACKUP",
"db_alter_clause : END BACKUP",
"alter_trigger_clause : symbol_trigger_name trigger_active new_trigger_type trigger_position begin_trigger new_trigger_action end_trigger",
"new_trigger_type : trigger_type",
"new_trigger_type :",
"new_trigger_action : trigger_action",
"new_trigger_action :",
"drop : DROP drop_clause",
"drop_clause : EXCEPTION symbol_exception_name",
"drop_clause : INDEX symbol_index_name",
"drop_clause : PROCEDURE symbol_procedure_name",
"drop_clause : TABLE symbol_table_name",
"drop_clause : TRIGGER symbol_trigger_name",
"drop_clause : VIEW symbol_view_name",
"drop_clause : FILTER symbol_filter_name",
"drop_clause : DOMAIN symbol_domain_name",
"drop_clause : EXTERNAL FUNCTION symbol_UDF_name",
"drop_clause : SHADOW pos_short_integer",
"drop_clause : ROLE symbol_role_name",
"drop_clause : GENERATOR symbol_generator_name",
"drop_clause : SEQUENCE symbol_generator_name",
"drop_clause : COLLATION symbol_collation_name",
"drop_clause : USER drop_user_clause",
"data_type : non_array_type",
"data_type : array_type",
"domain_or_non_array_type : domain_or_non_array_type_name",
"domain_or_non_array_type : domain_or_non_array_type_name NOT KW_NULL",
"domain_or_non_array_type_name : non_array_type",
"domain_or_non_array_type_name : domain_type",
"domain_type : KW_TYPE OF symbol_column_name",
"domain_type : KW_TYPE OF COLUMN symbol_column_name '.' symbol_column_name",
"domain_type : symbol_column_name",
"non_array_type : simple_type",
"non_array_type : blob_type",
"array_type : non_charset_simple_type '[' array_spec ']'",
"array_type : character_type '[' array_spec ']' charset_clause",
"array_spec : array_range",
"array_spec : array_spec ',' array_range",
"array_range : signed_long_integer",
"array_range : signed_long_integer ':' signed_long_integer",
"simple_type : non_charset_simple_type",
"simple_type : character_type charset_clause",
"non_charset_simple_type : national_character_type",
"non_charset_simple_type : numeric_type",
"non_charset_simple_type : float_type",
"non_charset_simple_type : BIGINT",
"non_charset_simple_type : integer_keyword",
"non_charset_simple_type : SMALLINT",
"non_charset_simple_type : DATE",
"non_charset_simple_type : TIME",
"non_charset_simple_type : TIMESTAMP",
"integer_keyword : INTEGER",
"integer_keyword : KW_INT",
"blob_type : BLOB blob_subtype blob_segsize charset_clause",
"blob_type : BLOB '(' unsigned_short_integer ')'",
"blob_type : BLOB '(' unsigned_short_integer ',' signed_short_integer ')'",
"blob_type : BLOB '(' ',' signed_short_integer ')'",
"blob_segsize : SEGMENT KW_SIZE unsigned_short_integer",
"blob_segsize :",
"blob_subtype : SUB_TYPE signed_short_integer",
"blob_subtype : SUB_TYPE symbol_blob_subtype_name",
"blob_subtype :",
"charset_clause : CHARACTER SET symbol_character_set_name",
"charset_clause :",
"national_character_type : national_character_keyword '(' pos_short_integer ')'",
"national_character_type : national_character_keyword",
"national_character_type : national_character_keyword VARYING '(' pos_short_integer ')'",
"character_type : character_keyword '(' pos_short_integer ')'",
"character_type : character_keyword",
"character_type : varying_keyword '(' pos_short_integer ')'",
"varying_keyword : VARCHAR",
"varying_keyword : CHARACTER VARYING",
"varying_keyword : KW_CHAR VARYING",
"character_keyword : CHARACTER",
"character_keyword : KW_CHAR",
"national_character_keyword : NCHAR",
"national_character_keyword : NATIONAL CHARACTER",
"national_character_keyword : NATIONAL KW_CHAR",
"numeric_type : KW_NUMERIC prec_scale",
"numeric_type : decimal_keyword prec_scale",
"prec_scale :",
"prec_scale : '(' signed_long_integer ')'",
"prec_scale : '(' signed_long_integer ',' signed_long_integer ')'",
"decimal_keyword : DECIMAL",
"decimal_keyword : KW_DEC",
"float_type : KW_FLOAT precision_opt",
"float_type : KW_LONG KW_FLOAT precision_opt",
"float_type : REAL",
"float_type : KW_DOUBLE PRECISION",
"precision_opt : '(' nonneg_short_integer ')'",
"precision_opt :",
"set : set_transaction",
"set : set_generator",
"set : set_statistics",
"set_generator : SET GENERATOR symbol_generator_name TO signed_long_integer",
"set_generator : SET GENERATOR symbol_generator_name TO NUMBER64BIT",
"set_generator : SET GENERATOR symbol_generator_name TO '-' NUMBER64BIT",
"savepoint : set_savepoint",
"savepoint : release_savepoint",
"savepoint : undo_savepoint",
"set_savepoint : SAVEPOINT symbol_savepoint_name",
"release_savepoint : RELEASE SAVEPOINT symbol_savepoint_name release_only_opt",
"release_only_opt : ONLY",
"release_only_opt :",
"undo_savepoint : ROLLBACK optional_work TO optional_savepoint symbol_savepoint_name",
"optional_savepoint : SAVEPOINT",
"optional_savepoint :",
"commit : COMMIT optional_work optional_retain",
"dump : DUMP",
"rollback : ROLLBACK optional_work optional_retain",
"optional_work : WORK",
"optional_work :",
"optional_retain : RETAIN opt_snapshot",
"optional_retain :",
"opt_snapshot : SNAPSHOT",
"opt_snapshot :",
"set_transaction : SET TRANSACTION tran_opt_list_m",
"tran_opt_list_m : tran_opt_list",
"tran_opt_list_m :",
"tran_opt_list : tran_opt",
"tran_opt_list : tran_opt_list tran_opt",
"tran_opt : access_mode",
"tran_opt : lock_wait",
"tran_opt : isolation_mode",
"tran_opt : tra_misc_options",
"tran_opt : tra_timeout",
"tran_opt : tbl_reserve_options",
"access_mode : READ ONLY",
"access_mode : READ WRITE",
"lock_wait : WAIT",
"lock_wait : NO WAIT",
"isolation_mode : ISOLATION LEVEL iso_mode",
"isolation_mode : iso_mode",
"iso_mode : snap_shot",
"iso_mode : READ UNCOMMITTED version_mode",
"iso_mode : READ COMMITTED version_mode",
"snap_shot : SNAPSHOT",
"snap_shot : SNAPSHOT TABLE",
"snap_shot : SNAPSHOT TABLE STABILITY",
"version_mode : VERSION",
"version_mode : NO VERSION",
"version_mode :",
"tra_misc_options : NO AUTO UNDO",
"tra_misc_options : KW_IGNORE LIMBO",
"tra_misc_options : RESTART REQUESTS",
"tra_timeout : LOCK TIMEOUT nonneg_short_integer",
"tbl_reserve_options : RESERVING restr_list",
"lock_type : KW_SHARED",
"lock_type : PROTECTED",
"lock_type :",
"lock_mode : READ",
"lock_mode : WRITE",
"restr_list : restr_option",
"restr_list : restr_list ',' restr_option",
"restr_option : table_list table_lock",
"table_lock : FOR lock_type lock_mode",
"table_lock :",
"table_list : simple_table_name",
"table_list : table_list ',' simple_table_name",
"set_statistics : SET STATISTICS INDEX symbol_index_name",
"comment : COMMENT ON ddl_type0 IS ddl_desc",
"comment : COMMENT ON ddl_type1 symbol_ddl_name IS ddl_desc",
"comment : COMMENT ON ddl_type2 symbol_ddl_name ddl_subname IS ddl_desc",
"ddl_type0 : DATABASE",
"ddl_type1 : DOMAIN",
"ddl_type1 : TABLE",
"ddl_type1 : VIEW",
"ddl_type1 : PROCEDURE",
"ddl_type1 : TRIGGER",
"ddl_type1 : EXTERNAL FUNCTION",
"ddl_type1 : FILTER",
"ddl_type1 : EXCEPTION",
"ddl_type1 : GENERATOR",
"ddl_type1 : SEQUENCE",
"ddl_type1 : INDEX",
"ddl_type1 : ROLE",
"ddl_type1 : CHARACTER SET",
"ddl_type1 : COLLATION",
"ddl_type2 : COLUMN",
"ddl_type2 : PARAMETER",
"ddl_subname : '.' symbol_ddl_name",
"ddl_desc : sql_string",
"ddl_desc : KW_NULL",
"select : select_expr for_update_clause lock_clause",
"for_update_clause : FOR UPDATE for_update_list",
"for_update_clause :",
"for_update_list : OF column_list",
"for_update_list :",
"lock_clause : WITH LOCK",
"lock_clause :",
"select_expr : with_clause select_expr_body order_clause rows_clause",
"with_clause : WITH RECURSIVE with_list",
"with_clause : WITH with_list",
"with_clause :",
"with_list : with_item",
"with_list : with_item ',' with_list",
"with_item : symbol_table_alias_name derived_column_list AS '(' select_expr ')'",
"column_select : with_clause select_expr_body order_clause rows_clause",
"column_singleton : with_clause select_expr_body order_clause rows_clause",
"select_expr_body : query_term",
"select_expr_body : select_expr_body UNION distinct_noise query_term",
"select_expr_body : select_expr_body UNION ALL query_term",
"query_term : query_spec",
"query_spec : SELECT limit_clause distinct_clause select_list from_clause where_clause group_clause having_clause plan_clause",
"limit_clause : first_clause skip_clause",
"limit_clause : first_clause",
"limit_clause : skip_clause",
"limit_clause :",
"first_clause : FIRST long_integer",
"first_clause : FIRST '(' value ')'",
"first_clause : FIRST parameter",
"skip_clause : SKIP long_integer",
"skip_clause : SKIP '(' value ')'",
"skip_clause : SKIP parameter",
"distinct_clause : DISTINCT",
"distinct_clause : all_noise",
"select_list : select_items",
"select_list : '*'",
"select_items : select_item",
"select_items : select_items ',' select_item",
"select_item : value",
"select_item : value as_noise symbol_item_alias_name",
"as_noise : AS",
"as_noise :",
"from_clause : FROM from_list",
"from_list : table_reference",
"from_list : from_list ',' table_reference",
"table_reference : joined_table",
"table_reference : table_primary",
"table_primary : table_proc",
"table_primary : derived_table",
"table_primary : '(' joined_table ')'",
"derived_table : '(' select_expr ')' as_noise correlation_name derived_column_list",
"correlation_name : symbol_table_alias_name",
"correlation_name :",
"derived_column_list : '(' alias_list ')'",
"derived_column_list :",
"alias_list : symbol_item_alias_name",
"alias_list : alias_list ',' symbol_item_alias_name",
"joined_table : cross_join",
"joined_table : natural_join",
"joined_table : qualified_join",
"cross_join : table_reference CROSS JOIN table_primary",
"natural_join : table_reference NATURAL join_type JOIN table_primary",
"qualified_join : table_reference join_type JOIN table_reference join_specification",
"join_specification : join_condition",
"join_specification : named_columns_join",
"join_condition : ON search_condition",
"named_columns_join : USING '(' column_list ')'",
"table_proc : symbol_procedure_name table_proc_inputs as_noise symbol_table_alias_name",
"table_proc : symbol_procedure_name table_proc_inputs",
"table_proc_inputs : '(' value_list ')'",
"table_proc_inputs :",
"table_name : simple_table_name",
"table_name : symbol_table_name as_noise symbol_table_alias_name",
"simple_table_name : symbol_table_name",
"join_type : INNER",
"join_type : LEFT outer_noise",
"join_type : RIGHT outer_noise",
"join_type : FULL outer_noise",
"join_type :",
"outer_noise : OUTER",
"outer_noise :",
"group_clause : GROUP BY group_by_list",
"group_clause :",
"group_by_list : group_by_item",
"group_by_list : group_by_list ',' group_by_item",
"group_by_item : value",
"having_clause : HAVING search_condition",
"having_clause :",
"where_clause : WHERE search_condition",
"where_clause :",
"plan_clause : PLAN plan_expression",
"plan_clause :",
"plan_expression : plan_type '(' plan_item_list ')'",
"plan_type : JOIN",
"plan_type : SORT MERGE",
"plan_type : MERGE",
"plan_type : SORT",
"plan_type :",
"plan_item_list : plan_item",
"plan_item_list : plan_item ',' plan_item_list",
"plan_item : table_or_alias_list access_type",
"plan_item : plan_expression",
"table_or_alias_list : symbol_table_name",
"table_or_alias_list : symbol_table_name table_or_alias_list",
"access_type : NATURAL",
"access_type : INDEX '(' index_list ')'",
"access_type : ORDER symbol_index_name extra_indices_opt",
"index_list : symbol_index_name",
"index_list : symbol_index_name ',' index_list",
"extra_indices_opt : INDEX '(' index_list ')'",
"extra_indices_opt :",
"order_clause : ORDER BY order_list",
"order_clause :",
"order_list : order_item",
"order_list : order_list ',' order_item",
"order_item : value order_direction nulls_clause",
"order_direction : ASC",
"order_direction : DESC",
"order_direction :",
"nulls_clause : NULLS nulls_placement",
"nulls_clause :",
"nulls_placement : FIRST",
"nulls_placement : LAST",
"rows_clause : ROWS value",
"rows_clause : ROWS value TO value",
"rows_clause :",
"insert : INSERT INTO simple_table_name ins_column_parens_opt VALUES '(' value_list ')' returning_clause",
"insert : INSERT INTO simple_table_name ins_column_parens_opt select_expr returning_clause",
"insert : INSERT INTO simple_table_name DEFAULT VALUES returning_clause",
"merge : MERGE INTO table_name USING table_reference ON search_condition merge_when_clause",
"merge_when_clause : merge_when_matched_clause merge_when_not_matched_clause",
"merge_when_clause : merge_when_not_matched_clause merge_when_matched_clause",
"merge_when_clause : merge_when_matched_clause",
"merge_when_clause : merge_when_not_matched_clause",
"merge_when_matched_clause : WHEN MATCHED THEN merge_update_specification",
"merge_when_not_matched_clause : WHEN NOT MATCHED THEN merge_insert_specification",
"merge_update_specification : UPDATE SET assignments",
"merge_insert_specification : INSERT ins_column_parens_opt VALUES '(' value_list ')'",
"delete : delete_searched",
"delete : delete_positioned",
"delete_searched : KW_DELETE FROM table_name where_clause plan_clause order_clause rows_clause returning_clause",
"delete_positioned : KW_DELETE FROM table_name cursor_clause",
"update : update_searched",
"update : update_positioned",
"update_searched : UPDATE table_name SET assignments where_clause plan_clause order_clause rows_clause returning_clause",
"update_positioned : UPDATE table_name SET assignments cursor_clause",
"update_or_insert : UPDATE OR INSERT INTO simple_table_name ins_column_parens_opt VALUES '(' value_list ')' update_or_insert_matching_opt returning_clause",
"update_or_insert_matching_opt : MATCHING ins_column_parens",
"update_or_insert_matching_opt :",
"returning_clause : RETURNING value_list",
"returning_clause : RETURNING value_list INTO variable_list",
"returning_clause :",
"cursor_clause : WHERE CURRENT OF symbol_cursor_name",
"assignments : assignment",
"assignments : assignments ',' assignment",
"assignment : update_column_name '=' value",
"exec_function : udf",
"exec_function : non_aggregate_function",
"blob_io : READ BLOB simple_column_name FROM simple_table_name filter_clause_io segment_clause_io",
"blob_io : INSERT BLOB simple_column_name INTO simple_table_name filter_clause_io segment_clause_io",
"filter_clause_io : FILTER FROM blob_subtype_value_io TO blob_subtype_value_io",
"filter_clause_io : FILTER TO blob_subtype_value_io",
"filter_clause_io :",
"blob_subtype_value_io : blob_subtype_io",
"blob_subtype_value_io : parameter",
"blob_subtype_io : signed_short_integer",
"segment_clause_io : MAX_SEGMENT segment_length_io",
"segment_clause_io :",
"segment_length_io : unsigned_short_integer",
"segment_length_io : parameter",
"column_parens_opt : column_parens",
"column_parens_opt :",
"column_parens : '(' column_list ')'",
"column_list : simple_column_name",
"column_list : column_list ',' simple_column_name",
"ins_column_parens_opt : ins_column_parens",
"ins_column_parens_opt :",
"ins_column_parens : '(' ins_column_list ')'",
"ins_column_list : update_column_name",
"ins_column_list : ins_column_list ',' update_column_name",
"column_name : simple_column_name",
"column_name : symbol_table_alias_name '.' symbol_column_name",
"column_name : symbol_table_alias_name '.' '*'",
"simple_column_name : symbol_column_name",
"update_column_name : simple_column_name",
"update_column_name : symbol_table_alias_name '.' symbol_column_name",
"search_condition : predicate",
"search_condition : search_condition OR search_condition",
"search_condition : search_condition AND search_condition",
"search_condition : NOT search_condition",
"predicate : comparison_predicate",
"predicate : distinct_predicate",
"predicate : between_predicate",
"predicate : like_predicate",
"predicate : in_predicate",
"predicate : null_predicate",
"predicate : quantified_predicate",
"predicate : exists_predicate",
"predicate : containing_predicate",
"predicate : similar_predicate",
"predicate : starting_predicate",
"predicate : singular_predicate",
"predicate : trigger_action_predicate",
"predicate : '(' search_condition ')'",
"comparison_predicate : value '=' value",
"comparison_predicate : value '<' value",
"comparison_predicate : value '>' value",
"comparison_predicate : value GEQ value",
"comparison_predicate : value LEQ value",
"comparison_predicate : value NOT_GTR value",
"comparison_predicate : value NOT_LSS value",
"comparison_predicate : value NEQ value",
"quantified_predicate : value '=' ALL '(' column_select ')'",
"quantified_predicate : value '<' ALL '(' column_select ')'",
"quantified_predicate : value '>' ALL '(' column_select ')'",
"quantified_predicate : value GEQ ALL '(' column_select ')'",
"quantified_predicate : value LEQ ALL '(' column_select ')'",
"quantified_predicate : value NOT_GTR ALL '(' column_select ')'",
"quantified_predicate : value NOT_LSS ALL '(' column_select ')'",
"quantified_predicate : value NEQ ALL '(' column_select ')'",
"quantified_predicate : value '=' some '(' column_select ')'",
"quantified_predicate : value '<' some '(' column_select ')'",
"quantified_predicate : value '>' some '(' column_select ')'",
"quantified_predicate : value GEQ some '(' column_select ')'",
"quantified_predicate : value LEQ some '(' column_select ')'",
"quantified_predicate : value NOT_GTR some '(' column_select ')'",
"quantified_predicate : value NOT_LSS some '(' column_select ')'",
"quantified_predicate : value NEQ some '(' column_select ')'",
"some : SOME",
"some : ANY",
"distinct_predicate : value IS DISTINCT FROM value",
"distinct_predicate : value IS NOT DISTINCT FROM value",
"between_predicate : value BETWEEN value AND value",
"between_predicate : value NOT BETWEEN value AND value",
"like_predicate : value LIKE value",
"like_predicate : value NOT LIKE value",
"like_predicate : value LIKE value ESCAPE value",
"like_predicate : value NOT LIKE value ESCAPE value",
"in_predicate : value KW_IN in_predicate_value",
"in_predicate : value NOT KW_IN in_predicate_value",
"containing_predicate : value CONTAINING value",
"containing_predicate : value NOT CONTAINING value",
"similar_predicate : value SIMILAR TO value",
"similar_predicate : value NOT SIMILAR TO value",
"similar_predicate : value SIMILAR TO value ESCAPE value",
"similar_predicate : value NOT SIMILAR TO value ESCAPE value",
"starting_predicate : value STARTING value",
"starting_predicate : value NOT STARTING value",
"starting_predicate : value STARTING WITH value",
"starting_predicate : value NOT STARTING WITH value",
"exists_predicate : EXISTS '(' select_expr ')'",
"singular_predicate : SINGULAR '(' select_expr ')'",
"null_predicate : value IS KW_NULL",
"null_predicate : value IS NOT KW_NULL",
"trigger_action_predicate : INSERTING",
"trigger_action_predicate : UPDATING",
"trigger_action_predicate : DELETING",
"in_predicate_value : table_subquery",
"in_predicate_value : '(' value_list ')'",
"table_subquery : '(' column_select ')'",
"create_user_clause : symbol_user_name passwd_clause firstname_opt middlename_opt lastname_opt grant_admin_opt",
"alter_user_clause : symbol_user_name passwd_opt firstname_opt middlename_opt lastname_opt admin_opt",
"alter_user_clause : symbol_user_name SET passwd_opt firstname_opt middlename_opt lastname_opt admin_opt",
"drop_user_clause : symbol_user_name",
"passwd_clause : PASSWORD sql_string",
"passwd_opt : passwd_clause",
"passwd_opt :",
"firstname_opt : FIRSTNAME sql_string",
"firstname_opt :",
"middlename_opt : MIDDLENAME sql_string",
"middlename_opt :",
"lastname_opt : LASTNAME sql_string",
"lastname_opt :",
"admin_opt : revoke_admin",
"admin_opt : grant_admin",
"admin_opt :",
"grant_admin_opt : grant_admin",
"grant_admin_opt :",
"revoke_admin : REVOKE ADMIN ROLE",
"grant_admin : GRANT ADMIN ROLE",
"value : column_name",
"value : array_element",
"value : function",
"value : u_constant",
"value : parameter",
"value : variable",
"value : cast_specification",
"value : case_expression",
"value : next_value_expression",
"value : udf",
"value : '-' value",
"value : '+' value",
"value : value '+' value",
"value : value CONCATENATE value",
"value : value COLLATE symbol_collation_name",
"value : value '-' value",
"value : value '*' value",
"value : value '/' value",
"value : '(' value ')'",
"value : '(' column_singleton ')'",
"value : current_user",
"value : current_role",
"value : internal_info",
"value : DB_KEY",
"value : symbol_table_alias_name '.' DB_KEY",
"value : KW_VALUE",
"value : datetime_value_expression",
"value : null_value",
"datetime_value_expression : CURRENT_DATE",
"datetime_value_expression : CURRENT_TIME sec_precision_opt",
"datetime_value_expression : LOCALTIME sec_precision_opt",
"datetime_value_expression : CURRENT_TIMESTAMP sec_precision_opt",
"datetime_value_expression : LOCALTIMESTAMP sec_precision_opt",
"sec_precision_opt : '(' nonneg_short_integer ')'",
"sec_precision_opt :",
"array_element : column_name '[' value_list ']'",
"value_list_opt : value_list",
"value_list_opt :",
"value_list : value",
"value_list : value_list ',' value",
"constant : u_constant",
"constant : '-' u_numeric_constant",
"u_numeric_constant : NUMERIC",
"u_numeric_constant : NUMBER",
"u_numeric_constant : FLOAT_NUMBER",
"u_numeric_constant : NUMBER64BIT",
"u_numeric_constant : SCALEDINT",
"u_constant : u_numeric_constant",
"u_constant : sql_string",
"u_constant : DATE STRING",
"u_constant : TIME STRING",
"u_constant : TIMESTAMP STRING",
"parameter : '?'",
"current_user : USER",
"current_user : CURRENT_USER",
"current_role : CURRENT_ROLE",
"internal_info : CURRENT_CONNECTION",
"internal_info : CURRENT_TRANSACTION",
"internal_info : GDSCODE",
"internal_info : SQLCODE",
"internal_info : SQLSTATE",
"internal_info : ROW_COUNT",
"sql_string : STRING",
"sql_string : INTRODUCER STRING",
"signed_short_integer : nonneg_short_integer",
"signed_short_integer : '-' neg_short_integer",
"nonneg_short_integer : NUMBER",
"neg_short_integer : NUMBER",
"pos_short_integer : nonneg_short_integer",
"unsigned_short_integer : NUMBER",
"signed_long_integer : long_integer",
"signed_long_integer : '-' long_integer",
"long_integer : NUMBER",
"function : aggregate_function",
"function : non_aggregate_function",
"non_aggregate_function : numeric_value_function",
"non_aggregate_function : string_value_function",
"non_aggregate_function : system_function_expression",
"aggregate_function : COUNT '(' '*' ')'",
"aggregate_function : COUNT '(' all_noise value ')'",
"aggregate_function : COUNT '(' DISTINCT value ')'",
"aggregate_function : SUM '(' all_noise value ')'",
"aggregate_function : SUM '(' DISTINCT value ')'",
"aggregate_function : AVG '(' all_noise value ')'",
"aggregate_function : AVG '(' DISTINCT value ')'",
"aggregate_function : MINIMUM '(' all_noise value ')'",
"aggregate_function : MINIMUM '(' DISTINCT value ')'",
"aggregate_function : MAXIMUM '(' all_noise value ')'",
"aggregate_function : MAXIMUM '(' DISTINCT value ')'",
"aggregate_function : LIST '(' all_noise value delimiter_opt ')'",
"aggregate_function : LIST '(' DISTINCT value delimiter_opt ')'",
"delimiter_opt : ',' value",
"delimiter_opt :",
"numeric_value_function : extract_expression",
"numeric_value_function : length_expression",
"extract_expression : EXTRACT '(' timestamp_part FROM value ')'",
"length_expression : bit_length_expression",
"length_expression : char_length_expression",
"length_expression : octet_length_expression",
"bit_length_expression : BIT_LENGTH '(' value ')'",
"char_length_expression : CHAR_LENGTH '(' value ')'",
"char_length_expression : CHARACTER_LENGTH '(' value ')'",
"octet_length_expression : OCTET_LENGTH '(' value ')'",
"system_function_expression : system_function_std_syntax '(' value_list_opt ')'",
"system_function_expression : system_function_special_syntax",
"system_function_std_syntax : ABS",
"system_function_std_syntax : ACOS",
"system_function_std_syntax : ASCII_CHAR",
"system_function_std_syntax : ASCII_VAL",
"system_function_std_syntax : ASIN",
"system_function_std_syntax : ATAN",
"system_function_std_syntax : ATAN2",
"system_function_std_syntax : BIN_AND",
"system_function_std_syntax : BIN_NOT",
"system_function_std_syntax : BIN_OR",
"system_function_std_syntax : BIN_SHL",
"system_function_std_syntax : BIN_SHR",
"system_function_std_syntax : BIN_XOR",
"system_function_std_syntax : CEIL",
"system_function_std_syntax : CHAR_TO_UUID",
"system_function_std_syntax : COS",
"system_function_std_syntax : COSH",
"system_function_std_syntax : COT",
"system_function_std_syntax : EXP",
"system_function_std_syntax : FLOOR",
"system_function_std_syntax : GEN_UUID",
"system_function_std_syntax : HASH",
"system_function_std_syntax : LEFT",
"system_function_std_syntax : LN",
"system_function_std_syntax : LOG",
"system_function_std_syntax : LOG10",
"system_function_std_syntax : LPAD",
"system_function_std_syntax : MAXVALUE",
"system_function_std_syntax : MINVALUE",
"system_function_std_syntax : MOD",
"system_function_std_syntax : PI",
"system_function_std_syntax : POSITION",
"system_function_std_syntax : POWER",
"system_function_std_syntax : RAND",
"system_function_std_syntax : REPLACE",
"system_function_std_syntax : REVERSE",
"system_function_std_syntax : RIGHT",
"system_function_std_syntax : ROUND",
"system_function_std_syntax : RPAD",
"system_function_std_syntax : SIGN",
"system_function_std_syntax : SIN",
"system_function_std_syntax : SINH",
"system_function_std_syntax : SQRT",
"system_function_std_syntax : TAN",
"system_function_std_syntax : TANH",
"system_function_std_syntax : TRUNC",
"system_function_std_syntax : UUID_TO_CHAR",
"system_function_special_syntax : DATEADD '(' value timestamp_part TO value ')'",
"system_function_special_syntax : DATEADD '(' timestamp_part ',' value ',' value ')'",
"system_function_special_syntax : DATEDIFF '(' timestamp_part FROM value TO value ')'",
"system_function_special_syntax : DATEDIFF '(' timestamp_part ',' value ',' value ')'",
"system_function_special_syntax : OVERLAY '(' value PLACING value FROM value FOR value ')'",
"system_function_special_syntax : OVERLAY '(' value PLACING value FROM value ')'",
"system_function_special_syntax : POSITION '(' value KW_IN value ')'",
"string_value_function : substring_function",
"string_value_function : trim_function",
"string_value_function : KW_UPPER '(' value ')'",
"string_value_function : KW_LOWER '(' value ')'",
"substring_function : SUBSTRING '(' value FROM value string_length_opt ')'",
"string_length_opt : FOR value",
"string_length_opt :",
"trim_function : TRIM '(' trim_specification value FROM value ')'",
"trim_function : TRIM '(' value FROM value ')'",
"trim_function : TRIM '(' trim_specification FROM value ')'",
"trim_function : TRIM '(' value ')'",
"trim_specification : BOTH",
"trim_specification : TRAILING",
"trim_specification : LEADING",
"udf : symbol_UDF_call_name '(' value_list ')'",
"udf : symbol_UDF_call_name '(' ')'",
"cast_specification : CAST '(' value AS data_type_descriptor ')'",
"case_expression : case_abbreviation",
"case_expression : case_specification",
"case_abbreviation : NULLIF '(' value ',' value ')'",
"case_abbreviation : IIF '(' search_condition ',' value ',' value ')'",
"case_abbreviation : COALESCE '(' value ',' value_list ')'",
"case_abbreviation : DECODE '(' value ',' decode_pairs ')'",
"case_abbreviation : DECODE '(' value ',' decode_pairs ',' value ')'",
"case_specification : simple_case",
"case_specification : searched_case",
"simple_case : CASE case_operand simple_when_clause END",
"simple_case : CASE case_operand simple_when_clause ELSE case_result END",
"simple_when_clause : WHEN when_operand THEN case_result",
"simple_when_clause : simple_when_clause WHEN when_operand THEN case_result",
"searched_case : CASE searched_when_clause END",
"searched_case : CASE searched_when_clause ELSE case_result END",
"searched_when_clause : WHEN search_condition THEN case_result",
"searched_when_clause : searched_when_clause WHEN search_condition THEN case_result",
"when_operand : value",
"case_operand : value",
"case_result : value",
"decode_pairs : value ',' value",
"decode_pairs : decode_pairs ',' value ',' value",
"next_value_expression : NEXT KW_VALUE FOR symbol_generator_name",
"next_value_expression : GEN_ID '(' symbol_generator_name ',' value ')'",
"timestamp_part : YEAR",
"timestamp_part : MONTH",
"timestamp_part : DAY",
"timestamp_part : HOUR",
"timestamp_part : MINUTE",
"timestamp_part : SECOND",
"timestamp_part : MILLISECOND",
"timestamp_part : WEEK",
"timestamp_part : WEEKDAY",
"timestamp_part : YEARDAY",
"all_noise : ALL",
"all_noise :",
"distinct_noise : DISTINCT",
"distinct_noise :",
"null_value : KW_NULL",
"symbol_UDF_call_name : SYMBOL",
"symbol_UDF_name : valid_symbol_name",
"symbol_blob_subtype_name : valid_symbol_name",
"symbol_character_set_name : valid_symbol_name",
"symbol_collation_name : valid_symbol_name",
"symbol_column_name : valid_symbol_name",
"symbol_constraint_name : valid_symbol_name",
"symbol_cursor_name : valid_symbol_name",
"symbol_domain_name : valid_symbol_name",
"symbol_exception_name : valid_symbol_name",
"symbol_filter_name : valid_symbol_name",
"symbol_gdscode_name : valid_symbol_name",
"symbol_generator_name : valid_symbol_name",
"symbol_index_name : valid_symbol_name",
"symbol_item_alias_name : valid_symbol_name",
"symbol_label_name : valid_symbol_name",
"symbol_ddl_name : valid_symbol_name",
"symbol_procedure_name : valid_symbol_name",
"symbol_role_name : valid_symbol_name",
"symbol_table_alias_name : valid_symbol_name",
"symbol_table_name : valid_symbol_name",
"symbol_trigger_name : valid_symbol_name",
"symbol_user_name : valid_symbol_name",
"symbol_variable_name : valid_symbol_name",
"symbol_view_name : valid_symbol_name",
"symbol_savepoint_name : valid_symbol_name",
"valid_symbol_name : SYMBOL",
"valid_symbol_name : non_reserved_word",
"non_reserved_word : ACTION",
"non_reserved_word : CASCADE",
"non_reserved_word : FREE_IT",
"non_reserved_word : RESTRICT",
"non_reserved_word : ROLE",
"non_reserved_word : KW_TYPE",
"non_reserved_word : KW_BREAK",
"non_reserved_word : KW_DESCRIPTOR",
"non_reserved_word : SUBSTRING",
"non_reserved_word : COALESCE",
"non_reserved_word : LAST",
"non_reserved_word : LEAVE",
"non_reserved_word : LOCK",
"non_reserved_word : NULLIF",
"non_reserved_word : NULLS",
"non_reserved_word : STATEMENT",
"non_reserved_word : INSERTING",
"non_reserved_word : UPDATING",
"non_reserved_word : DELETING",
"non_reserved_word : FIRST",
"non_reserved_word : SKIP",
"non_reserved_word : BLOCK",
"non_reserved_word : BACKUP",
"non_reserved_word : KW_DIFFERENCE",
"non_reserved_word : IIF",
"non_reserved_word : SCALAR_ARRAY",
"non_reserved_word : WEEKDAY",
"non_reserved_word : YEARDAY",
"non_reserved_word : SEQUENCE",
"non_reserved_word : NEXT",
"non_reserved_word : RESTART",
"non_reserved_word : COLLATION",
"non_reserved_word : RETURNING",
"non_reserved_word : KW_IGNORE",
"non_reserved_word : LIMBO",
"non_reserved_word : UNDO",
"non_reserved_word : REQUESTS",
"non_reserved_word : TIMEOUT",
"non_reserved_word : ABS",
"non_reserved_word : ACCENT",
"non_reserved_word : ACOS",
"non_reserved_word : ALWAYS",
"non_reserved_word : ASCII_CHAR",
"non_reserved_word : ASCII_VAL",
"non_reserved_word : ASIN",
"non_reserved_word : ATAN",
"non_reserved_word : ATAN2",
"non_reserved_word : BIN_AND",
"non_reserved_word : BIN_OR",
"non_reserved_word : BIN_SHL",
"non_reserved_word : BIN_SHR",
"non_reserved_word : BIN_XOR",
"non_reserved_word : CEIL",
"non_reserved_word : COS",
"non_reserved_word : COSH",
"non_reserved_word : COT",
"non_reserved_word : DATEADD",
"non_reserved_word : DATEDIFF",
"non_reserved_word : DECODE",
"non_reserved_word : EXP",
"non_reserved_word : FLOOR",
"non_reserved_word : GEN_UUID",
"non_reserved_word : GENERATED",
"non_reserved_word : HASH",
"non_reserved_word : LIST",
"non_reserved_word : LN",
"non_reserved_word : LOG",
"non_reserved_word : LOG10",
"non_reserved_word : LPAD",
"non_reserved_word : MATCHED",
"non_reserved_word : MATCHING",
"non_reserved_word : MAXVALUE",
"non_reserved_word : MILLISECOND",
"non_reserved_word : MINVALUE",
"non_reserved_word : MOD",
"non_reserved_word : OVERLAY",
"non_reserved_word : PAD",
"non_reserved_word : PI",
"non_reserved_word : PLACING",
"non_reserved_word : POWER",
"non_reserved_word : PRESERVE",
"non_reserved_word : RAND",
"non_reserved_word : REPLACE",
"non_reserved_word : REVERSE",
"non_reserved_word : ROUND",
"non_reserved_word : RPAD",
"non_reserved_word : SIGN",
"non_reserved_word : SIN",
"non_reserved_word : SINH",
"non_reserved_word : SPACE",
"non_reserved_word : SQRT",
"non_reserved_word : TAN",
"non_reserved_word : TANH",
"non_reserved_word : TEMPORARY",
"non_reserved_word : TRUNC",
"non_reserved_word : WEEK",
"non_reserved_word : AUTONOMOUS",
"non_reserved_word : CHAR_TO_UUID",
"non_reserved_word : FIRSTNAME",
"non_reserved_word : MIDDLENAME",
"non_reserved_word : LASTNAME",
"non_reserved_word : MAPPING",
"non_reserved_word : OS_NAME",
"non_reserved_word : UUID_TO_CHAR",
"non_reserved_word : GRANTED",
"non_reserved_word : CALLER",
"non_reserved_word : COMMON",
"non_reserved_word : DATA",
"non_reserved_word : SOURCE",
"non_reserved_word : TWO_PHASE",
"non_reserved_word : BIN_NOT",
"non_reserved_word : ACTIVE",
"non_reserved_word : AFTER",
"non_reserved_word : ASC",
"non_reserved_word : AUTO",
"non_reserved_word : BEFORE",
"non_reserved_word : COMMITTED",
"non_reserved_word : COMPUTED",
"non_reserved_word : CONDITIONAL",
"non_reserved_word : CONTAINING",
"non_reserved_word : CSTRING",
"non_reserved_word : DATABASE",
"non_reserved_word : DESC",
"non_reserved_word : DO",
"non_reserved_word : DOMAIN",
"non_reserved_word : ENTRY_POINT",
"non_reserved_word : EXCEPTION",
"non_reserved_word : EXIT",
"non_reserved_word : KW_FILE",
"non_reserved_word : GENERATOR",
"non_reserved_word : GEN_ID",
"non_reserved_word : IF",
"non_reserved_word : INACTIVE",
"non_reserved_word : INPUT_TYPE",
"non_reserved_word : ISOLATION",
"non_reserved_word : KEY",
"non_reserved_word : LENGTH",
"non_reserved_word : LEVEL",
"non_reserved_word : MANUAL",
"non_reserved_word : MODULE_NAME",
"non_reserved_word : NAMES",
"non_reserved_word : OPTION",
"non_reserved_word : OUTPUT_TYPE",
"non_reserved_word : OVERFLOW",
"non_reserved_word : PAGE",
"non_reserved_word : PAGES",
"non_reserved_word : KW_PAGE_SIZE",
"non_reserved_word : PASSWORD",
"non_reserved_word : PRIVILEGES",
"non_reserved_word : PROTECTED",
"non_reserved_word : READ",
"non_reserved_word : RESERVING",
"non_reserved_word : RETAIN",
"non_reserved_word : SEGMENT",
"non_reserved_word : SHADOW",
"non_reserved_word : KW_SHARED",
"non_reserved_word : SINGULAR",
"non_reserved_word : KW_SIZE",
"non_reserved_word : SNAPSHOT",
"non_reserved_word : SORT",
"non_reserved_word : STABILITY",
"non_reserved_word : STARTING",
"non_reserved_word : STATISTICS",
"non_reserved_word : SUB_TYPE",
"non_reserved_word : SUSPEND",
"non_reserved_word : TRANSACTION",
"non_reserved_word : UNCOMMITTED",
"non_reserved_word : WAIT",
"non_reserved_word : WORK",
"non_reserved_word : WRITE",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif

#ifdef YYREDUCEPOSNFUNC
#define YYCALLREDUCEPOSN(e)   \
	if (reduce_posn) {     \
	  YYREDUCEPOSNFUNC(yyps->pos, &(yyps->psp)[1 - yym], &(yyps->vsp)[1 - yym], \
			   yym, yyps->psp - yyps->ps, yychar, yyposn, e);       \
	  reduce_posn = 0;    \
	}

#ifndef YYCALLREDUCEPOSNARG
#define YYCALLREDUCEPOSNARG yyps->val
#endif


#define YYPOSNARG(n) ((yyps->psp)[1 - yym + (n) - 1])
#define YYPOSNOUT    (yyps->pos)
#endif

// If delete function is not defined by the user, do not deletions.
#ifndef YYDELETEVAL
#define YYDELETEVAL(v, n) 
#endif

// If delete function is not defined by the user, do not deletions.
#ifndef YYDELETEPOSN
#define YYDELETEPOSN(v, n) 
#endif

#define yyclearin (yychar = (-1))

#define yyerrok (yyps->errflag = 0)

#ifndef YYSTACKGROWTH
#define YYSTACKGROWTH 16
#endif

#ifndef YYDEFSTACKSIZE
#define YYDEFSTACKSIZE 12
#endif

#ifdef YYDEBUG
int yydebug;
#endif


#define YYABORT  goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab
#define YYVALID         do { if (yyps->save)          goto yyvalid; } while(0)
#define YYVALID_NESTED  do { if (yyps->save && \
                                 yyps->save->save == 0) goto yyvalid; } while(0)
//
// For use in generated program
//
#define yytrial (yyps->save)
#define yyvsp   (yyps->vsp)
#define yyval   (yyps->val)
#define yydepth (yyps->ssp - yyps->ss)




/*
 *	PROGRAM:	Dynamic SQL runtime support
 *	MODULE:		lex.c
 *	DESCRIPTION:	Lexical routine
 *
 */


void LEX_dsql_init(MemoryPool& pool)
{
/**************************************
 *
 *	L E X _ d s q l _ i n i t
 *
 **************************************
 *
 * Functional description
 *	Initialize LEX for processing.  This is called only once
 *	per session.
 *
 **************************************/
	for (const TOK* token = KEYWORD_getTokens(); token->tok_string; ++token)
	{
		dsql_sym* symbol = FB_NEW_RPT(pool, 0) dsql_sym;
		symbol->sym_string = token->tok_string;
		symbol->sym_length = strlen(token->tok_string);
		symbol->sym_type = SYM_keyword;
		symbol->sym_keyword = token->tok_ident;
		symbol->sym_version = token->tok_version;
		dsql_str* str = FB_NEW_RPT(pool, symbol->sym_length) dsql_str;
		str->str_length = symbol->sym_length;
		strncpy(str->str_data, symbol->sym_string, symbol->sym_length);
		//str->str_data[str->str_length] = 0; Is it necessary?
		symbol->sym_object = (void *) str;
		HSHD_insert(symbol);
	}
}


const TEXT* Parser::lex_position()
{
/**************************************
 *
 *	l e x _ p o s i t i o n
 *
 **************************************
 *
 * Functional description
 *	Return the current position of LEX
 *	in the input string.
 *
 **************************************/

	return lex.ptr;
}


#ifdef NOT_USED_OR_REPLACED
static bool long_int(dsql_nod* string,
					 SLONG *long_value)
{
/*************************************
 *
 *	l o n g _ i n t
 *
 *************************************
 *
 * Functional description
 *	checks for all digits in the
 *	number and return an atol().
 *
 *************************************/

	const char* data = ((dsql_str*) string)->str_data;
	for (const UCHAR* p = (UCHAR*) data; true; p++)
	{
		if (!(classes(*p) & CHR_DIGIT)) {
			return false;
		}
	}

	*long_value = atol(data);

	return true;
}
#endif


static dsql_fld* make_field (dsql_nod* field_name)
{
/**************************************
 *
 *	m a k e _ f i e l d
 *
 **************************************
 *
 * Functional description
 *	Make a field block of given name.
 *
 **************************************/
	thread_db* tdbb = JRD_get_thread_data();

	if (field_name == NULL)
	{
		dsql_fld* field = FB_NEW(*tdbb->getDefaultPool())
			dsql_fld(*tdbb->getDefaultPool());
		field->fld_name = INTERNAL_FIELD_NAME;
		return field;
	}
	const dsql_str* string = (dsql_str*) field_name->nod_arg[1];
	dsql_fld* field = FB_NEW(*tdbb->getDefaultPool())
		dsql_fld(*tdbb->getDefaultPool());
	field->fld_name = string->str_data;
	field->fld_explicit_collation = false;
	field->fld_not_nullable = false;
	field->fld_full_domain = false;

	return field;
}


static dsql_fil* make_file()
{
/**************************************
 *
 *	m a k e _ f i l e
 *
 **************************************
 *
 * Functional description
 *	Make a file block
 *
 **************************************/
	thread_db* tdbb = JRD_get_thread_data();

	dsql_fil* temp_file = FB_NEW(*tdbb->getDefaultPool()) dsql_fil;

	return temp_file;
}


dsql_nod* Parser::make_list (dsql_nod* node)
{
/**************************************
 *
 *	m a k e _ l i s t
 *
 **************************************
 *
 * Functional description
 *	Collapse nested list nodes into single list.
 *
 **************************************/
	thread_db* tdbb = JRD_get_thread_data();

	if (node)
	{
		DsqlNodStack stack;
		stack_nodes(node, stack);
		USHORT l = stack.getCount();

		const dsql_nod* old = node;
		node = FB_NEW_RPT(*tdbb->getDefaultPool(), l) dsql_nod;
		node->nod_count = l;
		node->nod_type = nod_list;
		node->nod_line = (USHORT) lex.lines_bk;
		node->nod_column = (USHORT) (lex.last_token_bk - lex.line_start_bk + 1);
		if (old->getType() == dsql_type_nod)
		{
			node->nod_flags = old->nod_flags;
		}
		dsql_nod** ptr = node->nod_arg + node->nod_count;

		while (stack.hasData())
			*--ptr = stack.pop();
	}

	return node;
}


dsql_nod* Parser::make_parameter()
{
/**************************************
 *
 *	m a k e _ p a r a m e t e r
 *
 **************************************
 *
 * Functional description
 *	Make parameter node
 *	Any change should also be made to function below
 *
 **************************************/
	thread_db* tdbb = JRD_get_thread_data();

	dsql_nod* node = FB_NEW_RPT(*tdbb->getDefaultPool(), e_par_count) dsql_nod;
	node->nod_type = nod_parameter;
	node->nod_line = (USHORT) lex.lines_bk;
	node->nod_column = (USHORT) (lex.last_token_bk - lex.line_start_bk + 1);
	node->nod_count = e_par_count;
	node->nod_arg[e_par_index] = (dsql_nod*)(IPTR) lex.param_number++;

	return node;
}


dsql_nod* Parser::make_node(NOD_TYPE type, int count, ...)
{
/**************************************
 *
 *	m a k e _ n o d e
 *
 **************************************
 *
 * Functional description
 *	Make a node of given type.
 *	Any change should also be made to function below
 *
 **************************************/
	thread_db* tdbb = JRD_get_thread_data();

	dsql_nod* node = FB_NEW_RPT(*tdbb->getDefaultPool(), count) dsql_nod;
	node->nod_type = type;
	node->nod_line = (USHORT) lex.lines_bk;
	node->nod_column = (USHORT) (lex.last_token_bk - lex.line_start_bk + 1);
	node->nod_count = count;
	dsql_nod** p = node->nod_arg;
	va_list	ptr;
	va_start (ptr, count);

	while (--count >= 0)
		*p++ = va_arg (ptr, dsql_nod*);

	va_end(ptr);
	return node;
}


dsql_nod* Parser::makeClassNode(Node* node)
{
	return make_node(nod_class_node, 1, reinterpret_cast<dsql_nod*>(node));
}


dsql_nod* Parser::make_flag_node(NOD_TYPE type, SSHORT flag, int count, ...)
{
/**************************************
 *
 *	m a k e _ f l a g _ n o d e
 *
 **************************************
 *
 * Functional description
 *	Make a node of given type. Set flag field
 *
 **************************************/
	thread_db* tdbb = JRD_get_thread_data();

	dsql_nod* node = FB_NEW_RPT(*tdbb->getDefaultPool(), count) dsql_nod;
	node->nod_type = type;
	node->nod_flags = flag;
	node->nod_line = (USHORT) lex.lines_bk;
	node->nod_column = (USHORT) (lex.last_token_bk - lex.line_start_bk + 1);
	node->nod_count = count;
	dsql_nod** p = node->nod_arg;
	va_list	ptr;
	va_start (ptr, count);

	while (--count >= 0)
		*p++ = va_arg (ptr, dsql_nod*);

	va_end(ptr);
	return node;
}


#ifdef NOT_USED_OR_REPLACED
static bool short_int(dsql_nod* string,
					  SLONG *long_value,
					  SSHORT range)
{
/*************************************
 *
 *	s h o r t _ i n t
 *
 *************************************
 *
 * Functional description
 *	is the string a valid representation
 *	of a positive short int?
 *
 *************************************/

	if (((dsql_str*) string)->str_length > 5) {
		return false;
	}

	for (UCHAR* p = (UCHAR*)((dsql_str*) string)->str_data; true; p++)
	{
		if (!(classes(*p) & CHR_DIGIT)) {
			return false;
		}
	}

	/* there are 5 or fewer digits, it's value may still be greater
	 * than 32767... */

	SCHAR buf[10];
	buf[0] = ((dsql_str*) string)->str_data[0];
	buf[1] = ((dsql_str*) string)->str_data[1];
	buf[2] = ((dsql_str*) string)->str_data[2];
	buf[3] = ((dsql_str*) string)->str_data[3];
	buf[4] = ((dsql_str*) string)->str_data[4];
	buf[5] = '\0';

	*long_value = atoi (buf);

	bool return_value;

	switch (range)
	{
		case POSITIVE:
			return_value = *long_value > SHRT_POS_MAX;
			break;
		case NEGATIVE:
			return_value = *long_value > SHRT_NEG_MAX;
			break;
		case UNSIGNED:
			return_value = *long_value > SHRT_UNSIGNED_MAX;
			break;
	}
	return !return_value;
}
#endif

static void stack_nodes (dsql_nod*	node,
						 DsqlNodStack& stack)
{
/**************************************
 *
 *	s t a c k _ n o d e s
 *
 **************************************
 *
 * Functional description
 *	Assist in turning a tree of misc nodes into a clean list.
 *
 **************************************/
	if (node->nod_type != nod_list)
	{
		stack.push(node);
		return;
	}

	/* To take care of cases where long lists of nodes are in a chain
	   of list nodes with exactly one entry, this algorithm will look
	   for a pattern of repeated list nodes with two entries, the first
	   being a list node and the second being a non-list node.   Such
	   a list will be reverse linked, and then re-reversed, stacking the
	   non-list nodes in the process.   The purpose of this is to avoid
	   massive recursion of this function. */

	dsql_nod* start_chain = node;
	dsql_nod* end_chain = NULL;
	dsql_nod* curr_node = node;
	dsql_nod* next_node = node->nod_arg[0];
	while ( curr_node->nod_count == 2 &&
			curr_node->nod_arg[0]->nod_type == nod_list &&
			curr_node->nod_arg[1]->nod_type != nod_list &&
			next_node->nod_arg[0]->nod_type == nod_list &&
			next_node->nod_arg[1]->nod_type != nod_list)
	{

		/* pattern was found so reverse the links and go to next node */

		dsql_nod* save_link = next_node->nod_arg[0];
		next_node->nod_arg[0] = curr_node;
		curr_node = next_node;
		next_node = save_link;
		end_chain = curr_node;
	}

	/* see if any chain was found */

	if (end_chain)
	{

		/* first, handle the rest of the nodes */
		/* note that next_node still points to the first non-pattern node */

		stack_nodes (next_node, stack);

		/* stack the non-list nodes and reverse the chain on the way back */

		curr_node = end_chain;
		while (true)
		{
			stack.push(curr_node->nod_arg[1]);
			if ( curr_node == start_chain)
				break;
			dsql_nod* save_link = curr_node->nod_arg[0];
			curr_node->nod_arg[0] = next_node;
			next_node = curr_node;
			curr_node = save_link;
		}
		return;
	}

	dsql_nod** ptr = node->nod_arg;
	for (const dsql_nod* const* const end = ptr + node->nod_count; ptr < end; ptr++)
		stack_nodes (*ptr, stack);
}

static Firebird::MetaName toName(dsql_nod* node)
{
	return Firebird::MetaName(((dsql_str*) node)->str_data);
}

int Parser::yylex()
{
	lex.prev_keyword = yylexAux();
	return lex.prev_keyword;
}

int Parser::yylexAux()
{
/**************************************
 *
 *	y y l e x A u x
 *
 **************************************
 *
 * Functional description: lexer.
 *
 **************************************/
	UCHAR tok_class;
	char string[MAX_TOKEN_LEN];
	SSHORT c;

	/* Find end of white space and skip comments */

	for (;;)
	{
		if (lex.ptr >= lex.end)
			return -1;

		c = *lex.ptr++;

		/* Process comments */

		if (c == '\n') {
			lex.lines++;
			lex.line_start = lex.ptr;
			continue;
		}

		if (c == '-' && lex.ptr < lex.end && *lex.ptr == '-')
		{
			/* single-line */

			lex.ptr++;
			while (lex.ptr < lex.end) {
				if ((c = *lex.ptr++) == '\n') {
					lex.lines++;
					lex.line_start = lex.ptr /* + 1*/; /* CVC: +1 left out. */
					break;
				}
			}
			if (lex.ptr >= lex.end)
				return -1;
			continue;
		}
		else if (c == '/' && lex.ptr < lex.end && *lex.ptr == '*')
		{
			/* multi-line */

			const TEXT& start_block = lex.ptr[-1];
			lex.ptr++;
			while (lex.ptr < lex.end) {
				if ((c = *lex.ptr++) == '*') {
					if (*lex.ptr == '/')
						break;
				}
				if (c == '\n') {
					lex.lines++;
					lex.line_start = lex.ptr /* + 1*/; /* CVC: +1 left out. */

				}
			}
			if (lex.ptr >= lex.end)
			{
				// I need this to report the correct beginning of the block,
				// since it's not a token really.
				lex.last_token = &start_block;
				yyerror("unterminated block comment");
				return -1;
			}
			lex.ptr++;
			continue;
		}

		tok_class = classes(c);

		if (!(tok_class & CHR_WHITE))
			break;
	}

	/* Depending on tok_class of token, parse token */

	lex.last_token = lex.ptr - 1;

	if (tok_class & CHR_INTRODUCER)
	{
		/* The Introducer (_) is skipped, all other idents are copied
		 * to become the name of the character set
		 */
		char* p = string;
		for (; lex.ptr < lex.end && classes(*lex.ptr) & CHR_IDENT; lex.ptr++)
		{
			if (lex.ptr >= lex.end)
				return -1;
			check_copy_incr(p, UPPER7(*lex.ptr), string);
		}

		check_bound(p, string);
		*p = 0;

		/* make a string value to hold the name, the name
		 * is resolved in pass1_constant */

		yylval = (dsql_nod*) (MAKE_string(string, p - string))->str_data;

		return INTRODUCER;
	}

	/* parse a quoted string, being sure to look for double quotes */

	if (tok_class & CHR_QUOTE)
	{
		StrMark mark;
		mark.pos = lex.last_token - lex.start;

		char* buffer = string;
		size_t buffer_len = sizeof (string);
		const char* buffer_end = buffer + buffer_len - 1;
		char* p;
		for (p = buffer; ; ++p)
		{
			if (lex.ptr >= lex.end)
			{
				if (buffer != string)
					gds__free (buffer);
				yyerror("unterminated string");
				return -1;
			}
			// Care about multi-line constants and identifiers
			if (*lex.ptr == '\n') {
				lex.lines++;
				lex.line_start = lex.ptr + 1;
			}
			/* *lex.ptr is quote - if next != quote we're at the end */
			if ((*lex.ptr == c) && ((++lex.ptr == lex.end) || (*lex.ptr != c)))
				break;
			if (p > buffer_end)
			{
				char* const new_buffer = (char*) gds__alloc (2 * buffer_len);
			/* FREE: at outer block */
				if (!new_buffer)		/* NOMEM: */
				{
					if (buffer != string)
						gds__free (buffer);
					return -1;
				}
				memcpy (new_buffer, buffer, buffer_len);
				if (buffer != string)
					gds__free (buffer);
				buffer = new_buffer;
				p = buffer + buffer_len;
				buffer_len = 2 * buffer_len;
				buffer_end = buffer + buffer_len - 1;
			}
			*p = *lex.ptr++;
		}
		if (c == '"')
		{
			stmt_ambiguous = true; /* string delimited by double quotes could be
					**   either a string constant or a SQL delimited
					**   identifier, therefore marks the SQL
					**   statement as ambiguous  */
			if (client_dialect == SQL_DIALECT_V6_TRANSITION)
			{
				if (buffer != string)
					gds__free (buffer);
				yyabandon (-104, isc_invalid_string_constant);
			}
			else if (client_dialect >= SQL_DIALECT_V6)
			{
				if ((p - buffer) >= MAX_TOKEN_LEN)
				{
					if (buffer != string)
						gds__free (buffer);
					yyabandon (-104, isc_token_too_long);
				}
				yylval = (dsql_nod*) MAKE_string(buffer, p - buffer);
				dsql_str* delimited_id_str = (dsql_str*) yylval;
				delimited_id_str->type = dsql_str::TYPE_DELIMITED;
				if (buffer != string)
					gds__free (buffer);
				return SYMBOL;
			}
		}
		yylval = (dsql_nod*) MAKE_string(buffer, p - buffer);
		if (buffer != string)
			gds__free (buffer);

		mark.length = lex.ptr - lex.last_token;
		mark.str = (dsql_str*) yylval;
		strMarks.put(mark.str, mark);

		return STRING;
	}

/*
 * Check for a numeric constant, which starts either with a digit or with
 * a decimal point followed by a digit.
 *
 * This code recognizes the following token types:
 *
 * NUMBER: string of digits which fits into a 32-bit integer
 *
 * NUMBER64BIT: string of digits whose value might fit into an SINT64,
 *   depending on whether or not there is a preceding '-', which is to
 *   say that "9223372036854775808" is accepted here.
 *
 * SCALEDINT: string of digits and a single '.', where the digits
 *   represent a value which might fit into an SINT64, depending on
 *   whether or not there is a preceding '-'.
 *
 * FLOAT: string of digits with an optional '.', and followed by an "e"
 *   or "E" and an optionally-signed exponent.
 *
 * NOTE: we swallow leading or trailing blanks, but we do NOT accept
 *   embedded blanks:
 *
 * Another note: c is the first character which need to be considered,
 *   ptr points to the next character.
 */

	fb_assert(lex.ptr <= lex.end);

	// Hexadecimal string constant.  This is treated the same as a
	// string constant, but is defined as: X'bbbb'
	//
	// Where the X is a literal 'x' or 'X' character, followed
	// by a set of nibble values in single quotes.  The nibble
	// can be 0-9, a-f, or A-F, and is converted from the hex.
	// The number of nibbles should be even.
	//
	// The resulting value is stored in a string descriptor and
	// returned to the parser as a string.  This can be stored
	// in a character or binary item.
	if ((c == 'x' || c == 'X') && lex.ptr < lex.end && *lex.ptr == '\'')
	{
		bool hexerror = false;

		// Remember where we start from, to rescan later.
		// Also we'll need to know the length of the buffer.

		const char* hexstring = ++lex.ptr;
		int charlen = 0;

		// Time to scan the string. Make sure the characters are legal,
		// and find out how long the hex digit string is.

		for (;;)
		{
			if (lex.ptr >= lex.end)	// Unexpected EOS
			{
				hexerror = true;
				break;
			}

			c = *lex.ptr;

			if (c == '\'')			// Trailing quote, done
			{
				++lex.ptr;			// Skip the quote
				break;
			}

			if (!(classes(c) & CHR_HEX))	// Illegal character
			{
				hexerror = true;
				break;
			}

			++charlen;	// Okay, just count 'em
			++lex.ptr;	// and advance...
		}

		hexerror = hexerror || (charlen & 1);	// IS_ODD(charlen)

		// If we made it this far with no error, then convert the string.
		if (!hexerror)
		{
			// Figure out the length of the actual resulting hex string.
			// Allocate a second temporary buffer for it.

			Firebird::string temp;

			// Re-scan over the hex string we got earlier, converting
			// adjacent bytes into nibble values.  Every other nibble,
			// write the saved byte to the temp space.  At the end of
			// this, the temp.space area will contain the binary
			// representation of the hex constant.

			UCHAR byte = 0;
			for (int i = 0; i < charlen; i++)
			{
				c = UPPER7(hexstring[i]);

				// Now convert the character to a nibble

				if (c >= 'A')
					c = (c - 'A') + 10;
				else
					c = (c - '0');

				if (i & 1) // nibble?
				{
					byte = (byte << 4) + (UCHAR) c;
					temp.append(1, (char) byte);
				}
				else
					byte = c;
			}

			dsql_str* string = MAKE_string(temp.c_str(), temp.length());
			string->type = dsql_str::TYPE_HEXA;
			string->str_charset = "BINARY";
			yylval = (dsql_nod*) string;

			return STRING;
		}  // if (!hexerror)...

		// If we got here, there was a parsing error.  Set the
		// position back to where it was before we messed with
		// it.  Then fall through to the next thing we might parse.

		c = *lex.last_token;
		lex.ptr = lex.last_token + 1;
	}

	// Hexadecimal numeric constants - 0xBBBBBB
	//
	// where the '0' and the 'X' (or 'x') are literal, followed
	// by a set of nibbles, using 0-9, a-f, or A-F.  Odd numbers
	// of nibbles assume a leading '0'.  The result is converted
	// to an integer, and the result returned to the caller.  The
	// token is identified as a NUMBER if it's a 32-bit or less
	// value, or a NUMBER64INT if it requires a 64-bit number.
	if (c == '0' && lex.ptr + 1 < lex.end && (*lex.ptr == 'x' || *lex.ptr == 'X') &&
		(classes(lex.ptr[1]) & CHR_HEX))
	{
		bool hexerror = false;

		// Remember where we start from, to rescan later.
		// Also we'll need to know the length of the buffer.

		++lex.ptr;  // Skip the 'X' and point to the first digit
		const char* hexstring = lex.ptr;
		int charlen = 0;

		// Time to scan the string. Make sure the characters are legal,
		// and find out how long the hex digit string is.

		for (;;)
		{
			if (charlen == 0 && lex.ptr >= lex.end)			// Unexpected EOS
			{
				hexerror = true;
				break;
			}

			c = *lex.ptr;

			if (!(classes(c) & CHR_HEX))	// End of digit string
				break;

			++charlen;			// Okay, just count 'em
			++lex.ptr;			// and advance...

			if (charlen > 16)	// Too many digits...
			{
				hexerror = true;
				break;
			}
		}

		// we have a valid hex token. Now give it back, either as
		// an NUMBER or NUMBER64BIT.
		if (!hexerror)
		{
			// if charlen > 8 (something like FFFF FFFF 0, w/o the spaces)
			// then we have to return a NUMBER64BIT. We'll make a string
			// node here, and let make.cpp worry about converting the
			// string to a number and building the node later.
			if (charlen > 8)
			{
				char cbuff[32];
				cbuff[0] = 'X';
				strncpy(&cbuff[1], hexstring, charlen);
				cbuff[charlen + 1] = '\0';

				char* p = &cbuff[1];

				while (*p != '\0')
				{
					if ((*p >= 'a') && (*p <= 'f'))
						*p = UPPER(*p);
					p++;
				}

				yylval = (dsql_nod*) MAKE_string(cbuff, strlen(cbuff));
				return NUMBER64BIT;
			}
			else
			{
				// we have an integer value. we'll return NUMBER.
				// but we have to make a number value to be compatible
				// with existing code.

				// See if the string length is odd.  If so,
				// we'll assume a leading zero.  Then figure out the length
				// of the actual resulting hex string.  Allocate a second
				// temporary buffer for it.

				bool nibble = (charlen & 1);  // IS_ODD(temp.length)

				// Re-scan over the hex string we got earlier, converting
				// adjacent bytes into nibble values.  Every other nibble,
				// write the saved byte to the temp space.  At the end of
				// this, the temp.space area will contain the binary
				// representation of the hex constant.

				UCHAR byte = 0;
				SINT64 value = 0;

				for (int i = 0; i < charlen; i++)
				{
					c = UPPER(hexstring[i]);

					// Now convert the character to a nibble

					if (c >= 'A')
						c = (c - 'A') + 10;
					else
						c = (c - '0');

					if (nibble)
					{
						byte = (byte << 4) + (UCHAR) c;
						nibble = false;
						value = (value << 8) + byte;
					}
					else
					{
						byte = c;
						nibble = true;
					}
				}

				yylval = (dsql_nod*)(long) value;
				return NUMBER;
			} // integer value
		}  // if (!hexerror)...

		// If we got here, there was a parsing error.  Set the
		// position back to where it was before we messed with
		// it.  Then fall through to the next thing we might parse.

		c = *lex.last_token;
		lex.ptr = lex.last_token + 1;
	} // headecimal numeric constants

	if ((tok_class & CHR_DIGIT) ||
		((c == '.') && (lex.ptr < lex.end) && (classes(*lex.ptr) & CHR_DIGIT)))
	{
		/* The following variables are used to recognize kinds of numbers. */

		bool have_error	 = false;	/* syntax error or value too large */
		bool have_digit	 = false;	/* we've seen a digit			  */
		bool have_decimal   = false;	/* we've seen a '.'				*/
		bool have_exp	   = false;	/* digit ... [eE]				  */
		bool have_exp_sign  = false; /* digit ... [eE] {+-]			 */
		bool have_exp_digit = false; /* digit ... [eE] ... digit		*/
		FB_UINT64 number		= 0;
		FB_UINT64 limit_by_10	= MAX_SINT64 / 10;

		for (--lex.ptr; lex.ptr < lex.end; lex.ptr++)
		{
			c = *lex.ptr;
			if (have_exp_digit && (! (classes(c) & CHR_DIGIT)))
				/* First non-digit after exponent and digit terminates
				 the token. */
				break;
			else if (have_exp_sign && (! (classes(c) & CHR_DIGIT)))
			{
				/* only digits can be accepted after "1E-" */
				have_error = true;
				break;
			}
			else if (have_exp)
			{
				/* We've seen e or E, but nothing beyond that. */
				if ( ('-' == c) || ('+' == c) )
					have_exp_sign = true;
				else if ( classes(c) & CHR_DIGIT )
					/* We have a digit: we haven't seen a sign yet,
					but it's too late now. */
					have_exp_digit = have_exp_sign  = true;
				else
				{
					/* end of the token */
					have_error = true;
					break;
				}
			}
			else if ('.' == c)
			{
				if (!have_decimal)
					have_decimal = true;
				else
				{
					have_error = true;
					break;
				}
			}
			else if (classes(c) & CHR_DIGIT)
			{
				/* Before computing the next value, make sure there will be
				   no overflow.  */

				have_digit = true;

				if (number >= limit_by_10)
				{
				/* possibility of an overflow */
					if ((number > limit_by_10) || (c > '8'))
					{
						have_error = true;
						break;
					}
				}
				number = number * 10 + (c - '0');
			}
			else if ( (('E' == c) || ('e' == c)) && have_digit )
				have_exp = true;
			else
				/* Unexpected character: this is the end of the number. */
				break;
		}

		/* We're done scanning the characters: now return the right kind
		   of number token, if any fits the bill. */

		if (!have_error)
		{
			fb_assert(have_digit);

			if (have_exp_digit)
			{
				yylval = (dsql_nod*) MAKE_string(lex.last_token, lex.ptr - lex.last_token);
				lex.last_token_bk = lex.last_token;
				lex.line_start_bk = lex.line_start;
				lex.lines_bk = lex.lines;

				return FLOAT_NUMBER;
			}
			else if (!have_exp)
			{

				/* We should return some kind (scaled-) integer type
				   except perhaps in dialect 1. */

				if (!have_decimal && (number <= MAX_SLONG))
				{
					yylval = (dsql_nod*) (IPTR) number;
					//printf ("parse.y %p %d\n", yylval, number);
					return NUMBER;
				}
				else
				{
					/* We have either a decimal point with no exponent
					   or a string of digits whose value exceeds MAX_SLONG:
					   the returned type depends on the client dialect,
					   so warn of the difference if the client dialect is
					   SQL_DIALECT_V6_TRANSITION.
					*/

					if (SQL_DIALECT_V6_TRANSITION == client_dialect)
					{
						/* Issue a warning about the ambiguity of the numeric
						 * numeric literal.  There are multiple calls because
						 * the message text exceeds the 119-character limit
						 * of our message database.
						 */
						ERRD_post_warning(Arg::Warning(isc_dsql_warning_number_ambiguous) <<
										  Arg::Str(Firebird::string(lex.last_token, lex.ptr - lex.last_token)));
						ERRD_post_warning(Arg::Warning(isc_dsql_warning_number_ambiguous1));
					}

					yylval = (dsql_nod*) MAKE_string(lex.last_token, lex.ptr - lex.last_token);

					lex.last_token_bk = lex.last_token;
					lex.line_start_bk = lex.line_start;
					lex.lines_bk = lex.lines;

					if (client_dialect < SQL_DIALECT_V6_TRANSITION)
						return FLOAT_NUMBER;
					else if (have_decimal)
						return SCALEDINT;
					else
						return NUMBER64BIT;
				}
			} /* else if (!have_exp) */
		} /* if (!have_error) */

		/* we got some kind of error or overflow, so don't recognize this
		 * as a number: just pass it through to the next part of the lexer.
		 */
	}

	/* Restore the status quo ante, before we started our unsuccessful
	   attempt to recognize a number. */
	lex.ptr = lex.last_token;
	c   = *lex.ptr++;
	/* We never touched tok_class, so it doesn't need to be restored. */

	/* end of number-recognition code */


	if (tok_class & CHR_LETTER)
	{
		char* p = string;
		check_copy_incr(p, UPPER (c), string);
		for (; lex.ptr < lex.end && classes(*lex.ptr) & CHR_IDENT; lex.ptr++)
		{
			if (lex.ptr >= lex.end)
				return -1;
			check_copy_incr(p, UPPER (*lex.ptr), string);
		}

		check_bound(p, string);
		*p = 0;
		dsql_sym* sym =
			HSHD_lookup (NULL, string, (SSHORT)(p - string), SYM_keyword, parser_version);
		if (sym && (sym->sym_keyword != COMMENT || lex.prev_keyword == -1))
		{
			yylval = (dsql_nod*) sym->sym_object;
			lex.last_token_bk = lex.last_token;
			lex.line_start_bk = lex.line_start;
			lex.lines_bk = lex.lines;
			return sym->sym_keyword;
		}
		yylval = (dsql_nod*) MAKE_string(string, p - string);
		lex.last_token_bk = lex.last_token;
		lex.line_start_bk = lex.line_start;
		lex.lines_bk = lex.lines;
		return SYMBOL;
	}

	/* Must be punctuation -- test for double character punctuation */

	if (lex.last_token + 1 < lex.end)
	{
		dsql_sym* sym =
			HSHD_lookup (NULL, lex.last_token, (SSHORT) 2, SYM_keyword, (USHORT) parser_version);
		if (sym)
		{
			++lex.ptr;
			return sym->sym_keyword;
		}
	}

	/* Single character punctuation are simply passed on */

	return (UCHAR) c;
}


void Parser::yyerror_detailed(const TEXT*
#ifdef DEV_BUILD
										  error_string
#endif
													  , int yychar, YYSTYPE&, YYPOSN&)
{
/**************************************
 *
 *	y y e r r o r _ d e t a i l e d
 *
 **************************************
 *
 * Functional description
 *	Print a syntax error.
 *
 **************************************/
	const TEXT* line_start = lex.line_start;
	SLONG lines = lex.lines;
	if (lex.last_token < lex.line_start)
	{
		line_start = lex.line_start_bk;
		lines--;
	}

	if (yychar < 1)
	{
		ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
				  /* Unexpected end of command */
				  Arg::Gds(isc_command_end_err2) << Arg::Num(lines) <<
													Arg::Num(lex.last_token - line_start + 1)
#ifdef DEV_BUILD
				  << Arg::Gds(isc_random) << error_string
#endif
				  );
	}
	else
	{
		ERRD_post (Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
				  /* Token unknown - line %d, column %d */
				  Arg::Gds(isc_dsql_token_unk_err) << Arg::Num(lines) <<
				  									  Arg::Num(lex.last_token - line_start + 1) << /*CVC: +1*/
				  /* Show the token */
				  Arg::Gds(isc_random) << Arg::Str(string(lex.last_token, lex.ptr - lex.last_token)));
	}
}


void Parser::yyerror(const TEXT* error_string)
{
	YYSTYPE errt_value =  0;
	YYPOSN errt_posn = -1;
	yyerror_detailed(error_string, -1, errt_value, errt_posn);
}


static void yyabandon (SLONG		sql_code,
					   ISC_STATUS	error_symbol)
{
/**************************************
 *
 *	y y a b a n d o n
 *
 **************************************
 *
 * Functional description
 *	Abandon the parsing outputting the supplied string
 *
 **************************************/

	ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(sql_code) <<
			  Arg::Gds(error_symbol));
}


void Parser::yySCopy(YYSTYPE* to, YYSTYPE* from, int size)
{
  int i;                             
  for (i = size - 1; i >= 0; i--) {
    to[i] = from[i];
  }
}


void Parser::yyPCopy(YYPOSN* to, YYPOSN* from, int size)
{
  int i;                             
  for (i = size - 1; i >= 0; i--) {
    to[i] = from[i];
  }
}


void Parser::yyMoreStack(yyparsestate* yyps)
{
  int p = yyps->ssp - yyps->ss;                               
  Yshort  *tss = yyps->ss;
  YYSTYPE *tvs = yyps->vs;
  YYPOSN  *tps = yyps->ps;
  yyps->ss = new Yshort [yyps->stacksize + YYSTACKGROWTH];   
  yyps->vs = new YYSTYPE[yyps->stacksize + YYSTACKGROWTH];  
  yyps->ps = new YYPOSN [yyps->stacksize + YYSTACKGROWTH];  
  memcpy(yyps->ss, tss, yyps->stacksize * sizeof(Yshort));  
  yySCopy(yyps->vs, tvs, yyps->stacksize);
  yyPCopy(yyps->ps, tps, yyps->stacksize);
  yyps->stacksize += YYSTACKGROWTH;
  delete[] tss;
  delete[] tvs;
  delete[] tps;
  yyps->ssp = yyps->ss + p;                                   
  yyps->vsp = yyps->vs + p;                                   
  yyps->psp = yyps->ps + p;                                   
}


Parser::yyparsestate* Parser::yyNewState(int size)
{
  yyparsestate *p = new yyparsestate;
  p->stacksize = size + 4;
  p->ss = new Yshort [size + 4];
  p->vs = new YYSTYPE[size + 4];
  p->ps = new YYPOSN [size + 4];
  memset(&p->vs[0], 0, (size + 4) * sizeof(YYSTYPE));
  memset(&p->ps[0], 0, (size + 4) * sizeof(YYPOSN));
  return p;
}


void Parser::yyFreeState(Parser::yyparsestate* p)
{
  delete[] p->ss;
  delete[] p->vs;
  delete[] p->ps;
  delete p;
}


int Parser::parseAux()
{
  int yym, yyn, yystate, yychar, yynewerrflag;
  yyparsestate *yyerrctx = NULL;
  int reduce_posn;

#if YYDEBUG
  const char *yys;
  
  if ((yys = getenv("YYDEBUG"))) {
    yyn = *yys;
    if (yyn >= '0' && yyn <= '9')
      yydebug = yyn - '0'; 
  }
#endif
  
  yyps = yyNewState(YYDEFSTACKSIZE);
  yyps->save = 0;
  yynerrs = 0;
  yyps->errflag = 0;
  yychar = (-1);
  
  yyps->ssp = yyps->ss;
  yyps->vsp = yyps->vs;
  yyps->psp = yyps->ps;
  *(yyps->ssp) = yystate = 0;
  

  //
  // Main parsing loop
  //
 yyloop:
  if ((yyn = yydefred[yystate])) {
    goto yyreduce;
  }

  //
  // Read one token
  //
  if (yychar < 0) {
    if ((yychar = yylex1()) < 0) yychar = 0;
#if YYDEBUG
    if (yydebug) {
      yys = 0;
      if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
      if (!yys) yys = "illegal-symbol";
      printf("yydebug[%d,%p]: state %d, reading %d (%s)", 
	     int(yydepth), yytrial, yystate, yychar, yys);
#ifdef YYDBPR
      printf("<");
      YYDBPR(yylval);
      printf(">");
#endif
      printf("\n"); 
    }
#endif
  }

  //
  // Do we have a conflict?
  //
  if ((yyn = yycindex[yystate]) &&
      (yyn += yychar) >= 0 &&
      yyn <= YYTABLESIZE &&
      yycheck[yyn] == yychar) {
    int ctry;

    if (yypath) {
#if YYDEBUG
      if (yydebug) {
        printf("yydebug[%d,%p]: CONFLICT in state %d: following successful trial parse\n", 
	       int(yydepth), yytrial, yystate);
      }
#endif
      // Switch to the next conflict context
      yyparsestate *save = yypath;
      yypath = save->save;
      ctry = save->ctry;
      if (save->state != yystate) 
        goto yyabort;
      yyFreeState(save); 

    } else {

#if YYDEBUG
      if (yydebug) {
        printf("yydebug[%d,%p]: CONFLICT in state %d. ", 
	       int(yydepth), yytrial, yystate);
        if (yyps->save) {
          printf("ALREADY in conflict. Continue trial parse.");
        } else {
          printf("Start trial parse.");
        }
        printf("\n");
      }
#endif
      yyparsestate *save = yyNewState(yyps->ssp - yyps->ss);
      save->save    = yyps->save;
      save->state   = yystate;
      save->errflag = yyps->errflag;
      save->ssp     = save->ss + (yyps->ssp - yyps->ss);
      save->vsp     = save->vs + (yyps->vsp - yyps->vs);
      save->psp     = save->ps + (yyps->psp - yyps->ps);
      memcpy (save->ss, yyps->ss, (yyps->ssp - yyps->ss + 1) * sizeof(Yshort));
      yySCopy(save->vs, yyps->vs, (yyps->ssp - yyps->ss + 1));
      yyPCopy(save->ps, yyps->ps, (yyps->ssp - yyps->ss + 1));
      ctry = yytable[yyn];
      if (yyctable[ctry] == -1) {
#if YYDEBUG
        if (yydebug && yychar >= 0)
          printf("yydebug[%p]: backtracking 1 token\n", yytrial);
#endif
        ctry++; 
      }
      save->ctry = ctry;
      if (!yyps->save) {
        // If this is a first conflict in the stack, start saving lexemes
        if (!yylexemes) {
          yylexemes = new Yshort[YYSTACKGROWTH];
          yylvals = new YYSTYPE[YYSTACKGROWTH];
          yylvlim = yylvals + YYSTACKGROWTH; 
          yylpsns = new YYPOSN[YYSTACKGROWTH];
          yylplim = yylpsns + YYSTACKGROWTH; 
        }
        if (yylvp == yylve) {
          yylvp = yylve = yylvals;
	  yylpp = yylpe = yylpsns;
          yylexp = yylexemes;
          if (yychar >= 0) {
            *yylve++ = yylval;
            *yylpe++ = yyposn;
            *yylexp = yychar;
            yychar = -1; 
          } 
        } 
      }
      if (yychar >= 0) {
        yylvp--, yylpp--, yylexp--;
        yychar = -1; 
      }
      save->lexeme = yylvp - yylvals;
      yyps->save = save; 
    }
    if (yytable[yyn] == ctry) {
#if YYDEBUG
      if (yydebug)
        printf("yydebug[%d,%p]: state %d, shifting to state %d\n",
               int(yydepth), yytrial, yystate, yyctable[ctry]);
#endif
      if (yychar < 0)
        yylvp++, yylpp++, yylexp++;
      yychar = -1;
      if (yyps->errflag > 0) --yyps->errflag;
      yystate = yyctable[ctry];
      goto yyshift; 
    } else {
      yyn = yyctable[ctry];
      goto yyreduce; 
    } 
  }

  //
  // Is action a shift?
  //
  if ((yyn = yysindex[yystate]) &&
      (yyn += yychar) >= 0 &&
      yyn <= YYTABLESIZE &&
      yycheck[yyn] == yychar) {
#if YYDEBUG
    if (yydebug)
      printf("yydebug[%d,%p]: state %d, shifting to state %d\n",
             int(yydepth), yytrial, yystate, yytable[yyn]);
#endif
    yychar = (-1);
    if (yyps->errflag > 0)  --yyps->errflag;
    yystate = yytable[yyn];
  yyshift:
    if (yyps->ssp >= yyps->ss + yyps->stacksize - 1) {
      yyMoreStack(yyps);
    }
    *++(yyps->ssp) = yystate;
    *++(yyps->vsp) = yylval;
    *++(yyps->psp) = yyposn;
    goto yyloop;
  }
  if ((yyn = yyrindex[yystate]) &&
      (yyn += yychar) >= 0 &&
      yyn <= YYTABLESIZE &&
      yycheck[yyn] == yychar) {
    yyn = yytable[yyn];
    goto yyreduce;
  }

  //
  // Action: error
  //
  if (yyps->errflag) goto yyinrecovery;
  yynewerrflag = 1;
  goto yyerrhandler;
yyerrlab:
  yynewerrflag = 0;
yyerrhandler:
  while (yyps->save) { 
    int ctry; 
    yyparsestate *save = yyps->save;
#if YYDEBUG
    if (yydebug)
      printf("yydebug[%d,%p]: ERROR in state %d, CONFLICT BACKTRACKING to state %d, %d tokens\n",
             int(yydepth), yytrial, yystate, yyps->save->state, int(yylvp - yylvals - yyps->save->lexeme));
#endif
    // Memorize most forward-looking error state in case
    // it's really an error.
    if (yyerrctx == NULL || yyerrctx->lexeme < yylvp-yylvals) {
      // Free old saved error context state
      if (yyerrctx) yyFreeState(yyerrctx);
      // Create and fill out new saved error context state
      yyerrctx = yyNewState(yyps->ssp - yyps->ss);
      yyerrctx->save = yyps->save;
      yyerrctx->state = yystate;
      yyerrctx->errflag = yyps->errflag;
      yyerrctx->ssp = yyerrctx->ss + (yyps->ssp - yyps->ss);
      yyerrctx->vsp = yyerrctx->vs + (yyps->vsp - yyps->vs);
      yyerrctx->psp = yyerrctx->ps + (yyps->psp - yyps->ps);
      memcpy (yyerrctx->ss, yyps->ss, (yyps->ssp - yyps->ss + 1) * sizeof(Yshort));
      yySCopy(yyerrctx->vs, yyps->vs, (yyps->ssp - yyps->ss + 1));
      yyPCopy(yyerrctx->ps, yyps->ps, (yyps->ssp - yyps->ss + 1));
      yyerrctx->lexeme = yylvp - yylvals;
    }
    yylvp  = yylvals   + save->lexeme;
    yylpp  = yylpsns   + save->lexeme;
    yylexp = yylexemes + save->lexeme;
    yychar = -1;
    yyps->ssp = yyps->ss + (save->ssp - save->ss);
    yyps->vsp = yyps->vs + (save->vsp - save->vs);
    yyps->psp = yyps->ps + (save->psp - save->ps);
    memcpy (yyps->ss, save->ss, (yyps->ssp - yyps->ss + 1) * sizeof(Yshort));
    yySCopy(yyps->vs, save->vs,  yyps->vsp - yyps->vs + 1);
    yyPCopy(yyps->ps, save->ps,  yyps->psp - yyps->ps + 1);
    ctry = ++save->ctry;
    yystate = save->state;
    // We tried shift, try reduce now
    if ((yyn = yyctable[ctry]) >= 0) {
      goto yyreduce;
    }
    yyps->save = save->save;
    yyFreeState(save);
    //
    // Nothing left on the stack -- error
    //
    if (!yyps->save) {
#if YYDEBUG
      if (yydebug) {
        printf("yydebug[%p]: trial parse FAILED, entering ERROR mode\n", 
	       yytrial);
      }
#endif
      // Restore state as it was in the most forward-advanced error
      yylvp  = yylvals   + yyerrctx->lexeme;
      yylpp  = yylpsns   + yyerrctx->lexeme;
      yylexp = yylexemes + yyerrctx->lexeme;
      yychar = yylexp[-1];
      yylval = yylvp[-1];
      yyposn = yylpp[-1];
      yyps->ssp = yyps->ss + (yyerrctx->ssp - yyerrctx->ss);
      yyps->vsp = yyps->vs + (yyerrctx->vsp - yyerrctx->vs);
      yyps->psp = yyps->ps + (yyerrctx->psp - yyerrctx->ps);
      memcpy (yyps->ss, yyerrctx->ss, (yyps->ssp - yyps->ss + 1) * sizeof(Yshort));
      yySCopy(yyps->vs, yyerrctx->vs,  yyps->vsp - yyps->vs + 1);
      yyPCopy(yyps->ps, yyerrctx->ps,  yyps->psp - yyps->ps + 1);
      yystate = yyerrctx->state;
      yyFreeState(yyerrctx);
      yyerrctx = NULL;
    }
    yynewerrflag = 1; 
  }
  if (yynewerrflag) {
#ifdef YYERROR_DETAILED
    yyerror_detailed("syntax error", yychar, yylval, yyposn);
#else
    yyerror("syntax error");
#endif
  }
  ++yynerrs;
 yyinrecovery:
  if (yyps->errflag < 3) {
    yyps->errflag = 3;
    for (;;) {
      if ((yyn = yysindex[*(yyps->ssp)]) && 
	  (yyn += YYERRCODE) >= 0 &&
          yyn <= YYTABLESIZE && 
	  yycheck[yyn] == YYERRCODE) {
#if YYDEBUG
        if (yydebug)
          printf("yydebug[%d,%p]: state %d, ERROR recovery shifts to state %d\n",
                 int(yydepth), yytrial, *(yyps->ssp), yytable[yyn]);
#endif
        /* Use label yyerrlab, so that compiler does not warn */
        if (yyps->errflag != yyps->errflag) goto yyerrlab;
        yystate = yytable[yyn];
        goto yyshift; 
      } else {
#if YYDEBUG
        if (yydebug)
          printf("yydebug[%d,%p]: ERROR recovery discards state %d\n",
                 int(yydepth), yytrial, *(yyps->ssp));
#endif
        if (yyps->ssp <= yyps->ss) {
	  goto yyabort;
	}
	if (!yytrial) {
	  YYDELETEVAL(yyps->vsp[0], 1);
	  YYDELETEPOSN(yyps->psp[0], 1);
	}
        --(yyps->ssp);
        --(yyps->vsp);
        --(yyps->psp);
      }
    }
  } else {
    if (yychar == 0) goto yyabort;
#if YYDEBUG
    if (yydebug) {
      yys = 0;
      if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
      if (!yys) yys = "illegal-symbol";
      printf("yydebug[%d,%p]: state %d, ERROR recovery discards token %d (%s)\n",
             int(yydepth), yytrial, yystate, yychar, yys); 
    }
#endif
    if (!yytrial) {
      YYDELETEVAL(yylval, 0);
      YYDELETEPOSN(yyposn, 0);
    }
    yychar = (-1);
    goto yyloop;
  }

  //
  // Reduce the rule
  //
yyreduce:
  yym = yylen[yyn];
#if YYDEBUG
  if (yydebug) {
    printf("yydebug[%d,%p]: state %d, reducing by rule %d (%s)",
           int(yydepth), yytrial, yystate, yyn, yyrule[yyn]);
#ifdef YYDBPR
    if (yym) {
      int i;
      printf("<");
      for (i = yym; i > 0; i--) {
        if (i != yym) printf(", ");
        YYDBPR((yyps->vsp)[1 - i]);
      }
      printf(">");
    }
#endif
    printf("\n");
  }
#endif
  if (yyps->ssp + 1 - yym >= yyps->ss + yyps->stacksize) {
    yyMoreStack(yyps);
  }

  /* default action - assign last argument as in standard yacc */
  yyps->val = yyvsp[1 - yym];

  /* default reduced position is NULL -- no position at all.
     no position will be assigned at trial time and if no position handling is present */
  memset(&yyps->pos, 0, sizeof(yyps->pos));

  reduce_posn = TRUE;

  switch (yyn) {

case 1:
  if (!yytrial)
{ DSQL_parse = yyvsp[0]; }
break;
case 2:
  if (!yytrial)
{ DSQL_parse = yyvsp[-1]; }
break;
case 26:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) e_grant_count,
					yyvsp[-7], yyvsp[-4], make_list(yyvsp[-2]), yyvsp[-1], yyvsp[0]); }
break;
case 27:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) e_grant_count,
					yyvsp[-7], yyvsp[-4], make_list(yyvsp[-2]), yyvsp[-1], yyvsp[0]); }
break;
case 28:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) e_grant_count,
					make_list(yyvsp[-4]), make_list(yyvsp[-2]), NULL, yyvsp[-1], yyvsp[0]); }
break;
case 31:
  if (!yytrial)
{ yyval = make_node (nod_all, (int) 0, NULL); }
break;
case 32:
  if (!yytrial)
{ yyval = make_node (nod_all, (int) 0, NULL); }
break;
case 33:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 35:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 36:
  if (!yytrial)
{ yyval = make_list (make_node (nod_execute, (int) 0, NULL)); }
break;
case 37:
  if (!yytrial)
{ yyval = make_node (nod_select, (int) 0, NULL); }
break;
case 38:
  if (!yytrial)
{ yyval = make_node (nod_insert, (int) 0, NULL); }
break;
case 39:
  if (!yytrial)
{ yyval = make_node (nod_delete, (int) 0, NULL); }
break;
case 40:
  if (!yytrial)
{ yyval = make_node (nod_update, (int) 1, yyvsp[0]); }
break;
case 41:
  if (!yytrial)
{ yyval = make_node (nod_references, (int) 1, yyvsp[0]); }
break;
case 42:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) 0, NULL); }
break;
case 43:
  if (!yytrial)
{ yyval = NULL; }
break;
case 44:
  if (!yytrial)
{ yyval = make_node (nod_grant_admin, (int) 0, NULL); }
break;
case 45:
  if (!yytrial)
{ yyval = NULL; }
break;
case 46:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 47:
  if (!yytrial)
{ yyval = NULL; }
break;
case 50:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 51:
  if (!yytrial)
{ yyval = make_node (nod_procedure_name, (int) 1, yyvsp[0]); }
break;
case 52:
  if (!yytrial)
{ yyval = make_node (nod_revoke, (int) e_grant_count,
					yyvsp[-6], yyvsp[-3], make_list(yyvsp[-1]), yyvsp[-7], yyvsp[0]); }
break;
case 53:
  if (!yytrial)
{ yyval = make_node (nod_revoke, (int) e_grant_count,
					yyvsp[-6], yyvsp[-3], make_list(yyvsp[-1]), yyvsp[-7], yyvsp[0]); }
break;
case 54:
  if (!yytrial)
{ yyval = make_node (nod_revoke, (int) e_grant_count,
					make_list(yyvsp[-3]), make_list(yyvsp[-1]), NULL, yyvsp[-4], yyvsp[0]); }
break;
case 55:
  if (!yytrial)
{ yyval = make_node (nod_revoke, (int) e_grant_count,
					NULL, NULL, make_list(yyvsp[0]), NULL, NULL); }
break;
case 56:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) 0, NULL); }
break;
case 57:
  if (!yytrial)
{ yyval = NULL; }
break;
case 58:
  if (!yytrial)
{ yyval = make_node (nod_grant_admin, (int) 0, NULL); }
break;
case 59:
  if (!yytrial)
{ yyval = NULL; }
break;
case 63:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 64:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 65:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 66:
  if (!yytrial)
{ yyval = make_node (nod_proc_obj, (int) 1, yyvsp[0]); }
break;
case 67:
  if (!yytrial)
{ yyval = make_node (nod_trig_obj, (int) 1, yyvsp[0]); }
break;
case 68:
  if (!yytrial)
{ yyval = make_node (nod_view_obj, (int) 1, yyvsp[0]); }
break;
case 69:
  if (!yytrial)
{ yyval = make_node (nod_role_name, (int) 1, yyvsp[0]); }
break;
case 71:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 72:
  if (!yytrial)
{ yyval = make_node (nod_user_name, (int) 1, yyvsp[0]); }
break;
case 73:
  if (!yytrial)
{ yyval = make_node (nod_user_name, (int) 2, yyvsp[0], NULL); }
break;
case 74:
  if (!yytrial)
{ yyval = make_node (nod_user_group, (int) 1, yyvsp[0]); }
break;
case 76:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 77:
  if (!yytrial)
{ yyval = make_node (nod_role_name, (int) 1, yyvsp[0]); }
break;
case 79:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 80:
  if (!yytrial)
{ yyval = make_node (nod_user_name, (int) 1, yyvsp[0]); }
break;
case 81:
  if (!yytrial)
{ yyval = make_node (nod_user_name, (int) 1, yyvsp[0]); }
break;
case 82:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 83:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 84:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 85:
  if (!yytrial)
{ yyval = make_node (nod_def_udf, (int) e_udf_count,
				yyvsp[-7], yyvsp[-2], yyvsp[0], make_list (yyvsp[-6]), yyvsp[-4]); }
break;
case 87:
  if (!yytrial)
{ lex.g_field->fld_dtype = dtype_blob; }
break;
case 88:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_cstring;
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-2]; }
break;
case 89:
  if (!yytrial)
{ yyval = NULL; }
break;
case 91:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 93:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 94:
  if (!yytrial)
{ yyval = make_node (nod_udf_param, (int) e_udf_param_count,
							  yyvsp[-2], yyvsp[0]); }
break;
case 95:
  if (!yytrial)
{ yyval = NULL; }
break;
case 96:
  if (!yytrial)
{ yyval = MAKE_const_slong (FUN_descriptor); }
break;
case 97:
  if (!yytrial)
{ yyval = MAKE_const_slong (FUN_scalar_array); }
break;
case 98:
  if (!yytrial)
{ yyval = MAKE_const_slong (FUN_ref_with_null); }
break;
case 100:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 101:
  if (!yytrial)
{ yyval = make_node (nod_udf_return_value, (int) e_udf_param_count,
							  yyvsp[-2], yyvsp[0]); }
break;
case 102:
  if (!yytrial)
{ yyval = make_node (nod_udf_return_value, (int) e_udf_param_count,
				NULL, MAKE_const_slong ((IPTR) yyvsp[0]));}
break;
case 103:
  if (!yytrial)
{ yyval = MAKE_const_slong (FUN_reference); }
break;
case 104:
  if (!yytrial)
{ yyval = MAKE_const_slong (FUN_value); }
break;
case 105:
  if (!yytrial)
{ yyval = MAKE_const_slong (FUN_descriptor); }
break;
case 106:
  if (!yytrial)
{ yyval = MAKE_const_slong (-1 * FUN_reference); }
break;
case 107:
  if (!yytrial)
{ yyval = MAKE_const_slong (-1 * FUN_descriptor); }
break;
case 108:
  if (!yytrial)
{ yyval = make_node (nod_def_filter, (int) e_filter_count,
						yyvsp[-8], yyvsp[-6], yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 109:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_STRING); }
break;
case 110:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 111:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 112:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 113:
  if (!yytrial)
{ yyval = make_node (nod_def_index, (int) e_idx_count,
					yyvsp[-6], yyvsp[-5], yyvsp[-3], yyvsp[-1], yyvsp[0]); }
break;
case 114:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 115:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 116:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 117:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 118:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 119:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 120:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 121:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 122:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 123:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 124:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 125:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 126:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 127:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 128:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 129:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 130:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 131:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 132:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 133:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 134:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 135:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 136:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 137:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 138:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 139:
  if (!yytrial)
{ yyval = make_node (nod_def_exception, (int) e_xcp_count,
						yyvsp[-1], yyvsp[0]); }
break;
case 140:
  if (!yytrial)
{ yyval = make_node (nod_redef_exception, (int) e_xcp_count,
						yyvsp[-1], yyvsp[0]); }
break;
case 141:
  if (!yytrial)
{ yyval = make_node (nod_replace_exception, (int) e_xcp_count,
						yyvsp[-1], yyvsp[0]); }
break;
case 142:
  if (!yytrial)
{ yyval = make_node (nod_mod_exception, (int) e_xcp_count,
						yyvsp[-1], yyvsp[0]); }
break;
case 143:
  if (!yytrial)
{ yyval = make_node (nod_unique, 0, NULL); }
break;
case 144:
  if (!yytrial)
{ yyval = NULL; }
break;
case 145:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 147:
  if (!yytrial)
{ yyval = make_node (nod_def_computed, 2, yyvsp[-2], yyvsp[-1]); }
break;
case 148:
  if (!yytrial)
{ yyval = make_node (nod_def_shadow, (int) e_shadow_count,
				 yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], make_list (yyvsp[0])); }
break;
case 149:
  if (!yytrial)
{ yyval = MAKE_const_slong (1); }
break;
case 150:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 151:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 152:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 153:
  if (!yytrial)
{ yyval = MAKE_const_slong (1); }
break;
case 154:
  if (!yytrial)
{ yyval = (dsql_nod*) 0;}
break;
case 155:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 156:
  if (!yytrial)
{ yyval = NULL; }
break;
case 159:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 160:
  if (!yytrial)
{ yyval = make_node (nod_def_domain, (int) e_dom_count, yyvsp[-5], yyvsp[-2], make_list (yyvsp[-1]), yyvsp[0]); }
break;
case 161:
  if (!yytrial)
{ yyval = NULL; }
break;
case 162:
  if (!yytrial)
{ yyval = NULL; }
break;
case 163:
  if (!yytrial)
{ yyval = make_node (nod_def_default, (int) e_dft_count, yyvsp[-1], yyvsp[0]); }
break;
case 165:
  if (!yytrial)
{ yyval = NULL; }
break;
case 167:
  if (!yytrial)
{ yyval = NULL; }
break;
case 169:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 170:
  if (!yytrial)
{ yyval = make_node (nod_rel_constraint, (int) 2, NULL, yyvsp[0]);}
break;
case 173:
  if (!yytrial)
{ yyval = make_node (nod_null, (int) 0, NULL); }
break;
case 174:
  if (!yytrial)
{ yyval = make_node (nod_def_constraint, (int) e_cnstr_count,
					NULL, NULL, yyvsp[-2], NULL, yyvsp[0]); }
break;
case 175:
  if (!yytrial)
{ yyval = make_node (nod_def_generator, (int) e_gen_count, yyvsp[0]); }
break;
case 176:
  if (!yytrial)
{ yyval = make_node (nod_def_role, (int) 1, yyvsp[0]); }
break;
case 177:
  if (!yytrial)
{ yyval = make_node (nod_def_collation,
						(int) e_def_coll_count, yyvsp[-5], yyvsp[-3], yyvsp[-2], make_list(yyvsp[-1]), yyvsp[0]); }
break;
case 178:
  if (!yytrial)
{ yyval = make_node(nod_collation_from, 1, yyvsp[0]); }
break;
case 179:
  if (!yytrial)
{ yyval = make_node(nod_collation_from_external, 1, yyvsp[-1]); }
break;
case 180:
  if (!yytrial)
{ yyval = NULL; }
break;
case 181:
  if (!yytrial)
{ yyval = NULL; }
break;
case 184:
  if (!yytrial)
{ yyval = make_node(nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 188:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, -TEXTTYPE_ATTR_PAD_SPACE); }
break;
case 189:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, TEXTTYPE_ATTR_PAD_SPACE); }
break;
case 190:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, -TEXTTYPE_ATTR_CASE_INSENSITIVE); }
break;
case 191:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, TEXTTYPE_ATTR_CASE_INSENSITIVE); }
break;
case 192:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, -TEXTTYPE_ATTR_ACCENT_INSENSITIVE); }
break;
case 193:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, TEXTTYPE_ATTR_ACCENT_INSENSITIVE); }
break;
case 194:
  if (!yytrial)
{ yyval = NULL; }
break;
case 195:
  if (!yytrial)
{ yyval = make_node(nod_collation_specific_attr, 1,
				MAKE_constant((dsql_str*)yyvsp[0], CONSTANT_STRING)); }
break;
case 196:
  if (!yytrial)
{
			yyval = makeClassNode(FB_NEW(getPool())
					AlterCharSetNode(getPool(), toName(yyvsp[-4]), toName(yyvsp[0])));
		}
break;
case 197:
  if (!yytrial)
{ yyval = make_node (nod_def_database, (int) e_cdb_count,
				 yyvsp[-2], make_list(yyvsp[-1]), make_list (yyvsp[0]));}
break;
case 200:
  if (!yytrial)
{ yyval = (dsql_nod*) yyvsp[0]; }
break;
case 201:
  if (!yytrial)
{yyval = NULL;}
break;
case 204:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 205:
  if (!yytrial)
{ yyval = make_node (nod_page_size, 1, yyvsp[0]);}
break;
case 206:
  if (!yytrial)
{ yyval = make_node (nod_file_length, 1, yyvsp[-1]);}
break;
case 207:
  if (!yytrial)
{ yyval = make_node (nod_user_name, 1, yyvsp[0]);}
break;
case 208:
  if (!yytrial)
{ yyval = make_node (nod_password, 1, yyvsp[0]);}
break;
case 209:
  if (!yytrial)
{ yyval = make_node (nod_lc_ctype, 1, yyvsp[0]);}
break;
case 210:
  if (!yytrial)
{yyval = NULL;}
break;
case 213:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 215:
  if (!yytrial)
{ yyval = make_node (nod_dfl_charset, 1, yyvsp[0]);}
break;
case 216:
  if (!yytrial)
{ yyval = make_node (nod_list, 2,
				make_node (nod_dfl_charset, 1, yyvsp[-2]),
				make_node (nod_dfl_collate, 1, yyvsp[0]));
			}
break;
case 217:
  if (!yytrial)
{ yyval = make_node (nod_difference_file, 1, yyvsp[0]); }
break;
case 218:
  if (!yytrial)
{ lex.g_file->fil_name = (dsql_str*) yyvsp[-1];
			  yyval = (dsql_nod*) make_node (nod_file_desc, (int) 1,
						(dsql_nod*) lex.g_file); }
break;
case 219:
  if (!yytrial)
{ lex.g_file  = make_file();}
break;
case 224:
  if (!yytrial)
{ lex.g_file->fil_start = (IPTR) yyvsp[0];}
break;
case 225:
  if (!yytrial)
{ lex.g_file->fil_length = (IPTR) yyvsp[-1];}
break;
case 232:
  if (!yytrial)
{ yyval = make_flag_node (nod_def_relation, NOD_PERMANENT_TABLE,
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-1]), yyvsp[-3]); }
break;
case 233:
  if (!yytrial)
{ yyval = make_flag_node (nod_redef_relation, NOD_PERMANENT_TABLE,
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-1]), yyvsp[-3]); }
break;
case 234:
  if (!yytrial)
{ yyval = make_flag_node (nod_def_relation, (SSHORT) (IPTR) (yyvsp[0]),
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-2]), NULL); }
break;
case 235:
  if (!yytrial)
{ yyval = make_flag_node (nod_redef_relation, (SSHORT) (IPTR) (yyvsp[0]),
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-2]), NULL); }
break;
case 236:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_GLOBAL_TEMP_TABLE_PRESERVE_ROWS; }
break;
case 237:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_GLOBAL_TEMP_TABLE_DELETE_ROWS; }
break;
case 238:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_GLOBAL_TEMP_TABLE_DELETE_ROWS; }
break;
case 239:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 240:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 241:
  if (!yytrial)
{ yyval = NULL; }
break;
case 243:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 246:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count,
					yyvsp[-4], yyvsp[-2], make_list (yyvsp[-1]), yyvsp[0], yyvsp[-3], NULL); }
break;
case 247:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count,
					yyvsp[-2], NULL, NULL, NULL, NULL, yyvsp[0]); }
break;
case 248:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count,
					yyvsp[-1], NULL, NULL, NULL, NULL, yyvsp[0]); }
break;
case 249:
  if (!yytrial)
{
				lex.g_field->fld_flags |= FLD_computed;
				yyval = make_node (nod_def_computed, 2, yyvsp[-2], yyvsp[-1]);
			}
break;
case 254:
  if (!yytrial)
{ yyval = NULL; }
break;
case 255:
  if (!yytrial)
{ yyval = make_node (nod_def_domain, (int) e_dom_count, yyvsp[0], NULL, NULL, NULL); }
break;
case 256:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 257:
  if (!yytrial)
{ yyval = NULL; }
break;
case 258:
  if (!yytrial)
{
				lex.g_field_name = yyvsp[0];
				lex.g_field = make_field (yyvsp[0]);
				yyval = (dsql_nod*) lex.g_field;
			}
break;
case 259:
  if (!yytrial)
{
				lex.g_field = make_field (yyvsp[0]);
				yyval = (dsql_nod*) lex.g_field;
			}
break;
case 260:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 261:
  if (!yytrial)
{
				((dsql_fld*) yyvsp[0])->fld_type_of_name = ((dsql_fld*) yyvsp[0])->fld_name;
				yyval = yyvsp[0];
			}
break;
case 262:
  if (!yytrial)
{
				lex.g_field = make_field(NULL);
				lex.g_field->fld_type_of_table = ((dsql_str*) yyvsp[-2])->str_data;
				lex.g_field->fld_type_of_name = ((dsql_str*) yyvsp[0])->str_data;
				yyval = (dsql_nod*) lex.g_field;
			}
break;
case 263:
  if (!yytrial)
{
				((dsql_fld*) yyvsp[0])->fld_type_of_name = ((dsql_fld*) yyvsp[0])->fld_name;
				((dsql_fld*) yyvsp[0])->fld_full_domain = true;
				yyval = yyvsp[0];
			}
break;
case 264:
  if (!yytrial)
{ lex.g_field = make_field (NULL);
			  yyval = (dsql_nod*) lex.g_field; }
break;
case 271:
  if (!yytrial)
{ yyval = NULL; }
break;
case 274:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 275:
  if (!yytrial)
{ yyval = make_node (nod_rel_constraint, (int) 2, yyvsp[-1], yyvsp[0]);}
break;
case 278:
  if (!yytrial)
{ yyval = make_node (nod_foreign, (int) e_for_count,
						make_node (nod_list, (int) 1, lex.g_field_name), yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 279:
  if (!yytrial)
{ yyval = make_node (nod_unique, 2, NULL, yyvsp[0]); }
break;
case 280:
  if (!yytrial)
{ yyval = make_node (nod_primary, (int) e_pri_count, NULL, yyvsp[0]); }
break;
case 281:
  if (!yytrial)
{ yyval = make_node (nod_rel_constraint, (int) 2, yyvsp[-1], yyvsp[0]);}
break;
case 282:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 283:
  if (!yytrial)
{ yyval = NULL; }
break;
case 288:
  if (!yytrial)
{ yyval = make_node (nod_unique, 2, yyvsp[-1], yyvsp[0]); }
break;
case 289:
  if (!yytrial)
{ yyval = make_node (nod_primary, (int) e_pri_count, yyvsp[-1], yyvsp[0]); }
break;
case 290:
  if (!yytrial)
{ yyval = make_node (nod_foreign, (int) e_for_count, yyvsp[-5], yyvsp[-3],
					 yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 291:
  if (!yytrial)
{ yyval = make_node (nod_def_index, (int) e_idx_count,
					NULL, yyvsp[-2], yyvsp[0], NULL, NULL); }
break;
case 292:
  if (!yytrial)
{ yyval = make_node (nod_def_index, (int) e_idx_count,
					NULL, NULL, NULL, NULL, NULL); }
break;
case 293:
  if (!yytrial)
{ yyval = make_node (nod_ref_upd_del, (int) e_ref_upd_del_count, yyvsp[0], NULL);}
break;
case 294:
  if (!yytrial)
{ yyval = make_node (nod_ref_upd_del, (int) e_ref_upd_del_count, NULL, yyvsp[0]);}
break;
case 295:
  if (!yytrial)
{ yyval = make_node (nod_ref_upd_del, (int) e_ref_upd_del_count, yyvsp[0], yyvsp[-1]); }
break;
case 296:
  if (!yytrial)
{ yyval = make_node (nod_ref_upd_del, (int) e_ref_upd_del_count, yyvsp[-1], yyvsp[0]);}
break;
case 297:
  if (!yytrial)
{ yyval = NULL;}
break;
case 298:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 299:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 300:
  if (!yytrial)
{ yyval = make_flag_node (nod_ref_trig_action,
			 REF_ACTION_CASCADE, (int) e_ref_trig_action_count, NULL);}
break;
case 301:
  if (!yytrial)
{ yyval = make_flag_node (nod_ref_trig_action,
			 REF_ACTION_SET_DEFAULT, (int) e_ref_trig_action_count, NULL);}
break;
case 302:
  if (!yytrial)
{ yyval = make_flag_node (nod_ref_trig_action,
			 REF_ACTION_SET_NULL, (int) e_ref_trig_action_count, NULL);}
break;
case 303:
  if (!yytrial)
{ yyval = make_flag_node (nod_ref_trig_action,
			 REF_ACTION_NONE, (int) e_ref_trig_action_count, NULL);}
break;
case 304:
  if (!yytrial)
{ yyval = make_node (nod_def_procedure,
						(int) e_prc_count, yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 305:
  if (!yytrial)
{ yyval = make_node (nod_redef_procedure,
						(int) e_prc_count, yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 306:
  if (!yytrial)
{ yyval = make_node (nod_replace_procedure,
						(int) e_prc_count, yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 307:
  if (!yytrial)
{ yyval = make_node (nod_mod_procedure,
						(int) e_prc_count, yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 308:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 309:
  if (!yytrial)
{ yyval = NULL; }
break;
case 310:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 311:
  if (!yytrial)
{ yyval = NULL; }
break;
case 313:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 314:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count,
				yyvsp[-3], yyvsp[0], NULL, yyvsp[-1], NULL, NULL); }
break;
case 316:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 317:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count,
				yyvsp[-2], NULL, NULL, yyvsp[0], NULL, NULL); }
break;
case 318:
  if (!yytrial)
{ yyval = make_node (nod_def_default, (int) e_dft_count, yyvsp[-1], yyvsp[0]); }
break;
case 319:
  if (!yytrial)
{ yyval = make_node (nod_def_default, (int) e_dft_count, yyvsp[-1], yyvsp[0]); }
break;
case 320:
  if (!yytrial)
{ yyval = NULL; }
break;
case 321:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 322:
  if (!yytrial)
{ yyval = NULL; }
break;
case 324:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 325:
  if (!yytrial)
{
				yyval = yyvsp[-1];
				yyval->nod_line = (IPTR) yyvsp[-5];
				yyval->nod_column = (IPTR) yyvsp[-4];
			}
break;
case 328:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count,
				yyvsp[-3], yyvsp[0], NULL, yyvsp[-1], NULL, NULL); }
break;
case 329:
  if (!yytrial)
{ yyval = NULL; }
break;
case 330:
  if (!yytrial)
{ yyval = NULL; }
break;
case 331:
  if (!yytrial)
{ yyval = make_flag_node (nod_cursor, NOD_CURSOR_EXPLICIT,
				(int) e_cur_count, yyvsp[-5], yyvsp[-1], NULL, NULL); }
break;
case 334:
  if (!yytrial)
{
				yyval = make_node (nod_src_info, e_src_info_count, yyvsp[-4], yyvsp[-3], yyvsp[-1]);
			}
break;
case 335:
  if (!yytrial)
{ yyval = make_node (nod_block, (int) e_blk_count, make_list (yyvsp[0]), NULL); }
break;
case 336:
  if (!yytrial)
{ yyval = make_node (nod_block, (int) e_blk_count, make_list (yyvsp[-1]), make_list (yyvsp[0])); }
break;
case 337:
  if (!yytrial)
{ yyval = make_node (nod_block, (int) e_blk_count, NULL, NULL);}
break;
case 339:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 340:
  if (!yytrial)
{
				yyval = make_node (nod_src_info, e_src_info_count, yyvsp[-3], yyvsp[-2], yyvsp[-1]);
			}
break;
case 341:
  if (!yytrial)
{
				yyval = make_node (nod_src_info, e_src_info_count, yyvsp[-2], yyvsp[-1], yyvsp[0]);
			}
break;
case 342:
  if (!yytrial)
{ yyval = (dsql_nod*) (IPTR) lex.lines_bk; }
break;
case 343:
  if (!yytrial)
{
			const USHORT column = (lex.last_token_bk - lex.line_start_bk + 1);
			yyval = (dsql_nod*) (IPTR) column;
		}
break;
case 360:
  if (!yytrial)
{ yyval = make_node (nod_return, (int) e_rtn_count, NULL); }
break;
case 361:
  if (!yytrial)
{ yyval = make_node (nod_exit, 0, NULL); }
break;
case 367:
  if (!yytrial)
{
			InAutonomousTransactionNode* node = FB_NEW(getPool())
				InAutonomousTransactionNode(getPool());
			node->dsqlAction = yyvsp[0];
			yyval = makeClassNode(node);
		}
break;
case 368:
  if (!yytrial)
{ yyval = make_node (nod_exception_stmt, (int) e_xcp_count, yyvsp[0], NULL); }
break;
case 369:
  if (!yytrial)
{ yyval = make_node (nod_exception_stmt, (int) e_xcp_count, yyvsp[-1], yyvsp[0]); }
break;
case 370:
  if (!yytrial)
{ yyval = make_node (nod_exception_stmt, (int) e_xcp_count, NULL, NULL); }
break;
case 371:
  if (!yytrial)
{ yyval = make_node (nod_for_select, (int) e_flp_count, yyvsp[-5],
					  make_list (yyvsp[-3]), yyvsp[-2], yyvsp[0], yyvsp[-7]); }
break;
case 372:
  if (!yytrial)
{
			yyval = make_node (nod_exec_stmt, int (e_exec_stmt_count),
					(yyvsp[-1])->nod_arg[0], (yyvsp[-1])->nod_arg[1], NULL, NULL, NULL, make_list(yyvsp[0]), NULL, NULL, NULL, NULL, NULL, NULL);
		}
break;
case 373:
  if (!yytrial)
{
			yyval = make_node (nod_exec_stmt, int (e_exec_stmt_count),
					(yyvsp[-3])->nod_arg[0], (yyvsp[-3])->nod_arg[1], make_list(yyvsp[0]), NULL, NULL, make_list(yyvsp[-2]), NULL, NULL, NULL, NULL, NULL, NULL);
		}
break;
case 374:
  if (!yytrial)
{
			yyval = make_node (nod_exec_stmt, int (e_exec_stmt_count),
					(yyvsp[-5])->nod_arg[0], (yyvsp[-5])->nod_arg[1], make_list(yyvsp[-2]), yyvsp[0], yyvsp[-9], make_list(yyvsp[-4]), NULL, NULL, NULL, NULL, NULL, NULL);
		}
break;
case 375:
  if (!yytrial)
{ yyval = make_node (nod_exec_stmt_inputs, e_exec_stmt_inputs_count, yyvsp[0], NULL); }
break;
case 376:
  if (!yytrial)
{ yyval = make_node (nod_exec_stmt_inputs, e_exec_stmt_inputs_count, yyvsp[-4], make_list (yyvsp[-1])); }
break;
case 377:
  if (!yytrial)
{ yyval = make_node (nod_exec_stmt_inputs, e_exec_stmt_inputs_count, yyvsp[-4], make_list (yyvsp[-1])); }
break;
case 379:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 380:
  if (!yytrial)
{ yyval = make_node (nod_named_param, e_named_param_count, yyvsp[-2], yyvsp[0]); }
break;
case 382:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 383:
  if (!yytrial)
{ yyval = make_node (nod_named_param, e_named_param_count, NULL, yyvsp[0]); }
break;
case 385:
  if (!yytrial)
{ yyval = NULL; }
break;
case 386:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 394:
  if (!yytrial)
{ yyval = make_node (nod_exec_stmt_datasrc, 1, yyvsp[0]); }
break;
case 395:
  if (!yytrial)
{ yyval = make_node (nod_exec_stmt_datasrc, 1, yyvsp[0]); }
break;
case 396:
  if (!yytrial)
{ yyval = make_node (nod_exec_stmt_user, 1, yyvsp[0]); }
break;
case 397:
  if (!yytrial)
{ yyval = make_node (nod_exec_stmt_pwd, 1, yyvsp[0]); }
break;
case 398:
  if (!yytrial)
{ yyval = make_node (nod_exec_stmt_role, 1, yyvsp[0]); }
break;
case 399:
  if (!yytrial)
{ yyval = make_flag_node(nod_tran_params, NOD_TRAN_AUTONOMOUS, 1, NULL); }
break;
case 400:
  if (!yytrial)
{ yyval = make_flag_node(nod_tran_params, NOD_TRAN_COMMON, 1, NULL); }
break;
case 401:
  if (!yytrial)
{ yyval = make_node (nod_exec_stmt_privs, 1, NULL); }
break;
case 402:
  if (!yytrial)
{ yyval = make_node (nod_if, (int) e_if_count, yyvsp[-5], yyvsp[-2], yyvsp[0]); }
break;
case 403:
  if (!yytrial)
{ yyval = make_node (nod_if, (int) e_if_count, yyvsp[-3], yyvsp[0], NULL); }
break;
case 404:
  if (!yytrial)
{ yyval = make_node (nod_post, (int) e_pst_count, yyvsp[-1], yyvsp[0]); }
break;
case 405:
  if (!yytrial)
{ yyval = NULL; }
break;
case 406:
  if (!yytrial)
{ yyval = make_node (nod_for_select, (int) e_flp_count, yyvsp[-2],
					  make_list (yyvsp[0]), NULL, NULL, NULL); }
break;
case 407:
  if (!yytrial)
{ yyval = make_node (nod_var_name, (int) e_vrn_count,
							yyvsp[0]); }
break;
case 410:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 411:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 412:
  if (!yytrial)
{ yyval = make_node (nod_while, (int) e_while_count, yyvsp[-3], yyvsp[0], yyvsp[-6]); }
break;
case 413:
  if (!yytrial)
{ yyval = make_node (nod_label, (int) e_label_count, yyvsp[-1], NULL); }
break;
case 414:
  if (!yytrial)
{ yyval = NULL; }
break;
case 415:
  if (!yytrial)
{ yyval = make_node (nod_breakleave, (int) e_breakleave_count, NULL); }
break;
case 416:
  if (!yytrial)
{ yyval = make_node (nod_breakleave, (int) e_breakleave_count, NULL); }
break;
case 417:
  if (!yytrial)
{ yyval = make_node (nod_breakleave, (int) e_breakleave_count,
				make_node (nod_label, (int) e_label_count, yyvsp[0], NULL)); }
break;
case 418:
  if (!yytrial)
{ yyval = make_flag_node (nod_cursor, NOD_CURSOR_FOR,
				(int) e_cur_count, yyvsp[0], NULL, NULL, NULL); }
break;
case 419:
  if (!yytrial)
{ yyval = NULL; }
break;
case 421:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 422:
  if (!yytrial)
{ yyval = make_node (nod_on_error, (int) e_err_count,
					make_list (yyvsp[-2]), yyvsp[0]); }
break;
case 424:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 425:
  if (!yytrial)
{ yyval = make_node (nod_sqlcode, 1, yyvsp[0]); }
break;
case 426:
  if (!yytrial)
{ yyval = make_node (nod_gdscode, 1, yyvsp[0]); }
break;
case 427:
  if (!yytrial)
{ yyval = make_node (nod_exception, 1, yyvsp[0]); }
break;
case 428:
  if (!yytrial)
{ yyval = make_node (nod_default, 1, NULL); }
break;
case 432:
  if (!yytrial)
{ yyval = make_node (nod_cursor_open, (int) e_cur_stmt_count, yyvsp[0], NULL, NULL); }
break;
case 433:
  if (!yytrial)
{ yyval = make_node (nod_cursor_close, (int) e_cur_stmt_count, yyvsp[0], NULL, NULL); }
break;
case 434:
  if (!yytrial)
{ yyval = make_node (nod_cursor_fetch, (int) e_cur_stmt_count, yyvsp[-2], yyvsp[-3], make_list (yyvsp[0])); }
break;
case 435:
  if (!yytrial)
{ yyval = NULL; }
break;
case 436:
  if (!yytrial)
{ yyval = make_node (nod_exec_procedure, (int) e_exe_count,
					yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 437:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 438:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 439:
  if (!yytrial)
{ yyval = NULL; }
break;
case 440:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 441:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 442:
  if (!yytrial)
{ yyval = NULL; }
break;
case 443:
  if (!yytrial)
{ yyval = make_node (nod_exec_block,
						  (int) e_exe_blk_count,
					          yyvsp[-4], yyvsp[-3], yyvsp[-1], yyvsp[0], make_node (nod_all, (int) 0, NULL)); }
break;
case 444:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 445:
  if (!yytrial)
{ yyval = NULL; }
break;
case 447:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 448:
  if (!yytrial)
{ yyval = make_node (nod_param_val, e_prm_val_count, yyvsp[-2], yyvsp[0]); }
break;
case 449:
  if (!yytrial)
{ yyval = make_node (nod_def_view, (int) e_view_count,
					  yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 450:
  if (!yytrial)
{ yyval = make_node (nod_redef_view, (int) e_view_count,
					  yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 451:
  if (!yytrial)
{ yyval = make_node (nod_replace_view, (int) e_view_count,
					  yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 452:
  if (!yytrial)
{ yyval = make_node (nod_mod_view, (int) e_view_count,
					  yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 453:
  if (!yytrial)
{ lex.beginnings.push(lex_position()); }
break;
case 454:
  if (!yytrial)
{ lex.beginnings.push(lex.last_token); }
break;
case 455:
  if (!yytrial)
{
				const TEXT* start = lex.beginnings.pop();
				string str;
				transformString(start, lex_position() - start, str);
				yyval = (dsql_nod*) MAKE_string(str.c_str(), str.length());
			}
break;
case 456:
  if (!yytrial)
{
				const TEXT* start = lex.beginnings.pop();
				yyval = (dsql_nod*) MAKE_string(start,
					(yychar <= 0 ? lex_position() : lex.last_token) - start);
			}
break;
case 457:
  if (!yytrial)
{ yyval = make_node (nod_def_constraint, (int) e_cnstr_count,
					NULL, NULL, NULL, NULL, NULL); }
break;
case 458:
  if (!yytrial)
{ yyval = 0; }
break;
case 459:
  if (!yytrial)
{
			yyval = make_node (nod_def_trigger, (int) e_trg_count,
				yyvsp[-5], NULL, yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 460:
  if (!yytrial)
{
			yyval = make_node (nod_def_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 461:
  if (!yytrial)
{
			yyval = make_node (nod_def_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-2], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-1], yyvsp[0]);
		}
break;
case 462:
  if (!yytrial)
{
			yyval = make_node (nod_redef_trigger, (int) e_trg_count,
				yyvsp[-5], NULL, yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 463:
  if (!yytrial)
{
			yyval = make_node (nod_redef_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 464:
  if (!yytrial)
{
			yyval = make_node (nod_redef_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-2], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-1], yyvsp[0]);
		}
break;
case 465:
  if (!yytrial)
{
			yyval = make_node (nod_replace_trigger, (int) e_trg_count,
				yyvsp[-5], NULL, yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 466:
  if (!yytrial)
{
			yyval = make_node (nod_replace_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 467:
  if (!yytrial)
{
			yyval = make_node (nod_replace_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-2], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-1], yyvsp[0]);
		}
break;
case 468:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 469:
  if (!yytrial)
{ yyval = MAKE_const_slong (1); }
break;
case 470:
  if (!yytrial)
{ yyval = NULL; }
break;
case 471:
  if (!yytrial)
{ yyval = MAKE_trigger_type (yyvsp[-1], yyvsp[0]); }
break;
case 472:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 473:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_CONNECT); }
break;
case 474:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_DISCONNECT); }
break;
case 475:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_TRANS_START); }
break;
case 476:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_TRANS_COMMIT); }
break;
case 477:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_TRANS_ROLLBACK); }
break;
case 478:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 479:
  if (!yytrial)
{ yyval = MAKE_const_slong (1); }
break;
case 480:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 0, 0)); }
break;
case 481:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 0, 0)); }
break;
case 482:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 0, 0)); }
break;
case 483:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 2, 0)); }
break;
case 484:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 3, 0)); }
break;
case 485:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 1, 0)); }
break;
case 486:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 3, 0)); }
break;
case 487:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 1, 0)); }
break;
case 488:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 2, 0)); }
break;
case 489:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 2, 3)); }
break;
case 490:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 3, 2)); }
break;
case 491:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 1, 3)); }
break;
case 492:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 3, 1)); }
break;
case 493:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 1, 2)); }
break;
case 494:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 2, 1)); }
break;
case 495:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 496:
  if (!yytrial)
{ yyval = NULL; }
break;
case 497:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) e_trg_act_count, yyvsp[-1], yyvsp[0]); }
break;
case 498:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 499:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 500:
  if (!yytrial)
{ yyval = make_node (nod_mod_relation, (int) e_alt_count,
						yyvsp[-1], make_list (yyvsp[0])); }
break;
case 501:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 502:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 503:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 504:
  if (!yytrial)
{ yyval = make_node (nod_mod_database, (int) e_adb_count,
				make_list (yyvsp[0])); }
break;
case 505:
  if (!yytrial)
{ yyval = make_node (nod_mod_domain, (int) e_alt_count,
										  yyvsp[-1], make_list (yyvsp[0])); }
break;
case 506:
  if (!yytrial)
{ yyval = make_node (nod_mod_index, (int) e_mod_idx_count, yyvsp[0]); }
break;
case 507:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 508:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 509:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 510:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 511:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 513:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 514:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 515:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 516:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 517:
  if (!yytrial)
{yyval = make_node (nod_del_default, (int) 0, NULL); }
break;
case 518:
  if (!yytrial)
{ yyval = make_node (nod_delete_rel_constraint, (int) 1, NULL); }
break;
case 519:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 520:
  if (!yytrial)
{ yyval = make_node (nod_mod_domain_type, 2, yyvsp[-1]); }
break;
case 522:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 523:
  if (!yytrial)
{ yyval = make_node (nod_del_field, 2, yyvsp[-1], yyvsp[0]); }
break;
case 524:
  if (!yytrial)
{ yyval = make_node (nod_delete_rel_constraint, (int) 1, yyvsp[0]);}
break;
case 525:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 526:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 527:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_pos, 2, yyvsp[-2],
				MAKE_const_slong((IPTR) yyvsp[0])); }
break;
case 528:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_name, 2, yyvsp[-2], yyvsp[0]); }
break;
case 529:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_type, e_mod_fld_type_count, yyvsp[-2], yyvsp[0], NULL, NULL); }
break;
case 530:
  if (!yytrial)
{
				/* Due to parser hacks, we should not pass $4 (non_array_type) to make_node.*/
				yyval = make_node(nod_mod_field_type, e_mod_fld_type_count, yyvsp[-3], NULL, NULL, yyvsp[0]);
			}
break;
case 531:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_type, e_mod_fld_type_count, yyvsp[-1], NULL, NULL, yyvsp[0]); }
break;
case 532:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_type, e_mod_fld_type_count, yyvsp[-2], NULL, yyvsp[0], NULL); }
break;
case 533:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_type, e_mod_fld_type_count, yyvsp[-2], NULL,
					make_node(nod_del_default, (int) 0, NULL), NULL); }
break;
case 534:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count,
						NULL, yyvsp[0]); }
break;
case 587:
  if (!yytrial)
{ yyval = NULL; }
break;
case 588:
  if (!yytrial)
{ yyval = NULL; }
break;
case 589:
  if (!yytrial)
{ yyval = NULL; }
break;
case 590:
  if (!yytrial)
{ yyval = make_node (nod_def_domain, (int) e_dom_count, yyvsp[0], NULL, NULL, NULL); }
break;
case 591:
  if (!yytrial)
{ lex.g_field_name = yyvsp[0];
			  lex.g_field = make_field (yyvsp[0]);
			  yyval = (dsql_nod*) lex.g_field; }
break;
case 592:
  if (!yytrial)
{ yyval = make_node (nod_restrict, 0, NULL); }
break;
case 593:
  if (!yytrial)
{ yyval = make_node (nod_cascade, 0, NULL); }
break;
case 594:
  if (!yytrial)
{ yyval = make_node (nod_restrict, 0, NULL); }
break;
case 595:
  if (!yytrial)
{ yyval = make_node (nod_idx_active, 1, yyvsp[-1]); }
break;
case 596:
  if (!yytrial)
{ yyval = make_node (nod_idx_inactive, 1, yyvsp[-1]); }
break;
case 597:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-3],
				MAKE_const_slong ((IPTR) yyvsp[0])); }
break;
case 598:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-3],
				MAKE_constant((dsql_str*) yyvsp[0], CONSTANT_SINT64)); }
break;
case 599:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-4],
				make_node(nod_negate, 1, MAKE_constant((dsql_str*) yyvsp[0], CONSTANT_SINT64))); }
break;
case 600:
  if (!yytrial)
{ yyval = make_node(nod_mod_udf, e_mod_udf_count, yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 601:
  if (!yytrial)
{ yyval = make_node(nod_mod_role, e_mod_role_count, NULL, yyvsp[-4], yyvsp[-3]); }
break;
case 602:
  if (!yytrial)
{ yyval = MAKE_const_slong (isc_dyn_automap_role); }
break;
case 603:
  if (!yytrial)
{ yyval = MAKE_const_slong (isc_dyn_autounmap_role); }
break;
case 604:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 605:
  if (!yytrial)
{ yyval = NULL; }
break;
case 606:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 607:
  if (!yytrial)
{ yyval = NULL; }
break;
case 608:
  if (!yytrial)
{ yyval = NULL; }
break;
case 610:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 611:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 612:
  if (!yytrial)
{ yyval = make_node (nod_difference_file, (int) 1, yyvsp[0]); }
break;
case 613:
  if (!yytrial)
{ yyval = make_node (nod_drop_difference, (int) 0, NULL); }
break;
case 614:
  if (!yytrial)
{ yyval = make_node (nod_begin_backup, (int) 0, NULL); }
break;
case 615:
  if (!yytrial)
{ yyval = make_node (nod_end_backup, (int) 0, NULL); }
break;
case 616:
  if (!yytrial)
{ yyval = make_node (nod_mod_trigger, (int) e_trg_count,
				yyvsp[-6], NULL, yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-1], yyvsp[0]); }
break;
case 618:
  if (!yytrial)
{ yyval = NULL; }
break;
case 620:
  if (!yytrial)
{ yyval = NULL; }
break;
case 621:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 622:
  if (!yytrial)
{ yyval = make_node (nod_del_exception, 1, yyvsp[0]); }
break;
case 623:
  if (!yytrial)
{ yyval = make_node (nod_del_index, (int) 1, yyvsp[0]); }
break;
case 624:
  if (!yytrial)
{ yyval = make_node (nod_del_procedure, (int) 1, yyvsp[0]); }
break;
case 625:
  if (!yytrial)
{ yyval = make_node (nod_del_relation, (int) 1, yyvsp[0]); }
break;
case 626:
  if (!yytrial)
{ yyval = make_node (nod_del_trigger, (int) 1, yyvsp[0]); }
break;
case 627:
  if (!yytrial)
{ yyval = make_node (nod_del_view, (int) 1, yyvsp[0]); }
break;
case 628:
  if (!yytrial)
{ yyval = make_node (nod_del_filter, (int) 1, yyvsp[0]); }
break;
case 629:
  if (!yytrial)
{ yyval = make_node (nod_del_domain, (int) 1, yyvsp[0]); }
break;
case 630:
  if (!yytrial)
{ yyval = make_node (nod_del_udf, (int) 1, yyvsp[0]); }
break;
case 631:
  if (!yytrial)
{ yyval = make_node (nod_del_shadow, (int) 1, yyvsp[0]); }
break;
case 632:
  if (!yytrial)
{ yyval = make_node (nod_del_role, (int) 1, yyvsp[0]); }
break;
case 633:
  if (!yytrial)
{ yyval = make_node (nod_del_generator, (int) 1, yyvsp[0]); }
break;
case 634:
  if (!yytrial)
{ yyval = make_node (nod_del_generator, (int) 1, yyvsp[0]); }
break;
case 635:
  if (!yytrial)
{ yyval = make_node (nod_del_collation, (int) 1, yyvsp[0]); }
break;
case 636:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 640:
  if (!yytrial)
{ lex.g_field->fld_not_nullable = true; }
break;
case 643:
  if (!yytrial)
{ lex.g_field->fld_type_of_name = ((dsql_str*) yyvsp[0])->str_data; }
break;
case 644:
  if (!yytrial)
{
				lex.g_field->fld_type_of_name = ((dsql_str*) yyvsp[0])->str_data;
				lex.g_field->fld_type_of_table = ((dsql_str*) yyvsp[-2])->str_data;
			}
break;
case 645:
  if (!yytrial)
{
				lex.g_field->fld_type_of_name = ((dsql_str*) yyvsp[0])->str_data;
				lex.g_field->fld_full_domain = true;
			}
break;
case 648:
  if (!yytrial)
{ lex.g_field->fld_ranges = make_list (yyvsp[-1]);
			  lex.g_field->fld_dimensions = lex.g_field->fld_ranges->nod_count / 2;
			  lex.g_field->fld_element_dtype = lex.g_field->fld_dtype;
			  yyval = yyvsp[-3]; }
break;
case 649:
  if (!yytrial)
{ lex.g_field->fld_ranges = make_list (yyvsp[-2]);
			  lex.g_field->fld_dimensions = lex.g_field->fld_ranges->nod_count / 2;
			  lex.g_field->fld_element_dtype = lex.g_field->fld_dtype;
			  yyval = yyvsp[-4]; }
break;
case 651:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 652:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] < 1)
			 		yyval = make_node (nod_list, (int) 2,
					MAKE_const_slong ((IPTR) yyvsp[0]),
					MAKE_const_slong (1));
				  else
			 		yyval = make_node (nod_list, (int) 2,
			   		MAKE_const_slong (1),
					MAKE_const_slong ((IPTR) yyvsp[0]) ); }
break;
case 653:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2,
			 	MAKE_const_slong ((IPTR) yyvsp[-2]),
				MAKE_const_slong ((IPTR) yyvsp[0])); }
break;
case 659:
  if (!yytrial)
{
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
					Arg::Gds(isc_sql_dialect_datatype_unsupport) << Arg::Num(client_dialect) <<
																	Arg::Str("BIGINT"));
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
					Arg::Gds(isc_sql_db_dialect_dtype_unsupport) << Arg::Num(db_dialect) <<
																	Arg::Str("BIGINT"));
			lex.g_field->fld_dtype = dtype_int64;
			lex.g_field->fld_length = sizeof (SINT64);
			}
break;
case 660:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_long;
			lex.g_field->fld_length = sizeof (SLONG);
			}
break;
case 661:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_short;
			lex.g_field->fld_length = sizeof (SSHORT);
			}
break;
case 662:
  if (!yytrial)
{
			stmt_ambiguous = true;
			if (client_dialect <= SQL_DIALECT_V5)
				{
				/* Post warning saying that DATE is equivalent to TIMESTAMP */
				ERRD_post_warning(Arg::Warning(isc_sqlwarn) << Arg::Num(301) <<
								  Arg::Warning(isc_dtype_renamed));
				lex.g_field->fld_dtype = dtype_timestamp;
				lex.g_field->fld_length = sizeof (GDS_TIMESTAMP);
				}
			else if (client_dialect == SQL_DIALECT_V6_TRANSITION)
				yyabandon (-104, isc_transitional_date);
			else
				{
				lex.g_field->fld_dtype = dtype_sql_date;
				lex.g_field->fld_length = sizeof (ULONG);
				}
			}
break;
case 663:
  if (!yytrial)
{
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
						  Arg::Gds(isc_sql_dialect_datatype_unsupport) << Arg::Num(client_dialect) <<
																		  Arg::Str("TIME"));
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
						  Arg::Gds(isc_sql_db_dialect_dtype_unsupport) << Arg::Num(db_dialect) <<
																		  Arg::Str("TIME"));
			lex.g_field->fld_dtype = dtype_sql_time;
			lex.g_field->fld_length = sizeof (SLONG);
			}
break;
case 664:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_timestamp;
			lex.g_field->fld_length = sizeof (GDS_TIMESTAMP);
			}
break;
case 667:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_blob;
			lex.g_field->fld_length = sizeof(ISC_QUAD);
			}
break;
case 668:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_blob;
			lex.g_field->fld_length = sizeof(ISC_QUAD);
			lex.g_field->fld_seg_length = (USHORT)(IPTR) yyvsp[-1];
			lex.g_field->fld_sub_type = 0;
			}
break;
case 669:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_blob;
			lex.g_field->fld_length = sizeof(ISC_QUAD);
			lex.g_field->fld_seg_length = (USHORT)(IPTR) yyvsp[-3];
			lex.g_field->fld_sub_type = (USHORT)(IPTR) yyvsp[-1];
			}
break;
case 670:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_blob;
			lex.g_field->fld_length = sizeof(ISC_QUAD);
			lex.g_field->fld_seg_length = 80;
			lex.g_field->fld_sub_type = (USHORT)(IPTR) yyvsp[-1];
			}
break;
case 671:
  if (!yytrial)
{
			lex.g_field->fld_seg_length = (USHORT)(IPTR) yyvsp[0];
		  	}
break;
case 672:
  if (!yytrial)
{
			lex.g_field->fld_seg_length = (USHORT) 80;
		  	}
break;
case 673:
  if (!yytrial)
{
			lex.g_field->fld_sub_type = (USHORT)(IPTR) yyvsp[0];
			}
break;
case 674:
  if (!yytrial)
{
			lex.g_field->fld_sub_type_name = yyvsp[0];
			}
break;
case 675:
  if (!yytrial)
{
			lex.g_field->fld_sub_type = (USHORT) 0;
			}
break;
case 676:
  if (!yytrial)
{
			lex.g_field->fld_character_set = yyvsp[0];
			}
break;
case 678:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_text;
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-1];
			lex.g_field->fld_flags |= FLD_national;
			}
break;
case 679:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_text;
			lex.g_field->fld_character_length = 1;
			lex.g_field->fld_flags |= FLD_national;
			}
break;
case 680:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_varying;
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-1];
			lex.g_field->fld_flags |= FLD_national;
			}
break;
case 681:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_text;
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-1];
			}
break;
case 682:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_text;
			lex.g_field->fld_character_length = 1;
			}
break;
case 683:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_varying;
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-1];
			}
break;
case 692:
  if (!yytrial)
{
			  lex.g_field->fld_sub_type = dsc_num_type_numeric;
			}
break;
case 693:
  if (!yytrial)
{
			   lex.g_field->fld_sub_type = dsc_num_type_decimal;
			   if (lex.g_field->fld_dtype == dtype_short)
				{
				lex.g_field->fld_dtype = dtype_long;
				lex.g_field->fld_length = sizeof (SLONG);
				}
			}
break;
case 694:
  if (!yytrial)
{
				lex.g_field->fld_dtype = dtype_long;
				lex.g_field->fld_length = sizeof (SLONG);
				lex.g_field->fld_precision = 9;
			}
break;
case 695:
  if (!yytrial)
{
			if ( ((IPTR) yyvsp[-1] < 1) || ((IPTR) yyvsp[-1] > 18) )
				yyabandon (-842, isc_precision_err);
				/* Precision most be between 1 and 18. */
			if ((IPTR) yyvsp[-1] > 9)
			{
				if ( ( (client_dialect <= SQL_DIALECT_V5) &&
				   (db_dialect > SQL_DIALECT_V5) ) ||
				 ( (client_dialect > SQL_DIALECT_V5) &&
				   (db_dialect <= SQL_DIALECT_V5) ) )
					ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-817) <<
							  Arg::Gds(isc_ddl_not_allowed_by_db_sql_dial) << Arg::Num(db_dialect));
				if (client_dialect <= SQL_DIALECT_V5)
				{
					lex.g_field->fld_dtype = dtype_double;
					lex.g_field->fld_length = sizeof (double);
				}
				else
				{
					if (client_dialect == SQL_DIALECT_V6_TRANSITION)
					{
						ERRD_post_warning(Arg::Warning(isc_dsql_warn_precision_ambiguous));
						ERRD_post_warning(Arg::Warning(isc_dsql_warn_precision_ambiguous1));
						ERRD_post_warning(Arg::Warning(isc_dsql_warn_precision_ambiguous2));
					}
					lex.g_field->fld_dtype = dtype_int64;
					lex.g_field->fld_length = sizeof (SINT64);
				}
			}
			else
			{
				if ((IPTR) yyvsp[-1] < 5)
				{
					lex.g_field->fld_dtype = dtype_short;
					lex.g_field->fld_length = sizeof (SSHORT);
				}
				else
				{
					lex.g_field->fld_dtype = dtype_long;
					lex.g_field->fld_length = sizeof (SLONG);
				}
			}
			lex.g_field->fld_precision = (USHORT)(IPTR) yyvsp[-1];
			}
break;
case 696:
  if (!yytrial)
{
			if ( ((IPTR) yyvsp[-3] < 1) || ((IPTR) yyvsp[-3] > 18) )
				yyabandon (-842, isc_precision_err);
				/* Precision should be between 1 and 18 */
			if (((IPTR) yyvsp[-1] > (IPTR) yyvsp[-3]) || ((IPTR) yyvsp[-1] < 0))
				yyabandon (-842, isc_scale_nogt);
				/* Scale must be between 0 and precision */
			if ((IPTR) yyvsp[-3] > 9)
			{
				if ( ( (client_dialect <= SQL_DIALECT_V5) &&
				   (db_dialect > SQL_DIALECT_V5) ) ||
				 ( (client_dialect > SQL_DIALECT_V5) &&
				   (db_dialect <= SQL_DIALECT_V5) ) )
				{
					ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-817) <<
							  Arg::Gds(isc_ddl_not_allowed_by_db_sql_dial) << Arg::Num(db_dialect));
				}
				if (client_dialect <= SQL_DIALECT_V5)
				{
					lex.g_field->fld_dtype = dtype_double;
					lex.g_field->fld_length = sizeof (double);
				}
				else
				{
					if (client_dialect == SQL_DIALECT_V6_TRANSITION)
					{
						ERRD_post_warning(Arg::Warning(isc_dsql_warn_precision_ambiguous));
						ERRD_post_warning(Arg::Warning(isc_dsql_warn_precision_ambiguous1));
						ERRD_post_warning(Arg::Warning(isc_dsql_warn_precision_ambiguous2));
					}
					/* client_dialect >= SQL_DIALECT_V6 */
					lex.g_field->fld_dtype = dtype_int64;
					lex.g_field->fld_length = sizeof (SINT64);
				}
			}
			else
			{
				if ((IPTR) yyvsp[-3] < 5)
				{
					lex.g_field->fld_dtype = dtype_short;
					lex.g_field->fld_length = sizeof (SSHORT);
				}
				else
				{
					lex.g_field->fld_dtype = dtype_long;
					lex.g_field->fld_length = sizeof (SLONG);
				}
			}
			lex.g_field->fld_precision = (USHORT)(IPTR) yyvsp[-3];
			lex.g_field->fld_scale = - (SSHORT)(IPTR) yyvsp[-1];
			}
break;
case 699:
  if (!yytrial)
{
			if ((IPTR) yyvsp[0] > 7)
				{
				lex.g_field->fld_dtype = dtype_double;
				lex.g_field->fld_length = sizeof (double);
				}
			else
				{
				lex.g_field->fld_dtype = dtype_real;
				lex.g_field->fld_length = sizeof (float);
				}
			}
break;
case 700:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_double;
			lex.g_field->fld_length = sizeof (double);
			}
break;
case 701:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_real;
			lex.g_field->fld_length = sizeof (float);
			}
break;
case 702:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_double;
			lex.g_field->fld_length = sizeof (double);
			}
break;
case 703:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 704:
  if (!yytrial)
{ yyval = 0; }
break;
case 708:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-2],
				MAKE_const_slong ((IPTR) yyvsp[0])); }
break;
case 709:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-2],
				MAKE_constant((dsql_str*) yyvsp[0], CONSTANT_SINT64)); }
break;
case 710:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-3],
				make_node(nod_negate, 1, MAKE_constant((dsql_str*) yyvsp[0], CONSTANT_SINT64))); }
break;
case 714:
  if (!yytrial)
{ yyval = make_node (nod_user_savepoint, 1, yyvsp[0]); }
break;
case 715:
  if (!yytrial)
{ yyval = make_node (nod_release_savepoint, 2, yyvsp[-1], yyvsp[0]); }
break;
case 716:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 717:
  if (!yytrial)
{ yyval = 0; }
break;
case 718:
  if (!yytrial)
{ yyval = make_node (nod_undo_savepoint, 1, yyvsp[0]); }
break;
case 721:
  if (!yytrial)
{ yyval = make_node (nod_commit, e_commit_count, yyvsp[0]); }
break;
case 722:
  if (!yytrial)
{
#ifdef POOL_DUMP
			  Firebird::MemoryPool::printAll();
			  yyerror("Pseudo-error: DUMP complete");
#else
			  yyerror("DUMP not supported");
#endif
			  yyval = NULL; }
break;
case 723:
  if (!yytrial)
{ yyval = make_node (nod_rollback, e_rollback_count, yyvsp[0]); }
break;
case 726:
  if (!yytrial)
{ yyval = make_node (nod_retain, 0, NULL); }
break;
case 727:
  if (!yytrial)
{ yyval = NULL; }
break;
case 729:
  if (!yytrial)
{ yyval = NULL; }
break;
case 730:
  if (!yytrial)
{yyval = make_node (nod_trans, 1, make_list (yyvsp[0])); }
break;
case 732:
  if (!yytrial)
{ yyval = NULL; }
break;
case 734:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 741:
  if (!yytrial)
{ yyval = make_flag_node (nod_access, NOD_READ_ONLY, (int) 0, NULL); }
break;
case 742:
  if (!yytrial)
{ yyval = make_flag_node (nod_access, NOD_READ_WRITE, (int) 0, NULL); }
break;
case 743:
  if (!yytrial)
{ yyval = make_flag_node (nod_wait, NOD_WAIT, (int) 0, NULL); }
break;
case 744:
  if (!yytrial)
{ yyval = make_flag_node (nod_wait, NOD_NO_WAIT, (int) 0, NULL); }
break;
case 745:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 747:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 748:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_READ_COMMITTED, 1, yyvsp[0]); }
break;
case 749:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_READ_COMMITTED, 1, yyvsp[0]); }
break;
case 750:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_CONCURRENCY, 0, NULL); }
break;
case 751:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_CONSISTENCY, 0, NULL); }
break;
case 752:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_CONSISTENCY, 0, NULL); }
break;
case 753:
  if (!yytrial)
{ yyval = make_flag_node (nod_version, NOD_VERSION, 0, NULL); }
break;
case 754:
  if (!yytrial)
{ yyval = make_flag_node (nod_version, NOD_NO_VERSION, 0, NULL); }
break;
case 755:
  if (!yytrial)
{ yyval = 0; }
break;
case 756:
  if (!yytrial)
{ yyval = make_flag_node(nod_tra_misc, NOD_NO_AUTO_UNDO, 0, NULL); }
break;
case 757:
  if (!yytrial)
{ yyval = make_flag_node(nod_tra_misc, NOD_IGNORE_LIMBO, 0, NULL); }
break;
case 758:
  if (!yytrial)
{ yyval = make_flag_node(nod_tra_misc, NOD_RESTART_REQUESTS, 0, NULL); }
break;
case 759:
  if (!yytrial)
{ yyval = make_node(nod_lock_timeout, 1, MAKE_const_slong ((IPTR) yyvsp[0])); }
break;
case 760:
  if (!yytrial)
{ yyval = make_node (nod_reserve, 1, make_list (yyvsp[0])); }
break;
case 761:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_SHARED; }
break;
case 762:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_PROTECTED; }
break;
case 763:
  if (!yytrial)
{ yyval = (dsql_nod*) 0; }
break;
case 764:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_READ; }
break;
case 765:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_WRITE; }
break;
case 767:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 768:
  if (!yytrial)
{ yyval = make_node (nod_table_lock, (int) 2, make_list (yyvsp[-1]), yyvsp[0]); }
break;
case 769:
  if (!yytrial)
{ yyval = make_flag_node (nod_lock_mode, (SSHORT) ((SSHORT)(IPTR) yyvsp[-1] | (SSHORT)(IPTR) yyvsp[0]), (SSHORT) 0, NULL); }
break;
case 770:
  if (!yytrial)
{ yyval = 0; }
break;
case 772:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 773:
  if (!yytrial)
{ yyval = make_node (nod_set_statistics, (int) e_stat_count, yyvsp[0]); }
break;
case 774:
  if (!yytrial)
{ yyval = make_node(nod_comment, e_comment_count, yyvsp[-2], NULL, NULL, yyvsp[0]); }
break;
case 775:
  if (!yytrial)
{ yyval = make_node(nod_comment, e_comment_count, yyvsp[-3], yyvsp[-2], NULL, yyvsp[0]); }
break;
case 776:
  if (!yytrial)
{ yyval = make_node(nod_comment, e_comment_count, yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[0]); }
break;
case 777:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_database); }
break;
case 778:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_domain); }
break;
case 779:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_relation); }
break;
case 780:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_view); }
break;
case 781:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_procedure); }
break;
case 782:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_trigger); }
break;
case 783:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_udf); }
break;
case 784:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_blob_filter); }
break;
case 785:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_exception); }
break;
case 786:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_generator); }
break;
case 787:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_generator); }
break;
case 788:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_index); }
break;
case 789:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_role); }
break;
case 790:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_charset); }
break;
case 791:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_collation); }
break;
case 792:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_relation); }
break;
case 793:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_procedure); }
break;
case 794:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 796:
  if (!yytrial)
{ yyval = NULL; }
break;
case 797:
  if (!yytrial)
{ yyval = make_node (nod_select, (int) e_select_count, yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 798:
  if (!yytrial)
{ yyval = make_node (nod_for_update, (int) e_fpd_count, yyvsp[0]); }
break;
case 799:
  if (!yytrial)
{ yyval = NULL; }
break;
case 800:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 801:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 802:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 803:
  if (!yytrial)
{ yyval = NULL; }
break;
case 804:
  if (!yytrial)
{ yyval = make_node (nod_select_expr, (int) e_sel_count, yyvsp[-2], yyvsp[-1], yyvsp[0], yyvsp[-3]); }
break;
case 805:
  if (!yytrial)
{ yyval = make_flag_node (nod_with, NOD_UNION_RECURSIVE, 1, make_list(yyvsp[0])); }
break;
case 806:
  if (!yytrial)
{ yyval = make_node (nod_with, 1, make_list(yyvsp[0])); }
break;
case 807:
  if (!yytrial)
{ yyval = NULL; }
break;
case 809:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 810:
  if (!yytrial)
{ yyval = make_node (nod_derived_table, (int) e_derived_table_count, yyvsp[-1], yyvsp[-5], yyvsp[-4], NULL); }
break;
case 811:
  if (!yytrial)
{ yyval = make_flag_node (nod_select_expr, NOD_SELECT_EXPR_VALUE,
					(int) e_sel_count, yyvsp[-2], yyvsp[-1], yyvsp[0], yyvsp[-3]); }
break;
case 812:
  if (!yytrial)
{ yyval = make_flag_node (nod_select_expr, NOD_SELECT_EXPR_VALUE | NOD_SELECT_EXPR_SINGLETON,
					(int) e_sel_count, yyvsp[-2], yyvsp[-1], yyvsp[0], yyvsp[-3]); }
break;
case 814:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-3], yyvsp[0]); }
break;
case 815:
  if (!yytrial)
{ yyval = make_flag_node (nod_list, NOD_UNION_ALL, 2, yyvsp[-3], yyvsp[0]); }
break;
case 817:
  if (!yytrial)
{ yyval = make_node (nod_query_spec, (int) e_qry_count,
					yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 818:
  if (!yytrial)
{ yyval = make_node (nod_limit, (int) e_limit_count, yyvsp[0], yyvsp[-1]); }
break;
case 819:
  if (!yytrial)
{ yyval = make_node (nod_limit, (int) e_limit_count, NULL, yyvsp[0]); }
break;
case 820:
  if (!yytrial)
{ yyval = make_node (nod_limit, (int) e_limit_count, yyvsp[0], NULL); }
break;
case 821:
  if (!yytrial)
{ yyval = 0; }
break;
case 822:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 823:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 824:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 825:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 826:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 827:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 828:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 829:
  if (!yytrial)
{ yyval = 0; }
break;
case 830:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 831:
  if (!yytrial)
{ yyval = 0; }
break;
case 833:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 835:
  if (!yytrial)
{ yyval = make_node (nod_alias, 2, yyvsp[-2], yyvsp[0]); }
break;
case 838:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 840:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 845:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 846:
  if (!yytrial)
{ yyval = make_node(nod_derived_table, (int) e_derived_table_count, yyvsp[-4], yyvsp[-1], yyvsp[0], NULL); }
break;
case 848:
  if (!yytrial)
{ yyval = NULL; }
break;
case 849:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 850:
  if (!yytrial)
{ yyval = NULL; }
break;
case 852:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 856:
  if (!yytrial)
{ yyval = make_node (nod_join, (int) e_join_count, yyvsp[-3],
				make_node (nod_join_inner, (int) 0, NULL), yyvsp[0], NULL); }
break;
case 857:
  if (!yytrial)
{ yyval = make_node (nod_join, (int) e_join_count, yyvsp[-4], yyvsp[-2], yyvsp[0],
					make_node (nod_flag, 0, NULL)); }
break;
case 858:
  if (!yytrial)
{ yyval = make_node (nod_join, (int) e_join_count, yyvsp[-4], yyvsp[-3], yyvsp[-1], yyvsp[0]); }
break;
case 861:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 862:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 863:
  if (!yytrial)
{ yyval = make_node (nod_rel_proc_name,
					(int) e_rpn_count, yyvsp[-3], yyvsp[0], yyvsp[-2]); }
break;
case 864:
  if (!yytrial)
{ yyval = make_node (nod_rel_proc_name,
					(int) e_rpn_count, yyvsp[-1], NULL, yyvsp[0]); }
break;
case 865:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 866:
  if (!yytrial)
{ yyval = NULL; }
break;
case 868:
  if (!yytrial)
{ yyval = make_node (nod_relation_name,
						(int) e_rln_count, yyvsp[-2], yyvsp[0]); }
break;
case 869:
  if (!yytrial)
{ yyval = make_node (nod_relation_name,
						(int) e_rln_count, yyvsp[0], NULL); }
break;
case 870:
  if (!yytrial)
{ yyval = make_node (nod_join_inner, (int) 0, NULL); }
break;
case 871:
  if (!yytrial)
{ yyval = make_node (nod_join_left, (int) 0, NULL); }
break;
case 872:
  if (!yytrial)
{ yyval = make_node (nod_join_right, (int) 0, NULL); }
break;
case 873:
  if (!yytrial)
{ yyval = make_node (nod_join_full, (int) 0, NULL); }
break;
case 874:
  if (!yytrial)
{ yyval = make_node (nod_join_inner, (int) 0, NULL); }
break;
case 877:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 878:
  if (!yytrial)
{ yyval = NULL; }
break;
case 880:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 882:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 883:
  if (!yytrial)
{ yyval = NULL; }
break;
case 884:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 885:
  if (!yytrial)
{ yyval = NULL; }
break;
case 886:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 887:
  if (!yytrial)
{ yyval = NULL; }
break;
case 888:
  if (!yytrial)
{ yyval = make_node (nod_plan_expr, 2, yyvsp[-3], make_list (yyvsp[-1])); }
break;
case 889:
  if (!yytrial)
{ yyval = 0; }
break;
case 890:
  if (!yytrial)
{ yyval = make_node (nod_merge_plan, (int) 0, NULL); }
break;
case 891:
  if (!yytrial)
{ yyval = make_node (nod_merge_plan, (int) 0, NULL); }
break;
case 892:
  if (!yytrial)
{ yyval = 0; }
break;
case 893:
  if (!yytrial)
{ yyval = 0; }
break;
case 895:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 896:
  if (!yytrial)
{ yyval = make_node (nod_plan_item, 2, make_list (yyvsp[-1]), yyvsp[0]); }
break;
case 899:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 900:
  if (!yytrial)
{ yyval = make_node (nod_natural, (int) 0, NULL); }
break;
case 901:
  if (!yytrial)
{ yyval = make_node (nod_index, 1, make_list (yyvsp[-1])); }
break;
case 902:
  if (!yytrial)
{ yyval = make_node (nod_index_order, 2, yyvsp[-1], yyvsp[0]); }
break;
case 904:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 905:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 906:
  if (!yytrial)
{ yyval = 0; }
break;
case 907:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 908:
  if (!yytrial)
{ yyval = 0; }
break;
case 910:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 911:
  if (!yytrial)
{ yyval = make_node (nod_order, (int) e_order_count, yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 912:
  if (!yytrial)
{ yyval = 0; }
break;
case 913:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 914:
  if (!yytrial)
{ yyval = 0; }
break;
case 915:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 916:
  if (!yytrial)
{ yyval = 0; }
break;
case 917:
  if (!yytrial)
{ yyval = MAKE_const_slong(NOD_NULLS_FIRST); }
break;
case 918:
  if (!yytrial)
{ yyval = MAKE_const_slong(NOD_NULLS_LAST); }
break;
case 919:
  if (!yytrial)
{ yyval = make_node (nod_rows, (int) e_rows_count, NULL, yyvsp[0]); }
break;
case 920:
  if (!yytrial)
{ yyval = make_node (nod_rows, (int) e_rows_count,
				make_node (nod_subtract, 2, yyvsp[-2],
					MAKE_const_slong (1)),
				make_node (nod_add, 2,
					make_node (nod_subtract, 2, yyvsp[0], yyvsp[-2]),
					MAKE_const_slong (1))); }
break;
case 921:
  if (!yytrial)
{ yyval = NULL; }
break;
case 922:
  if (!yytrial)
{ yyval = make_node (nod_insert, (int) e_ins_count,
				yyvsp[-6], yyvsp[-5], make_list (yyvsp[-2]), NULL, yyvsp[0]); }
break;
case 923:
  if (!yytrial)
{ yyval = make_node (nod_insert, (int) e_ins_count,
				yyvsp[-3], yyvsp[-2], NULL, yyvsp[-1], yyvsp[0]); }
break;
case 924:
  if (!yytrial)
{ yyval = make_node (nod_insert, (int) e_ins_count,
				yyvsp[-3], NULL, NULL, NULL, yyvsp[0]); }
break;
case 925:
  if (!yytrial)
{
			yyval = make_node(nod_merge, e_mrg_count, yyvsp[-5], yyvsp[-3], yyvsp[-1], yyvsp[0]);
		}
break;
case 926:
  if (!yytrial)
{ yyval = make_node(nod_merge_when, e_mrg_when_count, yyvsp[-1], yyvsp[0]); }
break;
case 927:
  if (!yytrial)
{ yyval = make_node(nod_merge_when, e_mrg_when_count, yyvsp[0], yyvsp[-1]); }
break;
case 928:
  if (!yytrial)
{ yyval = make_node(nod_merge_when, e_mrg_when_count, yyvsp[0], NULL); }
break;
case 929:
  if (!yytrial)
{ yyval = make_node(nod_merge_when, e_mrg_when_count, NULL, yyvsp[0]); }
break;
case 930:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 931:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 932:
  if (!yytrial)
{ yyval = make_node(nod_merge_update, e_mrg_update_count, make_list(yyvsp[0])); }
break;
case 933:
  if (!yytrial)
{ yyval = make_node(nod_merge_insert, e_mrg_insert_count, make_list(yyvsp[-4]), make_list(yyvsp[-1])); }
break;
case 936:
  if (!yytrial)
{ yyval = make_node (nod_delete, (int) e_del_count,
				yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], NULL, yyvsp[0]); }
break;
case 937:
  if (!yytrial)
{ yyval = make_node (nod_delete, (int) e_del_count,
				yyvsp[-1], NULL, NULL, NULL, NULL, yyvsp[0], NULL); }
break;
case 940:
  if (!yytrial)
{ yyval = make_node (nod_update, (int) e_upd_count,
				yyvsp[-7], make_list (yyvsp[-5]), yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], NULL, yyvsp[0], NULL); }
break;
case 941:
  if (!yytrial)
{ yyval = make_node (nod_update, (int) e_upd_count,
				yyvsp[-3], make_list (yyvsp[-1]), NULL, NULL, NULL, NULL, yyvsp[0], NULL, NULL); }
break;
case 942:
  if (!yytrial)
{
			yyval = make_node (nod_update_or_insert, (int) e_upi_count,
				yyvsp[-7], make_list (yyvsp[-6]), make_list (yyvsp[-3]), yyvsp[-1], yyvsp[0]);
		}
break;
case 943:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 944:
  if (!yytrial)
{ yyval = NULL; }
break;
case 945:
  if (!yytrial)
{ yyval = make_node (nod_returning, (int) e_ret_count,
					make_list (yyvsp[0]), NULL); }
break;
case 946:
  if (!yytrial)
{ yyval = make_node (nod_returning, (int) e_ret_count,
					make_list (yyvsp[-2]), make_list (yyvsp[0])); }
break;
case 947:
  if (!yytrial)
{ yyval = NULL; }
break;
case 948:
  if (!yytrial)
{ yyval = make_node (nod_cursor, (int) e_cur_count, yyvsp[0], NULL, NULL, NULL); }
break;
case 950:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 951:
  if (!yytrial)
{ yyval = make_node (nod_assign, e_asgn_count, yyvsp[0], yyvsp[-2]); }
break;
case 952:
  if (!yytrial)
{ yyval = make_node (nod_assign, e_asgn_count, yyvsp[0], make_node (nod_null, 0, NULL)); }
break;
case 953:
  if (!yytrial)
{ yyval = make_node (nod_assign, e_asgn_count, yyvsp[0], make_node (nod_null, 0, NULL)); }
break;
case 954:
  if (!yytrial)
{ yyval = make_node (nod_get_segment, (int) e_blb_count, yyvsp[-4], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 955:
  if (!yytrial)
{ yyval = make_node (nod_put_segment, (int) e_blb_count, yyvsp[-4], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 956:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 957:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, NULL, yyvsp[0]); }
break;
case 958:
  if (!yytrial)
{ yyval = NULL; }
break;
case 961:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 962:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 963:
  if (!yytrial)
{ yyval = NULL; }
break;
case 964:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 967:
  if (!yytrial)
{ yyval = NULL; }
break;
case 968:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 970:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 972:
  if (!yytrial)
{ yyval = NULL; }
break;
case 973:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 975:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 977:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count,
							yyvsp[-2], yyvsp[0]); }
break;
case 978:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count,
							yyvsp[-2], NULL); }
break;
case 979:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count,
						NULL, yyvsp[0]); }
break;
case 981:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count,
							yyvsp[-2], yyvsp[0]); }
break;
case 983:
  if (!yytrial)
{ yyval = make_node (nod_or, 2, yyvsp[-2], yyvsp[0]); }
break;
case 984:
  if (!yytrial)
{ yyval = make_node (nod_and, 2, yyvsp[-2], yyvsp[0]); }
break;
case 985:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, yyvsp[0]); }
break;
case 999:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 1000:
  if (!yytrial)
{ yyval = make_node (nod_eql, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1001:
  if (!yytrial)
{ yyval = make_node (nod_lss, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1002:
  if (!yytrial)
{ yyval = make_node (nod_gtr, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1003:
  if (!yytrial)
{ yyval = make_node (nod_geq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1004:
  if (!yytrial)
{ yyval = make_node (nod_leq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1005:
  if (!yytrial)
{ yyval = make_node (nod_leq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1006:
  if (!yytrial)
{ yyval = make_node (nod_geq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1007:
  if (!yytrial)
{ yyval = make_node (nod_neq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1008:
  if (!yytrial)
{ yyval = make_node (nod_eql_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1009:
  if (!yytrial)
{ yyval = make_node (nod_lss_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1010:
  if (!yytrial)
{ yyval = make_node (nod_gtr_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1011:
  if (!yytrial)
{ yyval = make_node (nod_geq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1012:
  if (!yytrial)
{ yyval = make_node (nod_leq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1013:
  if (!yytrial)
{ yyval = make_node (nod_leq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1014:
  if (!yytrial)
{ yyval = make_node (nod_geq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1015:
  if (!yytrial)
{ yyval = make_node (nod_neq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1016:
  if (!yytrial)
{ yyval = make_node (nod_eql_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1017:
  if (!yytrial)
{ yyval = make_node (nod_lss_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1018:
  if (!yytrial)
{ yyval = make_node (nod_gtr_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1019:
  if (!yytrial)
{ yyval = make_node (nod_geq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1020:
  if (!yytrial)
{ yyval = make_node (nod_leq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1021:
  if (!yytrial)
{ yyval = make_node (nod_leq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1022:
  if (!yytrial)
{ yyval = make_node (nod_geq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1023:
  if (!yytrial)
{ yyval = make_node (nod_neq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1026:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_equiv, 2, yyvsp[-4], yyvsp[0])); }
break;
case 1027:
  if (!yytrial)
{ yyval = make_node (nod_equiv, 2, yyvsp[-5], yyvsp[0]); }
break;
case 1028:
  if (!yytrial)
{ yyval = make_node (nod_between, 3, yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 1029:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_between,
						3, yyvsp[-5], yyvsp[-2], yyvsp[0])); }
break;
case 1030:
  if (!yytrial)
{ yyval = make_node (nod_like, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1031:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_like, 2, yyvsp[-3], yyvsp[0])); }
break;
case 1032:
  if (!yytrial)
{ yyval = make_node (nod_like, 3, yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 1033:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_like,
						3, yyvsp[-5], yyvsp[-2], yyvsp[0])); }
break;
case 1034:
  if (!yytrial)
{ yyval = make_node (nod_eql_any, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1035:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_eql_any, 2, yyvsp[-3], yyvsp[0])); }
break;
case 1036:
  if (!yytrial)
{ yyval = make_node (nod_containing, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1037:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_containing, 2, yyvsp[-3], yyvsp[0])); }
break;
case 1038:
  if (!yytrial)
{ yyval = make_node(nod_similar, e_similar_count, yyvsp[-3], yyvsp[0], NULL); }
break;
case 1039:
  if (!yytrial)
{ yyval = make_node(nod_not, 1, make_node(nod_similar, e_similar_count, yyvsp[-4], yyvsp[0], NULL)); }
break;
case 1040:
  if (!yytrial)
{ yyval = make_node(nod_similar, e_similar_count, yyvsp[-5], yyvsp[-2], yyvsp[0]); }
break;
case 1041:
  if (!yytrial)
{ yyval = make_node(nod_not, 1, make_node(nod_similar, e_similar_count, yyvsp[-6], yyvsp[-2], yyvsp[0])); }
break;
case 1042:
  if (!yytrial)
{ yyval = make_node (nod_starting, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1043:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_starting, 2, yyvsp[-3], yyvsp[0])); }
break;
case 1044:
  if (!yytrial)
{ yyval = make_node (nod_starting, 2, yyvsp[-3], yyvsp[0]); }
break;
case 1045:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_starting, 2, yyvsp[-4], yyvsp[0])); }
break;
case 1046:
  if (!yytrial)
{ yyval = make_node (nod_exists, 1, yyvsp[-1]); }
break;
case 1047:
  if (!yytrial)
{ yyval = make_node (nod_singular, 1, yyvsp[-1]); }
break;
case 1048:
  if (!yytrial)
{ yyval = make_node (nod_missing, 1, yyvsp[-2]); }
break;
case 1049:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_missing, 1, yyvsp[-3])); }
break;
case 1050:
  if (!yytrial)
{ yyval = make_node (nod_eql, 2,
					make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_trigger_action)),
						MAKE_const_slong (1)); }
break;
case 1051:
  if (!yytrial)
{ yyval = make_node (nod_eql, 2,
					make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_trigger_action)),
						MAKE_const_slong (2)); }
break;
case 1052:
  if (!yytrial)
{ yyval = make_node (nod_eql, 2,
					make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_trigger_action)),
						MAKE_const_slong (3)); }
break;
case 1054:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 1055:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 1056:
  if (!yytrial)
{ yyval = make_node(nod_add_user, (int) e_user_count, yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 1057:
  if (!yytrial)
{ yyval = make_node(nod_mod_user, (int) e_user_count, yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 1058:
  if (!yytrial)
{ yyval = make_node(nod_mod_user, (int) e_user_count, yyvsp[-6], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 1059:
  if (!yytrial)
{ yyval = make_node(nod_del_user, (int) e_del_user_count, yyvsp[0]); }
break;
case 1060:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1061:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1062:
  if (!yytrial)
{ yyval = NULL; }
break;
case 1063:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1064:
  if (!yytrial)
{ yyval = NULL; }
break;
case 1065:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1066:
  if (!yytrial)
{ yyval = NULL; }
break;
case 1067:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1068:
  if (!yytrial)
{ yyval = NULL; }
break;
case 1069:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1070:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1071:
  if (!yytrial)
{ yyval = NULL; }
break;
case 1072:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1073:
  if (!yytrial)
{ yyval = NULL; }
break;
case 1074:
  if (!yytrial)
{ yyval = (dsql_nod*) MAKE_cstring("0"); }
break;
case 1075:
  if (!yytrial)
{ yyval = (dsql_nod*) MAKE_cstring("1"); }
break;
case 1086:
  if (!yytrial)
{ yyval = make_node (nod_negate, 1, yyvsp[0]); }
break;
case 1087:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1088:
  if (!yytrial)
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_add2, 2, yyvsp[-2], yyvsp[0]);
			  else
				  yyval = make_node (nod_add, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 1089:
  if (!yytrial)
{ yyval = make_node (nod_concatenate, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1090:
  if (!yytrial)
{ yyval = make_node (nod_collate, (int) e_coll_count, (dsql_nod*) yyvsp[0], yyvsp[-2]); }
break;
case 1091:
  if (!yytrial)
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_subtract2, 2, yyvsp[-2], yyvsp[0]);
			  else
				  yyval = make_node (nod_subtract, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 1092:
  if (!yytrial)
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				   yyval = make_node (nod_multiply2, 2, yyvsp[-2], yyvsp[0]);
			  else
				   yyval = make_node (nod_multiply, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 1093:
  if (!yytrial)
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_divide2, 2, yyvsp[-2], yyvsp[0]);
			  else
				  yyval = make_node (nod_divide, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 1094:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 1095:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 1099:
  if (!yytrial)
{ yyval = make_node (nod_dbkey, 1, NULL); }
break;
case 1100:
  if (!yytrial)
{ yyval = make_node (nod_dbkey, 1, yyvsp[-2]); }
break;
case 1101:
  if (!yytrial)
{
			  yyval = make_node (nod_dom_value, 0, NULL);
						}
break;
case 1104:
  if (!yytrial)
{
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
			{
				ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
						  Arg::Gds(isc_sql_dialect_datatype_unsupport) << Arg::Num(client_dialect) <<
						  												  Arg::Str("DATE"));
			}
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
			{
				ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
						  Arg::Gds(isc_sql_db_dialect_dtype_unsupport) << Arg::Num(db_dialect) <<
						  												  Arg::Str("DATE"));
			}
			yyval = make_node (nod_current_date, 0, NULL);
			}
break;
case 1105:
  if (!yytrial)
{
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
			{
				ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
						  Arg::Gds(isc_sql_dialect_datatype_unsupport) << Arg::Num(client_dialect) <<
						  												  Arg::Str("TIME"));
			}
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
			{
				ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
						  Arg::Gds(isc_sql_db_dialect_dtype_unsupport) << Arg::Num(db_dialect) <<
						  												  Arg::Str("TIME"));
			}
			yyval = make_node (nod_current_time, 1, yyvsp[0]);
			}
break;
case 1106:
  if (!yytrial)
{
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
			{
				ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
						  Arg::Gds(isc_sql_dialect_datatype_unsupport) << Arg::Num(client_dialect) <<
						  												  Arg::Str("TIME"));
			}
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
			{
				ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
						  Arg::Gds(isc_sql_db_dialect_dtype_unsupport) << Arg::Num(db_dialect) <<
						  												  Arg::Str("TIME"));
			}
			yyval = make_node (nod_local_time, 1, yyvsp[0]);
			}
break;
case 1107:
  if (!yytrial)
{ yyval = make_node (nod_current_timestamp, 1, yyvsp[0]); }
break;
case 1108:
  if (!yytrial)
{ yyval = make_node (nod_local_timestamp, 1, yyvsp[0]); }
break;
case 1109:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[-1]); }
break;
case 1110:
  if (!yytrial)
{ yyval = NULL; }
break;
case 1111:
  if (!yytrial)
{ yyval = make_node (nod_array, (int) e_ary_count, yyvsp[-3], make_list (yyvsp[-1])); }
break;
case 1113:
  if (!yytrial)
{ yyval = NULL; }
break;
case 1115:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1117:
  if (!yytrial)
{ yyval = make_node (nod_negate, 1, yyvsp[0]); }
break;
case 1118:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_STRING); }
break;
case 1119:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 1120:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_DOUBLE); }
break;
case 1121:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_SINT64); }
break;
case 1122:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_SINT64); }
break;
case 1124:
  if (!yytrial)
{ yyval = MAKE_str_constant ((dsql_str*) yyvsp[0], lex.att_charset); }
break;
case 1125:
  if (!yytrial)
{
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
			{
				ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
						  Arg::Gds(isc_sql_dialect_datatype_unsupport) << Arg::Num(client_dialect) <<
						  												  Arg::Str("DATE"));
			}
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
			{
				ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
						  Arg::Gds(isc_sql_db_dialect_dtype_unsupport) << Arg::Num(db_dialect) <<
						  												  Arg::Str("DATE"));
			}
			yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_DATE);
			}
break;
case 1126:
  if (!yytrial)
{
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
			{
				ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
						  Arg::Gds(isc_sql_dialect_datatype_unsupport) << Arg::Num(client_dialect) <<
						  												  Arg::Str("TIME"));
			}
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
			{
				ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
						  Arg::Gds(isc_sql_db_dialect_dtype_unsupport) << Arg::Num(db_dialect) <<
						  												  Arg::Str("TIME"));
			}
			yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_TIME);
			}
break;
case 1127:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_TIMESTAMP); }
break;
case 1128:
  if (!yytrial)
{ yyval = make_parameter (); }
break;
case 1129:
  if (!yytrial)
{ yyval = make_node (nod_user_name, 0, NULL); }
break;
case 1130:
  if (!yytrial)
{ yyval = make_node (nod_user_name, 0, NULL); }
break;
case 1131:
  if (!yytrial)
{ yyval = make_node (nod_current_role, 0, NULL); }
break;
case 1132:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_connection_id)); }
break;
case 1133:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_transaction_id)); }
break;
case 1134:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_gdscode)); }
break;
case 1135:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_sqlcode)); }
break;
case 1136:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_sqlstate)); }
break;
case 1137:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_rows_affected)); }
break;
case 1138:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1139:
  if (!yytrial)
{
			dsql_str* str = (dsql_str*) yyvsp[0];
			str->str_charset = (TEXT*) yyvsp[-1];
			if (str->type == dsql_str::TYPE_SIMPLE)
			{
				StrMark* mark = strMarks.get(str);
				fb_assert(mark);
				if (mark)
					mark->introduced = true;
			}
			yyval = yyvsp[0];
		}
break;
case 1141:
  if (!yytrial)
{ yyval = (dsql_nod*) - (IPTR) yyvsp[0]; }
break;
case 1142:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] > SHRT_POS_MAX)
				yyabandon (-842, isc_expec_short);
				/* Short integer expected */
			  yyval = yyvsp[0];}
break;
case 1143:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] > SHRT_NEG_MAX)
				yyabandon (-842, isc_expec_short);
				/* Short integer expected */
			  yyval = yyvsp[0];}
break;
case 1144:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] == 0)
				yyabandon (-842, isc_expec_positive);
				/* Positive number expected */
			  yyval = yyvsp[0];}
break;
case 1145:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] > SHRT_UNSIGNED_MAX)
				yyabandon (-842, isc_expec_ushort);
				/* Unsigned short integer expected */
			  yyval = yyvsp[0];}
break;
case 1147:
  if (!yytrial)
{ yyval = (dsql_nod*) - (IPTR) yyvsp[0]; }
break;
case 1148:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 1154:
  if (!yytrial)
{ yyval = make_node (nod_agg_count, 0, NULL); }
break;
case 1155:
  if (!yytrial)
{ yyval = make_node (nod_agg_count, 1, yyvsp[-1]); }
break;
case 1156:
  if (!yytrial)
{ yyval = make_flag_node (nod_agg_count,
									   NOD_AGG_DISTINCT, 1, yyvsp[-1]); }
break;
case 1157:
  if (!yytrial)
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_agg_total2, 1, yyvsp[-1]);
			  else
				  yyval = make_node (nod_agg_total, 1, yyvsp[-1]);
			}
break;
case 1158:
  if (!yytrial)
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_flag_node (nod_agg_total2,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			  else
				  yyval = make_flag_node (nod_agg_total,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			}
break;
case 1159:
  if (!yytrial)
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_agg_average2, 1, yyvsp[-1]);
			  else
				  yyval = make_node (nod_agg_average, 1, yyvsp[-1]);
			}
break;
case 1160:
  if (!yytrial)
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_flag_node (nod_agg_average2,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			  else
				  yyval = make_flag_node (nod_agg_average,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			}
break;
case 1161:
  if (!yytrial)
{ yyval = make_node (nod_agg_min, 1, yyvsp[-1]); }
break;
case 1162:
  if (!yytrial)
{ yyval = make_node (nod_agg_min, 1, yyvsp[-1]); }
break;
case 1163:
  if (!yytrial)
{ yyval = make_node (nod_agg_max, 1, yyvsp[-1]); }
break;
case 1164:
  if (!yytrial)
{ yyval = make_node (nod_agg_max, 1, yyvsp[-1]); }
break;
case 1165:
  if (!yytrial)
{ yyval = make_node (nod_agg_list, 2, yyvsp[-2], yyvsp[-1]); }
break;
case 1166:
  if (!yytrial)
{ yyval = make_flag_node (nod_agg_list, NOD_AGG_DISTINCT, 2, yyvsp[-2], yyvsp[-1]); }
break;
case 1167:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1168:
  if (!yytrial)
{ yyval = MAKE_str_constant (MAKE_cstring(","), lex.att_charset); }
break;
case 1171:
  if (!yytrial)
{ yyval = make_node (nod_extract, (int) e_extract_count, yyvsp[-3], yyvsp[-1]); }
break;
case 1175:
  if (!yytrial)
{ yyval = make_node(nod_strlen, (int) e_strlen_count,
					MAKE_const_slong(blr_strlen_bit), yyvsp[-1]); }
break;
case 1176:
  if (!yytrial)
{ yyval = make_node(nod_strlen, (int) e_strlen_count,
					MAKE_const_slong(blr_strlen_char), yyvsp[-1]); }
break;
case 1177:
  if (!yytrial)
{ yyval = make_node(nod_strlen, (int) e_strlen_count,
					MAKE_const_slong(blr_strlen_char), yyvsp[-1]); }
break;
case 1178:
  if (!yytrial)
{ yyval = make_node(nod_strlen, (int) e_strlen_count,
					MAKE_const_slong(blr_strlen_octet), yyvsp[-1]); }
break;
case 1179:
  if (!yytrial)
{ yyval = make_node(nod_sys_function, e_sysfunc_count, yyvsp[-3], make_list(yyvsp[-1])); }
break;
case 1228:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-6], make_node(nod_list, 3, yyvsp[-4], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1229:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-7], make_node(nod_list, 3, yyvsp[-3], yyvsp[-5], yyvsp[-1]));
		}
break;
case 1230:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-7], make_node(nod_list, 3, yyvsp[-5], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1231:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-7], make_node(nod_list, 3, yyvsp[-5], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1232:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-9], make_node(nod_list, 4, yyvsp[-7], yyvsp[-5], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1233:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-7], make_node(nod_list, 3, yyvsp[-5], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1234:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-5], make_node(nod_list, 2, yyvsp[-3], yyvsp[-1]));
		}
break;
case 1237:
  if (!yytrial)
{ yyval = make_node (nod_upcase, 1, yyvsp[-1]); }
break;
case 1238:
  if (!yytrial)
{ yyval = make_node (nod_lowcase, 1, yyvsp[-1]); }
break;
case 1239:
  if (!yytrial)
{ yyval = make_node (nod_substr, (int) e_substr_count, yyvsp[-4],
				make_node (nod_subtract, 2, yyvsp[-2],
					MAKE_const_slong (1)), yyvsp[-1]); }
break;
case 1240:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1241:
  if (!yytrial)
{ yyval = MAKE_const_slong (LONG_POS_MAX); }
break;
case 1242:
  if (!yytrial)
{ yyval = make_node (nod_trim, (int) e_trim_count, yyvsp[-4], yyvsp[-3], yyvsp[-1]); }
break;
case 1243:
  if (!yytrial)
{ yyval = make_node (nod_trim, (int) e_trim_count,
				MAKE_const_slong (blr_trim_both), yyvsp[-3], yyvsp[-1]); }
break;
case 1244:
  if (!yytrial)
{ yyval = make_node (nod_trim, (int) e_trim_count, yyvsp[-3], NULL, yyvsp[-1]); }
break;
case 1245:
  if (!yytrial)
{ yyval = make_node (nod_trim, (int) e_trim_count,
				MAKE_const_slong (blr_trim_both), NULL, yyvsp[-1]); }
break;
case 1246:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_trim_both); }
break;
case 1247:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_trim_trailing); }
break;
case 1248:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_trim_leading); }
break;
case 1249:
  if (!yytrial)
{ yyval = make_node (nod_udf, 2, yyvsp[-3], yyvsp[-1]); }
break;
case 1250:
  if (!yytrial)
{ yyval = make_node (nod_udf, 1, yyvsp[-2]); }
break;
case 1251:
  if (!yytrial)
{ yyval = make_node (nod_cast, (int) e_cast_count, yyvsp[-1], yyvsp[-3]); }
break;
case 1254:
  if (!yytrial)
{ yyval = make_node (nod_searched_case, 2,
				make_node (nod_list, 2, make_node (nod_eql, 2, yyvsp[-3], yyvsp[-1]),
				make_node (nod_null, 0, NULL)), yyvsp[-3]); }
break;
case 1255:
  if (!yytrial)
{ yyval = make_node (nod_searched_case, 2,
				make_node (nod_list, 2, yyvsp[-5], yyvsp[-3]), yyvsp[-1]); }
break;
case 1256:
  if (!yytrial)
{ yyval = make_node (nod_coalesce, 2, yyvsp[-3], yyvsp[-1]); }
break;
case 1257:
  if (!yytrial)
{ yyval = make_node(nod_simple_case, 3, yyvsp[-3], make_list(yyvsp[-1]), make_node(nod_null, 0, NULL)); }
break;
case 1258:
  if (!yytrial)
{ yyval = make_node(nod_simple_case, 3, yyvsp[-5], make_list(yyvsp[-3]), yyvsp[-1]); }
break;
case 1261:
  if (!yytrial)
{ yyval = make_node (nod_simple_case, 3, yyvsp[-2], make_list(yyvsp[-1]), make_node (nod_null, 0, NULL)); }
break;
case 1262:
  if (!yytrial)
{ yyval = make_node (nod_simple_case, 3, yyvsp[-4], make_list(yyvsp[-3]), yyvsp[-1]); }
break;
case 1263:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1264:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-4], make_node (nod_list, 2, yyvsp[-2], yyvsp[0])); }
break;
case 1265:
  if (!yytrial)
{ yyval = make_node (nod_searched_case, 2, make_list(yyvsp[-1]), make_node (nod_null, 0, NULL)); }
break;
case 1266:
  if (!yytrial)
{ yyval = make_node (nod_searched_case, 2, make_list(yyvsp[-3]), yyvsp[-1]); }
break;
case 1267:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1268:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-4], make_node (nod_list, 2, yyvsp[-2], yyvsp[0])); }
break;
case 1272:
  if (!yytrial)
{ yyval = make_node(nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1273:
  if (!yytrial)
{ yyval = make_node(nod_list, 2, yyvsp[-4], make_node(nod_list, 2, yyvsp[-2], yyvsp[0])); }
break;
case 1274:
  if (!yytrial)
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_gen_id2, 2, yyvsp[0],
						MAKE_const_slong(1));
			  else
				  yyval = make_node (nod_gen_id, 2, yyvsp[0],
						MAKE_const_slong(1));
			}
break;
case 1275:
  if (!yytrial)
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_gen_id2, 2, yyvsp[-3], yyvsp[-1]);
			  else
				  yyval = make_node (nod_gen_id, 2, yyvsp[-3], yyvsp[-1]);
			}
break;
case 1276:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_year); }
break;
case 1277:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_month); }
break;
case 1278:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_day); }
break;
case 1279:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_hour); }
break;
case 1280:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_minute); }
break;
case 1281:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_second); }
break;
case 1282:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_millisecond); }
break;
case 1283:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_week); }
break;
case 1284:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_weekday); }
break;
case 1285:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_yearday); }
break;
case 1290:
  if (!yytrial)
{ yyval = make_node (nod_null, 0, NULL); }
break;

  default:
    break;
  }

#if YYDEBUG && defined(YYDBPR)
  if (yydebug) {
    printf("yydebug[%d]: after reduction, result is ", yytrial);
    YYDBPR(yyps->val);
    printf("\n");
  }
#endif

  // Perform user-defined position reduction
#ifdef YYREDUCEPOSNFUNC
  if (!yytrial) {
    YYCALLREDUCEPOSN(YYREDUCEPOSNFUNCARG);
  }
#endif

  yyps->ssp -= yym;
  yystate = *(yyps->ssp);
  yyps->vsp -= yym;
  yyps->psp -= yym;

  yym = yylhs[yyn];
  if (yystate == 0 && yym == 0) {
#if YYDEBUG
    if (yydebug) {
      printf("yydebug[%d,%p]: after reduction, shifting from state 0 to state %d\n", 
	     int(yydepth), yytrial, YYFINAL);
    }
#endif
    yystate = YYFINAL;
    *++(yyps->ssp) = YYFINAL;
    *++(yyps->vsp) = yyps->val;
    yyretlval = yyps->val;	// return value of root non-terminal to yylval
    *++(yyps->psp) = yyps->pos;
    yyretposn = yyps->pos;	// return value of root position to yyposn
    if (yychar < 0) {
      if ((yychar = yylex1()) < 0) {
        yychar = 0;
      }
#if YYDEBUG
      if (yydebug) {
        yys = 0;
        if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
        if (!yys) yys = "illegal-symbol";
        printf("yydebug[%d,%p]: state %d, reading %d (%s)\n", 
	       int(yydepth), yytrial, YYFINAL, yychar, yys); 
      }
#endif
    }
    if (yychar == 0) goto yyaccept;
    goto yyloop;
  }

  if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
      yyn <= YYTABLESIZE && yycheck[yyn] == yystate) {
    yystate = yytable[yyn];
  } else {
    yystate = yydgoto[yym];
  }
#if YYDEBUG
  if (yydebug)
    printf("yydebug[%d,%p]: after reduction, shifting from state %d to state %d\n",
           int(yydepth), yytrial, *(yyps->ssp), yystate);
#endif
  if (yyps->ssp >= yyps->ss + yyps->stacksize - 1) {
    yyMoreStack(yyps);
  }
  *++(yyps->ssp) = yystate;
  *++(yyps->vsp) = yyps->val;
  *++(yyps->psp) = yyps->pos;
  goto yyloop;


  //
  // Reduction declares that this path is valid.
  // Set yypath and do a full parse
  //
yyvalid:
  if (yypath) {
    goto yyabort;
  }
  while (yyps->save) {
    yyparsestate *save = yyps->save;
    yyps->save = save->save;
    save->save = yypath;
    yypath = save;
  }
#if YYDEBUG
  if (yydebug)
    printf("yydebug[%d,%p]: CONFLICT trial successful, backtracking to state %d, %d tokens\n",
           int(yydepth), yytrial, yypath->state, int(yylvp - yylvals - yypath->lexeme));
#endif
  if (yyerrctx) {
    yyFreeState(yyerrctx);
    yyerrctx = NULL;
  }
  yychar = -1;
  yyps->ssp = yyps->ss + (yypath->ssp - yypath->ss);
  yyps->vsp = yyps->vs + (yypath->vsp - yypath->vs);
  yyps->psp = yyps->ps + (yypath->psp - yypath->ps);
  memcpy (yyps->ss, yypath->ss, (yyps->ssp - yyps->ss + 1) * sizeof(Yshort));
  yySCopy(yyps->vs, yypath->vs,  yyps->vsp - yyps->vs + 1);
  yyPCopy(yyps->ps, yypath->ps,  yyps->psp - yyps->ps + 1);
  yylvp = yylvals + yypath->lexeme;
  yylpp = yylpsns + yypath->lexeme;
  yylexp = yylexemes + yypath->lexeme;
  yystate = yypath->state;
  goto yyloop;


yyabort:
  if (yyerrctx) {
    yyFreeState(yyerrctx);
    yyerrctx = NULL;
  }

  YYSTYPE *pv;
  for(pv = yyps->vs; pv < yyps->vsp; pv++) {
    YYDELETEVAL(*pv, 2);
  }

  YYPOSN *pp;
  for(pp = yyps->ps; pp < yyps->psp; pp++) {
    YYDELETEPOSN(*pp, 2);
  }

  while (yyps) {
    yyparsestate *save = yyps;
    yyps = save->save;
    yyFreeState(save);
  }
  while (yypath) {
    yyparsestate *save = yypath;
    yypath = save->save;
    yyFreeState(save); 
  }
  return (1);


yyaccept:
  if (yyps->save) goto yyvalid;
  if (yyerrctx) {
    yyFreeState(yyerrctx);
    yyerrctx = NULL;
  }
  while (yyps) {
    yyparsestate *save = yyps;
    yyps = save->save;
    yyFreeState(save);
  }
  while (yypath) {
    yyparsestate *save = yypath;
    yypath = save->save;
    yyFreeState(save); 
  }
  return (0);
}


int Parser::yylex1()
{
  if (yylvp < yylve) {
    yylval = *yylvp++;
    yyposn = *yylpp++;
    return *yylexp++;
  } else {
    if (yyps->save) {
      if (yylvp == yylvlim) {
	yyexpand();
      }
      *yylexp = yylex();
      *yylvp++ = yylval;
      yylve++;
      *yylpp++ = yyposn;
      yylpe++;
      return *yylexp++;
    } else {
      return yylex();
    }
  }
}


int Parser::yyexpand()
{
  int p = yylvp - yylvals;
  int s = yylvlim - yylvals;
  s += YYSTACKGROWTH;
  { Yshort  *tl = yylexemes; 
    YYSTYPE *tv = yylvals;
    YYPOSN  *tp = yylpsns;
    yylvals = new YYSTYPE[s];
    yylpsns = new YYPOSN[s];
    yylexemes = new Yshort[s];
    memcpy(yylexemes, tl, (s - YYSTACKGROWTH) * sizeof(Yshort));
    yySCopy(yylvals, tv, s - YYSTACKGROWTH);
    yyPCopy(yylpsns, tp, s - YYSTACKGROWTH);
    delete[] tl;
    delete[] tv;
    delete[] tp;
  }
  yylvp = yylve = yylvals + p;
  yylvlim = yylvals + s;
  yylpp = yylpe = yylpsns + p;
  yylplim = yylpsns + s;
  yylexp = yylexemes + p;
  return 0;
}

